/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			14-Jan-1993				      */
/*									      */
/*	Module Name:		DBCDefines.h				      */
/*	Module Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Modification History:	First time 14-Jan-1993			      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/

#ifndef	IncDBCdefinesH
#define	IncDBCdefinesH

#include "dbDefs.h"

/* dbLibrary file names */
#ifndef WIN32
#define	DBASEPATH	"/tis4000db"
#else
#define DBASEPATH	"c:\\tis4000db"
#endif WIN32
#define	DBC_SDRFILE	"default.dctsdr"
#define	DBC_XREFFILE	"pdbxref"
#define	DBC_PVMAPFILE	"pvmap"
#define	DBC_IOCLISTFILE	"ioclist"
#define	DBC_RESLISTFILE	"reslist"
#define	DBC_IOADDRFILE	"ioaddr"
#define	DBC_CALCOPFILE	"calcops"
#define	DBC_FANLINKFILE	"fanlink"
#define	DBC_SELLINKFILE	"sellink"
#define	DBC_PIPEVARSFILE "pipevars"
#define	DBC_PIPECMDSFILE "pipecmds"
#define	DBC_TANKVARSFILE "tankvars"
#define	DBC_TANKCMDSFILE "tankcmds"
#define	DBC_TANKPRBSFILE "tankprbs"
#define	DBC_TANKVLVSFILE "tankvlvs"
#define	DBC_VLVVARSFILE	"vlvvars"
#define	DBC_PUMPVARSFILE "pumpvars"
#define	DBC_POTVARSFILE "potvars"
#define	DBC_PIDFILE	"pid"
#define	DBC_ACCUMFILE	"accum"
#define DBC_ARREDUC	"ar_reduc"
#ifndef WIN32
#define	DBCPATH		"/tis4000/tasks/dbC"
#else
#define DBCPATH		"c:\\tis4000\\tasks\\dbC"
#endif WIN32
#define	DBCLOCK		"dbClient.lock"
/* field names */
#define	FLD_NAME	"NAME"
#define	FLD_TYPE	"TYPE"
#define	FLD_FIELD_NAME	"FIELD_NAME"
#define	FLD_TABLE	"TABLE"
#define	FLD_TRUE_STATE	"TRUE_STATE"
#define	FLD_RESOURCE	"RESRCNAME"
#define	FLD_IOC1	"PRIMARYIOC"
#define	FLD_IOC2	"SECNDRYIOC"
#define	FLD_REFERENCE	"REFERENCE"
#define	FLD_CONSTANT	"CONSTANT"
#define	FLD_PROCINPUT	"PROC_INPUT"
#define	FLD_MAXSEVERITY	"MAXSEVERTY"
#define	FLD_LINE	"LINE"
#define	FLD_ADDRESS	"ADDRESS"
#define	FLD_CARD	"CARD"
#define	FLD_SIGNAL	"SIGNAL"
#define	FLD_CALCOP	"OPERANDID"
#define	FLD_CRC		"CHECKSUM"
#define	FLD_CALCOP_KEY	"NAMEID"
#define	FLD_SCANRATE	"SRATE"
#define	FLD_REFFIELD	"REFFIELD"
#define	FLD_CONSTFIELD	"CONSTFIELD"
#define	FLD_SYNCFLAG	"NO_SYNC"
#define	FLD_HARDFIELD	"HWFLAG"
#define	FLD_VARDESC	"VARDESC"
#define	FLD_VARNAME	"VARNAME"
#define	FLD_PROBENAME	"PROBENAME"
#define	FLD_INDICATOR	"INDICATOR"
#define	FLD_MVMS	"MVALMS"
#define	FLD_MVPROC	"MVALPROC"
#define	FLD_SETPTCONST	"SETPTCONST"
#define	FLD_SETPTMS	"SETPTMS"
#define	FLD_SETPTPROC	"SETPTPROC"
#define	FLD_CASCADEMS	"CASCADEMS"
#define	FLD_CASCADEPROC	"CASPROCINP"
#define	FLD_PROCFZSPEC	"PROCFZSPEC"
#define	FLD_MAXSFZSPEC	"MAXSFZSPEC"
#define	FLD_ISHOST     	"IS_HOST"
/* fields for online additions */
#define	FLD_IOC1DNLD	"IOC1DNLD"
#define	FLD_IOC2DNLD	"IOC2DNLD"
#define	FLD_ONSCAN	"ONSCAN"
/* size parameters */
#define	DBC_KEY_SIZE	(80)
#ifndef DBC_IOCNAMESIZE
#define	DBC_IOCNAMESIZE	(16)
#endif DBC_IOCNAMESIZE
#define	DBC_PTNAMESIZE	(48)
#define	DBC_WINDOW_SIZE	(8)		/* Download window size */
#define	DBC_RESNAMESIZE	(16)
#define	DBC_MAXIOCPERRES (2)		/* maximum number of resourses/IOC */
#define	DBC_MAXCRCPERREQ (32)		/* maximum CRCs in response message */
#define	DBC_NETMSG_SIZE	(4096)		/* IOC TCP message I/O buffer size */
#define	DBC_MAX_DISPATCH (256)		/* dispatch table entries (sparse array) */
#define	DBC_IDLE_TIMER_VALUE	(60)	/* 60 second fdmgr_pend_event idle loop */
#define	DBC_POLL_TIMER_VALUE	(15)	/* 15 second IOC connect check */
#define	DBC_CARDIAC_ARREST	(120)	/* > 2 minutes...link must have died */
#define	DBC_HEART_BEAT		(30)	/* 30 second wake up call */
#define	DBC_MAX_SYMS		(30)	/* Maximum number of symbols to transmit */
#define	DBC_MAX_TABLES		(10)	/* Max table handles per point type */
#define	DBC_OPID_SIZE		(16)	/* new size for tank farm stuff */
#ifndef	ERROR
#define	ERROR (-1)
#endif
/*
	Constants for the minimum record count for a single point entry. These values
	are used to determine how many records to pre-create for a copy operation.
*/
#define	DBC_PVMAP_CNT		1		/* The PVMAP and default count is one per entry */
#define	DBC_IOADDR_CNT		1		/* for all except PTO */
#define	DBC_IOADDR_PTO_CNT	2		/* PTOs have an A & B entry */
#define	DBC_CALCOPS_CNT		12		/* A through L */
#define	DBC_PIPEVARS_CNT	2
#define	DBC_PIPECMDS_CNT	2
#define	DBC_TANKVARS_CNT	10
#define	DBC_TANKCMDS_CNT	4
#define	DBC_TANKPRBS_CNT	10
#define	DBC_TANKVLVS_CNT	10
#define	DBC_VLVVARS_CNT		11
#define	DBC_PUMPVARS_CNT	8
#define	DBC_POTVARS_CNT		9
#define	DBC_SELLINK_CNT		12
#define	DBC_FANLINK_CNT		6

typedef enum {NO_ACCEPT_IOCS,ACCEPT_IOCS} ACCEPT_STATE;
typedef	enum
	{
	DBC_SUCCESS,			/* No problems */
	DBC_XREFERR,			/* Database cross reference file trouble */
	DBC_PVMAPERR,			/* PVMAP file error */
	DBC_INITCRCERR,			/* CRC initialization error */
	DBC_IOCLISTERR,			/* IOC list file error */
	DBC_RESLISTERR,			/* Resource list file error */
	DBC_IOCTABLEERR,		/* IOC table error */
	DBC_CALCOPERR,			/* calc operand table error. */
	DBC_SELLINKERR,
	DBC_FANLINKERR,
	DBC_PIPEVARSERR,		/* pipe vars file error */
	DBC_PIPECMDSERR,		/* pipe commands file error */
	DBC_TANKVARSERR,		/* tank vars file error */
	DBC_TANKCMDSERR,		/* tank commands file error */
	DBC_TANKPRBSERR,		/* tank probes file error */
	DBC_TANKVLVSERR,		/* tank valves file error */
	DBC_VLVVARSERR,			/* valve PV file error */
	DBC_PUMPVARSERR,
	DBC_POTVARSERR,
	DBC_BCASTERR,			/* broadcast socket problems */
	DBC_BCASTOPTERR,		/* problem setting socket options */
	DBC_BCASTBNDERR,		/* problem binding socket */
	DBC_LISTENERR,			/* Can't create socket to listen on */
	DBC_LISTENBNDERR,		/* problem binding socket */
	DBC_NOLISTENERR,		/* Can't listen with socket */
	DBC_SDRERR,			/* SDR load trouble */
	DBC_NOTYPE,			/* unsupported pointtype */
	DBC_CHOICEERR,			/* Null choice pointer */
	DBC_ARRCHOICEERR,		/* Null choice pointer */
	DBC_DEVCHOICEERR,		/* Null choice pointer */
	DBC_CVTCHOICEERR,
	DBC_IOADDRERR,
	DBC_NOMEM,			/* can't allocate memory for record */
	DBC_NOXREF,			/* Type not in XREF list */
	DBC_NOCMDS,			/* no commands */
	DBC_LINKERR,			/* error converting links */
	DBC_RNF,	       		/* record not found */
	DBC_COMMERR,			/* read or write TCP error */
	DBC_FIELDMODERR			/* errors making field mods */
	} DBC_ERROR_CODES;
extern char *DBC_ErrorMsg[];
typedef	enum
	{
	VU_AI=1,
	VU_AO,
	VU_BI,
	VU_BO,
	VU_CALC,
	VU_FANOUT,
	VU_MBBI,
	VU_MBBO,
	VU_PID,
	VU_SEL,
	VU_STATE,
	VU_STRINGIN,
	VU_STRINGOUT,
	VU_WAVEFORM,
	VU_LEADLAG,
	VU_RAMP,
	VU_PIPE,
	VU_TANK,
	VU_VALVE,
	VU_PUMP,
	VU_POT,
	VU_ACCUM,
	VU_PTO,
	VU_DEADTIME,
	VU_DATAMOVE,
	VU_TD,
	VU_SIGCHAR,
	VU_UDB,
	VU_PAT,
	VU_LDFW1,
	VU_LDFW2,
	VU_DDC,
	VU_MAX_TYPES			/* ALL VALID TYPES MUST COME BEFORE THIS VALUE !!! */
	} VU_VALID_TYPES;
/*
	IOC State codes.
*/
typedef enum iocstate
	{
	IOC_OK,
	IOC_DOWNLOADING,
	IOC_SDRDWNLD,
	IOC_ERROR,
	IOC_CRCCHECK,
	IOC_SYMREQ,
	IOC_NONET,
	IOC_INHIBITED
	} IOC_STATE;
typedef enum iocinhibit
{
  IOC_INHIBIT_COMM=1,
  IOC_ALLOW_COMM
} IOC_INHIBIT;
/*
	The following structure is used to hold a list of points that have
	been downloaded online but have NOT been acknowleged as such. When
	I received the ack then I will go throgh this list and mark all the 
	points as downloaded and remove the list. The initial number of points(32)
	should prove adequate but the list can grow as needed.

	GCT 25-May-1995
*/
#define	ACK_MAX_POINTS	32
typedef	struct _ack_pending
	{
	struct _ack_pending		*ackNext;				/* pointer to next list or zero if end */
	int						ackPointsInList;		/* number of points in this list <= 32 */
	struct
		{
		char	ackPVEntry[PVNAME_SZ+1];			/* PV name entry */
		int		ackIOCIndex;						/* IOC index 0 or 1 */
		} ackPoint[ACK_MAX_POINTS];
	} ACK_PENDING, *ACK_PENDING_PTR;
#define	ACK_PEND_SIZE sizeof(ACK_PENDING)
/*
	tree node structure.
*/
typedef	struct
	{
	struct treenode	*left;				/* pointer to left node */
	struct treenode *right;				/* poiinter to right node */
	char		treePVName[PVNAME_SZ];		/* point name */
	int		treePointId;			/* point ID from IOC */
	unsigned short	treeCRC;			/* CRC as in PVMAP */
	} TREENODE,*TREENODE_PTR;
#define	TREENODESIZE	sizeof(TREENODE)

typedef enum {READTCP_IN=1,READTCP_OUT,READFD_IN,READFD_OUT} TRACE_TYPE;
typedef struct {
	TRACE_TYPE	id;
	short	ioc_msgtype;
	short	rxCount;
	short	rxNextChar;
	char	rxbuffer0;
	char	rxbuffer1;
} DBCTRACEITEM;

typedef struct {
	short		dbtIx;
	DBCTRACEITEM	dbtList [128];
} DBCTRACE;
/*
	The following structure will hold information pertaining to
	the IOC.
*/
typedef enum {PASS1,PASS2} VERIFY_PASS;
typedef	struct iocinfo
{
  NODE 	node;
  char 	ioc_name[DBC_IOCNAMESIZE];
  int  	ioc_socket;			/* TCP socket dbClient -> IOC */
  int  	ioc_addr;			/* INET address */
  int  	ioc_msgtype;			/* message type of last message recv'd */
  int  	ioc_index;			/* num actually sent */
  char 	ioc_host;			/* 1 means this IOC is a workstation (HOST) */
  IOC_STATE	ioc_state;	       	/* IOC state */
  char 	ioc_lastpt[PVNAME_SZ];		/* last point requested */
  int  	ioc_numToSend;			/* # of verify messages to send */
/*
	The following is a binary tree root pointer. This tree is used to keep a symbol
	table for each IOC. The symbol table is used to to store the PV name along
	with a PV id # generated by the IOC as well as the CRC for the database record
	cooresponding to the PV name. This tree will be used to validate checksums between
	dbClient and dbServer.
*/
  TREENODE	*ioc_treeroot;	       	/* tree root for above mentioned tree */
  int  	ioc_lastTxTime;			/* time of last TCP transmit */
  int  	ioc_lastRxTime;			/* time of last TCP recieve */
/*
	The following is used in the new IOC communication function.
*/
  char	ioc_rxBuffer[DBC_NETMSG_SIZE];
  int  	ioc_rxCount;			/* number of chars in ioc_rxBuffer */
  int  	ioc_rxNextChar;			/* next char to read */
/*
	Pointer to list of un-ack'd but thought to be downloaded points
*/
  ACK_PENDING_PTR	ioc_ackPending;
  DBCTRACE	dbt;				/* GCT & JD 21-Mar-1997 */
  IOC_INHIBIT	inhibitState;			/* GCT 27-May-1997 */
  struct resinfo  *ioc_lastResource;		/* GCT 21-Jul-1997 last Resource I seek'ed with */
  int ioc_newResource;				/* GCT 25-Jul-1997 -1 if first time, 0 if  current, 1 if new */
} DBC_IOCINFO, *DBC_IOCINFO_PTR;
#define	IOCINFOSIZE	sizeof(DBC_IOCINFO)
/*
	This is the Resource information structure. These will be allocated
	at initialization time.
*/
typedef	struct resinfo
	{
	NODE		node;
	char		res_name[DBC_RESNAMESIZE];	/* resource name */
	struct iocinfo	*res_iocinfo[DBC_MAXIOCPERRES];	/* pointers to IOC info areas */
	} DBC_RESINFO, *DBC_RESINFO_PTR;
#define	RESINFOSIZE	sizeof(DBC_RESINFO)

typedef	struct	recdesc
	{
	short		recType;			/* point type index */
	short		recSize;			/* size of record */
	char		*recPtr;			/* pointer to record */
	} DBC_RECDESC;
#define	RECDESC_SIZE	sizeof(DBC_RECDESC)
#define	USE_PREALLOC	1

/*
	EPICS to DBASE crossreference table. This is a linked list pointed to
	by an array of LIST structures indexed via point type.
*/
typedef	struct
	{
	NODE		node;				/* for linked list functions */
	struct	fldDes	*xrefFieldDesc;			/* pointer to EPICS fldDes */
	DB_TABLE_PTR	xrefTable;			/* used to access point specific table */
	DB_FIELD_PTR	xrefField;			/* dbase field pointer */
	DB_FIELD_PTR	xrefRefField;			/* for reference field in xxx.DBF */
	DB_FIELD_PTR	xrefConstField;			/* for constant field in xxx.DBF */
	char		xrefTrue;
	char		xrefHardware;			/* 0 if NO hardware 1 if there is */
	char		xrefOpId[DBC_OPID_SIZE];
	}DBC_XREFTABLE,*DBC_XREFTABLE_PTR;
#define	XREFSIZE	sizeof(DBC_XREFTABLE)

typedef	struct
	{
	LIST			xrefHdrList;						/* list of fields for this point type */
	DB_TABLE_PTR	xrefHdrTables[DBC_MAX_TABLES];		/* table handles for this point type */
	int				xrefRecCount[DBC_MAX_TABLES];		/* count of minimum records for single point entry */
	short			xrefSeqNumber[DBC_MAX_TABLES];		/* sequence number for interhost whole record transfers */
	}DBC_XREFHDR,*DBC_XREFHDR_PTR;
#define	XREFHDRSIZE	sizeof(DBC_XREFHDR)
/**************************************************************************
* a macro to return a  value from the devChoiceRec struct 
* this macro assumes that checking for NULL pointers has been already done 
* typical usage :
*
*	long	link_type;
*	char	*pstring;
*	link_type = GET_DEV_CHOICE_VAL(record_type, card_type, link_type);
*	pstring = GET_DEV_CHOICE_VAL(record_type, carc_type, pchoice);
*
***************************************************************************/

#define GET_DEV_CHOICE_VAL(RECORD_TYPE, CARD_TYPE, VALUE) \
(\
choiceDev->papDevChoiceSet[(RECORD_TYPE)]->papDevChoice[(CARD_TYPE)]->VALUE \
)

/****************************************************************************
*  this macro returns the value of link_type from the devChoiceRec
*  usage:
*
*	long	link_type;
*	link_type = GET_DEV_CHOICE_LINK_VAL(record_type, card_type);
****************************************************************************/
#define GET_DEV_CHOICE_LINK_VAL(RECORD_TYPE, CARD_TYPE) \
(\
	GET_DEV_CHOICE_VAL((RECORD_TYPE), (CARD_TYPE), link_type) \
)

extern	char	dbVerbose;
#define	V_DEBUG	3
#define	V_STATUS	2
#define	V_INFO	1
#define	VERBOSE(x)		if(dbVerbose >= x) syslog

#ifndef WIN32
#include <syslog.h>
#ifndef TRUE
#    define TRUE	(1==1)
#endif TRUE
#ifndef FALSE
#    define FALSE	(1!=1)
#endif FALSE
#define LOG_OPTIONSE	(LOG_ALERT | LOG_LOCAL1)
#define LOG_OPTIONSI	(LOG_ALERT | LOG_LOCAL1)
#else
HANDLE eventH;
char eventapp [80];
char *eventStrP[2];
#define openlog(ident,opt,facility) { strncpy(eventapp,ident,sizeof(eventapp)); eventH=RegisterEventSource(NULL,ident);}
#define syslog(pri,msg) { eventStrP[0]=msg; ReportEvent(eventH,pri,0,0,NULL,1,0,eventStrP,NULL); }
#define closelog() { DeregisterEventSource (eventH); }
#define LOG_ERR		EVENTLOG_ERROR_TYPE
#define LOG_LOCAL1	0
#define LOG_OPTIONSE	(LOG_ERR | LOG_LOCAL1)
#define LOG_OPTIONSI	(EVENTLOG_INFORMATION_TYPE | LOG_LOCAL1)
char logmsg[132];
#endif WIN32

extern struct dbdatabase	DB_Database;
extern	DB_TABLE_PTR	DBC_IOCListTable,DBC_ArReducTable,DBC_IOAddrTable;
extern	DB_FIELD_PTR	DBC_IOCSyncField;
extern	DB_TABLE_PTR	calcOpsTable,pipeVarsTable,pipeCmdsTable;
extern	DB_TABLE_PTR	tankVarsTable,tankCmdsTable,tankPrbsTable,tankVlvsTable,valveVarsTable;
extern	DB_TABLE_PTR	selLinkTable,fanLinkTable,pumpVarsTable,potVarsTable;
extern	DB_FIELD_PTR	pvmapNameField,pvmapTypeField,pvmapDeleteFlag;
extern  ACCEPT_STATE	acceptIOC;
extern  DBC_IOCINFO  hostInfo[];		/* host info for inter-host sync */;
extern  int maxConnected;
#define DBC_MAX_HOSTS	32
time_t	synchTime();
#ifdef WIN32
#define MAXHOSTNAMELEN 1024
/*typedef  char *caddr_t;*/
int		serverInit(char *,char *);
int		sdrLoad(char *,int);
int		DBC_BuildXREFTable();
void	ackCleanList(ACK_PENDING_PTR);
int		xrefFindIndex(DBC_XREFHDR_PTR ,DB_TABLE_PTR);
void	DBC_SendToAllHosts(VERIFY_INFO * ,short );
int		readFD(DBC_IOCINFO_PTR);
int		readTcp(DBC_IOCINFO_PTR,char *,int);
int		writeTcp(DBC_IOCINFO_PTR,char *,int);
DBC_ERROR_CODES	DBC_BuildRecord(char *,DBC_RECDESC *,DB_RECORD_PTR);
short DBC_CRCRecord(char *,short);
short oldDBC_CRCRecord(char *,short);
int getTypeIndex(char *);
int getIOCIndex(char *,DBC_IOCINFO_PTR);
DBC_IOCINFO_PTR dbcIocSearch(char *);
DBC_ProcessSymPurge(DBC_IOCINFO_PTR);
int tcpError(DBC_IOCINFO_PTR);
#endif WIN32

#endif	IncDBCdefinesH
