/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#ifndef	dbcverifydefsH
#define	dbcverifydefsH

#include "dbDefs.h"

typedef	struct
{
  char		viHostName[DBC_IOCNAMESIZE+1];	/* my host name				17*/
  char		viPVName[PVNAME_SZ+1];		/* this point name			29*/
  short		viTypeIndex;			/* point type index			 2*/
  int  		viTimeStamp;			/* date-time of last mod or delete	 4*/
  unsigned char	viPVStatus;			/* bit mask of point status		 1*/
  short		viCRC;				/* record CRC from pvmap		 2*/
  char		vipad[9];			/* pad to 64 */
}VERIFY_INFO, *VERIFY_INFO_PTR;

#define	VERIFY_INFO_SIZE	sizeof(VERIFY_INFO)

typedef	struct
{
  char		viImportNode[DBC_IOCNAMESIZE+1];	/* where I got the message */
  int  		viImportDate;				/* date/time of message from Import node */
  char		viImpDelFlag;				/* is file deleted */
} IMPORT_INFO,*IMPORT_INFO_PTR;

#define	IMPORT_INFO_SIZE	sizeof(IMPORT_INFO)

typedef	struct
{
  short	viMsgType;					/* type of inter-host message */
  short	viCount;					/* number of info blocks */
} VERIFY_HDR,*VERIFY_HDR_PTR;

#define	VERIFY_HDR_SIZE	sizeof(VERIFY_HDR)

typedef	struct
	{
  char	recHost[DBC_IOCNAMESIZE];
  char	reqName[PVNAME_SZ];
  int		fill1;
  short	reqType;
} VI_RECREQUEST, *VI_RECREQUEST_PTR;

#define	RECREQUEST_SIZE	sizeof(VI_RECREQUEST)

typedef	struct
	{
  char	recName[PVNAME_SZ];
  short	recTypeIndex;
  short	recIsDeleted;
  short	recRecSize;
} VI_RECREPLY, *VI_RECREPLY_PTR;

#define	RECREPLY_SIZE	sizeof(VI_RECREPLY)
/*
	status flag bits
*/
#define	VI_DELETED_BIT	0
#define	VI_LOADED_1_BIT	1
#define	VI_LOADED_2_BIT	2
#define	VI_IMPDEL_BIT	3

#define	VI_DELETED     	(1 << VI_DELETED_BIT)
#define	VI_LOADED_1    	(1 << VI_LOADED_1_BIT)
#define	VI_LOADED_2    	(1 << VI_LOADED_2_BIT)
#define	VI_IMPDELETED	(1 << VI_IMPDEL_BIT)

#define	VI_IS_DELETED(x)	(x & VI_DELETED)	/* 1 = deleted */
#define	VI_IS_LOADED1(x)	(x & VI_LOADED_1)	/* 1 = loaded */
#define	VI_IS_LOADED2(x)	(x & VI_LOADED_2)	/* 1 = loaded */
#define	VI_IS_IMPDELETED(x)	(x & VI_IMPDELETED)	/* 1 = deleted on import node */

#define	VI_FLD_TIMESTAMP	"TIMESTAMP"
#define	VI_FLD_LOAD1FLAG	"LOAD1FLAG"
#define	VI_FLD_LOAD2FLAG	"LOAD2FLAG"
#define	VI_FLD_DELETEFLAG	"DELETEFLAG"
#define	VI_FLD_POINTTYPE	"TYPE"
#define	VI_FLD_NAME    		"NAME"
#define	VI_FLD_IMPORTNODE	"IMPORTNODE"
#define	VI_FLD_IMPORTDATE	"IMPORTDATE"
#define	VI_FLD_IMPDELFLAG	"IMPDELFLAG"
#define VI_FLD_CHECKSUM		"CHECKSUM"

#define	VERIFY_COUNT		20

#endif	dbcverifydefsH
