/****
*
*	File name :		sscommon.h
*	Author :		Steve Johnson
*	Creation date :	September 10, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Include file for all source modules on all platforms
*
****/

#define MAX_STRING			254
#define TRUE				1
#define FALSE				0
#define MAX(a,b)			(((a) > (b)) ? (a) : (b))
#define MIN(a,b)			(((a) < (b)) ? (a) : (b))
#define IS_WHITE_SPACE(c)	(((c) == ' ') || ((c) == '\t'))
#define	IS_EOL(c)			(((c) == '\0') || ((c) == '\n'))
#define IS_COMMENT(c)		((c=='*') || (c==';') || (c=='!') || (c=='#'))


#define DNP_BINARY_INPUT	1
#define CA_BINARY_INPUT		101
#define DNP_BINARY_CHANGE	2
#define DNP_BINARY_OUTPUT	12
#define AGC_BINARY_OUTPUT	112
#define AGC2_BINARY_OUTPUT	212
#define CA_BINARY_OUTPUT	312
#define AGC3_BINARY_OUTPUT	412
#define DNP_BINARY_COUNTER	20
#define DNP_FROZEN_COUNTER	21
#define DNP_ANALOG_INPUT	30
#define CA_ANALOG_INPUT		130
#define DNP_ANALOG_OUTPUT	41
#define DNP_TIME_AND_DATE	50
#define DNP_STATIC_CLASS	60
#define DNP_INDICATORS		80
#define DNP_STATISTICS		999

#define POINT_SELECT		65534
#define POINT_FREEZE		65534
#define POINT_FREEZE_CLEAR	65533

enum DNP_MODE_TYPES_ENUM {
	DNP_MASTER,
	DNP_SLAVE,
};
typedef enum DNP_MODE_TYPES_ENUM		DNP_MODE;

typedef struct {
    char        ff_reserved[21];
    char        ff_attrib;
    unsigned    ff_ftime;
    unsigned    ff_fdate;
    long        ff_fsize;
    char        ff_name[13];
} FIND_FILE_DEF;

/****
*
*	Microsoft 6.0 under DOS
*
****/

#ifdef MSC60

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <malloc.h>
#include <dos.h>
#include <conio.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <graph.h>
#include <fcntl.h>

#ifdef NOVELL

#include <sys\socket.h>
#include <netinet\in.h>

#define	FD_BIT_MASK						fd_set
#define E_PENDING						EINPROGRESS
#define SET_OPTION(a,b,c,d,e)			setsockopt (a,b,c,d,e)
#define FILL_ADDRESS(H,A)				H . s_addr = A
#define GET_ADDRESS(H)					(H . s_addr)
#define GET_INET_ADDRESS(a)				inet_addr (a)
#define SOCKET_CLOSE(a)					soclose(a)
#define NON_BLOCKING(s,p)				ioctl(s,FIONBIO,(char *) &p)
#define NON_BLOCKING_C(s,p)				ioctl(s,FIONBIO,(char *) &p)
#define GET_HOST_NAME(a,b)				strcpy (a,"")

#else
#define	FD_BIT_MASK						int *
#endif


#define NEW_LINE						"\n"
#define GetLastError()					errno
#define GetLastTcpError()				errno
#define TOUPPER(a)						toupper ((UCHAR) (a))
#define SLEEP(a)						local_sleep(a)
#define INTERRUPT						_interrupt _far
#define ENABLE()						_enable()
#define DISABLE()						_disable()
#define INPORT(a)						inp(a)
#define OUTPORT(a,b)					outp(a,b)
#define GET_VECTOR(a)					_dos_getvect(a)
#define SET_VECTOR(a,b)					_dos_setvect(a,b)
#define NO_SIGPIPE()
#define FormatMessage(a,b,c,d,e,f,g)	strcpy (e, "Not Implmented")
#define ADDRESS_ALIAS(a)				(a << 12)
#define ADDRESS_MASK(a)					(((ULONG) a) >> 20)
#define TERROR(d)						(!d)
#define TOPENW(n)						fopen (n, "w")
#define TOPENR(n)						fopen (n, "r")
#define TFILENO(d)						(d)
#define TFLUSH(d)						fflush (d)
#define TCLOSE(d)						fclose (d)
#define TWRITE(d,b,l)					fwrite (b,1,l,d);fflush(d)
#define TSEEK(d,p)						fseek (d, p, SEEK_SET)
#define TREAD(d,b,l)					fread (b,1,l,d)
#define GET_TASK_ID()					1

typedef struct sockaddr_in				TCP_ADDR_IN;
typedef struct sockaddr					TCP_ADDR;
typedef int								TCP_ADDR_LEN;
typedef long							ULONG;
typedef unsigned int					UINT;
typedef unsigned char					UCHAR;
typedef unsigned short					USHORT;
typedef unsigned short					WORD;
typedef FILE							*TFILE;

typedef struct {
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME;

extern long			GetTickCount (void);
extern void			GetLocalTime (SYSTEMTIME *);
extern void			SetLocalTime (SYSTEMTIME *);
extern int			TimeCompare (SYSTEMTIME *, SYSTEMTIME *);
extern int			TimeGetFileMod (char *, SYSTEMTIME *);
extern void			taskDelay (int);
extern void			sysReboot (void);

#endif

/****
*
*	Microsoft VC 5.0 under Win 32
*
****/

#ifdef MSWIN32

#pragma pack (8)
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <malloc.h>
#include <dos.h>
#include <fcntl.h>
#include <conio.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <winsock.h>
#include <mmsystem.h>
#include <errno.h>

#pragma pack ()

#define NEW_LINE						"\n"
#define TOUPPER(a)						toupper ((UCHAR) (a))
#define ENABLE()						
#define DISABLE()						
#define	FD_BIT_MASK						fd_set
#define EINPROGRESS						WSAEINPROGRESS
#define EWOULDBLOCK						WSAEWOULDBLOCK
#define ECONNRESET						WSAECONNRESET
#define ENOFILE							ENFILE
#define ENOPATH							ENOENT
#define ENOBUFS							WSAENOBUFS
#define GetLastTcpError()				WSAGetLastError ()
#define SET_OPTION(a,b,c,d,e)			setsockopt (a,b,c,d,e)
#define FILL_ADDRESS(H,A)				H . s_addr = A
#define GET_ADDRESS(H)					(H . s_addr)
#define GET_INET_ADDRESS(a)				make_inet_addr (a)
#define GET_HOST_NAME(a,b)				strcpy (a,"")
#define SOCKET_CLOSE(a)
#define NON_BLOCKING(s,p)				ioctlsocket(s,FIONBIO,(u_long *) &p)
#define NON_BLOCKING_C(s,p)				ioctlsocket(s,FIONBIO,(u_long *) &p)
#define NO_SIGPIPE()				
#define ADDRESS_ALIAS(a)				(a << 12)
#define ADDRESS_MASK(a)					(((ULONG) a) >> 20)
#define TERROR(d)						(!d)
#define TOPENW(n)						fopen (n, "w")
#define TOPENR(n)						fopen (n, "r")
#define TFILENO(d)						(d)
#define TFLUSH(d)						fflush (d)
#define TCLOSE(d)						fclose (d)
#define TSEEK(d,p)						fseek (d, p, SEEK_SET)
#define TWRITE(d,b,l)					fwrite (b,1,l,d);fflush(d);
#define TREAD(d,b,l)					fread (b,1,l,d)
#define GET_TASK_ID()					1

typedef struct sockaddr_in				TCP_ADDR_IN;
typedef struct sockaddr					TCP_ADDR;
typedef int								TCP_ADDR_LEN;
typedef fd_set							FD_BIT_MASK;
typedef unsigned int					UINT;
typedef unsigned char					UCHAR;
typedef unsigned short					USHORT;
typedef unsigned long					ULONG;
typedef unsigned int					uint;
typedef unsigned char					uchar;
typedef unsigned short					ushort;
typedef unsigned long					ulong;
typedef FILE							*TFILE;

extern int		kbhit (void);
extern int		getch (void);
extern int		wsa_init (void);
extern void		wsa_exit (void);
extern void		taskDelay (int);
extern void		sysReboot (void);
extern int		TimeCompare (SYSTEMTIME *, SYSTEMTIME *);
extern int		TimeGetFileMod (char *, SYSTEMTIME *);
extern void		ca_temp (int);

#endif

/****
*
*	Borland C 5.0.
*
****/

#ifdef BORLAND_C50

#pragma pack (8)
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <malloc.h>
#include <dos.h>
#include <fcntl.h>
#include <conio.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <winsock.h>
#include <mmsystem.h>
#pragma pack ()

#define NEW_LINE						"\n"
#define TOUPPER(a)						toupper ((UCHAR) (a))
#define ENABLE()						
#define DISABLE()						
#define	FD_BIT_MASK						fd_set
#define EINPROGRESS						WSAEINPROGRESS
#define EWOULDBLOCK						WSAEWOULDBLOCK
#define ECONNRESET						WSAECONNRESET
#define GetLastTcpError()				WSAGetLastError ()
#define SET_OPTION(a,b,c,d,e)			setsockopt (a,b,c,d,e)
#define FILL_ADDRESS(H,A)				H . s_addr = A
#define GET_ADDRESS(H)					(H . s_addr)
#define GET_INET_ADDRESS(a)				make_inet_addr (a)
#define GET_HOST_NAME(a,b)				strcpy (a,"")
#define SOCKET_CLOSE(a)
#define NON_BLOCKING(s,p)				ioctlsocket(s,FIONBIO,(u_long *) &p)
#define NON_BLOCKING_C(s,p)				ioctlsocket(s,FIONBIO,(u_long *) &p)
#define NO_SIGPIPE()				
#define ADDRESS_ALIAS(a)				(a << 12)
#define ADDRESS_MASK(a)					(((ULONG) a) >> 20)
#define TERROR(d)						(!d)
#define TOPENW(n)						fopen (n, "w")
#define TOPENR(n)						fopen (n, "r")
#define TFILENO(d)						(d)
#define TFLUSH(d)						fflush (d)
#define TCLOSE(d)						fclose (d)
#define TSEEK(d,p)						fseek (d, p, SEEK_SET)
#define TWRITE(d,b,l)					fwrite (b,1,l,d);fflush(d);
#define TREAD(d,b,l)					fread (b,1,l,d)
#define GET_TASK_ID()					1

typedef struct sockaddr_in				TCP_ADDR_IN;
typedef struct sockaddr					TCP_ADDR;
typedef int								TCP_ADDR_LEN;
typedef fd_set							FD_BIT_MASK;
typedef unsigned int					UINT;
typedef unsigned char					UCHAR;
typedef unsigned long					ULONG;
typedef FILE							*TFILE;

extern int		kbhit (void);
extern int		getch (void);
extern int		wsa_init (void);
extern void		wsa_exit (void);
extern void		taskDelay (int);
extern void		sysReboot (void);
extern int		TimeCompare (SYSTEMTIME *, SYSTEMTIME *);
extern int		TimeGetFileMod (char *, SYSTEMTIME *);

#endif

/****
*
*	vxWorks
*
****/

#ifdef vxWorks

#include <vxWorks.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <fcntl.h>
#include <ioctl.h>
#include <taskLib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <selectLib.h>
#include <sockLib.h>
#include <hostLib.h>
#include <ioLib.h>
#include <timers.h>
#include <dirent.h>
#include <stat.h>
#include <iv.h>
#include <intLib.h>
#include <sysLib.h>

#define const
#define INTERRUPT						
#define NEW_LINE						"\r\n"
#define GetLastError()					errno
#define GetLastTcpError()				errno
#define SOCKET_ERROR					-1
#define INVALID_SOCKET					-1
#define E_PENDING						EINPROGRESS
#define ENOFILE							ENFILE
#define ENOPATH							ENOENT
#define TOUPPER(a)						toupper ((UCHAR) (a))
#define SET_OPTION(a,b,c,d,e)			setsockopt (a,b,c,d,e)
#define FILL_ADDRESS(H,A)				H . s_addr = A
#define GET_ADDRESS(H)					(H . s_addr)
#define GET_INET_ADDRESS(a)				inet_addr (a)
#define GET_HOST_NAME(a,b)				strcpy (a,"")
#define SOCKET_CLOSE(s)					close(s)
#define NON_BLOCKING(s,p)				ioctl(s, FIONBIO, (int) (&p))
#define NON_BLOCKING_C(s,p)				ioctl(s, FIONBIO, (int) (&p))
#define FormatMessage(a,b,c,d,e,f,g)	strcpy (e, "Not Implmented")
#define NO_SIGPIPE()
#define ENABLE()						vx_enable()
#define DISABLE()						vx_disable()
#define INPORT(a)						vx_inport(a)
#define OUTPORT(a,b)					vx_outport(a,b)
#define GET_VECTOR(a)					vx_getvector(a)
#define SET_VECTOR(a,b)					vx_setvector(a,b)
#define ADDRESS_ALIAS(a)				(a)
#define ADDRESS_MASK(a)					(((ULONG) a) >> 8)
#define TERROR(d)						(d == ERROR)
#define TOPENW(n)						vx_open (n, O_WRONLY, 0)
#define TOPENR(n)						vx_open (n, O_RDONLY, 0)
#define TFLUSH(d)						
#define TFILENO(d)						vx_fileno (d)
#define TCLOSE(d)						vx_close (d)
#define TSEEK(d,p)						vx_seek (d, p)
#define TWRITE(d,b,l)					vx_write (d, b, l)
#define TREAD(d,b,l)					vx_read (d, b, l)
#define GET_TASK_ID()					taskIdSelf ()
#define ca_temp(x)

typedef struct sockaddr_in	TCP_ADDR_IN;
typedef struct sockaddr		TCP_ADDR;
typedef int					TCP_ADDR_LEN;
typedef fd_set				FD_BIT_MASK;
typedef unsigned short		WORD;
typedef int					TFILE;
typedef unsigned int		uint;
typedef unsigned char		uchar;
typedef unsigned long		ulong;

typedef struct {
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME;

typedef struct {
        long LowPart;
        long HighPart;
} LONGLONG;

typedef union {
    struct {
        long LowPart;
        long HighPart;
    } u;
    LONGLONG QuadPart;
} LARGE_INTEGER;

extern int		kbhit (void);
extern int		getch (void);
extern long		GetTickCount (void);
extern void		GetLocalTime (SYSTEMTIME *);
extern void		SetLocalTime (SYSTEMTIME *);
extern int		TimeCompare (SYSTEMTIME *, SYSTEMTIME *);
extern int		TimeGetFileMod (char *, SYSTEMTIME *);
extern int		QueryPerformanceCounter (LARGE_INTEGER *);
extern void		vx_enable ();
extern void		vx_disable ();
extern void		*vx_getvector (int);
extern void		vx_setvector (int, void (*));
extern void		vx_outport (USHORT, UCHAR);
extern UCHAR 	vx_inport (USHORT);
extern TFILE	vx_open (char *, int, int);
extern TFILE	vx_fileno (FILE *);
extern void		vx_close (TFILE);
extern void		vx_write (TFILE, void *, size_t);
extern void		vx_read (TFILE, void *, size_t);
extern void		vx_seek (TFILE, long);

#endif

/****
*
*	Common library prototypes defined for all platforms
*
****/

extern int		case_compare (char *, char *);
extern void		GetTickInit (void);
extern int		GetTickUnits (LARGE_INTEGER *);
extern int		GetTickCounter (LARGE_INTEGER *);
extern int		file_find_first (char *, FIND_FILE_DEF *, int);
extern int		file_find_next (FIND_FILE_DEF *);

