/****
*
*	File name :		sslevel1.h
*	Author :		Steve Johnson
*	Creation date :	September 16, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Include file for the physical communications layer
*
****/

/****
*
*	Definition of handles returned by open
*
****/

typedef void	*LEVEL1_HANDLE;

/****
*
*	Possible level1 error values
*
****/

typedef enum {
	LEVEL1_NORMAL			= -1,
	LEVEL1_BASE				= 1000,
	LEVEL1_BAD_NAME			= LEVEL1_BASE + 1,
	LEVEL1_BAD_HANDLE		= LEVEL1_BASE + 2,
	LEVEL1_NO_MEMORY		= LEVEL1_BASE + 3,
	LEVEL1_OFFLINE			= LEVEL1_BASE + 4,
	LEVEL1_ABORTED			= LEVEL1_BASE + 5,
	LEVEL1_SHUTDOWN			= LEVEL1_BASE + 6,
	LEVEL1_OVERFLOW			= LEVEL1_BASE + 7,
	LEVEL1_TIMEOUT			= LEVEL1_BASE + 8,
	LEVEL1_NO_DATA			= LEVEL1_BASE + 9,
	LEVEL1_IO_ERROR			= LEVEL1_BASE + 10,
	LEVEL1_PROTOCOL			= LEVEL1_BASE + 11,
	LEVEL1_NOT_IMPLEMENTED	= LEVEL1_BASE + 11,
	LEVEL1_BAD_PORT			= LEVEL1_BASE + 12,
	LEVEL1_BAD_ADDRESS		= LEVEL1_BASE + 13,
} LEVEL1_STATUS;

extern LEVEL1_STATUS	level1_init (void);
extern LEVEL1_STATUS	level1_connect (LEVEL1_HANDLE *, char *);
extern LEVEL1_STATUS	level1_publish (LEVEL1_HANDLE *, char *);
extern LEVEL1_STATUS	level1_accept (LEVEL1_HANDLE *, LEVEL1_HANDLE);
extern LEVEL1_STATUS	level1_write (LEVEL1_HANDLE, size_t, void *);
extern LEVEL1_STATUS	level1_read (LEVEL1_HANDLE, size_t, void *, size_t *);
extern LEVEL1_STATUS	level1_poll (LEVEL1_HANDLE, size_t *);
extern LEVEL1_STATUS	level1_clear (LEVEL1_HANDLE);
extern LEVEL1_STATUS	level1_shutdown (LEVEL1_HANDLE);
extern LEVEL1_STATUS	level1_exit (void);

