/****
*
*	File name :		sstcpip.h
*	Author :		Steve Johnson
*	Creation date :	September 10, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Include file for the tcp/ip library
*
****/

typedef void	*TCP_HANDLE;

#define TCPIP_NORMAL			-1
#define TCPIP_BASE				2000
#define TCPIP_PROTOCOL			TCPIP_BASE + 1
#define TCPIP_BAD_ADDRESS		TCPIP_BASE + 2
#define TCPIP_CHANNEL			TCPIP_BASE + 3
#define TCPIP_NO_MEMORY			TCPIP_BASE + 4
#define TCPIP_ABORTED			TCPIP_BASE + 5
#define TCPIP_SHUTDOWN			TCPIP_BASE + 6
#define TCPIP_OVERFLOW			TCPIP_BASE + 7
#define TCPIP_UNDERFLOW			TCPIP_BASE + 8
#define TCPIP_TIMEOUT			TCPIP_BASE + 9
#define TCPIP_NO_DATA			TCPIP_BASE + 10
#define TCPIP_NOT_IMPLEMENTED	TCPIP_BASE + 11

extern int	tcpip_init (void);
extern int	tcpip_publish (TCP_HANDLE *, char *);
extern int	tcpip_connect (TCP_HANDLE *, char *);
extern int	tcpip_accept (TCP_HANDLE *, TCP_HANDLE);
extern int	tcpip_write (TCP_HANDLE, size_t, void *);
extern int	tcpip_select (TCP_HANDLE *);
extern int	tcpip_poll (TCP_HANDLE);
extern int	tcpip_read (TCP_HANDLE, size_t, void *, size_t *);
extern int	tcpip_shutdown (TCP_HANDLE);
extern int	tcpip_exit (void);

