/**********
*
*	File:	accredfldidx.h
*	Author:	William H. Szostak
*	Date:	08-August-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the accumulator record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in recAcc.c.
*	NOTE:
*		current size needed for redundant buffer
*			20	header
*		       156	field ptrs
*		       224	field sizes
*		      ----
*		       400
*
*	Modification Log
*       ----------------
* .01	05-10-94	ems	added INI2, chg NUMFLDS to NUMACCFLDS
* .02	09-16-94	ems	added lots of fields
* .03	10-07-94	ems	added LRST
* .04	10-10-94	ems	added NFTM
* .05	10-14-94	ems	added TIME and RSEC, deleted FTS0 and LRST
* .05	10-20-94	ems	chg TIME to LATM (last alarm time)
* .06	01-13-94	ems	added MLST
* .07	02-07-95	ems	added LMTO (last RTOT used for monitor)
* .06	04-03-96	ems	added HHLL,HILO,RTCT,LARF
**********/

#define		STAT	0	/* current status		*/
#define		SEVR	1	/* current severity		*/
#define		VAL	2	/* current value		*/
#define		RSMP	3	/* number running samples	*/
#define		RTOT	4	/* running total		*/
#define		RAVG	5	/* running average		*/
#define		RMIN	6	/* running minimum		*/
#define		RMAX	7	/* running maximum		*/
#define		FTIM	8	/* frozen time stamp		*/
#define		FSMP	9	/* frozen number samples	*/
#define		FTOT	10	/* frozen total			*/
#define		FAVG	11	/* frozen average		*/
#define		FMIN	12	/* frozen minimum		*/
#define		FMAX	13	/* frozen maximum		*/
#define		LALM	14	/* last value alarmed		*/
#define		RSEC	15	/* reset seconds		*/
#define		INI2	16	/* secondary init flag		*/
#define		LTCK	17	/* last tick count		*/
#define		LMOD	18	/* last mode			*/
#define		STOT	19	/* save running total		*/
#define		SSMP	20	/* save running sample number	*/
#define		SMIN	21	/* save running minimum		*/
#define		SMAX	22	/* save running maximum		*/
#define		SSTT	23	/* save ATOT			*/
#define		LARS	24	/* last async reset value	*/
#define		ARSF	25	/* async reset flag		*/
#define		FSTA	26	/* frozen status		*/
#define		FSEV	27	/* frozen severity		*/
#define		NFSA	28	/* running frozen status	*/
#define		NFSV	29	/* running frozen severity	*/
#define		LSAV	30	/* last running save ticks	*/
#define		FSEC	31	/* frozen seconds		*/
#define		ATOT	32	/* total for RAVG		*/
#define		LASF	33	/* last async freeze value	*/
#define		TALC	34	/* threshold alarm count	*/
#define		NFTM	35	/* next freeze time		*/
#define		LATM	36	/* last alarm time		*/
#define		MLST	37	/* last VAL monitored		*/
#define		LMTO	38	/* last RTOT used for monitor	*/
#define		HHLL	39	/* hihi/lolo alarm counter	*/
#define		HILO	40	/* high/low alarm counter	*/
#define		RTCT	41	/* return to normal counter	*/
#define		LARF	42	/* last alarm flag		*/

#define		NUMACCFLDS	(LARF + 1)

