#if (defined(SOLARIS) || defined(WIN32))

#define bcopy(s,d,n) memcpy(d,s,n);

#else SOLARIS

#ifndef AXP
#define bcopy(src, dest, nbytes) \
{ \
	register int moveSize = (nbytes); \
	long srcAddr = (long)(src); \
	long destAddr = (long)(dest); \
	long descrim = srcAddr | destAddr | moveSize; \
	if (descrim & 1) \
	    { \
	    register char *chSrc = (char *) srcAddr; \
	    register char *chDest = (char *) destAddr; \
	    while (moveSize--) \
		*chDest++ = *chSrc++; \
	    } \
	else if (descrim & 2) \
	    { \
	    register short *shSrc = (short *) srcAddr; \
	    register short *shDest = (short *) destAddr; \
	    moveSize >>= 1; \
	    while (moveSize--) \
		*shDest++ = *shSrc++; \
	    } \
	else \
	    { \
	    register int *inSrc = (int *) srcAddr; \
	    register int *inDest = (int *) destAddr; \
	    moveSize >>= 2; \
	    while (moveSize--) \
		*inDest++ = *inSrc++; \
	    } \
}

#else AXP
#define bcopy(src, dest, nbytes) \
{ \
	register int moveSize = (nbytes); \
	long srcAddr = (long)(src); \
	long destAddr = (long)(dest); \
	long descrim = srcAddr | destAddr | moveSize; \
	if (descrim & 1) \
	    { \
	    register char *chSrc = (char *) srcAddr; \
	    register char *chDest = (char *) destAddr; \
	    while (moveSize--) \
		*chDest++ = *chSrc++; \
	    } \
	else if (descrim & 2) \
	    { \
	    register short *shSrc = (short *) srcAddr; \
	    register short *shDest = (short *) destAddr; \
	    moveSize >>= 1; \
	    while (moveSize--) \
		*shDest++ = *shSrc++; \
	    } \
	else if (descrim & 4) \
	    { \
	    register int *inSrc = (int *) srcAddr; \
	    register int *inDest = (int *) destAddr; \
	    moveSize >>= 2; \
	    while (moveSize--) \
		*inDest++ = *inSrc++; \
	    } \
	else \
	    { \
	    register long *loSrc = (long *) srcAddr; \
	    register long *loDest = (long *) destAddr; \
	    moveSize >>= 3; \
	    while (moveSize--) \
		*loDest++ = *loSrc++; \
	    } \
}
#endif AXP
#endif SOLARIS
