/**********
*
*	File:	biredfldidx.h
*	Author:	William H. Szostak
*	Date:	14-Feb-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the binary input record.
*
*	Modification Log
*       ----------------
*	.01  03-12-93	ems	deleted ACK, adjusted indicies accordingly
*	.02  04-20-94	ems	added INI2, chg NUMFLDS to NUMBIFLDS
*	.03  10-12-94	ems	added TIME and LVAL
*	.04  10-20-94	ems	chg TIME to LATM (last alarm time)
*	.05  12-05-94	ems	added TCNT (transition counter)
*       .06  01-13-95	wep	add mlst to redundancy
*	.07  04-11-96	ems	added HHLL,RTCT
*
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current block value		*/
#define		LALM	3	/* last value alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last alarm time		*/
#define		LVAL	6	/* last block value		*/
#define		TCNT	7	/* state transition counter	*/
#define         MLST    8	/* last value monitored		*/
#define		HHLL	9	/* STATE alarm counter		*/
#define		RTCT	10	/* return to normal counter	*/

#define		NUMBIFLDS    (RTCT + 1)
