/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		MACROS TO CONVERT DOUBLES AND FLOATS		*/
/*								*/
/*	(Our own little implementation of XDR?)			*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef BYTEORDER_0123

#define ntohd(NET, HOST) \
    { \
    int	x; \
    x = ntohl(*(int*) (NET)); \
    *(int *)(HOST) = ntohl(*(int *)((int *)(NET) + 1)); \
    *(int *)((int *)HOST + 1) = x; \
    }

#define ntohf(NET, HOST) \
    {*(unsigned int *) (HOST) = ntohl(*(unsigned int *)NET);}

#else BYTEORDER_0123

#ifdef ultrix

#define ntohd(NET, HOST) \
    { \
    int	x; \
    x = ntohl(*(int*) NET); \
    *(int *)(HOST) = ntohl(*((int *)NET + 1)); \
    *((int *)HOST + 1) = x; \
    }

#define ntohf(NET, HOST) \
    {*(unsigned long *) (HOST) = ntohl(*(unsigned long *)NET);}

#else
#ifdef vax

double mth$cvt_g_d();

#define ntohd(NET, HOST) \
    { \
    *((short *)(HOST)) = ntohs(*(short *)NET) + 32; \
    *(((short *)HOST) + 1) = ntohs(*(((short *)NET) + 1)); \
    *(((short *)HOST) + 2) = ntohs(*(((short *)NET) + 2)); \
    *(((short *)HOST) + 3) = ntohs(*(((short *)NET) + 3)); \
    *HOST = mth$cvt_g_d(HOST); \
    }

#define ntohf(NET, HOST) \
    { \
    *((short *)(HOST)) = ntohs(*(short *)NET) + 256; \
    *(((short *)HOST) + 1) = ntohs(*(((short *)NET) + 1)); \
    }

#else vax

#define ntohd(NET, HOST) \
    {*(double *)HOST = *(double *)NET;}

#define ntohf(NET, HOST) \
    {*(float *)HOST = *(float *) NET;}

#endif vax
#endif ultrix
#endif BYTEORDER_0123

