/* dbRecType.h		record type names*/
/* share/epicsH @(#)dbRecType.h	1.3     6/7/91 */

/*
 *      Author:          Marty Kraimer
 *      Date:            6-1-90
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .01  mm-dd-yy        iii     Comment
 */

#ifndef INCdbRecTypeh
#define INCdbRecTypeh 1

struct recType {
	long	number;		/*number of types		*/
	char	**papName;	/*ptr to arr of ptr to name	*/
    };
extern struct recType *dbRecType;

#define S_rectype_noRecs     (M_recType| 3) /*No record types are defined*/

/*************************************************************************
 * Except that some entries may be null the following is valid access
 * 
 * dbRecType->papName[i]
 *
 * The memory layout is
 *
 * dbRecType->papName[1]->"ai"
 *		     [2]->"ao"
 **************************************************************************/

/**************************************************************************
 * The following macro returns NULL or a ptr to the rectype string
 * A typical usage is:
 *
 *	char *pstr;
 *	if(!(pstr=GET_PRECTYPE(type))) {<null>}
 **************************************************************************/
#define GET_PRECTYPE(REC_TYPE)\
(\
    dbRecType\
	?(\
		( ((REC_TYPE)<1) || ((REC_TYPE)>=dbRecType->number) )\
		? NULL\
		: (dbRecType->papName[(REC_TYPE)])\
	)\
	: NULL\
)
#endif
