/* db_addr.h */
/* share/epicsH @(#)db_addr.h	1.1     6/25/91 */

/*
 *      Author:          Bob Dalesio
 *      Date:            4-4-88
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 *	Modification Log:
 *	-----------------
 */
#ifndef INC_db_addrh
#define INC_db_addrh
/* 
 *database access address structure 
 */

/* include definition of struct dbAddr */

#include "dbAddr.h"

typedef struct db_addr
{
        char    *precord;       /* record number of specified type	    */
        char    *pfield;        /* offset from the record origin	    */
        char    *pad0;          /* not used by old			    */
        short   pad1;           /* not used by old			    */
        short   no_elements;    /* number of elements in arrays of data	    */
        short   record_type;    /* type of record being accessed	    */
        short   pad2;           /* not used by old			    */
        short   field_size;     /* size of the field being accessed	    */
        short   special;        /* special processing			    */
        short   choice_set;     /* index of choiceSet GBLCHOICE & RECCHOICE */
        short   field_type;	/* field type as seen by database request   */
				/*DBR_STRING,...,DBR_ENUM,DBR_NOACCESS	    */
} DB_ADDR;

void	db_process (register struct db_addr *pdb_addr);

void	fill (register char  *pbuffer, register short size, register char  fillchar);

int	db_name_to_addr(char *pname, struct db_addr *paddr);

int	db_get_field(DBADDR *paddr, short buffer_type,
		     char *pbuffer, unsigned short no_elements,
		     void   *pfl);
int	db_put_field(DBADDR *paddr, short src_type,
		     char *psrc, short no_elements);

#endif
