#ifndef INC_ezsSockSubr_h
#define INC_ezsSockSubr_h
/*	@(#)ezsSockSubr.h	1.1 6/19/91
 *	Author:	Roger A. Cole
 *	Date:	11/23/90
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 *	Copyright 1991, the Regents of the University of California,
 *	and the University of Chicago Board of Governors.
 *
 *	This software was produced under  U.S. Government contracts:
 *	(W-7405-ENG-36) at the Los Alamos National Laboratory,
 *	and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *	Initial development by:
 *		The Controls and Automation Group (AT-8)
 *		Ground Test Accelerator
 *		Accelerator Technology Division
 *		Los Alamos National Laboratory
 *
 *	Co-developed with
 *		The Controls and Computing Group
 *		Accelerator Systems Division
 *		Advanced Photon Source
 *		Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .00	11/23/90	rac	initial version
 * .01	06-19-91	rac	installed in SCCS
 *
 */
/*+/mod***********************************************************************
* TITLE	ezsSockSubr.h - definitions for using the easy socket routines
*
* DESCRIPTION
*
*-***************************************************************************/

/*-----------------------------------------------------------------------------
* prototypes
*----------------------------------------------------------------------------*/
int ezsCheckFdRead(int fd);
int ezsCheckFpRead(FILE *fp);
int ezsConnectToServer(int *pServerSock, int portNum, char *hostName, char *message);
int ezsCreateListenSocket(int *pListenSock, int portNum);
int ezsFopenToFd(FILE **pFp, int *pFd);
int ezsFreopenToFd(FILE *fp, int *pFd, int *pOldFd);
int ezsListenExclusiveUse(int *pClientSock, int *pListenSock, int *pInUseFlag,
			  char *name, char *greetMsg);
void ezsSleep(int seconds, int usec);

#endif
