/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* iocsiodvr_bridge.h - bridge interface prototypes */

void print_init_values (unsigned short line);

void enable_rx_ints (unsigned short line);

void disable_rx_ints (unsigned short line);

void enable_tx_ints (unsigned short line);
 
void disable_tx_ints (unsigned short line);

void set_rts (unsigned short line);

void clear_rts (unsigned short line);

unsigned short read_cts (unsigned short line);

void set_dtr (unsigned short line);

void clear_dtr (unsigned short line);

unsigned short read_dsr (unsigned short line);

unsigned short read_dcd (unsigned short line);

/*
  read_rx_hw - read char & status @ hardware level

  some of the code in this routine is cobbled from the
  appropriate standard characteristics modules (i.e. hw*.c).
*/
void read_rx_hw (unsigned short line,
 char *retch, unsigned short *retstat, unsigned short *rx_err_mask);

/*
  write_tx_hw - write char, read status @ hardware level

  the code in this routine is cobbled from the appropriate
  standard characteristics modules (i.e. hw*.c).
*/
void write_tx_hw (unsigned short line,
 char outch, unsigned short *retstat, unsigned short *tx_err_mask);

void z8530stats (unsigned int line);

int DefaultHardwareSetup(void);

int comm_init (unsigned int channel, char *mode, FUNCPTR txint_callback, FUNCPTR rxint_callback);

int comm_disconnect (unsigned short channel);
