/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/**********
*
*	File:	ldfwe1redfldidx.h
*	Author:	emsteel
*	Date:	23 May 96
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the lead follow 1 record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in ldfw1.c.
*
*	Modification Log
*       ----------------
*	.01	05-23-96	ems	creation date
**********/


#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		LALM	3	/* last VAL alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last alarm time		*/
#define		MLST	6	/* last VAL monitored		*/
#define		PREQ	7	/* pumps requested		*/
#define		LPST	8	/* last pump started		*/
#define		LPCT	9	/* last pump chg time		*/
#define		LPCM	10	/* last pump cmd time		*/
#define		PC01	11	/* pump 1 chg time		*/
#define		PC02	12	/* pump 2 chg time		*/
#define		PC03	13	/* pump 3 chg time		*/
#define		PC04	14	/* pump 4 chg time		*/
#define		PC05	15	/* pump 5 chg time		*/
#define		PC06	16	/* pump 6 chg time		*/
#define		PC07	17	/* pump 7 chg time		*/
#define		PC08	18	/* pump 8 chg time		*/
#define		PC09	19	/* pump 9 chg time		*/
#define		PC10	20	/* pump 10 chg time		*/
#define		PC11	21	/* pump 11 chg time		*/
#define		PC12	22	/* pump 12 chg time		*/
#define		PC13	23	/* pump 13 chg time		*/
#define		PC14	24	/* pump 14 chg time		*/
#define		PC15	25	/* pump 15 chg time		*/
#define		PC16	26	/* pump 16 chg time		*/
#define		PC17	27	/* pump 17 chg time		*/
#define		PC18	28	/* pump 18 chg time		*/
#define		PC19	29	/* pump 19 chg time		*/
#define		PC20	30	/* pump 20 chg time		*/

#define		NUMLDFW1FLDS    (PC20 + 1)

