/* lstLib.h - doubly linked list library header */

/*
modification history
--------------------
01d,21may86,llk	 added forward declaration of lstNStep.
01c,03jun84,dnw  changed list.{head,tail} to list.node.
		 added declarations of lst{First,Last,Next,Previous}.
01b,27jan84,ecs  added inclusion test.
01b,15mar83,dnw  changed name from lstlb to lstLib
*/

#ifndef INClstLibh
#define INClstLibh	1


/* type definitions */

typedef struct node		/* Node of a linked list. */
    {
    struct node *next;		/* Points at the next node in the list */
    struct node *previous;	/* Points at the previous node in the list */
    } NODE;


/* HIDDEN */

typedef struct			/* Header for a linked list. */
    {
    NODE node;			/* Header list node */
    int count;			/* Number of nodes in list */
    } LIST;

/* END_HIDDEN */


/* function declarations */

void lstInit (LIST *pList);
void lstAdd (LIST *pList, NODE *pNode);
void lstConcat (LIST *pDstList, LIST *pAddList);
int lstCount (LIST *pList);
void lstDelete (LIST *pList, NODE *pNode);
void lstExtract (LIST *pSrcList, NODE *pStartNode, NODE *pEndNode, LIST *pDstList);
NODE *lstFirst (LIST *pList);
NODE *lstGet (LIST *pList);
void lstInsert (LIST *pList, NODE *pPrev, NODE *pNode);
NODE *lstLast (LIST *pList);
NODE *lstNext (NODE *pNode);
NODE *lstNth (LIST *pList, int nodenum);
NODE *lstPrevious (NODE *pNode);
NODE *lstNStep (NODE *pNode, int nStep);
int lstFind (LIST *pList, NODE *pNode);
void lstFree (LIST *pList);

#endif
