/****************************************************************/
/*								*/
/*		DEFINES USED TO FIND MEMORY LEAKS		*/
/*								*/
/*	These defines are used to divert the usual memory	*/
/*	allocation calls to TIS routines that server as a	*/
/*	wrapper. These wrapper routines leave tracks that	*/
/*	can be used to isolate memory leaks. See memLeak.c.	*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef WIN32
#include <X11/xlibint.h>	/* defines malloc,etc... to their X counterparts */
#else
#define malloc(x)	tisMalloc(__FILE__, __LINE__, (x))
#define calloc(x,y)	tisCalloc(__FILE__, __LINE__, (x), (y))
#define free(x)		tisFree((x))

void *tisMalloc();
void *tisCalloc();
void tisFree();
#endif WIN32