/**********
*
*	File:	pidredfldidx.h
*	Author:	John L. Dalesio
*	Date:	Aug 19 1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the pid record.
*
*	Modification Log
*       ----------------
*  .01	02-28-94	ems	deleted MLST, ALST
*  .02	04-27-94	ems	added INI2
*  .03	10-13-94	ems	added TIME
*  .04	10-20-94	ems	chg TIME to LATM (last alarm time)
*  .05	02-08-95	ems	added LMAS (last monitored ASTP) 
*				and LMMV (last MVAL monitored)
*  .06	04-04-96	ems	added DVCT, HLOC, HLSC
*	
**********/


#define		STAT	0
#define		SEVR	1
#define		ASTP	2
#define		MVAL	3
#define		NMV	4
#define		NSP	5
#define		CT	6
#define		ERR	7
#define		ERSQ	8
#define		DERR	9
#define		DVAL	10
#define		VAL	11
#define		PVAL	12
#define		LALM	13
#define		LMDE	14
#define		MODE	15
#define		SPAN	16
#define		ZERO	17
#define		AM	18
#define		USCS	19
#define		SPT	20
#define		FGCR	21
#define		SNDF	22
#define		GACT	23
#define		NGAP	24
#define		CSP     25
#define		ISTP    26
#define		INI2	27
#define		LATM	28
#define		MLST	29
#define		LMAS	30
#define		LMMV	31
#define		DVCT	32	/* deviation alarm counter	*/
#define		HLOC	33	/* hi/lo clamp alarm counter	*/
#define		HLSC	34	/* hi/lo setpt alarm counter	*/

#define		NUMPIDFLDS    (HLSC + 1)

