
/****************************************************************************
 *
 *  FILE    :   piperedfldidx.h 
 *  DATE    :   16 Mar 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indices used by the
 *              redundant update memory que routines for the pipe record
 *
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 23 Feb 94
 *  REVISION:  removed INIT, MLST, ALST, not needed
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 18 MAY 94
 *  REVISION: added INI2, CMDS, CRUN, CSTP, SRUN, SSTP, PCMD
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION: added TIME
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :123 Jan 95
 *  REVISION:	added MLST
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 *  NOTE: The order of the fields in this list MUST match the order in the
 *        namelist[] in recPipe.c
 *
 *
****************************************************************************/



#define     STAT     0     /* alarm status            */
#define     SEVR     1     /* alarm severity          */
#define     VAL      2     /* current product volume  */
#define     PSTS     3     /* current pipe ops status */
#define     PISV     4     /* pipe status local       */
#define     TTIM     5     /* stop/quiescent timer    */
#define     QVOL     6     /* quiescent volume        */
#define     LALM     7     /* last value alarmed      */
#define     ESOU     8     /* emergency stop          */
#define     TVAL     9     /* is pipe in volume alarm */
#define     INI2     10    /* secondary init flag     */
#define     CMDS     11    /* command string          */
#define     CRUN     12    /* run command             */
#define     CSTP     13    /* stop command            */
#define     SRUN     14    /* special run command     */
#define     SSTP     15    /* special stop command    */
#define     PCMD     16    /* previous command        */
#define     LATM     17    /* last alarm time	      */
#define     MLST     18    /* last VAL monitored      */

#define     NUMPIPEFLDS (MLST + 1)

