
/* accumRecord.h */
#ifndef INCaccumRecordh
#define INCaccumRecordh
#ifndef	INCLlstLibh
#include <lstLib.h>	/* list structure definition for the monitor list */
#endif
#ifndef	INCLsemLibh
#include <semLib.h>	/* semaphore structure definition for the monitor lock*/
#endif
#ifndef INCLfast_lockh
#include <fast_lock.h>	/* fast lock data structures and macros */
#endif
#ifndef INCLlinkh
#include <link.h>	/* fast lock data structures and macros */
#endif
#ifndef INC_tsDefs_h
#include <tsDefs.h>	/* time-stamp related definitions */
#endif
struct accumRecord	{
	char		name[28];		/*  */
	char		desc[41];		/*  */
	char alignPad1;		/*  */
	unsigned short	scan;		/*  */
	short		phas;		/*  */
	short		evnt;		/*  */
	unsigned short	dtyp;		/*  */
	unsigned short	tenb;		/*  */
	struct dset	*dset;		/*  */
	LIST		mlis;		/*  */
	FAST_LOCK	mlok;		/*  */
	struct link	sdis;		/*  */
	struct link	adis;		/*  */
	short		disv;		/*  */
	short		disa;		/*  */
	unsigned char	pact;		/*  */
	unsigned char	udf;		/*  */
	short		lset;		/*  */
	short		lcnt;		/*  */
	short		proc;		/*  */
	short		init;		/*  */
	unsigned short	stat;		/*  */
	unsigned short	sevr;		/*  */
	unsigned short	nsta;		/*  */
	unsigned short	nsev;		/*  */
	short		tagd;		/*  */
	TS_STAMP	latm;		/*  */
	TS_STAMP      lptm;		/*  */
	unsigned short	ack;		/*  */
	unsigned short	oscn;		/*  */
	unsigned short	aenb;		/*  */
	char		resn[16];		/*  */
	char		algp[16];		/*  */
	short		rdur;		/*  */
	void          *radr;		/*  */
	short		rduf;		/*  */
	short		rcrc;		/*  */
	struct scanLock *lsad;		/*  */
	struct dbCommon *lsnr;		/*  */
	short		ini2;		/*  */
	unsigned short	msev;		/*  */
	unsigned short	psta;		/*  */
	unsigned short	psev;		/*  */
	short		hhll;		/*  */
	short		hilo;		/*  */
	short		aldl;		/*  */
	short		rtct;		/*  */
	unsigned long	larf;		/*  */
	short		dvct;		/*  */
	unsigned short	itag;		/*  */
	long		tstp;		/*  */
	short		ralm;		/*  */
	char alignPad3[2];		/*  */
	/* start of accum specific fields */ 
	double		val;		/*  */
	double		rsmp;		/*  */
	double		rtot;		/*  */
	double		ravg;		/*  */
	double		rmin;		/*  */
	double		rmax;		/*  */
	TS_STAMP        ftim;		/*  */
	double		fsmp;		/*  */
	double		ftot;		/*  */
	double		favg;		/*  */
	double		fmin;		/*  */
	double		fmax;		/*  */
	char		egu[16];		/*  */
	short		prec;		/*  */
	short		aftm;		/*  */
	float		hopr;		/*  */
	float		lopr;		/*  */
	struct link	inp;		/*  */
	float		aoff;		/*  */
	float		aslo;		/*  */
	struct link	flnk;		/*  */
	float		hihi;		/*  */
	float		lolo;		/*  */
	float		high;		/*  */
	float		low;		/*  */
	float		thld;		/*  */
	unsigned short	hhsv;		/*  */
	unsigned short	llsv;		/*  */
	unsigned short	hsv;		/*  */
	unsigned short	lsv;		/*  */
	unsigned short	thsv;		/*  */
	unsigned short	uzdf;		/*  */
	short		fafh;		/*  */
	short		fpps;		/*  */
	double		hyst;		/*  */
	double		adel;		/*  */
	double		mdel;		/*  */
	double		lalm;		/*  */
	double		alst;		/*  */
	double		mlst;		/*  */
	double		rval;		/*  */
	double		oraw;		/*  */
	double		zdth;		/*  */
	double		rlov;		/*  */
	unsigned short	afmd;		/*  */
	unsigned short	roff;		/*  */
	unsigned short	aftu;		/*  */
	unsigned short	dmdf;		/*  */
	double		afiv;		/*  */
	struct link	afis;		/*  */
	unsigned short	afs;		/*  */
	short		thct;		/*  */
	char		fts0[28];		/*  */
	short		fafm;		/*  */
	short		mpre;		/*  */
	float		mslo;		/*  */
	float		moff;		/*  */
	char		megu[16];		/*  */
	float		mhpr;		/*  */
	float		mlpr;		/*  */
	double		atot;		/*  */
	double		stot;		/*  */
	double		ssmp;		/*  */
	double		smin;		/*  */
	double		smax;		/*  */
	double		sstt;		/*  */
	unsigned long	ltck;		/*  */
	unsigned long	lsav;		/*  */
	unsigned long	fsec;		/*  */
	struct link	aris;		/*  */
	double		lars;		/*  */
	double		lasf;		/*  */
	unsigned short	arsf;		/*  */
	unsigned short	fsta;		/*  */
	unsigned short	fsev;		/*  */
	unsigned short	nfsa;		/*  */
	unsigned short	nfsv;		/*  */
	unsigned short	tsel;		/*  */
	unsigned short	mode;		/*  */
	unsigned short	lmod;		/*  */
	float		srvt;		/*  */
	float		terr;		/*  */
	double		lmto;		/*  */
	double		lato;		/*  */
	short		talc;		/*  */
	short		rgrp;		/*  */
	char		lrst[28];		/*  */
	TS_STAMP         nftm;		/*  */
	unsigned long	rsec;		/*  */
};
#endif

