/****************************************************************************
 *
 *  FILE    :   tankredfldidx.h
 *  DATE    :   14 Apr 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the tank record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 23 Feb 94
 *  REVISION:  removed INIT, MLST, ALST, ESIN not needed
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 25 May 94
 *  REVISION:	added INI2, PCMD and command fields
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION:	added TIME, NOTE!!!, this requires a redundant buffer of
 *		char[418], as of this time the max is 424 as defined by
 *		REDQ_MAX_MSGLEN 
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          : 13 Jan 95
 *  REVISION:	added MLST
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order in the
 *       namlist[] in recTank.c
 *       Spelling must also match that in tankRecord.<ascii,h>
 *
****************************************************************************/


#define	STAT	0	/* alarm status            */
#define	SEVR	1	/* alarm severity          */
#define	VAL	2	/* current product volume  */
#define	V01M	3	/* valve 1 mode            */
#define	V02M	4	/* valve 2 mode            */
#define	V03M	5	/* valve 3 mode            */
#define	V04M	6	/* valve 4 mode            */
#define	V05M	7	/* valve 5 mode            */
#define	V06M	8	/* valve 6 mode            */
#define	V07M	9	/* valve 7 mode            */
#define	V08M	10	/* valve 8 mode            */
#define	V09M	11	/* valve 9 mode            */
#define	V10M	12	/* valve 10 mode           */
#define	APID	13	/* API date                */
#define	ESOU	14	/* emergency stop output   */
#define	TSTS	15	/* tank status             */
#define	SGRV	16	/* API specific gravity    */
#define	TASV	17	/* tank status local       */
#define	MLOS	18	/* mode lock status        */
#define	QVOL	19	/* quiescent (stopped) vol */
#define	TTIM	20	/* stopped/qvol timer      */
#define	VTIM	21	/* valve state timer       */
#define	LALM	22	/* last volume alarmed     */
#define	LLAL	23	/* last level alarmed      */
#define	LTAL	24	/* last temp alarmed       */
#define	LBAL	25	/* last BSW alarmed        */
#define	TVAL	26	/* is tank in volume alarm */
#define	LVHH	27	/* high high level alarm   */
#define	LVHI	28	/* high level              */
#define	LVLO	29	/* low level               */
#define	LVLL	30	/* low low level           */
#define	PCMD	31	/* last command string     */
#define	INI2	32	/* secondary init flag     */
#define	CMDS	33	/* command string field    */
#define	CISS	34	/* issue command           */
#define	CREC	35	/* receive command         */
#define	CRUN	36	/* run command             */
#define	CSTP	37	/* stop command            */
#define	SISS	38	/* special issue command   */
#define	SREC	39	/* special receive command */
#define	SRUN	40	/* special run command     */
#define	SSTP	41	/* special stop command    */
#define	LATM	42	/* last alarm time	   */
#define	MLST	43	/* last VAL monitored	   */

#define	NUMTANKFLDS (MLST + 1)

