/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
 * Modification Log:
 * -----------------
 * .01  mm-dd-yy        iii     Comment
 * .01	01-11-96	ems	added zcmf (zero cmds flag) to UDB_ZERO_CMDS macro
*/


#ifndef IncludeUDBMACROS
#define	IncludeUDBMACROS

#include <alarm.h>
#include <dbDefs.h>
#include <errMdef.h>

#ifndef	UDBDEFS
#include <udbDefs.h>
#endif


/* THE FOLLOWING MACRO IS PROVIDED TO DEFINE THE USER'S LOCAL STACK VERSION
   OF THE DATA IN THE UDB RECORD
*/

/* define udbRecord variables for the users local stack */
#define	UDBDATA	struct userudb_data	usd;


/* THE FOLLOWING MACROS ARE PROVIDED FOR THE USER TO EASILY ACCESS THE
   DATA IN UDBDATA (DEFINED PREVIOUSLY)
*/
#define	UDBNAME	usd.udb_name	/* udb record name */

#define	INI2	usd.ini2	/* secondary init flag */
#define	STAT	usd.stat	/* current alarm status */
#define	SEVR	usd.sevr	/* current alarm severity */
#define	NSTA	usd.nsta	/* new alarm status */
#define	NSEV	usd.nsev	/* new alarm severity */
#define	TENB	usd.tenb	/* trend enable flag */

#define	INV1	usd.inv[0]	/* input values 1 - 8 */
#define	INV2	usd.inv[1]
#define	INV3	usd.inv[2]
#define	INV4	usd.inv[3]
#define	INV5	usd.inv[4]
#define	INV6	usd.inv[5]
#define	INV7	usd.inv[6]
#define	INV8	usd.inv[7]

#define IOK1	usd.iok[0]	/* input status 1 - 8 */
#define IOK2	usd.iok[1]
#define IOK3	usd.iok[2]
#define IOK4	usd.iok[3]
#define IOK5	usd.iok[4]
#define IOK6	usd.iok[5]
#define IOK7	usd.iok[6]
#define IOK8	usd.iok[7]

#define	OVL1	usd.ovl[0]	/* output value 1 - 8 */
#define OVL2	usd.ovl[1]
#define OVL3	usd.ovl[2]
#define OVL4	usd.ovl[3]
#define OVL5	usd.ovl[4]
#define OVL6	usd.ovl[5]
#define OVL7	usd.ovl[6]
#define OVL8	usd.ovl[7]

#define	OOK1	usd.ook[0]	/* output status 1 - 8 */
#define	OOK2	usd.ook[1]
#define	OOK3	usd.ook[2]
#define	OOK4	usd.ook[3]
#define	OOK5	usd.ook[4]
#define	OOK6	usd.ook[5]
#define	OOK7	usd.ook[6]
#define	OOK8	usd.ook[7]

#define	MODE	usd.mode	/* current mode */
#define	NCMD	usd.ncmd	/* current new command */
#define	LCMD	usd.lcmd	/* last command value */

#define	CMDM1	usd.cmm[0]	/* manual commands 1 - 8 */
#define	CMDM2	usd.cmm[1]
#define	CMDM3	usd.cmm[2]
#define	CMDM4	usd.cmm[3]
#define	CMDM5	usd.cmm[4]
#define	CMDM6	usd.cmm[5]
#define	CMDM7	usd.cmm[6]
#define	CMDM8	usd.cmm[7]

#define	CMDA1	usd.cma[0]	/* automatic commands 1 - 8 */
#define	CMDA2	usd.cma[1]
#define	CMDA3	usd.cma[2]
#define	CMDA4	usd.cma[3]
#define	CMDA5	usd.cma[4]
#define	CMDA6	usd.cma[5]
#define	CMDA7	usd.cma[6]
#define	CMDA8	usd.cma[7]

#define	FUNC	usd.func	/* current function */
#define	FUNC1	usd.ffl[0]	/* function flags 1 - 4 */
#define	FUNC2	usd.ffl[1]
#define	FUNC3	usd.ffl[2]
#define	FUNC4	usd.ffl[3]

#define	STTS	usd.stts	/* current block status */

#define	CHKBX1	usd.chk[0]	/* check boxes 1 - 8 */
#define	CHKBX2	usd.chk[1]
#define	CHKBX3	usd.chk[2]
#define	CHKBX4	usd.chk[3]
#define	CHKBX5	usd.chk[4]
#define	CHKBX6	usd.chk[5]
#define	CHKBX7	usd.chk[6]
#define	CHKBX8	usd.chk[7]

#define NUMFL1	usd.n[0]	/* numeric float values 1 - 12 */
#define NUMFL2	usd.n[1]
#define NUMFL3	usd.n[2]
#define NUMFL4	usd.n[3]
#define NUMFL5	usd.n[4]
#define NUMFL6	usd.n[5]
#define NUMFL7	usd.n[6]
#define NUMFL8	usd.n[7]
#define NUMFL9	usd.n[8]
#define NUMFL10	usd.n[9]
#define NUMFL11	usd.n[10]
#define NUMFL12	usd.n[11]

#define	NUMDB1	usd.d[0]	/* numeric double values 1 - 6 */
#define	NUMDB2	usd.d[1]
#define	NUMDB3	usd.d[2]
#define	NUMDB4	usd.d[3]
#define	NUMDB5	usd.d[4]
#define	NUMDB6	usd.d[5]

#define	NUMUL1	usd.u[0]	/* numeric unsigned long values 1 - 2 */
#define	NUMUL2	usd.u[1]

#define	ETIME	usd.cetm	/* current epics time in seconds */
#define	YEAR	usd.year	/* year as 1995 */
#define LEAP	usd.leap	/* leap year, 0 isnt 1 is */
#define	DOY	usd.doy		/* day of year, 1 is jan 1st */
#define	MON	usd.mon		/* month of year, 1 is jan */
#define	DOM	usd.dom		/* day of month, 1 is 1st day of month */
#define	DOW	usd.dow		/* day of week, 1 is sunday, 7 is saturday */
#define	HOUR	usd.hour	/* current hour of day */
#define	MINUTE	usd.min		/* current minute */
#define	SECOND	usd.sec		/* current seconds */
#define	CTCK	usd.ctck	/* current IOC clock ticks */
#define	DCTK	usd.dctk	/* delta clock ticks from last scan */

#define	TIMER1	usd.tmr[0]	/* timers 1 - 12 */
#define	TIMER2	usd.tmr[1]
#define	TIMER3	usd.tmr[2]
#define	TIMER4	usd.tmr[3]
#define	TIMER5	usd.tmr[4]
#define	TIMER6	usd.tmr[5]
#define	TIMER7	usd.tmr[6]
#define	TIMER8	usd.tmr[7]
#define	TIMER9	usd.tmr[8]
#define	TIMER10	usd.tmr[9]
#define	TIMER11	usd.tmr[10]
#define	TIMER12	usd.tmr[11]

#define	TIMERST1 usd.tf[0]	/* timer status flags 1 - 12 */
#define	TIMERST2 usd.tf[1]
#define	TIMERST3 usd.tf[2]
#define	TIMERST4 usd.tf[3]
#define	TIMERST5 usd.tf[4]
#define	TIMERST6 usd.tf[5]
#define	TIMERST7 usd.tf[6]
#define	TIMERST8 usd.tf[7]
#define	TIMERST9 usd.tf[8]
#define	TIMERST10 usd.tf[9]
#define	TIMERST11 usd.tf[10]
#define	TIMERST12 usd.tf[11]

#define	TEMPFL1	usd.fp[0]	/* temporary float values 1 - 16 */
#define	TEMPFL2 usd.fp[1]
#define	TEMPFL3 usd.fp[2]
#define	TEMPFL4 usd.fp[3]
#define	TEMPFL5 usd.fp[4]
#define	TEMPFL6 usd.fp[5]
#define	TEMPFL7 usd.fp[6]
#define	TEMPFL8 usd.fp[7]
#define	TEMPFL9 usd.fp[8]
#define	TEMPFL10 usd.fp[9]
#define	TEMPFL11 usd.fp[10]
#define	TEMPFL12 usd.fp[11]
#define	TEMPFL13 usd.fp[12]
#define	TEMPFL14 usd.fp[13]
#define	TEMPFL15 usd.fp[14]
#define	TEMPFL16 usd.fp[15]

#define	TEMPUL1	usd.ul[0]	/* temporary unsigned long values 1 - 8 */
#define	TEMPUL2 usd.ul[1]
#define	TEMPUL3 usd.ul[2]
#define	TEMPUL4 usd.ul[3]
#define	TEMPUL5 usd.ul[4]
#define	TEMPUL6 usd.ul[5]
#define	TEMPUL7 usd.ul[6]
#define	TEMPUL8 usd.ul[7]

#define	TEMPDB1	usd.db[0]	/* temporary double values 1 - 4 */
#define	TEMPDB2 usd.db[1]
#define	TEMPDB3 usd.db[2]
#define	TEMPDB4 usd.db[3]

#define	BF1	usd.bl[0]	/* boolean flags 1 - 16 */
#define	BF2	usd.bl[1]
#define	BF3	usd.bl[2]
#define	BF4	usd.bl[3]
#define	BF5	usd.bl[4]
#define	BF6	usd.bl[5]
#define	BF7	usd.bl[6]
#define	BF8	usd.bl[7]
#define	BF9	usd.bl[8]
#define	BF10	usd.bl[9]
#define	BF11	usd.bl[10]
#define	BF12	usd.bl[11]
#define	BF13	usd.bl[12]
#define	BF14	usd.bl[13]
#define	BF15	usd.bl[14]
#define	BF16	usd.bl[15]

#define	MESSAGE	usd.msgf	/* the message field */

#define	FPAS	usd.fpas	/* first process pass flag */

#define	UDB_ERROR usd.error
#define	DEBUG	usd.debug


/* THE FOLLOWING MACROS ARE PROVIDED TO COPY DATA TO AND FROM THE udbRecord */

/* copy udbRecord data from pudb  to users local stack in UDBDATA */
#define	UDBINIT_UDBDATA \
	UDB_CLEAR(UDB_ERROR) \
	UDB_CLEAR(DEBUG) \
	UDB_data_transfer (pudb, &usd, UDB_COPY_TO_LOCAL);



/* copy users local stack, UDBDATA, back to udbRecord pudb */
#define	UDBCOPY_UDBDATA \
	UDB_data_transfer (pudb, &usd, UDB_COPY_TO_REC);


/* THE FOLLOWING MACROS ARE PROVIDED FOR GENERAL USE */

/* set a variable to 1 */
#define	UDB_SET(x)		x = 1;

/* clear a variable */
#define	UDB_CLEAR(x)		x = 0;

/* increment a variable */
#define	UDB_INCREMENT(x)	x += 1;

/* decrement a variable */
#define	UDB_DECREMENT(x)	x -= 1;

/* increase a variable */
#define	UDB_INCREASE(x,y)	x += y;

/* decrease a variable */
#define	UDB_DECREASE(x,y)	x -= y;

/* change value of a variable */
#define	UDB_CHANGE(x,y)		x = y;

/* copy string to buffer */
#define	UDB_STRING(x,y)		strncpy (x, y, sizeof (x));

/* allow user to set an alarm condition */
#define	UDB_SET_ALARM(new_stat, new_sevr) \
	UDB_new_alarm (new_stat, new_sevr, &usd.nsta, &usd.nsev, \
			usd.debug, &usd.error, usd.udb_name);


/* THE FOLLOWING MACROS ARE PROVIDED FOR COMMAND SUPPORT */

/* zero the manual (cmm) and automatic (cma) command flags in local stack 
   if any command is non-zero, set zcmf (zero cmds flag) so that cmds
   can be zeroed on the slave
*/
#define	UDB_ZERO_CMDS \
{ \
	int i; \
	for (i = 0; i < UDB_NUM_CMDS; i++) \
	{ \
		if (usd.cmm[i] != 0) \
		    usd.zcmf = 1; \
		usd.cmm[i] = 0; \
		if (usd.cma[i] != 0) \
		    usd.zcmf = 1; \
		usd.cma[i] = 0; \
	} \
}

/* post NCMD field for trending */
#define UDB_TREND_NCMD \
	usd.trnc = 1;


/* THE FOLLOWING MACROS ARE PROVIDED FOR FUNCTION SUPPORT */

/* zero the FUNCTION flags */
#define	UDB_ZERO_FUNC \
{ \
	int i; \
	for (i = 0; i < UDB_NUM_FUNCS; i++) \
		usd.ffl[i] = 0; \
}


/* THE FOLLOWING MACROS ARE PROVIDED FOR SETTING THE BIT FLAGS NRFL AND
   NRFL TO TELL recUdb:process WHICH NUMERIC FIELDS TO POST (NPFL) AND
   WHICH FIELDS TO REDUNDANTLY UPDATE (NRFL)
*/

/* post a float */
#define	UDB_POST_FLOAT(which_float)\
	if ( (which_float < 1) || (which_float > UDB_NUM_NUMERIC_FLOAT) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_FLOAT range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_FLOAT, which_float); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.npfl |= 1 << (which_float-1);

/* redundantly update a float */
#define	UDB_REDUND_FLOAT(which_float)\
	if ( (which_float < 1) || (which_float > UDB_NUM_NUMERIC_FLOAT) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, REDUND_FLOAT range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_FLOAT, which_float); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.nrfl |= 1 << (which_float-1);

/* post a double */
#define	UDB_POST_DOUBLE(which_double)\
	if ( (which_double < 1) || (which_double > UDB_NUM_NUMERIC_DOUBLE) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_DOUBLE range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_DOUBLE, which_double); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.npfl |= 1 << (UDB_NUM_NUMERIC_FLOAT + (which_double-1));

/* redundantly update a double */
#define	UDB_REDUND_DOUBLE(which_double)\
	if ( (which_double < 1) || (which_double > UDB_NUM_NUMERIC_DOUBLE) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, REDUND_DOUBLE range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_DOUBLE, which_double); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.nrfl |= 1 << (UDB_NUM_NUMERIC_FLOAT + (which_double-1));

/* post a ulong */
#define	UDB_POST_ULONG(which_ulong)\
	if ( (which_ulong < 1) || (which_ulong > UDB_NUM_NUMERIC_ULONG) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_ULONG range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_ULONG, which_ulong); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.npfl |= 1 << (UDB_NUM_NUMERIC_FLOAT + \
				UDB_NUM_NUMERIC_DOUBLE + (which_ulong-1));

/* redundantly update a ulong */
#define	UDB_REDUND_ULONG(which_ulong)\
	if ( (which_ulong < 1) || (which_ulong > UDB_NUM_NUMERIC_ULONG) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, REDUND_ULONG range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_NUMERIC_ULONG, which_ulong); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.nrfl |= 1 << (UDB_NUM_NUMERIC_FLOAT + \
				UDB_NUM_NUMERIC_DOUBLE + (which_ulong-1));


/* THE FOLLOWING MACROS ARE PROVIDED FOR SETTING THE BIT FLAG TMLF
   TO TELL recUdb:process WHICH TEMP OR THE MESSAGE FIELD MSGF TO 
   POST FOR EVENTS, ALSO TO SET TRFL TO TELL recUdb:process
   WHICH TEMP FLOAT TO TREND
*/

/* flag for temp floats */
#define	UDB_POST_TEMP_FLOAT(which_float)\
	if ( (which_float < 1) || (which_float > UDB_NUM_TEMP_FLOAT) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_TEMP_FLOAT range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TEMP_FLOAT, which_float); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.tmfl |= 1 << (which_float-1);

/* trend temp floats, only allow trend 1 - 8 */
#define	UDB_TREND_TEMP_FLOATS(which_float) \
	if ( (which_float < 1) || (which_float > 8) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, TREND_TEMP_FLOAT, range 1 - 8 (%d)\n", \
				 usd.udb_name, which_float); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.trfl |= 1 << (which_float - 1);


/* flag for temp ulongs */
#define	UDB_POST_TEMP_ULONG(which_ulong)\
	if ( (which_ulong < 1) || (which_ulong > UDB_NUM_TEMP_ULONG) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_TEMP_ULONG range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TEMP_ULONG, which_ulong); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.tmfl |= 1 << (UDB_NUM_TEMP_FLOAT + (which_ulong-1));

/* flag for temp double */
#define	UDB_POST_TEMP_DOUBLE(which_double)\
	if ( (which_double < 1) || (which_double > UDB_NUM_TEMP_DOUBLE) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_TEMP_DOUBLE range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TEMP_DOUBLE, which_double); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.tmfl |= 1 << (UDB_NUM_TEMP_FLOAT + \
					UDB_NUM_TEMP_ULONG + (which_double-1));

/* flag for msgf */
#define	UDB_POST_MSGF\
	usd.tmfl |= 1 << ((UDB_NUM_TEMP_FLOAT + UDB_NUM_TEMP_ULONG + \
						UDB_NUM_TEMP_DOUBLE + 1) - 1);


/* THE FOLLOWING MACROS ARE PROVIDED FOR I/O SUPPORT */


/* set the input flag bit based on which_input in local stack */
#define UDB_POST_INPUT(which_input) \
	if ( (which_input < 1) || (which_input > UDB_NUM_INPUTS) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, POST_INPUT range 0 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_INPUTS, which_input); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.inpf |= 1 << (which_input-1);

/* set input flag to post all input values whether chg'd or not */
#define	UDB_POST_ALL_INPUTS\
	usd.inpf = 0xffff;


/* set the output flag bit based on which_output in local stack 
   tells recUdb:process which output to send and post 
*/
#define UDB_SET_OUTPUT_FLAG(which_output) \
	if ( (which_output < 1) || (which_output > UDB_NUM_OUTPUTS) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, OUTPUT_FLAG range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_OUTPUTS, which_output); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.outf |= 1 << (which_output-1);

/* set output flag to output all values whether chg'd or not, in local stack */
#define	UDB_OUTPUT_ALL \
	usd.outf = 0xffff;


/* THE FOLLOWING MACROS ARE PROVIDED FOR BOOLEAN FLAG SUPPORT */

#define	UDB_TREND_BOOL_FLAG(which_flag) \
	if ( (which_flag < 1) | (which_flag > 8) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, TREND_BOOL range 1 - 8 (%d)\n", \
				usd.udb_name, which_flag); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.trbl |= 1 << (which_flag-1);


/* THE FOLLOWING MACROS ARE PROVIDED FOR TIMER SUPPORT 
   AND TIME DELAY SUPPORT 
*/

/* start a timer */
#define	UDB_START_TIMER(which_timer) \
	if ( (which_timer < 1) || (which_timer > UDB_NUM_TIMERS) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, START_TIMER range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TIMERS, which_timer); \
		usd.error = S_udb_RangeError; \
	} \
	else \
	{ \
		if (usd.tf[which_timer-1] == UDB_TIMER_NOT_ACTIVE) \
			usd.tmr[which_timer-1] = 0; \
		usd.tf[which_timer-1] = UDB_TIMER_ACTIVE; \
	}

/* hold a timer */
#define	UDB_HOLD_TIMER(which_timer) \
	if ( (which_timer < 1) || (which_timer > UDB_NUM_TIMERS) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, HOLD_TIMER range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TIMERS, which_timer); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.tf[which_timer-1] = UDB_TIMER_HELD;

/* stop a timer */
#define	UDB_STOP_TIMER(which_timer) \
	if ( (which_timer < 1) || (which_timer > UDB_NUM_TIMERS) ) \
	{ \
		if (usd.debug) \
			printf ("UDB:%s, STOP_TIMER range 1 - %d (%d)\n", \
				usd.udb_name, UDB_NUM_TIMERS, which_timer); \
		usd.error = S_udb_RangeError; \
	} \
	else \
		usd.tf[which_timer-1] = UDB_TIMER_NOT_ACTIVE;


/* THE FOLLOWING MACROS ARE PROVIDED FOR EPICS TIME SUPPORT */

/* given an epics time in seconds, return a string of the form
	mm/dd/yy hh:mm:ss
*/
#define	UDB_STAMP_TO_TEXT(epics_time, buff) \
	usd.error = UDB_stamp_to_text (&epics_time, buff);

/* given a time string of form
	mm/dd/yy hh:mm:ss
   reutrn an epics time in seconds
*/
#define	UDB_TEXT_TO_STAMP(buff, epics_time) \
	usd.error = UDB_text_to_stamp (buff, &epics_time);


/* THE FOLLOWING MACROS ARE PROVIDED TO DO TIMEDELAY OUTPUTS */

/*   do a TD pulse one shot with leadling edge */
#define	UDB_PULSE_OS_LE(timer, input, output, timedelay) \
	if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
	{ \
		if (input) \
		{ \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else \
		{ \
			output = 0; \
			UDB_STOP_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
	{ \
		if (usd.tmr[timer-1] >= timedelay) \
		{ \
			output = 0; \
			UDB_HOLD_TIMER(timer) \
			if (!input) \
			{ \
				UDB_STOP_TIMER(timer) \
			} \
		} \
		else \
		{ \
			output = 1; \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
	{ \
		output = 0; \
		if (!input) \
		{ \
			UDB_STOP_TIMER(timer)\
		} \
	}

/* do a TD pusle one shot with trailing edge */
#define	UDB_PULSE_OS_TE(timer, input, output, timedelay) \
	if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
	{ \
		if (!input) \
		{ \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else \
		{ \
			output = 0; \
			UDB_STOP_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
	{ \
		if (usd.tmr[timer-1] >= timedelay) \
		{ \
			output = 0; \
			UDB_HOLD_TIMER(timer) \
			if (input) \
			{ \
				UDB_STOP_TIMER(timer) \
			} \
		} \
		else \
		{ \
			output = 1; \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
	{ \
		output = 0; \
		if (input) \
		{ \
			UDB_STOP_TIMER(timer)\
		} \
	}

/* do a TD pulse reset with leading edge */
#define	UDB_PULSE_RST_LE(timer, input, output, timedelay) \
	if (input) \
	{ \
		if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
		{ \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
		{ \
			if (usd.tmr[timer-1] >= timedelay) \
			{ \
				output = 0; \
				UDB_HOLD_TIMER(timer) \
			} \
			else \
			{ \
				output = 1; \
			} \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
		{ \
			output = 0; \
		} \
	} \
	else \
	{ \
		output = 0; \
		UDB_STOP_TIMER(timer) \
	}

/* do a TD pulse reset with trainling edge */
#define	UDB_PULSE_RST_TE(timer, input, output, timedelay) \
	if (!input) \
	{ \
		if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
		{ \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
		{ \
			if (usd.tmr[timer-1] >= timedelay) \
			{ \
				output = 0; \
				UDB_HOLD_TIMER(timer) \
			} \
			else \
			{ \
				output = 1; \
			} \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
		{ \
			output = 0; \
		} \
	} \
	else \
	{ \
		output = 0; \
		UDB_STOP_TIMER(timer) \
	}

/* do a TD on energize */
#define	UDB_TDE(timer, input, output, timedelay) \
	if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
	{ \
		output = 0; \
		if (input) \
		{ \
			UDB_START_TIMER(timer) \
		} \
		else \
		{ \
			UDB_STOP_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
	{ \
		if (input) \
		{ \
			if (usd.tmr[timer-1] >= timedelay) \
			{ \
				output = 1; \
				UDB_HOLD_TIMER(timer) \
			} \
			else \
			{ \
				output = 0; \
			} \
		} \
		else \
		{ \
			output = 0; \
			UDB_STOP_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
	{ \
		if (input) \
		{ \
			output = 1; \
		} \
		else \
		{ \
			output = 0; \
			UDB_STOP_TIMER(timer) \
		} \
	}

/* do a TD on deenergize */
#define	UDB_TDD(timer, input, output, timedelay) \
	if (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) \
	{ \
		output = 1; \
		if (!input) \
		{ \
			UDB_START_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
	{ \
		if (!input) \
		{ \
			if (usd.tmr[timer-1] >= timedelay) \
			{ \
				output = 0; \
				UDB_HOLD_TIMER(timer) \
			} \
		} \
		else \
		{ \
			output = 1; \
			UDB_STOP_TIMER(timer) \
		} \
	} \
	else if (usd.tf[timer-1] == UDB_TIMER_HELD) \
	{ \
		if (input) \
		{ \
			output = 1; \
			UDB_STOP_TIMER(timer) \
		} \
		else \
		{ \
			output = 0; \
		} \
	}

/* do a cycle TD leading edge */
#define	UDB_CYCLE_LE(timer, input, output, ondelay, offdelay) \
	if (input) \
	{ \
		if ( (usd.tf[timer-1] == UDB_TIMER_HELD) || \
		     (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) ) \
		{ \
			UDB_STOP_TIMER(timer) \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
		{ \
			if (output) \
			{ \
				if (usd.tmr[timer-1] >= ondelay) \
				{ \
					UDB_STOP_TIMER(timer) \
					output = 0; \
					UDB_START_TIMER(timer) \
				} \
				else \
				{ \
					output = 1; \
				} \
			} \
			else \
			{ \
				if (usd.tmr[timer-1] >= offdelay) \
				{ \
					UDB_STOP_TIMER(timer) \
					output = 1; \
					UDB_START_TIMER(timer) \
				} \
				else \
				{ \
					output = 0; \
				} \
			} \
		} \
	} \
	else \
	{ \
		output = 0; \
		UDB_HOLD_TIMER(timer) \
	}

/* do a cycle TD trailing edge */
#define	UDB_CYCLE_TE(timer, input, output, ondelay, offdelay) \
	if (!input) \
	{ \
		if ( (usd.tf[timer-1] == UDB_TIMER_HELD) || \
		     (usd.tf[timer-1] == UDB_TIMER_NOT_ACTIVE) ) \
		{ \
			UDB_STOP_TIMER(timer) \
			output = 1; \
			UDB_START_TIMER(timer) \
		} \
		else if (usd.tf[timer-1] == UDB_TIMER_ACTIVE) \
		{ \
			if (output) \
			{ \
				if (usd.tmr[timer-1] >= ondelay) \
				{ \
					UDB_STOP_TIMER(timer) \
					output = 0; \
					UDB_START_TIMER(timer) \
				} \
				else \
				{ \
					output = 1; \
				} \
			} \
			else \
			{ \
				if (usd.tmr[timer-1] >= offdelay) \
				{ \
					UDB_STOP_TIMER(timer) \
					output = 1; \
					UDB_START_TIMER(timer) \
				} \
				else \
				{ \
					output = 0; \
				} \
			} \
		} \
	} \
	else \
	{ \
		output = 0; \
		UDB_HOLD_TIMER(timer) \
	}


/* THE FOLLOWING MACROS ARE PROVIDED TO ALLOW THE USER TO GET A FIELD FROM THE
   INPUT/OUTPUT PVS OR PUT A VALUE TO A FIELD IN THE INPUT/OUTPUT PVS AND
   GET THE STATUS OF THE RESOURCE ASSOCIATED WITH AN INPUT OR OUTPUT
*/

/* get from an input field */
#define	UDB_GET_INPUT(which_input, field_name, value, fld_type) \
		usd.error = UDB_get_field (pudb, which_input, field_name, \
					   (void*)&value, fld_type, UDB_INPUT_FIELD);

/* get from an output field */
#define	UDB_GET_OUTPUT(which_output, field_name, value, fld_type) \
		usd.error = UDB_get_field (pudb, which_output, field_name, \
					   (void*)&value, fld_type, UDB_OUTPUT_FIELD);

/* put to an input field */
#define	UDB_PUT_INPUT(which_input, field_name, value, fld_type) \
		usd.error = UDB_put_field (pudb, which_input, field_name, \
					   (void*)&value, fld_type, UDB_INPUT_FIELD);

/* put to an output field */
#define	UDB_PUT_OUTPUT(which_output, field_name, value, fld_type) \
		usd.error = UDB_put_field (pudb, which_output, field_name, \
					   (void*)&value, fld_type, UDB_OUTPUT_FIELD);

/* return whether the resource for an input is MASTER (1) or not (0) */
#define	UDB_INPUT_MASTER(which_input) \
	UDB_master (pudb, which_input, UDB_INPUT_FIELD, &usd.error)

/* return whether the resource for an output is MASTER (1) or not (0) */
#define	UDB_OUTPUT_MASTER(which_output) \
	UDB_master (pudb, which_output, UDB_OUTPUT_FIELD, &usd.error)

#endif

