

/****************************************************************************
 *
 *  FILE    :   valveredfldidx.h
 *  DATE    :   04 May 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the valve record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :28 Feb 94
 *  REVISION:  removed INIT, not needed
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :3 May 94
 *  REVISION:  removed VAL, not used by VALVE, added INI2 and PCMD and MLTL
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :10 May 94
 *  REVISION:  added command fields
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :18 Oct 94
 *  REVISION:	added TIME
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :14 Feb 95
 *  REVISION:	added VAL
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order and the
 *       spelling in namelist[] in recValve.c. Spelling must also match that
 *       in valveRecord.<ascii,h>
 *
****************************************************************************/


#define	STAT	0	/* alarm status            */
#define	SEVR	1	/* alarm severity          */
#define	VAST	2	/* valve status            */
#define	SWST	3	/* ROL switch status       */
#define	VASV	4	/* valve status local      */
#define	SWSV	5	/* ROL switch status local */
#define	LMOD	6	/* learn mode              */
#define	ESIN	7	/* init emergency stop     */
#define	EXOP	8	/* open time in seconds    */
#define	EXCL	9	/* close time in seconds   */
#define	BSIN	10	/* bad state indicator     */
#define	VCUR	11	/* current valve position  */
#define	BTIM	12	/* bad timer               */
#define	TTIM	13	/* travel timer            */
#define	FSRC	14	/* fault source            */
#define	SMOD	15	/* save MODE               */
#define	LMEN	16	/* learn mode enable       */
#define	LCMD	17	/* last command issued     */
#define	PLTR	18	/* previous local tracking */
#define	PCMD	19	/* previous command completed */
#define	MLTL	20	/* torque lag time         */
#define	INI2	21	/* secondary init flag     */
#define	CMDS	22	/* command string	   */
#define	COPN	23	/* open cmd		   */
#define	CCLS	24	/* close cmd               */
#define	CREV	25	/* reverse cmd             */
#define	CJGO	26	/* jog open cmd            */
#define	CJGC	27	/* jog close cmd           */
#define	CPOS	28	/* position cmd            */
#define	OPNS	29	/* special open cmd        */
#define	CLSS	30	/* special close cmd       */
#define	REVS	31	/* special reverse cmd     */
#define	JGOS	32	/* special jog open cmd    */
#define	JGCS	33	/* special jog close cmd   */
#define	POSS	34	/* special position cmd    */
#define	LATM	35	/* last alarm time         */
#define	VAL	36	/* status                  */

#define	NUMVALVEFLDS (VAL + 1)

