/*drvBailey_proto.h,v 1.1.1.1 1999/08/03 14:41:54 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* Name: drvBailey_proto.h */

static  long init ();


/*********************************************************************************************/
/*********************************************************************************************/
/***** User/Operator Routines ****************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

        void HELP (void);

	void TRACEON (unsigned short line);

	void TRACEOFF (unsigned short line);

        void TRAFFIC (unsigned short line, unsigned short type);

	void TRAFFICON (unsigned short line);

	void TRAFFICOFF (unsigned short line);

	void RTRACE (unsigned short line, unsigned short level);

	void RTRACEON (unsigned short line);

	void RTRACEOFf (unsigned short line);

	void TRACELEVEL (unsigned short line, unsigned short level);

        void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable);

        void SIMOFF (unsigned short line);

        void CONTRACEON (unsigned short line);

        void CONTRACEOFF (unsigned short line);

        void RUNTRACEON (unsigned short line);

        void RUNTRACEOFF (unsigned short line);

        void REJECTTRACEON (unsigned short line);

        void REJECTTRACEOFF (unsigned short line);

        void NACKTRACEON (unsigned short line);

        void NACKTRACEOFF (unsigned short line);

        void OKTRACEON (unsigned short line);

        void OKTRACEOFF (unsigned short line);

        void STATETRACEON (unsigned short line);

        void STATETRACEOFF (unsigned short line);

        void ERRTRACEON (unsigned short line);

        void ERRTRACEOFF (unsigned short line);

        void CONFTRACEON (unsigned short line);

        void CONFTRACEOFF (unsigned short line);

        void HUHTRACEON (unsigned short line);

        void HUHTRACEOFF (unsigned short line);

        void DEFAULTTRACE (unsigned short line);

        void baileyerrortrace (unsigned short line);

	int STOPDRIVER (short ln);

        int STARTDRIVER (unsigned short line,
                          char *mode,
                          unsigned short delay,
                          unsigned short hdflag,
                          unsigned short delay1,
                          unsigned short delay2);

	void SETCOMM (unsigned short line,
                      unsigned short tickcount1,
                      unsigned short hdflag,
                      unsigned short tickcount2,
                      unsigned short tickcount3);


/**************************************************************************************/
/**************************************************************************************/
/***** Driver Routines ****************************************************************/
/**************************************************************************************/
/**************************************************************************************/

	void MAIN (unsigned short line,
                   unsigned char *mode,
                   unsigned short delay,
                   unsigned short hdflag,
                   unsigned short delay1,
                   unsigned short delay2);

static  void getsemaphore(unsigned short line);

static  void on_line (unsigned short line);

static  void prepresponses (unsigned short line);


static  void restart_all (unsigned short line);

static  void mark_not_valid (unsigned short line);

static  void invalidate_all (unsigned short line);

static  void invalidate_module (void *pointer);

static void badciutest (unsigned short line);

static void badmoduletest (unsigned short line);

static  void scan_ciu (unsigned short line);

static  void scan_exceptions (unsigned short line);

static  void sim_ciu (unsigned short line);

static  void checkoutputs (unsigned short line);

	int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, short *pvalue,
	    unsigned short conversion, unsigned char *resname);

	int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname);

	int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned short *pvalue,
	    unsigned short conv, unsigned char *resname);

	int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long mask,
	    unsigned long *pvalue, unsigned char *resname);

	int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long value,
	    unsigned long mask, unsigned char *resname);

	int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long *pvalue,
	    unsigned long mask, unsigned char *resname);


static  void register_resource (unsigned short link, unsigned char *resname, char *pointname);

static  void outqueinit (unsigned short line);

static  OUTQENT *ogetemptyp (unsigned short line);

static  void omarkfull (unsigned short line);

static  OUTQENT *ogetnextp (unsigned short line);

static  void oreleasefull (unsigned short line);

static  void link_status (unsigned short line);

static  int allocate_ciu (unsigned short line);

static  int allocate_loop (unsigned short line, unsigned short loop);

static  int allocate_pcu (unsigned short line, LOOPALLOC  *ploop, unsigned short pcu);

static  int allocate_module (unsigned short line, PCUALLOC  *ppcu, unsigned short module);

static  int allocate_block100 (unsigned short line, MODULEALLOC  *pmodule, unsigned short block100);

static int allocate_block (unsigned short line, BLOCK100ALLOC  *pblock100,
                           unsigned short block, unsigned short type);

static  void init_ciu_tab (CIUALLOC *pciu);

static	void init_loop_tab (LOOPALLOC  *ploop);

static	void init_pcu_tab (PCUALLOC  *ppcu);

static	void init_module_tab (MODULEALLOC  *pmodule);

static	void init_block100_tab (BLOCK100ALLOC *pblock100);

static	void init_aer_tab (AERALLOC *pblock);

static	void init_der_tab (DERALLOC *pblock);

static	void init_rcm_tab (RCMALLOC *pblock);

static	void init_rmsc_tab (RMSCALLOC *pblock);

static	void init_cs_tab (CSALLOC *pblock);

static	void init_dd_tab (DDALLOC *pblock);


static	void makechecksum (unsigned char *srcbuf, unsigned short srclen,
                           unsigned char *retbuf, unsigned short *retlen);

static	int checkchecksum (unsigned char *srcbuf, unsigned short srclen,
                           unsigned char *retbuf, unsigned short *retlen);

static  void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

static  void stop_rx (unsigned short line );

static  void rx_int_proc (unsigned short line );

static  int check_line_activity (unsigned short line, unsigned short predelay);

static  void start_tx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus);

static  void stop_tx (unsigned short line );

static  void tx_int_proc (unsigned short line );

static  unsigned short msgxfer (unsigned short line);

static  void replystats (unsigned short line, unsigned short reply);

static  void replytrace (unsigned short line, unsigned short reply, unsigned short replytrace);


static  void initstats (unsigned short line);

static  void initciustats (CIUALLOC *pciu);

static	void initloopstats (LOOPALLOC  *ploop);

static	void initpcustats (PCUALLOC  *ppcu);

static	void initmodulestats (MODULEALLOC  *pmodule);

static  int any_responding (unsigned short line);

static	unsigned short baileyrestart (unsigned short line);

static  unsigned short setrmsc_ao (unsigned short line, unsigned short signal, float fvalue);

static  unsigned short setrmsc_bo (unsigned short line, unsigned short signal,
                                   unsigned long value, unsigned long mask);

static unsigned short setrcm (unsigned short line, unsigned short signal,
                              unsigned long value, unsigned long mask);

static unsigned short setcs_bo (unsigned short line, unsigned short signal,
                                unsigned long value, unsigned long mask);

static unsigned short setstation (unsigned short line, unsigned short signal, float fvalue);

static unsigned short readexceptions (unsigned short line);

static unsigned short readstationexceptions (unsigned short line);

static unsigned short readmiscstatusexceptions (unsigned short line);

static unsigned short float_to_real3 (float input, unsigned char *output);

static unsigned short real3_to_float (unsigned char *input, float *output);


/*********************************************************************************************/
/*********************************************************************************************/
/***** User/Operator Routines ****************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

static	void clearciustats (unsigned short line);

static	void clearloopstats (unsigned short line, unsigned short loop);

static	void clearpcustats (unsigned short line, unsigned short loop,
                            unsigned short pcu);

static	void clearmodulestats (unsigned short line, unsigned short loop,
                               unsigned short pcu, unsigned short module);


        void DUMPMSGCNTS (unsigned short line);

        void CLEARMSGCNTS (unsigned short line);

        void DUMPLINESTATS (unsigned short line);

        void CLEARLINESTATS (unsigned short line);

        void CIUINFO (unsigned short line);

        void CIUTREE (unsigned short line);

        void LOOPINFO (unsigned short line,
                       unsigned short loop);

        void PCUINFO (unsigned short line,
                      unsigned short loop,
                      unsigned short pcu);

        void MODULEINFO (unsigned short line,
                         unsigned short loop,
                         unsigned short pcu,
                         unsigned short module);

        void ALLINFO (unsigned short line);


static  void print_block (void *pblock);

/* End of File:     drvBailey_proto.h */


