/*drvCsi.c,v 1.1.1.1 1999/08/03 14:42:11 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File:	drvCsi.c													
**  Edit: 	07/08/94	JLD: created based on drvmodbus.c
**  Edit: 	08/29/94	WHS: Testing and debugging
*/


#define  MAIN        csi_driver           /* NOTE: change here */
#define  AIDRIVER    csi_aidriver         /* NOTE: change here */
#define  AODRIVER    csi_aodriver         /* NOTE: change here */
#define  AOREAD      csi_aoread           /* NOTE: change here */
#define  BIDRIVER    csi_bidriver         /* NOTE: change here */
#define  BODRIVER    csi_bodriver         /* NOTE: change here */
#define  BOREAD      csi_boread           /* NOTE: change here */

#define  TRACEON     csitraceon           /* NOTE: change here */
#define  TRACEOFF    csitraceoff          /* NOTE: change here */
#define  RTRACEON    csirestraceon        /* NOTE: change here */
#define  RTRACEOFF   csirestraceoff       /* NOTE: change here */
#define  TRACELEVEL  csitrlv              /* NOTE: change here */

#define  STOPDRIVER  stopcsi              /* NOTE: change here */
#define  STARTDRIVER startcsi            /* NOTE: change here */
#define  SETDELAYS   csi_setdelays        /* NOTE: change here */
#define  TABLEINFO   csi_dmt              /* NOTE: change here */
#define  LINEINFO    csi_sli              /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvCsi.h>		          /* NOTE: change here */
#include <drvCsi_proto.h> 		  /* NOTE: change here */
#include <restable.h>


/* static long	init    (); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvCsi = {2, NULL, init};



static CSIRTU		*plcs [CSILINES] [NUMCSIRTUS + 1];	/* two dimensional array of pointers to the fixed length   		*/
								/* extra pointer is for Query structure used independently 		*/
								/* match the mod value.                                    		*/

static unsigned long	maxage [CSILINES];			/* maximum age of data without asking for refresh */
static unsigned long	linkid [CSILINES];			/* link number attached to this line */
static unsigned long	tapid [CSILINES];			/* tap id attached to this line */
static unsigned char	resnames [CSILINES] [RESNAMELEN];	/* array of resource name strings. 					*/

static RES_TABLE	*prestable [CSILINES];			/* array of pointers to resource tables 				*/

static unsigned short	resresponse [CSILINES];			/* array of resource response flags. 					*/
								/* False=not active resource(slave), True= active resource(master) 	*/

static unsigned short	line_activity [CSILINES];		/* true/false line active flag. calculated using activity_time below. 	*/
static unsigned short	lastactivity [CSILINES];		/* assigned value of line_activity prior to it's recalculation.   	*/

static unsigned short	modtrace [CSILINES];			/* controls output of communication error log messages (true/false) 	*/
static unsigned short	mltrace [CSILINES];			/* controls output of certain resource related log messages (level) 	*/
static unsigned short	modrestrace [CSILINES];			/* controls output of MASTER/SLAVE arbitration log messages (binary) 	*/

static OUTPUTQUE	*oq [CSILINES];				/* array of ptrs to the line output queues and their control structures */

static SEM_ID		semids [CSILINES] [2];			/* 'new' semaphore logic. the old SEMAPHORE is still used. 		*/

static short		linetimers [CSILINES];			/* except on init (init_line_tabs), all references commented out 	*/

static SEM_ID		linesems [CSILINES];			/* not used. no references in the code at all 				*/
                                                	
static unsigned short	intermsgdelay [CSILINES];		/* holds value passed in task spawn. used  for each msgxfer attempt 	*/
static unsigned short	pretxdelay [CSILINES];			/* holds post RTS delay before TX. 					*/
static unsigned short	posttxdelay [CSILINES];			/* holds post TX delay before dropping RTS. 				*/

static long		activity_time [CSILINES];		/* holds timetick of last activity. used to set line_activity flag  	*/

static char		user [40], password [40];		/* holds id and password of the user that spawned the driver task	*/
								/* required by host to check file read privileges on RTU load files 	*/


/*
**      Storage for CSI Comm Line Structures
**
*/

static RXLINE          *rxlinetab [CSILINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; 	/* array of pointers to dynamically allocated comm controls/buffers 	*/

static TXLINE          *txlinetab [CSILINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,} ; 	/* array of pointers to dynamically allocated comm controls/buffers */

static char    *bools[] =
	{
	"TRUE ",
	"FALSE"
	};

static int		taskId [CSILINES];

static char *tasknames[] = {"CSIRTU Ch0","CSIRTU Ch1","CSIRTU Ch2","CSIRTU Ch3","CSIRTU Ch4","CSIRTU Ch5",
			    "CSIRTU Ch6","CSIRTU Ch7","CSIRTU Ch8","CSIRTU Ch9","CSIRTU Ch10","CSIRTU Ch11",
			    "CSIRTU Ch12","CSIRTU Ch13","CSIRTU Ch14","CSIRTU Ch15","CSIRTU Ch16","CSIRTU Ch17",
			    "CSIRTU Ch18","CSIRTU Ch19","CSIRTU Ch20"
			    };

static ACTID	actids [CSILINES]; /* Action IDs to pass to control messages */
static char	*sysmsgs [] = {
                "Power Restored",
		"H-LAN Reconfigure",
		"Link Reconfigure",
		"C-LAN Reconfigure",
		"Upload Request",
		"Trend Upload Request",
		"Station Lost",
		"Station Restored",
		"UC Lost",
		"UC Restored",
		"Test Off DCU",
		"Test On DCU",
		"Host Sign On",
		"Host Sign off",
		"DCU Sign On",
		"DCU Sign Off",
		"DCU Alarm Ack",
		"UC Alarm Ack",
		"Set Date",
		"Set Time",
		"ATS Start",
		"ATS Stop",
		"ATC Start",
		"ATC Stop",
		"DMD Start",
		"DMD Stop",
		"DCU Software Lost",
		"LAN TAP Software Lost",
		"Link Tap Software Lost",
		"Host Tap Software Lost"
	};
static unsigned char	*csi_status [] =
			{
			"No Error",
			"Illegal Subcommand",
			"Illegal Parameter / i.e invalid point address",
			"Memory Error",
			"Entry not defined / i.e Point is not defined in the DCU",
			"Command to Fast"
			};
/**********
*
*	This routine is required by iocinit
*
**********/
static long init ()
{
	return (0);
}

/**********
*
*	This routine enables logging of comm trace messages
*
**********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/**********
*
*	This routine disables logging of comm trace messages
*
**********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/**********
*
*	This routine enables logging of resource trace messages
*
**********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = TRUE;
}

/**********
*
*	This routine disables logging of resource trace messages
*
**********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = FALSE;
}

/**********
*
*	This routine controls logging of trace messages
*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short ln, char *mode,unsigned short delay,
		 char *actid, unsigned long age, unsigned short link,
		unsigned short tap)
{
	if ( ln < CSILINES )
	{
	    taskId [ln] = taskSpawn (tasknames [ln], CSI_PRIORITY, CSI_TASK_OPTIONS, CSI_STACK, MAIN, ln,
	    				mode, delay, actid, age, link, tap);

	    logMsg ("Started the CSIRTU driver on line %d\n", ln);

	    remCurIdGet (user, password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}

/**********
*
* Set communication logic time delays to handle half/full duplex, radio delays, etc 
*
**********/
void SETDELAYS (unsigned short line,
		unsigned short tickcount1,
		unsigned short tickcount2,
		unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.			*/
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.            */
	posttxdelay [line]   = tickcount3;  /* after sending last character of transmission before dropping RTS  */
}



/**********											*      CSI_driver                                                                      *                                                                                     	*      The purpose of this task is to scan the modbus plc                             	*      lines. It will maintain a configuration list supporting online additions       	*      and replacement of modules, and maintain a table of most recently              	*      scanned values.                                                                	*                                                                                     	**********/                                                                                     	
/* not called from within this driver */

void MAIN (unsigned short line, unsigned char *mode,
	   unsigned short delay, char *id, unsigned long age,
	   unsigned short link, unsigned short tap)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long	        this_time, last_time;
	CSIRTU          *pmod;
	RXLINE          *rxp;

/* Initialize the data structures */

	maxage [line] = age * 60;		/* age is specified in seconds */
	for (i = 0; (i < 4); i++)
	{					/* move in the Action ID */
	    actids [line].id [i] = id [i];
	}
	actids [line].id [i] = 0;

	linkid [line] = link;			/* link number attached to this line */
	tapid [line] = tap;			/* tap id attached to this line */
	intermsgdelay [line] = delay;
	pretxdelay [line] = 3;			/* wep: initialize to 50 msec */
	posttxdelay [line] = 3;			/* wep: initialize to 50 msec */

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = TRUE;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;

/* wep: output queue initialization */

	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

/* wep: communication initialization */

	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
	onlinefreq = 1;		/* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

	/* Wait for resource to be defined via an initial call to our own 'register_resource' from someone higher up */
	while ( (resnames [line] [0] == 0) || (prestable [line] == NULL) )
	{
	    if (mltrace [line] == 1)
            {
		logMsg ( "No Resource Defined for line - %d\n", line);
            }
	    taskDelay (120);
	}

	/* Start out as slave */

	resClearCaAnswer (prestable [line]);		/* start quiet */
	resPutLocalState (prestable [line], RES_SLV);
	if (modrestrace [line])
        {
	    logMsg ("1] Became RES_SLV \n");
        }
	taskDelay (300);
	while (mltrace [line] == 10)
	{
	    taskDelay (100);
	}
	resGetStates (prestable[line], &lstate, &pstate);
	activity = check_line_activity (line, ACTIVITYTIME);


	/* if the partner is not there, be master */

	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace [line])
            {
	    	logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
            }
	}

	cfgchk = 0;			/* Init the new config pointer */
	last_time = tickGet ();		/* Initialize the time  */

	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

	    /* we arrive here because we are a slave. 									  */
	    /* we stay here until:    asked to be master by partner. if we can reach RTUs, we breakout to 'master' state. */
	    /*                        the partner is not master and there is no activity on the line. 			  */

	    while (lstate == RES_SLV)
	    {
		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}

		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable[line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);


		/* see if needed by partner to be master. if yes, do it and break out of this slave state */

		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		        logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    }
		    break;
		}

		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;

		    taskDelay (2);		/* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */

		    for (mod = 1; (mod <= NUMCSIRTUS); mod++)
		    {
			pmod = plcs [line] [mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested))
			{
			    on_line (line, mod);	
			    if (pmod->is_responding)
			    {
				execute = TRUE;
				break;
			    }
			}
		    }

		    /* If someone answered, become master and make sure partner really gave it up */

		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace [line])
                        {
			    logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                        }
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    activity = check_line_activity (line, 2);    /* wait two seconds before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
                            {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                            }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
                    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
                    }
		    prepresponses (line);
		}
	    }

            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
		clear_rts (line); 		/* Make sure line is left for master */
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding */

		resGetStates (prestable[line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
                    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
                    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    }
		    prepresponses (line);
		}
	    }

            /* we come here because we have gone to, or are looping in, the master state.          */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */

	    /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
	    /*  within this loop, but is never seen by the while loop conditional evaluation.       */

	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT))
	    {
		/* initial stuff */

		resresponse [line] = TRUE;		/* Make sure driver is responding. driver won't issue commands if not set. */
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);	/* clear out commands */


		/* if relinquish command sent, change state and break out to outer loop */

		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
		        logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n", pstate,activity);
                    }
		    break;
		}


		/* wep: scan plcs for data i/o, if allowed */

		modspolled = 0;

		/* call 'scan_plc' for each RTU device, unless user has taken it off line or it is not responding */

		for (mod = 1; (mod <= NUMCSIRTUS); mod++ )
		{
		    pmod = plcs [line] [mod];			/* shorthand pointer 			*/
		    if (pmod)					/* verify pointer validity prior to use */
		    {
			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via pseudo commands, mark it as not responding */

 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
			    modspolled++;
			    scan_plc (pmod, line, mod, FALSE);	/* I/O done here! 			*/
			    if (!pmod->is_responding)
			    {
				mark_not_valid(pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop through this while statement. */

		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
                    }
		} /* end of scan loop */


		/* try and bring all nonresponding plcs on line, but don't bring in more than a specified number. */

		cnt = 0;
		if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (mod = 1; (mod <= NUMCSIRTUS); mod++)
		    {
			cfgchk++;		/* manage plc index */
			if (cfgchk == (NUMCSIRTUS + 1))
			{
			    cfgchk=1;		/* wrap plc index */
                        }
			pmod = plcs [line] [cfgchk];
			if ((pmod) &&		/* verify pointer validity prior to use*/
			    (!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
		    	{
			    on_line (line, cfgchk);	/* loopback testing done here! 			*/

			    modspolled++;
			    cnt++;
			    if (cnt == MAXCFGCK)
			    {
			        break;
                            }
			}
		    }
		}

		/* see if anyone on the line has been responding. if not, try to get partner to become slave. */
		/* Check for no one responding */

		if (!any_responding (line))
		{
		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
                        {
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);
                        }

			/* Give partner access to the hardware */

			clear_rts (line);

			/* Remember the time of this try */

			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{					/* SLWINDOW is the # of ticks for slave to try */
			    taskDelay (10);
		    						/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable[line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
                                {
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                                }
				taskDelay (240);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
			    resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
                            {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                            }
			}
		    }
		}

		/* take plcs off of hold status. the plc's data is not to be held off since we are now master. */

		for (mod = 1; (mod <= NUMCSIRTUS); mod++)
		{
		    pmod = plcs [line] [mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
	    }
	    if (modspolled == 0)
            {
		taskDelay (60);
            }
	    else
	    {
		taskDelay (10);
            }
	} /* end infinite task loop */
}

/**********
*
* Try to bring a RTU on line
*
**********/

/* this routine only called from MAIN */

static void on_line (unsigned short line, unsigned short mod)
{
	CSIRTU			*pmod;
	unsigned short		i, j;

	pmod = plcs [line] [mod];	
	if (pmod)			/* verify pointer prior to use */
	{
	    if (mltrace[line] == 1)
	    {
	        logMsg ( "Bring Online line - %d  mod - %d \n",
				line, mod );
	    }
	    /* Use the loop back function to see if the unit is there and responding */

	    if (!modloopback (ONERETRY + line, mod, pmod))
            {
	        return;		/* if no response, get out */
            }

	    mark_not_valid (pmod);	/* a RTU that has just been brought online must have it's data marked not valid */

	    pmod->is_responding = TRUE;
        }
}



/**********
*							
* Mark all plc data elements as not valid     		
*                                             		
**********/                                             	

/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (CSIRTU  *pmod)
{
	unsigned short		i, j;

							
/*      Initialize the Analogs as not valid */     

	for (i = 0; (i < MAXPOINT); i++)
	{
	    pmod->ais [i].data_valid = FALSE;
	    pmod->ais [i].last_time = 0;
	    pmod->aos [i].data_valid = FALSE;
	    pmod->aos [i].limit_valid = FALSE;
	    pmod->aos [i].last_time;
	    pmod->aos [i].lim_last_time = 0;
	}

							
/*      Initialize the Digitals as not valid */     

	for (i=0; (i<MAXDIGS); i++)
	{
	    pmod->dis [i].data_valid = FALSE;
	    pmod->dis [i].last_time = 0;
	    pmod->das [i].data_valid = FALSE;
	    pmod->das [i].last_time = 0;
	    pmod->dms [i].data_valid = FALSE;
	    pmod->dms [i].last_time = 0;
	    pmod->dcs [i].data_valid = FALSE;
	    pmod->dcs [i].last_time = 0;
	    pmod->dos [i].data_valid = FALSE;
	    pmod->dos [i].last_time = 0;
	    pmod->pis [i].data_valid = FALSE;
	    pmod->pis [i].last_time = 0;
	}
}

/**********
*                                                           	
* Scan a CSIRTU RTU -  get inputs and set outputs as required	
*                                                            	
**********/

/* this routine only called from MAIN 		*/

static scan_plc (CSIRTU *pmod, unsigned short line, unsigned short mod,
		      unsigned short oneflag)
    {
	unsigned long		thistime;
	unsigned short		i, flix, status;
	FETCHPOINT		pointlist [FETCHMAX];

	checkoutputs (line);

	if (mltrace [line] == 1)
        {
	    logMsg ( "Scan  line - %d  mod - %d \n", line,mod );
        }

	/* Look for any invalid or old data */

	thistime = tickGet ();
	flix = 0;

	/* Check AIs */ 

	for (i = 0; (i < MAXPOINT); i++)
	{
	    if ((pmod->ais [i].was_requested) &&
	         ( (pmod->ais [i].data_valid == FALSE) ||
		   (thistime - pmod->ais [i].last_time > maxage [line])))
	    {

		if (!addtolist (CSIAIS, i, 0, &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the PIs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->pis [i].was_requested) &&
	         ( (pmod->pis [i].data_valid == FALSE) ||
		   (thistime - pmod->pis [i].last_time > maxage [line])))
	    {

		if (!addtolist (CSIPIS, (i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the AOs */

	for (i = 0; (i < MAXPOINT); i++)
	{
	    if ((pmod->aos [i].was_requested) &&
	        ((pmod->aos [i].data_valid == FALSE) ||
		(thistime - pmod->aos [i].last_time > maxage [line])))
	    {

		if (!addtolist (CSIAOS, i, 0, &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the DIs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->dis [i].was_requested) &&
	        ((pmod->dis [i].data_valid == FALSE) ||
		(thistime - pmod->dis [i].last_time > maxage [line])))
	    {
		if (!addtolist (CSIDIS, (i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the DAs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->das [i].was_requested) &&
	        ((pmod->das [i].data_valid == FALSE) ||
		(thistime - pmod->das [i].last_time > maxage [line])))
	    {

		if (!addtolist (CSIDAS, (i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the DMs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->dms [i].was_requested) &&
	        ((pmod->dms [i].data_valid == FALSE) ||
		(thistime - pmod->dms [i].last_time > maxage [line])))
	    {
		if (!addtolist (CSIDMS, ( i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the DCs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->dcs [i].was_requested) &&
	        ((pmod->dcs [i].data_valid == FALSE) ||
		(thistime - pmod->dcs [i].last_time > maxage [line])))
	    {
		if (!addtolist (CSIDCS, (i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	/* check the DOs */

	for (i = 0; (i < MAXDIGS); i++)
	{
	    if ((pmod->dos [i].was_requested) &&
	        ((pmod->dos [i].data_valid == FALSE) ||
		(thistime - pmod->dos [i].last_time > maxage [line])))
	    {

		if (!addtolist (CSIDOS, (i % MAXPOINT), (i / MAXPOINT), &pointlist [0], &flix, FALSE, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        	    {
			return (FALSE);
        	    }
		    return (TRUE);
                }
	    }
	}

	if (!addtolist (0, 0, 0, &pointlist [0], &flix, TRUE, line, pmod, mod))
        {
	    return (FALSE);
        }

	/* Fetch any request output limits */
	/* check the AO Limits */

	for (i = 0; (i < MAXPOINT); i++)
	{
	    if ((pmod->aos [i].limit_req) &&
	        ((pmod->aos [i].limit_valid == FALSE) ||
		(thistime - pmod->aos [i].lim_last_time > maxage [line])))
	    {

		if (!getaolimit (CSIAOS, i, line, pmod, mod))
                {
		    return (FALSE);
                }
		if (oneflag)
                {
		    return (TRUE);
                }
	    }
	}

	if (oneflag)
        {
	    return (FALSE);
        }

	/* Poll for any exception data */

	polltap (line);

	return (TRUE);
}

/**********
*												
* checkoutputs											
*      checks output que and returns if empty.							
*      if there is something on the queue it attempts to process all                           
*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
*                                                                                              
**********/                                                                                              

/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
{
	OUTQENT			*optr;
	unsigned short		rtuno, regaddr, regval, link, adapter, card, coiladdr, conv, stat;
	unsigned long		coilmask, coilval;
	CSIRTU			*pmod;
	double			dblaovalue;


	while ((optr = ogetnextp (line)) != 0)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		rtuno = adapter % 100;
		pmod = plcs [link] [rtuno];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, rtuno))
                    {
		        return; /* if not allocated, try. if can't allocate, get out. */
                    }
		    pmod = plcs [link] [rtuno];
		}

		card = optr->out.aonode.card;
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;

		if (mltrace [line] == 2)
		{ 
		    logMsg ( "Analog Output to line %d, address %d, card %d,  signal  - %d\n",
				link, adapter, card, regaddr );
                }
		if ((!pmod->cmd_force_offline) && (resresponse [link]) && (pmod->is_responding))
		{
		    if (!(csiaocmd (link, adapter, card, pmod, regaddr, regval, dblaovalue, conv )))
		    {
		        pmod->badoutcnt++;		    
		    }
		}
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		rtuno = adapter % 100;

		pmod = plcs [link] [rtuno];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, rtuno))
                    {
		        return; /* if not allocated, try. if can't allocate, get out. */
                    }
		    pmod = plcs [link] [rtuno];
		}

		card = optr->out.bonode.card;
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;

		if (mltrace [line] == 2)
		{ 
		    logMsg ( "Binary Output to line %d, address %d, card %d, signal  - %d\n",
				link, adapter,card, coiladdr );
                }
		if ((!pmod->cmd_force_offline) && (resresponse [link]) && (pmod->is_responding))
		{
		    if (!(csibocmd (link, adapter, card, pmod, coiladdr, coilmask, coilval)))
		    {
			pmod->badoutcnt++;
		    }
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
}

/**********                                                                                    	
*      AIDRIVER
*                                                                              	
*      This routines main purpose is to return the analog input value for the         	
*      specified module. For a module value                                           	
*      a (-1) will be returned if there is no valid data ready.                       	
*                                                                                     	
**********/

/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	CSIRTU			*pmod;
	unsigned short		blkix, rtuno, func, type, feature, signo;
	unsigned short		bitoff;
	unsigned short		*pdata;

	if (link > CSILINES)
        {
	    return (-1);
        }
	rtuno = adapter % 100;
	func = card / 100;
	type = card % 100;
	signo = signal/ 100;
	bitoff = signal % 100;

	if (rtuno > NUMCSIRTUS)
        {
	    return (-1);
        }
	if ((type != CSIAIS) && (type != CSIPIS) && 
	    (type != CSIAOS) && (card != PSEUDO))
        {
	    return (-1);
        }
	if (conversion != conversion)
        {
	    return (-1); /* No warnings */
        }
	
	if (signo > MAXPOINT)
        {
	    return (-1);
        }
	if (((type == CSIAIS) || (type == CSIPIS)) && (func != CSIVALUE))
        {
	    return (-1);
        }
	if ((type == CSIAOS) && 
	    ((func != CSIVALUE) && (func != CSIOLOW) && (func != CSIOHIGH)))
        {
	    return (-1);
        }
	pmod = plcs [link] [rtuno];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, rtuno))
            {
	        return; /* if not allocated, try. if can't allocate, get out. */
            }
	    pmod = plcs [link] [rtuno];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{

	    switch (signal)
	    {
	    case 0: /* Were the RTU values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the RTU responding */
		*pvalue = pmod->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = (pmod->no_dataout_msgs & 0x7fff);
		break;

	    case 6: /* Input Messages */
		*pvalue = (pmod->no_datain_msgs & 0x7fff);
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = (pmod->no_rxnoresp & 0x7fff);
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = (pmod->no_txnoresp & 0x7fff);
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = (pmod->no_dataerr & 0x7fff);
		break;

	    case 10: /* Message Retries */
		*pvalue = (pmod->no_retries & 0x7fff);
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = (pmod->no_rxhwerrs & 0x7fff);
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = (pmod->no_txhwerrs & 0x7fff);
		break;

	    case 13: /* CRC errors */
		*pvalue = (pmod->no_crcerrs & 0x7fff);
		break;

	    case 14: /* Offline transitions */
		*pvalue = (pmod->no_offlines & 0x7fff);
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the RTU offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = (pmod->badoutcnt & 0x7fff);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (type == CSIAIS)
	{
	    pmod->ais [signo].was_requested = TRUE;
	    if (!resresponse [link])
            {
		return (-1);
            }
	    if (pmod->holdflag)
            {
		return (-2);
            }
	    if (!pmod->is_responding)
            {
		return (-1);
            }
	    if (!pmod->ais [signo].data_valid)
	    {
		return (-1);
	    }
	    pdata = ((unsigned short*) &(pmod->ais [signo].last_read));
	}
	if (type == CSIPIS)
	{
	    pmod->pis [signo + (bitoff * 32)].was_requested = TRUE;
	    if (!resresponse [link])
            {
		return (-1);
            }
	    if (pmod->holdflag)
            {
		return (-2);
            }
	    if (!pmod->is_responding)
            {
		return (-1);
            }
	    if (!pmod->pis [signo + (bitoff * 32)].data_valid)
	    {
		return (-1);
	    }
	    pdata = ((unsigned short*) &(pmod->pis [signo + (bitoff * 32)].last_read));
	}

	if (type == CSIAOS)
	{
	    switch (func)
	    {
	    case (CSIVALUE):
	        pmod->aos [signo].was_requested = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].last_read));
		if (!pmod->aos [signo].data_valid)
		{
		    return (-1);
		}
		break;
	    case (CSIOLOW):
	        pmod->aos [signo].limit_req = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].outlow));
		if (!pmod->aos [signo].limit_valid)
		{
		    return (-1);
		}
		break;
	    case (CSIOHIGH):
	        pmod->aos [signo].limit_req = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].outhigh));
		if (!pmod->aos [signo].limit_valid)
		{
		    return (-1);
		}
		break;
	    }
	    if (!resresponse [link])
            {
		return (-1);
            }
	    if (pmod->holdflag)
            {
		return (-2);
            }
	    if (!pmod->is_responding)
            {
	    	return (-1);
            }
	}

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */

	switch (conversion)
	{
	case (AICNVDOUBLEINT):
	    pvalue [0] = pdata [0];
	    pvalue [1] = pdata [1];
	    break;

	case (AICNVFLOAT):
	    pvalue [0] = pdata [0];
	    pvalue [1] = pdata [1];
	    break;

	case (AICNVDOUBLEFLT):
	    pvalue [0] = pdata[0];
	    pvalue [1] = pdata [1];
	    pvalue [2] = pdata [2];
	    pvalue [3] = pdata [3];
	    break;

	case(AICNVINTEGER):
	default:
	    *pvalue = *pdata;
	    break;

 	}
	return (0);
}

/**********
*  										
*      AODRIVER
*                                                                            	
*      This routines main purpose is to set requested analog outputs to the  	
*      specified module.                                                     	
*
**********/                                                                            	

/* this routine not called from within this driver */

int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, double dvalue,
		unsigned short value, unsigned short conversion,
		unsigned char *resname)
{
	CSIRTU			*pmod;
	OUTQENT			*oqp;
	unsigned short		rtuno, func, type, feature, signo, bitoff;

	rtuno = adapter % 100;
	func = card / 100;
	type = card % 100;
	signo = signal / 100;
	bitoff = signal % 100;

	if (link > CSILINES)
        {
	    return (-1);
        }
	if (rtuno > NUMCSIRTUS)
        {
	    return (-1);
        }
	if ((type != CSIAIS) && (type != CSIAOS) && (type != CSIPIS) && (card != PSEUDO))
        {
	    return -1;
        }
	if ((type == CSIAOS) && 
	    ((func != CSIVALUE) && (func != CSIOLOW) && (func != CSIOHIGH)))
        {
	    return (-1);
        }
	if (((type == CSIAIS) || (type == CSIPIS)) && 
	    (func != CSIVALUE))
        {
	    return (-1);
        }

	pmod = plcs [link] [rtuno];

	if (pmod == NULL)
	{
	    if (!allocate_plc (link, rtuno))
            {
	        return; /* if not allocated, try. if can't allocate, get out. */
            }
	    pmod = plcs [link] [rtuno];
	}
	if (card == PSEUDO)
	{
	    if (!resresponse [link])
            {
		return (-1);
            }
	    switch (signal)
	    {
	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
                {
		    initstats (pmod);
                }
		break;

	    case 16: /* Force the RTU online/offline */
		pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (signo > MAXPOINT)
	{
	    return (-1);
	}

	pmod->was_requested = TRUE;

	switch (type)
	{
	case CSIAIS:
	case CSIAOS:
	    switch (func)
	    {
	    case (CSIVALUE):
		pmod->aos [signo].was_requested = TRUE;
		break;

	    case (CSIOLOW):
		pmod->aos [signo].limit_req = TRUE;
		break;

	    case (CSIOHIGH):
		pmod->aos [signo].limit_req = TRUE;
		break;
	    }
	    break;

	case CSIPIS:
	    pmod->pis [signo + (bitoff * 32)].was_requested = TRUE;
	    break;

	default:
	    return (-1);
	}
	if (!resresponse [link])
        {
	    return (-1);
        }
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}

	oqp = ogetemptyp (link);

	if (oqp == 0)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

	oqp->out.aonode.aovalue = value;
	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
}

/**********
*
*      AOREAD
*                                                                          	
*      This routines main purpose is to return the value last read back     	
*      from the analog output hardware. This is used to initialize analog   	
*      outputs.                                                             	
*
**********/

/* this routine not called from within this driver */

int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned short *pvalue, unsigned short conv,
		unsigned char *resname)
{
	CSIRTU			*pmod;
	unsigned short		*pdata;
	unsigned short		rtuno, func, type, feature, signo, bitoff;

	rtuno = adapter % 100;
	func = card / 100;
	type = card % 100;
	signo = signal / 100;
	bitoff = signal % 100;

	if (link > CSILINES)
        {
	    return (-1);
        }
	if (rtuno > NUMCSIRTUS)
        {
	    return (-1);
        }
	if ((type != CSIAOS) && (card != PSEUDO) &&
		(type != CSIAIS) && (type != CSIPIS))
        {
	    return (-1);
        }
	if ((type == CSIAOS) && 
	    ((func != CSIVALUE) && (func != CSIOLOW) && (func != CSIOHIGH)))
        {
	    return (-1);
        }
	if (((type == CSIAIS) || (type == CSIPIS)) && (func != CSIVALUE))
	{
	    return (-1);
	}

	pmod = plcs [link] [rtuno];

	if (pmod == NULL)
	{
	    if (!allocate_plc (link, rtuno))
	    {
	        return; /* if not allocated, try. if can't allocate, get out. */
            }
	    pmod = plcs [link] [rtuno];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current RTU offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (signo > MAXPOINT)
	{
	    return (-1);
	}

	pmod->was_requested = TRUE;

	switch (type)
	{
	case CSIAOS:
	    switch (func)
	    {
	    case (CSIVALUE):
	        pmod->aos [signo].was_requested = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].last_read));
		if (!pmod->aos [signo].data_valid)
		{
		    return (-1);
		}
		break;

	    case (CSIOLOW):
	        pmod->aos [signo].limit_req = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].outlow));
		if (!pmod->aos [signo].limit_valid)
		{
		    return (-1);
		}
		break;

	    case (CSIOHIGH):
	        pmod->aos [signo].limit_req = TRUE;
		pdata = ((unsigned short*) &(pmod->aos [signo].outhigh));
		if (!pmod->aos [signo].limit_valid)
		{
		    return (-1);
		}
		break;
	    }
	    break;

	case CSIPIS:
	    switch (func)
	    {
	    case (CSIVALUE):
	        pmod->pis [signo + (bitoff * 32)].was_requested = TRUE;
		pdata = ((unsigned short*) &(pmod->pis [signo + (bitoff * 32)].last_read));
		if (!pmod->pis [signo + (bitoff * 32)].data_valid)
		{
		    return (-1);
		}
		break;
	    default:
		return (-1);
	    }
	    break;

	case CSIAIS:
	    switch (func)
	    {
	    case (CSIVALUE):
	        pmod->ais [signo].was_requested = TRUE;
		pdata = ((unsigned short*) &(pmod->ais [signo].last_read));
		if (!pmod->ais [signo].data_valid)
		{
		    return (-1);
		}
		break;
	    default:
		return (-1);
	    }
	    break;
	}
	if (!resresponse [link])
        {
	    return (-1);
        }
	if (pmod->holdflag)
        {
	    return (-2);
        }
	if (!pmod->is_responding)
        {
	    return (-1);
        }

	/* NOTE !! MULTIPLE PRECISION VALUES MUST RESIDE IN A SINGLE BLOCK */

	/* Select the Size and Type of Response based on Conversion */

	switch (conv)
	{
	case(ASCFLT):
	    pvalue [0] = pdata [0];
	    pvalue [1] = pdata [1];
	    break;

	default:
	    *pvalue = *pdata;
	    break;
 	}
	return (0);
}

/**********
*
*   BIDRIVER
*                                                                               	
*      The main purpose of this routine is to return the request digital input  	
*      value(s) from the requested card. This routine will return a (-1) if the  	
*      requested module is the wrong type or the data is not yet valid.          	
*                                                                                	
**********/

/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)
{
	CSIRTU			*pmod;
	unsigned long		tvalue, tmask, set;
	unsigned short		blkix;
	unsigned short 		rtuno, func, type, feature, signo, bitoff;

	rtuno = adapter % 100;
	func = card / 100;
	type = card % 100;
	signo = signal / 100;
	bitoff = signal % 100;

	if (link > CSILINES)
        {
	    return (-1);
        }
	if (rtuno > NUMCSIRTUS)
        {
	    return (-1);
        }

	pmod = plcs [link] [rtuno];

	if (pmod == NULL)
	{
	    if (!allocate_plc (link, rtuno))
            {
	        return; /* if not allocated, try. if can't allocate, get out. */
            }
	    pmod = plcs [link] [rtuno];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the RTU values requested */
	        *pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the RTU responding */
	        *pvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
	        *pvalue = pmod->cmd_reset_stat;
	        break;

	    case 16: /* Force the RTU offline */
	        *pvalue = pmod->cmd_force_offline;
		break;

	    default:
	        return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if ((func != CSIAUTO) && (func != CSITEST) && (func != CSIVALUE))
        {
	    return (-1);
        }

	blkix = signo + (bitoff * 32);

	if (signo >= MAXPOINT)
        {
	    return (-1);
        }
	if (((type == CSIAIS) || (type == CSIAOS)) && (bitoff != 0))
        {
	    return (-1);
        }
	switch (type) {

	case (CSIDIS):
	    pmod->dis [blkix].was_requested = TRUE;
	    if (!pmod->dis [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
	        tvalue = pmod->dis [blkix].last_read;
		break;

	    case (CSIAUTO):
	        tvalue = pmod->dis [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->dis [blkix].testmode;
		break;
	    }
	    break;

	case (CSIDAS):
	    pmod->das [blkix].was_requested = TRUE;
	    if (!pmod->das [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
	        tvalue = pmod->das [blkix].last_read;
		break;

	    case (CSIAUTO):
	        tvalue = pmod->das [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->das [blkix].testmode;
		break;
	    }
	    break;

	case (CSIDMS):
	    pmod->dms [blkix].was_requested = TRUE;
	    if (!pmod->dms [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
	        tvalue = pmod->dms [blkix].last_read;
		break;

	    case (CSIAUTO):
	        tvalue = pmod->dms [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->dms [blkix].testmode;
		break;
	    }
	    break;

	case (CSIDCS):
	    pmod->dcs [blkix].was_requested = TRUE;
	    if (!pmod->dcs [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
	        tvalue = pmod->dcs [blkix].last_read;
		break;

	    case (CSIAUTO):
		tvalue = pmod->dcs [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->dcs [blkix].testmode;
		break;
	    }
	    break;

	case (CSIDOS):
	    pmod->dos [blkix].was_requested = TRUE;
	    if (!pmod->dos [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
	        tvalue = pmod->dos [blkix].last_read;
		break;

	    case (CSIAUTO):
	        tvalue = pmod->dos [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->dos [blkix].testmode;
		break;
	    }
	    break;

	case (CSIAIS):
	    pmod->ais [signo].was_requested = TRUE;
	    if (!pmod->ais [signo].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
		return (-1);

	    case (CSIAUTO):
	        tvalue = pmod->ais [signo].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->ais [signo].testmode;
		break;
	    }
	    break;

	case (CSIAOS):
	    pmod->aos [signo].was_requested = TRUE;
	    if (!pmod->aos [signo].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
		return (-1);

	    case (CSIAUTO):
	        tvalue = pmod->aos [signo].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->aos [signo].testmode;
		break;
	    }
	    break;

	case (CSIPIS):
	    pmod->pis [blkix].was_requested = TRUE;
	    if (!pmod->pis [blkix].data_valid)
            {
		return (-1);
            }
	    switch (func)
	    {
	    case (CSIVALUE):
		return (-1);

	    case (CSIAUTO):
	        tvalue = pmod->pis [blkix].automode;
		break;

	    case (CSITEST):
	        tvalue = pmod->pis [blkix].testmode;
		break;
	    }
	    break;
	default:
	    return (-1);
	}

	if (!resresponse [link])
        {
	    return (-1);
        }
	if (pmod->holdflag)
        {
	    return (-2);
        }
	if (!pmod->is_responding)
        {
	    return (-1);
	}

	tvalue = tvalue << (signal % 32);
	*pvalue = tvalue & mask;
	return (0);
}

/**********
*                                                                                	*      BODRIVER
*                                                                                 	*      The main purpose of this routine is to set the request digital output      	*      value(s) on the requested card. This routine will return a (-1) if the     	*      requested module is the wrong type or not configured yet.                  	*                                                                                 	**********/

/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, unsigned long value,
		unsigned long mask, unsigned char *resname)
{
	CSIRTU			*pmod;
	OUTQENT			*oqp;
	unsigned long		tmask, tval;
	unsigned short		special, i;
	unsigned short		blkix, rtuno, func, type, feature, signo, bitoff;

	rtuno = adapter % 100;
	func = card / 100;
	type = card % 100;
	signo = signal / 100;
	bitoff = signal % 100;

	if (link > CSILINES)
        {
	    return (-1);
        }
	if (rtuno > NUMCSIRTUS)
        {
	    return (-1);
        }

	pmod = plcs [link] [rtuno];

	if (pmod == NULL)
	{
	    if (!allocate_plc (link, rtuno))
            {
	        return; /* if not allocated, try. if can't allocate, get out. */
            }
	    pmod = plcs [link] [rtuno];
	}

	pmod->was_requested = TRUE;

	if (card == PSEUDO)
	{
	    if (!resresponse [link])
            {
		return (-1);
            }
	    switch (signal & 0x1f)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats(pmod);
                }
		break;

	    case 16: /* Force the RTU offline */
	        pmod->cmd_force_offline = (value != 0);
		pmod->is_responding = (value != 0);
		break;

	    default:
	        return (-1);
	    }
	    return (0);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if ((func != CSIAUTO) && (func != CSITEST) && (func != CSIVALUE))
        {
	    return (-1);
        }

	blkix = signo + (bitoff * 32);

	if (signo >= MAXPOINT)
        {
	    return (-1);
        }
	if (((type == CSIAIS) || (type == CSIAOS)) && (bitoff != 0))
        {
	    return (-1);
        }
	switch (type)
	{
	case (CSIDIS):
	    pmod->dis [blkix].was_requested = TRUE;
	    break;

	case (CSIDAS):
	    pmod->das [blkix].was_requested = TRUE;
	    break;

	case (CSIDMS):
	    pmod->dms [blkix].was_requested = TRUE;
	    break;

	case (CSIDCS):
	    if (func == CSIVALUE)
	    {
		value = ((~value) & mask);
	    }
	    pmod->dcs [blkix].was_requested = TRUE;
	    break;

	case (CSIDOS):
	    if (func == CSIVALUE)
	    {
		value = ((~value) & mask);
	    }
	    pmod->dos [blkix].was_requested = TRUE;
	    break;

	case (CSIAIS):
	    if (func == CSIVALUE)
            {
		return (-1);
            }
	    pmod->ais [signo].was_requested = TRUE;
	    break;

	case (CSIAOS):
	    if (func == CSIVALUE)
            {
		return (-1);
            }
	    pmod->aos [signo].was_requested = TRUE;
	    break;

	case (CSIPIS):
	    if (func == CSIVALUE)
            {
		return (-1);
            }
	    pmod->pis [blkix].was_requested = TRUE;
	    break;

	default:
	    return (-1);
	}

	if (!resresponse [link])
        {
	    return (-1);
        }
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	tval = value;
	tmask = mask;
	if (value != 0)
	{
	    for (i = 0; (i < 32); i++)
	    {
		if (((tval & 0x01) != 0) ||
		     ((tmask & 0x01) != 0))
                {
		     break;
                }

	        /* shift mask and value */

	        tval = tval >> 1;
	        tmask = tmask >> 1;
	    }
	}

	oqp = ogetemptyp (link);
	if (oqp == 0)
	{
	    return (-1);		/* output que is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = tmask;
	oqp->out.bonode.bovalue = tval;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
}

/**********
*
*      BOREAD
*                                                                           	
*      This routines main purpose is to return the value last read back      	
*      from the digital output hardware. This is used to initialize digital  	
*      outputs. This will return a (-1) if the module is the wrong type or    	
*      the data is not yet valid                                              	
*
**********/

/* this routine not called from within this driver */

int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

{
	return (BIDRIVER (pointname, link, adapter, card,
			   signal, mask, pvalue, resname));
}


/**********
*
* register_resource                                                              	*                                                                                	*	This routine is used to initialize the resource pointers                  	*  If this is the first time the resource for this line is being                  	*  referenced the pointer to the resource table entry will be set                  	*  and the resource name will be saved. If the resouce name has                    	*  already been set, this routine will verify that all other points                 	*  for this driver are using the same resource name.                                	*                                                                                   	**********/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BOREAD,							    BIDRIVER, and BODRIVER */                               	

static void  register_resource (unsigned short link, CSIRTU *pmod,
				unsigned char *resname, char *pointname)
{
	if (resnames [link] [0] == 0) /* This is the first reference */
	{
	    if (resGetByName (resname, &prestable [link]) != RES_OK)
	    {
		logMsg ( "Resource not found in table - %s \n",
				resname );
	    }
	    else strcpy(resnames [link], resname);
	}
	else
	{
	    if (strcmp (resnames [link], resname) != 0)
	    {
		logMsg ("Resource name conflict - %s,  %s point = %s\n",
				resnames[link],
				resname,
				pointname);
	    }
	}
}

/**********
*                                                                  		
*      Initialize the Queue                                        		
*
**********/                                                                        	

/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
	oq [line]->ooutix = oq [line]->oinix = 0;
}


/**********
*                                                                     		
*  ogetempty - get the next available slot on the output list         		
*
**********/

/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
	if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
	{
	    return (&oq [line]->outque [oq [line]->oinix]);
	}
	if (mltrace [line] == 1)
	{ 
	    logMsg ( "Output Que Full line - %d\n",line);
        }
	return (0);
}


/**********
*                                                                    		
* omarkfull                                                          		
*      mark the next block as full                                     	
*
**********/

/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
	    oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/**********
*                                                                      	
*  ogetnextp - get the next full slot on the output list               	
*
**********/                                                                      	

/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
	if (oq [line]->ooutix != oq [line]->oinix)
	{
	    return (&oq [line]->outque [oq [line]->ooutix]);
	}
	else return (0);
}


/**********
*                                                       	               	
* oreleasefull - release the current full output block    	              	
*
**********/                                                                            	

/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
	if (oq [line]->ooutix == oq [line]->oinix)
        {
	    return;
        }
	oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}

/**********                                                                             	*                                                                              
*	allocate_plc                                                            
*                                                                              
*	The purpose of this routine is to allocate the memory for a single     
*	plc data structure. If not successful, a console error message is  	
*	printed and an error flag is returned to the caller.                    
*	If successful, the newly allocated data structures are initialized.     
*                                                                             	
**********/

static int allocate_plc (unsigned short line, unsigned short plc)
{
	plcs [line] [plc] = (CSIRTU *) calloc(1, (sizeof (CSIRTU)));
	if (!plcs [line] [plc])
	{
	    logMsg ("Unable to allocate memory for CSIRTU data structure on line %d, plc %d\n",line ,plc);
	    return (FALSE);
	}
	else
	{
	    if (modtrace [line])
	    {
		logMsg ("Allocated memory for CSIRTU data structure on line %d, plc %d\n",line ,plc);
	    }
	    init_plc_tab (line, plc);	     /*	initialize the data structures. */
	}
	return (TRUE);
}

/**********
*                                                                   		
*      start_rx                                                        	
*                                                                     	 	
*      The purpose of this routine is to initialize a line table        	
*      for receive and to enable the receiver.                           	
*                                                                        	
**********/

/* only called from msgxfer */

static	void start_rx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus )
{
	RXLINE                  *rxp;

	rxp = rxlinetab [line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXBLKCNT;

}


/**********
*                                                                           	
*      stop_rx                                                              	
*                                                                           	
*      The purpose of this routine is to initialize a line table            	
*      for receive and to disable the receiver.                             	
*                                                                           	
**********/

/* only called from msgxfer */

static	void stop_rx (unsigned short line )
{
	RXLINE                  *rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
}


/**********
*                                                                        	
*      rx_int_proc                                                        	
*                                                                         	
*      The purpose of this routine is to process a receive character interrupt	
*      for a given line.                                                     	
*
**********/

/* referenced in system call in MAIN */

static	void rx_int_proc (unsigned short line )
{
	unsigned char		rxchar;
	unsigned short		rxstat;
	unsigned short		rx_err_mask;
	RXLINE			*rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

	rxp = rxlinetab [line];

	/* Something is sending in data */

	line_activity [line] = TRUE;

	if (rxp->rxstate == RXIGNORE)
        {
	    return;
        }
	if ((rxstat & rx_err_mask) != 0)
	{
	    if (rxp->rxix == 0)
            {
		return;
            }
	    *(rxp->status) = RXBAD;
	    rxp->rxstate = RXIGNORE;
	    rxp->rxbuf [100] = rxstat;
	    rxp->rxbuf [101] = rxchar;
	    return;
	}
	rxp->rxbuf [rxp->rxix++] = rxchar;

	switch (rxp->rxstate)
	{
	case RXBLKCNT:
	    rxp->rxstate = RXDATA;
	    rxp->rxmsglen = rxchar;
	    return;

	case RXDATA:
	default:			/* Data State */
	    rxp->rxmsglen--;
	    if (rxp->rxmsglen == 0)
	    {
	        *(rxp->status) = RXGOOD;
		rxp->rxstate = RXIGNORE;
		semGive (rxp->semid);
		return;
	    }
	}
	return;
    }

/**********
*                                                                           	
*      check_line_activity
*                                                                             	
*      The purpose of this routine is to process a receive character interrupt	
*      for a given line.                                                      	
*                                                                             	
**********/

/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay)
{
	long		thistime;
	short		status;

	if (predelay != 0)
        {
	    taskDelay (predelay);
        }
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
        {
	    return (lastactivity [line] || (line_activity [line]));
        }
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;

	return (status);
}

/**********
*                                                                         	
*      start_tx                                                            	
*                                                                          	
*      The purpose of this routine is to initialize a line table           	
*      for send and to enable the transmitter.                              	
*                                                                            	
**********/

/* only called from msgxfer  */

static	void start_tx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus)

{
	TXLINE                  *txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */

	enable_tx_ints (line);
}

/**********
*
*      stop_tx                                                                	
*                                                                             	
*      The purpose of this routine is to initialize a line table              	
*      for receive and to disable the receiver.                               	
*                                                                             	
**********/

/* only called from msgxfer  */

static	void stop_tx (unsigned short line )
{
	TXLINE			*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
}

/**********
*                                                                           	
*      tx_int_proc                                                           	
*                                                                            	
*      The purpose of this routine is to process a transmit character interrupt
*      for a given line.                                                  	
*                                                                         	
**********/

/* only called from MAIN  */

static	void tx_int_proc (unsigned short line)
{
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp = txlinetab [line];
	if (txp->txdisable)
        {
	    return;
        }
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf [txp->txix++];
	    write_tx_hw ( line, txchar, &txstat, &tx_err_mask );
	    if ((txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable = TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive (txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}


/**********
*                                                                         	
*      msgxfer                                                              	
*                                                                           	
*      The purpose of this routine is to transmit a buffer to the         	
*      analog devices I/O and to await a response. The transmit and receive
*      buffers are in their respective line tables. This routine will retry 	
*      the message up to a maximum number of times or until a response      	
*      is received with a proper checksum.                                  	
*              returns         XFERGOOD if response received                	
*                              XFERBAD  if no good response is received     	
*                                                                           	
**********/

static	unsigned short  msgxfer (unsigned short fline, unsigned short resplen,
				CSIRTU *pmod, unsigned short rxlength)
{
	unsigned short		retry, txstatus, rxstatus, rxlen, line, ix, i;
	RXLINE			*rxp;
	TXLINE			*txp;
	unsigned char		csums[2], lrc;

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab [line];

	if (intermsgdelay [line] != 0)
	{
	    taskDelay (intermsgdelay [line]);
	}

	set_rts (line);

	if (pretxdelay [line] != 0)
	{
	    taskDelay (pretxdelay [line]);
	}

	lrc = 0;
	txstatus = IO_TIMEOUT;
	rxp->fixedlen = resplen;
	rxp->rxmsglen = rxlength;
	rxstatus = IO_TIMEOUT;
	semTake (semids [line] [TXSEM], NO_WAIT);
	semTake (semids [line] [RXSEM], NO_WAIT);

	start_rx (line, semids [line] [RXSEM], &rxstatus);
	start_tx (line, semids [line] [TXSEM], &txstatus); /* this actually fires off the transmission. */

	if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
	    txstatus = IO_TIMEOUT;
        }
	stop_tx (line);

	if (posttxdelay [line] != 0)
	{
	    taskDelay (posttxdelay [line]);
	}

	clear_rts (line);

	if (txstatus == TXGOOD)
	{
	    if ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT * 2))) == ERROR)
            {
		rxstatus = IO_TIMEOUT;
            }
	    stop_rx (line);

	    rxlen = rxp->rxix;
	    if (rxstatus == RXGOOD)
	    {
		for (i = 1; (i < rxlen); i++)
		{
		    lrc = (lrc ^ rxp->rxbuf [i]);
		}
		lrc = ~lrc;
		if (lrc != 0)
		{
		    if (modtrace [line])
                    {
			logMsg("Invlalid lrc \n");
                    }
		    pmod->no_crcerrs++;
		}
		else
		{
		    return (XFERGOOD);
		}
	    }
	    else
	    { 
		if (rxstatus == IO_TIMEOUT)
		{
		    if (modtrace [line])
                    {
			logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
		    pmod->no_rxnoresp++;
		}
		else
		{
		    if (modtrace [line])
                    {
			logMsg ("Receive Error\n");
			logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
					rxp->rxbuf [100],
					rxp->rxbuf [101],
					rxp->rxix);
                    }
		    pmod->no_rxhwerrs++;
		}
	    }
	}
	else
	{
	    if (txstatus == IO_TIMEOUT)
	    {
		if (modtrace [line])
                {
		    logMsg ("Transmit Timeout\n");
                }
	    	pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
                {
		    logMsg ("Transmit Error\n");
                }
	        pmod->no_txhwerrs++;
	    }
	}
	if (modtrace [line])
        {
	    logMsg ("Xfer Bad\n");
        }
	return (XFERBAD);
}

/**********
*
*      init_plc_tab
*
*      The purpose of this routine is to initialize the line tables for the
*      analog devices I/O
*
**********/

/* only called from allocate_plc  */

static	void init_plc_tab (unsigned short line, unsigned short mod)

{
	CSIRTU			*pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
        {
	    return;
        }
	pmod->was_requested = FALSE;
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->cmd_force_offline = FALSE;

	initplc (pmod);
	initstats (pmod);

	/* Initialize this tasks semaphore*/

	semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}

/**********
*
* Cold Init a RTU
*
**********/

/* only called from init_line_tabs  */

static void initplc (CSIRTU  *pmod)

{
	unsigned short		i, j;

	/*      Initialize the Analogs as not valid */     

	for (i = 0; (i < MAXPOINT); i++)
	{
	    pmod->ais [i].data_valid = FALSE;
	    pmod->ais [i].last_time = 0;
	    pmod->ais [i].was_requested = FALSE;
	    pmod->ais [i].last_read = 0;
	    pmod->aos [i].data_valid = FALSE;
	    pmod->aos [i].limit_valid = FALSE;
	    pmod->aos [i].was_requested = FALSE;
	    pmod->aos [i].limit_req = FALSE;
	    pmod->aos [i].last_read = 0;
	    pmod->aos [i].outhigh = 0;
	    pmod->aos [i].outlow = 0;
	    pmod->aos [i].last_time = 0;
	    pmod->aos [i].lim_last_time = 0;
	    pmod->ais [i].was_requested = FALSE;
	    pmod->ais [i].last_read = 0;
	}
							
/*      Initialize the Digitals as not valid */     

	for (i = 0; (i < MAXDIGS); i++)
	{
	    pmod->dis [i].data_valid = FALSE;
	    pmod->dis [i].last_time = 0;
	    pmod->dis [i].was_requested = FALSE;
	    pmod->dis [i].last_read = 0;
	    pmod->das [i].data_valid = FALSE;
	    pmod->das [i].last_time = 0;
	    pmod->das [i].was_requested = FALSE;
	    pmod->das [i].last_read = 0;
	    pmod->dms [i].data_valid = FALSE;
	    pmod->dms [i].last_time = 0;
	    pmod->dms [i].was_requested = FALSE;
	    pmod->dms [i].last_read = 0;
	    pmod->dcs [i].data_valid = FALSE;
	    pmod->dcs [i].last_time = 0;
	    pmod->dcs [i].was_requested = FALSE;
	    pmod->dcs [i].last_read = 0;
	    pmod->dos [i].data_valid = FALSE;
	    pmod->dos [i].last_time = 0;
	    pmod->dos [i].was_requested = FALSE;
	    pmod->dos [i].last_read = 0;
	    pmod->pis [i].data_valid = FALSE;
	    pmod->pis [i].last_time = 0;
	}
}

/**********
*
* initialize the statistics for a modicon RTU
*
**********/

/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static	void initstats (CSIRTU *pmod)
{
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
}

/**********
*                                                                       
* modloopback                                                            
*                                                                        
**********/                                                                          	

/* only called from on_line */

static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 		CSIRTU *pmod)
{
	return (scan_plc (pmod, (line & ~ONERETRY), mod, TRUE));
}

/**********
*                                                                           	
*     prepresponses                                                            
*                                                                             	
*      The purpose of this routine is to mark the RTUs as on hold and the    	
*	data as not valid until read again from the RTU                       	
*                                                                           	
**********/

/* only called from MAIN */

static	void prepresponses (unsigned short line)
{
	unsigned short		mod;
	CSIRTU			*pmod;

	for (mod = 1; (mod <= NUMCSIRTUS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}

/**********
*                                                                  	
*      any_responding                                               	
*                                                                   	
*      The purpose of this routine is to see if any units are       	
*	responding on this line                                      	
*                                                                   	
**********/

/* only called from MAIN */

static	int any_responding (unsigned short line)
{
	unsigned short		mod;
	CSIRTU			*pmod;

	for (mod = 1; (mod <= NUMCSIRTUS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
		if (pmod->is_responding)
                {
		    return (TRUE);
                }
	    }
	}
	return (FALSE);
}

/**********
*                                                                  	
*      none_responding                                               	
*                                                                   	
*      The purpose of this routine is to mark all units as
*	not responding on this line                                      	
*                                                                   	
**********/

/* only called from MAIN */

static	int none_responding (unsigned short line)
{
	unsigned short		mod;
	CSIRTU			*pmod;

	for (mod = 1; (mod <= NUMCSIRTUS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
		if (pmod->is_responding)
		{
		    pmod->no_offlines++;
		}
		pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
	    }
	}
}

/**********
*
*  addtolist
*
*	add a point to the list to gather for this RTU
*	fetch them when we get to 18 
*
**********/
static int addtolist (unsigned short type, unsigned short point,
		      unsigned short bitoff, FETCHPOINT *pointlist,
		      unsigned short *fpix, unsigned short final,
		      unsigned short line, CSIRTU *pmod, unsigned short mod)
{
	TXLINE			*txp;
	RXLINE			*rxp;
	unsigned short		i, j, bufix, blkix;
	short			len, lrc;

	if (!final)
	{
	    pointlist [*fpix].type = type;
	    pointlist [*fpix].number = point;
	    pointlist [*fpix].offset = bitoff;
	    (*fpix)++;
	}

	if ((!final) && (*fpix != 18))
        {
	    return (TRUE);
        }
	if (*fpix == 0)
        {
	    return (TRUE);
        }

	/* Time to Transmit the buffer and get the data */
	/* Set up pointers for comm buffers */

	txp = txlinetab [line];
	rxp = rxlinetab [line];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [1] =  ((linkid [line] & 0x0f) << 4 ) + ((tapid [line] >> 2) & 0x0f);
	txp->txbuf [2] =  ((tapid [line] & 0x03) << 6) + (mod & 0x3f);
	txp->txbuf [3] =  CSIREADCMD;
	txp->txbuf [4] =  CSIREADSBCMD;

	bufix = 5;
	for (i = 0; (i < *fpix); i++)
	{
	    txp->txbuf [bufix++] = pointlist [i].number & 0x1f;
	    txp->txbuf [bufix++] = ((pointlist [i].offset & 0x0f) << 4) + 
				   (pointlist [i].type & 0x0f);
	}

	*fpix = 0;

	/* put in the length byte and the lrc */

	txp->txbuf [0] = bufix; /* this will include the lrc I am about to put in */
	lrc = 0;
	for (i = 1;(i < bufix);i++)
	{
	    lrc = (lrc ^ txp->txbuf [i]);
	}
	txp->txbuf [bufix++] = ~lrc;

	txp->txmsglen = bufix;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    /* Communications Failed */

	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}	

	/*  Verify the response and Store the data */
	/* Verify the linkid mod number command code and status */

	if ((((rxp->rxbuf [1] >> 4) & 0x0f) != linkid [line]) ||
	     (rxp->rxbuf [3] != CSIREADCMD) ||
	     (rxp->rxbuf [4] != 0) ||
	     ((rxp->rxbuf [2] & 0x3f) != mod))
	{

	    switch (rxp->rxbuf [4])
	    {
	    case 0:
		break;

	    case 1:
	    case 2:
	    case 3:
	    case 4:
	    case 5:
		logMsg ("Scan Error Status - %s\n", csi_status [rxp->rxbuf [4]]);
		break;

	    default:
		break;
	    }
	    pmod->no_dataerr++;
	    return (FALSE);
	}

	/* Store the data in a loop using remaining length / 7 bytes per */

	bufix = 5;
	len = rxp->rxbuf [0] - 5;
	while (len > 0)
	{		
	    if (!saveval (pmod, &rxp->rxbuf [bufix]))
            {
		return (FALSE);
            }
	    bufix += 7;
	    len -= 7;
	}
	return (TRUE);
}

/**********
*
* csisaveval
*
* Save the value in the data structure
*
**********/
static saveval (CSIRTU *pmod, char *rxbuf)
{

	unsigned short		blkix;
	float			ifloat;
	unsigned short		istate, ipoint, ibitoff, itype, itest, iman;
	unsigned long		thistime;

	thistime = tickGet ();

	iman = ((rxbuf [2]  & 0x04) != 0);
	ifloat = *((float*) (&rxbuf [3]));
	istate = (rxbuf [0] >> 5) & 0x07;
	ipoint = (rxbuf [0]  & 0x1f);
	ibitoff = (rxbuf [1] >> 4) & 0x07;
	itype = (rxbuf [1]  & 0x0f);
	itest = ((rxbuf [2]  & 0x80) != 0);

	blkix = ipoint + (ibitoff * 32);

	switch (itype)
	{
	case (CSIDIS):
	    pmod->dis [blkix].data_valid = TRUE;
	    pmod->dis [blkix].last_read = istate;
	    pmod->dis [blkix].automode = iman;
	    pmod->dis [blkix].testmode = itest;
	    pmod->dis [blkix].last_time = thistime;
	    break;

	case (CSIDAS):
	    pmod->das [blkix].data_valid = TRUE;
	    pmod->das [blkix].last_read = istate;
	    pmod->das [blkix].automode = iman;
	    pmod->das [blkix].testmode = itest;
	    pmod->das [blkix].last_time = thistime;
	    break;

	case (CSIDMS):
	    pmod->dms [blkix].data_valid = TRUE;
	    pmod->dms [blkix].last_read = istate;
	    pmod->dms [blkix].automode = iman;
	    pmod->dms [blkix].testmode = itest;
	    pmod->dms [blkix].last_time = thistime;
	    break;

	case (CSIDCS):
	    pmod->dcs [blkix].data_valid = TRUE;
	    pmod->dcs [blkix].last_read = istate;
	    pmod->dcs [blkix].automode = iman;
	    pmod->dcs [blkix].testmode = itest;
	    pmod->dcs [blkix].last_time = thistime;
	    break;

	case (CSIDOS):
	    pmod->dos [blkix].data_valid = TRUE;
	    pmod->dos [blkix].last_read = istate;
	    pmod->dos [blkix].automode = iman;
	    pmod->dos [blkix].testmode = itest;
	    pmod->dos [blkix].last_time = thistime;
	    break;

	case (CSIAIS):
	    pmod->ais [ipoint].data_valid = TRUE;
	    pmod->ais [ipoint].last_read = ifloat;
	    pmod->ais [ipoint].automode = iman;
	    pmod->ais [ipoint].testmode = itest;
	    pmod->ais [ipoint].last_time = thistime;
	    break;

	case (CSIAOS):
	    pmod->aos [ipoint].data_valid = TRUE;
	    pmod->aos [ipoint].last_read = ifloat;
	    pmod->aos [ipoint].automode = iman;
	    pmod->aos [ipoint].testmode = itest;
	    pmod->aos [ipoint].last_time = thistime;
	    break;

	case (CSIPIS):
	    pmod->pis [blkix].data_valid = TRUE;
	    pmod->pis [blkix].last_read = ifloat;
	    pmod->pis [blkix].automode = iman;
	    pmod->pis [blkix].testmode = itest;
	    pmod->pis [blkix].last_time = thistime;
	    break;

	default:
	    return (FALSE);

	}
	return (TRUE);
    }

/**********
*
* getaolimit
*
*	fetch any referenced ao limits
*
**********/
static getaolimit ( unsigned short type, unsigned short point,
		    unsigned short line, CSIRTU *pmod,
		    unsigned short mod)
{
	TXLINE			*txp;
	RXLINE			*rxp;
	unsigned short		i, j, bufix, blkix;
	short			len, lrc;
	float			hlimit, llimit;
	unsigned long		thistime;

	thistime = tickGet ();

	/* Time to Transmit the buffer and get the data */
	/* Set up pointers for comm buffers */

	txp = txlinetab [line];
	rxp = rxlinetab [line];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [1] =  ((linkid [line] & 0x0f) << 4 ) + ((tapid [line] >> 2) & 0x0f);
	txp->txbuf [2] =  ((tapid [line] & 0x03) << 6) + (mod & 0x3f);
	txp->txbuf [3] =  CSIREADAORECCMD;
	txp->txbuf [4] =  CSIREADAORECSBCMD;

	txp->txbuf [5] = point & 0x1f;
	txp->txbuf [6] = type & 0x0f;

	/* put in the length byte and the lrc */

	txp->txbuf [0] = bufix = 7; /* this will include the lrc I am about to put in */
	lrc = 0;
	for (i = 1; (i < bufix); i++)
	{
	    lrc = (lrc ^ txp->txbuf [i]);
	}
	txp->txbuf [bufix++] = ~lrc;

	txp->txmsglen = bufix;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    /* Communications Failed */

	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}	

	/*  Verify the response and Store the data */
	/* Verify the linkid mod number command code and status */

	if ((((rxp->rxbuf [1] >> 4) & 0x0f) != linkid[line]) ||
	     (rxp->rxbuf [3] != CSIREADAORECCMD) ||
	     (rxp->rxbuf [4] != 0) ||
	     ((rxp->rxbuf [2] & 0x2f) != mod))
	{

	    switch (rxp->rxbuf [4])
	    {
	    case 0:
		break;

	    case 1:
	    case 2:
	    case 3:
	    case 4:
	    case 5:
		logMsg ("AOLim Error Status - %s\n", csi_status [rxp->rxbuf [4]]);
		break;

	    default:
		break;
	    }
	    pmod->no_dataerr++;
	    return (FALSE);
	}

	/* Save the values retrieved and set the data valid flag */

	llimit = *((float*) (&rxp->rxbuf [44]));
	hlimit = *((float*) (&rxp->rxbuf [48]));

	pmod->aos [point].limit_valid = TRUE;
	pmod->aos [point].outhigh = hlimit;
	pmod->aos [point].outlow = llimit;
	pmod->aos [point].lim_last_time = thistime;

}


/**********
*
* 	polltap (line)
*
*	polls tap for any stored data
*       repeat last response on error return
*	process event messages 0-d
*	process action messsages
*	process control messsages
*	process system messsages
*
**********/
static polltap (unsigned short line)
{
	TXLINE			*txp;
	RXLINE			*rxp;
	CSIRTU			*pmod;
	unsigned short		mod, link, command, i, j, bufix, blkix;
	short			len, fmt, index;
	float			hlimit, llimit;

	/* Time to Transmit the buffer and get the data */
	/* Set up pointers for comm buffers */

	txp = txlinetab [line];
	rxp = rxlinetab [line];

	/* Format the output message */

	txp->txbuf [1] =  0;
	txp->txbuf [2] =  0;
	txp->txbuf [3] =  command = CSIPOLLCMD;

	/* put in the length byte and the lrc */

	txp->txbuf [0] = bufix = 4; /* this will include the lrc I am about to put in */

	/* lrc is just inverse of command */

	txp->txbuf [bufix++] = ~CSIPOLLCMD;

	txp->txmsglen = bufix;

	for (i = 0; (i < MAXRETRYS); i++)
	{
	    /* Send out the message */

	    if (msgxfer (line + ONERETRY, VARRESP, pmod, 0) == XFERBAD)
	    {
	        /* Communications Failed */
		/* Switch to repoll command */

		txp->txbuf [3] = command =  CSIREPOLLCMD;
		txp->txbuf [bufix++] = ~CSIREPOLLCMD;
		txp->txmsglen = bufix;
	    }
	    else
	    {
		break;
	    }	
	}

	if (i == MAXRETRYS)
	{
	    /* mark the entire line as not responding */

	    none_responding (line);
	    return (FALSE);
	}

	/*  Verify the response and Store the data */

	if (rxp->rxbuf [0] <= 5)			/* There is no message data */
        {
	    return (TRUE);
        }
	/* Extract the linkid mod number  */

	mod = rxp->rxbuf [2] & 0x3f;
	link = ((rxp->rxbuf [1] >> 4) & 0x0f);

	if ((link  != linkid [line]) ||		/* Should all have the proper link number */
	     (rxp->rxbuf [4] != 0))		/* status code should be 0 */
        {
	    return (TRUE);
        }

	switch (rxp->rxbuf [3])
	{
	case CSIUNSOLICITED:
	    fmt = ((rxp->rxbuf [8] & 0xc0) >> 6);
	    index = (rxp->rxbuf [8] & 0x3f);
	    switch (fmt)
	    {

	    case (EVENTFMT):
	    case (ACTIONFMT):
	    case (CONTROLFMT):

		if (rxp->rxbuf [0] < 42) /* There is not enough  message data */
        	{
		    return (TRUE);
        	}
		if (index > 0x0b)	 /* only process the ones we know about */
        	{
		    return (TRUE);
        	}
		mod = rxp->rxbuf [30] & 0x3f;
		pmod = plcs [line] [mod];
		if (!saveval (pmod, &rxp->rxbuf [31]))
        	{
		    return (FALSE);
        	}
		break;

	    case (SYSTEMFMT):

		logMsg( "System/Comm Message: %s (Link: %d, Tap: %d, DCU: %d\n",
	    		sysmsgs [index],
			((rxp->rxbuf [5] >> 4) & 0x0f),
			((rxp->rxbuf [5]  & 0x0f) << 2) +
			((rxp->rxbuf [6] >> 6) & 0x03),
			(rxp->rxbuf [6]  & 0x3f));
		break;

	    }
	    break;

	case CSIBROADCAST:
	    if (rxp->rxbuf [4] != 0)
	    {
		return (TRUE);
	    }
	    mod = rxp->rxbuf [6] & 0x3f;
	    pmod = plcs [line] [mod];
	    rxp->rxbuf [7] |= ((rxp->rxbuf [10] << 5) & 0xe0);
	    if (!saveval (pmod, &rxp->rxbuf [7]))
            {
		return (FALSE);
            }
	    break;

	default:
	    return (TRUE);
	}
	return (TRUE);
}

/**********
*
* csibocmd                                                        	
*	command an output to the rtu
*	select before operate
*
**********/
static	unsigned short csibocmd (unsigned short line, unsigned short mod,
			unsigned short card, CSIRTU *pmod,
			unsigned short bitaddr, unsigned long mask,
			unsigned long val)
{
	unsigned short		rtuno, func, type, feature, signo, bitoff;
	unsigned short		cmd, sbcmd, bufix, i, lrc;
	TXLINE			*txp;
	RXLINE			*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line];
	rxp = rxlinetab [line];

	rtuno = mod % 100;
	func = card / 100;
	type = card % 100;
	signo = bitaddr / 100;
	bitoff = bitaddr % 100;

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	txp->txbuf [1] =  ((linkid [line] & 0x0f) << 4 ) + ((tapid [line] >> 2) & 0x0f);
	txp->txbuf [2] =  ((tapid [line] & 0x03) << 6) + (mod & 0x3f);

	txp->txbuf [5] = signo & 0x1f;
	txp->txbuf [6] = (type + ((bitoff & 0x07) << 4) );

	switch (func)
	{
	case (CSIVALUE):
	    cmd = CSIWRITECMD;
	    sbcmd = CSIWRITESBCMD;
	      txp->txbuf [7] = ((val & mask) != 0);
	      bufix = 8;
	      break;

	case (CSIAUTO):
	    cmd = CSIACTIVATEMANUALCMD;
	    if (val != 0)
	    {
	        sbcmd = CSIACTIVATEMANUALSBCMD;
	    }
	    else
	    {
	        sbcmd = CSIDEACTIVATEMANUALSBCMD;
	    }
	    bufix = 7;
	    break;

	case (CSITEST):
	    cmd = CSIACTIVATETESTCMD;
	    if (val != 0)
	    {
 	        sbcmd = CSIACTIVATETESTSBCMD;
	    }
	    else
	    {
	        sbcmd = CSIDEACTIVATETESTSBCMD;
	    }
	    bufix = 7;
	    break;
	}

	txp->txbuf [3] =  cmd;
	txp->txbuf [4] =  sbcmd;

	for (i = 0; (i < 4); i++)
	{
	    txp->txbuf [bufix++] = actids [line].id [i];
	}

	/* put in the length byte and the lrc */

	txp->txbuf [0] = bufix; /* this will include the lrc I am about to put in */
	lrc = 0;
	for (i = 1;(i < bufix); i++)
	{
	    lrc = (lrc ^ txp->txbuf[i]);
	}
	txp->txbuf[bufix++] = ~lrc;

	txp->txmsglen = bufix;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    /* Communications Failed */

	    pmod->badoutcnt++;
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}	

	/*  Verify the response and Store the data */

	if ( (rxp->rxbuf [1] != txp->txbuf [1]) ||
	     (rxp->rxbuf [2] != txp->txbuf [2]) ||
	     (rxp->rxbuf [3] != txp->txbuf [3]) ||
	     (rxp->rxbuf [4] != 0))
	{
	    switch (rxp->rxbuf [4])
	    {
	    case 0:
		break;

	    case 1:
	    case 2:
	    case 3:
	    case 4:
	    case 5:
		logMsg ("BOUT Error Status - %s\n", csi_status [rxp->rxbuf [4]]);
		break;

	    default:
		break;
	    }
	    pmod->badoutcnt++;
	    return (FALSE);
	}

	return (TRUE);

}

/**********
*                                                                	
* csiaocmd                                                       	
*                                                                  	
**********/
static	unsigned short csiaocmd (unsigned short line, unsigned short mod,
			 unsigned short card, CSIRTU *pmod, unsigned short point,
			 unsigned short val, double dblval, unsigned short conv)

{
	unsigned short		rtuno, func, type, feature, signo, bitoff;
	unsigned short		cmd, sbcmd, i, bufix, lrc;
	TXLINE			*txp;
	RXLINE			*rxp;
	char			*pactid;
	union
	{
	    float 		oval;
	    unsigned long	olong;
	} ufl;

	/* Set up pointers for comm buffers */

	ufl.oval = dblval;	/* Output as a Float */
	txp = txlinetab [line];
	rxp = rxlinetab [line];

	rtuno = mod % 100;
	func = card / 100;
	type = card % 100;
	signo = point / 100;
	bitoff = point % 100;

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Deal with setting the AO Limits */

	if (func != CSIVALUE)
	{
	    if (!getaolimit (type, signo, line, pmod, mod))
	    {
	        pmod->badoutcnt++;
		return (FALSE);
	    }

	    /* Copy the Receive buffer to the transmit */

	    for (i = 0; (i < 52); i++)
	    {
		txp->txbuf [i] = rxp->rxbuf [i];
	    }

	    /* replace the new limit */
	    if (func == CSIOLOW) {
		bufix = 44;
	    } else {
		bufix = 48;
	    }
	    txp->txbuf [bufix] = (ufl.olong >> 24) & 0xff;
	    txp->txbuf [bufix + 1] = (ufl.olong >> 16) & 0xff;
	    txp->txbuf [bufix + 2] = (ufl.olong >> 8) & 0xff;
	    txp->txbuf [bufix + 3] = (ufl.olong  & 0xff);

	    txp->txbuf [3] = CSIWRITEAORECCMD;
	    bufix = 52;
	}
	else
	{
	    /* Format the EGU output message */

	    txp->txbuf [1] =  ((linkid [line] & 0x0f) << 4 ) + ((tapid [line] >> 2) & 0x0f);
	    txp->txbuf [2] =  ((tapid [line] & 0x03) << 6) + (mod & 0x3f);

	    txp->txbuf [5] = signo & 0x1f;
	    txp->txbuf [6] = (type + ((bitoff & 0x07) << 4) );

	    txp->txbuf [3] =  CSIWRITECMD;
	    txp->txbuf [4] =  CSIWRITESBCMD;
	    txp->txbuf [7] = (ufl.olong >> 24) & 0xff;
	    txp->txbuf [8] = (ufl.olong >> 16) & 0xff;
	    txp->txbuf [9] = (ufl.olong >> 8) & 0xff;
	    txp->txbuf [10] = (ufl.olong & 0xff);
	    bufix = 11;

	    for (i = 0; (i < 4); i++)
	    {
	        txp->txbuf [bufix++] = actids [line].id [i];
	    }
	}

	/* put in the length byte and the lrc */

	txp->txbuf [0] = bufix; /* this will include the lrc I am about to put in */
	lrc = 0;
	for (i = 1; (i < bufix); i++)
	{
	    lrc = (lrc ^ txp->txbuf [i]);
	}
	txp->txbuf [bufix++] = ~lrc;

	txp->txmsglen = bufix;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    /* Communications Failed */

	    pmod->badoutcnt++;
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}	

	/*  Verify the response and Store the data */

	if ( (rxp->rxbuf [1] != txp->txbuf [1]) ||
	     (rxp->rxbuf [2] != txp->txbuf [2]) ||
	     (rxp->rxbuf [3] != txp->txbuf [3]) ||
	     (rxp->rxbuf [4] != 0) )
	{
	    switch (rxp->rxbuf [4])
	    {
	    case 0:
		break;

	    case 1:
	    case 2:
	    case 3:
	    case 4:
	    case 5:
		logMsg ("AOUT Error Status - %s\n", csi_status [rxp->rxbuf [4]]);
		break;

	    default:
		break;
	    }
	    pmod->badoutcnt++;
	    return (FALSE);
	}

	return (TRUE);

    }


/**********
*                                                                          	
*      dump_mod_table                                                       	
*                                                                           	
*      The purpose of this routine is to dump the module description        	
*      portion of the analog devices driver tables for the selected line.   	
*      It will print out two lines for each module which is responding.     	
*      The first line will give the general module header, the second line 	
*      will give module type specific info.                                	
*
**********/

/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

{
	CSIRTU			*pmod;
	short			ix;
	unsigned short		i, n, j; 
	unsigned short		req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned long		bigvalue;
	unsigned char		buffer [200];


	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg ("Line/CSIAddress Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" # Output messages = %d \n", pmod->no_dataout_msgs);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp);
	printf (" #Data Errors = %d \n", pmod->no_dataerr);
	printf (" #Retries = %d \n", pmod->no_retries);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs);
	printf (" #Crc Errors = %d \n", pmod->no_crcerrs);
	printf (" #Off Lines = %d \n", pmod->no_offlines);
	printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt);


	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Module Is Responding = %d \n", pmod->is_responding );
	printf (" Hold flag  = %d \n", pmod->holdflag );

    }


/**********                                                               		
*                                                                	 	
*	The purpose of this routine is to display the contents            	
*	of the static variables contained within this driver.             	
*                                                                        	
**********/

/* this routine not called from within this driver */


LINEINFO ()
{
	short			i;
	char			buffer [132];
	char			*resrsp;
	char			*lineact;


	printf ("                                 Modbus Line Information Table         \n");
	printf ("\n");
	printf (" Line        Pointer to        Resource      Resource       Line        Delay Times:       Activity\n");
	printf ("Number      CSIRTU Table         Name        Response     Activity      IM  .TX  TX.         Time\n");
        /*     01234567891         01234567893         01234567895         0123456789 
			 01234567892         01234567894         01234567896
	*/
	printf("\n");

	for (i = 0; i < CSILINES; i++)
	{
		if(plcs [i] == NULL)
		{
			continue;
		}
		if (resresponse[i] == 0)
		{
			resrsp = "FALSE";
		}
		else
		{
			resrsp = "TRUE";
		}
		if (line_activity [i] == 0)
		{
			lineact = "FALSE";
		}
		else
		{
			lineact = "TRUE";
		}
		sprintf (buffer, "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i, plcs [i], &resnames [i],
			&resrsp [0],
			&lineact [0],
			intermsgdelay [i],
			pretxdelay [i],
			posttxdelay [i],
			activity_time [i]);
		printf ( "%s\n", buffer);
	}
	return (0);
}

/*	End of File:	drvCsi.c */
