/*drvMetone_proto.h,v 1.1.1.1 1999/08/03 14:43:19 tis4000 Exp */

/****************************************************************/
/*                                                              */
/*    This software is the proprietary property of Tate         */
/*    Integrated Systems, L.P.  Patents and copyrights are      */
/*    pending.                                                  */
/*                                                              */
/*    This software is furnished under a license and may        */
/*    be used and copied only in accordance with the terms      */
/*    of such license and with the inclusion of the above       */
/*    notice. This software or any other copies thereof         */
/*    may not be provided or otherwise made available to        */
/*    any other person. No title to and ownership of the        */
/*    software is hereby transferred.                           */
/*                                                              */
/*    The information in this software is subject to            */
/*    change without notice and should not be construed         */
/*    as a commitment by Tate Integrated Systems L.P. or        */
/*    its third party suppliers.                                */
/*                                                              */
/*    Tate Integrated Systems, L.P. (TIS) and its third         */
/*    party suppliers assume no responsibility for the          */
/*    use or inability to use any of its software. TIS          */
/*    software is provided "as is" without warranty of          */
/*    any kind and TIS expressly disclaims all implied          */
/*    warranties, including but not limited to the implied      */
/*    warranties of merchantability and fitness for a           */
/*    particular purpose.                                       */
/*                                                              */
/*    Notice: Notwithstanding any other lease or license        */
/*    that may pertain to or accompany the delivery of this     */
/*    computer software, the rights of the Government           */
/*    regarding its use, reproduction, and disclosure are       */
/*    as set forth in Section 52.227-19 of the FARS             */
/*    Computer Software-Restricted Rights clause.               */
/*                                                              */
/****************************************************************/
/*                                                                
/*  File: drvMetone_proto.h                                       
/*  Edit:  1/09/96     wep : created                              
/*                         :                                      
/*                                                                
*/                                                                                                                      

/**********
*
*    This routine is required by iocinit in the EPICS system.
*
**********/
static  long init ();

        void HELP (void);

        void TRACEON (unsigned short line);

        void TRACEOFF (unsigned short line);

        void TRAFFIC (unsigned short line, unsigned char add, unsigned type);

        void TRAFFICON (unsigned short line);

        void TRAFFICOFF (unsigned short line);

        void ASCIION (unsigned short line);

        void ASCIIOFF (unsigned short line);

        void RTRACE (unsigned short line, unsigned short level);

        void RTRACEON (unsigned short line);

        void RTRACEOFF (unsigned short line);

        void TRACELEVEL (unsigned short line, unsigned short level);

        void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable);

        void SIMOFF (unsigned short line);

        void CONTRACEON (unsigned short line);

        void CONTRACEOFF (unsigned short line);

        void RUNTRACEON (unsigned short line);

        void RUNTRACEOFF (unsigned short line);

        void REJECTTRACEON (unsigned short line);

        void REJECTTRACEOFF (unsigned short line);

        void NACKTRACEON (unsigned short line);

        void NACKTRACEOFF (unsigned short line);

        void m1allstatuson (unsigned short line);

        void m1allstatusoff (unsigned short line);

        void m1badstatuson (unsigned short line);

        void m1badstatusoff (unsigned short line);

        void DEFAULTTRACE (unsigned short line);

        int STOPDRIVER (short ln);

        int STARTDRIVER (unsigned short line,
                         char *mode,
                         unsigned short delay,
                         unsigned short x,
                         unsigned short delay1,
                         unsigned short delay2,
                         unsigned short private);

        void SETCOMM (unsigned short line,
                      unsigned short delay,
                      unsigned short x,
                      unsigned short delay1,
                      unsigned short delay2);

        void MAIN (unsigned short line,
                   unsigned char *mode,
                   unsigned short delay,
                   unsigned short delay1,
                   unsigned short delay2,
                   unsigned short private);

static  void getsemaphore(unsigned short line);

static  void on_line (unsigned short line, unsigned short mod);

static  void mark_not_valid (METONE  *pmod);

static  void scan_module (METONE *pmod, unsigned short line, unsigned short mod);

static  void sim_module (METONE *pmod, unsigned short line, unsigned short mod);

        int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
                      unsigned short card, unsigned short signal, float *pvalue,
                      unsigned short conversion, unsigned char *resname);

        int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
                      unsigned short card, unsigned short signal, double dvalue,
                      unsigned short value, unsigned short conversion, unsigned char *resname);

        int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
                    unsigned short card, unsigned short signal, unsigned short *pvalue,
                    unsigned short conversion, unsigned char *resname);

        int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
                      unsigned short card, unsigned short signal, unsigned long mask,
                      unsigned long *pvalue, unsigned char *resname);

        int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
                      unsigned short card, unsigned short signal, unsigned long value,
                      unsigned long mask, unsigned char *resname);

        int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
                    unsigned short card, unsigned short signal, unsigned long *pvalue,
                    unsigned long mask, unsigned char *resname);

static  void  register_resource (unsigned short link, METONE *pmod,
                                 unsigned char *resname, char *pointname);

static  int allocate_module (unsigned short line, unsigned short module );

static  void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

static  void stop_rx (unsigned short line );

static  void rx_int_proc (unsigned short line );

static  int check_line_activity (unsigned short line, unsigned short predelay );

static  void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus );

static  void stop_tx (unsigned short line );

static  void tx_int_proc (unsigned short line );

static  unsigned short  msgxfer (unsigned short fline, METONE *pmod, unsigned short rxlen);

static  short asciidec (unsigned short *val, char *buf);

static  short asciihex (unsigned short *val, char *buf);

static  void init_module_tab (unsigned short line, unsigned short mod);

static  void initmodule (METONE  *pmod);

static  void initstats (METONE *pmod);

static  unsigned short selectcounter (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short modloopback (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short setmode (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short startcount (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short stopcount (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short sendmode (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short sendrecord (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short resendrecord (unsigned short line, unsigned short mod, METONE *pmod);

static  unsigned short processresponse (unsigned short line, unsigned short mod, METONE *pmod);

static  void checkchksum (unsigned char *chkbuf, int len, char unsigned *retbuf);

static short parsefloat (char *buf, unsigned short length, float *datavalue);

static short onefascii (unsigned short *val, char ch);

static  void prepresponses (unsigned short line);

static  int any_responding (unsigned short line);

        void DUMPMSGCNTS (unsigned short line);

        void CLEARMSGCNTS (unsigned short line);

        void DUMPMODSTATS (unsigned short line, unsigned short maddr);

        void CLEARNMODSTATS (unsigned short line, unsigned short maddr);

        void TABLEINFO (unsigned short line, unsigned short maddr);

static  void printhdr (unsigned char *buffer, unsigned short cnt);

        void MODULEINFO (unsigned short line);

static  void printmodhdr (unsigned char *buffer, unsigned short cnt);

        int  LINEINFO ();

/*    End of File:    drvMetone_proto.h */
