/*drvMultilin.c,v 1.1.1.1 1999/08/03 14:43:24 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvMultilin.c
**  Edit: 03/03/97      WEP: created based on drvModicon.c
**        06/14/97	WEP: removed modbus bi calls
**        09/04/97	WEP: added Resource Group Lock function
**
*/                                                                                                                      

#define  MAIN           mul_driver           /* NOTE: change here */
#define  AIDRIVER       mul_aidriver         /* NOTE: change here */
#define  AODRIVER       mul_aodriver         /* NOTE: change here */
#define  AOREAD         mul_aoread           /* NOTE: change here */
#define  BIDRIVER       mul_bidriver         /* NOTE: change here */
#define  BODRIVER       mul_bodriver         /* NOTE: change here */
#define  BOREAD         mul_boread           /* NOTE: change here */

#define  TRAFFICON      multrafficon         /* NOTE: change here */
#define  TRAFFICOFF     multrafficoff        /* NOTE: change here */
#define  TRAFFIC        multraffic           /* NOTE: change here */
#define  TRACEON        multraceon           /* NOTE: change here */
#define  TRACEOFF       multraceoff          /* NOTE: change here */
#define  RTRACE         mulrestrlv           /* NOTE: change here */
#define  RTRACEON       mulrestraceon        /* NOTE: change here */
#define  RTRACEOFF      mulrestraceoff       /* NOTE: change here */
#define  TRACELEVEL     multrlv              /* NOTE: change here */
#define  CONTRACEON     mulcontraceon        /* NOTE: change here */
#define  CONTRACEOFF    mulcontraceoff       /* NOTE: change here */
#define  RUNTRACEON     mulruntraceon        /* NOTE: change here */
#define  RUNTRACEOFF    mulruntraceoff       /* NOTE: change here */
#define  REJECTTRACEON  mulrejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF mulrejecttraceoff    /* NOTE: change here */
#define  NACKTRACEON    mulnacktraceon       /* NOTE: change here */
#define  NACKTRACEOFF   mulnacktraceoff      /* NOTE: change here */
#define  DEFAULTTRACE   muldefaulttrace      /* NOTE: change here */

#define  HELP           mulhelp              /* NOTE: change here */
#define  SIMON          mulsimon             /* NOTE: change here */
#define  SIMOFF         mulsimoff            /* NOTE: change here */

#define  STOPDRIVER     stopmultilin         /* NOTE: change here */
#define  STARTDRIVER    startmultilin        /* NOTE: change here */
#define  SETCOMM        mulcomm              /* NOTE: change here */
#define  SHOWINFO       mulinfo              /* NOTE: change here */

#define  DUMPMSGCNTS    muldumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   mulclearmsgcnts      /* NOTE: change here */
#define  DUMPPLCSTATS   muldumpplcstats      /* NOTE: change here */
#define  CLEARPLCSTATS  mulclearplcstats     /* NOTE: change here */

#define  TABLEINFO      multable             /* NOTE: change here */
#define  LINEINFO       showlineinfo         /* NOTE: change here */

#define  ASSIGNGROUP    mulResGroup          /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <tsDefs.h>
#include <drvMultilin.h>                     /* NOTE: change here */
#include <drvMultilin_proto.h>               /* NOTE: change here */
#include <restable.h>


extern TS_STAMP	time_stamp;	/* current time stamp, defined in .../share/src/time/ts_drive.c */


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvMultilin={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
extern	unsigned char	resnames [MULLINES] [RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE	*prestable [MULLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [MULLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity [MULLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity [MULLINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace [MULLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace [MULLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace [MULLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [MULLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [MULLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay [MULLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay [MULLINES];		/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time [MULLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  SEM_ID		linemux [MULLINES];		/* 1/03/94: mutual-exclusion semaphore for	*/
							/* shared resource of the data link 		*/
							/* controls access to common path shared by	*/
							/* data and diagnostic channels. 		*/
							/* originally designed for use with MDS remote	*/
							/* radio diagnostics. 				*/

extern  unsigned short  halfduplex [MULLINES];          /* store half/full duplex line status           */

extern  unsigned short  pstatewait [MULLINES];          /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

extern  short           resGroupLock [];                /* holds line driver group lock flags.          */
extern  char           *resGroupTripName [];            /* holds line driver trip name.                 */


/*
**      Storage for MODBUS Comm Line Structures
**
*/

static RXLINE          *rxlinetab [MULLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [MULLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

/*
**      Storage for MODBUS PLC Structures
**
*/
static unsigned short   pryvate [MULLINES];              /* 0 = redundant mode,   !0=private mode      */

static unsigned int     mulsim [MULLINES];               /* 0 = normal operation, 1 = plc simulation.  */

static unsigned int	simdelay [MULLINES];

static 		int	simlow [MULLINES];

static 		int	simhigh [MULLINES];

static		int	simdigon [MULLINES];

static unsigned int     tick [MULLINES][5];

static unsigned int     lastscan [MULLINES];            /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [MULLINES];            /* holds actual time taken to scan plcs.        */

static unsigned int     loopoutmsgs [MULLINES];

static unsigned int     loopmsgs [MULLINES];

static LINESTATS	linestats [MULLINES];		/* array of line level statistics.              */

static MULPLC		*plcs [MULLINES] [NUMMULPLCS + 1];/* two dimensional array of pointers to the   */
                                                        /* fixed length dynamically allocated PLC       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the mod value.                */

static	unsigned short	trace [MULLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [MULLINES];
static  unsigned char   tracetype [MULLINES];

static OUTPUTQUE	*oq [MULLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */


static  unsigned short  options [MULLINES];             /* store half/full duplex line status           */

static char    *bools [] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [MULLINES];


static char *tasknames [] = {"MULTILIN 0","MULTILIN 1","MULTILIN 2","MULTILIN 3",
                             "MULTILIN 4","MULTILIN 5","MULTILIN 6","MULTILIN 7",
                             "MULTILIN 8","MULTILIN 9","MULTILIN 10","MULTILIN 11",
                             "MULTILIN 12","MULTILIN 13","MULTILIN 14",
                             "MULTILIN 15","MULTILIN 16","MULTILIN 17",
                             "MULTILIN 18","MULTILIN 19","MULTILIN 20",
                             "MULTILIN 21","MULTILIN 22","MULTILIN 23",
                             "MULTILIN 24","MULTILIN 25","MULTILIN 26",
                             "MULTILIN 27","MULTILIN 28","MULTILIN 29",
                             "MULTILIN 30","MULTILIN 31","MULTILIN 32"
                           };

static unsigned short mulResGroups [MULLINES] =
			{0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0} ; /* line driver group assignments   */

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf ("Starting and Stopping the Multilin Driver:\n");
    printf ("\n");
    printf (" startmultilin(N,C,t1,f,t2,t3,P)                                                \n");
    printf ("                     N:  start the driver on line N.                            \n");
    printf ("                     C:  communications parameter string (comma delimited ascii)\n"); 
    printf ("                     t1: intermessage delay (in ticks)                          \n");
    printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex   \n");
    printf ("                     t2: post RTS assert, pre TX delay (in ticks)               \n");
    printf ("                     t3: post TX, pre RTS drop delay (in ticks)                 \n");
    printf ("                     P:  Private flag.  0 = Redundant, 1 = Non-Redundant        \n");
    printf ("                                                                                \n");
    printf (" Example: startmultilin(2,\"9600,N,8,1\", 2,1,4,0)                              \n");
    printf ("                                                                                \n");
    printf (" stopmultilin(N)                                                                \n");
    printf ("                     N = line number                                            \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Multilin Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" multraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                  \n");
    printf ("                           scan time, total output messages, and total messages.   \n"); 
    printf ("                         2) Output Queue Overflow.                                 \n");
    printf ("                         3) All communication errors encountered in msgxfer.       \n");
    printf ("*multraceoff(N)        Disable all of the multraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" mulrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*mulrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" mulrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mulcontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*mulcontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" mulruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*mulruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" mulrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*mulrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" mulnacktraceon(N)     Enable display of point deselection on MODBUS command NACK. \n");
    printf ("*mulnacktraceoff(N)    Disable display of point deselection on MODBUS command NACK.\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" multrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of plc scan loop, bringing plcs online. \n");
    printf ("                         X=2,  beginning of plc scan.                            \n");
    printf ("                         X=3,  AO queue actions (normal: AODRIVER & checkoutputs)\n");
    printf ("                         X=4,  BO queue actions (normal: BODRIVER & checkoutputs)\n");
    printf ("                         X=5,   reserved.                                        \n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" multrafficon(N)       Enable traffic tracing for all plc addresses                \n");
    printf ("                         and all Modbus functions on line N.                       \n");
    printf ("*multrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" multraffic(N,X,Y)     Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.                  \n");
    printf ("                         X=255 enables tracing of all addresses.                   \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.         \n");
    printf ("                         Y=0   disables tracing of all Modbus functions.           \n");
    printf ("                         Y=255 enables tracing of all Modbus functions.            \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.        \n");
    printf ("\n");
    printf (" muldefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mulsimon(N,D,L,H,T)   Enables the simulation of responding plcs.                  \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                        L: low value of analog simulation range.                   \n");
    printf ("                        H: high value of analog simulation range.                  \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*mulsimoff(N)          Disables simulation, thus enabling normal driver function.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mulinfo(N)            Display startup and current state information.              \n");
    printf (" mulcomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                         t1: intermessage delay (in ticks).                        \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" muldumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" mulclearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" muldumpplcstats(N,X)  Display line N, plc X, communication statistics.            \n");
    printf (" mulclearplcstats(N,X) Display and clear line N, plc X, xfers, status & errors.    \n");
    printf (" multable(N,X)         Display line N, plc X, xfers, status, errors and input data.\n");
    printf ("\n");
    printf (" mulResGroup(N,G)      Assign line N to group G (valid G range is 1 to 16)         \n");
}


/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}



/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	This routine enables the simulation of responding plcs, reading all input values as zero.
**
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	mulsim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
**
**	This routine disables simulation, thus enabling normal driver function.
**
********/
void SIMOFF (unsigned short line)
{
	mulsim [line] = FALSE;
}

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void NACKTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | MODBUSNACKTRACE;
    }
void NACKTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
    }

/********
**
**	This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }
/********
**
**	This routine turns on all error tracing.
**
********/
void mulerrortrace (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE ||
                      CONFIGURATIONTRACE ||
                      RUNTIMEERRORTRACE ||
                      CALLREJECTTRACE ||
                      0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }


int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,      /* the line number of this driver.                      */
                 char *mode,               /* UART initializations string (comma delimited ascii). */
                 unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                 unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                 unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                 unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                 unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
	if (line < MULLINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     MUL_PRIORITY,
                                     MUL_TASK_OPTIONS,
                                     MUL_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private);

	    logMsg ("Started the Multilin driver on line %d\n",line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}


int ASSIGNGROUP (unsigned short line, unsigned short group)
{
    if (line < MULLINES)
    {
        if (group <= MAXGROUPNUM)
        {
            mulResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, MULLINES);
        return (-1);
    }
}

void mulgrouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  Limitorque Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = MULLINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    mulResGroups [index]/10,
                    mulResGroups [index]%10);
        }
        printf ("\n");
    }
}

void mullocktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void mullockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", *resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void mulsetlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void mulclrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void mulgrouphelp (void)
{
    printf (" Multilin Driver Group Related Functions\n");
    printf ("\n");
    printf (" mulResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" mulgrouptable         Display the Limitorque's line to group assignment table.    \n");
    printf (" mullocktable          Display the resource group lock Global Array.               \n");
    printf (" mullockall            Display the resource group lock and trip name Global Array. \n");
    printf (" mulsetlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" mulclrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" mulgrouphelp          Display this help message.                                  \n");
    printf ("\n");
}


/********
**
** Show Driver Info and Current State Information */ 
**
********/
void SHOWINFO (unsigned short line)
{
    printf ("intermsgdelay [%d]  = %d\n", line, intermsgdelay[line]);
    printf ("halfduplex [%d]     = %d\n", line, halfduplex[line]);
    printf ("pretxdelay [%d]     = %d\n", line, pretxdelay[line]);
    printf ("posttxdelay [%d]    = %d\n", line, posttxdelay[line]);
    printf ("pryvate [%d]        = %d\n", line, pryvate[line]);
    printf ("resresponse [%d]    = %d\n", line, resresponse[line]);
    printf ("activity_time [%d]  = %d\n", line, activity_time[line]);
    printf ("line_activity [%d]  = %d\n", line, line_activity[line]);
    printf ("lastactivity [%d]   = %d\n", line, lastactivity[line]);
    printf ("modtrace [%d]       = %d\n", line, modtrace[line]);
    printf ("mltrace [%d]        = %d\n", line, mltrace[line]);
    printf ("modrestrace [%d]    = %d\n", line, modrestrace[line]);
}


/*
**      MUL_driver
**
**      The purpose of this task is to scan the Modbus plc
**      lines. It will maintain a configuration list supporting online additions
**      and replacement of modules, and maintain a table of most recently
**      scanned values.
**
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command, i;
	unsigned short  masterpass1;
	long	        this_time, last_time;
	MULPLC          *pmod;
	RXLINE          *rxp;
        unsigned int    temptick, tempdiff;
        int             temp;
        short  *ptable_id;
        unsigned short  group;

/* Initialize the data structures */

	intermsgdelay [line] = delay;

	halfduplex [line]  = hdflag;
	pretxdelay [line]  = delay1;
	posttxdelay [line] = delay2;
        pryvate [line]     = private;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;

        pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

        /* debug structures */
/*        moddebugtrace (line); */
        DEFAULTTRACE (line);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();

        mulsim [line] = FALSE;              /* start with normal operation. */

        /* output queue initialization */
	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
        outqueinit (line);

        /* communication initialization */

	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();

	onlinefreq = 1;	  /* causes on_line calls to begin on first pass as master */

	/* Initialize the Rx interrupts to receive once for activity check         */
	/* enable the receiver interrupt after set to ignore                       */

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

	/* Initialize the line communication semaphores */
	semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
/*
** 1/03/94:                                                                                             
**         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put 
**         logic implemented below is designed to insure, under heavy diagnostic demand, that scan_plc	
**         and the on_line while routine are executed once for every two diagnostic Take/Put sequences. 
**         Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
**         the semaphore while the local state is not the master state.                                	
**
*/   
        taskLock ();
	linemux [line] = semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',    */
                                                      /* ready to be Taken.                           */
	if (!linemux [line])
	{
	    logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
            taskUnlock ();
	    return;
        }
        if ((semTake (linemux [line], MUXTIMEOUT)) == ERROR)
        {
	      logMsg ("Multilin: Mutual-Exclusion Semaphore Timeout on Line\n",line);
              taskDelay(300);
	}
        taskUnlock ();
	taskDelay (120);/* short delay for diagnostic readability */


	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    }
	    taskDelay (600);
	}

        if (pryvate[line])
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
	    semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            resClearCaAnswer (prestable [line]);		/* start quiet */
            resPutLocalState (prestable [line], RES_SLV);

            if (modrestrace [line])
            {
                logMsg ("1] Initialized as RES_SLV\n");
            }

            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if (pstate != 0)
                {
	            break;
                }
                taskDelay (60);
            }
            if (pstate == 0)
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate wait.\n");
            }

            for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
            {
                taskDelay(10);
            }

            activity = check_line_activity(line, 0);
            resGetStates (prestable [line], &lstate, &pstate);

            /******************************************/
            /* if the partner is not there, be master */

            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line] = 0;

                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
                }
                semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
                onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                masterpass1 = TRUE;
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /************************************/
            /* check for line group disablement */
            /************************************/
            group = mulResGroups [line];
            if ((group) && (resGroupLock [group-1]))
            {
                if (modrestrace [line])
                {
                    logMsg ("13] Forced to RES_SLV.\n");
                }
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
                if (modrestrace [line])
                {
                    logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity);
                }
                while (resGroupLock [group-1])
                {
                    group = mulResGroups [line];
                    if (group)
                    {
                        clear_rts (line); 		/* Make sure line is left for master    */
                        taskDelay (2);
                    }
                    else /* the line has been taken out of the group */
                    {
                        break;
                    }
                }
                if (modrestrace [line])
                {
                    logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity);
                    logMsg ("16] Released to RES_SLV.\n");
                }
            }



            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach PLCs, we become master.  */
            /*                  the partner is not master and there is no activity on the line.         */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /* check for plc simulated mode. */
                if (mulsim [line])
                {
		    semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
                        logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
		    }
                    masterpass1 = TRUE;
		    break;
                }

		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}
		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 17)) break;

                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
                    onlinefreq = 1;            /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for (mod = 1; (mod <= NUMMULPLCS); mod++)
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 18)) break;

			pmod = plcs [line] [mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
			{
			    on_line (line, mod);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 19)) break;

		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
			execute = FALSE;

			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    activity = check_line_activity (line, 2); /* pause before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
                            masterpass1 = TRUE;
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
                    onlinefreq = 1;        /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		}
	    }

            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
	        taskDelay (2);                   /* Give OS a chance...  */

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 20)) break;

		clear_rts (line); 		/* Make sure line is left for master    */
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
                    onlinefreq = 1;        /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 21)) break;

                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }
                /* check for plc simulated mode. */
                while (mulsim [line])
                {
		    resresponse [line] = TRUE; /* Make sure driver is responding. driver won't         */
		    for (mod = 1; (mod <= NUMMULPLCS); mod++)
		    {
		        pmod = plcs [line] [mod];	/* shorthand pointer 			*/
		        if (pmod)			/* verify pointer validity prior to use */
		        {
                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 22)) break;

			    if (pmod->cmd_force_offline)
			    { 
				/* if user has turned this plc offline via pseudo commands,     */
                                /* mark it as not responding.                                   */
 				pmod->is_responding = FALSE;
	    		    }
			    else
			    {
				sim_plc (pmod, line, mod);      /* I/O done here! 		*/
		   		taskDelay (simdelay [line]);			    }
			}
		    }
                    /************************************/
                    /* test for line group disablement. */
                    if (lstate != RES_MSTR) break;
                }
                /************************************/
                /* test for line group disablement. */
                if (lstate != RES_MSTR) break;

		/* initial stuff */
		resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                           /* issue commands if not set.                             */

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
                    getsemaphore(line);       /* make sure radio diagnostics are quiescent */

		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

                /* measure time between scans of the entire set of plcs. display if requested. */ 
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

                if (modtrace [line])
		{
                    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;

		/* scan plcs for data i/o, if allowed */

		modspolled = 0;

		/* call 'scan_plc' for each PLC device, unless user has */
                /* taken it off line or it is not responding.           */

		for (mod = 1; (mod <= NUMMULPLCS); mod++)
		{
		    pmod = plcs [line] [mod];		/* shorthand pointer 			*/
		    if (pmod)				/* verify pointer validity prior to use */
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 23)) break;

			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
                            /* local/partner lockstep recovery */
                            resGetStates (prestable [line], &lstate, &pstate);
                            if ((pstate == RES_MSTR) && (!pryvate[line]))
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts (line); 		/* Make sure line is left for master */
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   taskDelay(60);
                                }
                                break;
                            }
			    modspolled++;

                            getsemaphore(line);       /* make sure radio diagnostics are quiescent */

			    scan_plc (pmod, line, mod);      	/* I/O done here! 		*/
			    semGive (linemux [line]);
			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* test for lockstep detection or line group disablement. */
                if (lstate != RES_MSTR) break;


                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* try and bring all nonresponding plcs on line, but don't bring in more than */
                /* a specified number. (unless this is the first pass since becoming master)  */

		cnt = 0;
		if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (mod = 1; (mod <= NUMMULPLCS); mod++)
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 24)) break;

			cfgchk++;		/* manage plc index */
			if (cfgchk == NUMMULPLCS + 1)
			{
			    cfgchk=1;	/* wrap plc index */
                        }
			pmod = plcs [line] [cfgchk];
			if ((pmod) &&		/* verify pointer validity prior to use*/
			    (!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
		    	{
                            getsemaphore(line);       /* make sure radio diagnostics are quiescent */

			    on_line (line, cfgchk);	/* loopback testing done here! 	*/
			    semGive (linemux [line]);

			    modspolled++;
			    cnt++;
                            /* if just became master, try all plcs. else, only try a fixed number. */
                            if ((cnt == MAXCFGCK) && (!masterpass1))
			    {
				break;
			    }
			}
		    }
		}

                /************************************/
                /* test for line group disablement. */
                if (lstate != RES_MSTR) break;

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if ((!any_responding (line)) && (!pryvate[line]))
		{
		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

                        /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                        /* task is quiescent while partner is checking the line with the loopback    */
                        /* command. if local not master, then diagnostic won't try anyway, for       */
                        /* either master or remote radios, but it might have begun a 12 second test  */
                        /* sequence just before we got here.                                         */
                        getsemaphore(line);

                        /* we must semGive the semaphore back if and when we go to being the master */


			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
			}
			/* Give partner access to the hardware */
			clear_rts (line);

			/* Remember the time of this try */
			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 25)) break;

			    taskDelay (10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) ||
                                (pstate == RES_SLVWANT) ||
                                ((activity) &&
                                 (pstate != RES_SLV) &&
                                 (pstate != RES_SLVWANTCA)))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
				}
                                taskDelay(60);
                                taskDelay(60);
                                taskDelay(60);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
			    semGive (linemux [line]);	/* give back semaphore so diagnostics can run. */
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			    }
                            onlinefreq = 1;     /* causes on_line calls to begin on first pass as master */
                            masterpass1 = TRUE;
                            break;
			}
		    }
		}

		/* take plcs off hold status. the plc's data are not to be held off since now master. */
		for (mod = 1; (mod <= NUMMULPLCS); mod++ )
		{
		    pmod = plcs [line] [mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
                masterpass1 = FALSE;
                if (modspolled == 0)
		{
                   taskDelay(6);
		}
                else
		{
		    taskDelay(2);
		}
	    }
	} /* end infinite task loop */
}


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
    }
    return;
}

/************************************/
/* check for line group disablement */
/************************************/
int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = mulResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum);
        }
        return (TRUE);
    }
    return (FALSE);
}

/*
** Try to bring a PLC on line
**
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line,unsigned short mod)
   {
	MULPLC		*pmod;
	unsigned	short i, j;

	pmod = plcs [line] [mod];
	if (pmod)			/* verify pointer prior to use */
	{
		if (mltrace [line] == 1)
		{
			logMsg ( "Bring Online PLC %d\n", mod );
	        }
		/* Use the loop back function to see if the unit is there and responding */

		if (!modloopback (ONERETRY + line, mod, pmod))
			return; /* if no response, get out */

		mark_not_valid (pmod);	/* a PLC that has just been brought online must have    */
                                        /* it's data marked as being not valid.                 */

		pmod->is_responding = TRUE;
        }
}
/*							
** Mark all plc data elements as not valid     		
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (MULPLC  *pmod)
{
	unsigned	short i, j;

/*
**
**      EXCEPTION DATA ARE INITIALIZED AS NOT VALID		
*/
	pmod->exception.data_valid = FALSE;

/*
**      ANALOG INS ARE INITIALIZED AS NOT VALID		
*/
	for (i = 0; (i < NUMMULAIS); i++)
	{
	    pmod->ais [i].data_valid = FALSE;
	}

/*
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
**              - READ BACK NOT VALID      	               	
*/
	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].data_valid = FALSE;
	}
}
/*                                                           	
** Scan a MODBUS PLC -  get inputs and set outputs as required	
**                                                            	
*/
/* this routine only called from MAIN 		*/


static	void scan_plc (MULPLC *pmod, unsigned short line, unsigned short mod)
    {
	unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
	unsigned long   bitmask;
        unsigned short  temp, cmd;

	pmod->tscanpass++;

	if (mltrace [line] == 2)
	{
	    logMsg ( "Scanning PLC - %d.\n", mod );
	}
	checkoutputs (line);

	/* read the exception status */

        if (pmod->exception.was_requested)
        {
            temp = readexcept (line, mod, pmod);
            if (temp == CMDFAIL)
            {
                return;
            }
            if ((temp == CMDNACK) || (temp == CMDREJECT))
            {
                /* disable the entire range of NACKed points */
                if (trace[line] & MODBUSNACKTRACE)
                    logMsg ("Modbus Command NACK: Read Exception Status: Disabling Requested Points.\n");
                pmod->exception.was_requested = FALSE;
                pmod->exception.data_valid = FALSE;
            }
	}

	/* read the ai values to be scanned */

	for (i = 0; (i < NUMMULAIS); i++)
	{
	    if (pmod->ais [i].was_requested)
	    {
		for (j = 1; ((j < MAXREGBLKSIZE) && ((i + j) < NUMMULAIS)); j++)
		{
		    if (!pmod->ais [i + j].was_requested)
		    	break;
		}
		regaddr = i * REGBLOCK;
		readlen = j * REGBLOCK;
		temp = readais (line, mod, pmod, regaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MAINS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0; k < j; k++)
                    {
                        pmod->ais [i + k].was_requested = FALSE;
                        pmod->ais [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the reg values to be scanned */

	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    if (pmod->regs [i].was_requested)
	    {
		for (j = 1; ((j < MAXREGBLKSIZE) && ((i + j) < NUMREGISTERS)); j++)
		{
		    if (!pmod->regs [i + j].was_requested)
		    {
		    	break;
		    }
		}
		regaddr = i * REGBLOCK;
		readlen = j * REGBLOCK;
		temp = readregs (line, mod, pmod, regaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MREGS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0; k < j; k++)
                    {
                        pmod->regs [i + k].was_requested = FALSE;
                        pmod->regs [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}
}

static	void sim_plc (MULPLC *pmod, unsigned short line, unsigned short mod)
    {
	unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
	unsigned long   bitmask;
        unsigned short  temp, cmd;

	pmod->is_responding = pmod->was_requested;

	/* read the ai values to be scanned */

	for (i = 0; (i < NUMMULAIS); i++)
	{
	    pmod->ais [i].data_valid = pmod->ais [i].was_requested;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		if ((pmod->ais [i].aivals [j] < simlow [line]) ||
		    (pmod->ais [i].aivals [j] >= simhigh [line]))
		{
		    pmod->ais [i].aivals [j] = simlow [line];
		}
		else
		{
                    pmod->ais [i].aivals [j] += 1;
		}
	    }
	}

	/* read the reg values to be scanned */

	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].data_valid = pmod->regs [i].was_requested;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		if ((pmod->regs [i].ioregs [j] < simlow [line]) ||
		    (pmod->regs [i].ioregs [j] >= simhigh [line]))
		{
		    pmod->regs [i].ioregs [j] = simlow [line];
		}
		else
		{
                    pmod->regs [i].ioregs [j] += 1;
		}
	    }
	}
}
/*
** checkoutputs
**      checks output que and returns if empty.
**      if there is something on the queue it attempts to process all
**      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
**
*/                                                                                              
/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
{
	OUTQENT         *optr;
	unsigned short  regaddr, regval, link, adapter, coiladdr, conv;
	unsigned long   coilmask, coilval;
	MULPLC          *pmod;
	double 		dblaovalue;
        unsigned short  stringaddr, stringlen;
	unsigned char	*pstringval;
	unsigned short	write_status;

        if (mltrace [line] == 6)
	{
            logMsg ("Checking Output Queue ...\n"); 
	}

	while ((optr = ogetnextp (line)) != NULLP)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    pmod = plcs [link] [adapter];
		}
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
                if (mltrace [link] == 7)
                {
                    logMsg("AO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, regaddr, regval);
                } 

		if ((!pmod->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (pmod->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setreg (link, adapter, pmod, regaddr, regval, dblaovalue, conv);
		    if (write_status != CMDDONE)
		    {
		        pmod->badoutcnt++;
                        if (mltrace [link] == 3)
			{
                            logMsg("AO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }
                    else
		    {
                        if (mltrace [link] == 3)
			{
                            logMsg ("AO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }

		}
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    pmod = plcs [link] [adapter];
		}
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;
                if (mltrace [link] == 7)
                {
                    logMsg("BO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, coiladdr, coilval);
                }

		if ((!pmod->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (pmod->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setcoil (link, adapter, pmod, coiladdr, coilmask, coilval);
		    if (write_status != CMDDONE)
		    {
			pmod->badoutcnt++;
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
                    else
		    {
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
}


/*                                                                                     
**      AIDRIVER                                                                       
**                                                                                     
**      This routines main purpose is to return the analog input value for the         
**      specified module. For a module value                                           
**      a (-1) will be returned if there is no valid data ready.                       
**
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MULPLC		*pmod;

	unsigned short  blkix;
	unsigned short	*pdata;

	if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMULPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

	if (card == MAINS)
	{
            if ((signal > MAXAINO) || (signal < MINAINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                            pointname, link, adapter, card, signal, MAXAINO, MINAINO);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMMULAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
		    pvalue[1] = pmod->ais [blkix].aivals [3];
		    pvalue[0] = pmod->ais [blkix+1].aivals [0];
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT) &&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMMULAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->ais [blkix].aivals [1];
		             pvalue[2] = pmod->ais [blkix].aivals [2];
		             pvalue[1] = pmod->ais [blkix].aivals [3];
		             pvalue[0] = pmod->ais [blkix+1].aivals [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->ais [blkix].aivals [2];
		             pvalue[2] = pmod->ais [blkix].aivals [3];
		             pvalue[1] = pmod->ais [blkix+1].aivals [0];
		             pvalue[0] = pmod->ais [blkix+1].aivals [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->ais [blkix].aivals [3];
		             pvalue[2] = pmod->ais [blkix+1].aivals [0];
		             pvalue[1] = pmod->ais [blkix+1].aivals [1];
		             pvalue[0] = pmod->ais [blkix+1].aivals [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->ais [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
	    if (!pmod->ais [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
               return (-1);
	    }
            pdata = ((unsigned short*) &(pmod->ais [blkix].aivals [signal % REGBLOCK]));

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
            return(0);
	}

	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT) &&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
		        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->regs [blkix].ioregs [1];
		             pvalue[2] = pmod->regs [blkix].ioregs [2];
		             pvalue[1] = pmod->regs [blkix].ioregs [3];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->regs [blkix].ioregs [2];
		             pvalue[2] = pmod->regs [blkix].ioregs [3];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->regs [blkix].ioregs [3];
		             pvalue[2] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [1];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
	       return (-1);
	    }
            pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
            return(0);
	}
	return(-1);
    }

/*  										
**      AODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

{
    MULPLC          *pmod;
    unsigned short   blkix;
    OUTQENT         *oqp;

	if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if (adapter > NUMMULPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}
	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats(pmod);
		}
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXREGNO) || (signal < MINREGNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	blkix = (signal / REGBLOCK);

	pmod->regs [blkix].was_requested = TRUE;

        /* check for trans-REGBLOCK boundary access */
        if ((conversion == ASCFLT) && ((signal % REGBLOCK) == 3))
        {
            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg(
                "AODRIVER: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
            }
            /* as soon as the address is confirmed as valid, set next block's requested bits. */
            pmod->regs [blkix+1].was_requested = TRUE;
        }

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        /* check for plc simulated mode. */
        if (mulsim [link])
        {
            if (mltrace [link] == 3)
	    {
                logMsg("AODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    }
            return (0);
        }

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
            {
                logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    }
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

        oqp->out.aonode.aovalue = value;

	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace [link] == 3)
	{
            logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
	}
	return (0);
}

/*                                                                             
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	MULPLC		*pmod;
	unsigned short  blkix, *pdata;
	
	if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMULPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
                return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return(-1);
	    }
	    return (0);
	}

	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (  (conversion == ASCFLT)  &&
                  ((signal % REGBLOCK) == 3) )
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AOREAD: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                        return (-2);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                       if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    if (mltrace[link] == 8)
                        logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
            pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (ASCFLT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	       default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
	    return(0);
	}
	return(-1);
    }

/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask, unsigned long *pvalue,
		unsigned char *resname)
    {
	MULPLC 		*pmod;
	unsigned short	blkix;
	unsigned long	tvalue;

	if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMULPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MEINS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
                case 0: /* Were the PLC values requested */
                    *pvalue = pmod->was_requested;
                    break;

                case 1: /* Is the PLC responding */
                    *pvalue = pmod->is_responding;
                    break;

                case 15: /* reset statistics */
                    *pvalue = pmod->cmd_reset_stat;
                    break;

                case 16: /* Force the PLC offline */
                    *pvalue = pmod->cmd_force_offline;
                    break;

                default:
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
            }
            return (0);
        }

	tvalue = 0;

	if (card == MEINS)
	{
            if ((signal > MAXEINO) || (signal < MINEINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->exception.was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
		if (!pmod->exception.data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
		    return (-1);
		}
	        tvalue = pmod->exception.last_read & mask;
	    }

	    *pvalue = tvalue & mask;
            if (mltrace[link] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal, pvalue);
	    return (0);
	}

	return (-1);
    }
/*                                                                                     
**      BODRIVER                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
    {
	MULPLC 		*pmod;
	OUTQENT		*oqp;
	unsigned short  blkix;

        if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if (adapter > NUMMULPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if ((card != MCMDS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal & 0x1f)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCMDNO) || (signal < MINCMDNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

        pmod->was_requested = TRUE;

	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (mulsim [link])
        {
            if (mltrace [link] == 4)
	    {
                logMsg("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    }
            return (0);
        }
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
	return (0);
    }
/*
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the digital output hardware. This is used to initialize digital  	
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	MULPLC		*pmod;
	unsigned long	tvalue;

        if (link > MULLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (adapter > NUMMULPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if ((card != MCMDS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCMDNO) || (signal < MINCMDNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
	    return (-1);
	}

	if (resname != 0)
	{
             register_resource (link, pmod, resname, pointname);
	}

        pmod->was_requested = TRUE;

	tvalue = 0;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pmod->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pmod->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        tvalue = 0;
	*pvalue = tvalue & mask;

        if (mltrace[link] == 9)
            logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue);

	return (0);
    }

/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**  If this is the first time the resource for this line is being
**  referenced the pointer to the resource table entry will be set
**  and the resource name will be saved. If the resource name has
**  already been set, this routine will verify that all other points
**  for this driver are using the same resource name.
**
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, MULPLC *pmod,
                                unsigned char *resname, char *pointname)
{
        int group;

	if (resnames [link] [0] == 0) /* This is the first reference */
	{
	    if (resGetByName (resname, &prestable [link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else
	    {
		strcpy (resnames [link], resname);
                group = mulResGroups [link];
                if (group)
                {
                    if (assignLockGroup (group, resname) == ERROR)
                    {
                        logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                                 link, group, pointname, resname);
                    }
                }
	    }
	}
	else
	{
	    if (strcmp (resnames [link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
}

/*
**      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
	oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
	if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
	{
	    return (&oq [line]->outque[oq [line]->oinix]);
	}
        if (mltrace [line] == 11)
	{
	    logMsg ( "Output Queue Full\n");
	}
	return (NULLP);
}


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
	oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
	if (oq [line]->ooutix != oq [line]->oinix)
	{
	    return (&oq [line]->outque[oq [line]->ooutix]);
	}
	else
	{
	    return (NULLP);
	}
}


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
	if (oq [line]->ooutix == oq [line]->oinix)
	{
	    return;
	}
	oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}
/*                                                          			
**      link_status                                                           	
**                                                                            	
**      The purpose of this routine is to print out the state of each of the  	
**      analog devices lines and the statistics gathered about them.         	
**                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
{
	if (line > MULLINES-1)
	{
	    return;
	}
}

/*                                                                             	
**                                                                              
**	allocate_plc                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	plc data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
{
	plcs [line] [plc] = (MULPLC *) calloc (1, (sizeof (MULPLC)));
	if (!plcs [line] [plc])
	{
	    logMsg ("Unable to allocate memory");
            printf (" for MULPLC data structure on line %d, plc %d\n",line ,plc);
	    return(FALSE);
	}
	else
	{
	    logMsg ("Allocated memory for MULPLC data structure on line %d, plc %d\n",line ,plc);
	    init_plc_tab (line, plc);	     /*	initialize the data structures. */
	}

	return (TRUE);
}


/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXADRST;
        rxp->rxmsglen = rxp->rxmsglenexpected;
}

/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
    }

/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

        /* only execute if no comm error */
        if ((rxstat & rx_err_mask) == 0)
        {
            /* Something is sending in data. */
            line_activity [line] = TRUE;
            linestats [line].RXintcount++;
        }
        else
        {
            linestats [line].RXbadcount++;
        }

	rxp = rxlinetab [line];

	if (rxp->rxstate == RXIGNORE)
	{
	    return;
	}
        /* no matter what the state, errors cause a logical reset of the message processing */
        if ((rxstat & rx_err_mask) != 0)
	{
	    rxp->rxstate = RXADRST;    /* if comm goes bad, assume it was garbage,  */
                                     /* and go wait for the good stuff.           */ 
            rxp->rxix = 0;           /* reset the buffer index/counter            */
            rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.*/
	    return;
	}

	rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index.*/
	rxp->rxmsglen--;                  /* decrement the message length counter. although        */
                                          /* superfluous at the beginning of the fixed length      */
                                          /* messages, it does no harm.                            */
	switch (rxp->rxstate)
	{
	case RXADRST:    /* Address Field State */
             /* test for address validity */
             if (rxchar == rxp->txaddress)
             {
        	rxp->rxstate = RXFNCST;
                return;
             }
             else
             {
                rxp->rxstate = RXADRST;                  /* presume it was a false input.  */
                                                               /* go wait for the real one.      */ 
                rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.   */
                return;
             }

	case RXFNCST:    /* Function Field State */
            /* if a NAK response is being returned, convert to fixed length processing */
            if ((rxchar & FNCERRBIT) != 0)
	    {
		rxp->fixedlen = FIXEDRESP;
		rxp->rxmsglen = NAKMSGLEN;
                rxp->rxstate = RXDATAST;
                return;
	    }
            if (rxp->fixedlen) /* fixed length, rxmsglen is already setup. just go get the data. */
            {
                rxp->rxstate = RXDATAST;
            }
            else               /* for variable length, go read the length byte.                  */
            {
                rxp->rxstate = RXLENST;
            }
	    return;

	case RXLENST:    /* Length Field State */
	    rxp->fixedlen = FIXEDRESP;
	    rxp->rxmsglen = rxchar + 2;       /* Add 2 for crc */
	    rxp->rxstate = RXDATAST;
	    return;

        case RXDATAST:  /* Data Section State */
	default:
	    if (rxp->rxmsglen == 0)
	    {
		*(rxp->status) = RXGOOD;
		rxp->rxstate = RXIGNORE;
		semGive (rxp->semid);
		return;
	    }
	}
	return;
}

/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;

	return (status);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

{

	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints (line);

}


/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

    {
	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
    }

/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

{
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

        linestats [line].TXintcount++;

	txp = txlinetab [line];
	if (txp->txdisable)
	{
	    return;
	}
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf [txp->txix++];
	    write_tx_hw (line, txchar, &txstat, &tx_err_mask);
	    if ((txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable = TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive (txp->semid);
	        return;
	    }
	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}


/*                                                                         	
**      msgxfer                                                              	
**                                                                           	
**      The purpose of this routine is to transmit a buffer to the         	
**      analog devices I/O and to await a response. The transmit and receive	
**      buffers are in their respective line tables. This routine will retry 	
**      the message up to a maximum number of times or until a response      	
**      is received with a proper checksum.                                  	
**              returns         XFERGOOD if response received                	
**                              XFERBAD  if no good response is received     	
**                                                                           	
*/
/* called from modloopback, readcoils, readdis, readais, readregs, setcoil, setreg, */
/*             plc_start, plc_stop, pollfordone, plc_init, plc_getdim, plc_setdim,  */
/*             readmem, writemem, writelogic, and writeascii.                       */

static	unsigned short  msgxfer (unsigned short fline,
                                 unsigned short resplen,
                                 MULPLC *pmod,
                                 unsigned short rxlength)
{
	unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums [2];
        unsigned short  oldrxix;
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta40, delta01, delta12, delta23, delta34;
        unsigned long   msgstart;

	msgstart = tickGet();

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

        delta40 = delta01 = delta12 = delta23 = delta34 = 0;

	rxp = rxlinetab [line];
	txp = txlinetab [line];

	for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
	{
            linestats [line].msgxfercount++;
            loopmsgs [line]++;

            /* time since end of last msgxfer */

            tick [line] [0] = tickGet ();
            delta40 = (tick [line] [0] - tick [line] [4]);

	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }
	    set_rts (line);

	    if (pretxdelay [line] != 0)
	    {
		taskDelay (pretxdelay [line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglenexpected = rxlength;
	    rxp->txaddress = txp->txbuf [0];       /* rx_int_proc uses info to parse the response */
	    rxp->txfunction = txp->txbuf [1];

	    semTake (semids [line] [TXSEM], NO_WAIT);
	    semTake (semids [line] [RXSEM], NO_WAIT);

	    txlen = txp->txmsglen;

            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
            {
               printf ("TX:");
               for (ix = 0; ix < 12 ; ix++) /* 12 is maximum TX message length */
               {
                    if (ix < txlen)
		    {
                       printf("_%2x", txp->txbuf [ix]);
		    }
                    else
		    {
                       printf ("...");
		    }
               } 
               printf ("\n");
            }

            /* time from entering msgxfer to starting transmission. (including delays & diags) */ 

            tick [line] [1] = tickGet ();
            delta01 = (tick [line] [1] - tick [line] [0]);

            start_rx (line, semids [line] [RXSEM], &rxstatus);
	    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

	    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
	    {
		txstatus = IO_TIMEOUT;
	    }

            /* time to transmit message. */

            tick [line] [2] = tickGet ();
            delta12 = (tick [line] [2] - tick [line] [1]);

	    stop_tx (line);

	    if (posttxdelay [line] != 0)
	    {
		taskDelay (posttxdelay [line]);
	    }

	    if (halfduplex [line] == TRUE)
	    {
	       clear_rts (line);
	    }
            /* intermessage wait time. */

            tick [line] [3] = tickGet ();
            delta23 = (tick [line] [3] - tick [line] [2]);

	    if (txstatus == TXGOOD)
	    {
                oldrxix = -1;    /* make it pass through timeout loop at least once */
                while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
                {
                    if (oldrxix == rxp->rxix)
                    {
                        if (modtrace [line])
			{
                            logMsg("RX timeout\n");
			}
                        rxstatus = IO_TIMEOUT;
                        break;
                    }
                    else
                    {
                        if ((modtrace [line]) || (mltrace[line] == 12))
			{
                             logMsg("waiting...");
			}
                    }
                    oldrxix = rxp->rxix;
                }
		stop_rx (line);

                /* time to receive message. */

                tick [line] [4] = tickGet();
                delta34 = (tick [line] [4] - tick [line] [3]);

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
		{
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf("RX:");
                        for (ix = 0; ix < 26; ix++) /* 26 is maximum RX message length */
                        {
                            if (ix < rxlen)
			    {
                                printf("_%2x", rxp->rxbuf [ix]);
			    }
                            else
			    {
                                printf("...");
			    }
                        } 
	                printf("\n");
                        printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                    }
		    if (rxlen < 3)
		    {
			if (modtrace [line])
			{
			    logMsg("Invalid rxlen... %d\n", rxlen);
			}
		    }
		    else
		    {
		        makecrc (&rxp->rxbuf [0], rxlen-2, csums);
		    }
		    if ((csums [0] == rxp->rxbuf [rxp->rxix - 2]) &&
			 (csums [1] == rxp->rxbuf [rxp->rxix - 1]))
		    {
			if ((modtrace [line]) && ((rxp->rxbuf[ 1] & FNCERRBIT) != 0))
			{
			    switch (rxp->rxbuf [2])
			    {
			    case (1):
				logMsg("Modbus Error Illegal Function \n");
				break;

			    case (2):
				logMsg("Modbus Error Illegal Data Address \n");
				break;

			    case (3):
				logMsg("Modbus Error Illegal Data Value \n");
				break;

			    case (4):
				logMsg("Modbus Error Device Failure \n");
				break;

			    case (5):
				logMsg("Modbus Error Acknowledgement \n");
				break;

			    case (6):
				logMsg("Modbus Error Busy/Rejected Message \n");
				break;

			    case (7):
				logMsg("Modbus Error Negative Ack \n");
				break;
			    }
			}

                        pmod->msgs++;
                        pmod->responsetime += (tickGet() - msgstart);
			return (XFERGOOD);
		    }
		    else
		    {
			pmod->no_crcerrs++;
			if (modtrace [line])
			{
			    logMsg ("CRC Message Length = %d\n", rxlen);
			}
			if (modtrace [line])
			{
			    logMsg ("%x%x%x%x Bad CRC\n",
					rxp->rxbuf [rxp->rxix - 2], rxp->rxbuf [rxp->rxix - 1],
					csums [0], csums [1]
					);
			}
			for (ix = 0; ix < rxlen; ix++)
			{
			    if (modtrace [line])
			    {
			    	logMsg ("%x\n", rxp->rxbuf [ix]);
			    }
			}
		    }
		}
		else if (rxstatus == IO_TIMEOUT)
		{
                    if (modtrace [line])
                    {
		    	logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                    }
		    pmod->no_rxnoresp++;
		}
		else
		{
		    if (modtrace [line])
		    {
		    	logMsg ("Receive Error\n");
		    }
		    if (modtrace [line])
		    {
		    	logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
				 rxp->rxbuf[100],
				 rxp->rxbuf[101],
				 rxp->rxix);
		    }
		    pmod->no_rxhwerrs++;
		}
	    }
	    else if (txstatus == IO_TIMEOUT)
	    {
		if (modtrace [line])
                {
			logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
		pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
		{
		    logMsg ("Transmit Error\n");
		}
		pmod->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS)
		pmod->no_retries++;
	}
	if (modtrace [line])
	{
	    logMsg ("Xfer Bad\n");
	}
	return (XFERBAD);

}

/*
**      init_plc_tab
**
**      The purpose of this routine is to initialize the line tables for the
**      analog devices I/O
**
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, unsigned short mod)

{
	MULPLC  *pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
	{
		return;
	}
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;

	initplc (pmod);
	initstats (pmod);
}
/*
** Cold Init a PLC
**
*/
/* only called from init_line_tabs  */


static void initplc (MULPLC  *pmod)

{

	unsigned short	i,j;
                                                                	
/*                                                                 	
**      EXCEPTION INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
        pmod->exception.was_requested = FALSE;
	pmod->exception.data_valid = FALSE;


/*                                                                 	
**      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMMULAIS); i++)
	{
	    pmod->ais [i].was_requested = FALSE;
	    pmod->ais [i].data_valid = FALSE;
	}

/*                                                             		
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
**              - NOT REQUESTED                                    	
**              - READ BACK NOT VALID                              	
**              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].was_requested = FALSE;
	    pmod->regs [i].data_valid = FALSE;
	}

}

/*                                                            		
**                                                              	
** initialize the statistics for a Multilin PLC                  	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (MULPLC *pmod)

{
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/

        pmod->tscanpass = 0;        /* plc scan pass counter            */
        pmod->msgs = 0;             /* good response message counts     */
        pmod->responsetime = 0;     /* total wait time for good messages*/
}



/*                                                                       
** modloopback                                                            
**                                                                        
*/                                                                          	
/* only called from on_line */

static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 MULPLC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODLOOPBACK;
	txp->txbuf [2] =  0;
	txp->txbuf [3] =  0;
	txp->txbuf [4] =  0xA5;
	txp->txbuf [5] =  0x37;

	makecrc (&(txp->txbuf [0]), MODLOOPBACKLEN, &(txp->txbuf [MODLOOPBACKLEN]));

	txp->txmsglen = MODLOOPBACKLEN+MODCRCLEN;


	pmod->no_datain_msgs++;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, MODLOOPBACKRESPLEN) == XFERBAD)
	{
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}

	return (TRUE);
}

/*                                                                           	
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the PLCs as on hold and the    	
**	data as not valid until read again from the PLC                       	
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

{
	unsigned short	mod;
	MULPLC		*pmod;

	for (mod = 1; (mod <= NUMMULPLCS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}




/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

{
	unsigned short  mod;
	MULPLC		*pmod;

	for (mod = 1; (mod <= NUMMULPLCS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
                /* check cmd_force_offline flag because it is set in an asynchronous task */
                if ((pmod->is_responding) && (!pmod->cmd_force_offline))
		{
		    return (TRUE);
		}
	    }
	}
	return (FALSE);
}

/*                                                             	        
** Readexcept                                                           
**                                                              	
*/
static	unsigned short readexcept (unsigned short line, unsigned short mod, MULPLC *pmod)

/* only called from scan_plc */

{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODEXCEPTREAD;

	makecrc (&(txp->txbuf [0]), MODEXCEPTLEN, &(txp->txbuf [MODEXCEPTLEN]));

	txp->txmsglen = MODEXCEPTLEN + MODCRCLEN;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODEXCEPTREAD))
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

	/* Store the returned exception data            */

        pmod->exception.last_read = rxp->rxbuf[2];
	pmod->exception.data_valid = TRUE;

	return (CMDDONE);
}

/*
** Readais                                                        	
**                                                                	
*/
static	unsigned short readais (unsigned short line, unsigned short mod,
			 MULPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

{
    unsigned short  index;

    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  buildreg, oldreg, oldpass, debouncecount;
    unsigned short  i, j;
    int             absolute;
    long            diff, percent10, abs10, testvalue;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pmod->no_datain_msgs++;

    /* Format the output message */
    txp->txbuf [0] =  mod;
    txp->txbuf [1] =  MODAIREAD;
    txp->txbuf [2] =  (regaddr >> 8);
    txp->txbuf [3] =  (regaddr & 0xFF);
    txp->txbuf [4] =  (reglen >> 8);
    txp->txbuf [5] =  (reglen & 0xFF);

    makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

    txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

    /* Send out the message */
    if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (CMDFAIL);
    }

    /* Verify the response */
    if ((rxp->rxbuf [0] != mod) ||
        (rxp->rxbuf [1] != MODAIREAD) ||
        (rxp->rxbuf [2] != (reglen * 2)))
    {
        pmod->no_dataerr++;
        return (CMDNACK);
    }

    /* Store the returned data                      */
    /*  data is aligned by 4 register sets          */
    /*  and a multiple of 4 registers long          */
    for (i = 0; (i < rxp->rxbuf [2]); i += 8)
    {
        for (j = 0; (j < 4); j++)
        {
            buildreg = rxp->rxbuf [3 + i + (j * 2)];
            buildreg = (buildreg << 8) + rxp->rxbuf [3 + i + (j * 2) + 1];

            pmod->ais [(regaddr / 4) + (i / 8)].aivals [j] = buildreg;
        }
        pmod->ais [(regaddr / 4) + (i / 8)].data_valid = TRUE;
    }
    return (CMDDONE);
}

/*                                                                      	
** Readregs                                                                	
**                                                                            	
*/
static	unsigned short readregs (unsigned short line, unsigned short mod,
			 MULPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

{

	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  buildreg;
	unsigned short  i, j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODREGREAD;
	txp->txbuf [2] =  (regaddr >> 8);
	txp->txbuf [3] =  (regaddr & 0xFF);
	txp->txbuf [4] =  (reglen >> 8);
	txp->txbuf [5] =  (reglen & 0xFF);

	makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODREGREAD) ||
	    (rxp->rxbuf [2] != (reglen * 2)) )
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for (i = 0; (i < rxp->rxbuf [2]); i += 8)
	{
	    for (j = 0; (j < 4); j++)
	    {
		buildreg = rxp->rxbuf [3 + i + (j * 2)];
		buildreg = (buildreg << 8) + rxp->rxbuf [3 + i + (j * 2) + 1];
		pmod->regs [(regaddr / 4) + (i / 8)].ioregs [j] = buildreg;
	    }
	    pmod->regs [(regaddr / 4) + (i / 8)].data_valid = TRUE;
	}
	return (CMDDONE);
}

/*                                                           		
** Setcoil                                                        	
**                                                                 	
*/
static	unsigned short setcoil (unsigned short line, unsigned short mod,
			 MULPLC *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */

{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i, ix, lsignal;
	unsigned long	lmask, lval, tmask ,tval;


	if (mask == 0)
	{
	    return (CMDREJECT);
	}
	tmask = lmask = mask;
	tval = lval = val;
	lsignal = bitaddr;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	 /* adjust the bits to the low order bit */

	while ((tmask & 1) == 0)
	{
	    tval = tval >> 1;          /* adjust the value */
	    tmask = tmask >> 1;         /* adjust the mask */
	}

	/* Is it a single coil output */

	if ((tmask & 2) == 0)
	{
	    /* Format the output message */

	    txp->txbuf [0] =  mod;
	    txp->txbuf [1] =  MODCOILWRITE;
	    txp->txbuf [2] =  (lsignal >> 8);
	    txp->txbuf [3] =  (lsignal & 0xFF);
	    txp->txbuf [4] =  (lval==0)?0:0xFF;  /* 0 => off  0xFF => on */
	    txp->txbuf [5] =  0;

	    makecrc (&(txp->txbuf [0]), MODSETCOILLEN, &(txp->txbuf [MODSETCOILLEN]));

	    txp->txmsglen = MODSETCOILLEN + MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
		return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/
	    for (i = 0; (i < MODSETCOILLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    if (rxp->rxbuf [1] & FNCERRBIT)
		    {
			if (rxp->rxbuf [2] == MODEXCEPTBUSY)
			{
			    return (CMDBUSY);
			}
		    }
		    pmod->no_dataerr++;
		    return (CMDNACK);
		}
	    }
	    return (CMDDONE);
	}


}



/*
** Setreg                                                       	
**                                                                  	
*/
static	unsigned short setreg (unsigned short line, unsigned short mod,
			 MULPLC *pmod, unsigned short regaddr,
			 unsigned short val,double dblval, unsigned short conv)

/* only called from checkoutputs */

{
	TXLINE 		*txp;
	RXLINE 		*rxp;
	unsigned short	i;
   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	uval.fvalue = dblval;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [2] =  (regaddr >> 8);
	txp->txbuf [3] =  (regaddr & 0xFF);


	if (conv != ASCFLT)
	{
	    txp->txbuf [1] =  MODREGWRITE;
	    txp->txbuf [4] =  (val >> 8);
	    txp->txbuf [5] =  (val & 0xFF);

	    makecrc (&(txp->txbuf [0]), MODSETREGLEN, &(txp->txbuf [MODSETREGLEN]));

	    txp->txmsglen = MODSETREGLEN + MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/

	    for (i = 0; (i < MODSETREGLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    pmod->no_dataerr++;
		    return (CMDNACK);
	        }
	    }
	    return (CMDDONE);
	}
	else
	{ /* Send out float as multiple register write */

	    txp->txbuf [1] =  MODMREGWRITE;
	    txp->txbuf [4] = 0x00;
	    txp->txbuf [5] = 0x02;	/* Number of registers */
	    txp->txbuf [6] = 0x04;	/* Number of bytes */

	    txp->txbuf [7] = (uval.lvalue >> 8) & 0xFF;
	    txp->txbuf [8] =  uval.lvalue & 0xFF;
	    txp->txbuf [9] = (uval.lvalue >> 24) & 0xFF;
	    txp->txbuf [10] = (uval.lvalue >> 16) & 0xFF;


	    makecrc (&(txp->txbuf [0]), MODSET2REGLEN, &(txp->txbuf [MODSET2REGLEN]));

	    txp->txmsglen = MODSET2REGLEN + MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/

	    for (i = 0; (i < MODSETMREGRESPLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    pmod->no_dataerr++;
		    return (CMDNACK);
	        }
	    }
	    return (CMDDONE);
	}
}

/*
** makecrc 									
**                                                                        	
*/
/* called from msgxfer, modloopback, readcoils, readdis, readais, readregs, setcoil, setreg,  */
/*             plc_logout, plc_login, plc_start, plc_stop, pollfordone, plc_init, plc_getdim, */
/*             plc_setdim, readmem, writemem, writelogic, and writeascii.                     */

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short	checksum;
	unsigned int    i, j;
	unsigned short  flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++)
	{
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag)
		{
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf [1] = ((checksum >> 8) & 0xff);
	retbuf [0] = (checksum & 0xff);
}
/*                                                                        	
**      hexascii                                                            	
**                                                                          	
**      The purpose of this routine is to convert the hex byte to 2 ascii   	
**      characters and to place them into the buffer.                       	
**                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val,char *buf)

{
	char    hi, lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi <= 9)
	{
	    hi+='0';
	}
	else
	{
	    hi += ('A' - 10);
	}
	if (lo <= 9)
	{
	    lo += '0';
	}
	else
	{
	    lo += ('A' - 10);
	}
	buf [0] = hi;
	buf [1] = lo;

}

/*                                                                         	
**      asciihex                                                    	   	
**                                                                         	
**      The purpose of this routine is to convert the next 2 ascii         	
**      characters in the buffer to hex and return them in val. It         	
**      will return TRUE if good conversion of FALSE if bad.               	
*/                                                                         	
/* not called from within this driver */


static	short asciihex (unsigned short *val,char *buf)

{
	if ((buf [0] < '0') || (buf [0] > 'F'))
	{
	    return (FALSE);
	}
	if (buf [0] <= '9')
	{
	    *val = ((buf [0] & 0x0f) << 4);
	}
	else
	{
	    if (buf [0] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val = ((buf [0] - 'A' + 10) << 4);
	    }
	}
	if ((buf [1] < '0') || (buf [1] > 'F'))
	{
	    return (FALSE);
	}
	if ( buf [1] <= '9')
	{
	    *val += (buf [1] & 0x0f);
	}
	else
	{
	    if (buf [1] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val += (buf [1] - 'A' + 10);
	    }
	}
	return (TRUE);
}


/*
**      DUMPMSGCNTS
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, e, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	e = linestats [line].RXbadcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf ("TX Interrupt Count    = %10d\n", x);
            printf ("RX Interrupt Count    = %10d\n", y);
            printf ("BadRX Intrpt Count    = %10d\n", e);
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
        printf ("BadRX Intrpt Count    = %10d\n", e);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
**      CLEARMSGCNTS
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*
**      DUMPPLCSTATS
**
**      The purpose of this routine is to dump the plc level statistics for this driver.  
**
*/
/* called from TABLEINFO */

void DUMPPLCSTATS (unsigned short line, unsigned short maddr)

{
    MULPLC         *pmod;
    unsigned long   microsecs;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/ModbusAddress Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n", pmod->was_requested);
    printf (" Is responding = %d \n", pmod->is_responding);
    printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
    printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
    printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
    printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
    printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
    printf (" Force Offline = %d \n", pmod->cmd_force_offline);
    printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);
    printf ("\n");

    printf (" # of Completed Messages %d \n", pmod->msgs);
    printf (" Total Response Time (in ticks) = %lu \n", pmod->responsetime);
    printf ("   (includes retries prior to each completed message)\n");
    if (pmod->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n", pmod->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
    return;
}

/*
**      CLEARPLCSTATS
**
**      The purpose of this routine is to clear the plc level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void CLEARPLCSTATS (unsigned short line, unsigned short maddr)
{
    MULPLC		*pmod;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/ModbusAddress Not Defined \n");
        return;
    }

    initstats (pmod); /* use existing procedure */
    return;
}


/*
**      dump_mul_table
**                                                                           	
**      The purpose of this routine is twofold:                                 
**         1) dump the plc level statistics for the Multilin driver.
**         2) dump the data for the specified Modbus plc.
**                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

    {
	MULPLC		*pmod;
	short           ix;
	unsigned	short	i, n, j; 

	MULCMDS		*coilptr;
	MULEXCEPT	*eiptr;
	REGISTERS	*regptr;
	MULAIS		*aiptr;
	unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer [200];


	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg("Line/ModbusAddress Not Defined \n");
	    return;
	}

        /* previously integral code moved to seperate procedure for debugging convenience */
        DUMPPLCSTATS (line, maddr);



	linecnt = 1;
	printeihdr (buffer, linecnt);
	addr = 1;
	printf ("  %4d    ", addr);
 	eiptr = &pmod->exception;
	printf("%1x,  %1x,         %lx,\n",
                eiptr->was_requested,
                eiptr->data_valid,
                eiptr->last_read);

	linecnt = 1;
	printaihdr(buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXAINO; i += 8)
	{

	    printf ("  %4d \t", addr);
				   
	    for (n = 0; n < 2; n++ )
	    {		
		aiptr = &pmod->ais [(i / 4) + n];
		printf ("\t%1x,%1x  \t", aiptr->was_requested, aiptr->data_valid);
		for (j = 0; j < 4; j++)
		{
                    printf("%5d: ,   ", aiptr->aivals[j]);
		}
	    }
	    printf("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < MAXAINO) )
	    {
		linecnt = 1;
		printaihdr (buffer, linecnt);
	    }
	    addr += 8;		
	}

	linecnt = 1;
	printreghdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXREGNO; i += 8)
	{
	    printf("  %4d \t", addr);

	    for (n = 0; n < 2; n++)
	    {		
		regptr = &pmod->regs[(i/4)+n];
		printf("\t%1x, %1x,\t", regptr->was_requested, regptr->data_valid);
		for (j = 0; j < 4; j++)
		{
		    printf("%6d,\t",regptr->ioregs[j]);
		}
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < MAXREGNO) )
	    {
		linecnt = 1;
		printreghdr (buffer, linecnt);
	    }
	    addr += 8;		
	}
}


/******************************************************************************/
/*                                                                              
**      dump_ai_table                                                       	
**                                                                           	
**      The purpose of this routine is twofold:                                 
**         1) dump the plc level statistics for the Multilin driver.
**         2) dump the data for the specified Modbus plc.
**                                                                              
*/
/* not called from within this driver */

void dump_ai_table (unsigned short line, unsigned short maddr)
{
    MULPLC		*pmod;
    short           ix;
    unsigned	short	i, n, j; 

    MULAIS		*aiptr;

    unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
    unsigned	long	bigvalue;
    unsigned	char	buffer [200];


    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg("Line/ModbusAddress Not Defined \n");
        return;
    }

    /* previously integral code moved to seperate procedure for debugging convenience */
    DUMPPLCSTATS (line, maddr);

    linecnt = 1;
    printeihdr(buffer, linecnt);
    addr = 1;
    for (i = 0; i < MAXAINO; i += 8)
    {
        printf ("  %4d \t", addr);
        for (n = 0; n < 2; n++ )
        {		

            aiptr = &pmod->ais [(i / 4) + n];
            printf ("\t%1x,%1x  \t", aiptr->was_requested, aiptr->data_valid);
            for (j = 0; j < 4; j++)
            {
                printf("%5d: ,   ", aiptr->aivals[j]);
            }
        }
        printf("\n");
        linecnt += 1;
        if ((linecnt >= 17) && ((i + 8)  < MAXAINO) )
        {
            linecnt = 1;
            printaihdr (buffer, linecnt);
        }
        addr += 8;		
    }
}



/*
** only called from dump_mul_table
*/


static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{	
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
        sprintf (buffer,"                                                   MODBUS COILS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
        sprintf (buffer,
               "          R   V      Value\tR   V      Value");
 	printf ( "%s\n", buffer);
 	cnt += 1;
}
/*
** only called from dump_mul_table
*/


static void printeihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
        sprintf (buffer,"                                              MODBUS EXCEPTION DATA");
	printf ( "%s\n", buffer);
	cnt += 1;
        sprintf (buffer,
                "          R   V      Value");
	printf ( "%s\n", buffer);
 	cnt += 1;
}
/*
** only called from dump_mul_table
*/


static void printaihdr(unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
       sprintf (buffer,"                                            MODBUS ANALOG INPUTS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
       sprintf (buffer," \t \tR  V\tValue  \tValue  \tValue  \tValue  \t \tR  V\tValue  \tValue  \tValue  \tValue");
 	printf ( "%s\n", buffer);
 	cnt += 1;
}

/*
** only called from dump_mul_table
*/


static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
       sprintf (buffer,"                                             MODBUS REGISTERS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
       sprintf (buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf ( "%s\n", buffer);
 	cnt += 1;

}
/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer [132];
	char	*resrsp;
	char	*lineact;


        printf ("                                 Modbus Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number      MULPLC Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
	printf ("\n");

	for (i = 0; i < MULLINES; i++)
	{
	    if(plcs [i] == NULL)
	    {
		continue;
	    }
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (line_activity [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,plcs[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}

/*	End of File:	drvMultilin.c */
