/*drvQ984.c,v 1.1.1.1 1999/08/03 14:44:14 tis4000 Exp */
/***************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File:  drvQ984.c
**  Edit:  09/24/95 12:33 JLD
**  Edit:  09/04/97       wep : added Resource Group Lock function
**                            :
**
*/

#define  ASSIGNGROUP    qtmsResGroup             /* NOTE: change here */

#include <ctype.h>
/*#include <malloc.h>*/
#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <vme.h>

#include <devType.h>
#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <restable.h>
#include <drvQ984.h>
#include <dbRecType.h>
#include <dbRecords.h>
#include <dbDefs.h>

#include <redmsgs.h>
#include <socket.h>
#include <in.h>
#include <task_params.h>
 
#include <dbCommon.h>
#include <recSup.h>
#include <errno.h>
#include <redflds.h>
#include <dbRecDes.h>
#include <rec/aiRecord.h>
#include <rec/patRecord.h>


static long	init();

struct {
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
} drvQtm={
	2,
	NULL,
	init};

/*
**      Storage for QTM-SCANNER  Structures
**
*/
static short  cur_op_stat[LINES] =  {0, 0, 0, 0};
static short  opstat[LINES] = {0, 0, 0, 0};
static unsigned long Ireqs[LINES] = {0,0,0,0};
static unsigned long GIrsps[LINES] = {0,0,0,0};
static unsigned long BIrsps[LINES] = {0,0,0,0};
static unsigned long Idelay[LINES] = {0,0,0,0};
static unsigned long Chgint[LINES] = {0,0,0,0};
static long		lastouttime[LINES];
static short		was_resp[LINES];
static QTMLINK		*plcs[LINES] = {NULL, NULL, NULL, NULL} ;
static short		Qtmtries[LINES]= {15,15,15,15};
static unsigned char	resnames [LINES][RESNAMELEN];
static RES_TABLE	*prestable[LINES];
static unsigned short	resresponse[LINES];
static unsigned short   redflags[LINES];
static unsigned long	last_drop_stat[LINES];
static unsigned long	serredupdtime[LINES];
static unsigned long	last_active_time_ck[LINES];
static unsigned long	last_output_time_ck[LINES];
static unsigned long	last_online_time[LINES] = {0,0,0,0};
static unsigned short	modtrace[LINES] = {TRUE,TRUE,TRUE,TRUE};
static unsigned short	scanfail[LINES] = {FALSE,FALSE,FALSE,FALSE};
static unsigned short	wasstarted[LINES] = {FALSE,FALSE,FALSE,FALSE};
static unsigned short	lights[LINES] = {0,0,0,0};
static unsigned short	enbcj[LINES] = {FALSE,FALSE,FALSE,FALSE};
static unsigned short	extcj[LINES] = {FALSE,FALSE,FALSE,FALSE};
static unsigned short	modrestrace[LINES];
static OUTPUTQUE	*oq[LINES];		/* array of output queues and their control structures */
static unsigned short	forcedslave[LINES] = {FALSE,FALSE,FALSE,FALSE};
static unsigned short	cur_op__stat[LINES];
static unsigned short	Qtm_op__stat[LINES];
static SEM_ID           semids[LINES];

static SEM_ID           redsemids[LINES];
static int		redsize[LINES];
static int		Qtmsredperiod[LINES];
static int		serredperiod[LINES];
static int		Qtmsredport[LINES];
static int		serredport[LINES];

static int		monitor908[LINES] = {FALSE,FALSE,FALSE,FALSE};

static QTM_SREGION *svmebases[LINES] = {(QTM_SREGION *)QTMSL1SBASE,(QTM_SREGION *)QTMSL2SBASE,
					 (QTM_SREGION *)QTMSL3SBASE,(QTM_SREGION *)QTMSL4SBASE};
static QTM_SREGION *sbases[LINES];

static QTM_REGION	*vmebases[LINES] = {(QTM_REGION *)QTMSL1LBASE,(QTM_REGION *)QTMSL2LBASE,
					 (QTM_REGION *)QTMSL3LBASE,(QTM_REGION *)QTMSL4LBASE};
static QTM_REGION	*bases[LINES];
static char		*membases[LINES];
static unsigned	vectors[LINES] = {QTMSL1VEC,QTMSL2VEC,QTMSL3VEC,QTMSL4VEC};

static short	smasks[] = {0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,
			    0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000 };

static short	rsmasks[] = { 0x8000,0x4000,0x2000,0x1000,0x0800,0x0400,0x0200,0x0100,
			      0x0080,0x0040,0x0020,0x0010,0x0008,0x0004,0x0002,0x0001 };

static short	rbmasks[] = { 0x0080,0x0040,0x0020,0x0010,0x0008,0x0004,0x0002,0x0001 };

static long lmasks [] = {
	0x00000001, 0x00000002, 0x00000004, 0x00000008,
	0x00000010, 0x00000020, 0x00000040, 0x00000080,
	0x00000100, 0x00000200, 0x00000400, 0x00000800,
	0x00001000, 0x00002000, 0x00004000, 0x00008000,
	0x00010000, 0x00020000, 0x00040000, 0x00080000,
	0x00100000, 0x00200000, 0x00400000, 0x00800000,
	0x01000000, 0x02000000, 0x04000000, 0x08000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000,
};

static unsigned short	intermsgdelay[LINES];
static char		user[40],password[40];

/*****************************************************/
extern  short           resGroupLock [];              /* holds line driver group lock flags.          */
extern  char           *resGroupTripName [];          /* holds line driver trip name.                 */
/*****************************************************/

/*
**      Storage for QTM-SCANNER Comm Line Structures
**
*/

static RXLINE          *rxlinetab[LINES] = 
			{NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static TXLINE          *txlinetab[LINES] = 
			{NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [LINES];

static char *modtypes[] = {"","DI8","DI16","DI32","DO8","DO16","DO32",
				   "AO","AICUR","AIVOLT","AITC","AIRTD"};


static unsigned short qtmsResGroups [LINES] ={ 0, 0, 0, 0} ; /* line driver group assignments   */


static char *tasknames[] = {"QTMS Ch0","QTMS Ch1","QTMS Ch2","QTMS Ch3"	};
static char *pointtypes[] = { "ai","ao","bi","bo","mbbi",
					"mbbo","pto","td","pat",NULL};
					/* ID   QTM I-CFG O-CFG #I #O #T PTYP #SIG BTYP */
static MODPARAMS	mparm[] = {	{0x000f, 1, 0xa0, 0x00, 2, 0, 0,  SBI, 16, DI16},
					{0x0003, 1, 0xa0, 0x00, 4, 0, 0,  SBI, 32, DI32},
					{0x000b, 1, 0xa0, 0x00, 2, 0, 0,  SBI, 16, DI16},
					{0x0002, 1, 0x00, 0xa0, 0, 2, 2,  SBO, 16, DO16},
					{0x0005, 1, 0x00, 0xa0, 0, 2, 2,  SBO, 16, DO16},
					{0x0006, 1, 0xa0, 0x00, 4, 0, 0,  SBI, 32, DI32},
					{0x0012, 1, 0xa0, 0x00, 2, 0, 0,  SBI, 16, DI16},
					{0x0011, 1, 0xa0, 0x00, 4, 0, 0,  SBI, 32, DI32},
					{0x0004, 1, 0x00, 0xa0, 0, 4, 4,  SBO, 32, DO32},
					{0x0010, 1, 0x00, 0xa0, 0, 2, 2,  SBO, 16, DO16},
					{0x000c, 1, 0x00, 0xa0, 0, 2, 2,  SBO, 16, DO16},
					{0x0008, 1, 0x00, 0xa0, 0, 1, 2,  SBO, 8,  DO8},
					{0x0102, 1, 0x00, 0x00,18, 0, 2,  SAI, 8,  AICUR},
					{0x0106, 1, 0x00, 0x00,18, 0, 10, SAI, 8,  AIVOLT},
					{0x0103, 1, 0x00, 0x20, 0, 8, 12, SAO, 4,  AO},
					{0x0104, 1, 0x00, 0x20, 0, 8, 12, SAO, 4,  AO},
					{0x0107, 1, 0x20, 0x00,20, 0, 10, SAI, 9,  AITC},
					{0x010a, 1, 0x20, 0x00,18, 0, 10, SAI, 8,  AIRTD},
					{-1,0,0,0,0,0,0,0,0} };

/*
**
**		Prototypes for all routines in this module
**
*/
static GAIN_TABLE *buildGainTable ();
void setQtmretries(unsigned short line,unsigned short retries);
int startQtms(unsigned short ln, unsigned short redundant,
	      unsigned short delay , unsigned short port, unsigned short Qtmsredperiod,
	      unsigned short serport, unsigned short serperiod, char *redport);
void vQtm_driver (unsigned short line,  unsigned short redundant,
		  unsigned short delay ,unsigned short port, unsigned short Qtmsredperiod,
		  unsigned short serport, unsigned short serperiod, char *redport);
static void    on_line(unsigned short line, unsigned short state);
static void    bemaster(unsigned short line);
static void    beslave(unsigned short line);
static	void    scan_plc(unsigned short line);
static	void    slave_scan(unsigned short line,unsigned short operate);
static	void    master_updateredimage(unsigned short line);
static	void 	slave_updateredimage (unsigned short line, QTMSREDUPD *redbuf, int size);
static	void checkstattime(unsigned short line, unsigned short mode);
int vQtm_aidriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short xsignal, 
		 short *pvalue, unsigned short conversion,unsigned short gain,
		 unsigned short ctype, unsigned char *resname);

int vQtm_aodriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard, unsigned short signal, double dvalue,
		 unsigned short value, unsigned short conversion,
		 unsigned short ctype, unsigned char *resname);

int vQtm_aoread( char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short xsignal,
		 unsigned short *pvalue, unsigned short linr,
		 unsigned short ctype, unsigned char *resname);

int vQtm_bidriver(char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short xsignal,
		 unsigned long mask,unsigned long *pvalue,
		 unsigned short ctype, unsigned char *resname);

int vQtm_bodriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short xsignal,
		 unsigned long value, unsigned long mask,
		 unsigned short ctype, unsigned char *resname);

int vQtm_boread (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard, unsigned short xsignal,
		 unsigned long *pvalue, unsigned long mask,
		 unsigned short ctype, unsigned char *resname);

static void  register_resource (unsigned short link, QTMLINK *pmod,
                                unsigned char *resname, char *pointname);
static	void init_line_tabs(unsigned short line);
static	void initstats(QTMLINK *pmod);
static initscanner(unsigned short line);
Qtmic(unsigned short line);
static vQtm_int_proc(unsigned short line);
Qtmstdump();
void Qtminfo (unsigned short line, unsigned short l,unsigned short a,
 		unsigned short c, unsigned short b);




/********
**
**	This routine fails the resource
**
********/
void Qtmfail(unsigned short line)
    {

		resPutCommand(prestable[line],RES_RELINQUISH); /* clear out commands */
    }
/********
**
**	This routine sets the retry limit
**
********/
void setQtmretries(unsigned short line,unsigned short retries)
    {
	Qtmtries[line]= retries;
    }

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init () {
	return (0);
}
/********
**
**	This routine forces the driver to start in monitor mode
**
********/
void Qtmmonon(unsigned short line)
    {
	monitor908[line] = TRUE;
    }
/********
**
**	This routine releases the driver from monitor mode
**
********/
void Qtmmonoff(unsigned short line)
    {
	monitor908[line] = FALSE;
    }
/********
**
**	This routine forces the driver to remain in slave mode
**
********/
void Qtmsforceslaveon(unsigned short line)
    {
	forcedslave[line] = TRUE;
    }

/********
**
**	This routine allows tthe driver to leave slave mode
**
********/
void Qtmsforceslaveoff(unsigned short line)
    {
	forcedslave[line] = FALSE;
    }


/********
**
**	This routine enables logging of comm trace messages
**
********/
void Qtmstraceon(unsigned short line,unsigned short val)
    {
	modtrace[line] = val;
    }

/********
**
**	This routine disables logging of comm trace messages
**
********/
void Qtmstraceoff(unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
**
**	This routine enables logging of resource trace messages
**
********/
void Qtmsrestraceon(unsigned short line)
    {
	modrestrace[line] = TRUE;
    }

/********
**
**	This routine disables logging of resource trace messages
**
********/
void Qtmsrestraceoff(unsigned short line)
    {
	modrestrace[line] = FALSE;
    }

/********
**
**	This routine enables logging of comm trace messages
**
********/
void Qtmcj(unsigned short line,unsigned short enb,unsigned short ext)
    {
	enbcj[line] = enb;
	extcj[line] = ext;
    }


int stopQtms (short ln)
{
	if (comm_disconnect (ln) != -1) {
	    taskDelete (taskId [ln]);
	    return (1);
	} else {
	    return (-1);
	}
}

int startQtms(unsigned short ln, unsigned short redundant,
	     unsigned short delay, unsigned short port, unsigned short Qtmsredperiod,
	     unsigned short serport, unsigned short serperiod, char *redport)
{

	if ( ln < LINES )
	{
	    taskId [ln] = taskSpawn(tasknames[ln],QTMS_PRIORITY,QTMS_TASK_OPTIONS,QTMS_STACK,
		vQtm_driver,ln, redundant, delay, port, Qtmsredperiod, serport, serperiod, redport);

	    logMsg("Started the QTMS driver on line %d \n",ln);

	    remCurIdGet(user,password);
	    return (1);
	} else {

	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}

int ASSIGNGROUP (unsigned short line, unsigned short group)
{
    if (line < LINES)
    {
        if (group <= MAXGROUPNUM)
        {
            qtmsResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, LINES);
        return (-1);
    }
}

void qtmsgrouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  Limitorque Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = LINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    qtmsResGroups [index]/10,
                    qtmsResGroups [index]%10);
        }
        printf ("\n");
    }
}

void qtmslocktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void qtmslockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", *resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void qtmssetlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void qtmsclrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void qtmsgrouphelp (void)
{
    printf (" WPCS Driver Group Related Functions\n");
    printf ("\n");
    printf (" qtmsResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" qtmsgrouptable         Display the Limitorque's line to group assignment table.    \n");
    printf (" qtmslocktable          Display the resource group lock Global Array.               \n");
    printf (" qtmslockall            Display the resource group lock and trip name Global Array. \n");
    printf (" qtmssetlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" qtmsclrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" qtmsgrouphelp          Display this help message.                                  \n");
    printf ("\n");
}



/*
**      QTMS_driver
**
**      The purpose of this task is to scan the allen bradley remote I/O
**      lines. It will maintain a configuration list supporting online additions
**      and repplacement of modules, and  maintain a table of most recently
**      scanned values.
**
*/
void vQtm_driver ( unsigned short line,  unsigned short redundant,
		  unsigned short delay ,unsigned short port, unsigned short Qtmsperiod,
		  unsigned short serport, unsigned short serperiod, char *redport)

    {

	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq, activity;
	QTMLINK          *pmod;
	unsigned short  pstate, lstate, execute, command,i;
	long		this_time, last_time,slavestattime;	
        unsigned short  group,once;

	redsize[line] = sizeof(QTMSREDUPD);
	Qtmsredperiod[line] = Qtmsperiod;
	serredperiod[line] = serperiod;
	Qtmsredport[line] = port;
	serredport[line] = serport;
	serredupdtime[line] = 0;
	last_drop_stat[line] = 0;
	was_resp[line] = FALSE;
	/* Initialize the data structures */
	lastouttime[line] = 0;
	redflags[line] = redundant;
	intermsgdelay[line] = delay;
	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;
	modrestrace[line] = TRUE;
	last_output_time_ck[line] = slavestattime = tickGet();

	/* Wait for debug release !@!*/
	while (  (!modtrace[line])  ) {
	    taskDelay(120);
	}
	/* Make Pointer to Short Address space for control registers */
	sysBusToLocalAdrs(VME_AM_SUP_SHORT_IO,svmebases[line],&sbases[line]);

	/* Make Pointer to standard address space for data transfer */ 
	sysBusToLocalAdrs(VME_AM_STD_SUP_DATA,vmebases[line],&membases[line]);
	
	/* Make Pointer to standard address space for data transfer */ 
	sysBusToLocalAdrs(VME_AM_STD_SUP_DATA,((long)vmebases[line]+0x10000),&bases[line]);

	plcs[line] = (QTMLINK *)calloc(1,(sizeof(QTMLINK)));
	if (!plcs[line]) {
	    logMsg ("Not enough memory for PLC line %d \n",line);
	    return;
	}

	init_line_tabs (line);

/* wep: output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line]) {
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (tx)\n",line);
	    return;
	}

	onlinefreq = 1;

	/* Wait for resource to be defined */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL)  ) {
	    taskDelay(120);
	}

	while (!initscanner(line)) {
	    taskDelay(120);
	}


	resClearCaAnswer(prestable[line]);		/* Start Quiet */

 	pmod = plcs[line];

	if (redflags[line]) {
	    resPutLocalState(prestable[line],RES_SLV);	/* As Slave */
	    lstate = RES_SLV;
	    if (modrestrace[line]) {
		date();
 		logMsg ("1] Became RES_SLV \n");
	    }
	    resGetStates(prestable[line],&lstate,&pstate);
	    initRedDriverData( &resnames[line], &pmod->redund, &redsize[line], (FUNCPTR)slave_updateredimage,
			       line, Qtmsredperiod[line], port, &redsemids[line]);
	    attachSerialRedund(serport,serperiod);	
	    taskDelay(300); /* Give partner time to report its state */
	}

	/* if not redundant be master */
	if (!redflags[line])  {
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line],RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace[line]) {
		 date();
 		 logMsg ("2] Became RES_MSTR \n");
	    }
	}

	/* Task will process all modules sending outputs and getting inputs */
	/* It will then try to configure requested non responding modules   */

	last_time = tickGet(); /* Initialize the time  */
	while (TRUE) {

	    once = FALSE;
	    /* Prep change to slave  */
	    last_time = tickGet ();		/* initialize gap */

	    pmod = plcs[line];  /* shorthand pointer */

            /************************************/
            /* check for line group disablement */
            /************************************/
            group = qtmsResGroups [line];
            if ((group) && (resGroupLock [group-1]))
            {
                if (modrestrace [line])
                {
		    date();
                    logMsg ("13] Forced to RES_SLV.\n");
                }
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
                if (modrestrace [line])
                {
		    date();
                    logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity);
                }
                while (resGroupLock [group-1])
                {
		    checkstattime(line,lstate);
 		    slave_scan(line,FALSE);
	            pulseSerialRedund(serredport[line], 'S');
                    group = qtmsResGroups [line];
                    if (group)
                    {
                        taskDelay (2);
                    }
                    else /* the line has been taken out of the group */
                    {
                        break;
                    }
                }
                if (modrestrace [line])
                {
		    date();
                    logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity);
                    logMsg ("16] Released to RES_SLV.\n");
                }
            }


	    if (forcedslave[line])
			lstate = RES_SLV;

	    once = FALSE;
	    while (lstate == RES_SLV) {

 		pmod = plcs[line];

		beslave(line);		 /* Make sure line is left for master */

		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resPutCommand(prestable[line],0); /* clear out commands */

		taskDelay(2); /* slow down the refresh time */

		if ((!pmod->is_responding) &&
		    (pmod->was_requested) ){
			on_line(line,lstate);
		}

		if ((pmod->is_responding) &&
		    (pmod->was_requested) ){

			slave_scan(line,FALSE);

	    		this_time = tickGet ();
		}

		checkstattime(line,lstate);

		resGetStates(prestable[line],&lstate,&pstate);

		activity = ((remoteSerialRedund(serport) == 'M') && ((pstate == 0) || (pstate == RES_ISOLATED))) ;

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 17)) break;

		/* If partner is there and must give it up take it */
		if ((pstate == RES_SLVWANTCA) && (!forcedslave[line]) ) {
                    resresponse [line] = TRUE; 	/* Make Sure driver is responding   */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) {
			date();
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		        printseqs(line);
		    }
		    break;
		}

		/* If partner is there and wants to give it up try to take it */
		once = FALSE;
		while  ((pstate == RES_SLVWANT) && (!forcedslave[line]) ) {

		    if (!once) {
		        printseqs(line);
		        once = TRUE;
		    }

                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 18)) break;

		    execute = FALSE;

		    bemaster(line);

		    taskDelay(2); /* give it time to scan the I/O */

		    /* See if any one will answer to me */
		    pmod = plcs[line];
		    if ((!pmod->is_responding) && (pmod->was_requested) && (!pmod->cmd_force_offline)){
			on_line(line,RES_MSTR);
		    }
                    /* check cmd_force_offline flag before AND after due to asynchronous tasks */
		    if ((pmod->is_responding) && (pmod->was_requested) && (!pmod->cmd_force_offline)){
			slave_scan(line,TRUE);
		    }

		    if (pmod->was_requested) {
			execute = any_responding(line) && (pmod->is_responding);
		    }

		    /* If someone answered then become master and make sure partner gave it up */
		    if (execute) {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace[line]) {
			    date();
			    logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
			execute = FALSE;
			for (i=0;(i<300);i++) {
                           /************************************/
                           /* check for line group disablement */
                           if (checkgroup (line, &lstate, 19)) break;

			    resGetStates(prestable[line],&lstate,&pstate);
			    activity = ((remoteSerialRedund(serport) == 'M') && ((pstate == 0) || (pstate == RES_ISOLATED))) ;
			    if ( (pstate == RES_SLV) || ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) ) ){
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
		    	    if ((!pmod->is_responding) && (pmod->was_requested) ){
				on_line(line,lstate);
		    	    }
			    checkstattime(line,lstate);
			    taskDelay(2);
			}
			if (!execute) {   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line]) {
				date();
				logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			    }
			}
			else { /* Assume control by taking the CA responsibilities */ 
                    	    resresponse [line] = TRUE; 	/* Make Sure driver is responding   */
			    resSetCaAnswer(prestable[line]);
			    resPutLocalState(prestable[line],RES_MSTR);
			    prepresponses(line);
			    break;
			}
		    }

		    checkstattime(line,lstate);
		    resGetStates(prestable[line],&lstate,&pstate);
		}
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 20)) break;


		if (lstate != RES_SLV)
			break;

		/* if the partner is not talking be master */
		pmod = plcs[line];
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity) && 
		    (!forcedslave[line])  ) {
                    resresponse [line] = TRUE; 	/* Make Sure driver is responding   */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) {
			date();
			logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses(line);
		}

	    }
            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 21)) continue;


	    if (forcedslave[line])
			lstate = RES_SLV;
	
	    /* Prep change to slave want */
	    last_time = tickGet ();		/* initialize gap */

	    once = FALSE;
	    pmod = plcs[line];  /* shorthand pointer */
	    while (lstate == RES_SLVWANTCA) {


                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 22)) break;

		beslave(line); /* Make sure line is left for master */
		

	        pulseSerialRedund(serredport[line], 'S');

		taskDelay(Qtmsredperiod[line]+4);

		checkstattime(line,lstate);	/* keep alive must continue */

		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resGetStates(prestable[line],&lstate,&pstate);
		activity = ((remoteSerialRedund(serport) == 'M') && ((pstate == 0) || (pstate == RES_ISOLATED))) ;

		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity) ){
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line]) {
			date();
			logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL) {
                    resresponse [line] = TRUE; 	/* Make Sure driver is responding   */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) {
			date();
			logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses(line);
		}

	    }

            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 23)) continue;

	    /* Prep change to master */
	    last_time = tickGet ();		/* initialize gap */

	    pmod = plcs[line];  /* shorthand pointer */

	    once = FALSE;
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT) || (!redflags[line])) {

		resGetStates(prestable[line],&lstate,&pstate);
		activity = ((remoteSerialRedund(serport) == 'M') && ((pstate == 0) || (pstate == RES_ISOLATED))) ;
		if ((pstate == RES_MSTR) || ((activity) && (pstate != RES_SLVWANTCA))){
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line]) {
			date();
			logMsg ("9] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

		bemaster(line); 

		resresponse[line] = TRUE; /* Make Sure driver is responding */

		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if ((command == RES_RELINQUISH) && (redflags[line]) ) {
		    master_updateredimage(line);  /* Get Last update over */
		    printseqs(line);
		    resClearCaAnswer(prestable[line]);
		    taskDelay(30);
		    resPutLocalState(prestable[line],RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace[line]) {
			date();
			logMsg ("10] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}


		pmod = plcs[line];  /* shorthand pointer */

		if (pmod->cmd_force_offline) {
		    pmod->is_responding = FALSE;
		    pmod->lasttimervalue = 0xffff;
		}

		taskDelay(2);

		/* Try to bring the unit on line if it is not already */
		pmod = plcs[line];
		if ((!pmod->is_responding) &&
		    (pmod->was_requested) &&
		    (!pmod->cmd_force_offline)) {

			on_line(line,lstate);
		}

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 24)) break;

		if ((pmod->is_responding) && (!pmod->cmd_force_offline)) {
		    scan_plc(line);

		}

		checkstattime(line,lstate);	/* keep alive must continue */

		once = FALSE;
		if ((!any_responding(line)) && (redflags[line])) {
		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (6*SLWWINDOW)) {


                        /************************************/
                        /* check for line group disablement */

                        if (checkgroup (line, &lstate, 25)) break;

			/* Switch States to let partner Know its his time to try */

			master_updateredimage(line);  /* Get Last update over */
			resClearCaAnswer(prestable[line]); /* Stop processing blocks */
			taskDelay(30);
			lstate = RES_SLVWANT;
			resPutLocalState(prestable[line],RES_SLVWANT);

			if (modrestrace[line]) {
			    date();
			    logMsg ("11] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);
			}
		        if (!once) {
		            printseqs(line);
		            once = TRUE;
		        }

			/* Give Him Access to the Hardware */
		        beslave(line); /* Make sure line is left for master */

			last_time = tickGet(); /* Remember the time of this try */
			for (i=0; (i<SLWWINDOW); i+=10) {

                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 26)) break;

			    taskDelay(10);

			    /* If he picked up let him have control */
			    if (pmod->is_responding)
			        checkstattime(line,lstate);	/* keep alive must continue */

			    resGetStates(prestable[line],&lstate,&pstate);

			    activity = ((remoteSerialRedund(serport) == 'M') && ((pstate == 0) || (pstate == RES_ISOLATED))) ;

			    if ( (pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity) ) {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (modrestrace[line]) {
				    date();
				    logMsg ("12] Became RES_SLV  P= %x A= %d \n",pstate,activity);
				}
				for (i=0;(i<7);i++) {
				    if (pmod->is_responding)
			    	        checkstattime(line,lstate);	/* keep alive must continue */
			    	    taskDelay(40);
				}
				break;
			    }
			}

                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 27)) continue;

			/* Go Back to Master and take control of hardware */
			if (lstate != RES_SLV) {
                    	    resresponse [line] = TRUE; 	/* Make Sure driver is responding   */
			    resSetCaAnswer(prestable[line]);
			    resPutLocalState(prestable[line],RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace[line]) {
				date();
				logMsg ("13] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			    }
			    bemaster(line); /* Make sure line is left for master */
			}


		    }
		}	

		pmod->holdflag = FALSE; 

	    }

	} /* end task loop */


     }



/************************************/
/* check for line group disablement */
/************************************/
static int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = qtmsResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum);
        }
        return (TRUE);
    }
    return (FALSE);
}




/*
** Try to bring a PLC on line
**
*/
static void    on_line(unsigned short line, unsigned short state)

    {
	QTMLINK  *pmod;
	unsigned short i,j,present,timerrunning;
	QTM_REGION	*pQtm_region;
	unsigned long	thistime,qtimer;

	pQtm_region = bases[line];
	pmod = plcs[line];

	thistime = tickGet();

	qtimer = getword(&pQtm_region->w_timer);
	if (pmod->lasttimervalue != qtimer) {
	    pmod->lasttimervalue = qtimer;
	    pmod->tickchecktime = tickGet();
	    timerrunning = TRUE;
	} else {
	    /* Must have at least one report and go for .5 seconds */
	    if (((thistime-pmod->tickchecktime) > 30) && (pmod->lasttimervalue != 0xffff))
		timerrunning = FALSE;
	}
	/* If the card is not there we must reinitialize the card */
	present = getword(&pQtm_region->w_present);
	if (( present != QRIOM_PRESENT) ||
	    ( !timerrunning) ||
	    (scanfail[line]) ) {

	    if (!initscanner(line))
		return;
	}

	if (state == RES_SLV) {
	    pmod->redundmsgtime = 0;
	    pmod->is_responding = TRUE;
	    return;
	}

	/* Give it time to talk to the drops */
	for (i=0;(i<6);i++) {
	    if (any_responding(line)) {

		pmod->redundmsgtime = 0;

		pmod->is_responding = TRUE;

		return;
	    }
	    taskDelay (10);
	}
	if ( (tickGet() - last_online_time[line]) > RESETTIME)
	    initscanner(line);
    }



/*
** bemaster(line)
**	enable connection of remote I/O cable
*/
static void    bemaster(unsigned short line)

    {
	QTMLINK  *pmod;

	pmod = plcs[line];

	if (!pmod->ammaster) {
	    lights[line] = QFAIL | QPASS;
	    pmod->ammaster = TRUE;
	    if (modtrace[line]) 
		    logMsg ("Changing Mode to master line = %d\n",line);
	    if (!qriomcmd(line,STARTUP,0,0))
		logMsg ("Start Command failed line = %d\n",line);

	}


    }



/*
** beslave(line)
**	enable connection of remote I/O cable
*/
static void    beslave(unsigned short line)

    {
	QTMLINK  *pmod;
	QTM_SREGION		*pQs;

	pmod = plcs[line];
	pQs = sbases[line];		/* short address space control registers */

	if (pmod->ammaster) {
	    lights[line] = QFAIL;
	    pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB));
	    pmod->ammaster = FALSE;
	    if (modtrace[line]) 
		    logMsg ("Changing Mode to slave line = %d\n",line);


	    if (!qriomcmd(line,SHUTDOWN,0,0))
		    logMsg ("Shutdown Command failed line = %d\n",line);

	}


    }

/*
** Scan a set of adapters -  get inputs an set outputs as required
**
*/

static	void    scan_plc (unsigned short line)

    {
	QTM_REGION		*pQtm_region;
	QTMLINK  		*pmod;
	QTM_SREGION		*pQs;
	unsigned short		present,qtimer,i,timerrunning;
	unsigned long		timedelta,thistime;
	unsigned char		*en,*ec;

	pmod = plcs[line];
	pQs = sbases[line];		/* short address space control registers */
	pQtm_region = bases[line];	/* standard address space card memory */


	/* Temporary Debug Code !!!!???? */
	if (modtrace[line] == 77)
		Qtminfo(0,1,1,1,1);

	/* Test the operating status word of link to see if adapter		  */
        /* status has changed */
	cur_op_stat[line] = (pQtm_region->status);
	if (cur_op_stat[line] != opstat[line]) {
		logMsg("Status change line %d - Old stat %x, new stat %x\n",
			    line,opstat[line], cur_op_stat[line]);
		opstat[line] = cur_op_stat[line];
	}

	/* Tell it to scan at least every 80 ms. but not more*/
	thistime = tickGet();
	if ((thistime-pmod->lastscantime) < MINTICKPERSCAN)
	    taskDelay(thistime-pmod->lastscantime);

	/* Set Scan Control to Interrupt after this scan */
	en = &pQtm_region->eos_irq_mult;
	ec = &pQtm_region->eos_control;
	pQtm_region->eos_control = EOS_WAIT_EN;
	pQtm_region->eos_irq_mult = 1;
	pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/

	for (i=0;(i < Qtmtries[line]);i++) {
	    Ireqs[line]++;
	    if (semTake(semids[line], CMDTIMEOUT) == ERROR) {
		if (modtrace[line] == 2)
		    logMsg("Line %x Scan command timeout\n",
				line);
		*en = 1;
		*ec = EOS_WAIT_EN;
	        pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/
		Idelay[line]++;
	    } else {
		pmod->scanrate = tickGet() - thistime;
		break;
	    }

	}

	if (i == Qtmtries[line]) {
		/* Device Failure */
	    logMsg("Line %x Scan command timeout Going Off-line, status = %x\n",
				line,
				cur_op_stat[line]);
	    scanfail[line] = TRUE;
	    pmod->is_responding = FALSE;
	    pmod->lasttimervalue = 0xffff;
	    if (was_resp[line])
		    pmod->no_offlines++;
	    was_resp[line] = FALSE;
	}
	pmod->lastscantime = thistime = tickGet();

	qtimer = getword(&pQtm_region->w_timer);
	if (pmod->lasttimervalue != qtimer) {
	    pmod->lasttimervalue = qtimer;
	    pmod->tickchecktime = tickGet();
	    timerrunning = TRUE;
	} else {
	    /* Must have at least one report and go for .5 seconds */
	    if (((thistime-pmod->tickchecktime) > 30) & (pmod->lasttimervalue != 0xffff))
		timerrunning = FALSE;
	    else timerrunning = TRUE;
	}
	/* Verify the card's state of health */
	/* Check card present */
	/* Check card status on-line bad config bad command */
	/* Check card timer word to change every .5 sec */
	present = getword(&pQtm_region->w_present);
	if ((present != QRIOM_PRESENT) ||
	    (!timerrunning) ) {

	    logMsg("Line %x Scan board failure - Going Off-line Present = %x, Status = %x, Timer Running = %s\n",
				line,
				present,
				pQtm_region->status,
				timerrunning?"Yes":"NO" );
	    pmod->is_responding = FALSE;
	    pmod->lasttimervalue = 0xffff;
	    if (was_resp[line])
		    pmod->no_offlines++;
	    was_resp[line] = FALSE;
	}

	/* Make sure the serial link says the backup is there */
	pmod->partnerresp = (remoteSerialRedund(serredport[line]) == 'S');

	if (!pmod->is_responding)
		return;	/* If board is gone don't poison other side */

	pmod->newoutput = FALSE;
	pmod->redund.mastercnt++;
	pmod->mycount = pmod->redund.mastercnt;
	master_updateredimage(line);
	pmod->redundmsgtime = thistime;
    }

/*
** Slave Scan a QTMS -  get inputs
**
*/
static	void    slave_scan(unsigned short line,unsigned short operate)

    {
	unsigned short  present,i, j,timerrunning;
	unsigned long   thistime,qtimer;
	QTMLINK		*pmod;
	QTM_SREGION	*pQs;
	QTM_REGION	*pQtm_region;

	pmod = plcs[line];
	pQtm_region = bases[line];
	pQs = sbases[line];		/* short address space control registers */

	/* Test the operating status word of link to see if adapter		  *
         * status has changed since the last time the scanner interrupted us. */
	cur_op_stat[line] = (pQtm_region->status);
	if (cur_op_stat[line] != opstat[line]){
		logMsg("Status change line %d - Old stat %x, new stat %x\n",
			    line,opstat[line], cur_op_stat[line]);
		opstat[line] = cur_op_stat[line];
	}

	thistime = tickGet();

	qtimer = getword(&pQtm_region->w_timer);
	if (pmod->lasttimervalue != qtimer) {
	    pmod->lasttimervalue = qtimer;
	    pmod->tickchecktime = tickGet();
	    timerrunning = TRUE;
	} else {
	    /* Must have at least one report and go for .5 seconds */
	    if (((thistime-pmod->tickchecktime) > 30) & (pmod->lasttimervalue != 0xffff))
		timerrunning = FALSE;
	    else timerrunning = TRUE;
	}

	/* Verify the card's state of health */
	/* Check card present */
	/* Check card status on-line bad config bad command */
	/* Check card timer word to change every .5 sec */
	present = getword(&pQtm_region->w_present);
	if ((present != QRIOM_PRESENT) ||
	    (!timerrunning) ) {

	    logMsg("Line %x Scan board failure - Going Off-line Present = %x, Status = %x\n",
				line,
				present,
				pQtm_region->status );
	    pmod->is_responding = FALSE;
	    pmod->lasttimervalue = 0xffff;
	    if (was_resp[line])
		    pmod->no_offlines++;
	    was_resp[line] = FALSE;
	}

	if (pmod->partnercount != pmod->redund.mastercnt) {
          pmod->partnercount = pmod->redund.mastercnt;
	    pmod->partnerresp = TRUE;
          pmod->redundmsgtime = thistime;
	} else {
	    if ((thistime > (pmod->redundmsgtime + (Qtmsredperiod[line]*4))) && (pmod->partnerresp)) {
	        if (modtrace[line]) 
		        logMsg ("Partner Count update timed out\n");
	        pmod->partnerresp = FALSE;
	    }
	}

	/* Am I trying to take control ? */
	if (!operate)
		return;
	/* Enable the card to scan and wait for the End of Scan Interrupt */
	pQtm_region->eos_irq_mult = 1;
	pQtm_region->eos_control = EOS_WAIT_EN;
	pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/

	for (i=0;(i < Qtmtries[line]);i++) {
	    Ireqs[line]++;
	    if (semTake(semids[line], CMDTIMEOUT) == ERROR) {
		logMsg("Line %x Scan command timeout\n",
				line);
		pQtm_region->eos_irq_mult = 1;
		pQtm_region->eos_control = EOS_WAIT_EN;
		pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/
		Idelay[line]++;
	    } else {
		pmod->scanrate = tickGet() - thistime;
		break;
	    }
	}

	if (i == Qtmtries[line]) {
		/* Device Failure */
	    scanfail[line] = TRUE;
	    logMsg("Line %x Scan command timeout Going Off-line, status = %x\n",
				line,
				cur_op_stat[line]);
	    pmod->is_responding = FALSE;
	    pmod->lasttimervalue = 0xffff;
	    if (was_resp[line])
		    pmod->no_offlines++;
	    was_resp[line] = FALSE;
	}

	pmod->lastscantime = thistime = tickGet();

    }

/*
** master_updateredimage(line)
**      updates the image to send to the slave in case of fail over
**
*/
static	void master_updateredimage(unsigned short line)

    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,card;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;
	unsigned short	i, maxrack, maxcard; 
	unsigned short	outix;

	pmod = plcs[line];

	pQtm_region = bases[line];

	drvRedTake(redsemids[line]); 

	/* Fill in the header */
	pmod->redund.line = line;
	pmod->redund.mastercnt = pmod->mycount;

	/* Fill in the drop sequence numbers */
	for (i=0;(i<MAX_DROPS);i++) {
	    pdrop = &pQtm_region->drop[i];
	    if (pmod->drops[i].was_defined) {
		pmod->redund.seqs[i] = pdrop->last_seq;
		pmod->redund.state[i] = pdrop->state;
		pmod->redund.status[i] = pdrop->status;
	    } else {
		pmod->redund.state[i] = 0;
		pmod->redund.seqs[i] = 0;
		pmod->redund.status[i] = pdrop->status;
	    }
	}
	outix = 0;
	/* Fill in and count the output module data structures */
	for (drop=0;(drop<MAX_DROPS);drop++) {
	    if (!pmod->drops[drop].was_defined)
		continue;
	    pdrop = &pQtm_region->drop[i];

	    maxrack = pmod->drops[drop].is_quantum?1:MAX_RACKS;
	    maxcard = pmod->drops[drop].is_quantum?MAX_QSLOTS:MAX_SLOTS;

	    for (rack = 0;(rack<maxrack);rack++) {
		for (card = 0;(card<maxcard);card++) {
		    /* Has there been a card defined here */
		    pslot = pmod->drops[drop].racks[rack].mods[card];
		    if (!pslot)
			    continue;
		    /* See what type of card it is */
		    switch (pslot->mp->type) {
			case DO8:
			case DO16:
			case DO32:
			case AO:
			    pmod->redund.outs[outix].drop = drop;
			    pmod->redund.outs[outix].rack = rack;
			    pmod->redund.outs[outix].card = card;
			    pmod->redund.outs[outix].type = pslot->mp->id;
			    for (i=0;(i<=pslot->mp->outbyte);i++) {
				pmod->redund.outs[outix].data[i] = pslot->outdata[i];
			    }
			    outix++;
			    if (outix >= MAXUPDS ) {
				logMsg ("Too many output modules defined for redundancy \n");
				return;
			    }
			    break;
			/* Inputs require no processing */
			case DI8:
			case DI16:
			case DI32:
			case AICUR:
			case AIVOLT:
			case AITC:
			case AIRTD:
			default:
			    break;
		    }
		}
	    }
	}
	/* set number of structures */
	pmod->redund.outcount = outix;

	drvRedGive(redsemids[line]); 
   }

/*
** 	slave_updateredimage(line,bufptr,size)
**      updates the image to output if we become master
**
*/
static	void 	slave_updateredimage (unsigned short line ,QTMSREDUPD *redbuf, int size)

    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,card;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;
	unsigned short	i, maxrack, maxcard; 
	unsigned short	outix;


	pmod = plcs[line];

	pQtm_region = bases[line];

	if (size != redsize[line]) {
		if (modtrace[line])
		    logMsg ("Redundant update size mismatch Mine = %d, Partner = %d\n",
				redsize[line],
				size );
		pmod->redund.mastercnt = 0;
		return;
	}
	/* Verify the line number in the message */
 	if (redbuf->line != line) {
		if (modtrace[line])
		    logMsg ("Redundant update Line number mis match Mine = %d, Partner = %d\n",
				line,
				redbuf->line );
		return;
	}

	/* Fill in the drop sequence numbers */
	for (i=0;(i<MAX_DROPS);i++) {
	    pdrop = &pQtm_region->drop[i];
	    if (pmod->drops[i].was_defined) {
		putword(&pdrop->w_activity, HOLDUPTIME);
		pdrop->last_seq = redbuf->seqs[i];
		pdrop->state = redbuf->state[i];
		pdrop->status = redbuf->status[i];
	    }
	}

	/* Verify not too many updates */
	if (redbuf->outcount >= MAXUPDS ) {
	    logMsg ("Too many output updates set by master \n");
	    return;
	}

	/* cycle throug the output board updates */
	for (outix = 0;(outix < redbuf->outcount);outix++) {
	    drop = redbuf->outs[outix].drop;
	    rack = redbuf->outs[outix].rack;
	    card = redbuf->outs[outix].card;

	    /* Verify the module types match */
	    pslot = pmod->drops[drop].racks[rack].mods[card];
	    if (!pslot) {
		if (modtrace[line])
		    logMsg ("Redundant update message for undefined module line = %d, drop = %d, rack = %d, card = %d\n",
				line,
				drop,
				rack,
				card );
		continue;
	    }

	    if (redbuf->outs[outix].type != pslot->mp->id) {
		if (modtrace[line])
		    logMsg ("Redundant update message for mismatched module line = %d, drop = %d, rack = %d, card = %d\n",
				line,
				drop,
				rack,
				card );
		continue;
	    }


	    /* See what type of card it is */
	    switch (pslot->mp->type) {
		case DO8:
		case DO16:
		case DO32:
		case AO:
		    for (i=0;(i<=pslot->mp->outbyte);i++) {
			pslot->outdata[i] = redbuf->outs[outix].data[i];
		    }
		    break;
		/* Inputs require no processing */
		case DI8:
		case DI16:
		case DI32:
		case AICUR:
		case AIVOLT:
		case AITC:
		case AIRTD:
		default:
		    if (modtrace[line])
			logMsg ("Redundant update message for unknown or input module line = %d, drop = %d, rack = %d, card = %d\n",
				line,
				drop,
				rack,
				card );
		    break;
	    }
	}

	pmod->redund.mastercnt = redbuf->mastercnt;


    }

/*
** Routine to print sequnence numbers
**
*/

static void printseqs(unsigned short line)

    {
	QTMLINK  		*pmod;
	QTM_REGION		*pQtm_region;
	unsigned short i,hold;
	unsigned char  seq,state,status;
	struct drop_str	*pdrop;

	pmod = plcs[line];
	pQtm_region = bases[line];

	date();
	for (i=0;(i<MAX_DROPS);i++) {
	    pdrop = &pQtm_region->drop[i];
	    if (pmod->drops[i].was_defined) {

		hold = getword(&pdrop->w_activity);
		seq = pdrop->last_seq;
		state = pdrop->state;
		status = pdrop->status;
		printf ( "Drop = %d, Hold Time = %d, Seq# = %d, State = %d, Status = %d \n",
				i,
				hold,
				seq,
				state,
				status );
	    }
	}

    }


/*
** checkstattime
**      checks checks to see if its time to request configuration status to keep the board alive
**
*/
static	void checkstattime(unsigned short line, unsigned short mode)

    {
	unsigned long   thistime;
	unsigned char	mchar;
	QTMLINK  *pmod;

	pmod = plcs[line];
	thistime = tickGet();
	switch (mode) {
	    case RES_SLV:
		mchar = 'S';
		break;
	    case RES_MSTR:
		mchar = 'M';
		break;
	    case RES_SLVWANT:
		mchar = 'W';
		break;
	    case RES_SLVWANTCA:
		mchar = 'S';
		break;
	    case 0:
	    default:
		return;
		break;
	}

 	if ((thistime-serredupdtime[line]) > (serredperiod[line])/4) {
	    serredupdtime[line] = thistime;
	    pulseSerialRedund(serredport[line], mchar);
	}
   }

/*
**      aidriver
**
**      This routines main purpose is to return the analog input value for the
**      specified module. For a module value
**      a (-1) will be returned if there is no valid data ready.
**
*/
int vQtm_aidriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short signal, 
		 short *pvalue, unsigned short conversion,unsigned short gain,
		 unsigned short ctype, unsigned char *resname)

    {
	QTMLINK  		*pmod;
	unsigned short  	present,drop,rack,slot;
	unsigned short 		adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str		*pdrop;
	MODULE			*pslot;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LINES) {
	    return (-1);
	}

	pmod = plcs [link];


	/* Make pointer to card memory */
	pQtm_region = bases[link];

	xsignal = signal;

	if (xadapter == QTMSCANNER) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    switch (xsignal) {

	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 3: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 4: /* What is the partner count for the line */
		*pvalue = pmod->partnercount & 0x7fff;
		break;

            case 5: /* What is my count for the line */
                *pvalue = pmod->mycount & 0x7fff;
		break;

            case 6: /* What is last scan rate in ticks */
                *pvalue = pmod->scanrate & 0x7fff;
		break;

	    case 7: /* Card Present Word */
		present = getword(&pQtm_region->w_present);
		*pvalue = present;
		break;

	    case 8: /* Rx Packets */
		*pvalue = getword(&pQtm_region->w_rx_count) & 0x7fff;
		break;

	    case 9: /* Tx Packets */
		*pvalue = getword(&pQtm_region->w_tx_count) & 0x7fff;
		break;

	    case 10: /* Err Packets */
		*pvalue = getword(&pQtm_region->w_err_count) & 0x7fff;
		break;

	    case 11: /* Card Status */
		*pvalue = pQtm_region->status;
		break;

	    case 12: /* Timer */
		*pvalue = getword(&pQtm_region->w_timer) & 0x7fff;
		break;

	    default:

		return (-1);
	    }
	    return (0);
	}

	if (xadapter == QTMADAPTER) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    /* Looking for drop information */
	    if ((xcard-1) >= MAX_DROPS)
		return(-1);

	    pdrop = &pQtm_region->drop[xcard-1];

	    switch (xsignal) {

		case 0: /* Drop  values requested */
		    *pvalue = pmod->drops[xcard-1].was_defined;
		    break;

		case 1: /* Drop  is online */
		    *pvalue = (pdrop->status & ONLINE);
		    break;

		case 2: /* Drop has valid configuration */
		    *pvalue = (pdrop->status & CFG_VALID);
		    break;

		case 3: /* Drop Status */
		    *pvalue = pdrop->status;
		    break;

		case 4: /* Drop Activity Timer */
		    *pvalue = getword(&pdrop->w_activity) & 0x7fff;
		    break;

		case 5: /* Drops last sequence number */
		    *pvalue = pdrop->last_seq;
		    break;

		case 6: /* Drop state */
		    *pvalue = pdrop->state;
		    break;

		case 7: /* Drop retry counter */
		    *pvalue = getword(&pdrop->w_retries) & 0x7fff;
		    break;

		default:

		    return (-1);
	    }
	    return(0);
	}

	if (xadapter == QTMCARD) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    drop = (xcard/1000)-1;
	    slot = (xcard % 100)-1;
	    rack = ((xcard/100)%10);

	    if ((drop >= MAX_DROPS) ||
		  (rack >= MAX_RACKS) ||
		  (slot >= MAX_QSLOTS))
		return(-1);


	    /* Looking for Module Defined ? */
	    pslot = pmod->drops[drop].racks[rack].mods[slot];
	    if ((pslot == NULL) && (xsignal == 0)) {
		    *pvalue = 0;
		    return (0);
	    }

	    if (pslot == NULL)
		return (-1);

	    pdrop = &pQtm_region->drop[drop];
	    switch (xsignal) {

		case 0: /* Was defined */
		    *pvalue = 1;
		    break;

		case 1: /* Board Type */
		    *pvalue = pslot->mp->id;
		    break;

		case 2: /* Module Health */
		    *pvalue = (pdrop->health[(rack*2)+(slot/8)]& rbmasks[slot%8])?1:0;
		    break;

		default:
		    return (-1);
	    }
	    return(0);
	}

	xsignal = signal-1;

	drop = (xadapter)-1;
	slot = (xcard % 100)-1;
	rack = (xcard/100);

	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}

	pslot = pmod->drops[drop].racks[rack].mods[slot];

	/* Verify the definition of module card type and gain */
	/* Can update gain */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog input card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot+1);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig)
		return (-1);

	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog input card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot+1);
	    return (-1);
	}

	if (pslot->gains[xsignal] != gain) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog input signal gain redefinition - line %d, drop %d, rack %d, slot %d, signal %d\n",
				    link,drop+1,rack,slot+1,signal);
	    pslot->gains[xsignal] = gain;
	    toutinit(pmod,pslot);
	}

	if (conversion != conversion) {
	    return (-1);		/* No warnings */
	}

	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if (!pmod->is_responding) return (-1);

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);
	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	/* Set up to return the value */
	/* Endian */
	*pvalue = (pslot->indata[xsignal*2]<<8) + ((pslot->indata[(xsignal*2)+1])); 
	/* Verify the point is not out of range */
	if ((pslot->indata[17] & smasks[xsignal]) != 0)
	    *pvalue = 0xDEAD;
	return (0);

    }



/*
**      vQtm_aodriver
**
**      This routines main purpose is to set requested analog outputs to the
**      specified module.
*/
int vQtm_aodriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard, unsigned short signal, double dvalue,
		 unsigned short value, unsigned short conversion,
		 unsigned short ctype, unsigned char *resname)

    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,slot;
	unsigned short 	adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;


	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LINES) {
	    return (-1);
	}

	pmod = plcs [link];

	/* Make pointer to card memory */
	pQtm_region = bases[link];

	xsignal = signal;

	/* Range check rack and card */

	xsignal = signal - 1;

	drop = (xadapter)-1;
	slot = (xcard % 100)-1;
	rack = (xcard/100);

	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}

	pslot = pmod->drops[drop].racks[rack].mods[slot];


	/* Verify the definition of module card type */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog output card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot+1);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig)
	    return(-1);

	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog output card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop,rack,slot+1);
	    return (-1);
	}


	/* At this point only physical I/O is being addressed */
	pmod->was_requested = TRUE;


	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);

	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	pmod->no_dataout_msgs++;

	/* Place data in output block a set flag */
	/* endian */
	pslot->outdata[(xsignal*2)+1] = (value & 0xff);
	pslot->outdata[(xsignal*2)] = ((value >>8) & 0xff); 
	pmod->newoutput = TRUE;
	return (0);

    }


/*
**      vQtm_aoread
**
**      This routines main purpose is to return the value last read back
**      from the analog output hardware. This is used to initialize analog
**      outputs.
*/
int vQtm_aoread( char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short signal,
		 unsigned short *pvalue, unsigned short linr,
		 unsigned short ctype, unsigned char *resname)

    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,slot;
	unsigned short 		adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str		*pdrop;
	MODULE			*pslot;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LINES) {
	    return (-1);
	}

	pmod = plcs [link];

	/* Make pointer to card memory */
	pQtm_region = bases[link];

	/* Range check rack and card */

	xsignal = signal - 1;
	drop = (xadapter)-1;
	slot = (xcard % 100)-1;
	rack = (xcard/100);

	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}

	pslot = pmod->drops[drop].racks[rack].mods[slot];

	/* Verify the definition of module card type */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog output card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig)
		return (-1);

	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Analog output card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot);
	    return (-1);
	}


	/* At this point only physical I/O is being addressed */
	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);

	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	/* Place data in output block a set flag */
	/* endian */
	*pvalue = (pslot->outdata[(xsignal*2)+1]) + ((pslot->outdata[(xsignal*2)])<<8); 
	return (0);
    }


/*
**      vQtm_bidriver
**
**      The main purpose of this routine is to return the request digital input
**      value(s) from the requested card. This routine will return a (-1) if the
**      requested module is the wrong type or the data is not yet valid.
**
*/

int vQtm_bidriver(char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short signal,
		 unsigned long mask,unsigned long *pvalue,
		 unsigned short ctype, unsigned char *resname)

    {
	QTMLINK  		*pmod;
	unsigned short  	present,drop,rack,slot;
	unsigned short 	adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;
	unsigned long tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LINES) {
	    return (-1);
	}

	pmod = plcs [link];


	/* Make pointer to card memory */
	pQtm_region = bases[link];

	xsignal = signal;

	if (xadapter == QTMSCANNER) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    card = xcard;
	    switch (xsignal) {

	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* Is the master sending updates */
		*pvalue = pmod->partnerresp;
		break;

	    case 3: /* Card Present Word */
		present = getword(&pQtm_region->w_present);
		*pvalue = (present==QRIOM_PRESENT)?1:0 ;
		break;

	    case 4: /* Card Status - On-Line*/
		*pvalue = (pQtm_region->status & ONLINE);
		break;

	    case 5: /* Card Status - BADCONFIG*/
		*pvalue = (pQtm_region->status & BADCONFIG);
		break;

	    case 6: /* Card Status - DATA_CHANGE*/
		*pvalue = (pQtm_region->status & DATA_CHANGE);
		break;

	    case 7: /* Card Status - CFG_VALID*/
		*pvalue = (pQtm_region->status & CFG_VALID);
		break;

	    case 8: /* Card Status - TIMEOUT*/
		*pvalue = (pQtm_region->status & TIMEOUT);
		break;


	    default:

		return (-1);
	    }
	    return (0);
	}

	if (xadapter == QTMADAPTER) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    /* Looking for drop information */
	    if ((xcard-1) >= MAX_DROPS)
		return(-1);

	    pdrop = &pQtm_region->drop[xcard-1];

	    switch (xsignal) {

		case 0: /* Drop  values requested */
		    *pvalue = pmod->drops[xcard-1].was_defined;
		    break;

	        case 1: /* Card Status - On-Line*/
		    *pvalue = (pdrop->status & ONLINE);
		    break;

	        case 2: /* Card Status - BADCONFIG*/
		    *pvalue = (pdrop->status & BADCONFIG);
		    break;

	        case 3: /* Card Status - DATA_CHANGE*/
		    *pvalue = (pdrop->status & DATA_CHANGE);
		    break;

	        case 4: /* Card Status - CFG_VALID*/
		    *pvalue = (pdrop->status & CFG_VALID);
		    break;

	        case 5: /* Card Status - TIMEOUT*/
		    *pvalue = (pdrop->status & TIMEOUT);
		    break;

		case 6: /* Drop state */
		    *pvalue = (pdrop->state << (31 - (xsignal % 32)));
		    break;

		default:

		    return (-1);
	    }
	    return(0);
	}

	if (xadapter == QTMCARD) {

	    if (!pmod->init_complete) {
	        return (-1);
	    }

	    drop = (xcard/1000)-1;
	    slot = (xcard % 100)-1;
	    rack = ((xcard / 100)%10);

	    if ((drop >= MAX_DROPS) ||
		  (rack >= MAX_RACKS) ||
		  (slot >= MAX_QSLOTS))
		return(-1);

	    /* Looking for Module Defined ? */
	    pslot = pmod->drops[drop].racks[rack].mods[slot];
	    if ((pslot == NULL) && (xsignal == 0)) {
		    *pvalue = 0;
		    return (0);
	    }

	    if (pslot == NULL)
		return (-1);

	    pdrop = &pQtm_region->drop[drop];
	    switch (xsignal) {

		case 0: /* Was defined */
		    *pvalue = mask;
		    break;

		case 2: /* Module Health */
		    *pvalue = (pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8])?mask:0;
		    break;

		case 3: /* Board Type */
		    *pvalue = (pslot->mp->id << (31 - (xsignal % 32)));
		    break;

		default:
		    return (-1);
	    }
	    return(0);
	}

	xsignal = signal-1;

	drop = (xadapter)-1;
	slot = (xcard % 100 )-1;
	rack = (xcard/100);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}

	pslot = pmod->drops[drop].racks[rack].mods[slot];

	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);



	/* Verify the definition of module card type */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital input card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop,rack,slot+1);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig) 
		return(-1);

	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital input card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop,rack,slot+1);
	    return (-1);
	}

	pmod->was_requested = TRUE;

	if (!resresponse[link])
		 return (-1);
	if (pmod->holdflag)
		 return (-2);
	if (!pmod->is_responding)
		 return (-1);

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);

	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	tvalue = (pslot->indata[0]);
	tvalue = (tvalue << 8)+(pslot->indata[1]);
	tvalue = (tvalue << 8)+(pslot->indata[2]);
	tvalue = (tvalue << 8)+(pslot->indata[3]);
	*pvalue = (tvalue & mask);
	return (0);

    }


/*
**      vQtm_bodriver
**
**      The main purpose of this routine is to set the request digital output
**      value(s) on the requested card. This routine will return a (-1) if the
**      requested module is the wrong type or not configured yet.
**
*/
int vQtm_bodriver (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard,unsigned short signal,
		 unsigned long value, unsigned long mask,
		 unsigned short ctype, unsigned char *resname)


    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,slot;
	unsigned short 	adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;
	unsigned long tvalue;


	if (!plcs [link]) {
	    return (-1);
	}

	pQtm_region = bases[link];

	if (link >= LINES) {
	    return (-1);
	}

	pmod = plcs [link];


	if (xadapter == QTMSCANNER) {
	    switch (signal) {

	    case 2: /* Reset the scanners accumulated statistics */
		if (value != 0) initstats(pmod);
		break;

	    case 3: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0 ) {
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
			  pmod->lasttimervalue = 0xffff;
		    }
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	xsignal = signal-1;

	drop = (xadapter-1);
	slot = (xcard % 100)-1;
	rack = (xcard / 100);


	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}


	pslot = pmod->drops[drop].racks[rack].mods[slot];


	/* Verify the definition of module card type */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital input card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot+1);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig)
		return (-1);

	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital output card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop+1,rack,slot+1);
	    return (-1);
	}

	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if (pmod->holdflag) return (-2);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);

	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	pmod->no_dataout_msgs++;

	if (pslot->mp->maxsig > 16) {
	    tvalue = (pslot->outdata[0]);
	    tvalue = (tvalue << 8)+(pslot->outdata[1]);
	    tvalue = (tvalue << 8)+(pslot->outdata[2]);
	    tvalue = (tvalue << 8)+(pslot->outdata[3]);

	    tvalue = ((tvalue & (~mask)) | value );

	    pslot->outdata[3] = (tvalue & 0xff);
	    pslot->outdata[2] = (tvalue >> 8) & 0xff;
	    pslot->outdata[1] = (tvalue >> 16) & 0xff;
	    pslot->outdata[0] = (tvalue >> 24) & 0xff;

	    pmod->newoutput = TRUE;

	    return (0);
	} else {
	    tvalue = (pslot->outdata[0]);
	    tvalue = (tvalue << 8)+(pslot->outdata[1]);
	    tvalue <<= 16;

	    tvalue = ((tvalue & (~mask)) | value );

	    tvalue >>= 16;
	    pslot->outdata[1] = (tvalue & 0xff);
	    pslot->outdata[0] = (tvalue >> 8) & 0xff;

	    pmod->newoutput = TRUE;

	    return (0);
	}

	return (-1);

    }


/*
**      vQtm_boread
**
**      This routines main purpose is to return the value last read back
**      from the digital output hardware. This is used to initialize digital
**      outputs. This will return a (-1) if the module is the wrong type or
**      the data is not yet valid
*/
int vQtm_boread (char *pname, unsigned short link, unsigned short xadapter,
		 unsigned short xcard, unsigned short signal,
		 unsigned long *pvalue, unsigned long mask,
		 unsigned short ctype, unsigned char *resname)

    {
	QTMLINK  		*pmod;
	unsigned short  	drop,rack,slot;
	unsigned short 	adapter,card,xsignal;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	MODULE		*pslot;
	unsigned long tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	pQtm_region = bases[link];

	if (link >= LINES) {
	    return (-1);
	}


	pmod = plcs [link];

	if (xadapter == QTMSCANNER) {
	    switch (signal) {

	    case 2: /* Reset the scanners accumulated statistics */
		*pvalue = 0;
		break;

	    case 3: /* Force the PLC offline */
		*pvalue = 0;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}


	/* Range check rack and card */

	xsignal = signal-1;

	drop = (xadapter)-1;
	slot = (xcard % 100)-1;
	rack = (xcard / 100);

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (!pmod->init_complete) {
	    return (-1);
	}

	pslot = pmod->drops[drop].racks[rack].mods[slot];

	if ((drop >= MAX_DROPS) ||
	    (rack >= MAX_RACKS) ||
	    (slot >= MAX_QSLOTS) )
		return(-1);



	/* Verify the definition of module card type */
	if (pslot == NULL) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital input card not defined - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop,rack,slot+1);
	    return (-1);
	}

	if (xsignal >= pslot->mp->maxsig)
	    return (-1);


	if (pslot->mp->id != ctype) {
	    if (modtrace[link] >1 ) 
		logMsg ("Digital output card type mismatch - line %d, drop %d, rack %d, slot %d  \n",
				    link,drop,rack,slot+1);
	    return (-1);
	}


	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if (pmod->holdflag) return (-2);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	pdrop = &pQtm_region->drop[drop];

	/* Verify the drop is on-line */
	if ( ((pdrop->status & ONLINE) == 0) )
		return (-1);

	/* Verify that the module health bit is ok */
	if ((pdrop->health[(rack*2)+(slot/8)] & rbmasks[slot%8]) == 0)
		return (-1);

	tvalue = (pslot->outdata[0]);
	tvalue = (tvalue << 8)+(pslot->outdata[1]);
	tvalue = (tvalue << 8)+(pslot->outdata[2]);
	tvalue = (tvalue << 8)+(pslot->outdata[3]);
	*pvalue = (tvalue & mask);

	return (0);
    }

/*
** register_resource                                                              	
**                                                                                	
**	This routine is used to initialize the resource pointers                  	
**  If this is the first time the resource for this line is being                  	
**  referenced the pointer to the resource table entry will be set                  	
**  and the resource name will be saved. If the resource name has                       
**  already been set, this routine will verify that all other points                 	
**  for this driver are using the same resource name.                                	
**                                                                                   	
*/                                                                                    	
static void  register_resource (unsigned short link, QTMLINK *pmod,
                                unsigned char *resname, char *pointname)
    {

    int group;

	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else
            {
                strcpy(resnames[link], resname);
                group = qtmsResGroups [link];
                if (group)
                {
                    if (assignLockGroup (group, resname) == ERROR)
                    {
                        logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                                 link, group, pointname, resname);
                    }
                }
            }
	}
	else
	{
	    if (strcmp(resnames[link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
    }




/*
**      init_line_tabs
**
**      The purpose of this routine is to initialize the line tables for the
**      Allen Bradley Scanner
**
*/
static	void init_line_tabs(unsigned short line)

    {

	unsigned short  drop,rack,mod,card;
	QTMLINK  *pmod;

	pmod = plcs[line];

	pmod->redund.mastercnt = 0;

	pmod->was_requested = FALSE;
	pmod->init_complete = FALSE;
	pmod->is_responding = FALSE;
	pmod->lastscantime = 0;
	pmod->lasttimervalue = 0xffff;
	pmod->holdflag = FALSE;
	pmod->cmd_reset_stat = FALSE;
	pmod->cmd_force_offline = FALSE;

	pmod->partnerstate = 0;
	pmod->partnercount = 0;
	pmod->partnerresp = FALSE;
	pmod->mycount = 0;
	pmod->ammaster = FALSE;

	
	pmod->tickchecktime = 0;
	pmod->redundmsgtime = 0;
	pmod->newoutput = FALSE;


	pmod->enbcj = enbcj[line];
	pmod->extcj = extcj[line];

	pmod->lastdropmask = 0;

	for (drop=0; (drop<MAX_DROPS); drop++) {
	    pmod->drops[drop].was_defined = FALSE;
	    pmod->drops[drop].is_quantum = FALSE;
	    pmod->drops[drop].nummods = 0;

	    for (rack = 0;(rack<MAX_RACKS);rack++) {
		for (card = 0;(card<MAX_QSLOTS);card++) {
		    pmod->drops[drop].racks[rack].mods[card] = NULL;
		}
	    }
	}
	initstats(pmod);

	/* Initialize this tasks semaphore*/
	semids[line] = semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);


    }


char	qriomdir[80] = "BBM:";
/*
**	Q984setdir( "directory")
**
*/
Q984setdir (char *directory)

	{
		if (strlen (directory) > 60 ) {
		    logMsg("Invalid directory name (too long) \n");
		    return (0);
		}
		strncpy(&qriomdir[0], directory, 60);
		return (0);
	}





/*
**
** initialize the statistics
**
*/

static	void initstats(QTMLINK *pmod)

   {
	pmod->no_dataout_msgs = 0;      /* 5  Count Output Msgs */
	pmod->no_offlines = 0;		  /* 14 Count Off Line Transitions */
	pmod->scanrate = 0;		  /* 6 Scan rate */

   }




/*
**	init the scanner card
** 	establish the communication line with the QTM scanner
*/
static initscanner(unsigned short line)

    {
	QTM_SREGION		*pQs;
	QTM_REGION		*pQtm_region;
	unsigned char		buffer[80];
	unsigned char		*pbuffer = &buffer[0];
	unsigned char		ch,*pcmem;
	unsigned short		present,thismod,length;
	short			loc,mods,ptype,btype,started,j,k;
	unsigned short		drop,rack,card,slot,signal;
	unsigned long		i;
	char			*pfirmware_info;
	QTMLINK  		*pmod;
	MODULE			*pslot;
	struct drop_str		*pdrop;
	struct module_str	*pqmod;
	unsigned char		resetvec[] = {0xea,0x00,0x00,0x40,0x00};
	FILE			*fp;
	GAIN_TABLE		*pg;
	unsigned short		ref = 1;

	/* Initialize the Interrupt Vector */

	intConnect((vectors[line]*4),(FUNCPTR)vQtm_int_proc,line);
	sysIntEnable(QTMSINTLEV); 


	pQs = sbases[line];		/* short address space control registers */
	pQtm_region = bases[line];	/* standard address space card memory */
	pcmem = (char *)membases[line];

	/* Pulse Reset and turn off fail led */
	lights[line] = QFAIL;
/*	pQs->ctl_stat = ((lights[line] | QRUN_V40));      */

	pQs->ctl_stat = (lights[line]);
	taskDelay(((HOLDUPTIME*10)/60)+180);	/* 3 seconds longer than the drop hold time */

	/* Set the standard address space memory pointer */
	pQs->lbase = (((long)bases[line]>>16) | SRUN);

	/* Clear the Interrupt vector id */
	pQs->intid = (0);


	/* test memory at load address */
	for (i=0; (i<=255); i++) {
	    pcmem[0x400] = i;
	    if (pcmem[0x400] != i) {
		logMsg ("Line %d Quantum Interface Card failed memory test \n",line);
		return (FALSE);
	    }
	}

	/* Clear all of the memory */
	for (i=0;(i<0x20000);i++) {
	    pcmem[i] = 0;
	    if (pcmem[i] != 0) {
		logMsg ("Line %d Quantum Interface Card failed to clear memory \n",line);
		return (FALSE);
	    }
	}
	
	/* make file name - open file and load memory */
	iam(user,password);
	buffer[0] = 0;
	strcpy (pbuffer, qriomdir);
	if (!monitor908[line]) {
	    strcat (pbuffer, "qriom.bin");
	    if ((fp = fopen(pbuffer,"r"))== NULL) {
	        logMsg("Could not open QTM Scanner Program File qriom.bin \n");
	        return (FALSE);
	    }
	} else {
	    strcat (pbuffer, "mon.bin");
	    if ((fp = fopen(pbuffer,"r"))== NULL) {
	        logMsg("Could not open QTM Scanner Monitor Program File mon.bin \n");
	        return (FALSE);
	    }

	}

	/* read the file into the cards memory starting at location 0x400 */
	loc = 0x400;
	ch = getc(fp);
	while (!feof(fp)) {
	    pcmem[loc] = ch;
	    if (pcmem[loc] != ch) {
		logMsg ("Line %d Quantum Interface Card failed memory test \n",line);
		fclose(fp);
		return (FALSE);
	    }
	    loc++;
	    ch = getc(fp);
	}

	fclose(fp);

	/* load the reset vector into the begining of card memory */
	for (i=0; (i<5); i++) {
	    pcmem[i] = resetvec[i];
	    if (pcmem[i] != resetvec[i]) {
		logMsg ("Line %d Quantum Interface Card failed memory test \n",line);
		return (FALSE);
	    }
	}

	/* Start the card Running */
	pQs->ctl_stat = ((lights[line] | QRUN_V40)); /*End*/

	/* Set the Interrupt vector id */
	pQs->intid = (vectors[line]);


	/* The monitoring function should be working now */
	if (monitor908[line]) {
	    for(;;) {
		logMsg ( "Line %d is now in monitor mode\n",line);
		taskDelay(1800);
		if (!monitor908[line])
		    return FALSE;
	    }
	}

	/* Wait for the card to initialize */
	started = FALSE;
	for (i=0; (i<20); i++) {
	    taskDelay(15);
	    /* Look for the startup code */
	    present = getword(&pQtm_region->w_present);
	    if (present == QRIOM_PRESENT) { /* End */
		started = TRUE;
		break;
	    }
	}
	if (!started) {
	    logMsg ("Line %d failed to initialize \n",line);
	    return(FALSE);
	}

	pmod = plcs[line];
	pfirmware_info = &pmod->firmwareinfo[0];
	
	strncpy(pfirmware_info,pQtm_region->version,11);

	logMsg("Line %x, powerup...\n",line);
	/* on initialization the scanner puts its firmware revision info	*/
	/* into the general data are of the dual-port.  We save it here. 	*/
	logMsg("Line %x f/w = :\n\t%s\n",line,pmod->firmwareinfo);

	opstat[line] = (pQtm_region->status);

	logMsg("Link %x, initial operating status word = %x\n",line,opstat[line]);	

	pg = buildGainTable();
	if (pg == NULL)
		return (FALSE);
	/* build configuration table from database */
	/* loop throught the table we just gathered */
	for (i = 0; (i<2000),(pg[i].pointType != NULL);i++) {
	    /* ignore units not on this line */
	    if (pg[i].line != line)
		continue;
	    drop =  pg[i].addr-1;
	    rack = (pg[i].card / 100);
	    slot = (pg[i].card % 100)-1;
	    signal = pg[i].signal;
	    /* verify numbers work */
	    if (  (drop >= MAX_DROPS) ||
		  (rack >= MAX_RACKS) ||
		  (slot >= MAX_QSLOTS)) {
		if ((pg[i].addr == QTMSCANNER) ||
		    (pg[i].addr == QTMADAPTER) ||
		    (pg[i].addr == QTMCARD) )
			continue;
		logMsg ("Invalid I/O address L=%d,A=%d,C=%d,S=%d \n",
				line,
				pg[i].addr,
				pg[i].card,
				pg[i].signal );
		continue;
	    }

	    /* Search for the point type string */
	    j = 0;
	    while (pointtypes[j] != NULL) {
		if (strcmp(pointtypes[j],pg[i].pointType) == 0)
		    break;
		j++;
	    }
	    if (pointtypes[j] == NULL) {
		logMsg ("Invalid point type in pg structure %s at index %d\n",
			pg[i].pointType,
			i );
		continue;
	    }
	    ptype = j;
	    /* Map the bdtype to the Module Id */
	    btype =QtmBdtypeToId(ptype,pg[i].devType,0,i);
	    if (btype == -1)
		 continue;
	    /* Locate the parameter table entry in the parameters table */ 
	    j = 0;
	    while (mparm[j].id != -1) {
		if (mparm[j].id == btype)
		    break;
		j++;
	    }
	    if (mparm[j].id == -1) {
		logMsg ("Invalid board type in map table - %d\n",
			btype);
		continue;
	    }
	    if (signal > mparm[j].maxsig) {
		logMsg ("Signal number too large for module  line- %d - drop %d - rack %d - slot %d - signal %d\n",
				line,
				drop,
				rack,
				slot+1,
				signal);
		continue;
	    }
	    /* Make sure this module is allocated */
	    pslot = pmod->drops[drop].racks[rack].mods[slot];
	    if (pslot == NULL) {
		pslot = (MODULE *)calloc(1,(sizeof(MODULE)));
		if (!pslot) {
	    	    logMsg ("Not enough memory for MODULES line %d \n",line);
	    	    return(FALSE);
		}
		/* set the was defined and the quantum flag on the first module */
		if (!pmod->drops[drop].was_defined) {
		    pmod->drops[drop].is_quantum = mparm[j].qtmflg;
		    pmod->drops[drop].was_defined = TRUE;
		}
		/* Initialize the Module memory structure */
		pslot->type = mparm[j].type;
		pslot->mp = &mparm[j];
		for (k=0;(k<MAXGAINS);k++)
		    pslot->gains[k] = 0xff;
		/* save the gain for this signal */
		if (pslot->mp->sigtype == SAI)
		    pslot->gains[signal-1] = pg[i].gain;
		pmod->drops[drop].racks[rack].mods[slot] = pslot;
	    } else {  /* Was already there make sure not different module type */ 
		if (pslot->mp->id != mparm[j].id) {
	    	    logMsg ("Module type redefinition line- %d - drop %d - rack %d - slot %d\n",
				line,
				drop,
				rack,
				slot);
	    	    continue;
		}
	    }
	    /* Verify that the is quantum stays the same */
	    if (mparm[j].qtmflg != pmod->drops[drop].is_quantum) {
		logMsg ("Is quantum state redefined line- %d - drop %d - rack %d - slot %d - signal %d\n",
				line,
				drop,
				rack,
				slot+1,
				signal);
		continue;
	    }

	    /* If the gain has not been set set set it */
	    if (( pslot->mp->sigtype == SAI) &&
		  (pslot->gains[signal-1] == 0xff) )
			pslot->gains[signal-1] = pg[i].gain;

	    else {
		/* Make sure the gain has not been redefined */
		if (( pslot->mp->sigtype == SAI) &&
		    (pslot->gains[signal-1] != pg[i].gain)) {
	    	    logMsg ("Gain redefinition line- %d - drop %d - rack %d - slot %d - signal %d\n",
				line,
				drop,
				rack,
				slot+1,
				signal );
	    	    continue;
		}
	    }
	}

	/* We now have all of the module structures filled out */
	/* Free the gain table */
	free (pg);


	/* Time to add the drops to the QRIOM card */
	/* Scan each drop to see if it is defined */

	for (i=0;(i<MAX_DROPS);i++) {
	    if (pmod->drops[i].was_defined) {
		mods = 0;
		/* Count the number of Modules defined for all of the racks */
		for (j=0;(j<MAX_RACKS);j++) {
		    for (k=0;(k<MAX_QSLOTS);k++) {
		      if (pmod->drops[i].racks[j].mods[k])
				mods++;
		    }
		}
		pmod->drops[i].nummods = mods;
		/* time to issue the add drop command */
		if (!qriomcmd(line,ADD_DROP,i+1,mods))
		    return (FALSE);
	    }
	}

	/* Time to configure all of the module for each drop */

	for (i=0;(i<MAX_DROPS);i++) {
	    if (pmod->drops[i].was_defined) {
		thismod = 0;
		/* Make pointers to the drop and module area */
		pdrop = &pQtm_region->drop[i];
		pqmod = (struct module_str *)(((char *) pQtm_region)+ getword(&pdrop->w_module_offset));

		/* Set the drop parameters in the drop structure */
		/* Is Quantum Flag */
		if (pmod->drops[i].is_quantum == 1) {
		    pdrop->control = ISQUANTUM;
		}
		/* Output hold on loss of comm */
		putword(&pdrop->w_holdup_time, HOLDUPTIME);
		/* Status fetch flag for quantum I/O */
		putword(&pdrop->w_status_ref, 1); /* Tell the scanner to fetch the status information */

		/* Set the module configuration for each module on this drop */
		for (j=0;(j<MAX_RACKS);j++) {
		    for (k=0;(k<MAX_QSLOTS);k++) {
		      pslot = pmod->drops[i].racks[j].mods[k];
		      if (pslot) {
			    pslot->qmod = &pqmod[thismod];
			    if (thismod > pmod->drops[i].nummods) {
				logMsg ("Number of modules mismatch in configure pass\n");
				return (FALSE);
			    }
			    pqmod[thismod].rack = j+1;				/* Rack Number */
			    pqmod[thismod].slot = k+1;				/* Slot Number */
			    putword(&pqmod[thismod].w_id, pslot->mp->id);	/* Module Type */
			    pqmod[thismod].in_length = pslot->mp->inbyte;	/* Input Bytes */

			    if (pslot->mp->inbyte)
				putword(&pqmod[thismod].w_in_ref,ref);

			    pqmod[thismod].out_length = pslot->mp->outbyte;	/* Output Bytes */

			    if (pslot->mp->outbyte)
				putword(&pqmod[thismod].w_out_ref,ref);


			    pqmod[thismod].in_cfg = pslot->mp->incfg;		/* In configuration */
			    pqmod[thismod].out_cfg = pslot->mp->outcfg | pmod->hold_last;
												/* Out configuration */
			    putword(&pqmod[thismod].w_tout_length, pslot->mp->toutlen);	/* Time out values & params */
			    thismod++;
			}
		    }
		}
		/* time to issue the configure drop command */
		if (!qriomcmd(line,CONFIG_DROP,i+1))
		    return (FALSE);
		/* Read back the data & status pointers */
		for (j=0;(j<pmod->drops[i].nummods);j++) {
		    rack = pqmod[j].rack-1;
		    card = pqmod[j].slot-1;
		    pslot = pmod->drops[i].racks[rack].mods[card];
		    pslot->indata =  (((char *)  pQtm_region)+ (getword(&pqmod[j].w_in_offset)));
		    pslot->outdata = (((char *)  pQtm_region)+ (getword(&pqmod[j].w_out_offset)));
		    pslot->status =  (((char *)  pQtm_region)+ (getword(&pdrop->w_plc_status_offset)) +
							   (rack*16)+card);
		    pslot->ptout = (((char *) pQtm_region)+ (getword(&pqmod[j].w_tout_offset)));
		}

		/* Set up the timeout parameters (AI config) */
		/* Set output Values here too ?? */
		for (j=0;(j<pmod->drops[i].nummods);j++) {
		    rack = pqmod[j].rack-1;
		    card = pqmod[j].slot-1;
		    pslot = pmod->drops[i].racks[rack].mods[card];
		    if (!toutinit(pmod,pslot))
			return(FALSE);
		}
	    } /* Next Drop */
	}

	/* Set Scan Control to Interrupt after every scan */
	pQtm_region->eos_irq_mult = 3;
	pQtm_region->eos_control = EOS_WAIT_EN;

	/* Enable the interrupts from the card */
	pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/

	if (modtrace[line] == 2) {
	    for(i=0;i<10;i++) {
	        Q984IntTest(line);
	    }
	}


	/* Should Get First Interrupt After Here */
	wasstarted[line] = FALSE;
	scanfail[line] = FALSE;
	pmod->is_responding = TRUE;
	last_online_time[line] = tickGet();
	pmod->init_complete = TRUE;
	return(TRUE);
    }

/*
**
** Q984IntTest
**	Routine to test the Q984 interrupt mechanism
*/
Q984IntTest ( unsigned short line)
    {

	QTM_SREGION		*pQs;

	pQs = sbases[line];		/* short address space control registers */
	Qtmic(line);
	pQs->ctl_stat = ((lights[line] | QRUN_V40 | QINT_ENB)); /*End*/
	Ireqs[line]++;
	if (!qriomcmd(line,IRQ_HOST,0,0)) {
	    logMsg ("Command to Intterrupt Failed for line- %d\n",line);
	    return (-1);
	}
	Qtmic(line);
    }


/*
** qriomcmd (line,Command,Arg0,Arg1)
**
*/
static qriomcmd(unsigned short line, unsigned short command,
		    unsigned short arg0, unsigned short arg1)
    {
	QTM_REGION		*pQtm_region;
	unsigned short	i;

	pQtm_region = bases[line];	/* standard address space card memory */
	/* Wait for the card to be READY */
	i = 0;
	while (pQtm_region->command == BUSY) {
	    if (i>CMDTIMEOUT) {
		logMsg ("Card BUSY too long - line %d, command %d\n",line,command);
		return (FALSE);
	    }
	    i++;
	}
	if (pQtm_region->command != READY) {
	    logMsg ("Card with unknown state - line %d, command %d\n",line,pQtm_region->command);
	    return (FALSE);
	}

	/* Issue the command */
	putword(&pQtm_region->w_arg[0], arg0);				/* Endian Issue */
	putword(&pQtm_region->w_arg[1], arg1);
	pQtm_region->command = command;

	/* Wait for the card to go ready */
	for (i=0; (i<CMDTIMEOUT); i++) {
	    if (pQtm_region->command == READY)
		break;

	    taskDelay(1);
	}
	if (pQtm_region->command != READY) {
	    logMsg ("Line %d failed to complete command - %d \n",line,command);
	    return(FALSE);
	}

	/* Verify the Comand was accepted */
	if ((pQtm_region->status & BADCOMMAND) != 0)
		return (FALSE);

	return (TRUE);

    }

/*
**
** Initialize the TOUT data section for a board
**
*/
static toutinit(QTMLINK *pmod, MODULE *pslot)

    {
	unsigned short	k;

	switch (pslot->mp->id) {
	/* Digital inputs have no parameters */
		case 0x0003:
		case 0x0006:
		case 0x000B:
		case 0x000F:
		case 0x0011:
		case 0x0012:
		    break;

		/* 8 Bit Digital Outputs */
		case 0x0008:

		/* 16 Bit Digital Outputs */
		case 0x0002:
		case 0x0005:
		case 0x000C:
		case 0x0010:
		    /* Characters and Endian*/
		    pslot->ptout[0] = 0;
		    pslot->ptout[1] = 0;
		    break;

		/* 32 Bit Digital Outputs */
		case 0x0004:
		    /* Characters and Endian*/
		    pslot->ptout[0] = 0;
		    pslot->ptout[1] = 0;
		    pslot->ptout[2] = 0;
		    pslot->ptout[3] = 0;
		    break;

		/* Current Input */
		case 0x0102:
		    /* Characters and Endian*/
		    pslot->ptout[1] = QAVI_RIGHTJ;
		    pslot->ptout[0] = 0;
		    break;

		/* Voltage Input */
		case 0x0106:
		    /* Characters and Endian*/
		    pslot->ptout[1] = QAVI_RIGHTJ;	/* Right Justify */
		    pslot->ptout[0] = pslot->gains[0];
		    pslot->ptout[3] = pslot->gains[1];
		    pslot->ptout[2] = pslot->gains[2];
		    pslot->ptout[5] = pslot->gains[3];
		    pslot->ptout[4] = pslot->gains[4];
		    pslot->ptout[7] = pslot->gains[5];
		    pslot->ptout[6] = pslot->gains[6];
		    pslot->ptout[9] = pslot->gains[7];
		    pslot->ptout[8] = 00;
		    break;

		/* Thermocouple Input */
		case 0x0107:
		    /* Characters and Endian*/
		    pslot->ptout[1] = QATC_TENTH+(pmod->extcj)+(pmod->enbcj);
		    pslot->ptout[0] = pslot->gains[0]+(pmod->enboc);
		    pslot->ptout[3] = pslot->gains[1]+(pmod->enboc);
		    pslot->ptout[2] = pslot->gains[2]+(pmod->enboc);
		    pslot->ptout[5] = pslot->gains[3]+(pmod->enboc);
		    pslot->ptout[4] = pslot->gains[4]+(pmod->enboc);
		    pslot->ptout[7] = pslot->gains[5]+(pmod->enboc);
		    pslot->ptout[6] = pslot->gains[6]+(pmod->enboc);
		    pslot->ptout[9] = pslot->gains[7]+(pmod->enboc);
		    pslot->ptout[8] = 00;
		    break;


		/* 4 Channel Analog Output */
		case 0x0103:
		case 0x0104:
		    /* Characters and Endian*/
		    pslot->ptout[1] = QAVO_RIGHTJ;	/* Right Justify */
		    pslot->ptout[0] = QAVO_PARAMS;	/*Params 2-6 follow */
		    if (pmod->hold_last) {
			pslot->ptout[3] = QAVO_HOLD2;
			pslot->ptout[2] = QAVO_HOLD2;
		    } else {
			pslot->ptout[3] = QAVO_DROP2;
			pslot->ptout[2] = QAVO_DROP2;
		    }
		    /* Set Loss of Comm Values */
		    for (k=4;(k<12);k+=2) {
			pslot->ptout[k] =  QAVO_LOSSH;
			pslot->ptout[k+1] = QAVO_LOSSL;
		    }
		    break;

		/* RTD Input */
		case 0x010a:
		    /* Characters and Endian*/
		    /* Not Supported Yet */
		/* Not Supported Yet - This can't happen I already checked them */
		default:
		    logMsg ("Unsupported module type encountered while setting Parameters \n");
		    return (FALSE);	
		    break;
	}
	return (TRUE);
    }



/*
** Print Int Counters */
Qtmic(unsigned short line)
    {
	logMsg("Line %d, Int Requests = %d,  Int responses = %d, Int Delays = %d, Change Interrupts %d, Bad Interrupts %d\n",
				 line,
				 Ireqs[line],
				 GIrsps[line],
				 Idelay[line],
				 Chgint[line],
				 BIrsps[line] );	
    }
		


/*
** QTM_INTR
**
** interrupt service routine
**
** The SS Technology board provides an interrupt at the end of each scan
** It indicates that it is generating a valid interrupt by setting an interrupt
** request flag in its card status register in short address space. The interrupt
** must be dismissed and reenabled by pulsing the interrupt enable flag.
** The cause of the interrupt must be dismissed and reenabled as well or else the
** next scan will not procede. This fuction is provided by the scan task. The interrupt
** service routine will notify it that this scan is over and it will enable the next one.
** The card also has the ability to interupt on data changes. We are not using
** this feature but we will proces the event if it occurs and dismiss it.
*/
static vQtm_int_proc(unsigned short line)

    {
	QTM_REGION		*pQtm_region;
	QTMLINK  		*pmod;
	QTM_SREGION		*pQs;
	unsigned short		i,cardstat,chgflg;
	struct drop_str		*pdrop;

	pmod = plcs[line];
	pQs = sbases[line];		/* short address space control registers */
	pQtm_region = bases[line];	/* standard address space card memory */

	chgflg = FALSE;
	cardstat = pQs->ctl_stat;
	if ((cardstat & QINT_REQ) == 0) {
	    /* Don't know why we are here */
	    /* Try to clear it anyway */
	    pQs->ctl_stat = ((lights[line] | QRUN_V40 )); /*End*/
	    BIrsps[line]++; /* Count the Bad Ones */
	}

	/* There should only be End of Scan Interrupts */
	/* But we will try to dismiss and disable any data change interrupt just in case */

	if ((pQtm_region->status & DATA_CHANGE) != 0) {
	    Chgint[line]++;
	    chgflg = TRUE;
	    for (i=0;(i<MAX_DROPS);i++) {
		pdrop = &pQtm_region->drop[i];
		if ((pdrop->status & DATA_CHANGE) != 0) {
		    /* Clear the data changed flag */
		    pdrop->status = pdrop->status & (~DATA_CHANGE);
		    /* Clear the Interrupt on data changed flag */
		    pdrop->control = (pdrop->status & ISQUANTUM);
		}
	    }
	    pQtm_region->status = pQtm_region->status & (~DATA_CHANGE);
	}

	/* Is there a real End of Scan Interrupt to process ? */
	if ((pQtm_region->eos_control & EOS_WAITING) != 0) {
	    /* Clear it away */
	    pQs->ctl_stat = ((lights[line] | QRUN_V40 )); /*End*/
	    GIrsps[line]++;
	    /* Tell the scan task */
	    semGive(semids[line]);
	} else {
	    /* Try to clear it anyway */
	    pQs->ctl_stat = ((lights[line] | QRUN_V40 )); /*End*/
	    if (!chgflg)
	        BIrsps[line+1]++; /* Count the Bad Ones */
	}

   }



/*
**     prepresponses
**
**      The purpose of this routine is to mark the PLCs as on hold and the 
**	data as not valid until read again from the PLC
**
*/
static	void prepresponses(unsigned short line)

    {

	unsigned short  mod;
	QTMLINK  *pmod;

	pmod = plcs[line];
	pmod->holdflag = TRUE;

    }



/*
**      any_responding
**
**      The purpose of this routine is to see if any adapters are 
**	responding to this scanner
**
*/
static	int any_responding(unsigned short line)

    {

	unsigned short  i,j,acttime;
	QTMLINK  	*pmod;
	unsigned long	thistime,dropson,dropmask,lstat;
	struct drop_str	*pdrop;
	QTM_REGION	*pQtm_region;

	pQtm_region = bases[line];

	thistime = tickGet();
	pmod = plcs[line];

        /* check cmd_force_offline flag because it is set in an asynchronous task */
	if (pmod->cmd_force_offline) {
	    if (was_resp[line])
		pmod->no_offlines++;
	    was_resp[line] = FALSE;
	    return(FALSE);
	}
	dropson = 0;
	dropmask = 1;
	/* See if any of the required drops are responding */
	for (i=0; (i<MAX_DROPS); i++) {
	    pdrop = &pQtm_region->drop[i];
	    acttime = getword(&pdrop->w_activity);
	    if (  (pmod->drops[i].was_defined) &&
		  ((pdrop->status & (ONLINE | BADCONFIG)) == ONLINE) &&
		  ( acttime > (HOLDUPTIME - FAILTIME)) ) { 
		if ((!(last_drop_stat[line] & dropmask)) && (modtrace[line]))
		    logMsg ("Regained drop %d status = %x, state = %d \n",
				i+1,
				pdrop->status,
				pdrop->state );
		dropson = dropson | dropmask;
	    } else {
		if ((last_drop_stat[line] & dropmask) && (modtrace[line]))
		    logMsg ("Lost drop %d status = %x, state = %d \n",
				i+1,
				pdrop->status,
				pdrop->state );
	    }
	    dropmask = dropmask << 1;
	}
 
	/* If I have lost a drop report FALSE */
	lstat = last_drop_stat[line];
	last_drop_stat[line] = dropson;
	if (dropson == 0) {    /* No Drops On Line */
	    if (was_resp[line])
		pmod->no_offlines++;
	    was_resp[line] = FALSE;
	    if ( (tickGet() - last_online_time[line]) > RESETTIME) {
		pmod->is_responding = FALSE;
	        pmod->lasttimervalue = 0xffff;
	    }
	    return (FALSE);
	}
	if ( (lstat & (~dropson)) != 0) { /* lost some */
	    if (was_resp[line])
		pmod->no_offlines++;
	    was_resp[line] = FALSE;
	    return (FALSE);
	}

	was_resp[line] = TRUE;
	return (TRUE);

    }


/*                                                                          	
**      Qtminfo(line,l,a,c,b)                                                       	
**                                                                           	
**      The purpose of this routine is to dump the module description        	
**      portion of the analog devices driver tables for the selected line.   	
**      It will print out two lines for each module which is responding.     	
**      The first line will give the general module header, the second line 	
**      will give module type specific info.                                	
*/
/* not called from within this driver */
void Qtminfo (unsigned short line, unsigned short l,unsigned short a,
 		unsigned short c, unsigned short b)

    {
	QTMLINK  		*pmod;
	unsigned short  	present,drop,rack,slot;
	unsigned short 	adapter,card,xsignal,value;
	QTM_REGION		*pQtm_region;
	struct drop_str	*pdrop;
	struct module_str	*pqmod;
	MODULE		*pslot;
	unsigned short	i, n, j, lstate, pstate, maxrack, maxcard; 
	unsigned long	itvalue, otvalue;

	pQtm_region = bases[line];

	pmod = plcs[line];

	if (!pmod) {
	    printf(" Line - %d Not initialized \n",line);
	    return;
	}

	if (l != 0) { /* Is Scanner Information Required ??*/
	    printf(" Line - %d Status Information ... \n",line);
	    printf("\n");
	    printf(" Resource Name = %s\n",&resnames[line][0]);
	    resGetStates(prestable[line],&lstate,&pstate);
	    printf(" Local state = %d, Partner State = %d \n",lstate,pstate);
	    printf(" Scanner firmware revision = %s\n",pQtm_region->version);
	    present = getword(&pQtm_region->w_present);
	    printf(" Scanner present word  = %x\n",present);

	    printf(" Scanner current status = %x \n",pQtm_region->status);
	    printf("\n");

	    printf (" Was requested = %d \n", pmod->was_requested);
	    printf (" Is responding = %d \n", pmod->is_responding);
	    printf (" Resource Responding = %d \n", resresponse[line]);
	    printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	    printf (" Hold Flag  = %d \n", pmod->holdflag);
	    printf("\n");

	    printf (" My Count =  %d \n",pmod->mycount);
	    printf (" Partner Count = %d \n",pmod->partnercount);
	    printf("\n");

	    printf (" # Output commands = %d \n", pmod->no_dataout_msgs);
	    printf (" # Transmit packets = %d \n", (getword(&pQtm_region->w_tx_count)));
	    printf (" # Receive packets = %d \n", (getword(&pQtm_region->w_rx_count)));
	    printf (" # Error packets = %d \n", (getword(&pQtm_region->w_err_count)));
	    printf (" # Timer Word = %d \n", (getword(&pQtm_region->w_timer)));
	    printf (" # Memory Used = %d \n", (getword(&pQtm_region->w_mem_used)));

	    printf("\n");

	    printf("\n");
	    printf("\n");
	}
	if (a != 0) { /* Is Drop Information Required ??*/


	    printf("Drop\tDef\tQtm\t# Mods\tOnLine\tStatus\tAct\tSeq\tRetry\t H0 H1 H2 H3 H4 H5 H6 H7 H8 H9\n");

	    for (i=0;(i<MAX_DROPS);i++) {
		pdrop = &pQtm_region->drop[i];

		printf("%d\t%d\t%d\t%d\t%s\t%x\t%d\t%d\t%d\t %02.2x %02.2x  %02.2x  %02.2x  %02.2x  %02.2x  %02.2x  %02.2x  %02.2x  %02.2x \n",
		    i+1,
		    pmod->drops[i].was_defined,
		    pmod->drops[i].is_quantum,
		    pmod->drops[i].nummods,
		    (pdrop->status & ONLINE)?"Y":"N",
		    pdrop->status,
		    getword(&pdrop->w_activity),
		    pdrop->last_seq,
		    getword(&pdrop->w_retries) & 0x7fff,
		    pdrop->health[0],
		    pdrop->health[1],
		    pdrop->health[2],
		    pdrop->health[3],
		    pdrop->health[4],
		    pdrop->health[5],
		    pdrop->health[6],
		    pdrop->health[7],
		    pdrop->health[8],
		    pdrop->health[9]	 );

	    }
	}

	if (c != 0) { /* Is Card Information Required ??*/
	    for (drop=0;(drop<MAX_DROPS);drop++) {
		if (!pmod->drops[drop].was_defined)
			continue;
		pdrop = &pQtm_region->drop[drop];

		maxrack = pmod->drops[drop].is_quantum?1:MAX_RACKS;
		maxcard = pmod->drops[drop].is_quantum?MAX_QSLOTS:MAX_SLOTS;

		for (rack = 0;(rack<maxrack);rack++) {
		    printf("Drop = %d, Rack = %d, Qtm = %s, Status = %s, State = %d\n",
			drop+1,
			rack,
			pmod->drops[drop].is_quantum?"YES":"No",
			(pdrop->status & ONLINE)?"On-line":"Off-line",
			pdrop->state );

		    printf("Card\tId\tType\t# Sig\tOk\tStatus\tVals\n");


		    for (card = 0;(card<maxcard);card++) {
			/* Has there been a card defined here */
			pslot = pmod->drops[drop].racks[rack].mods[card];
			if (!pslot)
			    continue;


			printf("%d\t%x\t%s\t%d\t%s\t%x\t",
			    card+1,
			    pslot->mp->id,
			    modtypes[pslot->mp->type],
			    pslot->mp->maxsig,
			    (pdrop->health[(rack*2)+(card/8)] & rbmasks[card%8])?"Good":"Bad",
			    pslot->status[(rack*16)+card] );

			itvalue = (pslot->indata[0]);
			itvalue = (itvalue << 8)+(pslot->indata[1]);
			itvalue = (itvalue << 8)+(pslot->indata[2]);
			itvalue = (itvalue << 8)+(pslot->indata[3]);

			otvalue = (pslot->outdata[0]);
			otvalue = (otvalue << 8)+(pslot->outdata[1]);
			otvalue = (otvalue << 8)+(pslot->outdata[2]);
			otvalue = (otvalue << 8)+(pslot->outdata[3]);

			switch (pslot->mp->type) {
			    case DI8:
			    case DI16:
				printf ("%04.4x\n",(itvalue & 0xffff));
				break;
			    case DI32:
				printf ("%08.8xl\n",itvalue);
				break;
			    case DO8:
			    case DO16:
				printf ("%04.4x\n",((otvalue >> 16) & 0xffff));
				break;
			    case DO32:
				printf ("%08.8xl\n",otvalue);
				break;
			    case AO:
				for (i=0;(i<=pslot->mp->maxsig);i++) {
				    value = ((pslot->outdata[(i*2)+1]) +
						 ((pslot->outdata[(i*2)])<<8) ); 
				    printf ("%04.4x ", value);
				}
				printf ("\n");
				break;
			    case AICUR:
			    case AIVOLT:
			    case AITC:
				for (i=0;(i<=pslot->mp->maxsig);i++) {
				    value = ((pslot->indata[(i*2)+1]) +
						 ((pslot->indata[(i*2)])<<8) ); 
				    printf ("%04.4x ", value);
				}
				printf ("\n");
				break;
			    case AIRTD:
			    default:
				printf ("   Unknown Module Type \n");
				break;
			}
		    }
		}
	    }
	}
    }
/*                                                                          	
**      Qtmmon(line)                                                       	
**                                                                           	
**      The purpose of this routine is to dump the module description        	
**      portion of the analog devices driver tables for the selected line.   	
**      It will print out two lines for each module which is responding.     	
**      The first line will give the general module header, the second line 	
**      will give module type specific info.                                	
*/
/* not called from within this driver */
Qtmmon (unsigned short line)

    {
	QTMLINK  		*pmod;
	QTM_REGION		*pQtm_region;
	unsigned short		offset,endoff,i;
	unsigned long		loc,start1,start2,end1,end2; 
	FILE			*fp;
	unsigned char		ch,*pcmem;

	pQtm_region = bases[line];

	pcmem = (char *)membases[line];
	pmod = plcs[line];

	if (!monitor908[line]) {
	    printf(" Line - %d Not in monitor mode \n",line);
	    return;
	}

	if (!pmod) {
	    printf(" Line - %d Not initialized \n",line);
	    return;
	}

	for(;;) {
	    offset = getword (&pcmem[0x10000]);
	    endoff = getword (&pcmem[0x10002]);


	    if (offset & 0x8000) {
		start1 = 0x10089;
		end1 = (endoff & 0x7fff) - 0x89;
		start2 = 0x18089;
		end2 = (offset & 0x7fff) - 0x89;
	    } else {
		start1 = 0x18089;
		end1 = (endoff & 0x7fff) - 0x89;
		start2 = 0x10089;
		end2 = (offset & 0x7fff) - 0x89;
	   }
	   if ( (end1 < 0x10000) && (end2 < 0x10000)  &&
		(end1 > 0x1000 ) && (end2 > 0x1000 ) )
		break;
	}


	logMsg ("Offset %x, Endoff %x, Start1 %x, End1 %x, Start2 %x, End2 %x \n",
		offset,
		endoff,
		start1,
		end1,
		start2,
		end2 );


	/* write the cards memory into the file*/
	
	if ((fp = fopen("file00.bin","w"))== NULL) {
	    logMsg("Could not open QTM monitor data file 0 \n");
	    return (FALSE);
	}

	loc = start1;
	i = 0;
	while ((!feof(fp)) && (i < end1)) {
	    ch = pcmem[loc];
	    putc(ch,fp);
	    loc++;
	    i++;
	}

	fclose(fp);

	if ((fp = fopen("file01.bin","w"))== NULL) {
	    logMsg("Could not open QTM monitor data file 1 \n");
	    return (FALSE);
	}

	loc = start2;
	i = 0;
	while ((!feof(fp)) && (i < end2)) {
	    ch = pcmem[loc];
	    putc(ch,fp);
	    loc++;
	    i++;
	}

	fclose(fp);

	return TRUE;

    }



GAIN_TABLE *buildGainTable()
{
    int			gainsPosted = 0;
    int			i;
    int			j;
    char		*pointType;
    GAIN_TABLE		*currTable;
    GAIN_TABLE		*origTable;
    struct recTypDes	*pRecTypeDes;
    struct fldDes	*pFldDes;
    struct link		*pLink;

    if ((origTable = calloc(MAX_QUANTUM_PTS, sizeof(GAIN_TABLE))) == 0)
	return (NULL);
    currTable = origTable;

    for (i = 0; i < dbRecords -> number; i++)
	{
	if ((pointType = (char *) GET_PRECTYPE(i)) == NULL)
	    continue;
	}

    for (i = 0; i < dbRecords -> number; i++)
	{
        struct recLoc	*recLoc;
        struct recChain	*chain;
        struct fldDes	**fldDes;
    
        if (!(recLoc = dbRecords -> papRecLoc[i]))
    	    continue;		/* No points this type */

	
	if ((pointType = (char *) GET_PRECTYPE(i)) == NULL)
	    {
	    printErr("Can't get point type label for type %d\n", i);
	    free(origTable);
	    return ((GAIN_TABLE *) NULL);
	    }
	if ((pRecTypeDes = GET_PRECTYPDES(i)) == NULL)
	    {
	    printErr("Can't get record type descriptor for %s point type.\n", pointType);
	    free(origTable);
	    return (NULL);
	    }
    
        for (chain = (struct recChain *) (recLoc -> pFirst); chain; chain = chain -> next)
            {
    	    struct dbCommon	*recHdr;
    
    	    if (!(recHdr = (struct dbCommon *) (chain -> pRecord)))
    	        continue;	/* No record pointer */
    
    	    if (!(recHdr -> name[0]))
    	        continue;	/* Point was deleted */
    
	    for (j = 0; j < pRecTypeDes -> no_links; j++)
		{
		if ((pFldDes = GET_PFLDDES(pRecTypeDes, pRecTypeDes -> link_ind[j])) == NULL)
		   {
		   printErr("Can't get field descriptor for fld %d, type %s\n", pRecTypeDes -> link_ind[j], pointType);
		   free(origTable);
		   return (NULL);
		   }

		pLink = (struct link *) (((char *) recHdr) + pFldDes -> offset);
		if (pLink -> type != V984_IO)
		    continue;

		/*
		All record types can be handled the same way except for PAT.
		*/

		if (strcmp(pointType, "pat"))
		    {
		    if (gainsPosted >= MAX_QUANTUM_PTS)
			{
			printErr("Can't build gain table for more than %d Quantum I/O points\n", MAX_QUANTUM_PTS);
			free(origTable);
			return (NULL);
			}

		    currTable -> pointType = pointType;
		    currTable -> devType = recHdr -> dtyp;
		    currTable -> line = pLink -> value.tateio.link;
		    currTable -> addr = pLink -> value.tateio.adapter;
		    currTable -> card = pLink -> value.tateio.card;
		    currTable -> signal = pLink -> value.tateio.signal;

		    /*
		    AI records have a gain, also
		    */

		    if (!strcmp(pointType, "ai"))
			{
			struct aiRecord		*aiRec = (struct aiRecord *) recHdr;

			currTable -> gain = aiRec -> gain;
			}

		    /*
		    "Normal" record types have only one device.
		    */

		    currTable++;
		    gainsPosted++;
		    break;
		    }

		else
		    {

		    /*
		    Pat points have three different I/O types.
		    */

		    struct patRecord		*patRec = (struct patRecord *) recHdr;

		    if (patRec -> rlin.type == V984_IO)
			{
			/*
			Remote/local input.
			*/

		        if (gainsPosted >= MAX_QUANTUM_PTS)
			    {
			    printErr("Can't build gain table for more than %d Quantum I/O points\n", MAX_QUANTUM_PTS);
			    free(origTable);
			    return (NULL);
			    }
			currTable -> pointType = pointType;
			currTable -> devType = patRec -> dtyr;
			currTable -> line = patRec -> rlin.value.tateio.link;
			currTable -> addr = patRec -> rlin.value.tateio.adapter;
			currTable -> card = patRec -> rlin.value.tateio.card;
			currTable -> signal = patRec -> rlin.value.tateio.signal;
			gainsPosted++;
			currTable++;
			}
		    if (patRec -> inp.type == V984_IO)
			{

			/*
			Feedback input
			*/

		        if (gainsPosted >= MAX_QUANTUM_PTS)
			    {
			    printErr("Can't build gain table for more than %d Quantum I/O points\n", MAX_QUANTUM_PTS);
			    free(origTable);
			    return (NULL);
			    }
			currTable -> pointType = pointType;
			currTable -> devType = patRec -> dtyf;
			currTable -> line = patRec -> inp.value.tateio.link;
			currTable -> addr = patRec -> inp.value.tateio.adapter;
			currTable -> card = patRec -> inp.value.tateio.card;
			currTable -> signal = patRec -> inp.value.tateio.signal;
			gainsPosted++;
			currTable++;
			}
		    if (patRec -> pout.type == V984_IO)
			{

			/*
			Positive output
			*/

		        if (gainsPosted >= MAX_QUANTUM_PTS)
			    {
			    printErr("Can't build gain table for more than %d Quantum I/O points\n", MAX_QUANTUM_PTS);
			    free(origTable);
			    return (NULL);
			    }
			currTable -> pointType = pointType;
			currTable -> devType = patRec -> dtyp;
			currTable -> line = patRec -> pout.value.tateio.link;
			currTable -> addr = patRec -> pout.value.tateio.adapter;
			currTable -> card = patRec -> pout.value.tateio.card;
			currTable -> signal = patRec -> pout.value.tateio.signal;
			gainsPosted++;
			currTable++;
			}
		    if (patRec -> nout.type == V984_IO)
			{

			/*
			Negative output
			*/


		        if (gainsPosted >= MAX_QUANTUM_PTS)
			    {
			    printErr("Can't build gain table for more than %d Quantum I/O points\n", MAX_QUANTUM_PTS);
			    free(origTable);
			    return (NULL);
			    }
			currTable -> pointType = pointType;
			currTable -> devType = patRec -> dtyp;
			currTable -> line = patRec -> nout.value.tateio.link;
			currTable -> addr = patRec -> nout.value.tateio.adapter;
			currTable -> card = patRec -> nout.value.tateio.card;
			currTable -> signal = patRec -> nout.value.tateio.signal;
			gainsPosted++;
			currTable++;
			}
		    break;
		    }
		}

            } /* end all pts of type i */
    
        } /* end for all pt types */

    return(origTable);
}

/*	End of File: drvQtms.c */
