/****
*
*	File name :		meter.h
*	Author :		Steve Johnson
*	Creation date :	September 10, 1998
*
*	Copyright (c) 1998,1999 Sigma Six Corporation
*
*	Include file for the Siemens Meter Protocol
*
****/

/****
*
*	Definition of handles returned by open
*
****/

typedef void		*METER_HANDLE;

/****
*
*	Possible meter error values
*
****/

typedef enum {
	METER_NORMAL			= -1,
	METER_BASE				= 2000,
	METER_BAD_NAME			= METER_BASE + 1,
	METER_BAD_HANDLE		= METER_BASE + 2,
	METER_NO_MEMORY			= METER_BASE + 3,
	METER_ABORTED			= METER_BASE + 4,
	METER_PENDING			= METER_BASE + 5,
	METER_SHUTDOWN			= METER_BASE + 6,
	METER_OVERFLOW			= METER_BASE + 7,
	METER_TIMEOUT			= METER_BASE + 8,
	METER_NO_DATA			= METER_BASE + 9,
	METER_IO_ERROR			= METER_BASE + 10,
	METER_NOT_IMPLEMENTED	= METER_BASE + 11,
	METER_TABLE_EMPTY		= METER_BASE + 12,
	METER_LOCK_ERROR		= METER_BASE + 13,
} METER_STATUS;

#define METER_MAX_BUFFER_SIZE	267

extern METER_STATUS		meter_init (void);
extern METER_STATUS		meter_connect (METER_HANDLE *, char *);
extern METER_STATUS		meter_poll (METER_HANDLE *);
extern METER_STATUS		meter_write (METER_HANDLE, size_t, void *);
extern METER_STATUS		meter_read (METER_HANDLE, size_t, void *, size_t *);
extern METER_STATUS		meter_lock (METER_HANDLE);
extern METER_STATUS		meter_unlock (METER_HANDLE);
extern METER_STATUS		meter_read_table (METER_HANDLE, int, size_t, void *, size_t *);
extern UCHAR			*meter_table_addr (USHORT, USHORT);
extern void				meter_debug_on (void);
extern void				meter_debug_off (void);
extern METER_STATUS		meter_get_id (METER_HANDLE, long *);
extern METER_STATUS		meter_shutdown (METER_HANDLE);
extern METER_STATUS		meter_exit (void);

