/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*****************************************************************
*
*  File: drvSecurity.h
*  Edit:  7/20/95      WEP: original version.
*
******************************************************************/


#define TRUE       1
#define FALSE	   0
#define NULLP	   0
#define CR	0x0d

#define TICKSPERSEC 60

/*****************************************
*
*    number of lines of Security drivers
*
******************************************/

#define SECLINES  20

#define MDATA      0                             /* Card number for 'real' i/o           */
#define MPSEUDO   33                             /* Card number for pseudo i/o           */

#define MAXTERMINAL 0                            /* maximum address value in security    */


/***********************
*
*    Number of items
*
***********************/

#define MINAINO   1                              /* min number of 'real' AIs             */
#define MINBINO   1                              /* min number of 'real' BIs             */
/*#define MINBONO   1                              /* min number of 'real' BOs             */
#define MINSINO   1                              /* min number of 'real' SIs             */
#define MINSONO   1                              /* min number of 'real' SOs             */

#define MAXAINO   3                              /* max number of 'real' AIs             */
#define MAXBINO   1                              /* max number of 'real' BIs             */
/*#define MAXBONO   2                              /* max number of 'real' BOs             */
#define MAXSINO   2                              /* max number of 'real' SIs             */
#define MAXSONO   2                              /* max number of 'real' SOs             */


#define    WATCHDOGTIMEOUT       10*60 /* watchdog monitor timeout.  */

/************************************************
*
*	Communications I/O Structures
*
*************************************************/

#define		RXSEM		0
#define		TXSEM		1
#define		MAXRXMSG	256
#define		MAXTXMSG	256


/*typedef	struct {
	unsigned short		rxstate;
/* trash most of this? cob 9-20-95 */
/*	unsigned short		fixedlen;
	unsigned short		rxmsglenexpected;
        unsigned short          rxmsglen;
       	unsigned short		rxix;
	SEMAPHORE		*semid;
	unsigned short		*status;
        unsigned char           txaddress;
        unsigned char           txfunction;
       	unsigned char		rxbuf[MAXRXMSG];
		} 	RXLINE;
*/

typedef	struct {
/*	unsigned short		protocol; */
	unsigned short		txdisable;
/*	unsigned short		txtocnt; */
/*	unsigned short		txhwerrcnt; */
	unsigned short		txmsglen;
	unsigned short		txix;
	SEMAPHORE		*semid;
	unsigned short		*status;
	unsigned char		txbuf[MAXTXMSG];
		} 	TXLINE;

/* Circular Raw RX Data Buffer */
typedef	struct {
        unsigned char           rxchar;
        unsigned char           rxstatus;
		} 	RXRAW;

#define         RXRAWQSIZE      2000

typedef struct {
         unsigned short         rxinix;
         unsigned short         rxoutix;
         RXRAW                  rxque[RXRAWQSIZE];
               }      RXRAWQUE;


/***********************************************
*
*	Communications I/O Constants
*
************************************************/

#define		RXGOOD			1
#define		RXBAD			2
#define		RXTIMEOUT		60	/* 16 ms ticks 				*/
#define		ACTIVITYTIME		300	/* must see activity in 5 seconds 	*/

#define		VARRESP			FALSE
#define		FIXEDRESP		TRUE
#define		ONERETRY		0x8000	/* OR'ed into line number for xfermsg 	*/
#define		RXIGNORE		0
#define		RXADRST			1
#define		RXFNCST			2
#define		RXLENST			3
#define		RXDATAST		4

#define		TXGOOD			1
#define		TXBAD			2
#define		IO_TIMEOUT		3	/* Code returned by timer 		*/


#define		TXTIMEOUT		60	/* 16 ms ticks: one second              */

#define		MAXRETRYS		3	/* retransmission trys 			*/

#define		MAXCFGCK		8	/* Try to Bring online each cycle 	*/
#define		BRINGBACKCNT		4	/* Poll loops per cycle 		*/

#define		XFERGOOD		1
#define		XFERBAD			2

#define		RESNAMELEN		16	/* length of a resource name 		*/
#define		SLWWINDOW		900	/* # of ticks to allow slave to try 	*/


/*********************************************************
*
* Output Queue Management Structures for Terminal Protocol
*
**********************************************************/

#define         AOUTTYPE        1
#define         BOUTTYPE        2
#define         SOUTTYPE        3

#define         OUTQSIZE        128
#define		STRINGMSGLEN	80

typedef struct {
	unsigned short  link;
	unsigned short  adapter;
	unsigned short  card;
	unsigned short  aosignal;
	short           aovalue;
	double		dblaovalue;
	unsigned short	conversion;
		} AOUT, *AOUTPTR;

typedef struct {
	unsigned short  link;
	unsigned short  adapter;
	unsigned short  card;
	unsigned short  bosignal;
	long            bomask;
	long            bovalue;
		} BOUT, *BOUTPTR;

typedef struct {
	unsigned short  link;
	unsigned short  adapter;
	unsigned short  card;
	unsigned short  sosignal;
	long            solen;
	unsigned char   sovalue[STRINGMSGLEN];
		} SOUT, *SOUTPTR;

typedef struct {
		unsigned short  otype;
		union   {
			AOUT    aonode;
			BOUT    bonode;
			SOUT	sonode;
			}out;
	       } OUTQENT;

typedef struct {
		unsigned short	ooutix;
		unsigned short	oinix;
		OUTQENT         outque[OUTQSIZE];
		} OUTPUTQUE;


/********************************************
*
*    File Loading Termination Error Codes
*
********************************************/

#define LOADOK                  0x00
#define CANNOTOPENFILE          0x01
#define SYNTAXERROR             0x02
#define NOTIMEOUTVALUE          0x03
#define BADUSERID               0x04
#define BADPASSWORD             0x05
#define	BADTIMEOUTVALUE		0x06
#define	NOUSERIDS		0x07
#define	NOMEMORY		0x08
#define CANNOTGETTIMEOUT        0x09


/***********************************************
*
*    User File Parsing State Name Assignments
*
***********************************************/

#define  START                  0x00
#define  NEXTLINE               0x01
#define  TIMEOUTPARAM           0x02
#define  FIRSTPARAM             0x03
#define  SECONDPARAM            0x04
#define  STOREVALUE             0x05
#define  WRAPUP                 0x06

#define  MAXUSERLEN               20


/***************************************************************
*
*    Internal structure for Security driver
*
****************************************************************/

typedef	struct	{
    unsigned short  was_requested;      /* 0  The scan task has accessed this Driver    */
    unsigned short  is_responding;      /* 1  The XXX is responding 			*/
    unsigned short  holdflag;           /*    The XXX data is on hold 			*/
    unsigned short  no_dataout_msgs;    /* 5  Count Output Msgs 			*/
    unsigned short  no_datain_msgs;     /* 6  Count Data Requests 			*/
    unsigned short  no_putch_msgs;      /* ?  Count Output single chararacter Msgs	*/
    unsigned short  no_putstr_msgs;     /* ?  Count Output string Msgs 		        */
    unsigned short  no_rxnoresp;        /* 7  Count No Responses 			*/
    unsigned short  no_txnoresp;        /* 8  Count No Responses 			*/
    unsigned short  no_dataerr;	        /* 9  Count Message Echo Errors 		*/
    unsigned short  no_retries;         /* 10 Count Retries 				*/
    unsigned short  no_rxhwerrs;        /* 11 Count Comm Hardware Errors 		*/
    unsigned short  no_txhwerrs;        /* 12 Count Comm Hardware Errors 		*/
    unsigned short  no_offlines;        /* 14 Count Off Line Transitions		*/
    unsigned short  cmd_reset_stat;     /* 15 Command to reset stats			*/
    unsigned short  cmd_force_offline;  /* 16 Command to Force Offline 			*/
    unsigned short  badoutcnt;          /* 17 Count Failed output commands 		*/
    unsigned short  tscanpass;          /* Total number of scanpasses. incremented at   */
                                        /*  the start of each terminal scan.            */
    unsigned short  msgs;               /* Count of messages which got good responses.  */
                                        /*  incremented on each exit from 'good' msgxfer*/
    unsigned long   responsetime;       /* Total time(ticks) waiting for good responses.*/
                                        /* accumu (exit-entry) time for 'good' msgxfers */
    unsigned short  data_valid;         /* driver data status:  0 = invalid, 1 = valid. */
    unsigned char   userid[MAXUSERLEN+1];       /* current operator id                  */
    unsigned char   logstamp[STRINGMSGLEN+1];	/* logon/logoff date/time stamp         */
    unsigned char   outstr1[STRINGMSGLEN+1];	/* user output message			*/
    unsigned char   outstr2[STRINGMSGLEN+1];	/* user output message			*/
    unsigned long   logontime;          /* time since logon became active. (0 = logoff) */
    unsigned long   last_clk_ticks;	/* last clock tick count			*/
    unsigned short  baduseridcnt;       /* count of invalid user ids entered.           */
    unsigned short  badpasswordcnt;     /* count of invalid passwords entered.          */
    unsigned long   logonstatus;        /* mbbi value of logon status                   */
    unsigned char   newuserid[MAXUSERLEN+1];	/* someone is logging on		*/
    unsigned char   newpasswd[MAXUSERLEN+1];	/* new users password			*/
    unsigned short  login_state;		/* state while someone is logging on	*/
    short	    idx;		/* index into newuserid/newpasswd		*/
    } SECURITY;

/*********************************************************************************
*
*    structure that defines all valid users and passwords as read from host file 
*
**********************************************************************************/

typedef struct
{
    unsigned char    userid[MAXUSERLEN+1];
    unsigned char    password[MAXUSERLEN+1];
    void             *nextuser;
}   USER;

/***********************************************
*
*    defined for each line that is defined
*
***********************************************/

typedef struct
{
    unsigned short  line;
    unsigned short  loading;
    unsigned short  user_load_status;
    unsigned short  user_load_code;
    unsigned short  entry_count;
    unsigned long   timeout;		/* in clock ticks	*/
    unsigned char   filename[100];
    FILE           *userfile;
    USER           *firstuser;
}   LOADUSER;

/******************************************
*
*    define strings to send to terminal
*
******************************************/

#define	SEC_ID_PROMPT		"\r\nID > "
#define	SEC_PASSWD_PROMPT	"\r\nPASSWORD > "
#define	SEC_LOGOFF_PROMPT	"\r\nLOGOFF (Y) > "
#define	SEC_ILLEGAL_ID_MSG	"\r\nILLEGAL ID \r\n"
#define	SEC_INVALID_PASSWD_MSG	"\r\nINVALID PASSWORD\r\n"
#define	SEC_LOGNAME_TO_LONG_MSG	"\r\nLOGIN ID TO LONG\r\n"
#define	SEC_PASSWD_TO_LONG_MSG	"\r\nPASSWORD TO LONG\r\n"
#define	SEC_INPUT_TIMEOUT_MSG	"\r\nINPUT TIMED OUT\r\n"

/*************************************
*
*    defines for logon/off status
*
*************************************/

#define	SEC_LOGGED_OFF		0
#define SEC_LOGGED_ON		1
#define	SEC_TIMED_OUT		2

/**********************************************************
*
*    defines for states while someone is trying to logon
*
***********************************************************/

#define SEC_IDLE                0
#define	SEC_LOGIN_ID		1
#define	SEC_PASSWD_ID		2
#define	SEC_LOGIN_FINISH	3

/**************************************************************
*
*    defines for returned by valid_id () and valid_passwd ()
*
**************************************************************/

#define	SEC_VALID_LOGIN		0
#define	SEC_VALID_ID		1
#define	SEC_INVALID_ID		2
#define	SEC_INVALID_PASSWD	3

/*********************************************************
*
*    defined legal characters for a userid and password
*
*********************************************************/

#define	SEC_LEGAL_CHARS\
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890_-%$&*"

/****************************************************************
*
*    define for timeout bwteen character entries from terminal 
*    as 5 seconds in clock ticks
*
****************************************************************/

#define	SEC_CHAR_TIMEOUT	300	/* 5 seconds in clock ticks	*/

/**********************
*
*    Command Results
*
**********************/

#define CMDDONE                 0x00     /* the command was sent and the response was error free.   */
#define CMDFAIL                 0x01     /* there were errors in sending or receiving the command.  */
#define CMDNACK                 0x02     /* response was error free, but command was not completed. */
#define CMDREJECT               0x03     /* driver rejected command due to unsupported data type.   */
#define CMDBUSY			0x05	 /* The command was sent, but the device is busy            */

/************************
*
*    task definitions
*
************************/

#define SEC_STACK               8000     /* Stack size              */
#define	SEC_PRIORITY            152      /* default priority        */
#define	SEC_TASK_OPTIONS        8        /* Floating point          */

typedef struct {
        unsigned long   TXintcount;
        unsigned long   RXintcount;
        unsigned long   msgxfercount;
        unsigned long   startingtick;
               }        LINESTATS;

/****************************
*
*    Trace Bit Definitions
*
****************************/

#define ALLTRAFFICTRACE      0x0001
#define MODBUSNACKTRACE      0x0002        /* MODBUS NACK errors.                               */
#define CONFIGURATIONTRACE   0x0010        /* trace configuration errors in driver calls.       */
#define RUNTIMEERRORTRACE    0x0020        /* trace run time errors in driver calls.            */
#define CALLREJECTTRACE      0x0040        /* trace non-error based driver call rejections.     */


/*	End of File:	drvSecurity.h */

