/*atca_main.c,v 1.1.1.1 1999/08/03 14:41:37 tis4000 Exp */

/*
**	Tate Integrated Systems,LP
**
**
**	These are the '@' functions for Lotus1-2-3
**
*/
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#define	LPI_MAIN_MODULE
#define	USE_REGISTER
#define	USE_RANGE
#define	USE_CELL
#include "atcamain.h"
#include <stdio.h>
#include <syslog.h>
LIST	ATCA_Table;			/* Linked list of pvname entries */
LpiAtProto(ATCA_GetValue);
LpiAtProto(ATCA_PutNumber);
LpiBindProto(atca_b);
LpiUnbindProto(atca_u);
/*
	GetValue custom '@' function definition
*/
lushort	ATCA_GetValue(ATCA_Context,ATCA_ArgCount,LpiContext)
LpiRegContextType	ATCA_Context;
lushort			ATCA_ArgCount;
lptr(CONTEXT)		LpiContext;
{
/*
	Local variables
*/
lushort	type;			/* used to get the argument type */
int	ATCA_Status;		/* status for function returns */
char	ATCA_ProcessVar[30];	/* Process Variable name */
char	*pstr;			/* temp pointer to cell string */
ENTRY	*ATCA_Entry;		/* pointer to table entry or zero if error */
int i;
/*
	Check for proper argument type. Must be a string cooresponding
	to a known process variable name! or range of cells containing
	process variable name strings.
*/
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NA);
if(LpiRegGetArgType(FIRST_ARG,&type) == LPI_SUCCESS)
  {
/*
	Based on type, get the args for this function and translate
	into channel access format
*/
    if(type == LPI_T_ARG_TYPE_STR)
      {
	LpiRegGetArgStrNative(FIRST_ARG,&pstr);
	sprintf(ATCA_ProcessVar,"%s\0",pstr);	/* get the argument */
	if((ATCA_Entry = ATCA_ProcessPoint(ATCA_ProcessVar)) != 0)
	  {
	    ATCA_Status = ca_pend_io(0.01);
	    for(i=0;i<100;i++)
	      {
		if(ATCA_Status != ECA_TIMEOUT)
		  ATCA_Status = ca_pend_io(0.01);
		else
		  break;
	      }
	    if(ATCA_Entry->valid)
	      {
		ATCA_SetNewValue(ATCA_Entry);	/* set the new return value */
		return(LPI_SUCCESS);				/* all done so leave from here */
	      }
	  }
      }
  }
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
return(LPI_SUCCESS);
}
/*
	PutNumber custom '@' function definition. The syntax for this function is
	as follows:

	@PUTNUMBER(123.456,"motor_temp.HIGH") put 123.456 into the HI alarm limit of motor_temp
	@PUTNUMBER(a:a4,"motor_temp.LOW) put value of cell a:a4 into the LOW alarm limit 
*/
lushort	ATCA_PutNumber(ATCA_Context,ATCA_ArgCount,LpiContext)
LpiRegContextType	ATCA_Context;
lushort			ATCA_ArgCount;
lptr(CONTEXT)		LpiContext;
{
/*
	"Local variables"
*/
lushort	type;
int	ATCA_Status;		/* status for function returns */
char	ATCA_ProcessVar[30];	/* Process Variable name */
char	*pstr;			/* temp pointer to cell string */
ENTRY	*ATCA_Entry;		/* pointer to table entry or zero if error */
LpiCellType	ATCA_CellID;	/* for upper left corner cell of range */
LpiRangeType	ATCA_RangeID;	/* so we can extract argument */
lmbcs	file[LPI_RNG_FILEPATH_BUFLEN];			/* worksheet file name */
lushort	sheet,col,row;		/* used to get the first cell in a range */
lushort	celltype;
lushort	datatype;
char	i;
lfloat8	value;			/* value from cell or constant */
float	ca_value;		/* same as above for channel access */

LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NA);
for(i = FIRST_ARG;i < NUM_ARGS;i++)
	{
	if(LpiRegGetArgType(i,&type) != LPI_SUCCESS)		/* get the first argument type */
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		break;
		}
	if(type == LPI_T_ARG_TYPE_NUM)
		{
		LpiRegGetArgNumFloat(i,&value);
		ca_value = value;
		}
	else if(type == LPI_T_ARG_TYPE_RNG)
		{
		if(LpiRegGetArgRange(i,&ATCA_RangeID) != LPI_SUCCESS)
			{
			LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
			break;
			}
		if(LpiRngGetFirstCell(ATCA_RangeID,file,&sheet,&col,&row) != LPI_SUCCESS)
			{
			LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
			LpiRngDestroy(&ATCA_RangeID);
			break;
			}
		if(LpiClConstructWZXY(&ATCA_CellID,file,sheet,col,row) != LPI_SUCCESS)
			{
			LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
			LpiRngDestroy(&ATCA_RangeID);
			break;
			}
		if(LpiClGetDataType(ATCA_CellID,&datatype) == LPI_SUCCESS)
			{
			LpiRngDestroy(&ATCA_RangeID);
			LpiClDestroy(&ATCA_CellID);
			break;
			}
		switch(datatype)
			{
			case LPI_T_DATA_BLANK:
			case LPI_T_DATA_STRINGDATA:
				break;
			case LPI_T_DATA_NADATA:
				LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
				break;
			case LPI_T_DATA_ERRDATA:
				LpiRngDestroy(&ATCA_RangeID);
				LpiClDestroy(&ATCA_CellID);
				LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
				break;
			case LPI_T_DATA_NUMBERDATA:
				if(LpiClGetValueFloat(ATCA_CellID,&value) != LPI_SUCCESS)
					{
					LpiRngDestroy(&ATCA_RangeID);
					LpiClDestroy(&ATCA_CellID);
					LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
					break;
					}
				ca_value = value;
				break;
			default:
				break;
			}
		LpiClDestroy(&ATCA_CellID);
		}
	else if(type == LPI_T_ARG_TYPE_STR)
		{
		if(i == FIRST_ARG) break;
		LpiRegGetArgStrNative(i,&pstr);
		sprintf(ATCA_ProcessVar,"%s\0",pstr);	/* get the argument */
		if((ATCA_Entry = ATCA_ProcessPoint(ATCA_ProcessVar)) != 0)
			{
			switch(ATCA_Entry->type)
				{
				case DBF_FLOAT:
					ATCA_Entry->value.float_value = ca_value;
					ca_put(ATCA_Entry->type,ATCA_Entry->channel_id,&ATCA_Entry->value.float_value);
					break;
				case DBF_LONG:
					ATCA_Entry->value.long_value = ca_value;
					ca_put(ATCA_Entry->type,ATCA_Entry->channel_id,&ATCA_Entry->value.long_value);
					break;
				case DBF_SHORT:
				case DBF_ENUM:
					ATCA_Entry->value.short_value = ca_value;
					ca_put(ATCA_Entry->type,ATCA_Entry->channel_id,&ATCA_Entry->value.short_value);
					break;
				case DBF_CHAR:
					ATCA_Entry->value.byte_value = ca_value;
					ca_put(ATCA_Entry->type,ATCA_Entry->channel_id,&ATCA_Entry->value.byte_value);
					break;
				default:
					break;
				}
			ATCA_SetNewValue(ATCA_Entry);
			ca_pend_event(0.01);
			return(LPI_SUCCESS);		/* all done so leave from here */
			}
		}
	}
return(LPI_SUCCESS);
}
/*
**	This function gets called when Lotus 1-2-3 loads this addin
**
*/
LpiBind(atca_b)
{
lsshort	ATCA_123Status;
lushort	ATCA_ArgType[NUM_ARGS];
int	ATCA_Status;


LPI_SETUP_LOAD;
if(LPI_LOAD_REGISTER != LPI_SUCCESS)
	LpiSignal(LPI_FAILURE);
if(LPI_LOAD_RANGE != LPI_SUCCESS)
	LpiSignal(LPI_FAILURE);
if(LPI_LOAD_CELL != LPI_SUCCESS)
	LpiSignal(LPI_FAILURE);
/*
	Establish access to 'ca_' functions.
*/
ATCA_Status = ca_task_initialize();
if(ATCA_Status != ECA_NORMAL)
	{
#ifdef	DEBUG_ATCA
	fprintf(stderr,"Could not initialize CA. Error code: %s\n",ca_message(ATCA_Status));
#endif
	LpiSignal(LPI_FAILURE);
	}
/*
	Register the new @ function
*/
ATCA_ArgType[0] = LPI_T_ARG_TYPE_STR;				/* specify arg types */
ATCA_123Status = LpiRegAtfunc(GETVALUE_NAME,ATCA_GetValue,1,ATCA_ArgType,LNULL,
	LPI_T_REG_AT_ALWAYS_DIRTY,
	(LPI_T_REG_AT_TYPE_ERR |
	 LPI_T_REG_AT_TYPE_NUM_FLOAT |
	 LPI_T_REG_AT_TYPE_STR_NATIVE |
	 LPI_T_REG_AT_TYPE_NUM_INT));
ATCA_ArgType[0] = LPI_T_ARG_TYPE_NUM | LPI_T_ARG_TYPE_RNG;	/* specify arg types */
ATCA_ArgType[1] = LPI_T_ARG_TYPE_STR;
ATCA_123Status = LpiRegAtfunc(PUTNUMBER_NAME,ATCA_PutNumber,2,ATCA_ArgType,LNULL,
	LPI_T_REG_AT_ALWAYS_DIRTY,
	(LPI_T_REG_AT_TYPE_ERR |
	 LPI_T_REG_AT_TYPE_NUM_FLOAT |
	 LPI_T_REG_AT_TYPE_STR_NATIVE |
	 LPI_T_REG_AT_TYPE_NUM_INT));
#ifdef USE_SYSLOG
/*
	Enable 'syslog' GCT 12-Jan-1995
*/
openlog("123/atca",LOG_PID,LOG_DAEMON);
syslog(LOG_ALERT|LOG_DAEMON,"atca.ad1 loaded...");
#endif
/*
	Initialize the pointers to the table
*/
lstInit((LIST *)&ATCA_Table);
/*
	Install custom exception handler
*/
LpiSignal(ATCA_123Status);
}
/*
**
**	This functions is called when Lotus 1-2-3 unloads this addin
**
*/
LpiUnbind(atca_u)
{
LPI_UNLOAD;
ca_task_exit();
/*
	Recursively free-up any memory allocated while this '@' function was loaded
*/
lstFree((LIST *)&ATCA_Table);			/* delete the list and its free memory */
LpiSignal(LPI_SUCCESS);
}
/*
	This is the search function. It is used to locate the process variable name
	in the ENTRY table. If the match succeeds then a poiner to the entry is
	returned else a NULL is returned;
*/
ENTRY	*ATCA_Search(item)
char	*item;
{
ENTRY	*i;
i = (ENTRY *)lstFirst((LIST *)&ATCA_Table);
while(i)
	{
	if(!strcmp((char *)(&i->var[0]),item))
		return((ENTRY *)i);
	i = (ENTRY *)lstNext((NODE *)i);
	}
return((ENTRY *)i);
}
