/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*****************************************************************
*
*    atv.h
*
*    modifications
*    -------------
*  .01	10-21-96	ems	creation date
*
******************************************************************/


#include <string.h>
#include <stdio.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <Xm/MainW.h>
#include <Xm/Label.h>
#include <Xm/BulletinB.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "atDefs.h"

/* some defines */

#define	ERRMSG_SZ	256
#define	MAJOR_IDX	0
#define	MINOR_IDX	1
#define	INFO_IDX	2

/* define some extenals */

extern int	atvIsModified;	/* start as 0, (not modified ) */
extern int	dbIsOpened;	/* set in atvInitDatabase () */
extern char	errmsgs[ERRMSG_SZ];

extern Widget	atvTopLevel;	/* top level from XtVaAllInitialize () */
extern Widget	atvEditDialog;	/* main container dialog */
extern Widget	atvInfo;	/* used for user decision prompts */
extern Widget	atvAreYouSure;	/* used for user decision promts */

extern CODE4	cb;		/* codebase */
extern DATA4	*alarmTalkDb;	/* return from d4open */
extern FIELD4	*alarmSevr, *annunciation, *spkrDevice;
extern FIELD4	*pageDevice, *autoDevice, *conNumber;
extern FIELD4	*conRedial, *pageNumber, *pageRedial;
extern FIELD4	*autoNumbr1, *autoNumbr2, *autoNumbr3;
extern FIELD4	*autoNumbr4, *autoNumbr5, *autoNumbr6;
extern FIELD4	*autoNumbr7, *autoNumbr8, *autoFailAnsTimeout;
extern FIELD4	*autoRestart, *idTimeout, *repackTimeout;

/* define prototypes */

void	atvCreateAreYouSure (char *, char *);
void	atvCreateEdit (Widget);
void	atvCreateInfo (char *, char *);
void	atvDoDismiss (Widget, XtPointer, XtPointer);
int	atvInitDatabase (void);

