/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*****************************************************************
*
*    atvDatabase.c
*
*    modifications
*    -------------
*  .01	10-21-96	ems	creation date
*
******************************************************************/

#include "atv.h"

FIELD4	*alarmSevr, *annunciation, *spkrDevice;
FIELD4	*pageDevice, *autoDevice, *conNumber;
FIELD4	*conRedial, *pageNumber, *pageRedial;
FIELD4	*autoNumbr1, *autoNumbr2, *autoNumbr3;
FIELD4	*autoNumbr4, *autoNumbr5, *autoNumbr6;
FIELD4	*autoNumbr7, *autoNumbr8, *autoFailAnsTimeout;
FIELD4	*autoRestart, *idTimeout, *repackTimeout;


/************************************************************
*
*    atvInitDatabase ()
*	open /tis4000db/alarmtlk.dbf and map its fields
*
************************************************************/

int	atvInitDatabase (void)
{
    struct stat	statbuff;
    int		status = 0;

    status = stat (AT_DATABASE, &statbuff);
    if (status == -1)
    {
	sprintf (errmsgs, "stat on %s failed",AT_DATABASE);
	return (1);
    }

    d4init (&cb);
#if defined(USECB63) || defined(WIN32)
    cb.errGo = 0;
    cb.errOpen = 0;
    cb.errCreate = 0;
    cb.errFieldName = 0;
#else
    cb.go_error = 0;
    cb.open_error = 0;
    cb.create_error = 0;
    cb.field_name_error = 0;
#endif	USECB63
    if ( (alarmTalkDb = d4open (&cb, AT_DATABASE)) == 0)
    {
	sprintf (errmsgs, "failed to open %s", AT_DATABASE);
	return (1);
    }
    dbIsOpened = 1;
    if ((alarmSevr = d4field (alarmTalkDb, "ALARMSEVER")) == 0)
    {
	sprintf (errmsgs, "did not find ALARMSEVER field");
	return (1);
    }
    if ((annunciation = d4field (alarmTalkDb, "ANNUNCTION")) == 0)
    {
	sprintf (errmsgs, "did not find ANNUNCTION field");
	return (1);
    }
    if ((spkrDevice = d4field (alarmTalkDb, "SPKRDEVICE")) == 0)
    {
	sprintf (errmsgs, "did not find SPKRDEVICE field");
	return (1);
    }
    if ((pageDevice = d4field (alarmTalkDb, "PAGEDEVICE")) == 0)
    {
	sprintf (errmsgs, "did not find PAGEDEVICE field");
	return (1);
    }
    if ((autoDevice = d4field (alarmTalkDb, "AUTODEVICE")) == 0)
    {
	sprintf (errmsgs, "did not find AUTODEVICE field");
	return (1);
    }
    if ((conNumber = d4field (alarmTalkDb, "CONNUMBER")) == 0)
    {
	sprintf (errmsgs, "did not find CONNUMBER field");
	return (1);
    }
    if ((conRedial = d4field (alarmTalkDb, "CONREDIAL")) == 0)
    {
	sprintf (errmsgs, "did not find CONREDIAL field");
	return (1);
    }
    if ((pageNumber = d4field (alarmTalkDb, "PAGENUMBER")) == 0)
    {
	sprintf (errmsgs, "did not find PAGENUMBER field");
	return (1);
    }
    if ((pageRedial = d4field (alarmTalkDb, "PAGEREDIAL")) == 0)
    {
	sprintf (errmsgs, "did not find PAGEREDIAL field");
	return (1);
    }
    if ((autoNumbr1 = d4field (alarmTalkDb, "AUTONUMBR1")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR1 field");
	return (1);
    }
    if ((autoNumbr2 = d4field (alarmTalkDb, "AUTONUMBR2")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR2 field");
	return (1);
    }
    if ((autoNumbr3 = d4field (alarmTalkDb, "AUTONUMBR3")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR3 field");
	return (1);
    }
    if ((autoNumbr4 = d4field (alarmTalkDb, "AUTONUMBR4")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR4 field");
	return (1);
    }
    if ((autoNumbr5 = d4field (alarmTalkDb, "AUTONUMBR5")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR5 field");
	return (1);
    }
    if ((autoNumbr6 = d4field (alarmTalkDb, "AUTONUMBR6")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR6 field");
	return (1);
    }
    if ((autoNumbr7 = d4field (alarmTalkDb, "AUTONUMBR7")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR7 field");
	return (1);
    }
    if ((autoNumbr8 = d4field (alarmTalkDb, "AUTONUMBR8")) == 0)
    {
	sprintf (errmsgs, "did not find AUTONUMBR8 field");
	return (1);
    }
    if ((autoFailAnsTimeout = d4field (alarmTalkDb, "AUFAILANST")) == 0)
    {
	sprintf (errmsgs, "did not find AUFAILANST field");
	return (1);
    }
    if ((autoRestart = d4field (alarmTalkDb, "AUTORESTRT")) == 0)
    {
	sprintf (errmsgs, "did not find AUTORESTRT field");
	return (1);
    }
    if ((idTimeout = d4field (alarmTalkDb, "IDTIMEOUT")) == 0)
    {
	sprintf (errmsgs, "did not find IDTIMEOUT field");
	return (1);
    }
    if ((repackTimeout = d4field (alarmTalkDb, "REPACKTOUT")) == 0)
    {
	sprintf (errmsgs, "did not find REPACKTOUT field");
	return (1);
    }
    return (0);
}
