/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*****************************************************************
*
*    atvUtils.c
*
*    modifications
*    -------------
*  .01	10-21-96	ems	creation date
*
******************************************************************/

#include "atv.h"


/*******************************************
*
*    atvCreateAreYouSure ()
*	callback for atvDismiss ()
*
*******************************************/

void	atvCreateAreYouSure(char *s,char *t)
{
    XmString	str,title,noString,yesString;

    if(!atvAreYouSure)
    {
	noString = XmStringCreateLtoR ("Cancel",XmSTRING_DEFAULT_CHARSET);
	yesString = XmStringCreateLtoR ("Yes",XmSTRING_DEFAULT_CHARSET);
	atvAreYouSure = (Widget)XmCreateQuestionDialog (atvTopLevel,"QUESTION",NULL,0);
	/* CANCEL or HELP in this one */
	XtUnmanageChild((Widget)XmMessageBoxGetChild (atvAreYouSure,XmDIALOG_HELP_BUTTON));	
	XtVaSetValues (atvAreYouSure,
		       XmNcancelLabelString,noString,
		       XmNokLabelString,yesString,
		       XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL,
		       XmNmessageAlignment,XmALIGNMENT_CENTER,
		       XmNx,400,
		       XmNy,400,
		       NULL);
      XmStringFree (yesString);
      XmStringFree (noString);
    }
    str = XmStringCreateLtoR (s,XmSTRING_DEFAULT_CHARSET);
    title = XmStringCreate (t,XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(atvAreYouSure,
		  XmNmessageString,str,
		  XmNdialogTitle,title,
		  NULL);
    XmStringFree(title);
    XmStringFree(str);
    XtManageChild(atvAreYouSure);
    return;
}


/**********************************************
*
*    atvCreateInfo ()
*	create informatinal dialog box
*
**********************************************/

void	atvCreateInfo (char *msg, char *t)
{
    XmString	message, title;

    if (atvInfo == 0)
    {
	atvInfo = (Widget)XmCreateInformationDialog (atvTopLevel, "INFO", NULL, 0);
	XtUnmanageChild ((Widget)XmMessageBoxGetChild (atvInfo, XmDIALOG_HELP_BUTTON));
	XtUnmanageChild ((Widget)XmMessageBoxGetChild (atvInfo, XmDIALOG_CANCEL_BUTTON));
	XtVaSetValues (atvInfo,
		       XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
		       XmNmessageAlignment, XmALIGNMENT_CENTER,
		       XmNx, 400, 
		       XmNy, 400, 
		       NULL);
    }
    message = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);
    title = XmStringCreate (t, XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues (atvInfo,
		   XmNmessageString, message,
		   XmNdialogTitle, title,
		   NULL);
    XmStringFree (message);
    XmStringFree (title);
    XtManageChild (atvInfo);

    return;
}
