/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#ifdef WIN32
#define	DEFAULT_PATH	"\\tis4000db\\"
#else
#define	DEFAULT_PATH	"/tis4000db/"
#endif WIN32

/* define dbase field names */
#define	AL_EGUTAG	"EGUTAG"
#define	AL_AUTOMATIC	"AUTOMATIC"
#define	AL_CLOSED	"CLOSEDLOOP"
#define	AL_MODE		"MODE"

/* define string values for the AUTOMATIC and CLOSEDLOOP fields */
#define	AL_AUTO_MODE	"Automatic"
#define	AL_MANUAL_MODE	"Manual"
#define	AL_SUPER_MODE	"Supervisory"
#define	AL_CLOSED_MODE	"Closed loop"

/* miscellaneous defines */
#define	AL_NOT_USED	"NOT USED"
#define	AL_NO_DATA	"N/A"
#define	AL_ENABLED	"Enabled"
#define	AL_DISABLED	"Disabled"
#define	MAX_LINES_PER_PAGE	60
#define	MAX_TIME_TO_WAIT	10.0

struct	AlrmgrpPoint
{
    struct AlrmgrpPoint	*NextPoint;
    char		name[30];
    char		type[18];
    char		desc[30];
    char		value[30];
    char		egu_tag[18];
    char		stat[30];
    char		tcnt[16];
    char		mode[18];
    char		onalarm;
    char		onscan;
    int			got_data;
    int			got_tcnt;
    chid		pCh;
    chid		tcntCh;
};

struct AlrmgrpPoint	*FirstPoint = (struct AlrmgrpPoint *)0;

C4CODE	cb;

D4DATA	*pvmap;

D4DATA	*accum;
T4TAG	*acctag;
F4FIELD	*accegu;
F4FIELD	*accauto;
static int accopen = 0;

D4DATA	*ai;
T4TAG	*aitag;
F4FIELD	*aiegu;
F4FIELD	*aiauto;
static int aiopen = 0;

D4DATA	*ao;
T4TAG	*aotag;
F4FIELD	*aoegu;
F4FIELD	*aoclosed;
static int aoopen = 0;

D4DATA	*bi;
T4TAG	*bitag;
F4FIELD	*biauto;
static int biopen = 0;

D4DATA	*bo;
T4TAG	*botag;
F4FIELD	*boclosed;
static int boopen = 0;

D4DATA	*calc;
T4TAG	*calctag;
F4FIELD	*calcegu;
F4FIELD	*calcauto;
static int calcopen = 0;

D4DATA	*datamove;
T4TAG	*dmtag;
F4FIELD	*dmauto;
static int dmopen = 0;

D4DATA	*deadtime;
T4TAG	*dttag;
F4FIELD	*dtegu;
F4FIELD	*dtauto;
static int dtopen = 0;

D4DATA	*fanout;
T4TAG	*fanouttag;
static int fanoutopen = 0;

D4DATA	*leadlag;
T4TAG	*lltag;
F4FIELD	*llegu;
F4FIELD	*llauto;
static int llopen = 0;

D4DATA	*mbbi;
T4TAG	*mbbitag;
F4FIELD	*mbbiauto;
static int mbbiopen = 0;

D4DATA	*mbbo;
T4TAG	*mbbotag;
F4FIELD	*mbboclosed;
static int mbboopen = 0;

D4DATA	*pid;
T4TAG	*pidtag;
F4FIELD	*pidegu;
F4FIELD	*pidauto;
static int pidopen = 0;

D4DATA	*pipeData;
T4TAG	*pipetag;
F4FIELD	*pipemode;
static int pipeopen = 0;

D4DATA	*pot;
T4TAG	*pottag;
F4FIELD	*potmode;
static int potopen = 0;

D4DATA	*pto;
T4TAG	*ptotag;
F4FIELD	*ptoegu;
F4FIELD	*ptoclosed;
static int ptoopen = 0;

D4DATA	*pump;
T4TAG	*pumptag;
F4FIELD	*pumpmode;
static int pumpopen = 0;

D4DATA	*ramp;
T4TAG	*ramptag;
F4FIELD	*rampegu;
F4FIELD	*rampauto;
static int rampopen = 0;

D4DATA	*sel;
T4TAG	*seltag;
F4FIELD	*selegu;
F4FIELD	*selauto;
static int selopen = 0;

D4DATA	*sigchar;
T4TAG	*sigtag;
F4FIELD	*sigegu;
F4FIELD	*sigauto;
static int sigopen = 0;

D4DATA	*state;
T4TAG	*statetag;
static int stateopen = 0;

D4DATA	*strngin;
T4TAG	*strintag;
F4FIELD	*strinauto;
static int strinopen = 0;

D4DATA	*strngout;
T4TAG	*strouttag;
F4FIELD	*stroutclosed;
static int stroutopen = 0;

D4DATA	*tank4;
T4TAG	*tank4tag;
F4FIELD	*tank4mode;
static int tank4open = 0;

D4DATA	*td;
T4TAG	*tdtag;
F4FIELD	*tdclosed;
static int tdopen = 0;

D4DATA	*udb;
T4TAG	*udbtag;
static int udbopen = 0;

D4DATA	*valve;
T4TAG	*valvetag;
F4FIELD	*valvemode;
static int valveopen = 0;

D4DATA	*waveform;
T4TAG	*wftag;
F4FIELD	*wfegu;
static int wfopen = 0;

