#ifndef	alcfgdatabaseclassHXX
#define	alcfgdatabaseclassHXX

extern "C"
{
#include "alarmDefs.h"
}

//** SOME DEFINES *******************************************************************

// define the name of the base group name
#define	ALCFG_MAIN_GROUP	"MAIN"

// defines for some database files
#define ALCFG_TREE_FILE		"atree"
#define	ALCFG_GROUP_FILE	"agroups"
#define	ALCFG_INFO_FILE		"ainfo"
#define	ALCFG_PRINTER_FILE	"printers"

// defines for fields

// GROUPNAME in ainfo and agroups
#define	FLD_GROUPNAME		"GROUPNAME"

// atree fields
#define	FLD_PARENT		"PARENT"
#define	FLD_CHILD		"CHILD"

// ainfo fields
#define	FLD_ASCRIPT		"ASCRIPT"
#define	FLD_AUXASCRIPT		"AUXASCRIPT"
#define	FLD_MSCRIPT		"MSCRIPT"
#define	FLD_AUXMSCRIPT		"AUXMSCRIPT"
#define	FLD_DISPNAME		"DISPNAME"
#define	FLD_HELPTOPIC		"HELPTOPIC"
#define	FLD_GUIDANCE		"GUIDANCE"
#define	FLD_MAJPRINT		"MAJPRINT"
#define	FLD_MINPRINT		"MINPRINT"
#define	FLD_INFOPRINT		"INFOPRINT"
#define	FLD_EVPRINT		"EVPRINT"
#define	FLD_NORMPRINT		"NORMPRINT"
#define	FLD_AMAJPRINT		"AMAJPRINT"
#define	FLD_AMINPRINT		"AMINPRINT"
#define	FLD_AINFOPRINT		"AINFOPRINT"
#define	FLD_AEVPRINT		"AEVPRINT"
#define	FLD_ANORMPRINT		"ANORMPRINT"
#define	FLD_MAJSOUND		"MAJSOUND"
#define	FLD_MAJRATE		"MAJRATE"
#define	FLD_MINSOUND		"MINSOUND"
#define	FLD_MINRATE		"MINRATE"
#define	FLD_INFOSOUND		"INFOSOUND"
#define	FLD_INFORATE		"INFORATE"
#define	FLD_EVSOUND		"EVSOUND"
#define	FLD_EVRATE		"EVRATE"
#define	FLD_AMAJSOUND		"AMAJSOUND"
#define	FLD_AMAJRATE		"AMAJRATE"
#define	FLD_AMINSOUND		"AMINSOUND"
#define	FLD_AMINRATE		"AMINRATE"
#define	FLD_AINFOSOUND		"AINFOSOUND"
#define	FLD_AINFORATE		"AINFORATE"
#define	FLD_AEVSOUND		"AEVSOUND"
#define	FLD_AEVRATE		"AEVRATE"
#define	FLD_AUXSELPV		"AUXSELPV"

// printers fields
#define	FLD_NAME		"NAME"


//** ALARM CONFIG DATABASE CLASS **********************************************

class alCfgDatabaseClass
{
    
    // resource to alarmConfig
    vresource	alCfgvresource;	

    // place to store current database path
    char	dbasePath [ALCFG_MAX_DATABASE_PATH];	

    // set to non-zero if errors from constructor
    int		initErrors;		

    // function to load the database
    int alCfgDatabaseInit (char *dbPath);

    alCfgMainDialogClass	*mainDialog;


public:

    // constructor
    alCfgDatabaseClass (char *dbPath, vresource alCfgvresource);

    // destructor
    ~alCfgDatabaseClass (void);

    // function to handle dbasePath
    char *getDbasePath (void)
	{ return (dbasePath); }

    // function to return initErrors
    int getInitErrors (void) 
	{ return (initErrors); }

    // functions to handle the mainDialog
    void storeMainDialog (alCfgMainDialogClass *mnDialog) 
	{ mainDialog = mnDialog; }
    alCfgMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // functions for the group list stored in alCfgApplication class
    void writeGroupList (vlist *groupList);
    void loadGroupList (vlist *groupList);

    // function for alarm tree list, alCfgTreelistClass.<hxx,cxx>
    int writeTreeList (void);

    //functions for the printer list stored in alCfgApplication
    void loadPrinterList (vlist *printList);
    void writePrinterList (vlist *printerList);

    // functions for the info parameters

    int  createInfoTable (void);
    void getInfoData (TREENODE_PTR node);
    void mainInfoTableFields (void);
    void mapInfoTableFields (void);
    void writeInfoRecord (TREENODE_PTR node);


    // pointers to various database tables (.dbf)
    DB_TABLE_PTR	alCfgTreeTable;
    DB_TABLE_PTR	alCfgInfoTable;
    DB_TABLE_PTR	alCfgPrinterTable;
    DB_TABLE_PTR	alCfgGroupTable;

    // pointers to some database fields

    // agroups.dbf
    DB_FIELD_PTR	grpGrpNameFld;

    // atree.dbf
    DB_FIELD_PTR	parentFld;
    DB_FIELD_PTR	childFld;

    // ainfo.dbf
    DB_FIELD_PTR	infoGrpNameFld;
    DB_FIELD_PTR	ascriptFld;
    DB_FIELD_PTR	auxascriptFld;
    DB_FIELD_PTR	mscriptFld;
    DB_FIELD_PTR	auxmscriptFld;
    DB_FIELD_PTR	dispnameFld;
    DB_FIELD_PTR	helptopicFld;
    DB_FIELD_PTR	guidanceFld;
    DB_FIELD_PTR	majprintFld;
    DB_FIELD_PTR	minprintFld;
    DB_FIELD_PTR	infoprintFld;
    DB_FIELD_PTR	evprintFld;
    DB_FIELD_PTR	normprintFld;
    DB_FIELD_PTR	amajprintFld;
    DB_FIELD_PTR	aminprintFld;
    DB_FIELD_PTR	ainfoprintFld;
    DB_FIELD_PTR	aevprintFld;
    DB_FIELD_PTR	anormprintFld;
    DB_FIELD_PTR	majsoundFld;
    DB_FIELD_PTR	majrateFld;
    DB_FIELD_PTR	minsoundFld;
    DB_FIELD_PTR	minrateFld;
    DB_FIELD_PTR	infosoundFld;
    DB_FIELD_PTR	inforateFld;
    DB_FIELD_PTR	evsoundFld;
    DB_FIELD_PTR	evrateFld;
    DB_FIELD_PTR	amajsoundFld;
    DB_FIELD_PTR	amajrateFld;
    DB_FIELD_PTR	aminsoundFld;
    DB_FIELD_PTR	aminrateFld;
    DB_FIELD_PTR	ainfosoundFld;
    DB_FIELD_PTR	ainforateFld;
    DB_FIELD_PTR	aevsoundFld;
    DB_FIELD_PTR	aevrateFld;
    DB_FIELD_PTR	auxselpvFld;

    // printers.dbf
    DB_FIELD_PTR	nameFld;
    DB_FIELD_PTR	printers[MAX_PRINTERS_PER_GROUP];
};

#endif	alcfgdatabaseclassHXX
