#ifndef	alcfgmaindialogclassHXX
#define	alcfgmaindialogclassHXX

//** MAIN DIALOG *******************************************************************

// enum values used for the vcommandSelector::Issue
enum
{
    QUIT_MENUITEM = 0,
    NEW_GROUP_MENUITEM,
    DELETE_GROUP_MENUITEM,
    INSERT_GROUP_MENUITEM,
    REMOVE_GROUP_MENUITEM,
    CUT_SUBTREE_MENUITEM,
    PASTE_CLIPBOARD_MENUITEM,
    MOD_PARAMS_MENUITEM,
    CLEAR_PARAMS_MENUITEM,
    EDIT_PRINTER_MENUITEM,
    CREATE_PRINTER_MENUITEM,
    DELETE_PRINTER_MENUITEM,
    MENUITEM_COUNT
};


class alCfgMainListClass;

class	alCfgMainDialogClass : public vdialog
{
    // pointer to application
    alCfgApplication	*alCfgApp;

    // resource for the main dialog
    vresource		mainDialogResource;

    // resource for dialog titles
    vresource		dialogTitles;

    // resource for messages
    vresource		dialogMessages;

    // resource for images
    vresource		imageResource;

    // place to store internal names for main dialog menu items
    const vname		*commandNames[MENUITEM_COUNT];

    // the main dialog's vlistitem where we write the alrm group tree
    alCfgMainListClass	*mainDialogList;

    // help menu stuff
    vmenu	*helpMenu;
    TisAbout	*tisAbout;
    void	BuildAboutMenu (void);

    // flags
    int	loadInitErrors;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alCfgMainDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(alCfgMainDialogClass, vdialog);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // override
    void Open (void);

    // remember the paste menu item
    vmenuItem	*pasteMenuItem;

    // functions to the application wrapper
    void storeAlCfgApp (alCfgApplication *app) 
	{ alCfgApp = app; }
    alCfgApplication *getApplication (void) 
	{ return (alCfgApp); }

    // store resources, mains is set in its LoadInit
    void storeMainsResource (vresource res)
	{ mainDialogResource = res; }
    void storeTitlesResource (vresource res) 
	{ dialogTitles = res; }
    void storeMessagesResource (vresource res) 
	{ dialogMessages = res; }

    // return the resources
    vresource getMainDialogResource (void) 
	{ return (mainDialogResource); }
    vresource getTitlesResource (void) 
	{ return (dialogTitles); }
    vresource getMessagesResource (void) 
	{ return (dialogMessages); }

    // function to return other stuff
    alCfgMainListClass *getListView (void)
	{ return (mainDialogList); }
    int getLoadInitErrors (void)
	{ return (loadInitErrors); }
};


// ** CLASS FOR THE MAIN DIALODS MENU COMMANDS *************************************

class  alCfgMainCommand : public vcommandSelector
{

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(alCfgMainCommand);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(alCfgMainCommand, vcommandSelector);

    //override virtual issue function
    int Issue(vdict *);
};

#endif	alcfgmaindialogclassHXX
