#ifndef alarmvuHXX
#define alarmvuHXX

#include "textFilters.hxx"
#include "tisgalaxylib.hxx"

//** SOME DEFINES *********************************************************

// define max database path
#ifndef WIN32
#define	ALVU_MAX_DATABASE_PATH	MAXPATHLEN
#else
#define	ALVU_MAX_DATABASE_PATH	_MAX_PATH
#endif WIN32

// define some shared memory stuff
#ifdef SOLARIS
#define	SHMSIZE	1024
#define	SHMMAX	(SHMSIZE * 1024)
#endif SOLARIS

#define	ALVU_BLINK_LEVEL_DEFAULT	6
#define	ALVU_DATETIME_STRING		"MM/DD/YY HH:MM:SS"

#ifdef WIN32
#define	ALVU_DBPATH			"c:\\tis4000db"
#else
#define	ALVU_DBPATH			"/tis4000db"
#endif WIN32

#define	ALVU_DEFAULT_FILTER_NAME	"default"
#define	ALVU_DEFAULT_GRP_DISPLAY_HGT	105
#define	ALVU_DEFAULT_GRP_DISPLAY_WID	1000
#define	ALVU_MAINS_GROUPNAME		"MAIN"
#define	ALVU_MAX_SENDS_DEFAULT		50
#define	ALVU_MAXITEMS			60
#define	ALVU_MIN_BLINK_LEVEL		0
#define	ALVU_MAX_BLINK_LEVEL		7
#define	ALVU_NEW_VERSION		3
#define	ALVU_SETUP_FILE			"Alarmvu.Setup"

// alarm color init setting
#define	NO_ALARM_COLOR		0x00a000
#define	INFO_ALARM_COLOR	0x00c8ff
#define	EVENT_ALARM_COLOR	0x000000
#define	MINOR_ALARM_COLOR	0xffc800
#define	MAJOR_ALARM_COLOR	0xff0000
#define	VALID_ALARM_COLOR	0xffffff

//** ENUM DEFINITIONS *****************************************************
enum {
    ALVU_ERROR = -1,
    ALVU_SUCCESS,
    ALVU_INFO_NOTICE,
    ALVU_CAUTION_NOTICE,
    ALVU_NUMMISCENUMS
};

//** needed by some existing code
#ifndef True
#define	True	(1 == 1)
#define False	(1 == 0)
#endif True


class alvuMainDialog;

class alvuApplication
{
    int		initErrors;
    int		initedOperPriv;
    int		initedOperTrack;
    int		initedTisGalaxy;

    void	alvuUsage (void);
    int		ContactAlarmMgr (void);
    void	InitPrinter (void);
    void	InitSetup (void);
    int		ReadCmdLineArgs (void);
    void	StartupDisplay (void);

public:

    // class constructor
    alvuApplication (int argCount, char **argList, char *dbpath);

    // class destructor
    ~alvuApplication ();

    int	MapSharedMemory (void);
    void UnMapSharedMemory (void);

    int GetInitErrors (void)
	{ return (initErrors); }

    // application ptr
    vapplication	*alvuApp;

    // ptr to main dialog
    alvuMainDialog	*mainDialog;

    // resources
    vresource		alvuResource;
    vresource		titlesResource;
    vresource		messagesResource;
    vresource		mainDlgResource;
    vresource		menutagsResource;
    vresource		tisGalaxyResource;

    // shared memory stuff
    int			numShrMemSegs;
    int			*shrMemIds;

    // printer 
    vprint		*printer;
    // used by print routines
    int			logicalPixelsY;

    // other stuff
#ifdef WIN32
    SOCKET		alarmhndSocket;
#else
    int			alarmhndSocket;
#endif WIN32
    Filter		shellFilter;
    char		setupFileName [ALVU_MAX_DATABASE_PATH + 1];

};

#endif alarmvuHXX

