#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vprintHEADER

extern "C"
{
#ifdef WIN32
#include <stdio.h>
#include <winsock.h>
// this bit of sillyness is needed because windows #defines AppendMenu
// as #define AppendMenu AppendMenuA, which interfers with galaxy class
// vmenubar::AppendMenu
#undef AppendMenu
#endif WIN32
#include "shareMem.h"
#include "tsDefs.h"
#include "alarmDefs.h"
#include "alarmfil.h"
#include "alarmvu.h"
}

#include "alvu.h"
#include "alarmvu.hxx"
#include "alvuProgressDialog.hxx"
#include "utils.hxx"

extern AckGroupPvPtrs	*ackLists;  // defined in alvuMainDialog.cxx


/*******************************************************************
*
*    alvuProgressDialog Class
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(alvuProgressDialog, vdialog, NULL);

/*******************************************************************
*
*    alvuProgressDialog constructor
*
*******************************************************************/

void alvuProgressDialog::LoadInit (vresource res)
{
    itemsText    = vtextitem::RequestSubLoad (this, alvu_ItemsText);
    cancelButton = alvuProgressCancelButton::RequestSubLoad (this, alvu_CancelButton);

    vdialog::LoadInit (res);

    // store ptr to dialog in buttons
    cancelButton -> StoreProgressDialog (this);
}


/*******************************************************************
*
*    alvuProgressDialog window observer
*
*******************************************************************/

void alvuProgressDialog::ObserveWindow (vevent *event)
{
    if (event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	FreeAckPtrs ();
	Close ();
    }
}

/*******************************************************************
*
*    alvuProgressDialog destructor
*
*******************************************************************/

void alvuProgressDialog::Destroy ()
{
    vdialog::Destroy ();
}

/*******************************************************************
*
*    alvuProgressDialog free ack ptrs function
*
*******************************************************************/

void alvuProgressDialog::FreeAckPtrs ()
{
    AckGroupPvPtrs *agptr = ackLists;
    AckGroupPvPtrs *nextptr;

    while (agptr)
    {
	nextptr = (AckGroupPvPtrs *)(agptr -> link);
	free ((void *)agptr);
	agptr = nextptr;
    }
    ackLists = NULL;
}


/*******************************************************************
*
*    alvuProgressDialog open function
*
*******************************************************************/

void alvuProgressDialog::OpenProgress (int remaining)
{
    // update itemsText field
    UpdateCount (remaining);

    // open the dialog and start a sub event loop, halts the caller
    vdialog::Open();
}

/*******************************************************************
*
*    alvuProgressDialog Update items text field
*
*******************************************************************/

void alvuProgressDialog::UpdateCount (int reminaing)
{
    char buff[32];

    sprintf (buff, "%8.8d", reminaing);
    itemsText -> SetTextScribed (vcharScribeSystem (buff));
}


/*******************************************************************
*
*    alvuProgressCancelButton Class
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(alvuProgressCancelButton, vbutton, NULL);

void alvuProgressCancelButton::ObserveDialogItem (vevent *event)
{
    progressDialog -> FreeAckPtrs ();
    progressDialog -> Close ();
}

