#ifndef	colordialogHXX
#define	colordialogHXX

class SevButtons;
class RedSlider;
class GreenSlider;
class BlueSlider;
class ColorAcceptButton;
class ColorCancelButton;

// *** FILTER DIALOG CLASS *********************************************

class ColorDialog : public vdialog
{
    alvuApplication	*app;

    void InitSliders (void);
    void LoadColors (long colors[NUM_SEV_COLORS]);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ColorDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ColorDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenColor (alvuApplication *app, long *colors);

    SevButtons		*sevButtons[NUM_SEV_COLORS];
    RedSlider		*redSlider;
    vtextitem		*redValue;
    GreenSlider		*greenSlider;
    vtextitem		*greenValue;
    BlueSlider		*blueSlider;
    vtextitem		*blueValue;
    ColorAcceptButton	*acceptButton;
    ColorCancelButton	*cancelButton;
 
    int	colorsOk;
    long newColors [NUM_SEV_COLORS];
    int	 selected;
    void GetNewColors (long *colors);
    void Select (int i);

};


// *** SEV BUTTON CLASS **********************************************

class SevButtons : public vbutton
{
    ColorDialog	*colorDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(SevButtons);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(SevButtons, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }

    // index into sev button array
    int index;
};


// *** RED SLIDER CLASS **********************************************

class RedSlider : public vslider
{
    ColorDialog	*colorDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(RedSlider);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(RedSlider, vslider);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }
};


// *** GREEN SLIDER CLASS **********************************************

class GreenSlider : public vslider
{
    ColorDialog	*colorDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(GreenSlider);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(GreenSlider, vslider);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }
};


// *** BLUE SLIDER CLASS **********************************************

class BlueSlider : public vslider
{
    ColorDialog	*colorDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(BlueSlider);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(BlueSlider, vslider);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }
};


// *** ACCEPT BUTTON CLASS **********************************************

class ColorAcceptButton : public vbutton
{
    ColorDialog	*colorDialog;

public:

    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ColorAcceptButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ColorAcceptButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }
};


// *** CANCEL BUTTON CLASS **********************************************

class ColorCancelButton : public vbutton
{
    ColorDialog	*colorDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(ColorCancelButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(ColorCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreColorDialog (ColorDialog *dlg)
	{ colorDialog = dlg; }
};

#endif	colordialogHXX

