#ifndef	onlinedialogHXX
#define	onlinedialogHXX

class OneLineOkButton;
class OneLineCancelButton;

enum OneLineTypes 
{
    ONELINE_PRINT_DEVICE = 0,
    ONELINE_FILENAME
};
#define	ONELINE_TEXTSIZE    256

// *** ONELINE DIALOG CLASS *********************************************

class OneLineDialog : public vdialog
{
    alvuApplication	*app;
    vstr		*title;
    vchar		oneLineText[ONELINE_TEXTSIZE];
    int			oneLineType;
    void SetDialogTitle (void);

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(OneLineDialog);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(OneLineDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void OpenOneLine (alvuApplication *app, int lineType);

    vtextitem		*textEntry;
    OneLineOkButton	*okButton;
    OneLineCancelButton	*cancelButton;

    // handle oneLineText
    vchar *GetOneLineText (void)
	{ return (oneLineText); }
};


// *** OK BUTTON CLASS **********************************************

class OneLineOkButton : public vbutton
{
    OneLineDialog	*oneLineDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(OneLineOkButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(OneLineOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreOneLineDialog (OneLineDialog *dlg)
	{ oneLineDialog = dlg; }
};


// *** CANCEL BUTTON CLASS **********************************************

class OneLineCancelButton : public vbutton
{
    OneLineDialog	*oneLineDialog;

public:
    // overrides for vkindTyped
    vkindTYPED_FULL_DECLARATION(OneLineCancelButton);

    // the default versions of necessary constructors/destructors
    vloadableINLINE_CONSTRUCTORS(OneLineCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // class extensions
    void StoreOneLineDialog (OneLineDialog *dlg)
	{ oneLineDialog = dlg; }
};

#endif	onlinedialogHXX
