/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <sys/time.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>

#include "elfapi.h"
#include "apxfunc.h"
#include "apxdefs.h"
#include "avl.h"
#include "../newtrend/trendDefs.h"
#include "../newtrend/oracleSnap.h"
#include "../newtrend/oracleSnapLib.h"
#include "../newtrend/archiveLib.h"
#define MAX_ARRAY_SIZE 2000


int     atcaCompare(void *,void *);
ENTRY	*atcaProcessPoint(char *point);
elfData	atcaSetNewValue(ENTRY *node);
void	atcaMonitor(struct event_handler_args arg);
void	atcaRead(struct	event_handler_args arg);
void	atcaConnect(struct connection_handler_args arg),atdbMonthDay(int, int, int *,int *);
void	atcaSignalHandler(int),atdbSplitDate(double,int *,int *,int *),atdbSplitTime(double,int *,int *,int *);
void	apxGetMemory(int size);
time_t	apxConvertTime(double date,double time);
char	msg[80];
float	tempvalue;
char	tempstatus[4];
static char daytab[2][13] =
{
  {0,31,28,31,30,31,30,31,31,30,31,30,31},
  {0,31,29,31,30,31,30,31,31,30,31,30,31}
};
#define	APX_ERR_SUCCESS		0
#define	APX_ERR_NORECORD	1
#define	APX_ERR_BADYEAR		2
#define	APX_ERR_SEEKERR		3
#define	APX_ERR_SKIPERR		4
#define	APX_ERR_NODATA		5
#define	APX_ERR_BLANK		6
char	*errorMsg[] =
{
  "Success",
  "Record not found",
  "Incorrect year",
  "Error from seek",
  "Error from skip",
  "No data for %s",
  "Data was blank",
  "Error opening ar_snap.dbf",
  "Arg must be string",
  "Invalid arg type",
  "Oracle error"
};
AVL_TREE *atcaTree;

OracleDesc    *apxOracleDesc;
/*
  Pointers to dynamic arrays sized by atdbCount GCT 25-Sep-1997
*/
static double *apxValue = 0;
static double *apxValue2 = 0;
static unsigned char **apxStatus = 0;
static int atdbCount = 0;

elfData AxDispatch(int funcId,elfData funcData)
{
elfData	rData = NULL;
elfData rArray;		/* 1-jul-1997 new for array return */
ENTRY	*atcaEntry;
char	atcaProcessVar[PVNAME_SZ+FLDNAME_SZ+1],atdbRed1[RED_STR_SIZE],atdbRed2[RED_STR_SIZE];
double	floatArg,dispLo,dispHi;
double atdbDate,atdbTime;
int	intArg,atdbSize;
int	i,atdbSpan;
int	atcaStatus = 0;
char	charArg[81],eguTag[20];
long	atdbRate;
time_t	apxTime;
char *sptr;
/*
  SnapRec structure for data returns from oracle wrapper functions
*/
elfData returnArray;
double testArray[10];
char statBytes[4];
switch(funcId)
  {
  case ARRAY_TEST:
    returnArray = AxMakeArray(10);
    for(i = 0;i < 10;i++)
      {
	testArray[i] = (i+1)*2.5;
	returnArray = AxAddFloatToArray(returnArray,i,testArray[i]);
      }
    rData = returnArray;
    break;
  case GET_VALUE:
    strcpy(atcaProcessVar,AxStrPtrFromDataPtr(funcData));
    if((atcaEntry = atcaProcessPoint(atcaProcessVar)) != 0)
      {
	atcaStatus = ca_pend_io(0.01);
	for(i=0;i<100;i++)
	  {
	    if(atcaStatus != ECA_TIMEOUT)
	      atcaStatus = ca_pend_io(0.01);
	    else
	      break;
	  }
 	if(atcaEntry->valid)
 	  rData = atcaSetNewValue(atcaEntry);		/* set the new return value */
      }
    else
      rData = AxMakeStrData(strlen(msg),msg);
    break;
  case PUT_VALUE:
    /* First argument MUST be the point nameas a string */
    rData = AxArrayElement(funcData,NAME_ARG);
    if(!AxIsString(rData))
      {
	AxError(2,errorMsg[8],"PUTVALUE");
	return(rData);
      }
    strcpy(atcaProcessVar,AxStrPtrFromDataPtr(rData));	/* get the point name and copy to atcaProcessVar */
    if((atcaEntry = atcaProcessPoint(atcaProcessVar)) != 0)
	{
	  rData = AxArrayElement(funcData,VALUE_ARG);
	  if(AxIsFloat(rData))				/* determine data type from arg list */
	    {
	      floatArg = AxFloatFromDataPtr(rData);
	      ca_put(OLD_DBF_DOUBLE,atcaEntry->channel_id,&floatArg);
	    }
	  else if(AxIsInt(rData))			/* convert to float here */
	    {
	      intArg = AxIntFromDataPtr(rData);
	      floatArg = intArg;
	      ca_put(OLD_DBF_DOUBLE,atcaEntry->channel_id,&floatArg);
	    }
	  else if(AxIsString(rData))
	    {
	      strcpy(charArg,AxStrPtrFromDataPtr(rData));
	      ca_put(OLD_DBF_STRING,atcaEntry->channel_id,&charArg);
	    }
	  else
	    {
	      AxError(2,errorMsg[9],"PUTVALUE");
	      return(rData);
	    }
	ca_pend_io(0);
/* 	rData = NULL; */
	return(rData);
	}
    break;
  case GET_HTREND:
    AxDecomposeArray(funcData,"cddiicc",atcaProcessVar,PVNAME_SZ,	/* Name */
		     &atdbDate,						/* Date */
		     &atdbTime,						/* Time */
		     &atdbSpan,						/* Duration for each cell */
		     &atdbSize,						/* number of cells  1-jul-1997 new for array return */
		     atdbRed1,RED_STR_SIZE,				/* reduction in file */
		     atdbRed2,RED_STR_SIZE);				/* desired reduction */
    apxTime = apxConvertTime(atdbDate,atdbTime);
/*
	Setup reduction method from file
*/
    for(i = 0;atdbRed1[i];i++) atdbRed1[i] = toupper(atdbRed1[i]);
    for(i = 0;atdbRed2[i];i++) atdbRed2[i] = toupper(atdbRed2[i]);
/*
	Get the sample.
*/
    apxGetMemory(atdbSize);			/* get some memory to hold values */
    if(!GetSnapValues(atcaProcessVar, atdbRed1,
		      atdbRed2, atdbSpan,
		      apxTime, &atdbRate,
		      eguTag, &dispLo,
		      &dispHi, atdbSize,
		      apxValue, apxStatus,
		      apxValue2))
      {
	AxError(2,errorMsg[10],"GETHTREND");
	return(rData);
      }
    rArray = AxMakeArray(atdbSize);		/* 1-jul-1997 new for array return */
    sptr = (char *)apxStatus;
    for(i = 0;i < atdbSize;i++)
      {
	if((char)sptr[i*3] == (char)0xff)
	  apxValue[i] = 0;
	rArray = AxAddFloatToArray(rArray,i,apxValue[i]);
      }
    rData = rArray;
    return(rData);
    break;
  case GET_HSTATUS:
    AxDecomposeArray(funcData, "cddiicc",
		     atcaProcessVar, PVNAME_SZ,
		     &atdbDate, &atdbTime,
		     &atdbSpan, &atdbSize,
		     atdbRed1, RED_STR_SIZE,
		     atdbRed2, RED_STR_SIZE);
    apxTime = apxConvertTime(atdbDate,atdbTime);
/*
	Setup reduction method from file
*/
    for(i = 0;atdbRed1[i];i++) atdbRed1[i] = toupper(atdbRed1[i]);
    for(i = 0;atdbRed2[i];i++) atdbRed2[i] = toupper(atdbRed2[i]);
/*
	Get the sample.
*/
    rData = NULL;
    apxGetMemory(atdbSize);			/* get some memory to hold values */
    memset((char *)apxStatus,' ',atdbSize*3);
    if(!GetSnapValues(atcaProcessVar, atdbRed1,
		      atdbRed2, atdbSpan,
		      apxTime, &atdbRate,
		      eguTag, &dispLo,
		      &dispHi, atdbSize,
		      apxValue, apxStatus,
		      apxValue2))
      {
	AxError(2,errorMsg[10],"GETHSTATUS");
	return(rData);
      }
    rArray = AxMakeArray(atdbSize);		/* 1-jul-1997 new for array return */
    sptr = (char *)apxStatus;
    for(i=0;i < atdbSize;i++)
      {
	if((char)sptr[i*3] == (char)0xff)       /* check for No Data */
	  strcpy(statBytes,"   ");
	else
	  memcpy(statBytes,(char *)&sptr[i*3],3);
	statBytes[3] = 0;
	rArray = AxAddStrToArray(rArray,i,statBytes);
      }
    rData = rArray;
    return(rArray);
    break;
  case INIT_MACROS:
    /*
      Init the Channel Access stuff first...
      */
    atcaTree = avl_init(atcaCompare);
    atcaStatus = ca_task_initialize();
    rData = AxMakeIntData(atcaStatus);
    /*
      Init database(Oracle) stuff next...
      */
    OpenOracle();					/* start oracle initialization */
    /*
      Establish signal handlers for command line exiting.
      */
    signal(SIGINT,atcaSignalHandler);
    signal(SIGHUP,atcaSignalHandler);
    break;
  }
return(rData);
}
ENTRY	*atcaProcessPoint(char *point)
{
  ENTRY	*atcaEntry,entry,*p1;
  chid	atcaChid;
  long	atcaStatus;
  evid	evID;						/* must have for NEW CA. GCT 30-Mar-1994 */
  char	msg[80];
  /*
    search tree for occurance of 'point' string. If found then
    return pointer to it . Else make entry in tree
    and attach channel to event handler.
    */
  
  sprintf(&entry.var[0],"%s\0",point);				/* copy the point name */
  if((atcaEntry = (ENTRY *)avl_findsym(atcaTree,&entry)) == 0)
    {
      if((atcaEntry = (ENTRY *)avl_newnode(ENTRY_SIZE)) == 0)		/* get some memory */
	{
	  sprintf(msg,"Can't allocate memory for PV:%s\n",point);
	  return(0);
	}
      sprintf(&atcaEntry->var[0],"%s\0",point);  		/* copy the point name */
      if((p1 = avl_insert(atcaTree,atcaEntry)) != NULL)
	avl_freenode(atcaEntry);
      if((atcaStatus = ca_build_read_and_monitor(point,atcaConnect,atcaEntry,atcaRead,atcaEntry,atcaMonitor,atcaEntry,&atcaChid,&evID)) != ECA_NORMAL)
	{
	  avl_freenode(atcaEntry);
	  sprintf(msg,"Problem with ca_build_read_and_monitor...%s\n",ca_message(atcaStatus));
	  return(0);
	}
      atcaEntry->lastvalue.float_value = 0.0;			/* in case protected on startup */
      atcaEntry->laststring[0] = '\0';			       	/* zero length string too. */
      atcaEntry->type = ca_field_type(atcaChid);		/* this is for both 'SET' functions */
      atcaEntry->channel_id = atcaChid;			       	/* for output points */
      atcaEntry->valid = 0;				       	/* not valid until first report */
      atcaChid->paddr = (void *)atcaEntry;		       	/* save here for connection event */
      ca_pend_io(MIN_TIMEOUT);
    }
  return(atcaEntry);
}
elfData	atcaSetNewValue(ENTRY *node)
{
  elfData	retData;
  switch(node->type)
    {
    case OLD_DBR_STS_FLOAT:
    case OLD_DBR_STS_DOUBLE:
    case OLD_DBR_CTRL_FLOAT:
    case OLD_DBR_CTRL_DOUBLE:
      retData = AxMakeFloatData(node -> value.float_value);
      break;
    case OLD_DBR_STS_CHAR:
    case OLD_DBR_CTRL_CHAR:
      retData = AxMakeIntData(node -> value.byte_value & 0xff);
      break;
    case OLD_DBR_STS_LONG:
    case OLD_DBR_CTRL_LONG:
      retData = AxMakeIntData(node -> value.long_value & 0xffffffff);
      break;
    case OLD_DBR_STS_SHORT:
    case OLD_DBR_STS_ENUM:
    case OLD_DBR_CTRL_SHORT:
    case OLD_DBR_CTRL_ENUM:
      retData = AxMakeIntData(node -> value.short_value & 0xffff);
      break;
    case OLD_DBR_STS_STRING:
    case OLD_DBR_CTRL_STRING:
      retData = AxMakeStrData(strlen(&node->string[0]),&node->string[0]);
      break;
    }
  return(retData);
}
void	atcaMonitor(struct event_handler_args arg)
{
  ENTRY	*node;

  node = arg.usr;					/* address of the ENTRY node for this point */
  node -> type = arg.type;			/* value type */
  node -> valid = 1;				/* value is good from now on. Use old value if "calc" rate > report rate */
  switch(arg.type)
    {
    case OLD_DBR_STS_DOUBLE:
      node -> value.float_value = ((struct dbr_sts_double *)arg.dbr)->value;
      break;
    case OLD_DBR_STS_FLOAT:
      node -> value.float_value =  ((struct dbr_sts_float *)arg.dbr)->value;
      break;
    case OLD_DBR_STS_CHAR:
      node -> value.byte_value = ((struct dbr_sts_char *)arg.dbr)->value;
      break;
    case OLD_DBR_STS_LONG:
      node -> value.long_value = ((struct dbr_sts_long *)arg.dbr)->value;
      break;
    case OLD_DBR_STS_SHORT:
    case OLD_DBR_STS_ENUM:
      node -> value.short_value = ((struct dbr_sts_short *)arg.dbr)->value;
      break;
    case OLD_DBR_CTRL_STRING:
    case OLD_DBR_STS_STRING:
      strcpy(node -> string, ((struct dbr_sts_string *)arg.dbr)->value);
      break;
    case OLD_DBR_CTRL_DOUBLE:
      node -> value.float_value = ((struct dbr_ctrl_double *)arg.dbr)->value;
      break;
    case OLD_DBR_CTRL_FLOAT:
      node -> value.float_value =  ((struct dbr_ctrl_float *)arg.dbr)->value;
      break;
    case OLD_DBR_CTRL_CHAR:
      node -> value.byte_value = ((struct dbr_ctrl_char *)arg.dbr)->value;
      break;
    case OLD_DBR_CTRL_LONG:
      node -> value.long_value = ((struct dbr_ctrl_long *)arg.dbr)->value;
      break;
    case OLD_DBR_CTRL_SHORT:
    case OLD_DBR_CTRL_ENUM:
      node -> value.short_value = ((struct dbr_ctrl_short *)arg.dbr)->value;
      break;
    }
}
/*
	Called after ca_build_read_and_monitor. same as above.
*/
void	atcaRead(struct	event_handler_args arg)
{
  atcaMonitor(arg);
}
/*
	Connection handler. Used to finish-up build_and_read...
*/
void	atcaConnect(struct connection_handler_args arg)
{
  ENTRY	*node;
  node = (ENTRY *)arg.chid->paddr;
  if(arg.op == CA_OP_CONN_UP)
    ca_complete_bld_read_mon(arg.chid);
  else
    node->valid = 0;					/* point invalid until next connect and report */
}
/*
  The compare function for the AVL tree
*/
int	atcaCompare(void *e1,void *e2)
{
  return(strcmp((char *)(&((ENTRY *)e1)->var[0]),(char *)(&((ENTRY *)e2)->var[0])));
}
void	atcaSignalHandler(int whichOne)
{
  switch(whichOne)
    {
    case SIGHUP:
    case SIGINT:
      CloseOracle();
      ca_task_exit();
      printf("apxDispatch exiting due to ctrl-C\n");
      exit(1);
      break;
    }
}
void	atdbSplitDate(double dv,int *m,int *d,int *y)
{
  int	dd,leap;
  int thisYear;
  time_t tempTime;
  struct tm *reqTime;

  tempTime	= time(0);
  reqTime	= localtime(&tempTime);
  thisYear	= reqTime->tm_year+1900;
  dd = dv;
  for(*y = 1900;*y < thisYear;(*y)++)	/* total days since 1900 */
    {
      leap = *y%4 == 0 && *y%100 != 0 || *y%400 == 0;
      dd -= (365 + leap);
    }
  atdbMonthDay(*y,dd,m,d);
}
void	atdbSplitTime(double tv,int *h,int *m,int *s)
{
  double hh,tt,mm,ss;
  tt = tv * SECS_PER_DAY;
  hh = tt / SECS_PER_HOUR;		/* get HOUR */
  *h = hh;
  mm = (hh - *h) * SECS_PER_MINUTE;	/* get MINUTES */
  *m = mm;
  ss = (mm - *m) * SECS_PER_MINUTE;	/* get SECONDS */
  *s = ss;
}
void	atdbMonthDay(int year,int doy,int *m,int *d)
{
  int	leap;
  leap = year%4 == 0 && year%100 != 0 || year%400 == 0;
  for(*m = 1;doy > daytab[leap][*m];(*m)++)
    doy -= daytab[leap][*m];
  *d = doy-1;
}
void apxGetMemory(int size)
{
if(size > atdbCount)
  {
    atdbCount = size;
    if(apxValue) free(apxValue);
    apxValue = (double *)calloc(size,sizeof(double));
    if(apxValue2) free(apxValue2);
    apxValue2 = (double *)calloc(size,sizeof(double));
    if(apxStatus) free(apxStatus);
    apxStatus = (unsigned char **)calloc(size*3,sizeof(char));
  }
}
time_t apxConvertTime(double d,double t)
{
  time_t apxtime;
  struct tm reqTime;	/* for GMT conversions */
  int atdbMonth,atdbDay,atdbYear;
  int atdbHour,atdbMinute,atdbSecond;

  atdbSplitDate(d,&atdbMonth,&atdbDay,&atdbYear);
  atdbSplitTime(t,&atdbHour,&atdbMinute,&atdbSecond);
/*
	06-Apr-1995 GCT.
	Set up for new GMT/DST conversion scheme.
*/
  reqTime.tm_year	= atdbYear - 1900;
  reqTime.tm_mon    	= atdbMonth - 1;
  reqTime.tm_mday	= atdbDay;
  reqTime.tm_hour	= atdbHour;
  reqTime.tm_min    	= atdbMinute;
  reqTime.tm_sec    	= atdbSecond;
  reqTime.tm_isdst	= -1;		/* GCT 9-Jun-1998 let time function determine DST for given struct tm */
#if !defined(MIPSEL) && !defined(AXP)
#if !defined(SOLARIS)
  apxtime = timelocal (&reqTime);
#else
  apxtime = mktime (&reqTime);
#endif
#else
  apxtime = mktime (&reqTime);
#endif
return(apxtime);
}
