/*atdb_main.c,v 1.1.1.1 1999/08/03 14:41:50 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Feb-1993				      */
/*									      */
/*	Module Name:		ATDB_MAIN.C				      */
/*	Module Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Modification History:						      */
/*				20-Feb-1993	GCT	First time	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/

#define	LPI_MAIN_MODULE
#define	USE_REGISTER
#define	USE_ATDATE
#include <ltscntrl.h>
#include <atdbmain.h>
/*#include <snapDefs.h>*/
#include <time.h>
#define SEVMASK     0xF8000000
#define QUALMASK    0x07C00000
#define ALMMASK     0x003FFFFF
#define EDITBIT		0x04000000
#define QERRBIT		0x02000000
#define CONNERRBIT	0x01000000

/* #define	DEBUG_ADDINS	1 */

char *atdbFileName;
LpiAtProto(ATDB_GetHTrend);
LpiAtProto(ATDB_GetHStatus);
LpiAtProto(ATDB_Extract);
LpiBindProto(atdb_b);
LpiUnbindProto(atdb_u);
int	ATDB_DoExtract(),atdbDayOfYear(),ATDB_GetRecord();
void	atdbConvertDate(),atdbConvertTime();
char	*StrStatus();
long 	longStatus();
/*
	Main database strutcure.
*/
struct	dbdatabase	DB_Database;	/* struct defined in DBDefines.h */
DB_TABLE_PTR	table;
DB_FIELD_PTR	dbRate,dbOffset,dbDOY,dbYear,dbHour,dbCnt;
DATA_FIELDS		pFields[60];
/*
	Used in ATDB_GetRecord and ATDB_GetNextRecord
*/
double	atdbRate;
lslong	atdbSampleCnt,atdbFieldIndex,atdbOffsetMinute,atdbMinute,atdbSecond,atdbFileHour;
double	tempvalue;
char	tempstatus[3];
int	tag_status;
double  min2sec = 1;


time_t	current_time,retval,tempTime;
/*
	GetHTrend custom '@' function definition
*/
lushort	ATDB_GetHTrend(ATDB_Context,ATDB_ArgCount,LpiContext)
LpiRegContextType	ATDB_Context;
lushort			ATDB_ArgCount;
lptr(CONTEXT)		LpiContext;
{
/*
	Local variables
*/
struct	tm	*local_time,*reqTime;	/* for GMT conversions */
lushort	type;			/* used to get the argument type */
int	ATDB_Status,i,loop_cnt,tempint;		/* status for function returns */
char	atdbTable[MAXSTRING],atdbKey[MAXSTRING],atdbField[MAXSTRING],*pstr;
char	atdbValue[MAXSTRING],atdbPoint[MAXSTRING],slot_data[MAXSTRING];
char	atdbReqMethod[MAXSTRING],atdbFileMethod[MAXSTRING];
lslong	atdbType,atdbDOY,atdbYear,atdbHour,dvalue;
lslong	atdbDay,atdbMonth;
lulong	atdbInteger,atdbNSamples;
lfloat8	atdbFloat,atdbDateValue,atdbTimeValue,atdbReqTime,atdbSpan,lotus_seconds,atdbCurrentTime,atdbLocalDateValue;
double	atdbDouble,atdbResult;
REDUCTION_TYPE	atdbFileReduction,atdbReqReduction;
#ifdef	NEW_FLOAT
char		*newfloatptr;
REAL_FLOAT	convert;
#endif
char		*fltptr;
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NA);
/*
	Get first argument...POINT NAME
*/
if(LpiRegGetArgType(FIRST_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(FIRST_ARG,&pstr);
	strcpy(atdbPoint,pstr);
	}
/*
	Get second argument...DATE
*/
if(LpiRegGetArgType(SECOND_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(SECOND_ARG,&atdbDateValue);
	}
atdbDateValue = floor(atdbDateValue);	/* GCT 1-Jul-96 make sure to drop the fraction */
/*
	Get third argument...TIME
*/
if(LpiRegGetArgType(THIRD_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(THIRD_ARG,&atdbTimeValue);
	LpiAtdHour(atdbTimeValue,&atdbHour);
	LpiAtdMinute(atdbTimeValue,&atdbMinute);
	LpiAtdSecond(atdbTimeValue,&atdbSecond);
	}
/*
	Add the date and time values together. This gives us the total LOTUS time
	value as a whole number(date) plus the fraction(time).
*/
LpiAtdYear(atdbDateValue,&atdbYear);
LpiAtdMonth(atdbDateValue,&atdbMonth);
LpiAtdDay(atdbDateValue,&atdbDay);
atdbLocalDateValue = atdbDateValue + atdbTimeValue;		/* for future date/time checking */
/*
	06-Sep-1994 GCT.
	convert to GMT based on result of localtime function

	local_time->tm_gmtoffs is difference in seconds from local time to GMT.
	negative values mean west of Greenwich England;

	06-Apr-1995 GCT.
	Set up for new GMT/DST conversion scheme.
*/
tempTime = time(0);
reqTime = localtime(&tempTime);
reqTime->tm_year = atdbYear - 1900;
reqTime->tm_mon	= atdbMonth - 1;
reqTime->tm_mday	= atdbDay;
reqTime->tm_hour	= atdbHour;
reqTime->tm_min	= atdbMinute;
reqTime->tm_sec	= atdbSecond;
#ifndef MIPSEL
#ifndef SOLARIS
	retval = timelocal (reqTime);
#else
	retval = mktime (reqTime);
#endif
#else
	retval = mktime (reqTime);
#endif
#ifdef	DEBUG_ADDINS
fprintf(stderr,"retval = %d\n",retval);
#endif
local_time = (struct tm *)gmtime(&retval);			/* get local time for this cell */
atdbYear = local_time->tm_year;
atdbMonth = local_time->tm_mon + 1;
atdbDay = local_time->tm_mday;
atdbHour = local_time->tm_hour;
atdbMinute = local_time->tm_min;
atdbSecond = local_time->tm_sec;
LpiAtdDate((lfloat8)atdbYear,(lfloat8)atdbMonth,(lfloat8)atdbDay,&dvalue);
atdbDateValue = dvalue;
LpiAtdTime((lfloat8)atdbHour,(lfloat8)atdbMinute,(lfloat8)atdbSecond,&atdbTimeValue);
atdbYear += 1900;
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbDateValue += atdbTimeValue;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"new date = %f\n",atdbDateValue);
#endif
atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
#ifdef	DEBUG_ADDINS
fprintf(stderr,"time = H %d,M %d,S %d\n",atdbHour,atdbMinute,atdbSecond);
#endif

/*
	Get fourth argument...Time in minutes to span for MIN,MAX,AVG. Ignored
	for SMP (get this sample).
*/
if(LpiRegGetArgType(FOURTH_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(FOURTH_ARG,&atdbSpan);
	}
/*
	Get fifth argument...Reduction method in file.
*/
if(LpiRegGetArgType(FIFTH_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(FIFTH_ARG,&pstr);
	strcpy(atdbFileMethod,pstr);
	for(i = 0;atdbFileMethod[i];i++) atdbFileMethod[i] = toupper(atdbFileMethod[i]);
	if(!strcmp(atdbFileMethod,"AVG") || !strcmp(atdbFileMethod,"AVERAGE"))
		atdbFileReduction = AVERAGE;
	else if(!strcmp(atdbFileMethod,"MIN") || !strcmp(atdbFileMethod,"MINIMUM"))
		atdbFileReduction = MINIMUM;
	else if(!strcmp(atdbFileMethod,"MAX") || !strcmp(atdbFileMethod,"MAXIMUM"))
		atdbFileReduction = MAXIMUM;
	else
		atdbFileReduction = SAMPLE;
	}
/*
	Get sixth argument...Requested reduction method.
*/
atdbReqReduction = atdbFileReduction;			/* set equal in case the sixth arg is missing */
if(LpiRegGetArgType(SIXTH_ARG,&type) != LPI_S_ARG_NO_ARG)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(SIXTH_ARG,&pstr);
	strcpy(atdbReqMethod,pstr);
	for(i = 0;atdbReqMethod[i];i++) atdbReqMethod[i] = toupper(atdbReqMethod[i]);
	if(!strcmp(atdbReqMethod,"AVG") || !strcmp(atdbFileMethod,"AVERAGE"))
		{
		atdbResult = 1.0;
		atdbReqReduction = AVERAGE;
		}
	else if(!strcmp(atdbReqMethod,"MIN") || !strcmp(atdbFileMethod,"MINIMUM"))
		{
		atdbResult = 1.0e+20;
		atdbReqReduction = MINIMUM;
		}
	else if(!strcmp(atdbReqMethod,"MAX") || !strcmp(atdbFileMethod,"MAXIMUM"))
		{
		atdbResult = 1.0e-20;
		atdbReqReduction = MAXIMUM;
		}
	else
		atdbReqReduction = SAMPLE;
	}
/*
	Process in the following order:

	1. Get the first record containing the desired point value
	2. calculate the number of samples to use in loop over requested time span
	3. apply the requested reduction to the value.
	4. bump the field index.
		if > sample_cnt then read new record
		else obtain the next value.
	5. if within span then loop back to step 3.
		else done.
*/
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.

	GCT 06-Apr-1995 atdbLocalDateValue is before any GMT/EST conversions so is LpiAtdNow so its OK to
	compare them.
*/
LpiAtdNow(&atdbCurrentTime);			/* return current time as LOTUS value */
atdbCurrentTime -= (10 * LOTUS_MINUTE);	/* backup ten minutes to avoid getting data that has not been written yet */
if(atdbLocalDateValue > atdbCurrentTime)
	{
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
	return(LPI_SUCCESS);
	}
if(atdbReqReduction == SAMPLE)			/* no need to proceed any further */
	{
	ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"VALUE");
#ifdef	DEBUG_ADDINS
fprintf(stderr,"return from ATDB_GetRecord\n");
#endif
	if(ATDB_Status == 0)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	atdbResult = tempvalue;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Setting type...%f\n",atdbResult);
#endif
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NUM_FLOAT);
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Setting value...%f\n",atdbResult);
#endif
	*((lptr(lfloat8))LpiRegAtAccessRetData()) = atdbResult;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Returning to 123...%f\n",atdbResult);
#endif
	return(LPI_SUCCESS);
	}
/*
	Backup time to get all points up to and including the spcified time.
*/
#ifdef	DEBUG_ADDINS
fprintf(stdout,"Original datevalue=%f, hour=%d, minute=%d, span=%f\n",atdbDateValue,atdbHour,atdbMinute,atdbSpan);
fprintf(stdout,"Original floor=%f, remainder=%f\n",floor(atdbDateValue),fmod(atdbDateValue,floor(atdbDateValue)));
#endif
atdbDateValue -= (atdbSpan * LOTUS_MINUTE);	/* atdbSpan is in minutes so convert to LOTUS format */
atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
#ifdef	DEBUG_ADDINS
fprintf(stdout,"New datevalue=%f, hour=%d & minute=%d\n",atdbDateValue,atdbHour,atdbMinute);
fprintf(stdout,"New floor=%f, remainder=%f\n",floor(atdbDateValue),fmod(atdbDateValue,floor(atdbDateValue)));
#endif
if((ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"VALUE")) == 0)
	{
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
	return(LPI_SUCCESS);
	}
atdbNSamples = 0;
loop_cnt = atdbSpan / (atdbRate/min2sec) ;		/* span from cell arg #4 / rate from file */
for(;loop_cnt != 0;loop_cnt--)		/* loop for this many data points */
	{
/*
	Get another point value here.
*/
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Loop count = %d\n",loop_cnt);
#endif
	atdbDateValue += ((atdbRate/min2sec) * LOTUS_MINUTE);
	atdbLocalDateValue += ((atdbRate/min2sec) * LOTUS_MINUTE);
	atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
	atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
	atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.
*/
	if(atdbLocalDateValue > atdbCurrentTime)
		{
		continue;
		}
#ifdef	DEBUG_ADDINS
fprintf(stdout,"About to get a new record\n");
#endif
	if((ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"VALUE")) == 0)
		{
		continue;
		}
	atdbNSamples++;
	switch(atdbReqReduction)
		{
		case AVERAGE:
			atdbResult = (atdbResult * (atdbNSamples - 1) + tempvalue) / atdbNSamples;
			break;
		case MINIMUM:
			if((atdbNSamples == 1) ||  (tempvalue < atdbResult))
				atdbResult = tempvalue;
			break;
		case MAXIMUM:
			if((atdbNSamples == 1) ||  (tempvalue > atdbResult))
				atdbResult = tempvalue;
			break;
		}
	}
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NUM_FLOAT);
*((lptr(lfloat8))LpiRegAtAccessRetData()) = atdbResult;
return(LPI_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			28-Oct-1993				      */
/*									      */
/*	Function Name:		ATDB_GetHStatus				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	28-Oct-1993	GCT	First time.	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
/*
	GetHStatus custom '@' function definition
*/
lushort	ATDB_GetHStatus(ATDB_Context,ATDB_ArgCount,LpiContext)
LpiRegContextType	ATDB_Context;
lushort			ATDB_ArgCount;
lptr(CONTEXT)		LpiContext;
{
/*
	Local variables
*/
struct	tm	*local_time,*reqTime;	/* for GMT conversions */
time_t	current_time,retval,tempTime;
lushort	type;				/* used to get the argument type */
int	ATDB_Status,loop_cnt;		/* status for function returns */
char	atdbTable[MAXSTRING],atdbKey[MAXSTRING],atdbField[MAXSTRING],*pstr;
char	atdbValue[MAXSTRING],atdbPoint[MAXSTRING],slot_data[MAXSTRING];
char	atdbReqMethod[MAXSTRING],atdbFileMethod[MAXSTRING],atdbStatusString[32];
long	atdbStatusValue,ts;
lslong	atdbType,atdbDOY,atdbYear,atdbHour,dvalue;
lslong	atdbDay,atdbMonth;
lulong	atdbInteger,atdbNSamples;
lfloat8	atdbFloat,atdbDateValue,atdbTimeValue,atdbReqTime,atdbSpan,lotus_seconds,atdbCurrentTime,atdbLocalDateValue;
REDUCTION_TYPE	atdbFileReduction,atdbReqReduction;
char	i,j,sawvaliddata;
tempstatus[0] = 0;
tempstatus[1] = 0;
tempstatus[2] = 0;

LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NA);
/*
	Get first argument...POINT NAME
*/
if(LpiRegGetArgType(FIRST_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(FIRST_ARG,&pstr);
	strcpy(atdbPoint,pstr);
	}
/*
	Get second argument...DATE
*/
if(LpiRegGetArgType(SECOND_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(SECOND_ARG,&atdbDateValue);
	}
atdbDateValue = floor(atdbDateValue);	/* GCT 1-Jul-96 make sure to drop the fraction */
/*
	Get third argument...TIME
*/
if(LpiRegGetArgType(THIRD_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(THIRD_ARG,&atdbTimeValue);
	LpiAtdHour(atdbTimeValue,&atdbHour);
	LpiAtdMinute(atdbTimeValue,&atdbMinute);
	LpiAtdSecond(atdbTimeValue,&atdbSecond);
	}
/*
	Add the date and time values together. This gives us the total LOTUS time
	value as a whole number(date) plus the fraction(time).
*/
LpiAtdYear(atdbDateValue,&atdbYear);
LpiAtdMonth(atdbDateValue,&atdbMonth);
LpiAtdDay(atdbDateValue,&atdbDay);
atdbLocalDateValue = atdbDateValue + atdbTimeValue;
/*
	06-Sep-1994 GCT.
	convert to GMT based on result of localtime function

	local_time->tm_gmtoffs is difference in seconds from local time to GMT.
	negative values mean west of Greenwich England;

	06-Apr-1995 GCT.
	Set up for new GMT/DST conversion scheme.
*/
tempTime = time(0);
reqTime = localtime(&tempTime);
reqTime->tm_year = atdbYear - 1900;
reqTime->tm_mon	= atdbMonth - 1;
reqTime->tm_mday	= atdbDay;
reqTime->tm_hour	= atdbHour;
reqTime->tm_min	= atdbMinute;
reqTime->tm_sec	= atdbSecond;
#ifndef MIPSEL
#ifndef SOLARIS
	retval = timelocal (reqTime);
#else
	retval = mktime (reqTime);
#endif
#else
	retval = mktime (reqTime);
#endif
#ifdef	DEBUG_ADDINS
fprintf(stderr,"retval = %d\n",retval);
#endif
local_time = (struct tm *)gmtime(&retval);			/* get local time for this cell */
atdbYear = local_time->tm_year;
atdbMonth = local_time->tm_mon + 1;
atdbDay = local_time->tm_mday;
atdbHour = local_time->tm_hour;
atdbMinute = local_time->tm_min;
atdbSecond = local_time->tm_sec;
LpiAtdDate((lfloat8)atdbYear,(lfloat8)atdbMonth,(lfloat8)atdbDay,&dvalue);
atdbDateValue = dvalue;
LpiAtdTime((lfloat8)atdbHour,(lfloat8)atdbMinute,(lfloat8)atdbSecond,&atdbTimeValue);
atdbYear += 1900;
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbDateValue += atdbTimeValue;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"old date = %f\n",atdbDateValue);
#endif
#ifdef	DEBUG_ADDINS
fprintf(stderr,"new date = %f\n",atdbDateValue);
#endif
atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
/*
	Get fourth argument...Time in minutes to span for MIN,MAX,AVG. Ignored
	for SMP (get this sample).
*/
if(LpiRegGetArgType(FOURTH_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_NUM)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgNumFloat(FOURTH_ARG,&atdbSpan);
	}
/*
	Get fifth argument...Reduction method in file.
*/
if(LpiRegGetArgType(FIFTH_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(FIFTH_ARG,&pstr);
	strcpy(atdbFileMethod,pstr);
	for(i = 0;atdbFileMethod[i];i++) atdbFileMethod[i] = toupper(atdbFileMethod[i]);
	if(!strcmp(atdbFileMethod,"AVG"))
		atdbFileReduction = AVERAGE;
	else if(!strcmp(atdbFileMethod,"MIN"))
		atdbFileReduction = MINIMUM;
	else if(!strcmp(atdbFileMethod,"MAX"))
		atdbFileReduction = MAXIMUM;
	else
		atdbFileReduction = SAMPLE;
	}
/*
	Get sixth argument...Requested reduction method.
*/
atdbReqReduction = atdbFileReduction;
if(LpiRegGetArgType(SIXTH_ARG,&type) != LPI_S_ARG_NO_ARG)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(SIXTH_ARG,&pstr);
	strcpy(atdbReqMethod,pstr);
	for(i = 0;atdbReqMethod[i];i++) atdbReqMethod[i] = toupper(atdbReqMethod[i]);
	if(!strcmp(atdbReqMethod,"AVG"))
		atdbReqReduction = AVERAGE;
	else if(!strcmp(atdbReqMethod,"MIN"))
		atdbReqReduction = MINIMUM;
	else if(!strcmp(atdbReqMethod,"MAX"))
		atdbReqReduction = MAXIMUM;
	else
		atdbReqReduction = SAMPLE;
	}
/*
	Process in the following order:

	1. Get the first record containing the desired point value
	2. calculate the number of samples to use in loop over requested time span
	3. apply the requested reduction to the value.
	4. bump the field index.
		if > sample_cnt then read new record
		else obtain the next value.
	5. if within span then loop back to step 3.
		else done.
*/
atdbStatusValue = 0xffffffffL;
LpiAtdNow(&atdbCurrentTime);			/* return curretn time as LOTUS value */
atdbCurrentTime -= (10 * LOTUS_MINUTE);	/* backup ten minutes to avoid getting data that has not been written yet */
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.
*/
	if(atdbLocalDateValue > atdbCurrentTime)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
if(atdbReqReduction == SAMPLE)			/* no need to proceed any further */
	{
	if((ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"STATUS")) == 0)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	memcpy(atdbStatusString,tempstatus,3);			/* get status string(3 chars) */
	atdbStatusString[3] = 0;						/* NULL terminate */
	atdbStatusValue = longStatus(atdbStatusString);	/* decode bits in value */
	(void)StrStatus(atdbStatusValue,atdbStatusString);	/* encode bits back into string */
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_STR_NATIVE);
	strcpy((char *)LpiRegAtAccessRetData(),atdbStatusString);
	return(LPI_SUCCESS);
	}
/*
	Backup time to get all points up to and including the specified time.
*/
atdbDateValue -= (atdbSpan * LOTUS_MINUTE);	/* atdbSpan is in minutes so convert to LOTUS format */
atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
if((ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"STATUS")) == 0)
	{
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
	return(LPI_SUCCESS);
	}
loop_cnt = atdbSpan / (atdbRate/min2sec);		/* span from cell arg #4 / rate from file */
atdbStatusValue = 0xffffffffL;
sawvaliddata = 0;
for(;loop_cnt != 0;loop_cnt--)		/* loop for this many data points */
	{
/*
	Get another point value here.
*/
	atdbDateValue += ((atdbRate/min2sec) * LOTUS_MINUTE);
	atdbLocalDateValue += ((atdbRate/min2sec) * LOTUS_MINUTE);
	atdbConvertDate(atdbDateValue,&atdbYear,&atdbMonth,&atdbDay);
	atdbDOY = atdbDayOfYear(atdbYear,atdbMonth,atdbDay);
	atdbConvertTime(atdbDateValue,&atdbHour,&atdbMinute,&atdbSecond);
/*
	GCT 12-Dec-1994 Must use current time to avoid reporting "future" data...Data that has not been written
	to the file yet. The sample count will always reflect a full record so we can't use it anymore.
*/
	LpiAtdNow(&atdbCurrentTime);			/* return curretn time as LOTUS value */
	if(atdbLocalDateValue > atdbCurrentTime)
		{
		continue;
		}
	if((ATDB_Status = ATDB_GetRecord(table,atdbPoint,atdbFileMethod,atdbYear,atdbDOY,atdbHour,"STATUS")) == 0)
		{
		continue;
		}
	tempstatus[3] = 0;				/* NULL terminate */
#ifdef	DEBUG_ADDINS
fprintf(stdout,"Status from file <%s>.\n",tempstatus);
#endif
	if (atdbStatusValue == 0xffffffffL)
		{
		atdbStatusValue = longStatus(tempstatus);
#ifdef	DEBUG_ADDINS
fprintf(stdout,"New Status long word <%08X>.\n",atdbStatusValue);
#endif
		}
	else											/* rest of samples are subjected to precedence */
		{
		ts = longStatus(tempstatus);			/* if new quality is worse, update the quality */
		if ((ts & QUALMASK) > (atdbStatusValue & QUALMASK))
			atdbStatusValue = (atdbStatusValue & ~QUALMASK) | (ts & QUALMASK);
		if ((ts & CONNERRBIT) == 0)
			sawvaliddata = 1;
/*
	if new error is more severe or we haven't seen an alarm,
	take value from new sample.
*/
		if (((ts & SEVMASK) > (atdbStatusValue & SEVMASK)) || ((atdbStatusValue & ALMMASK) == 0))
			atdbStatusValue = (atdbStatusValue & QUALMASK) | (ts & (SEVMASK | ALMMASK));
#ifdef	DEBUG_ADDINS
fprintf(stdout,"Modified Status long word <%08X>.\n",atdbStatusValue);
#endif
		}
	}
/*
	 if quality level is Connect but we saw valid data, convert to Q status.
*/
if ((atdbStatusValue != 0xffffffffL) && (atdbStatusValue & CONNERRBIT) && (sawvaliddata == 1))
	atdbStatusValue = (atdbStatusValue & ~QUALMASK) | QERRBIT;
/*
	Convert the status integer to a text string for display in Lotus
*/
(void)StrStatus(atdbStatusValue,atdbStatusString);
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_STR_NATIVE);
strcpy((char *)LpiRegAtAccessRetData(),atdbStatusString);
return(LPI_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Feb-1993				      */
/*									      */
/*	Function Name:		ATDB_Extract				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*	This is a generalized form of the GetHTrend @function.		      */
/*									      */
/*	The syntax is as follows:					      */
/*									      */
/*	@EXTRACT("table name","key string","field name")		      */
/*									      */
/*	where:								      */
/*		"table name"	Name of database file in default directory    */
/*		"key string"	String which is the key to use with its value */
/*				 as follows: "key=value"		      */
/*		"field name"	Field name where value is obtained.	      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*				LpiRegContextType	ATDB_Context;	      */
/*				lushort			ATDB_ArgCount;	      */
/*				lptr(CONTEXT)		LpiContext;	      */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	20-Feb-1993	GCT	First time.	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/

lushort	ATDB_Extract(ATDB_Context,ATDB_ArgCount,LpiContext)
LpiRegContextType	ATDB_Context;
lushort			ATDB_ArgCount;
lptr(CONTEXT)		LpiContext;
{
/*
	"Local variables"
*/
lushort	type;
int	ATDB_Status;		/* status for function returns */
char	atdbTable[MAXSTRING],atdbKey[MAXSTRING],atdbField[MAXSTRING],*pstr;
char	atdbValue[MAXSTRING],*pval;
int	atdbType;
lulong	atdbInteger;
lfloat8	atdbFloat;

pval = atdbValue;
LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NA);
/*
	Get first argument...TABLE
*/
if(LpiRegGetArgType(FIRST_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(FIRST_ARG,&pstr);
	strcpy(atdbTable,pstr);
	}
/*
	Get second argument...KEY
*/
if(LpiRegGetArgType(SECOND_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(SECOND_ARG,&pstr);
	strcpy(atdbKey,pstr);
	}
/*
	Get third argument...FIELD
*/
if(LpiRegGetArgType(THIRD_ARG,&type) == LPI_SUCCESS)
	{
	if(type != LPI_T_ARG_TYPE_STR)
		{
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
		return(LPI_SUCCESS);
		}
	LpiRegGetArgStrNative(THIRD_ARG,&pstr);
	strcpy(atdbField,pstr);
	}
/*
	Get the data from the field
*/
ATDB_Status = ATDB_DoExtract(atdbTable,atdbKey,atdbField,&atdbType,atdbValue);
if(!ATDB_Status)
	{
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);
	return(LPI_SUCCESS);
	}
switch(atdbType)
	{
	case 'C':
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_STR_NATIVE);
		strcpy((char *)LpiRegAtAccessRetData(),atdbValue);
		break;
	case 'N':
	case 'F':
		atdbFloat = *((double *)pval);
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NUM_FLOAT);
		*((lptr(lfloat8))LpiRegAtAccessRetData()) = atdbFloat;
		break;
	case 'L':
		atdbInteger = *((lulong *)pval);
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NUM_INT);
		*((lptr(lulong))LpiRegAtAccessRetData()) = atdbInteger & 1;
		break;
	case 'D':
		atdbInteger = *((lulong *)pval);
		atdbFloat = atdbInteger;
		LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_NUM_FLOAT);
		*((lptr(lfloat8))LpiRegAtAccessRetData()) = atdbFloat;
		break;
	}
return(LPI_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Feb-1993				      */
/*									      */
/*	Function Name:		LpiBind					      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	20-Feb-1993	GCT	First time.	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
LpiBind(atdb_b)
{
lsshort	ATDB_123Status;
lushort	ATDB_ArgType[NUM_ARGS];
int	ATDB_Status;
char	*path,fName[10],i;


LPI_SETUP_LOAD;
if(LPI_LOAD_REGISTER != LPI_SUCCESS)
	LpiSignal(LPI_FAILURE);
if(LPI_LOAD_ATDATE != LPI_SUCCESS)
	LpiSignal(LPI_FAILURE);
/*
	Register the new @ functions
*/
ATDB_ArgType[FIRST_ARG]		= LPI_T_ARG_TYPE_STR;	/* name */
ATDB_ArgType[SECOND_ARG]	= LPI_T_ARG_TYPE_NUM;	/* date MM/DD/YY from @DATEVALUE */
ATDB_ArgType[THIRD_ARG]		= LPI_T_ARG_TYPE_NUM;	/* time HH:MM from @TIMEVALUE or @NOW*/
ATDB_ArgType[FOURTH_ARG]	= LPI_T_ARG_TYPE_NUM;	/* span of samples (in minutes) for AVG,MIN or MAX */
ATDB_ArgType[FIFTH_ARG]		= LPI_T_ARG_TYPE_STR;	/* Reduction method in file */
ATDB_ArgType[SIXTH_ARG]		= LPI_T_ARG_TYPE_STR;	/* Reduction method for result */
ATDB_123Status = LpiRegAtfunc(GETHTREND_NAME,ATDB_GetHTrend,GETHTREND_ARGS,ATDB_ArgType,LNULL,
	(LPI_T_REG_AT_ALWAYS_DIRTY | LPI_T_REG_AT_VARARGS),
	(LPI_T_REG_AT_TYPE_ERR | LPI_T_REG_AT_TYPE_NUM_FLOAT));

ATDB_ArgType[FIRST_ARG]		= LPI_T_ARG_TYPE_STR;	/* name */
ATDB_ArgType[SECOND_ARG]	= LPI_T_ARG_TYPE_NUM;	/* date MM/DD/YY from @DATEVALUE */
ATDB_ArgType[THIRD_ARG]		= LPI_T_ARG_TYPE_NUM;	/* time HH:MM from @TIMEVALUE or @NOW*/
ATDB_ArgType[FOURTH_ARG]	= LPI_T_ARG_TYPE_NUM;	/* span of samples (in minutes) for AVG,MIN or MAX */
ATDB_ArgType[FIFTH_ARG]		= LPI_T_ARG_TYPE_STR;	/* Reduction method in file */
ATDB_ArgType[SIXTH_ARG]		= LPI_T_ARG_TYPE_STR;	/* Reduction method for result */
ATDB_123Status = LpiRegAtfunc(GETHSTATUS_NAME,ATDB_GetHStatus,GETHTREND_ARGS,ATDB_ArgType,LNULL,
	(LPI_T_REG_AT_ALWAYS_DIRTY | LPI_T_REG_AT_VARARGS),
	(LPI_T_REG_AT_TYPE_ERR | LPI_T_REG_AT_TYPE_STR_NATIVE));

ATDB_ArgType[FIRST_ARG] = LPI_T_ARG_TYPE_STR;			/* table */
ATDB_ArgType[SECOND_ARG] = LPI_T_ARG_TYPE_STR;			/* key */
ATDB_ArgType[THIRD_ARG] = LPI_T_ARG_TYPE_STR;			/* field */
ATDB_123Status = LpiRegAtfunc(EXTRACT_NAME,ATDB_Extract,EXTRACT_ARGS,ATDB_ArgType,LNULL,
	LPI_T_REG_AT_ALWAYS_DIRTY,
	(LPI_T_REG_AT_TYPE_ERR |
	 LPI_T_REG_AT_TYPE_NUM_FLOAT |
	 LPI_T_REG_AT_TYPE_STR_NATIVE |
	 LPI_T_REG_AT_TYPE_NUM_INT));
DB_InitDatabase("ATDB");			/* initialize all database access tables */
if((path = (char *)getenv(AR_SNAP_PATH)) == 0)
	path = ATDB_DEFAULT_PATH;
if((atdbFileName = (char *)getenv(AR_SNAP_NAME)) == 0)
	atdbFileName = ATDB_DEFAULT_NAME;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Path to file <%s>\n",path);
fprintf(stderr,"Trend file name <%s>\n",atdbFileName);
#endif
DB_MapDatabase(path);			/* files(tables) should be here */
if((table = DB_MapTable(atdbFileName)) == 0)		/* HTrend data file */
	{
#ifdef DEBUG_ADDINS
fprintf(stderr,"Can't open file <%s>\n",atdbFileName);
#endif
	LpiRegAtSetRetType(LPI_T_REG_AT_TYPE_ERR);	/* cant open file the ERR */
	return(LPI_SUCCESS);
	}
DB_UseKey(table,"METHOD_REC");					/* use the proper tag  for new files */
dbRate		= DB_MapField(table,"RATE");
dbOffset	= DB_MapField(table,"OFFSET_MIN");
dbDOY		= DB_MapField(table,"DAYOFYEAR");
dbYear		= DB_MapField(table,"YEAR");
dbHour		= DB_MapField(table,"HOUR");
dbCnt		= DB_MapField(table,"SAMPLE_CNT");
for(i=0;i < 60;i++)
	{
	sprintf(fName,"VALUE%d\0",i+1);
	pFields[i].pVal		= DB_MapField(table,fName);
	sprintf(fName,"STATUS%d\0",i+1);
	pFields[i].pStat	= DB_MapField(table,fName);
	}
LpiSignal(ATDB_123Status);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Feb-1993				      */
/*									      */
/*	Function Name:		LpiUnbind				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	20-Feb-1993	GCT	First time	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
LpiUnbind(atdb_u)
{
LPI_UNLOAD;
/*
	Clean up all database files
*/
DB_UnMapDatabase();
LpiSignal(LPI_SUCCESS);
}
