/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/BulletinB.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
/* prototypes */
void aimCreateEdit(Widget);			/* create main dialog box */
void aimApply(Widget,XtPointer,XmSelectionBoxCallbackStruct *);	/* save data to current record */
void aimSelect(Widget,XtPointer,XmSelectionBoxCallbackStruct *);	/* Select item from list */
void aimDismiss(Widget,XtPointer,XtPointer);   	/* ask to exit program...prompt if modified */
void aimDoDismiss(Widget,XtPointer,XtPointer);  /* exit program */
void aimDelete(Widget,XtPointer,XtPointer);   	/* ask to remove item from list */
void aimDoDelete(Widget,XtPointer,XtPointer);   /* remove item */
void aimModified(Widget,XtPointer,XtPointer);	/* mark record as modified via this callback */
void aimCreateAreYouSure(char *,char *);	/* create/pop-up decision dialog */
void aimCreateInfo(char *,char *);	       	/* create/pop-up information dialog */
void editInit(void);				/* init first edit session */
void aimBrowse(Widget ,XtPointer,XtPointer);	/* pop-up directory box */
void aimBrowseCancel(Widget ,XtPointer,XtPointer);	/* dismiss directory box */
void aimSetDir(Widget ,XtPointer ,XmFileSelectionBoxCallbackStruct *); /* callback from file eselection */
void aimCheckDigits(Widget ,char *,XmTextVerifyCallbackStruct *); /* allow only 0-9 */
/* externs */
extern int aimIsModified;			/* start as zero (not modified) */
extern Widget aimTopLevel;			/* top level from XtVaAppInitialize */
extern Widget aimEditDialog;			/* main container dialog */
extern Widget aimAreYouSure;			/* used for user decision prompts */
extern Widget aimInfo;				/* used for user information prompts */
extern FILE *aimFp;				/* for archconfig.txt file */
/* defines */
#ifdef WIN32
#define AIM_CONFIG_FILE "\\tis4000db\\archconfig.txt"
#else
#define AIM_CONFIG_FILE "/tis4000db/archconfig.txt"
#endif WIN32
#define AIM_ARCH_ENABLED "enabled"
#define AIM_ARCH_DISABLED "disabled"
