/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This program will display a MOTIF style message box
	requesting archive tables spec'd by the argv[2] value.

	Grant Irani (from code by Greg Tomalesky)
	10-nov-1996
*/
#include	<X11/Intrinsic.h>
#include	<Xm/Xm.h>
#include	<Xm/MessageB.h>
#include	<time.h>

void	reqByeBye();
void	reqAVMprocess();
void	reqByeBye();
void	reqExit();
Widget	reqCreateMessageBox();
Widget	reqCreateFinalMessageBox();
XtAppContext	app;
Widget		topLevel, msgBox;
Widget		operToplevel;

/* archiveMountRequest <table_list (comma separated)> */
void	main(argc,argv)
int	argc;
char	*argv[];
{
    Display		*operdpy;
    char		msgString[2048];
    unsigned char	type;

    if(argc < 2)    	/* must have at least one argument */
	exit(4);

    type = XmDIALOG_WARNING;
    topLevel = XtVaAppInitialize(&app,"reqArchDisp", NULL, 0, &argc, argv, NULL,
				XmNallowShellResize, True, NULL);

    operdpy = XtOpenDisplay (app, ":0.0", argv[0], "archMountReq", NULL, 0, &argc, argv);
    operToplevel = XtAppCreateShell (argv[0], "", applicationShellWidgetClass,
				    operdpy, NULL,0);
    sprintf(msgString,
"Please mount the following tables using the avm utility.\n%s\nPress OK when mounting has been completed, or Cancel to reject request",
		 argv[1]);
    type = XmDIALOG_WARNING;

    /* create the proper message box */
    msgBox = reqCreateMessageBox(operToplevel, msgString, "Archive Volume Mount request", type);

    XtRealizeWidget(operToplevel);
    XtAppMainLoop(app);
}

/*
	generic message box creator
*/
Widget	reqCreateMessageBox (parent, msgString, titleString, msgType)
Widget	parent;
char	*msgString,*titleString;
unsigned char	msgType;
{
    XmString	msg, title;
    Widget	msgbox;

    msg = XmStringCreateLtoR (msgString,XmSTRING_DEFAULT_CHARSET);
    title = XmStringCreateSimple (titleString);
    msgbox = XtVaCreateManagedWidget ("Warning", xmMessageBoxWidgetClass, parent,
					XmNdialogTitle,title,
					XmNdialogType,msgType,
					XmNmessageString,msg,
					NULL);
    XtAddCallback (msgbox,XmNokCallback, reqAVMprocess,0);
    XtAddCallback (msgbox,XmNcancelCallback, reqByeBye,0);
    XtUnmanageChild (XmMessageBoxGetChild(msgbox, XmDIALOG_HELP_BUTTON));
    XmStringFree (msg);
    XmStringFree (title);
    return(msgbox);
}

/*
	Cancel - Display mount reject notice on original display.
*/
void	reqByeBye(w,tag,reason)
Widget	w;
int		*tag;
int		reason;
{
    XUnmapWindow (XtDisplay(operToplevel), XtWindow(operToplevel)); 
    /* display reject notice */
    msgBox = reqCreateFinalMessageBox(topLevel, "Archive volume mount request rejected", "Archive Volume Mount", XmDIALOG_WARNING);

    XtRealizeWidget(topLevel);
}

/*
	OK - Display mount completed on original display.
*/
void	reqAVMprocess (w,tag,reason)
Widget	w;
int		*tag;
int		reason;
{
    XUnmapWindow (XtDisplay(operToplevel), XtWindow(operToplevel)); 
    /* display completed notice */
    msgBox = reqCreateFinalMessageBox(topLevel, "Archive volume mount completed", "Archive Volume Mount", XmDIALOG_WARNING);

    XtRealizeWidget(topLevel);
}

/*
	generic message box creator
*/
Widget	reqCreateFinalMessageBox (parent, msgString, titleString, msgType)
Widget	parent;
char	*msgString,*titleString;
unsigned char	msgType;
{
    XmString	msg, title;
    Widget	msgbox;

    msg = XmStringCreateLtoR (msgString,XmSTRING_DEFAULT_CHARSET);
    title = XmStringCreateSimple (titleString);
    msgbox = XtVaCreateManagedWidget ("Warning", xmMessageBoxWidgetClass, parent,
					XmNdialogTitle,title,
					XmNdialogType,msgType,
					XmNmessageString,msg,
					NULL);
    XtAddCallback (msgbox,XmNokCallback, reqExit,0);
    XtUnmanageChild (XmMessageBoxGetChild(msgbox, XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild (XmMessageBoxGetChild(msgbox, XmDIALOG_HELP_BUTTON));
    XmStringFree (msg);
    XmStringFree (title);
    return(msgbox);
}

/*
	Cancel - exit program.
*/
void	reqExit(w,tag,reason)
Widget	w;
int		*tag;
int		reason;
{
    exit(1);
}

