/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <errno.h>
#include "avm.h"

/* create and manage the AVM edit dialog box */
static Widget editList,sel;
/* static Widget editRowCol,editDOU,editCOL,frame;*/
static Widget editStart,editEnd,editIsMounted,editDisk,editPath,editTable;
static Widget editLoad,editUnload,editPathSelect;
static XmString avmCurrentItem;
void avmSetLabel(char online,time_t startDate,char *pathName);
void avmCopyOnLoad(Widget w,XtPointer client_data,XmFileSelectionBoxCallbackStruct *cbs);
void avmStringTime (time_t startDate, char *string);
int entryChanged = 0;
time_t saveStartDate;
static char avmCurrStatus;
extern char *sys_errlist[];

void avmCreateEdit(Widget parent)
{
  Widget label;
  int n=0;
  Arg args[20];
  XmString title,listLabel,okLabel,cancelLabel,helpLabel,applyLabel,dirString;
  
  title = XmStringCreateLocalized("Archive Volume Maintenance");
  avmEditDialog = XmCreateBulletinBoard(parent,"ARCHIVE",args,n);
  XtVaSetValues(avmEditDialog,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogTitle,title,NULL);
  n=0;
  listLabel = XmStringCreateLocalized("          Archive table name");
  okLabel = XmStringCreateLocalized("Apply");
  applyLabel = XmStringCreateLocalized("Dismiss");
  cancelLabel = XmStringCreateLocalized("Archive");
  helpLabel = XmStringCreateLocalized("Help");
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNapplyLabelString,applyLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNhelpLabelString,helpLabel);n++;
  XtSetArg(args[n],XmNlistVisibleItemCount,14);n++;
  /* create dialog */
  sel = XmCreateSelectionBox(avmEditDialog,"EDIT",args,n);
  XtManageChild(XmSelectionBoxGetChild(sel,XmDIALOG_APPLY_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_TEXT));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_SELECTION_LABEL));
  /* get children widgets */
  editList = XmSelectionBoxGetChild(sel,XmDIALOG_LIST);
  XtVaSetValues(editList,XmNscrollBarDisplayPolicy,XmSTATIC,NULL);
  XtRemoveAllCallbacks(editList,XmNdefaultActionCallback);
/*   XtRemoveAllCallbacks(editList,XmNbrowseSelectionCallback); */
  XtAddCallback(editList,XmNbrowseSelectionCallback,(XtCallbackProc)avmSelect,(XtPointer)0);
  /* add callbacks */
  XtAddCallback(sel,XmNokCallback,(XtCallbackProc)avmApply,(XtPointer)0);
  XtAddCallback(sel,XmNapplyCallback,avmDismiss,(XtPointer)0);
  XtAddCallback(sel,XmNcancelCallback,avmArchive,(XtPointer)0);
  XtAddCallback(sel,XmNhelpCallback,avmHelp,(XtPointer)0);
  /* manage selection box and free strings */
  XtManageChild(sel);
  XtManageChild(avmEditDialog);
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(applyLabel);
  XmStringFree(cancelLabel);
  XmStringFree(helpLabel);
  /* Add text widgets */
  /* Start Date */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,20);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_STARTDATE_SIZE*2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
#ifndef ENABLE_ADDITION
  XtSetArg(args[n],XmNeditable,False);n++;
#endif
  editStart = XmCreateText(avmEditDialog,"START",args,n);
  XtManageChild(editStart);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Start Date:",11,
				  XmNx,439,
				  XmNy,26,
				  NULL);
 /* End Date */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,60);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_ENDDATE_SIZE*2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
#ifndef ENABLE_ADDITION
  XtSetArg(args[n],XmNeditable,False);n++;
#endif
  editEnd = XmCreateText(avmEditDialog,"END",args,n);
  XtManageChild(editEnd);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"End Date:",10,
				  XmNx,453,
				  XmNy,66,
				  NULL);
  /* Disk Label */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,100);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_DISKLABEL_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
  editDisk = XmCreateText(avmEditDialog,"DISK",args,n);
  XtManageChild(editDisk);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Disk Label:",12,
				  XmNx,438,
				  XmNy,106,
				  NULL);
  XtAddCallback(editDisk,XmNvalueChangedCallback,(XtCallbackProc)avmModified,0);

  /* Mount point */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,140);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_MOUNTPNT_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_MOUNTPNT_SIZE);n++;
  editPath = XmCreateText(avmEditDialog,"PATH",args,n);
  XtManageChild(editPath);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Path to database:",18,
				  XmNx,390,
				  XmNy,146,
				  NULL);
  XtAddCallback(editPath,XmNmodifyVerifyCallback,(XtCallbackProc)avmCheckPath,0);

  /* Oracle Table */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,180);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_TABLENAME_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_TABLENAME_SIZE);n++;
  XtSetArg(args[n],XmNeditable,False);n++;
  editTable = XmCreateText(avmEditDialog,"PATH",args,n);
  XtManageChild(editTable);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Oracle table:",14,
				  XmNx,423,
				  XmNy,186,
				  NULL);
  XtAddCallback(editTable,XmNvalueChangedCallback,(XtCallbackProc)avmModified,0);


  /* Set/Display online status */
  editIsMounted = XtVaCreateManagedWidget("ONL",xmLabelWidgetClass,avmEditDialog,
					  XtVaTypedArg,XmNlabelString,XmRString,"Volume is: ONLINE ",19,
					  XmNx,447,
					  XmNy,225,
					  NULL);

/*   frame = XtVaCreateManagedWidget("frame",xmFrameWidgetClass,avmEditDialog, */
/* 				  XmNx,453, */
/* 				  XmNy,265, */
/* 				  XmNshadowType,XmSHADOW_ETCHED_OUT, */
/* 				  NULL); */

/*   editRowCol = XtVaCreateManagedWidget("rowcol",xmRowColumnWidgetClass,frame, */
/* 				       XmNorientation,XmVERTICAL, */
/* 				       XmNpacking,XmPACK_COLUMN, */
/* 				       XmNnumColumns,2, */
/* 				       NULL); */
  
/*   editCOL = XtVaCreateManagedWidget("COL",xmToggleButtonWidgetClass,editRowCol, */
/* 					  XtVaTypedArg,XmNlabelString,XmRString,"Copy on Load",13, */
/* 					  XmNindicatorSize,15, */
/* 					  XmNmarginHeight,0, */
/* 					  NULL); */
/*  editDOU = XtVaCreateManagedWidget("DOU",xmToggleButtonWidgetClass,avmEditDialog,
					  XtVaTypedArg,XmNlabelString,XmRString,"Delete after copy",19,
					  XmNx,610,
					  XmNy,222,
					  XmNindicatorSize,15,
					  XmNmarginHeight,0,
					  NULL);
*/
/*   label = XtVaCreateManagedWidget("sep",xmSeparatorWidgetClass,avmEditDialog, */
/* 				  XmNx,392, */
/* 				  XmNy,297, */
/* 				  XmNwidth,405, */
/* 				  NULL); */

  /* Load button */
   editLoad = XtVaCreateManagedWidget("Load",xmPushButtonWidgetClass,avmEditDialog,
 				      XmNx,392,
 				      XmNy,315,
 				      XmNheight,29,
				      XmNwidth,75,
 				      NULL);
  XtAddCallback(editLoad,XmNactivateCallback,avmLoad,(XtPointer)0);
  /* Unload button */
  editUnload = XtVaCreateManagedWidget("Unload",xmPushButtonWidgetClass,avmEditDialog,
 				      XmNx,479,
 				      XmNy,315,
 				      XmNheight,29,
 				      XmNwidth,75,
				      NULL);

  XtAddCallback(editUnload,XmNactivateCallback,avmUnLoad,(XtPointer)0);
  title = XmStringCreateLocalized("Archive directorys");
  dirString = XmStringCreateLocalized("/archiveA/dbs");
  n=0;
  XtSetArg(args[n],XmNdialogTitle,title);n++;
  XtSetArg(args[n],XmNautoUnmanage,True);n++;
  XtSetArg(args[n],XmNdirectory,dirString);n++;
  editPathSelect = (Widget)XmCreateFileSelectionDialog(avmEditDialog,"BROWSE",args,n);
  label = XmSelectionBoxGetChild(editPathSelect,XmDIALOG_LIST);
  XtUnmanageChild(XtParent(label));
  XtUnmanageChild(XmSelectionBoxGetChild(editPathSelect,XmDIALOG_LIST_LABEL));
  XtUnmanageChild(XmSelectionBoxGetChild(editPathSelect,XmDIALOG_HELP_BUTTON));
  XtAddCallback(editPathSelect,XmNokCallback,(XtCallbackProc)avmCopyOnLoad,(XtPointer)0);
  XmStringFree(title);
  XmStringFree(dirString);
}
/*
  load the first record and fill in the data
*/
void editInit()
{
  char tableName[AVM_TABLENAME_SIZE];
  XmString item;
  int stat,count;
  time_t startTime, endTime;
  
  /* load table names by start time */
  endTime = catGetEarliestStartDate();

  while(stat = catGetEntry(endTime, &startTime, &endTime, tableName, NULL, NULL, NULL))
    {
      item = XmStringCreateLocalized(tableName);
      XmListAddItem(editList,item,0);
      XmStringFree(item);
    }
  XtVaGetValues(editList,XmNitemCount,&count,NULL);
  if(count)
    XmListSelectPos(editList,1,True);
  entryChanged = 0;
}
/*
  Apply any changes to the record specified by the startDate
*/
void avmApply(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)	/* save data to current record */
{
  char *startStr,*endStr;
  char *diskName,*pathName;
#ifdef ENABLE_ADDITION
  char	*tableName, online, line[80];
  XmString item;
#endif ENABLE_ADDITION
  time_t startDate,endDate;
  struct tm tmBuff;

  memset((char *)&tmBuff,0,sizeof(struct tm));
  startStr = XmTextGetString(editStart);
  sscanf(startStr,AVM_DATE_FORMAT,&tmBuff.tm_mon,&tmBuff.tm_mday,&tmBuff.tm_year,&tmBuff.tm_hour,&tmBuff.tm_min,&tmBuff.tm_sec);
  if (tmBuff.tm_year < 70)
      tmBuff.tm_year += 100;
  tmBuff.tm_mon--;
  startDate = mktime(&tmBuff) - timezone;

  memset((char *)&tmBuff,0,sizeof(struct tm));
  endStr = XmTextGetString(editEnd);
  sscanf(endStr,AVM_DATE_FORMAT,&tmBuff.tm_mon,&tmBuff.tm_mday,&tmBuff.tm_year,&tmBuff.tm_hour,&tmBuff.tm_min,&tmBuff.tm_sec);
  if (tmBuff.tm_year < 70)
      tmBuff.tm_year += 100;
  tmBuff.tm_mon--;
  endDate = mktime(&tmBuff) - timezone;

  diskName = XmTextGetString(editDisk);
  pathName = XmTextGetString(editPath);
  if(!catUpdateEntry(startDate,(time_t)0,0,diskName,pathName,-1))
    {
#ifdef ENABLE_ADDITION
      catAddEntry(startDate,endDate,tableName,diskName,pathName,online);
      sprintf(line,AVM_LIST_FORMAT,startStr,endStr);
      item = XmStringCreateLocalized(line);
      XmListAddItem(editList,item,0);
      XmStringFree(item);
#endif ENABLE_ADDITION
    }
  XtFree(diskName);
  XtFree(pathName);
  XtFree(endStr);
  XtFree(startStr);
  entryChanged = 0;
}
void avmDismiss(Widget w,XtPointer client_data,XtPointer call_data)   	/* ask to exit program...prompt if modified */
{
  if(entryChanged)
    {
      avmCreateAreYouSure("Quit without saving changes ?","AVM");
      XtRemoveAllCallbacks(avmAreYouSure,XmNokCallback);
      XtAddCallback(avmAreYouSure,XmNokCallback,avmDoDismiss,(XtPointer)0);
      return;
    }
  catClose();
  exit(1);
}
void avmDoDismiss(Widget w,XtPointer client_data,XtPointer call_data)  	/* exit program */
{
  catClose();
  exit(1);
}
void avmHelp(Widget w,XtPointer client_data,XtPointer call_data)   	/* ask to exit program...prompt if modified */
{
  char msg[80];

  sprintf(msg,"Archive editor version 1.0\0");
  avmCreateInfo(msg,"AVM");
}
void avmSelect(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)     /* select record from list based on date range */
{
  char online,*choice,startStr[AVM_STARTDATE_SIZE],endStr[AVM_ENDDATE_SIZE],diskName[AVM_DISKLABEL_SIZE+1];
  char pathName[AVM_MOUNTPNT_SIZE+1],tableName[AVM_TABLENAME_SIZE+1];
  time_t startDate,endDate;
  int status;

  avmCurrentItem = XmStringCopy(cbs->value);
  XmStringGetLtoR(cbs->value,XmFONTLIST_DEFAULT_TAG,&choice);
  strncpy (tableName, strtok(choice," "), AVM_TABLENAME_SIZE);
  XtFree(choice);
  /*
    fill in rest of fields
  */
  status = catGetEntryByTableName(tableName,&startDate,&endDate,diskName,pathName,&online);
  if((status == 1) || ((status == 0) && strlen(tableName)))
    {
      saveStartDate = startDate;
      avmStringTime (startDate, startStr);
      XmTextSetString(editStart,startStr);
      avmStringTime (endDate, endStr);
      XmTextSetString(editEnd,endStr);
      XmTextSetString(editDisk,diskName);
      XmTextSetString(editPath,pathName);
      XmTextSetString(editTable,tableName);
      avmSetLabel(online,0,0);
      avmCurrStatus = online;
      entryChanged = 0;
    }
  }
void avmModified(Widget w,XtPointer client_data,XtPointer call_data)	/* mark record as modified via this callback */
{
  entryChanged = 1;
}
void avmLoad(Widget w,XtPointer client_data,XtPointer call_data)	/* perform oracle import via this callback */
{
  char *pathName;
  char *tableName;
  char fullPath[80];
  struct stat stBuff;
  char msg[80];
  char  cmd[80];

  pathName = XmTextGetString(editPath);
  tableName = XmTextGetString(editTable);
#ifdef	WIN32
  sprintf(fullPath,"%s\\%s.dmp\0",pathName,tableName);
#else
  sprintf(fullPath,"%s/%s.dmp\0",pathName,tableName);
#endif	WIN32
  if(avmCurrStatus == 1)					/* if already online then skip rest */
    {
      sprintf(msg,"Volume\n%s\nalready online",tableName);
      avmCreateInfo(msg,"AVM");
      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
    }
  else
    {
      if(stat(fullPath,&stBuff) < 0)
	{
	  sprintf(msg,"Import file doesn't exist\n%s\n%s\0",fullPath,sys_errlist[errno]);
	  avmCreateInfo(msg,"AVM");
	}
      else
	{
	  sprintf(cmd,"cd %s ;import_archive %s\0", pathName, tableName);
	  if(system(cmd) < 0)
	    {
	      sprintf(msg,"Load error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
	      avmCreateInfo(msg,"AVM");
	    }
	  else
	    {
	      avmSetLabel(1,saveStartDate,0);   	/* set label and update catalog */
	      sprintf(msg,"Load completed for file\n%s\n\0",fullPath);
	      avmCreateInfo(msg,"AVM");
	    }
	}
    }
  XtFree(pathName);
  XtFree(tableName);
}
void avmUnLoad(Widget w,XtPointer client_data,XtPointer call_data)	/* perform oracle un-load via this callback */
{
  avmCreateAreYouSure("Proceed to drop all table information for archive?\nYou must have an archive set to recover!","AVM");
  XtRemoveAllCallbacks(avmAreYouSure,XmNokCallback);
  XtAddCallback(avmAreYouSure,XmNokCallback,avmDoUnLoad,(XtPointer)0);
}
void avmDoUnLoad(Widget w,XtPointer client_data,XtPointer call_data)
{
  char *tableName;
  char msg[80];
  char  cmd[80];

  tableName = XmTextGetString(editTable);
  sprintf(cmd,"delete_archive %s\0", tableName);
  if(system(cmd) < 0)
    {
      sprintf(msg,"Delete error for table %s\n%s\0",tableName, sys_errlist[errno]);
      avmCreateInfo(msg,"AVM");
    }
  else
    {
      avmSetLabel(0,saveStartDate,0);	       		/* set label and update catalog */
	  sprintf(msg,"Unload completed for table\n%s\n\0",tableName);
	  avmCreateInfo(msg,"AVM");
    }
  XtFree(tableName);
}
void avmArchive(Widget w,XtPointer client_data,XtPointer call_data) /* perform oracle export via this callback */
{
  char *pathName;
  char *tableName;
  char fullPath[80];
  struct stat stBuff;
  char msg[80];
  char  cmd[80];

  pathName = XmTextGetString(editPath);
  tableName = XmTextGetString(editTable);
#ifdef	WIN32
  sprintf(fullPath,"%s\\%s.dmp\0",pathName,tableName);
#else
  sprintf(fullPath,"%s/%s.dmp\0",pathName,tableName);
#endif	WIN32
  sprintf(cmd,"cd %s; export_archive %s\0",pathName, tableName);
  if(system(cmd) < 0)
    {
      sprintf(msg,"Export error for table %s\n%s\n%s\0",tableName,pathName,sys_errlist[errno]);
      avmCreateInfo(msg,"AVM");
      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
    }
  else
    {
      if(stat(fullPath,&stBuff) < 0)
	{
	  sprintf(msg,"Export error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
	  avmCreateInfo(msg,"AVM");
	}
	else
	{
	  sprintf(msg,"Archive completed for file\n%s\n\0",fullPath);
	  avmCreateInfo(msg,"AVM");
	}
    }
  XtFree(pathName);
  XtFree(tableName);
}
void avmSetLabel(char online,time_t startDate,char *pathName)
{
  XmString labelString;
  char msg[80];

  avmCurrStatus = online;
  sprintf(msg,"Volume is: %s\0",(online ? "ONLINE " : "OFFLINE"));
  labelString = XmStringCreateLocalized(msg);
  XtVaSetValues(editIsMounted,XmNlabelString,labelString,NULL);
  XmStringFree(labelString);
  /* update catalog entry */
  catUpdateEntry(startDate,(time_t)0,0,0,pathName,online);
}
void avmCopyOnLoad(Widget w,XtPointer client_data,XmFileSelectionBoxCallbackStruct *cbs)
{
  char *newPath;

  XmStringGetLtoR(cbs->value,XmFONTLIST_DEFAULT_TAG,&newPath);
  XmTextSetString(editPath,newPath);
  XtFree(newPath);
}
void avmCheckPath(Widget w,XtPointer client_data,XmTextVerifyCallbackStruct *cbs)  	/* exit program */
{
  if(cbs -> event == NULL)			/* if other than keyboard entry ignore */
    return;
#ifndef SOLARIS
  if(cbs->text->ptr == NULL)			/* must have been backspace */
    return;
#else
  if(cbs->text == NULL)
    return;
#endif
  if(isspace(cbs->text->ptr[0]))	       	/* white space the show path dialog */
    {
      cbs->doit = False;			/* don't put char in widget */
      XtManageChild(editPathSelect);
    }
}
void avmStringTime (time_t timeVal, char *string)
{
  struct tm *tmPtr;

  tmPtr = gmtime(&timeVal);
  sprintf(string,AVM_DATE_FORMAT,tmPtr->tm_mon+1,tmPtr->tm_mday,tmPtr->tm_year % 100,tmPtr->tm_hour,tmPtr->tm_min,tmPtr->tm_sec);
}
