/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <avm.h>
#include <errno.h>
/* create and manage the AVM edit dialog box */
static Widget editList,editApply,editDelete,editDismiss,sel,editRowCol,editDOU,editRFO,editCOL;
static Widget editStart,editEnd,editIsMounted,editDisk,editPath,editTable,frame;
static Widget editLoad,editUnload,editPathSelect;
static XmString avmCurrentItem;
void avmSetLabel(char online,time_t startDate,char *pathName);
void avmCopyOnLoad(Widget w,XtPointer client_data,XmFileSelectionBoxCallbackStruct *cbs);
int entryChanged = 0;
time_t saveStartDate;
static char avmCurrStatus;
static char oldPathName[AVM_MOUNTPNT_SIZE+1];
extern char *sys_errlist[];
void avmCreateEdit(Widget parent)
{
  Widget label;
  int n=0;
  Arg args[20];
  XmString title,listLabel,selLabel,okLabel,cancelLabel,helpLabel,applyLabel,dirString;
  
  title = XmStringCreateLocalized("Archive Volume Maintenance");
  avmEditDialog = XmCreateBulletinBoard(parent,"ARCHIVE",args,n);
  XtVaSetValues(avmEditDialog,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogTitle,title,NULL);
  n=0;
  listLabel = XmStringCreateLocalized("     Table          Start Date    -    End Date");
  okLabel = XmStringCreateLocalized("Apply");
  applyLabel = XmStringCreateLocalized("Dismiss");
  cancelLabel = XmStringCreateLocalized("Load");
  helpLabel = XmStringCreateLocalized("Unload");
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNapplyLabelString,applyLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNhelpLabelString,helpLabel);n++;
  XtSetArg(args[n],XmNlistVisibleItemCount,14);n++;
  /* create dialog */
  sel = XmCreateSelectionBox(avmEditDialog,"EDIT",args,n);
  XtManageChild(XmSelectionBoxGetChild(sel,XmDIALOG_APPLY_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_TEXT));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_SELECTION_LABEL));
  /* get children widgets */
  editList = XmSelectionBoxGetChild(sel,XmDIALOG_LIST);
  XtVaSetValues(editList,XmNscrollBarDisplayPolicy,XmSTATIC,NULL);
  XtRemoveAllCallbacks(editList,XmNdefaultActionCallback);
/*   XtRemoveAllCallbacks(editList,XmNbrowseSelectionCallback); */
  XtAddCallback(editList,XmNbrowseSelectionCallback,(XtCallbackProc)avmSelect,(XtPointer)0);
  /* add callbacks */
  XtAddCallback(sel,XmNokCallback,(XtCallbackProc)avmApply,(XtPointer)0);
  XtAddCallback(sel,XmNapplyCallback,avmDismiss,(XtPointer)0);
  XtAddCallback(sel,XmNcancelCallback,avmLoad,(XtPointer)0);
  XtAddCallback(sel,XmNhelpCallback,avmUnLoad,(XtPointer)0);
  /* manage selection box and free strings */
  XtManageChild(sel);
  XtManageChild(avmEditDialog);
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(applyLabel);
  XmStringFree(cancelLabel);
  XmStringFree(helpLabel);
  /* Add text widgets */
#ifdef EDITSTARTEND
  /* Start Date */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,20);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_STARTDATE_SIZE*2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
#ifndef ENABLE_ADDITION
  XtSetArg(args[n],XmNeditable,False);n++;
#endif
  editStart = XmCreateText(avmEditDialog,"START",args,n);
  XtManageChild(editStart);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Start Date:",11,
				  XmNx,439,
				  XmNy,26,
				  NULL);
 /* End Date */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,60);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_ENDDATE_SIZE*2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
#ifndef ENABLE_ADDITION
  XtSetArg(args[n],XmNeditable,False);n++;
#endif
  editEnd = XmCreateText(avmEditDialog,"END",args,n);
  XtManageChild(editEnd);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"End Date:",10,
				  XmNx,453,
				  XmNy,66,
				  NULL);
#endif EDITSTARTEND
  /* Disk Label */
  n=0;
  XtSetArg(args[n],XmNx,490);n++;
  XtSetArg(args[n],XmNy,80);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_DISKLABEL_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_DISKLABEL_SIZE);n++;
  editDisk = XmCreateText(avmEditDialog,"DISK",args,n);
  XtManageChild(editDisk);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Disk Label",12,
				  XmNx,530,
				  XmNy,60,
				  NULL);
  XtAddCallback(editDisk,XmNvalueChangedCallback,(XtCallbackProc)avmModified,0);

  /* Mount point */
  n=0;
  XtSetArg(args[n],XmNx,490);n++;
  XtSetArg(args[n],XmNy,140);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_MOUNTPNT_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_MOUNTPNT_SIZE);n++;
  editPath = XmCreateText(avmEditDialog,"PATH",args,n);
  XtManageChild(editPath);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Path to database",18,
				  XmNx,530,
				  XmNy,120,
				  NULL);
  XtAddCallback(editPath,XmNmodifyVerifyCallback,(XtCallbackProc)avmCheckPath,0);

#ifdef EDITTABLE
  /* Oracle Table */
  n=0;
  XtSetArg(args[n],XmNx,530);n++;
  XtSetArg(args[n],XmNy,200);n++;
  XtSetArg(args[n],XmNmaxLength,AVM_TABLENAME_SIZE);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,AVM_TABLENAME_SIZE);n++;
  XtSetArg(args[n],XmNeditable,False);n++;
  editTable = XmCreateText(avmEditDialog,"PATH",args,n);
  XtManageChild(editTable);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,avmEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Oracle table:",14,
				  XmNx,423,
				  XmNy,180,
				  NULL);
  XtAddCallback(editTable,XmNvalueChangedCallback,(XtCallbackProc)avmModified,0);
#endif EDITTABLE

  /* Set/Display online status */
  editIsMounted = XtVaCreateManagedWidget("ONL",xmLabelWidgetClass,avmEditDialog,
					  XtVaTypedArg,XmNlabelString,XmRString,"Volume is: ONLINE ",19,
					  XmNx,530,
					  XmNy,190,
					  NULL);

/*   frame = XtVaCreateManagedWidget("frame",xmFrameWidgetClass,avmEditDialog, */
/* 				  XmNx,453, */
/* 				  XmNy,265, */
/* 				  XmNshadowType,XmSHADOW_ETCHED_OUT, */
/* 				  NULL); */

/*   editRowCol = XtVaCreateManagedWidget("rowcol",xmRowColumnWidgetClass,frame, */
/* 				       XmNorientation,XmVERTICAL, */
/* 				       XmNpacking,XmPACK_COLUMN, */
/* 				       XmNnumColumns,2, */
/* 				       NULL); */
  
/*   editCOL = XtVaCreateManagedWidget("COL",xmToggleButtonWidgetClass,editRowCol, */
/* 					  XtVaTypedArg,XmNlabelString,XmRString,"Copy on Load",13, */
/* 					  XmNindicatorSize,15, */
/* 					  XmNmarginHeight,0, */
/* 					  NULL); */
  editDOU = XtVaCreateManagedWidget("DOU",xmToggleButtonWidgetClass,avmEditDialog,
					  XtVaTypedArg,XmNlabelString,XmRString,"Delete after copy",19,
					  XmNx,530,
					  XmNy,222,
					  XmNindicatorSize,15,
					  XmNmarginHeight,0,
					  NULL);

/*   label = XtVaCreateManagedWidget("sep",xmSeparatorWidgetClass,avmEditDialog, */
/* 				  XmNx,392, */
/* 				  XmNy,297, */
/* 				  XmNwidth,405, */
/* 				  NULL); */

  /* Load button */
/*   editLoad = XtVaCreateManagedWidget("Load",xmPushButtonWidgetClass,avmEditDialog, */
/* 				      XmNx,392, */
/* 				      XmNy,315, */
/* 				      XmNheight,29, */
/* 				      XmNwidth,75, */
/* 				      NULL); */
/*   XtAddCallback(editLoad,XmNactivateCallback,avmLoad,(XtPointer)0); */
  /* Unload button */
/*   editUnload = XtVaCreateManagedWidget("Unload",xmPushButtonWidgetClass,avmEditDialog, */
/* 				      XmNx,479, */
/* 				      XmNy,315, */
/* 				      XmNheight,29, */
/* 				      XmNwidth,75, */
/* 				      NULL); */
/*   XtAddCallback(editUnload,XmNactivateCallback,avmUnLoad,(XtPointer)0); */
  title = XmStringCreateLocalized("Archive directorys");
  dirString = XmStringCreateLocalized("/archiveA/dbs");
  n=0;
  XtSetArg(args[n],XmNdialogTitle,title);n++;
  XtSetArg(args[n],XmNautoUnmanage,True);n++;
  XtSetArg(args[n],XmNdirectory,dirString);n++;
  editPathSelect = (Widget)XmCreateFileSelectionDialog(avmEditDialog,"BROWSE",args,n);
  label = XmSelectionBoxGetChild(editPathSelect,XmDIALOG_LIST);
  XtUnmanageChild(XtParent(label));
  XtUnmanageChild(XmSelectionBoxGetChild(editPathSelect,XmDIALOG_LIST_LABEL));
  XtUnmanageChild(XmSelectionBoxGetChild(editPathSelect,XmDIALOG_HELP_BUTTON));
  XtAddCallback(editPathSelect,XmNokCallback,(XtCallbackProc)avmCopyOnLoad,(XtPointer)0);
  XmStringFree(title);
  XmStringFree(dirString);
}
/*
  load the first record and fill in the data
*/
void editInit()
{
char line[80],startStr[AVM_STARTDATE_SIZE],endStr[AVM_ENDDATE_SIZE];
XmString item;
int stat,count;
char *tableName;

while(stat = catGetNextRawEntry(startStr,endStr,tableName,NULL,NULL,NULL))
  {
    sprintf(line,AVM_LIST_FORMAT,tableName,startStr,endStr);
    item = XmStringCreateLocalized(line);
    XmListAddItem(editList,item,0);
    XmStringFree(item);
  }
XtVaGetValues(editList,XmNitemCount,&count,NULL);
if(count)
  XmListSelectPos(editList,1,True);
entryChanged = 0;
}
/*
  Apply any changes to the record specified by the selection saveStartDate
  */
void avmApply(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)	/* save data to current record */
{
  char *choice;
  char line[80],*startStr,*endStr,*param,online;
  char *diskName,*pathName,*tableName;
  XmString item;
  time_t startDate,endDate;
  struct tm tmBuff;

#ifdef EDITSTARTEND
  memset((char *)&tmBuff,0,sizeof(struct tm));
  startStr = XmTextGetString(editStart);
  sscanf(startStr,AVM_DATE_FORMAT,&tmBuff.tm_mon,&tmBuff.tm_mday,&tmBuff.tm_year,&tmBuff.tm_hour,&tmBuff.tm_min,&tmBuff.tm_sec);
  tmBuff.tm_mon--;
  startDate = mktime(&tmBuff) - timezone;

  memset((char *)&tmBuff,0,sizeof(struct tm));
  endStr = XmTextGetString(editEnd);
  sscanf(endStr,AVM_DATE_FORMAT,&tmBuff.tm_mon,&tmBuff.tm_mday,&tmBuff.tm_year,&tmBuff.tm_hour,&tmBuff.tm_min,&tmBuff.tm_sec);
  tmBuff.tm_mon--;
  endDate = mktime(&tmBuff) - timezone;
#else
  startDate = saveStartDate;
#endif EDITSTARTEND

  diskName = XmTextGetString(editDisk);
  pathName = XmTextGetString(editPath);
  if(!catUpdateEntry(startDate,(time_t)0,0,diskName,pathName,-1))
    {
#ifdef ENABLE_ADDITION
      catAddEntry(startDate,endDate,tableName,diskName,pathName,online);
      sprintf(line,AVM_LIST_FORMAT,startStr,endStr);
      item = XmStringCreateLocalized(line);
      XmListAddItem(editList,item,0);
      XmStringFree(item);
#endif
    }
  XtFree(diskName);
  XtFree(pathName);
#ifdef EDITSTARTEND
  XtFree(endStr);
  XtFree(startStr);
#endif EDITSTARTEND
  entryChanged = 0;
}
void avmDismiss(Widget w,XtPointer client_data,XtPointer call_data)   	/* ask to exit program...prompt if modified */
{
  if(entryChanged)
    {
      avmCreateAreYouSure("Quit without saving changes ?","AVM");
      XtRemoveAllCallbacks(avmAreYouSure,XmNokCallback);
      XtAddCallback(avmAreYouSure,XmNokCallback,avmDoDismiss,(XtPointer)0);
      return;
    }
  catClose();
  exit(1);
}
void avmDoDismiss(Widget w,XtPointer client_data,XtPointer call_data)  	/* exit program */
{
  catClose();
  exit(1);
}
void avmSelect(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)     /* select record from list based on date range */
{
char online,*choice,*startStr,*endStr,diskName[AVM_DISKLABEL_SIZE+1],pathName[AVM_MOUNTPNT_SIZE+1],tableName[AVM_TABLENAME_SIZE+1];
time_t startDate;
struct tm tmBuff;
int type,status;
char *table;

avmCurrentItem = XmStringCopy(cbs->value);
XmStringGetLtoR(cbs->value,XmFONTLIST_DEFAULT_TAG,&choice);
table = strtok(choice," ");
startStr = strtok(NULL," ");
endStr = strtok(NULL," ");
#ifdef EDITSTARTEND
XmTextSetString(editStart,startStr);
XmTextSetString(editEnd,endStr);
#endif EDITSTARTEND
XtFree(choice);
/*
  fill in rest of fields
*/
memset((char *)&tmBuff,0,sizeof(struct tm));
sscanf(startStr,AVM_DATE_FORMAT,&tmBuff.tm_mon,&tmBuff.tm_mday,&tmBuff.tm_year,&tmBuff.tm_hour,&tmBuff.tm_min,&tmBuff.tm_sec);
tmBuff.tm_mon--;
startDate = mktime(&tmBuff) - timezone;
saveStartDate = startDate;
status = catGetEntry(startDate,NULL,NULL,tableName,diskName,pathName,&online);
if((status == 1) || ((status == 0) && strlen(tableName)))
  {
    XmTextSetString(editDisk,diskName);
    XmTextSetString(editPath,pathName);
#ifdef EDITTABLE
    XmTextSetString(editTable,tableName);
#endif EDITTABLE
    avmSetLabel(online,0,0);
    avmCurrStatus = online;
    strcpy(oldPathName,pathName);	/* save here for unload */
    entryChanged = 0;
  }
}
void avmModified(Widget w,XtPointer client_data,XtPointer call_data)	/* mark record as modified via this callback */
{
entryChanged = 1;
}
void avmLoad(Widget w,XtPointer client_data,XtPointer call_data)	/* perform oracle load via this callback */
{
  char *pathName;
  char *tableName;
  char fullPath[80];
  struct stat stBuff;
  char msg[80];
  char  cmd[80];

  if(avmCurrStatus == 1)					/* if already online then skip rest */
    {
      sprintf(msg,"Volume\n%s\nalready online",tableName);
      avmCreateInfo(msg,"AVM");
      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
    }
  else
    {
      /* use pathName as location of new tablespace support file */
      pathName = XmTextGetString(editPath);
      tableName = XmTextGetString(editTable);
      /* use oldPath as location of imp/exp file data */
      sprintf(fullPath,"%s%s.dmp\0",oldPathName,tableName);
      /* then import, and place online. use current archive info params for tablespace config. */ 
      if((stat(fullPath,&stBuff)) < 0)
	{
	  sprintf(msg,"Import file does not exist!\n%s\n%s\0",fullPath,sys_errlist[errno]);
	  avmCreateInfo(msg,"AVM");
	  XtRemoveAllCallbacks(avmInfo,XmNokCallback);
	  XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
	}
      else
	{
	  sprintf(cmd,"create_archive %s %d %s",tableName,tableSize,pathName);
	  if(system(cmd) < 0)
	    {
	      sprintf(msg,"Create error for archive tablespace\n%s\n%s\0",fullPath,sys_errlist[errno]);
	      vmCreateInfo(msg,"AVM");
	      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
	      XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
	    }
	  else
	    {
	      /* change the directory and import the data to the new tablespace */
	      sprintf(cmd,"cd %s; import_archive %s\0",oldPathName,tableName);
	      if(system(cmd) < 0)
		{
		sprintf(msg,"Copy error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
		avmCreateInfo(msg,"AVM");
		XtRemoveAllCallbacks(avmInfo,XmNokCallback);
		XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
		}
	      else
	        {
		  avmSetLabel(0,saveStartDate,pathName);   	/* set label and update catalog */
	        }
	    }
	}
      else
	{
	  sprintf(msg,"File error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
	  avmCreateInfo(msg,"AVM");
	  XtRemoveAllCallbacks(avmInfo,XmNokCallback);
	}
    }
  XtFree(pathName);
  XtFree(tableName);
}
void avmUnLoad(Widget w,XtPointer client_data,XtPointer call_data)	/* perform oracle un-load via this callback */
{
  char *tableName;
  char *pathName;
  int online;
  char  cmd[80];
  char  msg[80];
  char fullPath[80];
  struct stat stBuff;

  if(avmCurrStatus == 0)					/* if already online then skip rest */
    {
      sprintf(msg,"Volume\n%s\nalready offline",tableName);
      avmCreateInfo(msg,"AVM");
      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
    }
  else
    {
      tableName = XmTextGetString(editTable);
      pathName = XmTextGetString(editPath);
      /* first place table offline */
      if(UnloadArchiveData(tableName))
	{
      /*
	Now that the table is offline, export the tables in the tablespace.
	Set the current directory to the path information, and export_archive <tablename>.
      */
	  if(strcmp(oldPathName,pathName) != 0)
	    {
	      /* cd to the destination path, and export the tables */
	      sprintf(fullPath,"%s%s.dbf\0",oldPathName,tableName);
	      sprintf(cmd,"cd %s; export_archive %s\0",fullPath,tableName);
	      if(system(cmd) < 0)
		{
		  sprintf(msg,"Command error for archive export\n%s\n%s\0",fullPath,sys_errlist[errno]);
		  avmCreateInfo(msg,"AVM");
		  XtRemoveAllCallbacks(avmInfo,XmNokCallback);
		  XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
		  LoadArchiveData(tableName);			/* restore to ONLINE status */
		}
	      else
		{
		  if(stat(fullPath,&stBuff) < 0)
		    {
		      sprintf(msg,"Export error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
		      avmCreateInfo(msg,"AVM");
		      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
		      XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
		      LoadArchiveData(tableName);		/* restore to ONLINE status */
		    }
		  else
		    {
		      avmSetLabel(0,saveStartDate,pathName);   	/* set label and update catalog */
		      MoveArchiveData(tableName,oldPathName,pathName);
		      if(XmToggleButtonGetState(editDOU))	/* See if we should drop the table */
			{
			  sprintf(cmd,"drop_archive %s\0",tableName);
			  if(system(cmd) < 0)
			    {
			      sprintf(msg,"Drop_archive error for table\n%s\n%s\0",tableName,sys_errlist[errno]);
			      avmCreateInfo(msg,"AVM");
			      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
			    }
			  sprintf(cmd,"rm %s\0",fullPath);
			  if(system(cmd) < 0)
			    {
			      sprintf(msg,"Delete error for file\n%s\n%s\0",fullPath,sys_errlist[errno]);
			      avmCreateInfo(msg,"AVM");
			      XtRemoveAllCallbacks(avmInfo,XmNokCallback);
			    }
			}
		    }
		}
	    }
	  else
	    {
	      avmSetLabel(0,saveStartDate,pathName);   	/* set label and update catalog */
	    }
	}
      else
	{
	  sprintf(msg,"Oracle error for file\n%s\0",tableName);
	  avmCreateInfo(msg,"AVM");
	  XtRemoveAllCallbacks(avmInfo,XmNokCallback);
	  XmTextSetString(editPath,oldPathName);	/* did not work... reset path name */
	}
    }
  XtFree(pathName);
  XtFree(tableName);
}
void avmSetLabel(char online,time_t startDate,char *pathName)
{
  XmString labelString;
  char msg[80];

  avmCurrStatus = online;
  sprintf(msg,"Volume is: %s\0",(online ? "ONLINE " : "OFFLINE"));
  labelString = XmStringCreateLocalized(msg);
  XtVaSetValues(editIsMounted,XmNlabelString,labelString,NULL);
  XmStringFree(labelString);
  /* update catalog entry */
  if(pathName)
    catUpdateEntry(startDate,(time_t)0,0,0,pathName,online);
}
void avmCopyOnLoad(Widget w,XtPointer client_data,XmFileSelectionBoxCallbackStruct *cbs)
{
  char *newPath;

  XmStringGetLtoR(cbs->value,XmFONTLIST_DEFAULT_TAG,&newPath);
  XmTextSetString(editPath,newPath);
  XtFree(newPath);
}
void avmCheckPath(Widget w,XtPointer client_data,XmTextVerifyCallbackStruct *cbs)  	/* exit program */
{
  if(cbs -> event == NULL)			/* if other than keyboard entry ignore */
    return;
#ifndef SOLARIS
  if(cbs->text->ptr == NULL)			/* must have been backspace */
    return;
#else
  if(cbs->text == NULL)
    return;
#endif
  if(isspace(cbs->text->ptr[0]))	       	/* white space the show path dialog */
    {
      cbs->doit = False;			/* don't put char in widget */
      XtManageChild(editPathSelect);
    }
}
