/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include "DBDefines.h"


typedef enum {NO_CREATE,YES_CREATE} CREATE_FLAG;

/*
  parameters may be NULL if value not desired
*/

int  catOpen(CREATE_FLAG create_it,
	     char *id);

int  catAddEntry(time_t startDate,		/* start date of volume */
		 time_t endDate,		/* end date of data on this volume */
		 char *tableName,		/* Oracle table name */
		 char *diskName,		/* paper label name on disk */
		 char *pathName,		/* where to mount disk */
		 char onlineFlag);		/* is table on line 1=yes,0=no */

int  catUpdateEntry(time_t startDate,
		    time_t endDate,
		    char *tableName,
		    char *diskName,
		    char *pathName,
		    char onlineFlag);

int  catGetEntry(time_t targetDate,		/* desired date of user data */
		 time_t *startDate,		/* start date from disk entry */
		 time_t *endDate,		/* end date from disk entry */
		 char *tableName,
		 char *diskName,
		 char *pathName,
		 char *onlineFlag);

int catGetEntryByTableName(char *targetTable,	/* get other parameters given the table name */
			   time_t *startDate,
			   time_t *endDate,
			   char *diskName,
			   char *pathName,
			   char *onlineFlag);

DB_RECORD_PTR  catGetNextRawEntry(char *startDate,	/* date string from file */
			char *endDate,
			char *tableName,
			char *diskName,
			char *pathName,
			char *onlineFlag);

DB_RECORD_PTR  catDeleteCurrentEntry(void);

time_t  catGetEarliestStartDate(void);		/* get the earliest start date from the file */

time_t  catGetLatestEndDate(void);		/* get the latest end date from the file */

void catClose(void);
