/*caContext.c,v 1.1.1.1 1999/08/03 14:41:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		FIND CONTEXT FOR THIS TASK			*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef vxWorks
#include <vxWorks.h>
#include <socket.h>
#include <in.h>
#include <taskLib.h>
#include <string.h>
#include <memLib.h>

#include "agentMsgs.h"
#include "agentErrs.h"
#endif vxWorks

#ifdef vms
#include <selectvms.h>
#endif vms

#include "cadef.h"
#include "caContext.h"

extern CATX	*firstContext;

CATX *getContext()
{
#ifndef vxWorks
    return (firstContext);
#else
    int		myPid;
    CATX	*currCTX;

    myPid = taskIdSelf();
    currCTX = firstContext;

    while (currCTX)
	{
	if (currCTX -> taskId == myPid)
	    return (currCTX);
	currCTX = currCTX -> nextTask;
	}
    return (currCTX);
#endif
}


/****************************************************************/
/*								*/
/*		IMPORT ANOTHER CONTEXT FOR OUR OWN		*/
/*								*/
/****************************************************************/

#ifdef vxWorks
int ca_import(targetId)
int	targetId;
{
    CATX		*myCTX;
    CATX		*targetCTX;

    /*
    Get a pointer to my own context, creating one if necessary.
    */

    myCTX = getContext();

    /*
    See if there's one that can be reused before allocating a new one.
    */

    if (!myCTX)
	{
        taskLock();
        myCTX = firstContext;
        while (myCTX)
	    {
	    if (!(myCTX -> taskId))
	        {
	        targetCTX = myCTX -> nextTask;
	        memset((char *) myCTX, 0, sizeof(CATX));
	        myCTX -> nextTask = targetCTX;
	        myCTX -> taskId = taskIdSelf();
	        break;
	        }
	    myCTX = myCTX -> nextTask;
	    }
        taskUnlock();
	}

    if (!myCTX)
	{
	myCTX = (CATX *) calloc(1, sizeof(CATX));
	taskLock();
	myCTX -> nextTask = firstContext;
	firstContext = myCTX;
	taskUnlock();
	myCTX -> taskId = taskIdSelf();
	}

    /*
    Find the one that he wants to "borrow"
    */

    targetCTX = firstContext;
    while (targetCTX)
	{
	if (targetCTX -> taskId == targetId)
	    break;
	targetCTX = targetCTX -> nextTask;
	}

    if (!targetCTX)
	{
	myCTX -> taskId = 0;
	return (AGNT_NOCACTX);
	}
    myCTX -> importedContext = targetCTX;
    return (AGNT_NORMAL);
}
#endif
