/*caExit.c,v 1.1.1.1 1999/08/03 14:41:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	COMPLETELY DISCONNECT FROM CHANNEL ACCESS		*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#define FALSE	0

#ifdef	vms
#include <selectvms.h>
#endif vms

#ifdef vxWorks
#include <ioLib.h>
#endif vxWorks

#include "dbDefs.h"
#include "cadef.h"
#include "agentErrs.h"
#include "caContext.h"

extern CATX	*firstContext;

#ifdef vxWorks
void ca_task_exit(taskId)
int	taskId;
#else
void ca_task_exit (void)
#endif vxWorks
{
    chid	currChid;
    chid	nextChid;
    CATX	*ctx;

    /*
    Get our context
    */

#ifdef vxWorks
    /*
    In vxWorks, a task delete hook is called for every task that
    terminates. See if this task is a Channel Access user.
    */

    ctx = firstContext;
    while (ctx)
	{
	if (ctx -> taskId == taskId)
	    break;
	ctx = ctx -> nextTask;
	}
    if (!ctx)
	return;
#else
    ctx = getContext();
#endif

    /*
    Run along all of the chids, freeing them as we go.
    */

    currChid = ctx -> pFirstChid;
    while (currChid)
	{
	nextChid = currChid -> pNextChan;
	currChid -> pPrevChan = currChid;	/* Protect against double close */
	deleteCHID(currChid);
	currChid = nextChid;
	}

    /*
    Now close the socket, and then forget that we've ever been initialized.
    */

    if (ctx -> caSocketFd)
	{
#ifdef WIN32
	closesocket(ctx -> caSocketFd);
#else
	close(ctx -> caSocketFd);
#endif WIN32
    	if (ctx -> regFunc)
	    (*(ctx -> regFunc))(ctx -> regFuncArg, ctx -> caSocketFd, FALSE);
	ctx -> caSocketFd = 0;
	}

#ifdef vxWorks
    /*
    Delete the MutEx semaphore if used...
    */
    if (ctx -> sockMeSem)
	{
	semDelete (ctx -> sockMeSem);
	ctx -> sockMeSem = 0;
	}

    /*
    Indicate that context is free so that it can be reused.
    */

    ctx -> taskId = 0;
#endif vxWorks

    /*
    Done.
    */

    return;
}
