/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*			CLOSE A CHANNEL				*/
/*								*/
/*	This function closes a channel. First, if there are	*/
/*	any active monitors, we remove them. Then we close	*/
/*	the channel itself. Finally, we free the chid itself,	*/
/*	removing it from the chain.				*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef vms
#include <selectvms.h>
#endif
#ifdef WIN32
#include <sys/types.h>
#include	<winsock.h>
extern int sendCAQ(short, char *, int);
#else
#include <types.h>
#include <in.h>
#endif WIN32

#include "dbDefs.h"
#include "cadef.h"
#include "agentMsgs.h"
#include "agentErrs.h"

int ca_clear_channel(pChid)
chid	pChid;
{
    evid	currEvnt;
    /*CH_MONREM	monRem;*/
    CH_CLOSE	chanClose;
    short	msgType;

    /*
    Preliminary test -- make sure that the user is not trying
    to close a channel he's already closed!
    */

    if (pChid -> pPrevChan == pChid)
	return (AGNT_NORMAL);

    /*
    Next, run down the events, if there are any.
    */
    
    currEvnt = pChid -> pFirstEvnt;
    while (currEvnt)
	{
	/*evid	oldEvnt;*/

	/*msgType = htons(CHAN_MONREM);*/
	/*monRem.chHandle = pChid -> handle;*/
	/*sendCAQ(msgType, (char *) &monRem, sizeof(monRem));*/
	currEvnt -> userFunc = 0;
	/*oldEvnt = currEvnt;*/
	currEvnt = currEvnt -> pNextEvnt;

	/*
	Test this...don't delete the EVID until we delete the CHID!
	*/

	/* deleteEVID(oldEvnt); */
	}

    /*
    Now clear the channel itself.
    */

    pChid -> chanState = closed;
    msgType = htons(CHAN_CLOSE);
    chanClose.chHandle = pChid -> handle;
#ifndef POINTER64
    chanClose.chAppHandle = (int) pChid;
#else
    chanClose.chAppHandle = pChid -> chidToken;
#endif
    sendCAQ(msgType, (char *) &chanClose, sizeof(chanClose));

    /*
    Don't unchain the Chid until chanAcq tells us he's cleared it out!
    That code moved to msgProc.c
    */

    return (AGNT_NORMAL);
}

