/*clientInit.c,v 1.1.1.1 1999/08/03 14:42:00 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	INITIALIZE THE CHANNEL ACCESS AGENT TASKS		*/
/*								*/
/*	This function is used in the vxWorks environment.	*/
/*	It spawns the two tasks that support all of the		*/
/*	Channel access clients in the IOC.			*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <vxWorks.h>
#include <fioLib.h>
#include <stdio.h>
#include <task_params.h>

int sockMnt();
int chanAcq();

void caClientInit(void)
{
    if (taskSpawn(CHANACQ_NAME, CHANACQ_PRI, CHANACQ_OPT, CHANACQ_STACK, chanAcq, 0,0,0,0,0,0,0,0,0,0) == ERROR)
	{
	printErr("Can't spawn chanAcq!\n");
	}

    taskDelay(6);

    if (taskSpawn(SOCKMNT_NAME, SOCKMNT_PRI, SOCKMNT_OPT, SOCKMNT_STACK, sockMnt, 0,0,0,0,0,0,0,0,0,0) == ERROR)
	{
	printErr("Can't spawn sockMnt!\n");
	}
}
