/****************************************************************/
/*								*/
/*	CONVERT DATA STREAM INTO AN ALARM STRUCTURE		*/
/*								*/
/*	This function takes the variable part of the data	*/
/*	stream in a CHAN_ALARM message and parses it into	*/
/*	the appropriate structure members.			*/
/*								*/
/*	This stream consists of the null terminated point	*/
/*	name followed by the null terminated descriptor		*/
/*	followed by the null terminated value followed by	*/
/*	the null terminated EGU tag.
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <string.h>
#include "dbDefs.h"
#include "tisAlarm.h"


int caConvAlarmData(buff, alarm)
char		*buff;
tisAlarm	*alarm;
{
    short	length;

    strcpy(alarm -> pvName, buff);
    length = strlen(buff) + 1;
    buff += length;
    strcpy(alarm -> pvDesc, buff);
    length = strlen(buff) + 1;
    buff += length;
    strcpy(alarm -> alarmValue, buff);
    length = strlen(buff) + 1;
    buff += length;
    strcpy(alarm -> pvEgu, buff);
    return 0;
}
