/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "ctr.h"
void ctrReconnectCallback (void *arg, int fd, int cond)	/* Reconnect to CA */
{
  if (cond == 0)
    {
      doConnect = 1;
      if (debugLevel >= 1)
	syslog (LOG_OPTIONS, "Connection to CA lost.\n");
    }
  else
    {
    caFd = fd;				/* save CA fd here */
    if(caFd > maxFd) maxFd = caFd;	/* add to group I'm interested in */
    FD_SET(caFd,&myFds);
    bcopy((char *)&myFds,(char *)&saveFds,sizeof(fd_set));
    }
}

/*----------*/
void ctrDataCallback (char *chanName, short type,short count,void *buffPtr)
{
  int	success, intVal;
  double	doubleVal;
  float	floatVal;
  short	shortVal;
  char	charVal;
  long	longVal;
/*
  Check for an invalid timestamp.
*/
  if (((struct dbr_time_short *)buffPtr)->stamp.secPastEpoch < 100000)
    return;
  switch (type)
    {
    case DBR_TIME_STRING:
      syslog (LOG_OPTIONS, "Received DBR_TIME_STRING -- ignored."); 
      break;
    case DBR_TIME_SHORT:
      memcpy ((char *)&shortVal, (char *)&((struct dbr_time_short *)buffPtr)->value, sizeof (short));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_short *)buffPtr)->stamp,(double)shortVal);
      break;
    case DBR_TIME_FLOAT:
      memcpy ((char *)&floatVal, (char *)&((struct dbr_time_float *)buffPtr)->value, sizeof (float));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_float *)buffPtr)->stamp,(double)floatVal);
      break;
    case DBR_TIME_ENUM:
      memcpy ((char *)&shortVal, (char *)&((struct dbr_time_enum *)buffPtr)->value, sizeof (short));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_enum *)buffPtr)->stamp,(double)shortVal);
      break;
    case DBR_TIME_CHAR:
      memcpy ((char *)&charVal, (char *)&((struct dbr_time_char *)buffPtr)->value, sizeof (char));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_char *)buffPtr)->stamp,(double)charVal);
      break;
    case DBR_TIME_LONG:
      memcpy ((char *)&longVal, (char *)&((struct dbr_time_long *)buffPtr)->value, sizeof (long));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_long *)buffPtr)->stamp,(double)longVal);
      break;
    case DBR_TIME_DOUBLE:
      memcpy ((char *)&doubleVal, (char *)&((struct dbr_time_double *)buffPtr)->value, sizeof (double));
      success = ctrUpdateSamples (chanName,&((struct dbr_time_double *)buffPtr)->stamp,doubleVal);
      break;
    }
}

/*----------*/
void ctrConnectCallback (char *resName, short status)
{
TS_STAMP	ts;

if (status == 0)
  {	/* Resource has been lost */
    syslog (LOG_OPTIONS, "Resource %s has been lost",resName);
  }
}
/*
  Update sliding buffer with data from new CA report. 
  */
int ctrUpdateSamples(char *name,TS_STAMP *tm,double data)
{
  TREND_ENTRY   *pEntry,entry;

  strcpy(&entry.ctName[0],name);
  if(pEntry = avl_findsym(ctTree,&entry))
    {
/*  printf("Sample from CA for %s...%f\n",name,data); */
      pEntry->ctTime = *tm;
      pEntry->ctRecentSample = (float)data;
    }
return(1);
}
