#ifndef	datavuHXX
#define	datavuHXX

#include "textFilters.hxx"
#include "tisgalaxylib.hxx"

//** SOME EXTERNALS
extern int	vuOutput;		// defined in dataVu.cxx
extern int	vuReadOnly;		// defined in dataVu.cxx
extern int	vuUpdatePointPriv;	// defined in dataVu.cxx
extern int	vuDeletePointPriv;	// defined in dataVu.cxx


//** SOME DEFINES *******************************************************************

#define VU_MAX_MESSAGE		128

// see usedPointDialogs[][] in vuMainDialogClass
#define	VU_MAX_USED_POINTS	10

// define the max path size
#ifndef	WIN32
#    define	VU_MAX_PATH	MAXPATHLEN
#else
#    define	VU_MAX_PATH	_MAX_PATH
#endif	!WIN32

// define the MSDOS filename length
#define	VU_MSDOS_FILENAME_SZ	8

// define the MAX MSDOS extension
#define	VU_MSDOS_EXTENSION_SZ	3

// define the dbase file extension
#define	VU_DBASE_EXTENSION	"dbf"

// some defines for the vuOutput value
#define	VU_NO_CONSOLE_MSG	0
#define	VU_CONSOLE_MSG		1

// define for an array to hold a point type name,
// PVNAME_SZ and FLDNAME_SZ found in .../epicsH/dbdefs.h
#define	VU_POINTTYPE_NAME_SZ	PVNAME_SZ + FLDNAME_SZ


//** SOME PREDEFS FOR CLASSES **********************************************************

class	vuMainDialogClass;
class	vuPvNameButtonClass;
class	vuDatabaseClass;
class	vuCommonDialogClass;
class	vuNetwork;


//** ENUM DEFINITIONS ETC. ************************************************************
enum {
    VU_ERROR = -1,
    VU_SUCCESS,
    VU_TRUE,
    VU_FALSE,
    VU_NUMMISCENUMS
};


//** ERROR and MESSAGES TO GO TO NOTICE DIALOGS *****************************
//** return values and also used to produce info message notices,
//** see vuUtils.cxx/vuMessageCenter ()
enum {
    VU_QUIT_MSG = VU_NUMMISCENUMS,	// defined in vuMainDialogClass.hxx
    VU_XREFERR,			// Database cross reference file trouble
    VU_PVMAPERR,		// PVMAP file error
    VU_IOCLISTERR,		// IOC list file error
    VU_RESLISTERR,		// Resource list file error
    VU_PRIVTABERR,		// Privilege Table file error 
    VU_FIELDTABERR,		// Field Protection Table file error
    VU_ARREDUCERR,		// Archive Reduction Table file error
    VU_IOCTABLEERR,		// IOC table error
    VU_SDRERR,			// SDR load trouble
    VU_IOADDRERR,
    VU_CALCOPERR,
    VU_SELLINKERR,
    VU_FANLINKERR,
    VU_PUMPVARSERR,
    VU_VALVEVARSERR,
    VU_TANKVARSERR,
    VU_TANKCMDSERR,
    VU_TANKPRBSERR,
    VU_TANKVLVSERR,
    VU_PIPEVARSERR,
    VU_PIPECMDSERR,
    VU_POTVARSERR,
    VU_ALGRFILEERR,		// alarm group file error
    VU_ALARMINFOERR,       	// alarm info file error
    VU_TOMANYSCREENS,		// to many screens message
    VU_MOD_DISMISS_MSG,
    VU_CREATE_NEWPT_ERR,
    VU_PTFILEERR,		// point type file error
    VU_PTTYPEALLOCERR,		// mem alloc error for vuGetPointTypeList ()
    VU_PTTYPEDIALOGERR,		// point type point type dialog mismatch
    VU_PTISDELETEDERR,		// point name is deleted
    VU_NO_POINTTYPE_SELECTED_MSG,
    VU_NO_PTNAME_ENTERED_MSG,
    VU_NO_RESOURCE_SELECTED_MSG,
    VU_NO_IOCNAME_SELECTED_MSG,
    VU_NAVPTALLOCERR_MSG,
    VU_NO_PTNAMES_SELECTED_MSG,
    VU_CALCEXPRESSIONERR,	// calc expression error
    VU_PTNOTINPVMAPERR,		// point is not in pvmap
    VU_ENDOFLIST_MSG,		// end of list message
    VU_STARTOFLIST_MSG,		// start og list msg
    VU_NO_LIST_ERR,		// there is no list, see vuNav::okButton
    VU_FANOUT_SELN_ERR,		// fanout SELN range error
    VU_FANOUT_SELNPV_ERR,	// fanout no pv in selected slot
    VU_UDBCFGERR,
    VU_NUM_NOTICE_MSGS,
    VU_UDB_CFG_NO_PGNAME_ERR,
    VU_UDB_CFG_UPDATE_MSG,
    VU_UDB_CFG_LABEL_SELECT_ERR,
    VU_UDB_CFG_NO_NEWLABEL_ERR,
    VU_UDB_CFG_DELETE_MSG,
    VU_UDB_CFG_NO_RECORD_ERR,
    VU_FLDPROT_CLEAR_REQ_MSG,	// field protection message
    VU_FLDPROT_CLEAR_ERR,
    VU_FLDPROT_APPLY_NEW_REQ_MSG,
    VU_FLDPROT_APPLY_UPDATE_REQ_MSG,
    VU_FLDPROT_APPLY_ERR,
    VU_SYSUSERSERR,		// open error on sysuers.dbf
    VU_SYSUSERS_APPLY_MOD_REQ_MSG,
    VU_SYSUSERS_APPLY_ADD_REQ_MSG,
    VU_SYSUSERS_DELETE_REQ_MSG,
    VU_SCRIPTFILEERR,
    VU_SCRIPT_NO_SELECTED_MSG,
    VU_SCRIPT_NO_ID_MSG,
    VU_SCRIPT_NOT_EXIST_MSG,
    VU_SCRIPT_NEW_REQ_MSG,
    VU_SCRIPT_MOD_REQ_MSG,
    VU_SCRIPT_DEL_REQ_MSG,
    VU_HOUR_ERR_MSG,
    VU_MINUTE_ERR_MSG,
    VU_SECONDS_ERR_MSG,
    VU_LDFW_PUMPS_DEF_ERR,
    VU_LDFW_SEQ_ERR,
    VU_LDFW2_NO_LDFW1_ERR,
    VU_LDFW2_LDFW1_EXIST_ERR,
    VU_LAUNCHCFGERR,
    VU_LAUNCHCFG_NO_KEY_ERR,
    VU_LAUNCHCFG_NEW_REQ_MSG,
    VU_LAUNCHCFG_MOD_REQ_MSG,
    VU_LAUNCHCFG_DEL_REQ_MSG,
    VU_LAUNCHCFG_NOT_EXIST_MSG,
    VU_LAUNCHCFG_NO_SELECTED_MSG,
    VU_ARCHINFO_UPDATE_REQ_MSG,
    VU_ARCHINFO_ARCH_CLEAN_ERR,
    VU_ARCHINFO_NO_FILENAME_ERR,
    VU_ARCHINFO_FILENAME_ERR,
    VU_ARCHINFO_FILEEXT_ERR,
    VU_ARCHINFO_FILEOPEN_ERR,
    VU_FILTER_ERR,
    VU_NOT_TREND_PT_MSG,
    VU_ARCH_NEW_REQ_MSG,
    VU_ARCH_UPDATE_REQ_MSG,
    VU_ARCH_DELETE_REQ_MSG,
    VU_APIFILEERR,
    VU_STRAPFILEERR,
    VU_DPAFILEERR,
    VU_DPA_NODPA_SEL_MSG,
    VU_DPA_UPDATE_REQ_MSG,
    VU_DPA_DEL_REQ_MSG,
    VU_DPA_NO_PT_MSG,
    VU_NOT_IN_DELETE_MSG,
    VU_NO_LOCK_DELETE_MSG,
    VU_DELETE_REQ_MSG,
    VU_DELETE_SELECTED_REQ_MSG,
    VU_ALARMINFO_UPDATE_REQ_MSG,
    VU_ALARMINFO_DELETE_REQ_MSG,
    VU_ALARMINFO_DELETE_ERR_MSG,
    VU_NOTHING_SELECTED_MSG,
    VU_OPPRIV_NO_OP_MSG,
    VU_OPPRIV_NO_GRP_MSG,
    VU_OPPRIV_NO_LVL_MSG,
    VU_OPPRIV_NEW_REQ_MSG,
    VU_OPPRIV_UPDATE_REQ_MSG,
    VU_OPPRIV_NOREC_MSG,
    VU_OPPRIV_DEL_REQ_MSG,
    VU_RESEDIT_RESNAME_ERR,
    VU_RESEDIT_NEW_REQ,
    VU_RESEDIT_UPDATE_REQ,
    VU_RESEDIT_DEL_REQ,
    VU_RESEDIT_DEL_ERR,
    VU_CA_DBC_RESTART_MSG,
    VU_PARTIALPT_MSG,
    VU_CA_INIT_ERR,
    VU_CA_CONN_ERR,
    VU_CA_PUT_ERR,
    VU_INIT_OPERPRIV_ERR
};



//** ENUM DEFINITIONS FOR POINT TYPES ************************************************
//** enum values for the point types, these MUST agree with
//** the list in .../share/ascii/dbRecTypes.ascii, since this
//** makes up the record type list in the SDR,
//** NOTE: in the SDR the Ai has value 1, 0 is NULL, but here
//**	   everthing is indexed from 0

enum
{
    VU_AI = 0,
    VU_AO,
    VU_BI,
    VU_BO,
    VU_CALC,
    VU_FANOUT,
    VU_MBBI,
    VU_MBBO,
    VU_PID,
    VU_SEL,
    VU_STATE,
    VU_STRINGIN,
    VU_STRINGOUT,
    VU_WAVEFORM,
    VU_LEADLAG,
    VU_RAMP,
    VU_PIPE,
    VU_TANK,
    VU_VALVE,
    VU_PUMP,
    VU_POT,
    VU_ACCUM,
    VU_PTO,
    VU_DEADTIME,
    VU_DATAMOVE,
    VU_TD,
    VU_SIGCHAR,
    VU_UDB,
    VU_PAT,
    VU_LDFW1,
    VU_LDFW2,
    VU_DDC,
    VU_NUMPOINTS
};


//** ENUM for vuGetResList (), see vuUtils.cxx ***************************************

enum {
    VU_NO_DPAS,
    VU_ALL_RESOURCES,
    VU_ONLY_DPAS,
    VU_NUMRESOURCE
};


//** ENUM definitions for error detection return for the calc blocks
//** calc expression as returned by the postfix function
enum
{
    CALC_ERR_OPNDNEEDED = 4,
    CALC_ERR_OPEREXP,
    CALC_ERR_UNPAREN,
    CALC_ERR_EXPTOBIG,
    CALC_ERR_ILLELEM,
    CALC_ERR_ONEIF,
    CALC_ERR_ONEELSE,
    CALC_ERR_NEEDIF
};


//** APPLICATION CLASS DEFINITION ****************************************************
class	ChanAccTimer;
class	dataVuApplication
{
    vapplication	*dataVuvapplication;
    vresource		dataVuvresource;
    vuMainDialogClass	*vuMainDialog;
    vuDatabaseClass	*vuDataBase;

    // database path to use
    char dbasePath [VU_MAX_PATH];

    // init error
    int	initErrors;

    // tis galaxy stuff
    int		initedTisGalaxy;
    vresource	tisGalaxyvresource;

    // channel access stuff
    // Channel access init flag
    int		    CAInit;
    ChanAccTimer    *chanAccTimer;

public:

    // class constructor
    dataVuApplication (char *programName,char *dbPath);
    // class destructor
    ~dataVuApplication (void);

    // function to return the value of initError
    int getInitErrors (void) 
	{ return (initErrors); }

    // function to return dataVu's application
    vapplication *getDataVuvapplication (void) 
	{ return (dataVuvapplication); }
    // function to return the applications resource
    vresource getDataVuvresource (void) 
	{ return (dataVuvresource); }
    // function to return tis galaxy resource
    vresource getTisGalaxyvresource (void)
	{ return (tisGalaxyvresource); }

    // function to return the database class
    vuDatabaseClass *getDatabaseClass (void) 
	{ return (vuDataBase); }

    // function to return the main dialog class
    vuMainDialogClass *getMainDialogClass (void) 
	{ return (vuMainDialog); }

    // vuNetwork instance for dbClient communications
    vuNetwork *dbClientNotify;

    // functions to handle channel access stuff
    int getCAInit (void)
	{ return (CAInit); }
    void setCAInit (int val)
	{ CAInit = val; }

    // start timer sequence
    void StartChanAccTimer (void);
};


class ChanAccTimer : public vtimer
{

public:

    // virtual member function override
    void ObserveTimer (void);
};


// ** SOME GLOBAL CLASS DEFINITIONS *************************************************
//
//
//** Pv Name Button Class ***********************************************************

class vuPvNameButtonClass : public vbutton
{
    vuCommonDialogClass	*commonDialogClass;
    filteredTextitem	*pv;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuPvNameButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuPvNameButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle commonDialogClass
    void storeCommonDialog (vuCommonDialogClass *cd) 
	{ commonDialogClass = cd; }
    vuCommonDialogClass *getCommonDialog (void) 
	{ return (commonDialogClass); }

    // handle the pvname that is associated with the button
    void storePvName (filteredTextitem *pvname) { pv = pvname; }
    filteredTextitem *getPvName (void) { return (pv); }
};


// *** BOARDTYPE MENU CLASS  ********************************************************

class vuBoardTypeMenuClass : public vcontrolOptionMenu
{
    // ptr to the modify flag in the point dialogs
    int *modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuBoardTypeMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuBoardTypeMenuClass, vcontrolOptionMenu);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle the modified flag
    void vuSetModifiedPtr (int *mod) { modified = mod; }
    int *vuGetModifiedPtr (void) {return (modified); }
    void vuSetModifiedFlag (void) { *modified = vTRUE; }

    // function to build resource  menu
    virtual void vuBuildBoardTypeMenu (int pointType);
};


// *** CHECK BOX CLASS  *************************************************************

class vuCheckBoxClass : public vcontrolToggle
{
    // ptr to the modify flag in the point dialogs
    int *modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuCheckBoxClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuCheckBoxClass, vcontrolToggle);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle the modified flag
    void vuSetModifiedPtr (int *mod) { modified = mod; }
    int *vuGetModifiedPtr (void) {return (modified); }
    void vuSetModifiedFlag (void) { *modified = vTRUE; }
};


// *** CONVERSION MENU CLASS  ********************************************************

class vuConversionMenuClass : public vcontrolOptionMenu
{
    // ptr to the modify flag in the point dialogs
    int *modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuConversionMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuConversionMenuClass, vcontrolOptionMenu);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // handle the modified flag
    void vuSetModifiedPtr (int *mod) { modified = mod; }
    int *vuGetModifiedPtr (void) {return (modified); }
    void vuSetModifiedFlag (void) { *modified = vTRUE; }

    // function to build resource  menu
    void vuBuildConversionMenu (int pointType);
};


// *** CHOICE GBL MENU CLASS  *******************************************************

class vuChoiceGblMenuClass : public vcontrolOptionMenu
{
    // ptr to the modify flag in the point dialogs
    int *modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuChoiceGblMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuChoiceGblMenuClass, vcontrolOptionMenu);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // function to build the menu
    void vuBuildOptionMenu (int choiceIndex);

    // handle the modified flag
    void vuSetModifiedPtr (int *mod) { modified = mod; }
    int *vuGetModifiedPtr (void) {return (modified); }
    void vuSetModifiedFlag (void) { *modified = vTRUE; }
};


// *** CHOICE REC MENU CLASS  *******************************************************

class vuChoiceRecMenuClass : public vcontrolOptionMenu
{
    // ptr to the modify flag in the point dialogs
    int *modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuChoiceRecMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuChoiceRecMenuClass, vcontrolOptionMenu);

    // override 
    void LoadInit (vresource resource);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // function to build the menu
    void vuBuildOptionMenu (int pointType, int choiceIndex);

    // handle the modified flag
    void vuSetModifiedPtr (int *mod) { modified = mod; }
    int *vuGetModifiedPtr (void) {return (modified); }
    void vuSetModifiedFlag (void) { *modified = vTRUE; }
};


// *** SUBCLASS OF filteredTextitem **************************************************

class vuFilteredTextitem : public filteredTextitem
{
    vuCommonDialogClass	*commonDialogClass;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuFilteredTextitem);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuFilteredTextitem, filteredTextitem);

    // handle commonDialogClass
    void storeCommonDialog (vuCommonDialogClass *cd) 
	{ commonDialogClass = cd; }
    vuCommonDialogClass *getCommonDialog (void) 
	{ return (commonDialogClass); }
};

#endif	datavuHXX

