#ifndef vuaccdialogclassHXX
#define	vuaccdialogclassHXX

// define values for the xrefNode inDialog flag

enum {
    VU_ACC_NOT_IN_DIALOG = 1,
    VU_ACC_IN_MAIN_DIALOG,
    VU_ACC_ALARM_DIALOG
};

class vuAccAlarmButtonClass;
class vuAccAlarmDialogClass;
class vuAccAlarmDialogDismissButtonClass;

class	vuAccContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAccContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAccContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuAccDialogClass

    vuPvNameButtonClass	*referenceButton;
    vuFilteredTextitem	*reference;
    vuCheckBoxClass	*processInput;
    vuCheckBoxClass	*maximizeSeverity;
    vuCheckBoxClass	*manual;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    vuPvNameButtonClass	*asyncFrzRefButton;
    vuFilteredTextitem	*asyncFrzRef;
    vuCheckBoxClass	*prc2;
    vuCheckBoxClass	*mxs2;
    filteredTextitem	*asyncFrzValue;
    vuPvNameButtonClass	*asyncResetRefButton;
    vuFilteredTextitem	*asyncResetRef;
    vuCheckBoxClass	*prc3;
    vuCheckBoxClass	*mxs3;
    spinnerClass	*resetGroup;
    vuCheckBoxClass	*resetOnFreeze;
    filteredTextitem	*deltaModeRollover;
    vuCheckBoxClass	*deltaMode;
    vuCheckBoxClass	*useZeroData;
    filteredTextitem	*saveRunTime;
    filteredTextitem	*freezeEvery;
    vuChoiceRecMenuClass	*freezeTime;
    vuChoiceRecMenuClass	*autofreezeMode;
    spinnerClass	*firstAutoFreezeHours;
    spinnerClass	*firstAutoFreezeMinutes;
    vuChoiceRecMenuClass	*timeSelect;
    filteredTextitem	*monitorDeadband;
    filteredTextitem	*archiveDeadband;
    vuAccAlarmButtonClass	*alarmDetailsButton;
    filteredTextitem	*totalDisplayLow;
    filteredTextitem	*totalDisplayHigh;
    filteredTextitem	*totalOffset;
    filteredTextitem	*totalSlope;
    filteredTextitem	*totalPrecision;
    filteredTextitem	*totalEguTag;
    filteredTextitem	*displayLow;
    filteredTextitem	*displayHigh;
    filteredTextitem	*offset;
    filteredTextitem	*slope;
    filteredTextitem	*precision;
    filteredTextitem	*eguTag;
};


class vuAccAlarmDialogClass : public vdialog
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAccAlarmDialogClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuAccAlarmDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    filteredTextitem	*thresholdLimit;
    spinnerClass	*thresholdCount;
    filteredTextitem	*zeroThreshold;
    filteredTextitem	*thresholdError;
    vuChoiceGblMenuClass	*thresholdSeverity;
    filteredTextitem		*hihiLimit;
    vuChoiceGblMenuClass	*hihiSeverity;
    filteredTextitem		*highLimit;
    vuChoiceGblMenuClass	*highSeverity;
    filteredTextitem		*lowLimit;
    vuChoiceGblMenuClass	*lowSeverity;
    filteredTextitem		*loloLimit;
    vuChoiceGblMenuClass	*loloSeverity;
    vuChoiceRecMenuClass	*alarmFieldSelect;
    vuFilteredTextitem	*alarmGroup;
    filteredTextitem	*alarmDeadband;
    filteredTextitem	*alarmDelay;
    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    vuAccAlarmDialogDismissButtonClass	*dismissButton;
};


class	vuAccDialogClass : public vuCommonDialogClass
{
    vuAccContainerClass		*accContainer;
    vuAccAlarmDialogClass	*alarmDetails;
    vstr			*accTitle;
    int				newRecord;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAccDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAccDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);

    // functions to handle newRecord
    void vuSetNewRecord (int nr) { newRecord = nr; }
    int  vuGetNewRecord (void)   { return (newRecord); }
};


class vuAccAlarmButtonClass : public vbutton
{
    vuAccDialogClass		*accDialogClass;
    vuAccAlarmDialogClass	*accAlarmDialogClass;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuAccAlarmButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuAccAlarmButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the acc dialog
    void storeAccDialog (vuAccDialogClass *cd) 
	{ accDialogClass = cd; }
    vuAccDialogClass *getAccDialog (void) 
	{ return (accDialogClass); }

    // handle the pointer to the acc alarm dialog
    void storeAccAlarmDialog (vuAccAlarmDialogClass *cd) 
	{ accAlarmDialogClass = cd; }
    vuAccAlarmDialogClass *getAccAlarmDialog (void) 
	{ return (accAlarmDialogClass); }
};


class vuAccAlarmDialogDismissButtonClass : public vbutton
{
    vuAccAlarmDialogClass	*alarmDialogClass;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuAccAlarmDialogDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuAccAlarmDialogDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the acc alarm dialog
    void storeAccAlarmDialog (vuAccAlarmDialogClass *cd) 
	{ alarmDialogClass = cd; }
    vuAccAlarmDialogClass *getAccAlarmDialog (void) 
	{ return (alarmDialogClass); }
};

#endif	vuaccdialogclassHXX
