#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceAi.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuAiDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuAiDialogClass, vuCommonDialogClass, "vuAiDialogClass");

/*******************************************************************
*
*    vuAiDialogClass override for constructors init ()
*
*******************************************************************/

void vuAiDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    aiContainer = vuAiContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    aiContainer -> boardType -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> line -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> addr -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> card -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> signal -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> convertType -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> reference -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> constantValue -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> processInput -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> maximizeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> rocSamples -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> smoothing -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> slope -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> offset -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> irLow -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> irHigh -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> eguLow -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> eguHigh -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> instDeviation -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> gain -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> signalType -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> devSetpoint -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> rocLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> devLimit -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    aiContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> rocSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    aiContainer -> devSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    aiContainer -> referenceButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    aiContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    aiContainer -> reference -> storeCommonDialog ((vuCommonDialogClass *)this);
    aiContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    aiContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_AI);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    aiTitle = vresourceGetString (dialogTitles, 
				vunames_vuAiDialogTitle);
    SetTitle (aiTitle);
}


/*******************************************************************
*
*    vuAiDialogClass Destroy function
*
*******************************************************************/

void vuAiDialogClass::Destroy (void)
{
    vstrDestroy (aiTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuAiDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuAiDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (aiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		// set the default value for the Ai's smoothing field
		else if ( ((vcharCompareBounded (epics, "SMOO", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ASLO", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "AOFF", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		// set the default value for the Ai's precision field
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuAiDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// device type indicator

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an AI
	if (ptType != VU_AI)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_AI);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    // since the ai can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (
			vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (aiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    // to output CONSTANT field, device type must be CONSTANT
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) == 0)
		    {
			if (dType != VU_CONSTANT)
			    continue;
		    }
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) == 0)
		    {
			// device type must be REFERENCE to output the reference
			if (dType == VU_REFERENCE)
			{
			    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
					      dbValue, &dbaseType);
			    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
			}
			else 
			{
			    finalValue = vstrCloneScribed (vcharScribeSystem (""));
			}
		    }
		    else
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuAiDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dType;		// device type
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the ai can be a hardware point, find what we are for later use
    // by getting the DTYP (BOARD) value from the dialog
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (aiContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (aiContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) == 0)
		    {
			if (dType != VU_CONSTANT)
			    doubleValue = 0;
		    }
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DTYP", FLDNAME_SZ)) == 0)
		    {
			// write to DEVTYPE in pvmap
			DB_PutFieldValue (pntRecord, xrefNode -> xrefField, dbValue);
		    }
		    break;
		}

		case DBF_INLINK:
			if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) 
										== 0)
			{
			    // always write the boardtype from DTYP into the INP field
			    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
			    // if we are a reference then write INP into the REFERENCE 
			    // field
			    if (dType == VU_REFERENCE)
			    {
				putField = xrefNode -> xrefRefField;
				textItem = (vtextitem *)dialogItem;
				stringValue = textItem -> GetTextAsString ();
				vcharExport (vcharScribeSystemExport (stringValue), 
									    dbValue);
				vstrDestroy (stringValue);
			    }
			    else
			    {
				// make sure to null out the field
				putField = xrefNode -> xrefRefField;
				vmemSet (dbValue, 0, VU_KEY_SIZE);
			    }
			}
			else
			{
			    textItem = (vtextitem *)dialogItem;
			    stringValue = textItem -> GetTextAsString ();
			    vcharExport (vcharScribeSystemExport (stringValue), 
									    dbValue);
			    vstrDestroy (stringValue);
			}
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuAiContainerClass, vcontainer, "vuAiContainerClass");

/*******************************************************************
*
*    vuAiContainerClass override for constructor
*
*******************************************************************/

void vuAiContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuAiContainer);

    vcontainer *btcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiDTYPContainer);
    boardType = vuBoardTypeMenuClass::RequestSubLoad (btcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiLINEContainer);
    line = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiADDRContainer);
    addr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiCARDContainer);
    card = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiSIGNContainer);
    signal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    vcontainer *cvrtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiLINRContainer);
    convertType = vuConversionMenuClass::RequestSubLoad (cvrtcontainer,
				vunames_LINR);

    vcontainer *refcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiINPContainer);
    referenceButton = vuPvNameButtonClass::RequestSubLoad (refcontainer,
				vunames_vuAiINPButton);
    reference = vuFilteredTextitem::RequestSubLoad (refcontainer,
				vunames_INP);

    vcontainer *cnstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiCNSTContainer);
    constantValue = filteredTextitem::RequestSubLoad (cnstcontainer,
				vunames_CNST);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    processInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);

    maximizeSeverity = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *mdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdbcontainer,
				vunames_MDEL);

    vcontainer *archcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (archcontainer,
				vunames_ADEL);

    vcontainer *alarmdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (alarmdbcontainer,
				vunames_HYST);

    vcontainer *rocscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiROCNContainer);
    rocSamples = filteredTextitem::RequestSubLoad (rocscontainer,
				vunames_ROCN);

    vcontainer *smoothcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiSMOOContainer);
    smoothing = filteredTextitem::RequestSubLoad (smoothcontainer,
				vunames_SMOO);

    vcontainer *slopecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiASLOContainer);
    slope = filteredTextitem::RequestSubLoad (slopecontainer,
				vunames_ASLO);

    vcontainer *offsetcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiAOFFContainer);
    offset = filteredTextitem::RequestSubLoad (offsetcontainer,
				vunames_AOFF);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *egutagcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egutagcontainer,
				vunames_EGU);

    vcontainer *irlocontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiIRLOContainer);
    irLow = filteredTextitem::RequestSubLoad (irlocontainer,
				vunames_IRLO);

    vcontainer *irhicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiIRHIContainer);
    irHigh = filteredTextitem::RequestSubLoad (irhicontainer,
				vunames_IRHI);

    vcontainer *egulowcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiEGULContainer);
    eguLow = filteredTextitem::RequestSubLoad (egulowcontainer,
				vunames_EGUL);

    vcontainer *eguhicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiEGUFContainer);
    eguHigh = filteredTextitem::RequestSubLoad (eguhicontainer,
				vunames_EGUF);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *instdevcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiIDEVContainer);
    instDeviation = filteredTextitem::RequestSubLoad (instdevcontainer,
				vunames_IDEV);

    vcontainer *gaincontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiGAINContainer);
    gain = filteredTextitem::RequestSubLoad (gaincontainer,
				vunames_GAIN);

    vcontainer *sigtypecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiSTYPContainer);
    signalType = vuChoiceRecMenuClass::RequestSubLoad (sigtypecontainer,
				vunames_STYP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuAiADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer *devstpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiDEVSContainer);
    devSetpoint = filteredTextitem::RequestSubLoad (devstpcontainer,
				vunames_DEVS);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiAlarmContainer);

    vcontainer *hihilimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihilimcontainer,
				vunames_HIHI);
    vcontainer *hihisevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hihisevcontainer,
				vunames_HHSV);

    vcontainer *highlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highlimcontainer,
				vunames_HIGH);
    vcontainer *highsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (highsevcontainer,
				vunames_HSV);

    vcontainer *lowlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowlimcontainer,
				vunames_LOW);
    vcontainer *lowsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lowsevcontainer,
				vunames_LSV);

    vcontainer *lololimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lololimcontainer,
				vunames_LOLO);
    vcontainer *lolosevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolosevcontainer,
				vunames_LLSV);

    vcontainer *roclimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiROCContainer);
    rocLimit = filteredTextitem::RequestSubLoad (roclimcontainer,
				vunames_ROC);
    vcontainer *rocsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiRCSVContainer);
    rocSeverity = vuChoiceGblMenuClass::RequestSubLoad (rocsevcontainer,
				vunames_RCSV);

    vcontainer *devlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiDEVLContainer);
    devLimit = filteredTextitem::RequestSubLoad (devlimcontainer,
				vunames_DEVL);
    vcontainer *devsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuAiDVSVContainer);
    devSeverity = vuChoiceGblMenuClass::RequestSubLoad (devsevcontainer,
				vunames_DVSV);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAiALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    referenceButton -> storePvName (reference);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    line -> SetItemFilterFunc (numericFilter);
    addr -> SetItemFilterFunc (numericFilter);
    card -> SetItemFilterFunc (numericFilter);
    signal -> SetItemFilterFunc (numericFilter);

    reference -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *refText = (filteredText *)reference -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    refText -> SetUserPtr ((void *)reference);

    constantValue -> SetItemFilterFunc (floatFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    rocSamples -> SetItemFilterFunc (numericFilter);
    smoothing -> SetItemFilterFunc (floatFilter);
    slope -> SetItemFilterFunc (floatFilter);
    offset -> SetItemFilterFunc (floatFilter);
    precision -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);
    irLow -> SetItemFilterFunc (floatFilter);
    irHigh -> SetItemFilterFunc (floatFilter);
    eguLow -> SetItemFilterFunc (floatFilter);
    eguHigh -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    instDeviation -> SetItemFilterFunc (floatFilter);
    gain -> SetItemFilterFunc (floatFilter);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);
    devSetpoint -> SetItemFilterFunc (floatFilter);
    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    rocLimit -> SetItemFilterFunc (floatFilter);
    devLimit -> SetItemFilterFunc (floatFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    boardType    -> vuBuildBoardTypeMenu (VU_AI);
    convertType  -> vuBuildConversionMenu (VU_AI);
    signalType   -> vuBuildOptionMenu (VU_AI, REC_AI_STYP);
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    rocSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    devSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuAiContainerClass override for destructor
*
*******************************************************************/

void vuAiContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

