#ifndef vuaidialogclassHXX
#define	vuaidialogclassHXX

class	vuAiContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAiContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAiContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuAiDialogClass

    vuBoardTypeMenuClass	*boardType;
    filteredTextitem	*line;
    filteredTextitem	*addr;
    filteredTextitem	*card;
    filteredTextitem	*signal;
    vuConversionMenuClass	*convertType;
    vuPvNameButtonClass	*referenceButton;
    vuFilteredTextitem	*reference;
    filteredTextitem	*constantValue;
    vuCheckBoxClass	*manual;
    vuCheckBoxClass	*processInput;
    vuCheckBoxClass	*maximizeSeverity;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    filteredTextitem	*monitorDeadband;
    filteredTextitem	*archiveDeadband;
    filteredTextitem	*alarmDeadband;
    filteredTextitem	*rocSamples;
    filteredTextitem	*smoothing;
    filteredTextitem	*slope;
    filteredTextitem	*offset;
    filteredTextitem	*precision;
    filteredTextitem	*eguTag;
    filteredTextitem	*irLow;
    filteredTextitem	*irHigh;
    filteredTextitem	*eguLow;
    filteredTextitem	*eguHigh;
    filteredTextitem	*displayLow;
    filteredTextitem	*displayHigh;
    filteredTextitem	*instDeviation;
    filteredTextitem	*gain;
    vuChoiceRecMenuClass	*signalType;
    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    filteredTextitem	*alarmDelay;
    vuFilteredTextitem	*alarmGroup;
    filteredTextitem	*devSetpoint;
    filteredTextitem	*hihiLimit;
    vuChoiceGblMenuClass	*hihiSeverity;
    filteredTextitem		*highLimit;
    vuChoiceGblMenuClass	*highSeverity;
    filteredTextitem		*lowLimit;
    vuChoiceGblMenuClass	*lowSeverity;
    filteredTextitem		*loloLimit;
    vuChoiceGblMenuClass	*loloSeverity;
    filteredTextitem		*rocLimit;
    vuChoiceGblMenuClass	*rocSeverity;
    filteredTextitem		*devLimit;
    vuChoiceGblMenuClass	*devSeverity;
};


//*** AI DIALOG CLASS **************************************************

class	vuAiDialogClass : public vuCommonDialogClass
{
    vuAiContainerClass	*aiContainer;
    vstr		*aiTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAiDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAiDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);
};

#endif	vuaidialogclassHXX
