#ifndef vuddcdialogclassHXX
#define	vuddcdialogclassHXX

// define values for the xrefNode inDialog flag

enum {
    VU_DDC_NOT_IN_DIALOG = 1,
    VU_DDC_IN_MAIN_DIALOG,
    VU_DDC_OUTPUT_DIALOG
};

class vuDdcOutputButtonClass;
class vuDdcOutputDialogClass;
class vuDdcOutputDismissButtonClass;

class	vuDdcContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDdcContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDdcContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuDdcDialogClass

    vuBoardTypeMenuClass	*boardType;
    filteredTextitem	*line;
    filteredTextitem	*addr;
    filteredTextitem	*card;
    filteredTextitem	*signal;
    vuChoiceRecMenuClass	*initAction;
    vuPvNameButtonClass	*outputButton;
    vuFilteredTextitem	*output;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    vuCheckBoxClass	*manual;
    vuCheckBoxClass	*closedLoop;
    vuCheckBoxClass	*useFirstReset;
    vuPvNameButtonClass	*resetLinkButton;
    vuFilteredTextitem	*resetLink;
    vuCheckBoxClass	*procReset;
    vuCheckBoxClass	*msReset;
    filteredTextitem	*resetValue;
    vuPvNameButtonClass	*stepInputButton;
    vuFilteredTextitem	*stepInput;
    vuCheckBoxClass	*procStepInput;
    vuCheckBoxClass	*msStepInput;
    vuPvNameButtonClass	*primaryCascadeButton;
    vuFilteredTextitem	*primaryCascade;
    vuPvNameButtonClass	*downstreamCascadeButton;
    vuFilteredTextitem	*downstreamCascade;
    vuChoiceRecMenuClass	*drumControlType;
    vuChoiceRecMenuClass	*operatingMode;
    vuChoiceRecMenuClass	*timingMode;
    vuChoiceRecMenuClass	*activeEdge;
    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    vuFilteredTextitem	*alarmGroup;
    vuDdcOutputButtonClass	*outputValuesButton;
};


//*** DDC DIALOG CLASS ***************************************************

class	vuDdcDialogClass : public vuCommonDialogClass
{
    vuDdcContainerClass		*ddcContainer;
    vuDdcOutputDialogClass	*outputDialog;
    vstr			*ddcTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDdcDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDdcDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);

    // function to handle outputDialog
    vuDdcOutputDialogClass *getOutput (void)
	{ return (outputDialog); }
};


//*** DDC OUTPUT BUTTON CLASS *****************************************

class vuDdcOutputButtonClass : public vbutton
{
    vuDdcDialogClass		*ddcDialog;
    vuDdcOutputDialogClass	*outputDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuDdcOutputButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuDdcOutputButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the ddc dialog
    void storeDdcDialog (vuDdcDialogClass *cd) 
	{ ddcDialog = cd; }

    // handle the pointer to the ddc output dialog
    void storeDdcOutputDialog (vuDdcOutputDialogClass *cd) 
	{ outputDialog = cd; }
};


//*** DDC OUTPUT DIALOG CLASS ***************************************

class vuDdcOutputDialogClass : public vdialog
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDdcOutputDialogClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuDdcOutputDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    hhmmsstTimeClass	*time1;
    spinnerClass	*value1;
    hhmmsstTimeClass	*time2;
    spinnerClass	*value2;
    hhmmsstTimeClass	*time3;
    spinnerClass	*value3;
    hhmmsstTimeClass	*time4;
    spinnerClass	*value4;
    hhmmsstTimeClass	*time5;
    spinnerClass	*value5;
    hhmmsstTimeClass	*time6;
    spinnerClass	*value6;
    hhmmsstTimeClass	*time7;
    spinnerClass	*value7;
    hhmmsstTimeClass	*time8;
    spinnerClass	*value8;
    hhmmsstTimeClass	*time9;
    spinnerClass	*value9;
    hhmmsstTimeClass	*time10;
    spinnerClass	*value10;
    hhmmsstTimeClass	*time11;
    spinnerClass	*value11;
    hhmmsstTimeClass	*time12;
    spinnerClass	*value12;
    hhmmsstTimeClass	*time13;
    spinnerClass	*value13;
    hhmmsstTimeClass	*time14;
    spinnerClass	*value14;
    hhmmsstTimeClass	*time15;
    spinnerClass	*value15;
    hhmmsstTimeClass	*time16;
    spinnerClass	*value16;
    hhmmsstTimeClass	*time17;
    spinnerClass	*value17;
    hhmmsstTimeClass	*time18;
    spinnerClass	*value18;
    hhmmsstTimeClass	*time19;
    spinnerClass	*value19;
    hhmmsstTimeClass	*time20;
    spinnerClass	*value20;
    hhmmsstTimeClass	*time21;
    spinnerClass	*value21;
    hhmmsstTimeClass	*time22;
    spinnerClass	*value22;
    hhmmsstTimeClass	*time23;
    spinnerClass	*value23;
    hhmmsstTimeClass	*time24;
    spinnerClass	*value24;
    hhmmsstTimeClass	*time25;
    spinnerClass	*value25;
    hhmmsstTimeClass	*time26;
    spinnerClass	*value26;
    hhmmsstTimeClass	*time27;
    spinnerClass	*value27;
    hhmmsstTimeClass	*time28;
    spinnerClass	*value28;
    hhmmsstTimeClass	*time29;
    spinnerClass	*value29;
    hhmmsstTimeClass	*time30;
    spinnerClass	*value30;
    hhmmsstTimeClass	*time31;
    spinnerClass	*value31;
    hhmmsstTimeClass	*time32;
    spinnerClass	*value32;
    spinnerClass	*numOutputWords;
    spinnerClass	*numOutputBits;
    vuDdcOutputDismissButtonClass	*dismissButton;
};


//*** DDC OUTPUT DISMISS BUTTON CLASS *******************************

class vuDdcOutputDismissButtonClass : public vbutton
{
    vuDdcOutputDialogClass	*outputDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuDdcOutputDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuDdcOutputDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the ddc output dialog
    void storeDdcOutputDialog (vuDdcOutputDialogClass *cd) 
	{ outputDialog = cd; }
};

#endif	vuddcdialogclassHXX

