#ifndef vuldfwdialogclassHXX
#define	vuldfwdialogclassHXX

#define	VU_NUM_LDFW_PUMPS	20
#define	VU_LDFW_SEQ_NUM_SZ	2

/***********************************************************************
*
*	LEAD FOLLOW 1 DEFINITION
*
***********************************************************************/

class	vuLdfw1ContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLdfw1ContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLdfw1ContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuLdfw1DialogClass

    vuPvNameButtonClass	*suspendModeButton;
    vuFilteredTextitem	*suspendMode;
    filteredTextitem	*suspendValue;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    vuCheckBoxClass	*manual;
    vuPvNameButtonClass	*pumpButtons[VU_NUM_LDFW_PUMPS];
    vuFilteredTextitem	*pumps[VU_NUM_LDFW_PUMPS];
    spinnerClass	*pumpSeqNums[VU_NUM_LDFW_PUMPS];
    filteredTextitem	*offTimeSetpt;
    filteredTextitem	*secBetweenStarts;
    vuChoiceGblMenuClass	*upperLimSeverity;
    spinnerClass	*reservePumps;
    filteredTextitem	*secBetweenStops;
    vuChoiceGblMenuClass	*lowerLimSeverity;
    vuChoiceRecMenuClass	*pumpSelMode;
    vuFilteredTextitem	*alarmGroup;
    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
};


//*** LEAD FOLLOW 1  DIALOG CLASS *****************************************

class	vuLdfw1DialogClass : public vuCommonDialogClass
{
    vuLdfw1ContainerClass	*ldfw1Container;
    vstr			*ldfw1Title;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLdfw1DialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLdfw1DialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);

    // function to validate pump sequence
    int validatePumpSequence (void);
};


/***********************************************************************
*
*	LEAD FOLLOW 2 DEFINITION
*
***********************************************************************/

class	vuLdfw2ContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLdfw2ContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLdfw2ContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuLdfw2DialogClass

    vuPvNameButtonClass	*speedCtrlButton;
    vuFilteredTextitem	*speedCtrl;
    vuCheckBoxClass	*procSpeedCtrl;
    vuCheckBoxClass	*msSpeedCtrl;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*onAlarm;
    vuCheckBoxClass	*manual;
    vuPvNameButtonClass	*ldfw1Button;
    vuFilteredTextitem	*ldfw1;
    vuCheckBoxClass	*procLdfw1;
    vuCheckBoxClass	*msLdfw1;
    filteredTextitem	*precision;
    vuChoiceRecMenuClass	*pumpSelMode;
    filteredTextitem	*pumpStartSpeed;
    filteredTextitem	*pumpStopSpeed;
    filteredTextitem	*monitorDeadband;
    vuFilteredTextitem	*alarmGroup;
    vuPvNameButtonClass	*alarmDisableButton;
    vuFilteredTextitem	*alarmDisable;
    filteredTextitem	*adjFactors[VU_NUM_LDFW_PUMPS];
};


//*** LEAD FOLLOW 2  DIALOG CLASS *****************************************

class	vuLdfw2DialogClass : public vuCommonDialogClass
{
    vuLdfw2ContainerClass	*ldfw2Container;
    vstr			*ldfw2Title;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuLdfw2DialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuLdfw2DialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);

    // validate function for the ldfw1 ref
    int validateLdfw1Ref (vuDatabaseClass *db);
};

#endif	vuldfwdialogclassHXX
