#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choice.h"
#include "devSup.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuPatDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuPatDialogClass, vuCommonDialogClass, "vuPatDialogClass");

/*******************************************************************
*
*    vuPatDialogClass override for constructors init ()
*
*******************************************************************/

void vuPatDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    patContainer = vuPatContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    patContainer -> outputBoard -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> posLine -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> posAddr -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> posCard -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> posSignal -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> posInvert -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> negLine -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negAddr -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negCard -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negSignal -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negInvert -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> rlBoard -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> rlLine -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> rlAddr -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> rlCard -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> rlSignal -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> rlInvert -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> fbBoard -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> fbLine -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> fbAddr -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> fbCard -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> fbSignal -> SetTextModifiedPtr (&this -> dialogModified);

    patContainer -> setpt -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> initialSetpt -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> closedLoop -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> posChannel -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negChannel -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> rlChannel -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> fbChannel -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> irLow -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> irHigh -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> instDeviation -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> strokeTime -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> gap -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> posRocLimit -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> negRocLimit -> SetTextModifiedPtr (&this -> dialogModified);

    patContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> clampLow -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> clampHigh -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> clampLowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    patContainer -> clampHighSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    patContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    patContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    patContainer -> setptButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> posChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> negChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> rlChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> fbChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    patContainer -> setpt -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> posChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> negChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> rlChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> fbChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    patContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    patContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_PAT);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    patTitle = vresourceGetString (dialogTitles, 
				vunames_vuPatDialogTitle);
    SetTitle (patTitle);
}


/*******************************************************************
*
*    vuPatDialogClass Destroy function
*
*******************************************************************/

void vuPatDialogClass::Destroy (void)
{
    vstrDestroy (patTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuPatDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuPatDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (patContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		// set the default value for these pat fields
		else if ( ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "LIN2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADR2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CRD2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIG2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "LIN3", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADR3", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CRD3", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIG3", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "LIN4", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADR4", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CRD4", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIG4", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "STIM", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "GAP ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "PRCL", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "NRCL", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "IRLO", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else if ( (vcharCompareBounded (epics, "IRHI", FLDNAME_SZ)) == 0)
		{
		    vstr *irhi = vresourceGetString (defRes, 
						vunames_vuPatIRHIdefault);
		    textItem -> SetText (irhi);
		    vstrDestroy (irhi);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuPatDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		tempName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// output device type
    DTYP_TYPE		rlType;		// remote/local device type
    DTYP_TYPE		fbType;		// feedback (inp) device type

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an PAT
	if (ptType != VU_PAT)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_PAT);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    // since the pat can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT BO REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT BO CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT BI REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT BI CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (vnameGetGlobalScribed (vcharScribeSystem ("DTYR"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	rlType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	rlType = VU_CONSTANT;
    else
	rlType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT AI REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT AI CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (vnameGetGlobalScribed (vcharScribeSystem ("DTYF"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	fbType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	fbType = VU_CONSTANT;
    else
	fbType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);


    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (xrefNode -> xrefTable == db -> vuIOAddrTable) )
	    {
		if (xrefNode -> xrefTable == db -> vuIOAddrTable)
		{
		    // For PAT, the entry in the IOADDR file will be quadruplicated. 
		    // To avoid this, the point name will have a '1','2','3', or '4' 
		    // appended depending on the EPICS field name.
		    //	POUT (pos channel) = 1, NOUT (neg channel) = 2, 
		    //	RLIN (rl channel) = 3, INP (fb channel) = 4
		    strcpy (tempName, pvName);
		    if ( (strncmp ((const char *)epics, "LINE", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "ADDR", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "CARD", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "SIGN", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "1");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG2", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "2");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG3", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "3");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG4", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "4");
		    }
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, tempName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (patContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_OUTLINK:
		    // device type must be REFERENCE to output the reference
		    if (dType == VU_REFERENCE)
		    {
			DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    }
		    else 
		    {
			finalValue = vstrCloneScribed (vcharScribeSystem (""));
		    }
		    break;

		case DBF_INLINK:
		    // only output if RLIN or INP are ref's
		    if ( (strncmp (xrefNode -> xrefEpicsName, "RLIN", FLDNAME_SZ)) == 0)
		    {
			if (rlType == VU_REFERENCE)
			{
			    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
			}
			else
			{
			    finalValue = vstrCloneScribed (vcharScribeSystem (""));
			}
		    }
		    else if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) == 0)
		    {
			if (fbType == VU_REFERENCE)
			{
			    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
			}
			else
			{
			    finalValue = vstrCloneScribed (vcharScribeSystem (""));
			}
		    }
		    else
		    {
			DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    }
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuPatDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		tempName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    char		vuCurrentRL [VU_KEY_SIZE];
    char		vuCurrentFB [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    DTYP_TYPE		dType;		// output device type
    DTYP_TYPE		rlType;		// remote/local device type
    DTYP_TYPE		fbType;		// feedback (inp) device type

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the pat can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT BO REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT BO CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (patContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT BI REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT BI CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYR"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the RLBOARD (DTYR) field and get its value
    dialogItem = vuFindContainerItem (patContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentRL);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	rlType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	rlType = VU_CONSTANT;
    else
	rlType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    referenceString = vstrCloneScribed (vcharScribeSystem ("PAT AI REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("PAT AI CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYF"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the FBBOARD (DTYF) field and get its value
    dialogItem = vuFindContainerItem (patContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentFB);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	fbType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	fbType = VU_CONSTANT;
    else
	fbType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (xrefNode -> xrefTable == db -> vuIOAddrTable) )
	    {
		if (xrefNode -> xrefTable == db -> vuIOAddrTable)
		{
		    // For PAT, the entry in the IOADDR file will be quadruplicated. 
		    // To avoid this, the point name will have a '1','2','3', or '4' 
		    // appended depending on the EPICS field name.
		    //	POUT (pos channel) = 1, NOUT (neg channel) = 2, 
		    //	RLIN (rl channel) = 3, INP (fb channel) = 4
		    strcpy (tempName, pvName);
		    if ( (strncmp ((const char *)epics, "LINE", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "ADDR", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "CARD", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "SIGN", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "1");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG2", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "2");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD3", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG3", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "3");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD4", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG4", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "4");
		    }
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, tempName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (patContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
							    xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_OUTLINK:
		    // always write the boardtype from DTYP into the OUT field
		    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
		    // if we are a reference then write OUT into the REFERENCE field
		    if (dType == VU_REFERENCE)
		    {
			putField = xrefNode -> xrefRefField;
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    else
		    {
			// make sure to null out the field
			putField = xrefNode -> xrefRefField;
			vmemSet (dbValue, 0, VU_KEY_SIZE);
		    }
		    break;

		case DBF_INLINK:
		    // only save if RLIN or INP are ref's
		    if ( (strncmp (xrefNode -> xrefEpicsName, "RLIN", FLDNAME_SZ)) == 0)
		    {
			// always write the rb boardtype from DTYR into the RLBOARD field
			DB_PutFieldValue (pntRecord, putField, vuCurrentRL);
			// if we are a reference then write RLIN into the RLINPUT field
			if (rlType == VU_REFERENCE)
			{
			    putField = xrefNode -> xrefRefField;
			    textItem = (vtextitem *)dialogItem;
			    stringValue = textItem -> GetTextAsString ();
			    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			    vstrDestroy (stringValue);
			}
			else
			{
			    // make sure to null out the field
			    putField = xrefNode -> xrefRefField;
			    vmemSet (dbValue, 0, VU_KEY_SIZE);
			}
		    }
		    else if ( (strncmp (xrefNode -> xrefEpicsName, "INP ", FLDNAME_SZ)) == 0)
		    {
			// always write the fb boardtype from DTYF into the FBBOARD field
			DB_PutFieldValue (pntRecord, putField, vuCurrentFB);
			// if we are a reference then write INP into the REFERENCE field
			if (fbType == VU_REFERENCE)
			{
			    putField = xrefNode -> xrefRefField;
			    textItem = (vtextitem *)dialogItem;
			    stringValue = textItem -> GetTextAsString ();
			    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			    vstrDestroy (stringValue);
			}
			else
			{
			    // make sure to null out the field
			    putField = xrefNode -> xrefRefField;
			    vmemSet (dbValue, 0, VU_KEY_SIZE);
			}
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuPatContainerClass, vcontainer, "vuPatContainerClass");

/*******************************************************************
*
*    vuPatContainerClass override for constructor
*
*******************************************************************/

void vuPatContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuPatContainer);

    vcontainer *outbtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatDTYPContainer);
    outputBoard = vuPatBoardTypeMenuClass::RequestSubLoad (outbtcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatLINEContainer);
    posLine = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADDRContainer);
    posAddr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatCARDContainer);
    posCard = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatSIGNContainer);
    posSignal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    posInvert = vuCheckBoxClass::RequestSubLoad (this,
				vunames_POIV);

    vcontainer *neglinecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatLIN2Container);
    negLine = filteredTextitem::RequestSubLoad (neglinecontainer,
				vunames_LIN2);

    vcontainer *negaddrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADR2Container);
    negAddr = filteredTextitem::RequestSubLoad (negaddrcontainer,
				vunames_ADR2);

    vcontainer *negcardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatCRD2Container);
    negCard = filteredTextitem::RequestSubLoad (negcardcontainer,
				vunames_CRD2);

    vcontainer *negsignalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatSIG2Container);
    negSignal = filteredTextitem::RequestSubLoad (negsignalcontainer,
				vunames_SIG2);

    negInvert = vuCheckBoxClass::RequestSubLoad (this,
				vunames_NOIV);

    vcontainer *rlbtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatDTYRContainer);
    rlBoard = vuPatBoardTypeMenuClass::RequestSubLoad (rlbtcontainer,
				vunames_DTYR);

    vcontainer *rllinecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatLIN3Container);
    rlLine = filteredTextitem::RequestSubLoad (rllinecontainer,
				vunames_LIN3);

    vcontainer *rladdrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADR3Container);
    rlAddr = filteredTextitem::RequestSubLoad (rladdrcontainer,
				vunames_ADR3);

    vcontainer *rlcardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatCRD3Container);
    rlCard = filteredTextitem::RequestSubLoad (rlcardcontainer,
				vunames_CRD3);

    vcontainer *rlsignalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatSIG3Container);
    rlSignal = filteredTextitem::RequestSubLoad (rlsignalcontainer,
				vunames_SIG3);

    rlInvert = vuCheckBoxClass::RequestSubLoad (this,
				vunames_RLIV);

    vcontainer *fbbtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatDTYFContainer);
    fbBoard = vuPatBoardTypeMenuClass::RequestSubLoad (fbbtcontainer,
				vunames_DTYF);

    vcontainer *fblinecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatLIN4Container);
    fbLine = filteredTextitem::RequestSubLoad (fblinecontainer,
				vunames_LIN4);

    vcontainer *fbaddrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADR4Container);
    fbAddr = filteredTextitem::RequestSubLoad (fbaddrcontainer,
				vunames_ADR4);

    vcontainer *fbcardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatCRD4Container);
    fbCard = filteredTextitem::RequestSubLoad (fbcardcontainer,
				vunames_CRD4);

    vcontainer *fbsignalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatSIG4Container);
    fbSignal = filteredTextitem::RequestSubLoad (fbsignalcontainer,
				vunames_SIG4);

    vcontainer *spcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatSTPLContainer);
    setptButton = vuPvNameButtonClass::RequestSubLoad (spcontainer,
				vunames_vuPatSTPLButton);
    setpt = vuFilteredTextitem::RequestSubLoad (spcontainer,
				vunames_STPL);

    vcontainer *spinitcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatISTPContainer);
    initialSetpt = filteredTextitem::RequestSubLoad (spinitcontainer,
				vunames_ISTP);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    closedLoop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OMSL);

    vcontainer *posccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatPOUTContainer);
    posChannelButton = vuPvNameButtonClass::RequestSubLoad (posccontainer,
				vunames_vuPatPOUTButton);
    posChannel = vuFilteredTextitem::RequestSubLoad (posccontainer,
				vunames_POUT);

    vcontainer *negccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatNOUTContainer);
    negChannelButton = vuPvNameButtonClass::RequestSubLoad (negccontainer,
				vunames_vuPatNOUTButton);
    negChannel = vuFilteredTextitem::RequestSubLoad (negccontainer,
				vunames_NOUT);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *rlccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatRLINContainer);
    rlChannelButton = vuPvNameButtonClass::RequestSubLoad (rlccontainer,
				vunames_vuPatRLINButton);
    rlChannel = vuFilteredTextitem::RequestSubLoad (rlccontainer,
				vunames_RLIN);

    vcontainer *fbccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatINPContainer);
    fbChannelButton = vuPvNameButtonClass::RequestSubLoad (fbccontainer,
				vunames_vuPatINPButton);
    fbChannel = vuFilteredTextitem::RequestSubLoad (fbccontainer,
				vunames_INP);

    vcontainer *mdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdbcontainer,
				vunames_MDEL);

    vcontainer *archcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (archcontainer,
				vunames_ADEL);

    vcontainer *alarmdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (alarmdbcontainer,
				vunames_HYST);

    vcontainer *valuecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatValuesContainer);

    vcontainer *irlocontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatIRLOContainer);
    irLow = filteredTextitem::RequestSubLoad (irlocontainer,
				vunames_IRLO);

    vcontainer *irhicontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatIRHIContainer);
    irHigh = filteredTextitem::RequestSubLoad (irhicontainer,
				vunames_IRHI);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *idcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatIDEVContainer);
    instDeviation = filteredTextitem::RequestSubLoad (idcontainer,
				vunames_IDEV);

    vcontainer *stcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatSTIMContainer);
    strokeTime = filteredTextitem::RequestSubLoad (stcontainer,
				vunames_STIM);

    vcontainer *gapcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatGAPContainer);
    gap = filteredTextitem::RequestSubLoad (gapcontainer,
				vunames_GAP);

    vcontainer *posroccontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatPRCLContainer);
    posRocLimit = filteredTextitem::RequestSubLoad (posroccontainer,
				vunames_PRCL);

    vcontainer *negroccontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPatNRCLContainer);
    negRocLimit = filteredTextitem::RequestSubLoad (negroccontainer,
				vunames_NRCL);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatAlarmContainer);

    vcontainer *hihilimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihilimcontainer,
				vunames_HIHI);
    vcontainer *hihisevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hihisevcontainer,
				vunames_HHSV);

    vcontainer *highlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highlimcontainer,
				vunames_HIGH);
    vcontainer *highsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (highsevcontainer,
				vunames_HSV);

    vcontainer *lowlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowlimcontainer,
				vunames_LOW);
    vcontainer *lowsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lowsevcontainer,
				vunames_LSV);

    vcontainer *lololimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lololimcontainer,
				vunames_LOLO);
    vcontainer *lolosevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolosevcontainer,
				vunames_LLSV);

    vcontainer *clmhcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatCLMHContainer);
    clampHigh = filteredTextitem::RequestSubLoad (clmhcontainer,
				vunames_CLMH);
    vcontainer *clmhsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatCHSVContainer);
    clampHighSeverity = vuChoiceGblMenuClass::RequestSubLoad (clmhsevcontainer,
				vunames_CHSV);

    vcontainer *clmlcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatCLMLContainer);
    clampLow = filteredTextitem::RequestSubLoad (clmlcontainer,
				vunames_CLML);
    vcontainer *clmlsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPatCLSVContainer);
    clampLowSeverity = vuChoiceGblMenuClass::RequestSubLoad (clmlsevcontainer,
				vunames_CLSV);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuPatADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPatALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);


    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    setptButton -> storePvName (setpt);
    posChannelButton -> storePvName (posChannel);
    negChannelButton -> storePvName (negChannel);
    rlChannelButton -> storePvName (rlChannel);
    fbChannelButton -> storePvName (fbChannel);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    posLine -> SetItemFilterFunc (numericFilter);
    posAddr -> SetItemFilterFunc (numericFilter);
    posCard -> SetItemFilterFunc (numericFilter);
    posSignal -> SetItemFilterFunc (numericFilter);
    negLine -> SetItemFilterFunc (numericFilter);
    negAddr -> SetItemFilterFunc (numericFilter);
    negCard -> SetItemFilterFunc (numericFilter);
    negSignal -> SetItemFilterFunc (numericFilter);
    rlLine -> SetItemFilterFunc (numericFilter);
    rlAddr -> SetItemFilterFunc (numericFilter);
    rlCard -> SetItemFilterFunc (numericFilter);
    rlSignal -> SetItemFilterFunc (numericFilter);
    fbLine -> SetItemFilterFunc (numericFilter);
    fbAddr -> SetItemFilterFunc (numericFilter);
    fbCard -> SetItemFilterFunc (numericFilter);
    fbSignal -> SetItemFilterFunc (numericFilter);

    setpt -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *setptText = (filteredText *)setpt -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    setptText -> SetUserPtr ((void *)setpt);

    initialSetpt -> SetItemFilterFunc (floatFilter);

    posChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *poscText = (filteredText *)posChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    poscText -> SetUserPtr ((void *)posChannel);

    negChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *negcText = (filteredText *)negChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    negcText -> SetUserPtr ((void *)negChannel);

    precision -> SetItemFilterFunc (numericFilter);

    rlChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *rlcText = (filteredText *)rlChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    rlcText -> SetUserPtr ((void *)rlChannel);

    fbChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *fbcText = (filteredText *)fbChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    fbcText -> SetUserPtr ((void *)fbChannel);

    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    irLow -> SetItemFilterFunc (floatFilter);
    irHigh -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    instDeviation -> SetItemFilterFunc (floatFilter);
    strokeTime -> SetItemFilterFunc (floatFilter);
    gap -> SetItemFilterFunc (floatFilter);
    posRocLimit -> SetItemFilterFunc (floatFilter);
    negRocLimit -> SetItemFilterFunc (floatFilter);

    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    clampLow -> SetItemFilterFunc (floatFilter);
    clampHigh -> SetItemFilterFunc (floatFilter);


    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);


    // build popup menus
    outputBoard -> vuBuildBoardTypeMenu (VU_BO);
    rlBoard -> vuBuildBoardTypeMenu (VU_BI);
    fbBoard -> vuBuildBoardTypeMenu (VU_AI);
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    clampHighSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    clampLowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
}


/*******************************************************************
*
*    vuPatContainerClass override for destructor
*
*******************************************************************/

void vuPatContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}



/**********************************************************************
*
*    class that defines pat boardtype menu class
*
***********************************************************************/

vkindTYPED_FULL_DEFINITION(vuPatBoardTypeMenuClass, vuBoardTypeMenuClass, 
						"vuPatBoardTypeMenuClass");

/*******************************************************************
*
*    vuPatBuildBoardTypeMenu ()
*	passed the type of pat board to build. the pat has 3 
*	board types in the one choiceDev, the difference is in the
*	device set name which conatins eithere PatAi, PatBi or
*	PatBo
*	NOTE: we add 1 to the point type since we index from 0
*		but in the SDR, the first point type is at index
*		1, 0 is NULL
*
*******************************************************************/
void vuPatBoardTypeMenuClass::vuBuildBoardTypeMenu (int aux_ptype)
{
    int			i;
    int			numChoicesFound = 0;
    long		numDevChoices = 0;
    struct devChoice	**devChoices;
    struct devSup	*vuDevSup;
    char		*pChoice;
    char		*pDset;
    char		driver[10];
    vmenuItem		*menuItem;

    if (choiceDev == NULL)
	return;
    if ( (choiceDev -> papDevChoiceSet[VU_PAT + 1]) == NULL)
	return;

    // ptr to place where to get dset's for pat
    if (devSup == NULL)
	return;

    // get the one for the PAT block
    if ( (vuDevSup = devSup -> papDevSup[VU_PAT + 1]) == NULL)
	return;

    memset (driver, 0, sizeof (driver));
    if (aux_ptype == VU_AI)
	strcpy (driver, "PatAi");
    else if (aux_ptype == VU_BI)
	strcpy (driver, "PatBi");
    else if (aux_ptype == VU_BO)
	strcpy (driver, "PatBo");


    numDevChoices = choiceDev -> papDevChoiceSet[VU_PAT + 1] -> number;
    devChoices = choiceDev -> papDevChoiceSet[VU_PAT + 1] -> papDevChoice;

    /* create a new menu to attach to the vcontrol item, we are 
       creating a popup menu within a dialog
    */
    vmenu *newMenu = new vmenu;

    for (i = 0; i < numDevChoices; i++)
    {
	pChoice = devChoices[i] -> pchoice;
	if (pChoice)
	{
	    pDset = vuDevSup -> dsetName[i];
	    if ( (strstr ((const char *)pDset, (const char *)driver)) != NULL)
	    {
		menuItem = new vmenuItem;
		menuItem -> SetTitleScribed (vcharScribeSystem ((void *)pChoice));
		newMenu -> AppendItem (menuItem);
		numChoicesFound++;
	    }
	}
    }
    if (numChoicesFound)
    {
	// attach the menu to the control
	this -> SetMenu (newMenu);
	// set min and max for the control
	this -> SetMin (0);
	this -> SetMax (numChoicesFound - 1);
	// set value so current menu item will be the 1st one
	this -> SetValue (0);
    }
}

