#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choice.h"
#include "choicePto.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuPtoDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuPtoDialogClass, vuCommonDialogClass, "vuPtoDialogClass");

/*******************************************************************
*
*    vuPtoDialogClass override for constructors init ()
*
*******************************************************************/

void vuPtoDialogClass::LoadInit (vresource res)
{
    // load in the pto specific fields
    ptoContainer = vuPtoContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    ptoContainer -> outputBoard -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> posLine -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> posAddr -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> posCard -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> posSignal -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> posInvert -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> negLine -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> negAddr -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> negCard -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> negSignal -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> negInvert -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> valueLoc -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> closedLoop -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> posChannel -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> negChannel -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> numberBits -> SetModifiedPtr (&this -> dialogModified);
    ptoContainer -> pulseType -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> onValue -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> offValue -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> minimumValue -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> scale -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> clampLow -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> clampHigh -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> clampLowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    ptoContainer -> clampHighSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    ptoContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    ptoContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    ptoContainer -> valueLocButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> posChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> negChannelButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    ptoContainer -> valueLoc -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> posChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> negChannel -> storeCommonDialog ((vuCommonDialogClass *)this);
    ptoContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    ptoContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_PTO);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    ptoTitle = vresourceGetString (dialogTitles, 
				vunames_vuPtoDialogTitle);
    SetTitle (ptoTitle);
}


/*******************************************************************
*
*    vuPtoDialogClass Destroy function
*
*******************************************************************/

void vuPtoDialogClass::Destroy (void)
{
    vstrDestroy (ptoTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuPtoDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuPtoDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (ptoContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		// set the default value for these pat fields
		else if ( ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "LIN2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ADR2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "CRD2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SIG2", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "PONT", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "POFT ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "MNPW", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "SCLF", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuPtoDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		tempName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// output device type

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an PTO
	if (ptType != VU_PTO)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_PTO);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);
    }

    // since the pto can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (xrefNode -> xrefTable == db -> vuIOAddrTable) )
	    {
		if (xrefNode -> xrefTable == db -> vuIOAddrTable)
		{
		    // For PTO, the entry in the IOADDR file will be duplicated. 
		    // To avoid this, the point name will have a '1','2'
		    // appended depending on the EPICS field name.
		    //	POUT (pos channel) = 1, NOUT (neg channel) = 2, 
		    strcpy (tempName, pvName);
		    if ( (strncmp ((const char *)epics, "LINE", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "ADDR", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "CARD", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "SIGN", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "1");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG2", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "2");
		    }
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, tempName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (ptoContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_OUTLINK:
		    // device type must be REFERENCE to output the reference
		    if (dType == VU_REFERENCE)
		    {
			DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    }
		    else 
		    {
			finalValue = vstrCloneScribed (vcharScribeSystem (""));
		    }
		    break;

		case DBF_INLINK:
		    // works for all pto inputs, see pdbxref
		    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuPtoDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		tempName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    DTYP_TYPE		dType;		// output device type

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the pto can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (ptoContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (xrefNode -> xrefTable == db -> vuIOAddrTable) )
	    {
		if (xrefNode -> xrefTable == db -> vuIOAddrTable)
		{
		    // For PTO, the entry in the IOADDR file will be duplicated. 
		    // To avoid this, the point name will have a '1','2'
		    // appended depending on the EPICS field name.
		    //	POUT (pos channel) = 1, NOUT (neg channel) = 2, 
		    strcpy (tempName, pvName);
		    if ( (strncmp ((const char *)epics, "LINE", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "ADDR", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "CARD", FLDNAME_SZ) == 0) ||
			 (strncmp ((const char *)epics, "SIGN", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "1");
		    }
		    else if ( (strncmp ((const char *)epics, "LIN2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "ADR2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "CRD2", FLDNAME_SZ) == 0) ||
			      (strncmp ((const char *)epics, "SIG2", FLDNAME_SZ) == 0) )
		    {
			strcat (tempName, "2");
		    }
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, tempName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (ptoContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
							    xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_OUTLINK:
		    // always write the boardtype from DTYP into the OUT field
		    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
		    // if we are a reference then write OUT into the REFERENCE field
		    if (dType == VU_REFERENCE)
		    {
			putField = xrefNode -> xrefRefField;
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    else
		    {
			// make sure to null out the field
			putField = xrefNode -> xrefRefField;
			vmemSet (dbValue, 0, VU_KEY_SIZE);
		    }
		    break;

		case DBF_INLINK:
		    // for DOL, we must put its value to the OUTPUTREF field
		    // other wise it and other INLINKS are the same 
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DOL ", FLDNAME_SZ)) == 0)
		    {
			putField = xrefNode -> xrefRefField;
		    }
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuPtoContainerClass, vcontainer, "vuPtoContainerClass");

/*******************************************************************
*
*    vuPtoContainerClass override for constructor
*
*******************************************************************/

void vuPtoContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuPtoContainer);

    vcontainer *outbtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoDTYPContainer);
    outputBoard = vuBoardTypeMenuClass::RequestSubLoad (outbtcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoLINEContainer);
    posLine = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoADDRContainer);
    posAddr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoCARDContainer);
    posCard = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoSIGNContainer);
    posSignal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    posInvert = vuCheckBoxClass::RequestSubLoad (this,
				vunames_POIV);

    vcontainer *neglinecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoLIN2Container);
    negLine = filteredTextitem::RequestSubLoad (neglinecontainer,
				vunames_LIN2);

    vcontainer *negaddrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoADR2Container);
    negAddr = filteredTextitem::RequestSubLoad (negaddrcontainer,
				vunames_ADR2);

    vcontainer *negcardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoCRD2Container);
    negCard = filteredTextitem::RequestSubLoad (negcardcontainer,
				vunames_CRD2);

    vcontainer *negsignalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoSIG2Container);
    negSignal = filteredTextitem::RequestSubLoad (negsignalcontainer,
				vunames_SIG2);

    negInvert = vuCheckBoxClass::RequestSubLoad (this,
				vunames_NOIV);

    vcontainer *dolcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoDOLContainer);
    valueLocButton = vuPvNameButtonClass::RequestSubLoad (dolcontainer,
				vunames_vuPtoDOLButton);
    valueLoc = vuFilteredTextitem::RequestSubLoad (dolcontainer,
				vunames_DOL);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *egucontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egucontainer,
				vunames_EGU);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    closedLoop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OMSL);

    vcontainer *posccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoPOUTContainer);
    posChannelButton = vuPvNameButtonClass::RequestSubLoad (posccontainer,
				vunames_vuPtoPOUTButton);
    posChannel = vuFilteredTextitem::RequestSubLoad (posccontainer,
				vunames_POUT);

    vcontainer *negccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoNOUTContainer);
    negChannelButton = vuPvNameButtonClass::RequestSubLoad (negccontainer,
				vunames_vuPtoNOUTButton);
    negChannel = vuFilteredTextitem::RequestSubLoad (negccontainer,
				vunames_NOUT);

    vcontainer *nbitscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoNBITContainer);
    numberBits = spinnerClass::RequestSubLoad (nbitscontainer,
				vunames_NBIT);

    vcontainer *ptypcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoPTYPContainer);
    pulseType = vuChoiceRecMenuClass::RequestSubLoad (ptypcontainer,
				vunames_PTYP);

    vcontainer *mdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdbcontainer,
				vunames_MDEL);

    vcontainer *archcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (archcontainer,
				vunames_ADEL);

    vcontainer *alarmdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (alarmdbcontainer,
				vunames_HYST);

    vcontainer *valuecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoValuesContainer);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *pontcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoPONTContainer);
    onValue = filteredTextitem::RequestSubLoad (pontcontainer,
				vunames_PONT);

    vcontainer *poftcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoPOFTContainer);
    offValue = filteredTextitem::RequestSubLoad (poftcontainer,
				vunames_POFT);

    vcontainer *mnpwcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoMNPWContainer);
    minimumValue = filteredTextitem::RequestSubLoad (mnpwcontainer,
				vunames_MNPW);

    vcontainer *sclfcontainer = vcontainer::RequestSubLoad (valuecontainer,
				vunames_vuPtoSCLFContainer);
    scale = filteredTextitem::RequestSubLoad (sclfcontainer,
				vunames_SCLF);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoAlarmContainer);

    vcontainer *hihilimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihilimcontainer,
				vunames_HIHI);
    vcontainer *hihisevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hihisevcontainer,
				vunames_HHSV);

    vcontainer *highlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highlimcontainer,
				vunames_HIGH);
    vcontainer *highsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (highsevcontainer,
				vunames_HSV);

    vcontainer *lowlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowlimcontainer,
				vunames_LOW);
    vcontainer *lowsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lowsevcontainer,
				vunames_LSV);

    vcontainer *lololimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lololimcontainer,
				vunames_LOLO);
    vcontainer *lolosevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolosevcontainer,
				vunames_LLSV);

    vcontainer *clmhcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoCLMHContainer);
    clampHigh = filteredTextitem::RequestSubLoad (clmhcontainer,
				vunames_CLMH);
    vcontainer *clmhsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoCHSVContainer);
    clampHighSeverity = vuChoiceGblMenuClass::RequestSubLoad (clmhsevcontainer,
				vunames_CHSV);

    vcontainer *clmlcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoCLMLContainer);
    clampLow = filteredTextitem::RequestSubLoad (clmlcontainer,
				vunames_CLML);
    vcontainer *clmlsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuPtoCLSVContainer);
    clampLowSeverity = vuChoiceGblMenuClass::RequestSubLoad (clmlsevcontainer,
				vunames_CLSV);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPtoADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuPtoADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);


    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    valueLocButton -> storePvName (valueLoc);
    posChannelButton -> storePvName (posChannel);
    negChannelButton -> storePvName (negChannel);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    posLine -> SetItemFilterFunc (numericFilter);
    posAddr -> SetItemFilterFunc (numericFilter);
    posCard -> SetItemFilterFunc (numericFilter);
    posSignal -> SetItemFilterFunc (numericFilter);
    negLine -> SetItemFilterFunc (numericFilter);
    negAddr -> SetItemFilterFunc (numericFilter);
    negCard -> SetItemFilterFunc (numericFilter);
    negSignal -> SetItemFilterFunc (numericFilter);
    precision -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);

    valueLoc -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *vText = (filteredText *)valueLoc -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    vText -> SetUserPtr ((void *)valueLoc);

    posChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *poscText = (filteredText *)posChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    poscText -> SetUserPtr ((void *)posChannel);

    negChannel -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *negcText = (filteredText *)negChannel -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    negcText -> SetUserPtr ((void *)negChannel);

    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    onValue -> SetItemFilterFunc (floatFilter);
    offValue -> SetItemFilterFunc (floatFilter);
    minimumValue -> SetItemFilterFunc (floatFilter);
    scale -> SetItemFilterFunc (floatFilter);

    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    clampLow -> SetItemFilterFunc (floatFilter);
    clampHigh -> SetItemFilterFunc (floatFilter);


    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);


    // build popup menus
    outputBoard -> vuBuildBoardTypeMenu (VU_BO);
    pulseType -> vuBuildOptionMenu (VU_PTO, REC_PTO_PULSE);
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    clampHighSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    clampLowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
}


/*******************************************************************
*
*    vuPtoContainerClass override for destructor
*
*******************************************************************/

void vuPtoContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

