#ifndef vuscriptscheduledialogclassHXX
#define vuscriptscheduledialogclassHXX

class	vuScrSchApplyButtonClass;
class	vuScrSchDismissButtonClass;
class	vuScrSchDeleteButtonClass;
class	vuScrSchNewButtonClass;
class	vuScrSchGoToButtonClass;
class	vuScrSchNextButtonClass;
class	vuScrSchPrevButtonClass;
class	vuScrSchIdFilteredTextitem;
class	vuScrSchDomClass;
class	vuScrSchDomValueClass;
class	vuSelScrDialogClass;

//*** SCRIPT SCHEDULE DIALOG CLASS ******************************

class  vuScrSchDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;
    vuSelScrDialogClass	*selScrDialog;

    public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuScrSchDialogClass);

    // macros for standard constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuScrSchDialogClass, vdialog);

    // override to load dialog
    void LoadInit(vresource res);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuScrSchOpen(vuMainDialogClass *mainDialog);	

    // functions to handle dialogModified
    int getDialogModify (void) { return (dialogModified); }
    void setDialogModify (int val) { dialogModified = val; }

    // function to handle mainDialog
    void storeMainDialog (vuMainDialogClass *cd)
	{ mainDialog = cd; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // function to handle selScrDialog
    vuSelScrDialogClass *getSelScrDialog (void)
	{ return (selScrDialog); }
    void storeSelScrDialog (vuSelScrDialogClass *cd)
	{ selScrDialog = cd; }

    // function to reset dialog
    void vuNewScript (void);

    // function to load a script
    void vuLoadScript (vchar *scriptId);

    // function to map database fields
    void vuMapFields (void);

    // public so dont need funcs to access
    vuScrSchIdFilteredTextitem	*scriptID;
    optionMenuClass	*shell;
    filteredTextitem	*name;
    filteredTextitem	*description;
    checkBoxClass	*useParam[10];
    filteredTextitem	*params[10];
    hhmmTimeClass	*timeValue;
    groupContainerClass	*dayOfWeek;
    vuScrSchDomClass		*dayOfMonth;
    vuScrSchDomValueClass	*dayOfMonthValue;
    groupContainerClass	*monthOfYear;

    vuScrSchApplyButtonClass	*applyButton;
    vuScrSchDismissButtonClass	*dismissButton;
    vuScrSchDeleteButtonClass	*deleteButton;
    vuScrSchNewButtonClass	*newButton;
    vuScrSchGoToButtonClass	*gotoButton;
    vuScrSchNextButtonClass	*nextButton;
    vuScrSchPrevButtonClass	*prevButton;

    // database field ptrs
    DB_FIELD_PTR	scIdField;
    DB_FIELD_PTR	scShellField;
    DB_FIELD_PTR	scNameField;
    DB_FIELD_PTR	scDescField;
    DB_FIELD_PTR	scUseField;
    DB_FIELD_PTR	scParamsField[10];
    DB_FIELD_PTR	scHourField;
    DB_FIELD_PTR	scMinField;
    DB_FIELD_PTR	scDOWField[7];
    DB_FIELD_PTR	scDOMField;
    DB_FIELD_PTR	scMOYField[12];

};


//*** SCRIPT SCHEDULE APPLY BUTTON CLASS **********************

class vuScrSchApplyButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchApplyButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE DISMISS BUTTON CLASS **********************

class vuScrSchDismissButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE DELETE BUTTON CLASS ***********************

class vuScrSchDeleteButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchDeleteButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE NEW BUTTON CLASS ***************************

class vuScrSchNewButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchNewButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchNewButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE GOTO BUTTON CLASS *************************

class vuScrSchGoToButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchGoToButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchGoToButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE NEXT BUTTON CLASS ***************************

class vuScrSchNextButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchNextButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchNextButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


//*** SCRIPT SCHEDULE PREV BUTTON CLASS ***************************

class vuScrSchPrevButtonClass : public vbutton
{
    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchPrevButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchPrevButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
};


// *** SUBCLASS exclusiveContainer Class ************************

class vuScrSchDomClass : public exclusiveContainerClass
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchDomClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchDomClass, exclusiveContainerClass);

    // override the control notify
    void ObserveDialogItem (vevent *event);
};


//*** SUBCLASS optionMenuClass **********************************

class vuScrSchDomValueClass : public optionMenuClass
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchDomValueClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchDomValueClass, optionMenuClass);

    // override the control notify
    void ObserveDialogItem (vevent *event);

    // function to build attached menu
    void buildMenu (void);
};


//*** SELECT SCRIPT DIALOG CLASS **********************************

class	vuSelScrListClass;
class	vuSelScrApplyButtonClass;
class	vuSelScrDismissButtonClass;

class	vuSelScrDialogClass : public vdialog
{
    vuScrSchDialogClass	*scrSchDialog;
    vchar		scriptId[SCRIPTID_SZ + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelScrDialogClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuSelScrDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // destroy override
    void Destroy (void);

    // open function
    void vuSelScrOpen (vuScrSchDialogClass *scrSchDialog);

    // function for scriptId
    vchar *vuGetScriptId (void) 
	{ return (scriptId); }

    // public so dont need funcs to access
    vuSelScrListClass		*selScrList;
    vuSelScrApplyButtonClass	*applyButton;
    vuSelScrDismissButtonClass	*dismissButton;
};


// *** SCRIPT SELECT LISTVIEW CLASS ********************************

class vuSelScrListClass : public vlistview
{
    vuSelScrDialogClass	*selScrDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelScrListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelScrListClass, vlistview);

    // override
    void ObserveSelect (int state);

    // functions to handle selScrDialog
    void storeSelScrDialog (vuSelScrDialogClass *cd)
	{ selScrDialog = cd; }
};


//*** SCRIPT SELECT APPLY BUTTON CLASS **********************

class vuSelScrApplyButtonClass : public vbutton
{
    vuSelScrDialogClass	*selScrDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelScrApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelScrApplyButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle selScrDialog
    void storeSelScrDialog (vuSelScrDialogClass *cd) 
	{ selScrDialog = cd; }
};


//*** SCRIPT SELECT DISMISS BUTTON CLASS **********************

class vuSelScrDismissButtonClass : public vbutton
{
    vuSelScrDialogClass	*selScrDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSelScrDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSelScrDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle selScrDialog
    void storeSelScrDialog (vuSelScrDialogClass *cd) 
	{ selScrDialog = cd; }
};


// *** SUBCLASS OF filteredTextitem **************************************************

class vuScrSchIdFilteredTextitem : public filteredTextitem
{

    vuScrSchDialogClass	*scrSchDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuScrSchIdFilteredTextitem);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuScrSchIdFilteredTextitem, filteredTextitem);

    // override observe
    void ObserveView (vevent *event, int message);

    // handle scrSchDialog
    void storeScrSchDialog (vuScrSchDialogClass *cd) 
	{ scrSchDialog = cd; }
    vuScrSchDialogClass *getScrSchDialog (void) 
	{ return (scrSchDialog); }
};

#endif vuscriptscheduledialogclassHXX

