#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceSel.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuSelDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuSelDialogClass, vuCommonDialogClass, "vuSelDialogClass");

/*******************************************************************
*
*    vuSelDialogClass override for constructors init ()
*
*******************************************************************/

void vuSelDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    selContainer = vuSelContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    selContainer -> indexLocation -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prc1 -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> maxs -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> constantValue -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> rocSamples -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> selectMethod -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> numberInputs -> SetModifiedPtr (&this -> dialogModified);

    selContainer -> pva -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prca -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsa -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> csta -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvb -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcb -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsb -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstb -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvc -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcc -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsc -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstc -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvd -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcd -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsd -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstd -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pve -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prce -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxse -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cste -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvf -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcf -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsf -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstf -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvg -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcg -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsg -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstg -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvh -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prch -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsh -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> csth -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvi -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prci -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsi -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> csti -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvj -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcj -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsj -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstj -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvk -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prck -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsk -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstk -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> pvl -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> prcl -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> mxsl -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> cstl -> SetTextModifiedPtr (&this -> dialogModified);

    selContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> devSetpoint -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> rocLimit -> SetTextModifiedPtr (&this -> dialogModified);
    selContainer -> devLimit -> SetTextModifiedPtr (&this -> dialogModified);

    selContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> rocSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    selContainer -> devSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    selContainer -> indexLocationButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvaButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvbButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvcButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvdButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pveButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvfButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvgButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvhButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pviButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvjButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvkButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvlButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    selContainer -> indexLocation -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pva -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvb -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvc -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvd -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pve -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvf -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvg -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvh -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvi -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvj -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvk -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> pvl -> storeCommonDialog ((vuCommonDialogClass *)this);
    selContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    selContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_SEL);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    selTitle = vresourceGetString (dialogTitles, 
				vunames_vuSelDialogTitle);
    SetTitle (selTitle);
}


/*******************************************************************
*
*    vuSelDialogClass Destroy function
*
*******************************************************************/

void vuSelDialogClass::Destroy (void)
{
    vstrDestroy (selTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuSelDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuSelDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (selContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuSelDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

   vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an SEL
	if (ptType != VU_SEL)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_SEL);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
     // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (selContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuSelDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (selContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuSelContainerClass, vcontainer, "vuSelContainerClass");

/*******************************************************************
*
*    vuSelContainerClass override for constructor
*
*******************************************************************/

void vuSelContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuSelContainer);

    vcontainer *nvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelNVLContainer);
    indexLocationButton = vuPvNameButtonClass::RequestSubLoad (nvlcontainer,
				vunames_vuSelNVLButton);
    indexLocation = vuFilteredTextitem::RequestSubLoad (nvlcontainer,
				vunames_NVL);

    prc1 = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC1);

    maxs = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    vcontainer *cnstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCNSTContainer);
    constantValue = filteredTextitem::RequestSubLoad (cnstcontainer,
				vunames_CNST);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *egutagcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egutagcontainer,
				vunames_EGU);

    vcontainer *rocscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelROCNContainer);
    rocSamples = filteredTextitem::RequestSubLoad (rocscontainer,
				vunames_ROCN);

    vcontainer *selmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelSELMContainer);
    selectMethod = vuChoiceRecMenuClass::RequestSubLoad (selmcontainer,
				vunames_SELM);

    vcontainer *ninpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelNINPContainer);
    numberInputs = spinnerClass::RequestSubLoad (ninpcontainer,
				vunames_NINP);

    vcontainer *pvacontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPAContainer);
    pvaButton = vuPvNameButtonClass::RequestSubLoad (pvacontainer,
				vunames_vuSelINPAButton);
    pva = vuFilteredTextitem::RequestSubLoad (pvacontainer,
				vunames_INPA);
    prca = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCA);
    mxsa = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSA);
    vcontainer *cstacontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTAContainer);
    csta = filteredTextitem::RequestSubLoad (cstacontainer,
				vunames_CSTA);

    vcontainer *pvbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPBContainer);
    pvbButton = vuPvNameButtonClass::RequestSubLoad (pvbcontainer,
				vunames_vuSelINPBButton);
    pvb = vuFilteredTextitem::RequestSubLoad (pvbcontainer,
				vunames_INPB);
    prcb = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCB);
    mxsb = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSB);
    vcontainer *cstbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTBContainer);
    cstb = filteredTextitem::RequestSubLoad (cstbcontainer,
				vunames_CSTB);

    vcontainer *pvccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPCContainer);
    pvcButton = vuPvNameButtonClass::RequestSubLoad (pvccontainer,
				vunames_vuSelINPCButton);
    pvc = vuFilteredTextitem::RequestSubLoad (pvccontainer,
				vunames_INPC);
    prcc = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCC);
    mxsc = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSC);
    vcontainer *cstccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTCContainer);
    cstc = filteredTextitem::RequestSubLoad (cstccontainer,
				vunames_CSTC);

    vcontainer *pvdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPDContainer);
    pvdButton = vuPvNameButtonClass::RequestSubLoad (pvdcontainer,
				vunames_vuSelINPDButton);
    pvd = vuFilteredTextitem::RequestSubLoad (pvdcontainer,
				vunames_INPD);
    prcd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCD);
    mxsd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSD);
    vcontainer *cstdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTDContainer);
    cstd = filteredTextitem::RequestSubLoad (cstdcontainer,
				vunames_CSTD);

    vcontainer *pvecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPEContainer);
    pveButton = vuPvNameButtonClass::RequestSubLoad (pvecontainer,
				vunames_vuSelINPEButton);
    pve = vuFilteredTextitem::RequestSubLoad (pvecontainer,
				vunames_INPE);
    prce = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCE);
    mxse = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSE);
    vcontainer *cstecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTEContainer);
    cste = filteredTextitem::RequestSubLoad (cstecontainer,
				vunames_CSTE);

    vcontainer *pvfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPFContainer);
    pvfButton = vuPvNameButtonClass::RequestSubLoad (pvfcontainer,
				vunames_vuSelINPFButton);
    pvf = vuFilteredTextitem::RequestSubLoad (pvfcontainer,
				vunames_INPF);
    prcf = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCF);
    mxsf = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSF);
    vcontainer *cstfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTFContainer);
    cstf = filteredTextitem::RequestSubLoad (cstfcontainer,
				vunames_CSTF);

    vcontainer *pvgcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPGContainer);
    pvgButton = vuPvNameButtonClass::RequestSubLoad (pvgcontainer,
				vunames_vuSelINPGButton);
    pvg = vuFilteredTextitem::RequestSubLoad (pvgcontainer,
				vunames_INPG);
    prcg = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCG);
    mxsg = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSG);
    vcontainer *cstgcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTGContainer);
    cstg = filteredTextitem::RequestSubLoad (cstgcontainer,
				vunames_CSTG);

    vcontainer *pvhcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPHContainer);
    pvhButton = vuPvNameButtonClass::RequestSubLoad (pvhcontainer,
				vunames_vuSelINPHButton);
    pvh = vuFilteredTextitem::RequestSubLoad (pvhcontainer,
				vunames_INPH);
    prch = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCH);
    mxsh = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSH);
    vcontainer *csthcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTHContainer);
    csth = filteredTextitem::RequestSubLoad (csthcontainer,
				vunames_CSTH);

    vcontainer *pvicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPIContainer);
    pviButton = vuPvNameButtonClass::RequestSubLoad (pvicontainer,
				vunames_vuSelINPIButton);
    pvi = vuFilteredTextitem::RequestSubLoad (pvicontainer,
				vunames_INPI);
    prci = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);
    mxsi = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSI);
    vcontainer *csticontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTIContainer);
    csti = filteredTextitem::RequestSubLoad (csticontainer,
				vunames_CSTI);

    vcontainer *pvjcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPJContainer);
    pvjButton = vuPvNameButtonClass::RequestSubLoad (pvjcontainer,
				vunames_vuSelINPJButton);
    pvj = vuFilteredTextitem::RequestSubLoad (pvjcontainer,
				vunames_INPJ);
    prcj = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCJ);
    mxsj = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSJ);
    vcontainer *cstjcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTJContainer);
    cstj = filteredTextitem::RequestSubLoad (cstjcontainer,
				vunames_CSTJ);

    vcontainer *pvkcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPKContainer);
    pvkButton = vuPvNameButtonClass::RequestSubLoad (pvkcontainer,
				vunames_vuSelINPKButton);
    pvk = vuFilteredTextitem::RequestSubLoad (pvkcontainer,
				vunames_INPK);
    prck = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCK);
    mxsk = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSK);
    vcontainer *cstkcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTKContainer);
    cstk = filteredTextitem::RequestSubLoad (cstkcontainer,
				vunames_CSTK);

    vcontainer *pvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelINPLContainer);
    pvlButton = vuPvNameButtonClass::RequestSubLoad (pvlcontainer,
				vunames_vuSelINPLButton);
    pvl = vuFilteredTextitem::RequestSubLoad (pvlcontainer,
				vunames_INPL);
    prcl = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCL);
    mxsl = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSL);
    vcontainer *cstlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelCSTLContainer);
    cstl = filteredTextitem::RequestSubLoad (cstlcontainer,
				vunames_CSTL);

    vcontainer *mdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdbcontainer,
				vunames_MDEL);

    vcontainer *archcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (archcontainer,
				vunames_ADEL);

    vcontainer *alarmdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (alarmdbcontainer,
				vunames_HYST);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *devstpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelDEVSContainer);
    devSetpoint = filteredTextitem::RequestSubLoad (devstpcontainer,
				vunames_DEVS);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuSelADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSelAlarmContainer);

    vcontainer *hihilimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihilimcontainer,
				vunames_HIHI);
    vcontainer *hihisevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hihisevcontainer,
				vunames_HHSV);

    vcontainer *highlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highlimcontainer,
				vunames_HIGH);
    vcontainer *highsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (highsevcontainer,
				vunames_HSV);

    vcontainer *lowlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowlimcontainer,
				vunames_LOW);
    vcontainer *lowsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lowsevcontainer,
				vunames_LSV);

    vcontainer *lololimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lololimcontainer,
				vunames_LOLO);
    vcontainer *lolosevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolosevcontainer,
				vunames_LLSV);

    vcontainer *roclimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelROCContainer);
    rocLimit = filteredTextitem::RequestSubLoad (roclimcontainer,
				vunames_ROC);
    vcontainer *rocsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelRCSVContainer);
    rocSeverity = vuChoiceGblMenuClass::RequestSubLoad (rocsevcontainer,
				vunames_RCSV);

    vcontainer *devlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelDEVLContainer);
    devLimit = filteredTextitem::RequestSubLoad (devlimcontainer,
				vunames_DEVL);
    vcontainer *devsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSelDVSVContainer);
    devSeverity = vuChoiceGblMenuClass::RequestSubLoad (devsevcontainer,
				vunames_DVSV);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    indexLocationButton -> storePvName (indexLocation);
    pvaButton -> storePvName (pva);
    pvbButton -> storePvName (pvb);
    pvcButton -> storePvName (pvc);
    pvdButton -> storePvName (pvd);
    pveButton -> storePvName (pve);
    pvfButton -> storePvName (pvf);
    pvgButton -> storePvName (pvg);
    pvhButton -> storePvName (pvh);
    pviButton -> storePvName (pvi);
    pvjButton -> storePvName (pvj);
    pvkButton -> storePvName (pvk);
    pvlButton -> storePvName (pvl);
    alarmDisableButton -> storePvName (alarmDisable);


    precision -> SetItemFilterFunc (numericFilter);
    rocSamples -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);

    indexLocation -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *idlocText = (filteredText *)indexLocation -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    idlocText -> SetUserPtr ((void *)indexLocation);

    pva -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvaText = (filteredText *)pva -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvaText -> SetUserPtr ((void *)pva);

    pvb -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvbText = (filteredText *)pvb -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvbText -> SetUserPtr ((void *)pvb);

    pvc -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvcText = (filteredText *)pvc -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvcText -> SetUserPtr ((void *)pvc);

    pvd -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvdText = (filteredText *)pvd -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvdText -> SetUserPtr ((void *)pvd);

    pve -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pveText = (filteredText *)pve -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pveText -> SetUserPtr ((void *)pve);

    pvf -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvfText = (filteredText *)pvf -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvfText -> SetUserPtr ((void *)pvf);

    pvg -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvgText = (filteredText *)pvg -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvgText -> SetUserPtr ((void *)pvg);

    pvh -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvhText = (filteredText *)pvh -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvhText -> SetUserPtr ((void *)pvh);

    pvi -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pviText = (filteredText *)pvi -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pviText -> SetUserPtr ((void *)pvi);

    pvj -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvjText = (filteredText *)pvj -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvjText -> SetUserPtr ((void *)pvj);

    pvk -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvkText = (filteredText *)pvk -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvkText -> SetUserPtr ((void *)pvk);

    pvl -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvlText = (filteredText *)pvl -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvlText -> SetUserPtr ((void *)pvl);

    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    devSetpoint -> SetItemFilterFunc (floatFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);

    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    rocLimit -> SetItemFilterFunc (floatFilter);
    devLimit -> SetItemFilterFunc (floatFilter);

    // build popup menus
    selectMethod -> vuBuildOptionMenu (VU_SEL, REC_SEL_ALG);
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    rocSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    devSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuSelContainerClass override for destructor
*
*******************************************************************/

void vuSelContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

