#ifndef vusyncdialogclassHXX
#define vusyncdialogclassHXX

#include "vuFindDialogClass.hxx"

class vuSyncABButtonClass;
class vuSyncBAButtonClass;
class vuSyncDismissButtonClass;
class vuSyncFindButtonClass;
class vuSyncDialogClass;
class vuSyncRulerClass;

// *** SYNC CONTAINER CLASS ***************************************************

class  vuSyncContainerClass : public vcontainer
{

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuSyncContainerClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuSyncContainerClass, vcontainer);	

    // override to load dialog
    void LoadInit(vresource res);		

    // override 
    void Destroy ();

    vtextitem			*pathA;
    vtextitem			*pathB;
    vcontrolToggle		*pathAreadOnly;
    vcontrolToggle		*pathBreadOnly;
    vuSyncRulerClass		*ruler;
    vlistview			*pointList;
    vuSyncABButtonClass		*abButton;
    vuSyncBAButtonClass		*baButton;
    vcontainerExclusiveGroup	*options;
};


// *** SYNC RULER CLASS ******************************************************

class vuSyncRulerClass : public vruler
{

    vuSyncDialogClass *syncDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncRulerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncRulerClass, vruler);

    // override
    void ObserveRuler (vevent *event, vrulerItem *item, int message);

    // functions to handle syncDialog
    void setSyncDialog (vuSyncDialogClass *dialog)
	{ syncDialog = dialog; }
};


// *** SYNC AB BUTTON CLASS ***************************************************

class vuSyncABButtonClass : public vbutton
{
    vuSyncDialogClass	*syncDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncABButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncABButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle syncDialog
    void setSyncDialog (vuSyncDialogClass *dialog)
	{ syncDialog = dialog; }
};


// *** SYNC BA BUTTON CLASS ***************************************************

class vuSyncBAButtonClass : public vbutton
{
    vuSyncDialogClass	*syncDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncBAButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncBAButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle syncDialog
    void setSyncDialog (vuSyncDialogClass *dialog)
	{ syncDialog = dialog; }
};


// *** SYNC DISMISS BUTTON CLASS **********************************************

class vuSyncDismissButtonClass : public vbutton
{
    vuSyncDialogClass	*syncDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle syncDialog
    void setSyncDialog (vuSyncDialogClass *dialog) 
	{ syncDialog = dialog; }
};


// *** SYNC FIND BUTTON CLASS **********************************************

class vuSyncFindButtonClass : public vbutton
{
    vuSyncDialogClass	*syncDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncFindButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncFindButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle syncDialog
    void setSyncDialog (vuSyncDialogClass *dialog) 
	{ syncDialog = dialog; }
};


// *** SYNC DIALOG CLASS *****************************************************

class vuSyncDialogClass : public vuFindDialogClass
{
    vuSyncContainerClass	*syncContainer;
    vstr			*dialogTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuSyncDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuSyncDialogClass, vuFindDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    // override
    void vuFindOpen (vchar *label, vuMainDialogClass *mainDialog);

    // function to handle syncContainer
    vuSyncContainerClass *getSyncContainer (void)
	{ return (syncContainer); }

    vuSyncDismissButtonClass	*dismissButton;
    vuSyncFindButtonClass	*findButton;
};

#endif vusyncdialogclassHXX
