#include <vxWorks.h>
#include <logLib.h>
#include <symLib.h>
#include <taskLib.h>
#include <semLib.h>
#include <time.h>
#include "tsDefs.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define	DEFAULT_NUMLINES	10
#define NUMLINES		400
static SEM_ID	logsem;
static  char tempMsg[200];
static  char tempMsg2[200];
static  char timeStr[40];
extern SYMTAB_ID	sysSymTbl;
static int		nextMsg = 0;		/* place where next message goes */
static int		nextTempMsg = 0;		/* place where next message goes */
static int		installed = 0;		/* 0 = no installed 1 = installed */
static char		msgs[NUMLINES][132];	/* 400 messages of 132 bytes each */
static char		tempmsgs[NUMLINES][200];	/* 400 messages of 200 bytes each */
int			newLog = 0;		/* 1 = use old logMsg 0 = use this one */
void			(*oldLogMsg)();		/* store original logMsg here */
void			(*LocalTime)();		/* use these after iocCore downloaded */
void			(*StampToText)();
static int msgSize1 = 0 ,msgSize2 = 0;
int newLogMsg(char *format,int arg1,int arg2,int arg3,int arg4,int arg5,int arg6);
int dumpMsgs(int numLines);
/*
 */
void showMsgSize(){printf("1:%d,2:%d\n",msgSize1,msgSize2);}
void clearMsgSize(){msgSize1 = 0;msgSize2 = 0;}
void enableNewLog(){newLog = 1;}
void disableNewLog(){newLog = 0;}
int newLogMsg(char *format,int arg1,int arg2,int arg3,int arg4,int arg5,int arg6)
{
  SYM_TYPE symtype;
  UINT16 group = 0;
  int tempSize1,tempSize2;
  TS_STAMP now;
  if(installed)
    {
      semTake (logsem, WAIT_FOREVER);
      if(LocalTime)
	{
	  LocalTime(&now);
	  StampToText(&now,TS_TEXT_MONDDYYYY,timeStr);
	}
      else
	{
	  symFindByName(sysSymTbl,"_tsLocalTime",(char **)&LocalTime,&symtype);	/* get address of tsLocalTime */
	  symFindByName(sysSymTbl,"_tsStampToText",(char **)&StampToText,&symtype);	/* get address of tsStampToText */
	  strcpy(timeStr,"Time Unknown");
	}
      tempSize1 = sprintf(tempMsg,format,arg1,arg2,arg3,arg4,arg5,arg6);			/* format original message */
      tempSize2 = sprintf(tempMsg2,"<%s> <%s> %s",taskName(taskIdSelf()),timeStr,tempMsg);	/* Add date/time an proc name */
      if(tempSize1 > msgSize1)
	msgSize1 = tempSize1;
      if(tempSize2 > msgSize2)
	msgSize2 = tempSize2;
      strncpy(&msgs[nextMsg][0],tempMsg2,131);				/* save new message in ring buffer */
	msgs[nextMsg][131] = 0;
       if(msgs[nextMsg][strlen(&msgs[nextMsg][0])-1] == '\n')
	msgs[nextMsg][strlen(&msgs[nextMsg][0])-1] = 0;
      if(++nextMsg > NUMLINES-1) nextMsg = 0;
      if(!newLog)
	{
	  sprintf(&tempmsgs[nextTempMsg][0],"<%s> %s",timeStr,tempMsg);
	  oldLogMsg("%s", (int)&tempmsgs[nextTempMsg][0],0, 0, 0, 0, 0);	/* print original message */
	  if(++nextTempMsg > NUMLINES-1) nextTempMsg = 0;
	}
     semGive (logsem);
    }
  else
    {
      symFindByName(sysSymTbl,"_logMsg",(char **)&oldLogMsg,&symtype);	/* get address of original logMsg */
      symAdd(sysSymTbl,"_logMsg",(char *)newLogMsg,symtype,group);     	/* add old symbol new address */
      for(installed = 0;installed < NUMLINES;installed++) msgs[installed][0] = 0;
      installed = 1;						/* only do this this first time */
      LocalTime = 0;
      StampToText = 0;
      logsem = semBCreate(SEM_Q_FIFO, SEM_FULL);
    }
  return(1);
}
int dumpMsgs(int numLines)
{
  int start,i;

  if(numLines == 0) numLines = DEFAULT_NUMLINES;
  start = nextMsg - numLines;
  if(start < 0) start = NUMLINES+start;
  for(i = start;;)
    {
      if(strlen(&msgs[i][0]))
	{
		printf("%-3d: %s\n",i,&msgs[i][0]);
	}
      if(++i > (NUMLINES - 1)) i = 0;
      if(--numLines <= 0) break;
    }
  return(1);
}
