/*DBCSymTable.c,v 1.1.1.1 1999/08/03 14:42:37 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			18-Jan-1993				      */
/*									      */
/*	Module Name:		DBCSymTable.c				      */
/*	Module Description:						      */
/*									      */
/*	Handle all Symbol Table functions:	DBC_ProcessSymPurge	      */
/*						DBC_ProcessSymResp	      */
/*						symBuild		      */
/*						symSearch		      */
/*						symPurge		      */
/*									      */
/*	Modification History:	First try	12-Mar-1993		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include	<stdio.h>
#include	<sys/types.h>
#ifndef WIN32
#include	<sys/file.h>
#include	<netinet/in.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<netinet/in.h>
#include	<netinet/tcp.h>
#include	<netdb.h>
#else
#include	<winsock.h>
typedef char * caddr_t;
#endif WIN32
#include	<dbDefs.h>
#include	<dbRecType.h>
#include	<dbRecDes.h>
#include	<dbRecords.h>
/*
	dbClient specific includes
*/
#include	<DBDefines.h>
#include	<redmsgs.h>
#include	<DBCVerifyDefs.h>
#include	<DBCDefines.h>
#include	<DBProto.h>
#ifndef WIN32
#include	<syslog.h>
#include	"error.h"
#endif
/*
	Database pointers.
*/
extern	DB_FIELD_PTR	pvmapCRCField;
extern	DB_TABLE_PTR	DBC_PvmapTable;
#ifndef WIN32
extern	ERRSYMTAB_ID	errSymTbl;			/* defined in error.h */
#endif
TREENODE_PTR		symBuild(),symSearch();
void		symPurge();
extern	DBC_RECDESC	downloadRecDesc[DBC_WINDOW_SIZE];
#define	CHECK_FIRST	1
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1993				      */
/*									      */
/*	Function Name:		DBC_ProcessSymResp			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	12-Mar-1993	GCT	First Try	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_ProcessSymResp(iocinfo)
DBC_IOCINFO_PTR	iocinfo;
{
TREENODE	newNode,*pNewNode;
DBC_SYMRESPHDR	hdr;
DBC_SYMRESPNAME	sym;
DBC_SYMREQ	symRequest;
short		symCount,symRecvd,msgType;
int		type,tempcrc;
unsigned short crc;
char		crcString[5];
DB_RECORD_PTR	crcRecord;
#ifndef	USE_PREALLOC
DBC_RECDESC		bld;
#endif
VERIFY_INFO		verify_info;

readTcp(iocinfo,(char *)&hdr,sizeof(DBC_SYMRESPHDR));
symCount = ntohs(hdr.numSymbols);
symRecvd = 0;
while(symCount)
	{
	memset((char *)&newNode,0,sizeof(TREENODE));
	readTcp(iocinfo,(char *)&sym,sizeof(DBC_SYMRESPNAME));
	strcpy(symRequest.symLastName,sym.symName);			/* copy for last name */
	if((crcRecord = DB_Seek(DBC_PvmapTable,sym.symName)) != 0)		/* find record in PVMAP */
		{
/*

	GCT	28-Mar-1994
	See if I have downloaded this record. If I have the just get the CRC as before
	If I haven't then recalculate the CRC,save it in PVMAP and then pass it to the
	'symBuild' function.

	GCT 25-Jul-1994
	Use the new verification information to check download status.

*/
		DB_GetVerifyInfo(DBC_PvmapTable,sym.symName,&verify_info,0);
		if(VI_IS_LOADED1(verify_info.viPVStatus) || VI_IS_LOADED2(verify_info.viPVStatus))
			{
			DB_GetFieldValue(crcRecord,pvmapCRCField,crcString,&type);	/* get CRC */
			sscanf(crcString,"%X",&tempcrc);					/* put in table node */
			crc = tempcrc;
			}
		else
			{
#ifndef	USE_PREALLOC
			DBC_BuildRecord(sym.symName,&bld,crcRecord);
			crc = DBC_CRCRecord(bld.recPtr,bld.recType);
			free(bld.recPtr);
#else
			DBC_BuildRecord(sym.symName,&downloadRecDesc[0],crcRecord);
			crc = DBC_CRCRecord(downloadRecDesc[0].recPtr,downloadRecDesc[0].recType);
#endif
			sprintf(crcString,"%04.04X\0",crc);
			DB_PutFieldValue(crcRecord,pvmapCRCField,crcString);
/*
			iocIndex = getIOCIndex(sym.symName,iocinfo);
			verify_info.viPVStatus |= ((iocIndex== 0) ? VI_LOADED_1 : VI_LOADED_2);
			DB_PutVerifyInfo(DBC_PvmapTable,sym.symName,&verify_info,0);
*/
			}
		}
	else
		{
#ifndef WIN32
		VERBOSE(V_DEBUG)(LOG_ALERT|LOG_LOCAL1,"DBC_ProcessSymResp:Point %s not found\n",sym.symName);
#endif WIN32
/*
	I can't find this point so I will send a request to all other hosts
	in my IOC list. The response with the most current date will be used to
	request the record.
*/
		strcpy(verify_info.viPVName,sym.symName);
		gethostname(verify_info.viHostName,DBC_IOCNAMESIZE);	/* get host name */
		verify_info.viPVStatus = 0;
		verify_info.viTimeStamp = 0;						/* very old! */
		verify_info.viTypeIndex = 0;
		DBC_SendToAllHosts(&verify_info,VI_MSG_VERIFYREQUEST);	/* see if any one else has it */
		symCount--;											/* Can't find record...Might have deleted offline after download */
															/* or this could be a workstation that never had the point. */
		continue;											/* drain the messaage buffer to keep messages in sync */
		}
	newNode.treePointId = ntohl(sym.symTrans);
#ifdef	CHECK_FIRST
/*
	See if symbol is already in the tree. If so then just ignore symbol else
	add it to the table .
*/
	if((pNewNode = symSearch(iocinfo->ioc_treeroot,newNode.treePointId)) == 0)
		{
#endif
		symBuild(&iocinfo->ioc_treeroot,&newNode,&pNewNode);		/* Add to tree for this IOC */
		strcpy(pNewNode->treePVName,sym.symName);
		pNewNode->treeCRC = crc;
#ifdef	CHECK_FIRST
		}
#endif
	symCount--;
	symRecvd++;
	}
if(symRecvd)
	{
	msgType = htons(DBC_MSG_SYMREQUEST);
	writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));			/* send message type */
	symRequest.numSyms = htons(DBC_MAX_SYMS);
	writeTcp(iocinfo,(char *)&symRequest,sizeof(DBC_SYMREQ));		/* send message type */
	}
else
	iocinfo->ioc_state = IOC_OK;
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1993				      */
/*									      */
/*	Function Name:		DBC_ProcessSymPurge			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	12-Mar-1993	GCT	First Try	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_ProcessSymPurge(iocinfo)
DBC_IOCINFO_PTR	iocinfo;
{
DBC_SYMREQ	symRequest;					/* symbol table request message */
short		msgType;
symPurge(iocinfo->ioc_treeroot);				/* free memory in tree */
iocinfo->ioc_treeroot = 0;					/* clear root also */
/*
	Ask for new one.
*/
#ifndef WIN32
VERBOSE(V_DEBUG)(LOG_ALERT|LOG_LOCAL1,"Requesting a Symbol Table from %s\n",iocinfo->ioc_name);
#endif WIN32
msgType = htons(DBC_MSG_SYMREQUEST);
writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));			/* send message type */
symRequest.numSyms = htons(DBC_MAX_SYMS);
strcpy(&symRequest.symLastName[0],"");				/* NULL to start */
writeTcp(iocinfo,(char *)&symRequest,sizeof(DBC_SYMREQ));		/* send message type */
iocinfo->ioc_state = IOC_SYMREQ;
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1993				      */
/*									      */
/*	Function Name:		symBuild				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	12-Mar-1993	GCT	First Try	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
TREENODE_PTR	symBuild(root,node,new)
TREENODE_PTR	*root,node,*new;
{
int	cond;
if(*root == NULL)
	{
	*root = (TREENODE_PTR)calloc(1,TREENODESIZE);
	memcpy(*root,node,TREENODESIZE);
	*new = *root;
	}
else if((cond = (*root)->treePointId - node->treePointId) == 0)
	{
	*new = *root;
	return(*root);
	}
else if(cond > 0)
	(*root)->left = (struct treenode *)symBuild(&(*root)->left,node,new);
else
	(*root)->right = (struct treenode *)symBuild(&(*root)->right,node,new);
return(*root);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1993				      */
/*									      */
/*	Function Name:		symSearch				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:		tree root & data to be located	      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:	0 if not found			      */
/*					Pointer to node if found	      */
/*									      */
/*	Modification History:	12-Mar-1993	GCT	First Try	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
TREENODE_PTR	symSearch(root,data)
TREENODE_PTR	root;
int		data;
{
TREENODE_PTR	node;
node = root;
while(node)
	{
	if(node -> treePointId == data)
		return(node);				/* done ! */
	else if(node -> treePointId > data)
		node = (TREENODE_PTR)node -> left;	/* try left branch */
	else
		node = (TREENODE_PTR)node -> right;	/* try right branch */
	}
return(node);
}
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1993				      */
/*									      */
/*	Function Name:		symPurge				      */
/*	Function Description:						      */
/*			Traverse tree and clear point IDs. Leave tree	      */
/*			intact						      */
/*									      */
/*									      */
/*	Input Parameters:	TREENODE	*node pointer to node	      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	14-Mar-1993	GCT	First Try	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
void	symPurge(node)
TREENODE	*node;
{
TREENODE	temp;
if(node)
	{
	memcpy(&temp,node,sizeof(TREENODE));
	symPurge(temp.left);
	free(node);
	symPurge(temp.right);
	}
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			12-Mar-1994				      */
/*									      */
/*	Function Name:		DBC_ProcessNewSymResp			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	12-Mar-1994	GCT	Clone of DBC_ProcessSymResp	      */
/*										Don't ask for additional symbols	  */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_ProcessNewSymResp(iocinfo)
DBC_IOCINFO_PTR	iocinfo;
{
TREENODE	newNode,*pNewNode;
DBC_SYMRESPHDR	hdr;
DBC_SYMRESPNAME	sym;
DBC_SYMREQ	symRequest;
short		symCount,symRecvd;
int		type,crc;
char		crcString[5];
DB_RECORD_PTR	crcRecord;

readTcp(iocinfo,(char *)&hdr,sizeof(DBC_SYMRESPHDR));
symCount = ntohs(hdr.numSymbols);
symRecvd = 0;
while(symCount)
	{
	memset((char *)&newNode,0,sizeof(TREENODE));
	readTcp(iocinfo,(char *)&sym,sizeof(DBC_SYMRESPNAME));
	strcpy(symRequest.symLastName,sym.symName);			/* copy for last name */
	crcRecord = DB_Seek(DBC_PvmapTable,sym.symName);		/* find record in PVMAP */
	DB_GetFieldValue(crcRecord,pvmapCRCField,crcString,&type);	/* get CRC */
	sscanf(crcString,"%X",&crc);					/* put in table node */
	newNode.treePointId = ntohl(sym.symTrans);
	symBuild(&iocinfo->ioc_treeroot,&newNode,&pNewNode);		/* Add to tree for this IOC */
	strcpy(pNewNode->treePVName,sym.symName);
	pNewNode->treeCRC = (short)crc;
/*
	VERBOSE(V_DEBUG)(LOG_ALERT|LOG_LOCAL1,"Point <%-*.*s> in IOC <%s> has CRC <%04X>\n",
		PVNAME_SZ,PVNAME_SZ,
		sym.symName,
		iocinfo->ioc_name,
		crc);
*/
	symCount--;
	symRecvd++;
	}
/*
	All done...other code asked for ALL symbols, we need only the
	new one and will get another message when the IOC sends it.
*/
iocinfo->ioc_state = IOC_OK;
return(DBC_SUCCESS);
}
