/*maxSocket.c,v 1.1.1.1 1999/08/03 14:42:37 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*	MAX OUT A SOCKET'S SEND AND RECEIVE BUFFERS		*/
/*								*/
/*	The sockets that connect the Socket Creation and	*/
/*	Maintenance program with Channel Acquisition and	*/
/*	Control require a lot of buffer space, especially	*/
/*	for large systems. The maximum transmit and receive	*/
/*	buffers are implementation specific, so we will		*/
/*	bump up each buffer until it can't be bumped any	*/
/*	more. This will guarantee that we always have as	*/
/*	much buffering space as the system will let us have.	*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <types.h>
#include <socket.h>

maxSocket(fd)
int	fd;
{
    int		size;
    int		intsize = sizeof(int);

    for (;;)
	{
	getsockopt(fd, SOL_SOCKET, SO_SNDBUF, &size, &intsize); 
	size += 1024;
	if (setsockopt(fd, SOL_SOCKET, SO_SNDBUF, &size, sizeof(size)) == -1)
	    break;
	}

    for (;;)
	{
	getsockopt(fd, SOL_SOCKET, SO_RCVBUF, &size, &intsize); 
	size += 1024;
	if (setsockopt(fd, SOL_SOCKET, SO_RCVBUF, &size, sizeof(size)) == -1)
	    break;
	}
}
