/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <DBDefines.h>
#include <DBCVerifyDefs.h>
#include <DBCDefines.h>
#include <dbRecType.h>
#ifndef WIN32
#include	<syslog.h>
#endif	WIN32
#define	CHECK_ASCII 1
extern	DBC_XREFHDR_PTR	DBC_XREFTables;
extern  DB_TABLE_PTR DBC_PvmapTable;
/*
	Create a new record and store the  buffer containing the entire record for the given
	PV name. This buffer will be made up from all the component files as given in the 
	DBC_XREFTables structure based on the type index.
*/
int	DB_CrFullRec(name,index,buff,rsize)
char	*name;
int		index;
char	*buff;			/* buff is the address of full record buffer */
int	rsize;
{
char	*recptr,j,i,lockCount,numRecords,*namePtr;
#ifdef	CHECK_ASCII
	int gotit = 0;
	int k;
	char msg[40];
	char *bptr = buff;
#endif
if(buff == 0) return(0);
#ifdef	CHECK_ASCII
	for (k = 0;k < rsize;k++)
		{
		if(!isprint(bptr[k]))
			gotit++;
		}
	if(gotit)
		{
#ifndef WIN32
		  syslog(LOG_DAEMON | LOG_ALERT,"Received %d unprintable chars in %s record",gotit,name);
#endif	WIN32
		  for(k = 0;k < rsize;k+=8)
			{
			for(j=0;j < 8;j++)
				sprintf(&msg[j*3],"%02X \0",bptr[k+j]);
#ifndef WIN32
			syslog(LOG_DAEMON | LOG_ALERT,msg);
#endif	WIN32
			}
		return(0);
		}
#endif
/*
	Seek to each record given in the xrefHdr table list. Copy each record from the buff area
	and increment buff by the sizeof each record.
*/
lockCount = 0;
numRecords = 0;
if(dbLockTest(120))
  {
    for(i = 0; i < DBC_MAX_TABLES;i++)
      {
	if(DBC_XREFTables[index].xrefHdrTables[i] == 0)
	  continue;
	for(j = 0;j < DBC_XREFTables[index].xrefRecCount[i]; j++)
	  {
	    namePtr = 0;
	    if(DBC_XREFTables[index].xrefHdrTables[i] == DBC_PvmapTable)
	      namePtr = name;
	    if(dbObtainRecord(DBC_XREFTables[index].xrefHdrTables[i]->table,namePtr) == 0)
	      {
		lockCount++;
		dbWriteLog(__FILE__,__LINE__,DBC_XREFTables[index].xrefHdrTables[i]->table,"NEW",0,name,buff);
		recptr = d4record(DBC_XREFTables[index].xrefHdrTables[i]->table);
		memcpy(recptr,buff,d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table));
		d4changed(DBC_XREFTables[index].xrefHdrTables[i]->table,1);
		d4flush_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
	      }
	    buff += d4record_width(DBC_XREFTables[index].xrefHdrTables[i]->table);
	    numRecords++;
	  }
#ifndef CB51
	DBC_XREFTables[index].xrefHdrTables[i]->table->file_lock = 1;
	d4update_header(DBC_XREFTables[index].xrefHdrTables[i]->table,1,1);
	DBC_XREFTables[index].xrefHdrTables[i]->table->file_lock = 0;
#endif
	d4unlock_all(DBC_XREFTables[index].xrefHdrTables[i]->table);
      }
    dbUnLock();
    return(1);
  }
return(0);			/* could not lock dbLock.lock file */
}
