/*DBCreateTable.c,v 1.1.1.1 1999/08/03 14:42:39 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			23-Mar-1994				      */
/*									      */
/*	Function Name:		DB_CreateTable				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	TableDesc - 	table name string	      */
/*				FieldArray - 	pointer to field def array    */
/*				TagArray - 	pointer to tag def array      */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	error:   0 table not mapped	      */
/*					success: TableHandle		      */
/*									      */
/*	Modification History:	23-Mar-1994	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>
DB_TABLE_PTR	DB_CreateTable(char *tabdesc,FIELD4INFO *FieldArray,TAG4INFO *TagArray)
{
DB_TABLE_PTR	temp;
char	name[MAXPATHLEN];
#ifndef WIN32
char buff[MAXPATHLEN];
int	linklen;
linklen = readlink(DB_Database.path,buff,MAXPATHLEN);		/* convert link to abs path if possible */
if(linklen < 0)
	sprintf(name,"%s/%s.dbf\0",DB_Database.path,tabdesc);	/* path not a link...just copy name */
else
	{
	buff[linklen] = '\0';					/* null terminate */
	sprintf(name,"%s/%s.dbf\0",buff,tabdesc);		/* 'buff' has fully resolved path...copy name */
	}
#else
	sprintf(name,"%s\\%s.dbf\0",DB_Database.path,tabdesc);	/* path not a link...just copy name */
#endif WIN32
if((temp = (DB_TABLE_PTR)malloc(sizeof(DB_TABLE))) == 0)
	return((DB_TABLE_PTR)0);				/* can't get memory then return 0 */
strcpy(temp -> table_name,name);
if((temp -> table = d4create(&DB_CodeBase,name,FieldArray,TagArray)) == 0)		/* create database */
	{
	free(temp);						/* if error then release memory and exit */
	return((DB_TABLE_PTR)0);
	}
d4unlock_all(temp -> table);
temp -> table_records = d4reccount(temp -> table);		/* get number of records in file */
temp -> table_fields = d4num_fields(temp -> table);		/* get number of fields in file */
temp -> tag = d4tag_next(temp -> table,0);			/* get the default tag for this table */
temp -> current_record = 0;					/* no current record until DB_Seek */
lstInit((LIST *)&temp->fields);					/* init field list */
/*
	Add to list of tables
*/
lstAdd((LIST *)&DB_Database.tables,(NODE *)temp);
return(temp);
}
