/*DBNewRecord.c,v 1.1.1.1 1999/08/03 14:42:40 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Jul-1993				      */
/*									      */
/*	Function Name:		DB_NewRecord				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	TableHandle	- pointer to table structure. */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	error		0 bad record	      */
/*					success:	record handle	      */
/*									      */
/*	Modification History:	20-Jul-1993	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>

DB_RECORD_PTR	DB_NewRecord(TableHandle,name)
DB_TABLE_PTR	TableHandle;
char			*name;
{
if (TableHandle == 0)
	return((DB_RECORD_PTR)0);
if(dbObtainRecord(TableHandle->table,name) < 0)
  return((DB_RECORD_PTR)0);
d4unlock_all(TableHandle->table);
d4flush_all(TableHandle->table);
#ifndef CB51
TableHandle->table->file_lock = 1;
d4update_header(TableHandle->table,1,1);
TableHandle->table->file_lock = 0;
#endif
TableHandle -> current_record = 1;
d4unlock_all(TableHandle->table);
return((DB_RECORD_PTR)1);
}
