/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			28-Feb-1994				      */
/*									      */
/*	Function Name:		DB_UnDeleteMulti			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	DB_TABLE_PTR	tbl			      */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	none.				      */
/*									      */
/*	Modification History:	08-Apr-1993	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>

int	DB_UnDeleteMulti(tbl,key)
DB_TABLE_PTR	tbl;
char		*key;
{
F4FIELD		*fptr;
char	*newkey,padkey[PVNAME_SZ+1];
if(!strlen(key))
	return(0);
fptr = d4field(tbl->table,"NAME");
sprintf(padkey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,key);
if(d4seek(tbl->table,padkey) == 0)
	{
	do
		{
		d4recall(tbl->table);			/* remove deletion mark */
		d4flush_all(tbl->table);
		if(d4skip(tbl->table,1) == 0)		/* skip to next record */
			newkey = f4str(fptr);
		else
			break;
		}
	while(!strcmp(padkey,newkey));
	d4flush_all(tbl->table);
	d4unlock_all(tbl->table);		/* un-lock everything */
	return(1);				/* record deleted */
	}
else
	return(0);				/* record not found */
}
