/*DBUseKey.c,v 1.1.1.1 1999/08/03 14:42:42 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			08-Feb-1993				      */
/*									      */
/*	Function Name:		DB_UseKey				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	NewKey		- New key to use	      */
/*				TableHandle	- pointer to table structure. */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	error		0 invalid key	      */
/*					success:	new key is set	      */
/*									      */
/*	Modification History:	08-Feb-1993	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>

int	DB_UseKey(TableHandle,NewKey)
DB_TABLE_PTR	TableHandle;
char		*NewKey;
{
T4TAG		*newtag;
if (TableHandle == 0)
	return(0);
if(NewKey == 0)				/* switch to record number ordering */
	{
	TableHandle -> tag = 0;
	d4tag_select(TableHandle -> table,0);
	return(1);
	}
if(strlen(NewKey) == 0)			/* NULL length key then ignore */
	return(1);
if((newtag = d4tag(TableHandle -> table,NewKey)) != 0)
	{
	TableHandle -> tag = newtag;
	d4tag_select(TableHandle -> table,newtag);
	return(1);
	}
return(0);
}
