/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#include <DBDefines.h>
#include <stdio.h>
#include <time.h>

extern	FILE	*dbLog;		/* Log file pointer */
extern	int	dbPid;		/* PID of current program */
extern	int	dbJournal;	/* verbosity level */
extern	char	dbPName[MAXPATHLEN];	/* program name from argv[0] */

void	dbWriteLog(char *who,int line,D4DATA *where,char *how,DB_FIELD_PTR what,char *pvptr,char *value)
{
char	*module,*tstr,*fname;
int	size;
DB_TABLE_PTR owner;
time_t	now = time(0);
if(dbLog == 0) return;
if(what)
	size = what->field_size;	/* if we have a field then use field width */
else
	size = d4record_width(where); /* else use record size */
if(value == 0) size = 1;
module = (char *)strrchr(who,'/') + 1;
tstr = (char *)ctime(&now);
tstr[strlen(tstr)-1] = 0;
fname = 0;				/* in case there is no field */
if(what)
  {
    owner = (DB_TABLE_PTR)what->owner;
    if((fname = (char *)strrchr(owner->table_name,'/')) == 0)
      fname = (char *)owner->table_name;
  }
else
  {
	fname = (char *)d4fileName(where);
  }
fprintf(dbLog,"%s %-10.10s %16.16s %4d %-6.6s %10s <%-28.28s> <%-10.10s> <%-*.*s>\n",
	tstr,				/* date & time of event */
	dbPName,			/* pid of calling task */
	module,				/* name of source module */
	line,				/* line number of this function */
	how,				/* db operation */
	(fname  ? fname : ""),     	/* file being written to */
	(pvptr ? pvptr : ""),		/* PV name...if given */
	(what ? what->field_name : ""),	/* field name being written/NULL if whole record */
	size,size,
	(value ? value : ""));		/* value converted to text or whole record */
}
