/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include	<stdio.h>
#include	<string.h>
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#include	"dbDefs.h"
#include	"dbRecType.h"
#include	"descDataTable.h"
#include	"fieldAttributes.h"
#include	"msgMon.h"

extern SPECL_PASS	udbpass;
extern UDBPVS_PTR	udbpvs;

extern typeDesc		**descTable;

double	special_1 (char *, short, char *, SPECL_CONTROL);
double	special_2 (char *, short, char *, SPECL_CONTROL);
double	special_3 (char *, short, char *, SPECL_CONTROL);
double	special_4 (char *, short, char *, SPECL_CONTROL);
double	special_5 (char *, short, char *, SPECL_CONTROL);
double	special_6 (char *, short, char *, SPECL_CONTROL);
double	special_7 (char *, short, char *, SPECL_CONTROL);
double	special_8 (char *, short, char *, SPECL_CONTROL);
double	special_9 (char *, short, char *, SPECL_CONTROL);
double	special_10 (char *, short, char *, SPECL_CONTROL);
double	special_11 (char *, short, char *, SPECL_CONTROL);
double	special_12 (char *, short, char *, SPECL_CONTROL);
double	special_13 (char *, short, char *, SPECL_CONTROL);
double	special_14 (char *, short, char *, SPECL_CONTROL);
double	special_15 (char *, short, char *, SPECL_CONTROL);
double	special_16 (char *, short, char *, SPECL_CONTROL);
double	special_17 (char *, short, char *, SPECL_CONTROL);
double	special_18 (char *, short, char *, SPECL_CONTROL);
double	special_19 (char *, short, char *, SPECL_CONTROL);
double	special_20 (char *, short, char *, SPECL_CONTROL);
double	special_21 (char *, short, char *, SPECL_CONTROL);
double	special_22 (char *, short, char *, SPECL_CONTROL);
double	special_23 (char *, short, char *, SPECL_CONTROL);
double	special_24 (char *, short, char *, SPECL_CONTROL);
double	special_25 (char *, short, char *, SPECL_CONTROL);
double	special_26 (char *, short, char *, SPECL_CONTROL);
double	special_27 (char *, short, char *, SPECL_CONTROL);
double	special_28 (char *, short, char *, SPECL_CONTROL);
double	special_29 (char *, short, char *, SPECL_CONTROL);
double	special_30 (char *, short, char *, SPECL_CONTROL);
double	special_31 (char *, short, char *, SPECL_CONTROL);
double	special_32 (char *, short, char *, SPECL_CONTROL);
double	special_33 (char *, short, char *, SPECL_CONTROL);

static void   addUdbIOPvname (char *);
static double getUdbIOPrec (FIELD4 *, int *);
static double getUdbIOValue (FIELD4 *, char *, char *, SPECL_CONTROL);

double	(*dbSpecials[])(char *, short, char *, SPECL_CONTROL) = {
	0,
	special_1,
	special_2,
	special_3,
	special_4,
	special_5,
	special_6,
	special_7,
	special_8,
	special_9,
	special_10,
	special_11,
	special_12,
	special_13,
	special_14,
	special_15,
	special_16,
	special_17,
	special_18,
	special_19,
	special_20,
	special_21,
	special_22,
	special_23,
	special_24,
	special_25,
	special_26,
	special_27,
	special_28,
	special_29,
	special_30,
	special_31,
	special_32,
	special_33
	};


/*********************************************************************************
*
*    special_1
*	for the VAL field of the accum block, see recAcc.c/get_graphic_double
*	and get_control_double
*
**********************************************************************************/

double	special_1 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*accumDb;
    FIELD4	*accumAFS;
    FIELD4	*accumHOPR;
    FIELD4	*accumLOPR;
    FIELD4	*accumMHPR;
    FIELD4	*accumMLPR;
    double	value = 0;
    char	dbPath[256];
    char	alrmsel[8];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_1: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (accumDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (accumDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_1: failed to find %s\n", pvname);
	return (value);
    }

    if ( (accumAFS = d4field (accumDb, "ALRMFLDSEL")) == 0)
    {
	tisSysLog (0,0,"special_1: cant find \"ALRMFLDSEL\" for %s\n", pvname);
	return (value);
    }

    memset (alrmsel, ' ', sizeof (alrmsel));
    strncpy (alrmsel, f4str (accumAFS), sizeof (alrmsel));
    alrmsel[sizeof (alrmsel)-1] = 0;
    FA_removeTrailingSpaces (alrmsel);

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ( (accumLOPR = d4field (accumDb, "DISPLOW")) == 0)
	    {
		tisSysLog (0,0,"special_1: cant find \"DISPLOW\" for %s\n", pvname);
		return (value);
	    }
	    if ( (accumMLPR = d4field (accumDb, "AVGDISPLO")) == 0)
	    {
		tisSysLog (0,0,"special_1: cant find \"AVGDISPLO\" for %s\n", pvname);
		return (value);
	    }
	    if ((strncmp (alrmsel, "TOTAL", 5)) == 0)
	    {
		value = f4double (accumLOPR);
	    }
	    else
	    {
		value = f4double (accumMLPR);
	    }
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (accumHOPR = d4field (accumDb, "DISPHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_1: cant find \"DISPHIGH\" for %s\n", pvname);
		return (value);
	    }
	    if ( (accumMHPR = d4field (accumDb, "AVGDISPHI")) == 0)
	    {
		tisSysLog (0,0,"special_1: cant find \"AVGDISPHI\" for %s\n", pvname);
		return (value);
	    }
	    if ((strncmp (alrmsel, "TOTAL", 5)) == 0)
	    {
		value = f4double (accumHOPR);
	    }
	    else
	    {
		value = f4double (accumMHPR);
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_1: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_2
*	get the precision for certain fields in the accum block, see 
*	recAcc.c/get_preicion
*
**********************************************************************************/

double	special_2 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*accumDb;
    FIELD4	*accumAFS;
    FIELD4	*accumPREC;
    FIELD4	*accumMPRE;
    double	value = 0;
    char	dbPath[256];
    char	alrmsel[8];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_2: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (accumDb = getFile (dbPath, pttype)) == 0)
	return (value);


    switch (type)
    {
	case SPECL_PREC:
	    if ( (d4seek (accumDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_2: failed to find %s\n", pvname);
		break;
	    }

	    if ( (accumAFS = d4field (accumDb, "ALRMFLDSEL")) == 0)
	    {
		tisSysLog (0,0,"special_2: cant find \"ALRMFLDSEL\" for %s\n", pvname);
		break;
	    }
	    if ( (accumPREC = d4field (accumDb, "PRECISION")) == 0)
	    {
		tisSysLog (0,0,"special_2: cant find \"PRECISION\" for %s\n", pvname);
		break;
	    }
	    if ( (accumMPRE = d4field (accumDb, "AVGPREC")) == 0)
	    {
		tisSysLog (0,0,"special_2: cant find \"AVGPREC\" for %s\n", pvname);
		break;
	    }
	    memset (alrmsel, ' ', sizeof (alrmsel));
	    strncpy (alrmsel, f4str (accumAFS), sizeof (alrmsel));
	    alrmsel[sizeof (alrmsel)-1] = 0;
	    FA_removeTrailingSpaces (alrmsel);

	    if ((strncmp (alrmsel, "TOTAL", 5)) == 0)
	    {
		value = f4double (accumPREC);
	    }
	    else
	    {
		value = f4double (accumMPRE);
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_2: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_3
*	get the graphic and control high values for certain fields in the accum
*	block see recAcc.c
*
**********************************************************************************/

double	special_3 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*accumDb;
    FIELD4	*accumAFS;
    FIELD4	*accumHOPR;
    FIELD4	*accumLOPR;
    FIELD4	*accumMHPR;
    FIELD4	*accumMLPR;
    double	value = 0;
    double	hopr;
    double	lopr;
    double	span;
    char	dbPath[256];
    char	alrmsel[8];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_3: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (accumDb = getFile (dbPath, pttype)) == 0)
	return (value);


    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (accumDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_3: failed to find %s\n", pvname);
		break;
	    }

	    if ( (accumAFS = d4field (accumDb, "ALRMFLDSEL")) == 0)
	    {
		tisSysLog (0,0,"special_3: cant find \"ALRMFLDSEL\" for %s\n", pvname);
		break;
	    }
	    memset (alrmsel, ' ', sizeof (alrmsel));
	    strncpy (alrmsel, f4str (accumAFS), sizeof (alrmsel));
	    alrmsel[sizeof (alrmsel)-1] = 0;
	    FA_removeTrailingSpaces (alrmsel);

	    if ( (accumLOPR = d4field (accumDb, "DISPLOW")) == 0)
	    {
		tisSysLog (0,0,"special_3: cant find \"DISPLOW\" for %s\n", pvname);
		break;
	    }
	    if ( (accumHOPR = d4field (accumDb, "DISPHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_3: cant find \"DISPHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (accumMHPR = d4field (accumDb, "AVGDISPHI")) == 0)
	    {
		tisSysLog (0,0,"special_3: cant find \"AVGDISPHI\" for %s\n", pvname);
		break;
	    }
	    if ( (accumMLPR = d4field (accumDb, "AVGDISPLO")) == 0)
	    {
		tisSysLog (0,0,"special_3: cant find \"AVGDISPLO\" for %s\n", pvname);
		break;
	    }
	    hopr = f4double (accumHOPR);
	    lopr = f4double (accumLOPR);
	    if ((strncmp(alrmsel, "TOTAL", 5)) != 0)
	    {
		hopr = f4double (accumMHPR);
		lopr = f4double (accumMLPR);
	    }
	    span = hopr - lopr;
	    if (span < 0.0)
		span = -span;
	    value = span;
	    break;

	default:
	    tisSysLog (0,0,"special_3: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_4
*	get display and control high for certain fields  for ai and ao
*	see recAi.c and recAo.c
*
**********************************************************************************/

double	special_4 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptEGUF;
    FIELD4	*ptEGUL;
    double	value = 0;
    double	span;
    double	eguf;
    double	egul;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_4: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_4: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptEGUF = d4field (ptDb, "EGUHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_4: cant find \"EGUHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (ptEGUL = d4field (ptDb, "EGULOW")) == 0)
	    {
		tisSysLog (0,0,"special_4: cant find \"EGULOW\" for %s\n", pvname);
		break;
	    }
	    eguf = f4double (ptEGUF);
	    egul = f4double (ptEGUL);
	    span = eguf - egul;
	    if (span < 0.0)
		span = -span;
	    value = span;
	    break;

	default:
	    tisSysLog (0,0,"special_4: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_5
*	get display and control high for certain fields for various point types
*
**********************************************************************************/

double	special_5 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptHOPR;
    FIELD4	*ptLOPR;
    double	value = 0;
    double	span;
    double	hopr;
    double	lopr;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_5: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_5: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptHOPR = d4field (ptDb, "DISPHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_5: cant find \"DISPHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (ptLOPR = d4field (ptDb, "DISPLOW")) == 0)
	    {
		tisSysLog (0,0,"special_5: cant find \"DISPLOW\" for %s\n", pvname);
		break;
	    }
	    hopr = f4double (ptHOPR);
	    lopr = f4double (ptLOPR);
	    span = hopr - lopr;
	    if (span < 0.0)
		span = -span;
	    value = span;
	    break;

	default:
	    tisSysLog (0,0,"special_5: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_6
*	get display low and high for the RVAL field in ai and ao point types
*
**********************************************************************************/

double	special_6 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptHOPR;
    FIELD4	*ptLOPR;
    FIELD4	*ptBOARDTYPE;
    double	value = 0;
    char	dbPath[256];
    char	bdtype[25];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_6: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_6: failed to find %s in %s\n", pvname, pstr);
	return (value);
    }
    if ( (ptBOARDTYPE = d4field (ptDb, "BOARDTYPE")) == 0)
    {
	tisSysLog (0,0,"special_6: cant find \"BOARDTYPE\" for %s\n", pvname);
	return (value);
    }
    memset (bdtype, ' ', sizeof (bdtype));
    strncpy (bdtype, f4str (ptBOARDTYPE), sizeof (bdtype));
    bdtype[sizeof(bdtype)-1] = 0;
    FA_removeTrailingSpaces (bdtype);

    switch (type)
    {
	case SPECL_DISPLOW:
	    if ( ((strncmp (bdtype, "CONSTANT", 8)) == 0) ||
		 ((strncmp (bdtype, "REFERENCE", 9)) == 0) )
	    {
		if ( (ptLOPR = d4field (ptDb, "DISPLOW")) == 0)
		{
		    tisSysLog (0,0,"special_6: cant find \"DISPLOW\" for %s\n", pvname);
		    break;
		}
		value = f4double (ptLOPR);
	    }
	    else
	    {
		value = 0;
	    }
	    break;

	case SPECL_DISPHIGH:
	    if ( ((strncmp (bdtype, "CONSTANT", 8)) == 0) ||
		 ((strncmp (bdtype, "REFERENCE", 9)) == 0) )
	    {
		if ( (ptHOPR = d4field (ptDb, "DISPHIGH")) == 0)
		{
		    tisSysLog (0,0,"special_6: cant find \"DISPHIGH\" for %s\n", pvname);
		    break;
		}
		value = f4double (ptHOPR);
	    }
	    else
	    {
		value = 65535;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_6: illegal type %d\n", type);
	    break;
    }
    return (value);
}


/*********************************************************************************
*
*    special_7
*	get display and control high for IDEV in the ai point
*
**********************************************************************************/

double	special_7 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptIRHI;
    FIELD4	*ptIRLO;
    double	value = 0;
    double	span;
    double	irhi;
    double	irlo;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_7: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_7: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptIRHI = d4field (ptDb, "IRHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_7: cant find \"IRHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (ptIRLO = d4field (ptDb, "IRLOW")) == 0)
	    {
		tisSysLog (0,0,"special_7: cant find \"IRLOW\" for %s\n", pvname);
		break;
	    }
	    irhi = f4double (ptIRHI);
	    irlo = f4double (ptIRLO);
	    span = irhi - irlo;
	    if (span < 0.0)
		span = -span;
	    value = span;
	    break;

	default:
	    tisSysLog (0,0,"special_7: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_8
*	get display and control high for OGAP in the ao point
*
**********************************************************************************/

double	special_8 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptDRVH;
    FIELD4	*ptDRVL;
    double	value = 0;
    double	span;
    double	drvh;
    double	drvl;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_8: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_8: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptDRVH = d4field (ptDb, "DRIVEHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_8: cant find \"DRIVEHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (ptDRVL = d4field (ptDb, "DRIVELOW")) == 0)
	    {
		tisSysLog (0,0,"special_8: cant find \"DRIVELOW\" for %s\n", pvname);
		break;
	    }
	    drvh = f4double (ptDRVH);
	    drvl = f4double (ptDRVL);
	    span = drvh - drvl;
	    if (span < 0.0)
		span = -span;
	    value = span;
	    break;

	default:
	    tisSysLog (0,0,"special_8: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_9
*	get total number of steps for the DDC block for its display and 
*	control high values
*
**********************************************************************************/

double	special_9 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptNUMW;
    FIELD4	*ptDSCD;
    double	value = 0;
    double	totSteps = 0;
    char	dbPath[256];
    char	pvName[PVNAME_SZ + 1];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_10: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    strncpy (pvName, pvname, PVNAME_SZ);
    pvName[PVNAME_SZ] = 0;

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (ptNUMW = d4field (ptDb, "NUMOUTWRDS")) == 0)
	    {
		tisSysLog (0,0,"special_9: cant find \"NUMOUTWRDS\" for %s\n", pvname);
		break;
	    }
	    if ( (ptDSCD = d4field (ptDb, "DWNCASCADE")) == 0)
	    {
		tisSysLog (0,0,"special_9: cant find \"DWNCASCADE\" for %s\n", pvname);
		break;
	    }
	    while (1)
	    {
		if ( (d4seek (ptDb, pvName)) != 0)
		{
		    tisSysLog (0,0,"special_9: failed to find %s in %s\n", pvName, pstr);
		    return (value);
		}
		totSteps += f4double (ptNUMW);
		memset (pvName, ' ', sizeof (pvName));
		strncpy (pvName, f4str (ptDSCD), PVNAME_SZ);
		pvName[PVNAME_SZ] = 0;
		FA_removeTrailingSpaces (pvName);
		if ( (pvName[0] == 0) || (pvName[0] == ' ') )
		    break;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_9: illegal type %d\n", type);
	    break;
    }

    value = totSteps;

    return (value);
}


/*********************************************************************************
*
*    special_10
*	get display high for CTOT in the deadtime point
*
**********************************************************************************/

double	special_10 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptHOPR;
    FIELD4	*ptDETS;
    double	value = 0;
    double	hopr;
    double	dets;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_10: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_10: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptHOPR = d4field (ptDb, "DISPHIGH")) == 0)
	    {
		tisSysLog (0,0,"special_10: cant find \"DISPHIGH\" for %s\n", pvname);
		break;
	    }
	    if ( (ptDETS = d4field (ptDb, "DELAYSCANS")) == 0)
	    {
		tisSysLog (0,0,"special_10: cant find \"DELAYSCANS\" for %s\n", pvname);
		break;
	    }
	    hopr = f4double (ptHOPR);
	    dets = f4double (ptDETS);
	    value = hopr * dets;
	    break;

	default:
	    tisSysLog (0,0,"special_10: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_11
*	get default display high and default control high for the ldfw1 block
*	based on the number of pumps they have entered
*
**********************************************************************************/

double	special_11 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptPump;
    double	value = 0;
    int		numPumps = 0;
    int		i;
    char	dbPath[256];
    char	dbPumpField[16];
    char	*pstr;
    char	pumpName[PVNAME_SZ + 1];

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_11: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_11: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    for (i = 1; i <= 20; i++)
	    {
		sprintf (dbPumpField, "PUMP%d", i);
		if ( (ptPump = d4field (ptDb, dbPumpField)) == 0)
		{
		    tisSysLog (0,0,"special_11: cant find \"%s\" for %s\n", 
			     dbPumpField, pvname);
		    return (value);
		}
		memset (pumpName, ' ', sizeof (pumpName));
		strncpy (pumpName, f4str (ptPump), sizeof (pumpName));
		pumpName[PVNAME_SZ] = 0;
		FA_removeTrailingSpaces (pumpName);
		if ( (pumpName[0] != 0) && (pumpName[0] != ' ') )
		    numPumps++;
	    }
	    value = numPumps;
	    break;

	default:
	    tisSysLog (0,0,"special_11: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_12
*	get default display precision for the ldfw2 block
*
**********************************************************************************/

double	special_12 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptPrec;
    double	value = 0;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_12: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_PREC:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_12: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (strncmp (fldname, "PSPD", 4)) == 0)
	    {
		if ( (ptPrec = d4field (ptDb, "PRECISION")) == 0)
		{
		    tisSysLog (0,0,"special_12: cant find \"PRECISION\" for %s\n", pvname);
		    return (value);
		}
		value = f4double (ptPrec);
	    }
	    else
		value = 0;
	    break;

	default:
	    tisSysLog (0,0,"special_12: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_13
*	get display low and high for RVAL field of the PAT block
*
**********************************************************************************/

double	special_13 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptSTIM;
    double	value = 0;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_13: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_13: failed to find %s in %s\n", pvname, pstr);
	return (value);
    }

    if ( (ptSTIM = d4field (ptDb, "STROKETIME")) == 0)
    {
	tisSysLog (0,0,"special_13: cant find \"STROKETIME\" for %s\n", pvname);
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	    value = -(f4double (ptSTIM) * vxTicksPerSecond);
	    break;

	case SPECL_DISPHIGH:
	    value = f4double (ptSTIM) * vxTicksPerSecond;
	    break;

	default:
	    tisSysLog (0,0,"special_13: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_14
*	get display low and control low for some PID fields
*
**********************************************************************************/

double	special_14 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptVELO;
    double	value = 0;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_14: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_14: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptVELO = d4field (ptDb, "INCREMENTL")) == 0)
	    {
		tisSysLog (0,0,"special_14: cant find \"INCREMENTL\" for %s\n", pvname);
		break;
	    }
	    /* if FALSE, then value is 0, in recPid VELO is compared to
	       PID_POSITIONAL which has a value of 0 (FALSE)
	    */
	    if (f4char (ptVELO) == 'T')
		value = -100;
	    break;

	default:
	    tisSysLog (0,0,"special_14: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_15
*	get display high and control high for TTIM field in PIPE record
*
**********************************************************************************/

double	special_15 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptTSET;
    double	value = 0;
    double	tset;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_15: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);
    switch (type)
    {
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_15: failed to find %s in %s\n", pvname, pstr);
		break;
	    }

	    if ( (ptTSET = d4field (ptDb, "SETTLETIME")) == 0)
	    {
		tisSysLog (0,0,"special_15: cant find \"SETTLETIME\" for %s\n", pvname);
		break;
	    }

	    tset = f4double (ptTSET);
	    if (tset > 0)
		value = tset;
	    else
		value = 86400;
	    break;

	default:
	    tisSysLog (0,0,"special_15: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_16
*	get control values for the CPRE field for the pipe
*	if the PRESSURE PV name exists, look it up in pvmap to get
*	its pt type, then get its HOPR/LOPR from its pt type database
*	if HOPR/LOPR does not exist then take defaults
*	remember to seek back to the original record in pvmap before leaving
*	this function
*
**********************************************************************************/

double	special_16 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*pipeVars;
    TAG4	*pipeVarsTag;
    FIELD4	*varNameFld;
    DATA4	*varDb;
    FIELD4	*varHOPR;
    FIELD4	*varLOPR;
    char	dbPath[256];
    char	key[256];
    char	varName[PVNAME_SZ + 1];
    char	varPtypeStr[15];
    char	*pstr;
    int		pvexists;
    int		i;
    short	varPtype;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_16: pt type %d not found\n",pttype);
	return (value);
    }
    if ((strncmp (pstr, "pipe", 4)) != 0)
    {
	tisSysLog (0,0,"special_16: pttype %d is not a pipe\n", pttype);
	return (value);
    }
    sprintf (dbPath, "%spipevars", FA_DATABASEPATH);
    if ( (pipeVars = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (pipeVarsTag = d4tag (pipeVars, "NAMEID")) == 0)
    {
	tisSysLog (0,0,"special_16: d4tag failed for \"NAMEID\"\n");
	return (value);
    }
    d4tag_select (pipeVars, pipeVarsTag);
    if ((varNameFld = d4field (pipeVars, "VARNAME")) == 0)
    {
	tisSysLog (0,0,"special_16: failed to find \"VARNAME\" in %s for %s\n", dbPath,pvname);
	return (value);
    }
    sprintf (key, "%-*.*sPressure PV", PVNAME_SZ, PVNAME_SZ, pvname);

    pvexists = 0;

    /* look in pipevars.dbf for the PRESSURE PV, if it exists */
    if ((d4seek (pipeVars, key)) == 0)
    {
	strncpy (varName, f4str (varNameFld), PVNAME_SZ);
	varName[PVNAME_SZ] = 0;
	FA_removeTrailingSpaces (varName);
	if ((pstr = strrchr (varName, '.')) != NULL)
	    *pstr = 0;
	/* now seek for this record in pvmap to get it pttype */
	if ( (d4seek (FA_Pvmap, varName)) == 0)
	{
	    memset (varPtypeStr, ' ', sizeof (varPtypeStr));
	    strncpy (varPtypeStr, f4str (FA_PvmapTYPE), sizeof (varPtypeStr));
	    varPtypeStr[sizeof (varPtypeStr)-1] = 0;
	    FA_removeTrailingSpaces (varPtypeStr);
	    sprintf (dbPath, "%s%s", FA_DATABASEPATH, varPtypeStr);
	    varPtype = 0;
	    /* now look through pt type string array to get the
	       pt types index
	    */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0);
		    continue;
		if ((strcmp (varPtypeStr, dbRecType -> papName[i])) == 0)
		{
		    varPtype = i;
		    break;
		}
	    }
	    /* find this record in the pts database */
	    if (varPtype > 0)
	    {
		if ( (varDb = getFile (dbPath, varPtype)) != 0)
		{
		    if ((d4seek (varDb, varName)) == 0)
		    {
			pvexists = 1;
		    }
		}
	    }
	}
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
		if (pvexists)
		{
		    /* if LOPR field does not exist, take default */
		    if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
			break;
		    value = f4double (varLOPR);
		}
		else
		{
		    value = 0;
		}
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
		if (pvexists)
		{
		    /* if HOPR field does not exist, take default */
		    if ((varHOPR = d4field (varDb, "DISPHIGH")) == 0)
		    {
			value = 1000000;
			break;
		    }
		    value = f4double (varHOPR);
		}
		else
		{
		    value = 1000000;
		}
	    break;

	default:
	    tisSysLog (0,0,"special_16: illegal type %d\n", type);
	    break;
    }

    /* reset pvmap back to the original record */
    d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_17
*	get control values for the CTEM field for the pipe
*	if the TEMPERATURE PV name exists, look it up in pvmap to get
*	its pt type, then get its HOPR/LOPR from its pt type database
*	if HOPR/LOPR does not exist then take defaults
*	remember to seek back to the original record in pvmap before leaving
*	this function
*
**********************************************************************************/

double	special_17 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*pipeVars;
    TAG4	*pipeVarsTag;
    FIELD4	*varNameFld;
    DATA4	*varDb;
    FIELD4	*varHOPR;
    FIELD4	*varLOPR;
    char	dbPath[256];
    char	key[256];
    char	varName[PVNAME_SZ + 1];
    char	varPtypeStr[15];
    char	*pstr;
    int		pvexists;
    int		i;
    short	varPtype;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_17: pt type %d not found\n",pttype);
	return (value);
    }
    if ((strncmp (pstr, "pipe", 4)) != 0)
    {
	tisSysLog (0,0,"special_17: pttype %d is not a pipe\n", pttype);
	return (value);
    }
    sprintf (dbPath, "%spipevars", FA_DATABASEPATH);
    if ( (pipeVars = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (pipeVarsTag = d4tag (pipeVars, "NAMEID")) == 0)
    {
	tisSysLog (0,0,"special_17: d4tag failed for \"NAMEID\"\n");
	return (value);
    }
    d4tag_select (pipeVars, pipeVarsTag);
    if ((varNameFld = d4field (pipeVars, "VARNAME")) == 0)
    {
	tisSysLog (0,0,"special_17: failed to find \"VARNAME\" in %s for %s\n", dbPath,pvname);
	return (value);
    }
    sprintf (key, "%-*.*sTemp PV", PVNAME_SZ, PVNAME_SZ, pvname);

    pvexists = 0;

    /* look in pipevars.dbf for the TEMPERATURE PV, if it exists */
    if ((d4seek (pipeVars, key)) == 0)
    {
	strncpy (varName, f4str (varNameFld), PVNAME_SZ);
	varName[PVNAME_SZ] = 0;
	FA_removeTrailingSpaces (varName);
	if ((pstr = strrchr (varName, '.')) != NULL)
	    *pstr = 0;
	/* now seek for this record in pvmap to get it pttype */
	if ( (d4seek (FA_Pvmap, varName)) == 0)
	{
	    memset (varPtypeStr, ' ', sizeof (varPtypeStr));
	    strncpy (varPtypeStr, f4str (FA_PvmapTYPE), sizeof (varPtypeStr));
	    varPtypeStr[sizeof (varPtypeStr)-1] = 0;
	    FA_removeTrailingSpaces (varPtypeStr);
	    sprintf (dbPath, "%s%s", FA_DATABASEPATH, varPtypeStr);
	    varPtype = 0;
	    /* now look through pt type string array to get the
	       pt types index
	    */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0);
		    continue;
		if ((strcmp (varPtypeStr, dbRecType -> papName[i])) == 0)
		{
		    varPtype = i;
		    break;
		}
	    }
	    /* find this record in the pts database */
	    if (varPtype > 0)
	    {
		if ( (varDb = getFile (dbPath, varPtype)) != 0)
		{
		    if ((d4seek (varDb, varName)) == 0)
		    {
			pvexists = 1;
		    }
		}
	    }
	}
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
		if (pvexists)
		{
		    /* if LOPR field does not exist, take default */
		    if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
			break;
		    value = f4double (varLOPR);
		}
		else
		{
		    value = 0;
		}
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
		if (pvexists)
		{
		    /* if HOPR field does not exist, take default */
		    if ((varHOPR = d4field (varDb, "DISPHIGH")) == 0)
		    {
			value = 300;
			break;
		    }
		    value = f4double (varHOPR);
		}
		else
		{
		    value = 300;
		}
	    break;

	default:
	    tisSysLog (0,0,"special_17: illegal type %d\n", type);
	    break;
    }

    /* reset pvmap back to the original record */
    d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_18
*	get control values for certain fields in the POT record
*	if the CUSTODY PV name exists, look it up in pvmap to get
*	its pt type, then get its HOPR/LOPR from its pt type database
*	if HOPR/LOPR does not exist then take defaults
*	remember to seek back to the original record in pvmap before leaving
*	this function
*
**********************************************************************************/

double	special_18 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*potVars;
    TAG4	*potVarsTag;
    FIELD4	*varNameFld;
    DATA4	*varDb;
    FIELD4	*varHOPR;
    FIELD4	*varLOPR;
    char	dbPath[256];
    char	key[256];
    char	varName[PVNAME_SZ + 1];
    char	varPtypeStr[15];
    char	*pstr;
    int		i;
    int		pvexists;
    short	varPtype;
    double	value = 0;
    double	hopr;
    double	lopr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_18: pt type %d not found\n",pttype);
	return (value);
    }
    if ((strncmp (pstr, "pot", 3)) != 0)
    {
	tisSysLog (0,0,"special_18: pttype %d is not a pot\n", pttype);
	return (value);
    }
    sprintf (dbPath, "%spotvars", FA_DATABASEPATH);
    if ( (potVars = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (potVarsTag = d4tag (potVars, "NAMEID")) == 0)
    {
	tisSysLog (0,0,"special_18: d4tag failed for \"NAMEID\"\n");
	return (value);
    }
    d4tag_select (potVars, potVarsTag);
    if ((varNameFld = d4field (potVars, "VARNAME")) == 0)
    {
	tisSysLog (0,0,"special_18: failed to find \"VARNAME\" in %s for %s\n", dbPath,pvname);
	return (value);
    }
    sprintf (key, "%-*.*sCustody PV", PVNAME_SZ, PVNAME_SZ, pvname);

    pvexists = 0;

    /* look in potvars.dbf for the CUSTODY PV, if it exists */
    if ((d4seek (potVars, key)) == 0)
    {
	strncpy (varName, f4str (varNameFld), PVNAME_SZ);
	varName[PVNAME_SZ] = 0;
	FA_removeTrailingSpaces (varName);
	if ((pstr = strrchr (varName, '.')) != NULL)
	    *pstr = 0;
	/* now seek for this record in pvmap to get it pttype */
	if ( (d4seek (FA_Pvmap, varName)) == 0)
	{
	    memset (varPtypeStr, ' ', sizeof (varPtypeStr));
	    strncpy (varPtypeStr, f4str (FA_PvmapTYPE), sizeof (varPtypeStr));
	    varPtypeStr[sizeof (varPtypeStr)-1] = 0;
	    FA_removeTrailingSpaces (varPtypeStr);
	    sprintf (dbPath, "%s%s", FA_DATABASEPATH, varPtypeStr);
	    varPtype = 0;
	    /* now look through pt type string array to get the
	       pt types index
	    */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0);
		    continue;
		if ((strcmp (varPtypeStr, dbRecType -> papName[i])) == 0)
		{
		    varPtype = i;
		    break;
		}
	    }
	    /* find this record in the pts database */
	    if (varPtype > 0)
	    {
		if ( (varDb = getFile (dbPath, varPtype)) != 0)
		{
		    if ((d4seek (varDb, varName)) == 0)
		    {
			pvexists = 1;
		    }
		}
	    }
	}
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
		if (pvexists)
		{
		    /* if LOPR field does not exist, take default */
		    if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
			break;
		    value = f4double (varLOPR);
		}
		else
		{
		    value = 0;
		}
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
		if (pvexists)
		{
		    /* if LOPR field does not exist, take default */
		    if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
		    {
			value = 1000000;
			break;
		    }
		    /* if HOPR field does not exist, take default */
		    if ((varHOPR = d4field (varDb, "DISPHIGH")) == 0)
		    {
			value = 1000000;
			break;
		    }
		    hopr = f4double (varHOPR);
		    lopr = f4double (varLOPR);
		    value = hopr - lopr;
		}
		else
		{
		    value = 1000000;
		}
	    break;

	default:
	    tisSysLog (0,0,"special_18: illegal type %d\n", type);
	    break;
    }

    /* reset pvmap back to the original record */
    d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_19
*	get display high  TTIM field in PUMP record
*
**********************************************************************************/

double	special_19 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptEXON;
    FIELD4	*ptEXOF;
    FIELD4	*ptSADB;
    FIELD4	*ptSTDB;
    double	value = 0;
    double	on_time = 0;
    double	off_time = 0;
    double	exon = 0;
    double	exof = 0;
    double	sadb = 0;
    double	stdb = 0;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_19: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "pump", 4)) != 0)
    {
	tisSysLog (0,0,"special_19: pttype %d is not a pump\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_19: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptEXON = d4field (ptDb, "STARTTIME")) == 0)
	    {
		tisSysLog (0,0,"special_19: cant find \"STARTTIME\" for %s\n", pvname);
		break;
	    }
	    if ( (ptEXOF = d4field (ptDb, "STOPTIME")) == 0)
	    {
		tisSysLog (0,0,"special_19: cant find \"STOPTIME\" for %s\n", pvname);
		break;
	    }
	    if ( (ptSADB = d4field (ptDb, "STARTDBPCT")) == 0)
	    {
		tisSysLog (0,0,"special_19: cant find \"STARTDBPCT\" for %s\n", pvname);
		break;
	    }
	    if ( (ptSTDB = d4field (ptDb, "STOPDBPCT")) == 0)
	    {
		tisSysLog (0,0,"special_19: cant find \"STOPDBPCT\" for %s\n", pvname);
		break;
	    }
	    exon = f4double (ptEXON);
	    exof = f4double (ptEXOF);
	    sadb = f4double (ptSADB);
	    stdb = f4double (ptSTDB);
	    on_time = exon + ((exon * sadb) / 100.0);
	    off_time = exof + ((exof * stdb) / 100.0);
	    value = (on_time > off_time) ? on_time : off_time;
	    break;

	default:
	    tisSysLog (0,0,"special_19: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_20
*	get display/control values for certain temperature fields in the TANK 
*	record. use the average temperature pv TMPP if it exists, else use the
*	1st temperature probe T01V if it exists, else use defaults
*	remember to seek back to the original record in pvmap before leaving
*	this function
*
**********************************************************************************/

double	special_20 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*tankVars;
    TAG4	*tankVarsTag;
    FIELD4	*varNameFld;
    DATA4	*tankPrbs;
    TAG4	*tankPrbsTag;
    FIELD4	*prbNameFld;
    DATA4	*varDb;
    FIELD4	*varHOPR;
    FIELD4	*varLOPR;
    char	dbPath[256];
    char	key[256];
    char	pvName[PVNAME_SZ + 1];
    char	pvPtypeStr[15];
    char	*pstr;
    int		i;
    int		pvexists;
    short	pvPtype;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_20: pt type %d not found\n",pttype);
	return (value);
    }
    if ((strncmp (pstr, "tank", 4)) != 0)
    {
	tisSysLog (0,0,"special_20: pttype %d is not a tank\n", pttype);
	return (value);
    }
    sprintf (dbPath, "%stankvars", FA_DATABASEPATH);
    if ( (tankVars = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (tankVarsTag = d4tag (tankVars, "NAMEID")) == 0)
    {
	tisSysLog (0,0,"special_20: d4tag failed for \"NAMEID\" in tankvars\n");
	return (value);
    }
    d4tag_select (tankVars, tankVarsTag);
    if ((varNameFld = d4field (tankVars, "VARNAME")) == 0)
    {
	tisSysLog (0,0,"special_20: failed to find \"VARNAME\" in %s for %s\n", dbPath,pvname);
	return (value);
    }
    sprintf (key, "%-*.*sAvg Temp PV", PVNAME_SZ, PVNAME_SZ, pvname);

    pvexists = 0;

    if ((d4seek (tankVars, key)) == 0)
    {
	strncpy (pvName, f4str (varNameFld), PVNAME_SZ);
	pvName[PVNAME_SZ] = 0;
	FA_removeTrailingSpaces (pvName);
	if ((pstr = strrchr (pvName, '.')) != NULL)
	    *pstr = 0;
	pvexists = 1;
    }
    else
    {
	sprintf (dbPath, "%stankprbs", FA_DATABASEPATH);
	if ( (tankPrbs = getFile (dbPath, pttype)) == 0)
	    return (value);

	if ( (tankPrbsTag = d4tag (tankPrbs, "NAMEID")) == 0)
	{
	    tisSysLog (0,0,"special_20: d4tag failed for \"NAMEID\" in tankprbs\n");
	    return (value);
	}
	d4tag_select (tankPrbs, tankPrbsTag);
	if ((prbNameFld = d4field (tankPrbs, "PROBENAME")) == 0)
	{
	    tisSysLog (0,0,"special_20: failed to find \"PROBENAME\" in %s for %s\n", dbPath,pvname);
	    return (value);
	}
	/* the 1 in the sprintf is the 1st probeid number to complete the key */
	sprintf (key, "%-*.*s1", PVNAME_SZ, PVNAME_SZ, pvname);
	if ((d4seek (tankPrbs, key)) == 0)
	{
	    strncpy (pvName, f4str (prbNameFld), PVNAME_SZ);
	    pvName[PVNAME_SZ] = 0;
	    FA_removeTrailingSpaces (pvName);
	    if ((pstr = strrchr (pvName, '.')) != NULL)
		*pstr = 0;
	    pvexists = 1;
	}
    }
    if (pvexists)
    {
	pvexists = 0;
	/* now seek for this record in pvmap to get it pttype */
	if ( (d4seek (FA_Pvmap, pvName)) == 0)
	{
	    memset (pvPtypeStr, ' ', sizeof (pvPtypeStr));
	    strncpy (pvPtypeStr, f4str (FA_PvmapTYPE), sizeof (pvPtypeStr));
	    pvPtypeStr[sizeof (pvPtypeStr)-1] = 0;
	    FA_removeTrailingSpaces (pvPtypeStr);
	    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pvPtypeStr);
	    pvPtype = 0;
	    /* now look through pt type string array to get the
	       pt types index
	    */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0);
		    continue;
		if ((strcmp (pvPtypeStr, dbRecType -> papName[i])) == 0)
		{
		    pvPtype = i;
		    break;
		}
	    }
	    /* find this record in the pts database */
	    if (pvPtype > 0)
	    {
		if ( (varDb = getFile (dbPath, pvPtype)) != 0)
		{
		    if ((d4seek (varDb, pvName)) == 0)
		    {
			pvexists = 1;
		    }
		}
	    }
	}
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if (pvexists)
	    {
		/* if the LOPR field does not exist, take the default */
		if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
		    break;
		value = f4double (varLOPR);
	    }
	    else
	    {
		value = 0;
	    }
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if (pvexists)
	    {
		/* if the HOPR field does not exist, take the default */
		if ((varHOPR = d4field (varDb, "DISPHIGH")) == 0)
		{
		    value = 300;
		}
		else
		{
		    value = f4double (varHOPR);
		}
	    }
	    else
	    {
		value = 300;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_20: illegal type %d\n", type);
	    break;
    }

    /* reset pvmap back to the original record */
    d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_21
*	get display/control values for certain the DNCT field for the TANK.
*	if the DENSITY PV name exists, look it up in pvmap to get
*	its pt type, then get its HOPR/LOPR from its pt type database
*	if HOPR/LOPR does not exist then take defaults
*	remember to seek back to the original record in pvmap before leaving
*	this function
*
**********************************************************************************/

double	special_21 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*tankVars;
    TAG4	*tankVarsTag;
    FIELD4	*varNameFld;
    DATA4	*varDb;
    FIELD4	*varHOPR;
    FIELD4	*varLOPR;
    char	dbPath[256];
    char	key[256];
    char	varName[PVNAME_SZ + 1];
    char	varPtypeStr[15];
    char	*pstr;
    int		i;
    int		pvexists;
    short	varPtype;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_21: pt type %d not found\n",pttype);
	return (value);
    }
    if ((strncmp (pstr, "tank", 4)) != 0)
    {
	tisSysLog (0,0,"special_21: pttype %d is not a tank\n", pttype);
	return (value);
    }
    sprintf (dbPath, "%stankvars", FA_DATABASEPATH);
    if ( (tankVars = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (tankVarsTag = d4tag (tankVars, "NAMEID")) == 0)
    {
	tisSysLog (0,0,"special_21: d4tag failed for \"NAMEID\"\n");
	return (value);
    }
    d4tag_select (tankVars, tankVarsTag);
    if ((varNameFld = d4field (tankVars, "VARNAME")) == 0)
    {
	tisSysLog (0,0,"special_21: failed to find \"VARNAME\" in %s for %s\n", dbPath,pvname);
	return (value);
    }
    sprintf (key, "%-*.*sDensity PV", PVNAME_SZ, PVNAME_SZ, pvname);

    pvexists = 0;

    /* look in tankvars.dbf for the DENSITY PV, if it exists */
    if ((d4seek (tankVars, key)) == 0)
    {
	strncpy (varName, f4str (varNameFld), PVNAME_SZ);
	varName[PVNAME_SZ] = 0;
	FA_removeTrailingSpaces (varName);
	if ((pstr = strrchr (varName, '.')) != NULL)
	    *pstr = 0;
	/* now seek for this record in pvmap to get it pttype */
	if ( (d4seek (FA_Pvmap, varName)) == 0)
	{
	    memset (varPtypeStr, ' ', sizeof (varPtypeStr));
	    strncpy (varPtypeStr, f4str (FA_PvmapTYPE), sizeof (varPtypeStr));
	    varPtypeStr[sizeof (varPtypeStr)-1] = 0;
	    FA_removeTrailingSpaces (varPtypeStr);
	    sprintf (dbPath, "%s%s", FA_DATABASEPATH, varPtypeStr);
	    varPtype = 0;
	    /* now look through pt type string array to get the
	       pt types index
	    */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0);
		    continue;
		if ((strcmp (varPtypeStr, dbRecType -> papName[i])) == 0)
		{
		    varPtype = i;
		    break;
		}
	    }
	    /* find this record in the pts database */
	    if (varPtype > 0)
	    {
		if ( (varDb = getFile (dbPath, varPtype)) != 0)
		{
		    if ((d4seek (varDb, varName)) == 0)
		    {
			pvexists = 1;
		    }
		}
	    }
	}
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
		if (pvexists)
		{
		    /* if LOPR field does not exist, take default */
		    if ((varLOPR = d4field (varDb, "DISPLOW")) == 0)
			break;
		    value = f4double (varLOPR);
		}
		else
		{
		    value = 0;
		}
	    break;

	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
		if (pvexists)
		{
		    /* if HOPR field does not exist, take default */
		    if ((varHOPR = d4field (varDb, "DISPHIGH")) == 0)
		    {
			value = 1000000;
			break;
		    }
		    value = f4double (varHOPR);
		}
		else
		{
		    value = 1000000;
		}
	    break;

	default:
	    tisSysLog (0,0,"special_21: illegal type %d\n", type);
	    break;
    }

    /* reset pvmap back to the original record */
    d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_22
*	get display high TTIM field in TANK record
*
**********************************************************************************/

double	special_22 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptTSET;
    double	value = 0;
    double	tset;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_22: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "tank", 4)) != 0)
    {
	tisSysLog (0,0,"special_22: pttype %d is not a tank\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%stank2", FA_DATABASEPATH);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);


    switch (type)
    {
	case SPECL_DISPHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_22: failed to find %s in tank2\n", pvname);
		break;
	    }
	    if ( (ptTSET = d4field (ptDb, "TIME2SETTL")) == 0)
	    {
		tisSysLog (0,0,"special_22: cant find \"TIME2SETTL\" for %s\n", pvname);
		break;
	    }
	    tset = f4double (ptTSET);
	    if (tset > 0)
		value = tset;
	    else
		value = 86400;
	    break;

	default:
	    tisSysLog (0,0,"special_22: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_23
*	get display high VTIM field in TANK record
*
**********************************************************************************/

double	special_23 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptSTTO;
    FIELD4	*ptISTO;
    FIELD4	*ptRETO;
    FIELD4	*ptRUTO;
    double	value = 0;
    double	hopr;
    double	isto;
    double	reto;
    double	ruto;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_23: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "tank", 4)) != 0)
    {
	tisSysLog (0,0,"special_23: pttype %d is not a tank\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%stank2", FA_DATABASEPATH);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_23: failed to find %s in tank2\n", pvname);
		break;
	    }
	    if ( (ptSTTO = d4field (ptDb, "STOPTMO")) == 0)
	    {
		tisSysLog (0,0,"special_23: cant find \"STOPTMO\" for %s\n", pvname);
		break;
	    }

	    if ( (ptISTO = d4field (ptDb, "ISSUETMO")) == 0)
	    {
		tisSysLog (0,0,"special_23: cant find \"ISSUETMO\" for %s\n", pvname);
		break;
	    }

	    if ( (ptRETO = d4field (ptDb, "RECEIVETMO")) == 0)
	    {
		tisSysLog (0,0,"special_23: cant find \"RECEIVETMO\" for %s\n", pvname);
		break;
	    }

	    if ( (ptRUTO = d4field (ptDb, "RUNTMO")) == 0)
	    {
		tisSysLog (0,0,"special_23: cant find \"RUNTMO\" for %s\n", pvname);
		break;
	    }

	    hopr = f4double (ptSTTO);
	    isto = f4double (ptISTO);
	    if (isto > hopr)
		hopr = isto;
	    reto = f4double (ptRETO);
	    if (reto > hopr)
		hopr = reto;
	    ruto = f4double (ptRUTO);
	    if (ruto > hopr)
		hopr = ruto;
	    if (hopr > 0)
		value = hopr;
	    else
		value = 86400;
	    break;

	default:
	    tisSysLog (0,0,"special_23: illegal type %d\n", type);
	    break;
    }


    return (value);
}


/*********************************************************************************
*
*    special_24
*	get PRECISION for certain UDB point fields
*	the default precision as defined in .../share/src/rec/recUdb.c is 1
*
**********************************************************************************/

double	special_24 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1pr, *l2pr, *l3pr;
    FIELD4	*inv1, *inv2, *inv3, *inv4, *inv5, *inv6, *inv7, *inv8;
    FIELD4	*ovl1, *ovl2, *ovl3, *ovl4, *ovl5, *ovl6, *ovl7, *ovl8;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    int		seekpv = 0;
    double	prec1 = 0;
    double	prec2 = 0;
    double	prec3 = 0;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_24: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_24: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_24: failed to find %s in udb\n", pvname);
	return (value);
    }

    switch (type)
    {
	case SPECL_PREC:
	    if ((l1pr = d4field (ptDb, "LIM1PREC")) == 0)
	    {
		tisSysLog (0,0,"special_24: cant find \"LIM1PREC\" for %s\n", pvname);
		break;
	    }
	    if ((l2pr = d4field (ptDb, "LIM2PREC")) == 0)
	    {
		tisSysLog (0,0,"special_24: cant find \"LIM2PREC\" for %s\n", pvname);
		break;
	    }
	    if ((l3pr = d4field (ptDb, "LIM3PREC")) == 0)
	    {
		tisSysLog (0,0,"special_24: cant find \"LIM3PREC\" for %s\n", pvname);
		break;
	    }
	    prec1 = f4double (l1pr);
	    prec2 = f4double (l2pr);
	    prec3 = f4double (l3pr);
	    memset (limStr, 0, sizeof (limStr));

	    if ((strncmp (fldname, "N01", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N02", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM02\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N03", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM03")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM03\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N04", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM04")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM04\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N05", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM05")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM05\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N06", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM06")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM06\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N07", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM07")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM07\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N08", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM08")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM08\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N09", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM09")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM09\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N10", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM10")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM10\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N11", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM11")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM11\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "N12", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "FLOATLIM12")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"FLOATLIM12\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D01", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D02", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM02\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D03", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM03")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM03\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D04", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM04")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM04\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D05", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM05")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM05\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "D06", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "DBLLIM06")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"DBLLIM06\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "U01", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "ULONGLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"ULONGLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "U02", 3)) == 0)
	    {
		if ((limFld = d4field (ptDb, "ULONGLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"ULONGLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP01", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP02", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM02\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP03", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM03")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM03\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP04", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM04")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM04\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP05", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM05")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM05\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP06", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM06")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM06\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP07", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM07")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM07\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP08", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM08")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM08\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP09", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM09")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM09\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP10", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM10")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM10\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP11", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM11")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM11\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP12", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM12")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM12\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP13", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM13")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM13\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP14", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM14")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM14\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP15", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM15")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM15\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "FP16", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TFLTLIM16")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TFLTLIM16\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU01", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU02", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM02\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU03", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM03")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM03\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU04", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM04")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM04\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU05", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM05")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM05\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU06", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM06")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM06\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU07", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM07")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM07\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "LU08", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TULLIM08")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TULLIM08\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "DB01", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TDBLLIM01")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TDBLLIM01\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "DB02", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TDBLLIM02")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TDBLLIM02\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "DB03", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TDBLLIM03")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TDBLLIM03\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "DB04", 4)) == 0)
	    {
		if ((limFld = d4field (ptDb, "TDBLLIM04")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"TDBLLIM04\" for %s\n", pvname);
		    break;
		}
	    }
	    else if ((strncmp (fldname, "INV1", 4)) == 0)
	    {
		if ((inv1 = d4field (ptDb, "INPUT1")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT1\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv1, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV2", 4)) == 0)
	    {
		if ((inv2 = d4field (ptDb, "INPUT2")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT2\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv2, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV3", 4)) == 0)
	    {
		if ((inv3 = d4field (ptDb, "INPUT3")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT3\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv3, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV4", 4)) == 0)
	    {
		if ((inv4 = d4field (ptDb, "INPUT4")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT4\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv4, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV5", 4)) == 0)
	    {
		if ((inv5 = d4field (ptDb, "INPUT5")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT5\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv5, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV6", 4)) == 0)
	    {
		if ((inv6 = d4field (ptDb, "INPUT6")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT6\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv6, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV7", 4)) == 0)
	    {
		if ((inv7 = d4field (ptDb, "INPUT7")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT7\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv7, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "INV8", 4)) == 0)
	    {
		if ((inv8 = d4field (ptDb, "INPUT8")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"INPUT8\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (inv8, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL1", 4)) == 0)
	    {
		if ((ovl1 = d4field (ptDb, "OUTPUT1")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT1\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl1, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL2", 4)) == 0)
	    {
		if ((ovl2 = d4field (ptDb, "OUTPUT2")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT2\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl2, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL3", 4)) == 0)
	    {
		if ((ovl3 = d4field (ptDb, "OUTPUT3")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT3\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl3, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL4", 4)) == 0)
	    {
		if ((ovl4 = d4field (ptDb, "OUTPUT4")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT4\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl4, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL5", 4)) == 0)
	    {
		if ((ovl5 = d4field (ptDb, "OUTPUT5")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT5\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl5, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL6", 4)) == 0)
	    {
		if ((ovl6 = d4field (ptDb, "OUTPUT6")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT6\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl6, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL7", 4)) == 0)
	    {
		if ((ovl7 = d4field (ptDb, "OUTPUT7")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT7\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl7, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else if ((strncmp (fldname, "OVL8", 4)) == 0)
	    {
		if ((ovl8 = d4field (ptDb, "OUTPUT8")) == 0)
		{
		    tisSysLog (0,0,"special_24: cant find \"OUTPUT8\" for %s\n", pvname);
		    break;
		}
		value = getUdbIOPrec (ovl8, &seekpv);
		if (seekpv)
		    d4seek (FA_Pvmap, pvname);
		return (value);
	    }
	    else
		break;

	    break;

	default:
	    tisSysLog (0,0,"special_24: illegal type %d\n", type);
	    break;
    }

    if (limFld != 0)
    {
	strncpy (limStr, f4str (limFld), sizeof (limStr));
	limStr[sizeof(limStr)-1] = 0;
	FA_removeTrailingSpaces (limStr);
	if ( (strncmp (limStr, "0 - 100", 7)) == 0)
	    value = 1;
	else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
	    value = prec1;
	else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
	    value = prec2;
	else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
	    value = prec3;
    }

    /* if we had to seek in pvmap, make sure we go back to
       the original record
    */
    if (seekpv)
	d4seek (FA_Pvmap, pvname);
    return (value);
}


/*********************************************************************************
*
*    special_25
*	get the display and control limits for UDB floats N01-N12
*
**********************************************************************************/

double	special_25 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_25: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_25: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_25: failed to find %s in udb\n", pvname);
	return (value);
    }

    if ((strncmp (fldname, "N01", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N02", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N03", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM03")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM03\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N04", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM04")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM04\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N05", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM05")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM05\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N06", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM06")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM06\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N07", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM07")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM07\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N08", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM08")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM08\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N09", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM09")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM09\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N10", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM10")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM10\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N11", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM11")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM11\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "N12", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "FLOATLIM12")) == 0)
	{
	    tisSysLog (0,0,"special_25: cant find \"FLOATLIM12\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_25: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_25: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_26
*	get the display and control limits for UDB doubles D01-D06
*
**********************************************************************************/

double	special_26 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_26: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_26: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_26: failed to find %s in udb\n", pvname);
	return (value);
    }

    if ((strncmp (fldname, "D01", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "D02", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "D03", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM03")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM03\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "D04", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM04")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM04\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "D05", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM05")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM05\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "D06", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "DBLLIM06")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"DBLLIM06\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_26: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_27
*	get the display and control limits for UDB unsigned longs U01-U02
*
**********************************************************************************/

double	special_27 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_26: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_26: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ((strncmp (fldname, "U01", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "ULONGLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"ULONGLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "U02", 3)) == 0)
    {
	if ((limFld = d4field (ptDb, "ULONGLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_26: cant find \"ULONGLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_26: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_26: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_28
*	get the display and control limits for UDB temp floats FP01-FP16
*
**********************************************************************************/

double	special_28 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_28: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_28: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_28: failed to find %s in udb\n", pvname);
	return (value);
    }

    if ((strncmp (fldname, "FP01", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP02", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP03", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM03")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM03\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP04", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM04")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM04\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP05", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM05")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM05\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP06", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM06")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM06\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP07", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM07")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM07\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP08", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM08")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM08\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP09", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM09")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM09\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP10", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM10")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM10\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP11", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM11")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM11\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP12", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM12")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM12\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP13", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM13")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM13\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP14", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM14")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM14\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP15", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM15")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM15\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "FP16", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TFLTLIM16")) == 0)
	{
	    tisSysLog (0,0,"special_28: cant find \"TFLTLIM16\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_28: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_28: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_29
*	get the display and control limits for UDB temp unsigned longs LU01-LU08
*
**********************************************************************************/

double	special_29 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_29: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_29: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_29: failed to find %s in udb\n", pvname);
	return (value);
    }

    if ((strncmp (fldname, "LU01", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU02", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU03", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM03")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM03\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU04", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM04")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM04\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU05", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM05")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM05\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU06", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM06")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM06\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU07", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM07")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM07\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "LU08", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TULLIM08")) == 0)
	{
	    tisSysLog (0,0,"special_29: cant find \"TULLIM08\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_29: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_29: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_30
*	get the display and control limits for UDB temp doubles DB01-DB04
*
**********************************************************************************/

double	special_30 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*l1hi, *l1lo;
    FIELD4	*l2hi, *l2lo;
    FIELD4	*l3hi, *l3lo;
    FIELD4	*limFld = 0;
    char	dbPath[256];
    char	limStr[15];
    char	*pstr;
    double	lim1hi, lim1lo;
    double	lim2hi, lim2lo;
    double	lim3hi, lim3lo;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_30: pt type %d not found\n",pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_30: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if ( (d4seek (ptDb, pvname)) != 0)
    {
	tisSysLog (0,0,"special_30: failed to find %s in udb\n", pvname);
	return (value);
    }

    if ((strncmp (fldname, "DB01", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TDBLLIM01")) == 0)
	{
	    tisSysLog (0,0,"special_30: cant find \"TDBLLIM01\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "DB02", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TDBLLIM02")) == 0)
	{
	    tisSysLog (0,0,"special_30: cant find \"TDBLLIM02\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "DB03", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TDBLLIM03")) == 0)
	{
	    tisSysLog (0,0,"special_30: cant find \"TDBLLIM03\" for %s\n", pvname);
	    return (value);
	}
    }
    else if ((strncmp (fldname, "DB04", 4)) == 0)
    {
	if ((limFld = d4field (ptDb, "TDBLLIM04")) == 0)
	{
	    tisSysLog (0,0,"special_30: cant find \"TDBLLIM04\" for %s\n", pvname);
	    return (value);
	}
    }
    else
    {
	return (value);
    }

    switch (type)
    {
	case SPECL_DISPLOW:
	case SPECL_CTRLOW:
	    if ((l1lo = d4field (ptDb, "LIM1LOW")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM1LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l2lo = d4field (ptDb, "LIM2LOW")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM2LOW\" for %s\n", pvname);
		break;
	    }
	    if ((l3lo = d4field (ptDb, "LIM3LOW")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM3LOW\" for %s\n", pvname);
		break;
	    }
	    lim1lo = f4double (l1lo);
	    lim2lo = f4double (l2lo);
	    lim3lo = f4double (l3lo);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 0;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1lo;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2lo;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3lo;
	    }
	    break;
	
	case SPECL_DISPHIGH:
	case SPECL_CTRHIGH:
	    if ((l1hi = d4field (ptDb, "LIM1HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM1HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l2hi = d4field (ptDb, "LIM2HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM2HIGH\" for %s\n", pvname);
		break;
	    }
	    if ((l3hi = d4field (ptDb, "LIM3HIGH")) == 0)
	    {
		tisSysLog (0,0,"special_30: cant find \"LIM3HIGH\" for %s\n", pvname);
		break;
	    }
	    lim1hi = f4double (l1hi);
	    lim2hi = f4double (l2hi);
	    lim3hi = f4double (l3hi);
	    memset (limStr, 0, sizeof (limStr));
	    if (limFld != 0)
	    {
		strncpy (limStr, f4str (limFld), sizeof (limStr));
		limStr[sizeof(limStr)-1] = 0;
		FA_removeTrailingSpaces (limStr);
		if ( (strncmp (limStr, "0 - 100", 7)) == 0)
		    value = 100;
		else if ( (strncmp (limStr, "Limit 1", 7)) == 0)
		    value = lim1hi;
		else if ( (strncmp (limStr, "Limit 2", 7)) == 0)
		    value = lim2hi;
		else if ( (strncmp (limStr, "Limit 3", 7)) == 0)
		    value = lim3hi;
	    }
	    break;

	default:
	    tisSysLog (0,0,"special_30: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*    special_31
*	get the display and control limits for UDB Inputs INP1-INP8
*
**********************************************************************************/

double	special_31 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*inp = 0;
    char	dbPath[256];
    char	*pstr;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_31: pt type %d not found\n", pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_31: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if (udbpass == PASS_1)
    {
	addUdbIOPvname (pvname);
    }
    else
    {
	if ( (d4seek (ptDb, pvname)) != 0)
	{
	    tisSysLog (0,0,"special_31: failed to find %s in udb\n", pvname);
	    return (value);
	}
	if ((strncmp (fldname, "INV1", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT1")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT1\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV2", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT2")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT2\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV3", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT3")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT3\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV4", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT4")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT4\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV5", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT5")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT5\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV6", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT6")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT6\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV7", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT7")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT7\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "INV8", 4)) == 0)
	{
	    if ((inp = d4field (ptDb, "INPUT8")) == 0)
	    {
		tisSysLog (0,0,"special_31: failed to find \"INPUT8\" for %s\n", pvname);
		return (value);
	    }
	}
	else
	{
	    return (value);
	}
	if (inp)
	{
	    value = getUdbIOValue (inp, pvname, "special_31", type);
	}
    }

    return (value);
}


/*********************************************************************************
*
*    special_32
*	get the display and control limits for UDB outputs OUT1-OUT8
*
**********************************************************************************/

double	special_32 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*out = 0;
    char	dbPath[256];
    char	*pstr;
    double	value = 0;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_32: pt type %d not found\n", pttype);
	return (value);
    }

    if ((strncmp (pstr, "udb", 3)) != 0)
    {
	tisSysLog (0,0,"special_32: pttype %d is not a udb\n", pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    if (udbpass == PASS_1)
    {
	addUdbIOPvname (pvname);
    }
    else
    {
	if ( (d4seek (ptDb, pvname)) != 0)
	{
	    tisSysLog (0,0,"special_32: failed to find %s in udb\n", pvname);
	    return (value);
	}
	if ((strncmp (fldname, "OVL1", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT1")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT1\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL2", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT2")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT2\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL3", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT3")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT3\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL4", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT4")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT4\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL5", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT5")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT5\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL6", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT6")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT6\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL7", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT7")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT7\" for %s\n", pvname);
		return (value);
	    }
	}
	else if ((strncmp (fldname, "OVL8", 4)) == 0)
	{
	    if ((out = d4field (ptDb, "OUTPUT8")) == 0)
	    {
		tisSysLog (0,0,"special_32: failed to find \"OUTPUT8\" for %s\n", pvname);
		return (value);
	    }
	}
	else
	{
	    return (value);
	}
	if (out)
	{
	    value = getUdbIOValue (out, pvname, "special_32", type);
	}
    }

    return (value);
}


/*********************************************************************************
*
*    special_33
*	get display high TTIM field in VALVE record
*
**********************************************************************************/

double	special_33 (char *pvname, short pttype, char *fldname, SPECL_CONTROL type)
{
    DATA4	*ptDb;
    FIELD4	*ptEXOP;
    FIELD4	*ptEXCL;
    FIELD4	*ptOPDB;
    FIELD4	*ptCLDB;
    double	value = 0;
    double	open_time = 0;
    double	close_time = 0;
    double	exop = 0;
    double	excl = 0;
    double	opdb = 0;
    double	cldb = 0;
    char	dbPath[256];
    char	*pstr;

    if ((pstr = GET_PRECTYPE(pttype)) == NULL)
    {
	tisSysLog (0,0,"special_33: pt type %d not found\n",pttype);
	return (value);
    }

    sprintf (dbPath, "%s%s", FA_DATABASEPATH, pstr);

    if ( (ptDb = getFile (dbPath, pttype)) == 0)
	return (value);

    switch (type)
    {
	case SPECL_DISPHIGH:
	    if ( (d4seek (ptDb, pvname)) != 0)
	    {
		tisSysLog (0,0,"special_33: failed to find %s in %s\n", pvname, pstr);
		break;
	    }
	    if ( (ptEXOP = d4field (ptDb, "OPENTIME")) == 0)
	    {
		tisSysLog (0,0,"special_33: cant find \"OPENTIME\" for %s\n", pvname);
		break;
	    }
	    if ( (ptEXCL = d4field (ptDb, "CLOSETIME")) == 0)
	    {
		tisSysLog (0,0,"special_33: cant find \"CLOSETIME\" for %s\n", pvname);
		break;
	    }
	    if ( (ptOPDB = d4field (ptDb, "OPNDEADBND")) == 0)
	    {
		tisSysLog (0,0,"special_33: cant find \"OPNDEADBND\" for %s\n", pvname);
		break;
	    }
	    if ( (ptCLDB = d4field (ptDb, "CLSDEADBND")) == 0)
	    {
		tisSysLog (0,0,"special_33: cant find \"CLSDEADBND\" for %s\n", pvname);
		break;
	    }
	    exop = f4double (ptEXOP);
	    excl = f4double (ptEXCL);
	    opdb = f4double (ptOPDB);
	    cldb = f4double (ptCLDB);
	    open_time = exop + ((exop * opdb) / 100.0);
	    close_time = excl + ((excl * cldb) / 100.0);
	    value = (open_time > close_time) ? open_time : close_time;
	    break;

	default:
	    tisSysLog (0,0,"special_33: illegal type %d\n", type);
	    break;
    }

    return (value);
}


/*********************************************************************************
*
*   addUdbIOPvname ()
*	remember a UDB Pvname for post processing
*
**********************************************************************************/

static void	addUdbIOPvname (char *pvname)
{
    UDBPVS_PTR	currUdb, prevUdb;
    UDBPVS_PTR	newUdb = (UDBPVS_PTR)0;
    int		foundIt = 0;

    currUdb = prevUdb = udbpvs;

    while (currUdb != (UDBPVS_PTR)0)
    {
	if ( (strncmp (currUdb -> pvname, pvname, PVNAME_SZ)) == 0)
	{
	    currUdb -> usagecnt++;
	    foundIt = 1;
	    break;
	}
	prevUdb = currUdb;
	currUdb = currUdb -> nextUdb;
    }

    if (foundIt == 0)
    {
	if ((newUdb = (UDBPVS_PTR)calloc (1, sizeof (UDBPVS))) == NULL)
	{
	    tisSysLog (0,0,"addUdbIOPvname: calloc error for %s\n", pvname);
	    return;
	}
	strncpy (newUdb -> pvname, pvname, PVNAME_SZ);
	newUdb -> pvname[PVNAME_SZ] = 0;
	newUdb -> usagecnt = 1;
	newUdb -> nextUdb = (UDBPVS_PTR)0;

	if (udbpvs == (UDBPVS_PTR)0)
	{
	    udbpvs = newUdb;
	}
	else
	{
	    prevUdb -> nextUdb = newUdb;
	}
    }

    return;
}



/**********************************************************************
*
*    getUdbIOPrec ()
*	get the precision for the UDB Input and Output pts
*	make the rash decision that if there is no PRECISION field
*	there is no precision for the point
*	called by special_24
*
**********************************************************************/

static double	getUdbIOPrec (FIELD4 *pvFld, int *seekpv)
{
    DATA4	*pvDb;
    FIELD4	*pvPREC;
    char	pvName[PVNAME_SZ + 1];
    char	pvPtypeStr[15];
    char	*pChar;
    char	dbPath[256];
    short	pvPtype;
    int		i;
    double	value = 0;

    /* get the name of the UDB I/O point */
    strncpy (pvName, f4str (pvFld), PVNAME_SZ);
    pvName[PVNAME_SZ] = 0;
    if (pvName[0] == ' ')
	return (value);
    FA_removeTrailingSpaces (pvName);
    if ((pChar = strrchr (pvName, '.')) != NULL)
	*pChar = 0;
    /* find this point in pvmap */
    if ( (d4seek (FA_Pvmap, pvName)) == 0)
    {
	*seekpv = 1;
	memset (pvPtypeStr, ' ', sizeof (pvPtypeStr));
	/* get this points record type from pvmap */
	strncpy (pvPtypeStr, f4str (FA_PvmapTYPE), sizeof (pvPtypeStr));
	pvPtypeStr[sizeof (pvPtypeStr) - 1] = 0;
	FA_removeTrailingSpaces (pvPtypeStr);
	sprintf (dbPath, "%s%s", FA_DATABASEPATH, pvPtypeStr);
	pvPtype = 0;
	/* find the point type index */
	for (i = 0; i < dbRecType -> number; i++)
	{
	    if (dbRecType -> papName[i] == 0);
		continue;
	    if ((strcmp (pvPtypeStr, dbRecType -> papName[i])) == 0)
	    {
		pvPtype = i;
		break;
	    }
	}
	/* find this record in the pts database */
	if (pvPtype > 0)
	{
	    /* goto this points database */
	    if ( (pvDb = getFile (dbPath, pvPtype)) != 0)
	    {
		if ((d4seek (pvDb, pvName)) == 0)
		{
		    if ((pvPREC = d4field (pvDb, "PRECISION")) != 0)
		    {
			value = f4double (pvPREC);
		    }
		}
	    }
	}
    }

    return (value);
}


/**********************************************************************
*
*    getUdbIOValue ()
*	get the control value for the UDB Input and Output pts
*	called by special_31 and special_32
*
**********************************************************************/

static double	getUdbIOValue (FIELD4 *io, char *pvname, char *special, SPECL_CONTROL type)
{
    FIELD4	*pttype;
    double	value = 0;
    char	pvNameFld[PVNAME_SZ + 1];
    char	pvName[PVNAME_SZ + 1];
    char	pv[PVNAME_SZ + 1];
    char	pTypeStr[15];
    char	*pChar;
    int		i;
    double	dl, dh, cl, ch;
    short	pType = 0;

    strncpy (pvNameFld, f4str (io), PVNAME_SZ);
    if ((pvNameFld[0] == 0) || (pvNameFld[0] == ' '))
	return (value);
    strncpy (pv, f4str (io), PVNAME_SZ);
    pvNameFld[PVNAME_SZ] = 0;
    pv[PVNAME_SZ] = 0;
    FA_removeTrailingSpaces (pvNameFld);
    FA_removeTrailingSpaces (pv);
    /* separate the field name from the pvname, if it exists
       pvname.fldname
    */
    if ((pChar = strrchr (pvNameFld, '.')) != NULL)
    {
	*pChar = 0;
    }
    strncpy (pvName, pvNameFld, PVNAME_SZ);
    pvName[PVNAME_SZ] = 0;
    /* find this pv in pvmap */
    if ((d4seek (FA_Pvmap, pvName)) == 0)
    {
	/* get its point type */
	if ((pttype = d4field (FA_Pvmap, "TYPE")) == 0)
	{
	    tisSysLog (0,0,"getUdbIOValue: failed to find \"TYPE\" for %s\n", pvname);
	}
	else
	{
	    strncpy (pTypeStr, f4str (pttype), sizeof(pTypeStr));
	    pTypeStr[sizeof(pTypeStr)-1] = 0;
	    FA_removeTrailingSpaces (pTypeStr);
	    /* convert the point type string to an index value */
	    for (i = 0; i < dbRecType -> number; i++)
	    {
		if (dbRecType -> papName[i] == 0)
		    continue;
		if ((strcmp (pTypeStr, dbRecType -> papName[i])) == 0)
		{
		    pType = i;
		    break;
		}
	    }
	    if (pType > 0)
	    {
		/* get the value that was requested by the special */
		if ((FA_FetchSpecialData (descTable, pv, pType, &dl, &dh, &cl, &ch)) == 0)
		{
		    switch (type)
		    {
			case SPECL_DISPLOW:
			    value = dl;
			    break;

			case SPECL_DISPHIGH:
			    value = dh;
			    break;

			case SPECL_CTRLOW:
			    value = cl;
			    break;

			case SPECL_CTRHIGH:
			    value = ch;
			    break;

			default:
			    tisSysLog (0,0,"%s: illegal type %d\n", special, type);
			    break;
		    }
		}
	    }
	}
	/* return to original record in pvmap */
	d4seek (FA_Pvmap, pvname);
    }

    return (value);
}

