/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <in.h>
#include "dpamain.h"
#include "msgMon.h"

extern DPA_INFO	dpaInfo;
int	signals[] = {SIGINT,SIGHUP,0};
char appName[20];
AVL_TREE  *dpaPoints;

int main(int argc,char *argv[])
{
char *slash;
int appSocket;

tisOpenLog ("dpa", 6, 2, NULL, NULL);

dpaPoints = (AVL_TREE *)avl_init(dpaPointCompare);
slash = (char *)strrchr(argv[0],'/');
if(slash)
  {
    slash++;
    strcpy(appName,slash);
  }
else
  strcpy(appName,argv[0]);
openlog(ERR_LOG_NAME,LOG_PID,LOG_LOCAL1);
/*
	Init DPA sub-system
*/
if((appSocket = dpaInit(appName,dpaOpen,dpaRead,dpaWritePoint,0,dpaSignalHandler,signals)) < 0)
  exit(1);
dpaSetResMode(ALWAYS_MASTER);
dpaConfigure(appName);				/* configure export points from config file */

while(1)					/* loop for events from DPA & CA */
  {
    if(dpaEvent(DPA_SCAN_RATE) == DPA_ZEROREAD)	/* "scan rate" 5 seconds */
      {
	tisSysLog(0,0,"Zero length read from hsrvTask");
	exit(2);
      }
  }
}
int  dpaPointCompare(void *p1,void *p2)
{
  return(((POINT_INFO_PTR)p1)->dpaHandle - ((POINT_INFO_PTR)p2)->dpaHandle);
}
/*
  Handle signals
*/
void	dpaSignalHandler(int whichone)
{
switch(whichone)
  {
  case SIGINT:
    tisSysLog(0,0,"DPA:exiting due to ^C or -INT");
    exit(0);
    break;
  case SIGHUP:
    break;
  default:
    tisSysLog(0,0,"Unknown signal (%d)",whichone);
  }
}

