/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <in.h>
#include "dpamain.h"
void dpaWritePoint(void *handle,short type,void *data,short size)
{
  short stat,sevr;
  POINT_INFO  *pInfo,point;
  double alarmValue;
  short dType;
  int dSize;
  short lastVal,thisVal;

  point.dpaHandle = handle;
  if((pInfo = (POINT_INFO_PTR)avl_findsym(dpaPoints,&point)) != 0)
    {
      dpaGetFieldType(handle,&dType);
      switch(dType & 0xff)
	{
	case AGNT_FLOAT:
	  *(float *)&pInfo->dpaPointValue[0] = (float)dpaConvertToFloat(handle,data,type);
	  dSize = sizeof(float);
	  alarmValue = *(float *)&pInfo->dpaPointValue[0];
	  break;
	case AGNT_DOUBLE:
	  *(double *)&pInfo->dpaPointValue[0] = (double)dpaConvertToFloat(handle,data,type);
	  dSize = sizeof(double);
	  alarmValue = *(double *)&pInfo->dpaPointValue[0];
	  break;
	case AGNT_ENUM:
	case AGNT_SHORT:
	  *(short *)&pInfo->dpaPointValue[0] = (short)dpaConvertToInt(handle,data,type);
	  dSize = sizeof(short);
	  break;
	case AGNT_STRING:
	  strcpy(&pInfo->dpaPointValue[0],(char *)dpaConvertToString(handle,data,type));
	  dSize = strlen(&pInfo->dpaPointValue[0])+1;	/* include NULL too */
	  break;
	case AGNT_CHAR:
	  *(char *)&pInfo->dpaPointValue[0] = (char)dpaConvertToChar(handle,data,type);
	  dSize = sizeof(char);
	  break;
	case AGNT_LONG:
	 *(long *)&pInfo->dpaPointValue[0] = (long)dpaConvertToLong(handle,data,type);
	  dSize = sizeof(long);
	  break;
	default:
	  break;
	}
      stat = pInfo->dpaPointStatus;
      sevr = pInfo->dpaPointSeverity;
      if(((dType & 0xff) == AGNT_DOUBLE) || ((dType & 0xff) == AGNT_FLOAT))
	{
	  if(alarmValue > pInfo->dpaHighHigh)
	    {
	      stat = HIHI_ALARM;
	      sevr = pInfo->dpaHighHighSevr;
	    }
	  else if(alarmValue > pInfo->dpaHigh)
	    {
	      stat = HIGH_ALARM;
	      sevr = pInfo->dpaHighSevr;
	    }
	  else if(alarmValue < pInfo->dpaLowLow)
	    {
	      stat = LOLO_ALARM;
	      sevr = pInfo->dpaLowLowSevr;
	    }
	  else if(alarmValue < pInfo->dpaLow)
	    {
	      stat = LOW_ALARM;
	      sevr = pInfo->dpaLowSevr;
	    }
	  else
	    {
	      stat = NO_ALARM;
	      sevr = NO_ALARM;
	    }
	  dpaAlarm(pInfo->dpaHandle,(void *)&pInfo->dpaPointValue,dSize,stat,sevr,0);
	}
      else
	{
	  if((dType & 0xff) == AGNT_STRING)
	    {
	      sevr = pInfo->dpaHighHighSevr;	/* use HiHi severity for COS alarms */
	      if(!strcmp(&pInfo->dpaPointValue[0],&pInfo->dpaLastValue[0]))
		stat = NO_ALARM;
	      else
		stat = STATE_ALARM;
	      memcpy(&pInfo->dpaLastValue[0],&pInfo->dpaPointValue[0],DPA_VAL_SIZE);
	    }
	  else
	    {
	      lastVal = *((short *)&pInfo->dpaLastValue[0]);
	      thisVal = *((short *)&pInfo->dpaPointValue[0]);
	      if(lastVal != thisVal)
		{
		  memcpy(&pInfo->dpaLastValue[0],&pInfo->dpaPointValue[0],DPA_VAL_SIZE);
		  if(thisVal == 0)
		    {
		      sevr = pInfo->dpaHighHighSevr;	/* use HiHi severity for COS alarms */
		      stat = STATE_ALARM;
		    }
		  else
		    {
		      stat = NO_ALARM;
		      sevr = NO_ALARM;
		    }
		}
	    }
	  dpaAlarm(pInfo->dpaHandle,(void *)&pInfo->dpaPointValue,dSize,stat,sevr,0);
	}
      pInfo->dpaPointStatus = stat;
      pInfo->dpaPointSeverity = sevr;
      dpaWrite(pInfo->dpaHandle,&pInfo->dpaPointValue,dSize,AGNT_VALUE,stat,sevr);
    }
}
