/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include	<types.h>
#include	<sys/time.h>
#include	<in.h>

#include	"dbDefs.h"
#include	"alarm.h"
#include	"dpa.h"
#include	"dataTypes.h"
extern	DPA_INFO	dpaInfo;
extern	LIST		chanInfoTable;

void	dpaAlarm(void *handle,void *value,short size,short stat,short sevr,TS_STAMP *time)
{
  CH_ALARM	alarmData;
  short		msgType = CHAN_ALARM;
  char		buff[256];
  DPA_ADDR_PTR pAddr = (DPA_ADDR_PTR)handle;
  CHANNEL_INFO_PTR entry;
  struct timeval tv;
/*
	Use current time if user did not specify
*/
  if(pAddr == 0)
    return;
  entry = (CHANNEL_INFO_PTR)pAddr->precord;
  if(entry == 0)
    return;
  if(entry->valid == 0)
    return;
  if(!dpaInfo.appResourceState)
    return;
  if(!entry->chanAenb)
    return;
  if(entry->chanStat == stat)		/* only send if state has changed */
    return;
  if(time == 0)
    {
      gettimeofday(&tv,0);
      alarmData.alarmTime.secPastEpoch = tv.tv_sec - TS_EPOCH_SEC_PAST_1970;
    }
  else
    alarmData.alarmTime.secPastEpoch = time->secPastEpoch;
  entry->chanStat	       	= stat;
  entry->chanSevr	       	= sevr;
  if(sevr != NO_ALARM)
    {
      if(entry->chanAck == 0)
	entry->chanAck = 1;
    }
  entry->alarm_time.secPastEpoch = alarmData.alarmTime.secPastEpoch;	/* save time of this alarm */
  entry->alarm_time.nsec	= 0;
  memcpy((char *)&entry->last_value[0],(char *)value,size);
  alarmData.alarmTime.nsec	= 0;
  alarmData.alarmSerial		= 0;		       	/* filled in by hsrvTask */
  alarmData.alarmStat	       	= stat;
  alarmData.alarmSevr	       	= sevr;
  alarmData.alarmAck	       	= entry->chanAck;
  alarmData.alarmOnscan		= ON_SCAN;
  alarmData.alarmEnabled       	= entry->chanAenb;
  alarmData.alarmDataLen       	= dpaAlarmStream(entry,pAddr,value,buff);
  send(dpaInfo.appFd,&msgType,sizeof(short),0);
  send(dpaInfo.appFd,&alarmData,sizeof(CH_ALARM),0);
  send(dpaInfo.appFd,buff,alarmData.alarmDataLen,0);
}
/*
	format an alarm stream
*/
int	dpaAlarmStream(CHANNEL_INFO_PTR entry ,DPA_ADDR_PTR pAddr, void *value,char *buff)
{
  char	*val,*ptr = buff;
  int		size;

  strcpy(ptr,&entry->chanName[0]);	       	/* name */
  ptr += strlen(&entry->chanName[0]) + 1;

  strcpy(ptr,&entry->chanDesc[0]);	       /* descriptor */
  ptr += strlen(&entry->chanDesc[0]) + 1;

  val = dpaConvertToString(pAddr,value,pAddr->nativeType);		/* convert value to string */
  strcpy(ptr,val);
  ptr += strlen(val) + 1;

  strcpy(ptr,&entry->chanEgu[0]);
  ptr += strlen(&entry->chanEgu[0]) + 1;

  size = ptr - buff;
  if(size & 1) size++;
  return(size);
}
