/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	Functions to convert data in CA type to desired type
*/
#include	<stdio.h>
#include	<math.h>
#include	<in.h>

#include	"dbDefs.h"
#include	"dataTypes.h"
#include	"dpa.h"

float	dpaConvertToFloat(void *handle,void *value,short caType)
{
float	val;
switch(caType & 0xff)
	{
	case AGNT_ENUM:
		val = *(short *)value;
		break;
	case AGNT_STRING:
		return((float)atof((char *)value));
		break;
	case AGNT_LONG:
		val = *(long *)value;
		break;
	case AGNT_SHORT:
		val = *(short *)value;
		break;
	case AGNT_CHAR:
		val = *(char *)value;
		break;
	case AGNT_DOUBLE:
		val = *(double *)value;
		break;
	case AGNT_FLOAT:
		val = *(float *)value;
		break;
	}
return(val);
}
double	dpaConvertToDouble(void *handle,void *value,short caType)
{
double	val;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
		val = *(short *)value;
		break;
	case AGNT_STRING:
		return((double)atof((char *)value));
		break;
	case AGNT_LONG:
		val = *(long *)value;
		break;
	case AGNT_SHORT:
		val = *(short *)value;
		break;
	case AGNT_CHAR:
		val = *(char *)value;
		break;
	case AGNT_DOUBLE:
		val = *(double *)value;
		break;
	case AGNT_FLOAT:
		val = *(float *)value;
		break;
	}
return(val);
}
char	*dpaConvertToEnumStr(void *handle,void *value,short caType)
{
short	index;
DPA_ADDR		*pAddr = (DPA_ADDR_PTR)handle;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
	case AGNT_STRING:
		return((char *)value);
		break;
	case AGNT_SHORT:
		return((char *)pAddr->enums[*(short *)value]);
	case AGNT_CHAR:
		index = *(char *)value;
		return((char *)pAddr->enums[index]);
	case AGNT_DOUBLE:
		index = *(double *)value;
		return((char *)pAddr->enums[index]);
	case AGNT_FLOAT:
		index = *(float *)value;
		return((char *)pAddr->enums[index]);
	}
}
short	dpaConvertToInt(void *handle,void *value,short caType)
{
short	val;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
		val = *(short *)value;
		break;
	case AGNT_STRING:
		return((short)atoi((char *)value));
	case AGNT_LONG:
		val = *(long *)value;
		break;
	case AGNT_SHORT:
		val = *(short *)value;
		break;
	case AGNT_CHAR:
		val = *(char *)value;
		break;
	case AGNT_DOUBLE:
		val = *(double *)value;
		break;
	case AGNT_FLOAT:
		val = *(float *)value;
		break;
	}
return(val);
}
long	dpaConvertToLong(void *handle,void *value,short caType)
{
long	val;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
		val = *(short *)value;
		break;
	case AGNT_STRING:
		return((long)atoi((char *)value));
		break;
	case AGNT_LONG:
		return(*(long *)value);
	case AGNT_SHORT:
		val = *(short *)value;
		break;
	case AGNT_CHAR:
		val = *(char *)value;
		break;
	case AGNT_DOUBLE:
		val = *(double *)value;
		break;
	case AGNT_FLOAT:
		val = *(float *)value;
		break;
	}
return(val);
}
char	dpaConvertToChar(void *handle,void *value,short caType)
{
char	val;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
		val = *(short *)value;
		break;
	case AGNT_STRING:
		return((char)atoi((char *)value));
	case AGNT_LONG:
		val = *(long *)value;
		break;
	case AGNT_SHORT:
		val = *(short *)value;
		break;
	case AGNT_CHAR:
		return(*(char *)value);
	case AGNT_DOUBLE:
		val = *(double *)value;
		break;
	case AGNT_FLOAT:
		val = *(float *)value;
		break;
	}
return(val);
}
char	*dpaConvertToString(void *handle,void *value,short caType)
{
static	char	tempStr[1024];
DPA_ADDR		*pAddr = (DPA_ADDR_PTR)handle;
CHANNEL_INFO_PTR	entry  = (CHANNEL_INFO_PTR)pAddr->precord;
switch((caType & 0xff))
	{
	case AGNT_ENUM:
		return(pAddr->enums[*(short *)value]);
	case AGNT_STRING:
		return((char *)value);
	case AGNT_LONG:
		sprintf(tempStr,"%d\0",*(long *)value);
		break;
	case AGNT_SHORT:
		sprintf(tempStr,"%d\0",*(short *)value);
		break;
	case AGNT_CHAR:
		sprintf(tempStr,"%d\0",*(char *)value);
		break;
	case AGNT_DOUBLE:
		sprintf(tempStr,"%.*f\0",entry->chanPrec,*(double *)value);
		break;
	case AGNT_FLOAT:
		sprintf(tempStr,"%.*lf\0",entry->chanPrec,*(float *)value);
		break;
	}
return(&tempStr[0]);
}
