/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	These functions return the user handle (address of table entry) under
	various circumstances. a zero return is an error condition caused by:

		1.	Name not found.
		2.	Non-existant table.
		3.	End of table.

	GCT	19-OCT-1994

*/
#include	<in.h>

#include	"dbDefs.h"
#include	"dpa.h"
extern	LIST	chanInfoTable;
extern	DPA_INFO	dpaInfo;

void	*dpaGetHandle(name)
char	*name;
{
CHANNEL_INFO_PTR	entry;
char		nm[PVNAME_SZ+FLDNAME_SZ+50],channel[PVNAME_SZ+1],field[FLDNAME_SZ+1];

if(name == 0)
	return((void *)0);			/* return first if name is NULL */
strcpy(nm,name);
dpaSplitName(nm,channel,field);
entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
while(entry)
	{
	if(!strcmp(channel,entry->chanName))
		break;
	entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
	}
if(entry == 0)
	return((void *)entry);			/* zero if not found */
/* if(strlen(field)) */
/* 	{ */
/* 	return((void *)dpaNameToAddr(field,entry)); */
/* 	} */
return((void *)entry);
}
void	dpaFetchHandles(void *handles[],char *names[])
{
CHANNEL_INFO_PTR	entry;
int					i = 0;
entry = (CHANNEL_INFO_PTR)lstFirst((LIST *)&chanInfoTable);
while(entry)
	{
	handles[i] = (void *)entry;
	names[i] = (char *)&entry->chanName[0];
	i++;
	entry = (CHANNEL_INFO_PTR)lstNext((NODE *)entry);
	}
}
/*
	wait for ALL handles to become valid then return
*/
void	dpaAllValid(short num)
{
while(dpaInfo.appMaxHandles != num)
	dpaEvent(0.5);
}
