/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This function transfers data requested during a CH_DIRREAD or monitor operation.
	I must be called from within the users 'readFunc' function. It can also be called
	any time the user program decides that any data has changed.

	20-Oct-1994 GCT
*/
#include	<types.h>
#include	<socket.h>
#include	<in.h>
#include	<tcp.h>
#include	<sys/time.h>

#include	"dbDefs.h"
#include	"dpa.h"
#include	"dataTypes.h"
#include	"alarm.h"
extern	DPA_INFO	dpaInfo;
extern	LIST		chanInfoTable;
extern	char	respData[];

int		dpaWrite(handle,value,valsize,mask,stat,sevr)
void	*handle;	/* address of desired field */
void	*value;
short	valsize;
short	mask;
short	stat,sevr;
{
CH_MONDATA	mMsg;

short		msgType,oldstat,oldsevr;
int			totalSize;
DPA_ADDR *pAddr;
CHANNEL_INFO_PTR	entry;
DPA_HANDLES_PTR		hp;

memset(respData,0,DPA_CHAN_DATA_SIZE);
if(!dpaInfo.appResourceState)					/* do nothing if slave*/
	return(DPA_NULLHANDLE);
if(handle == 0)
	return(DPA_NULLHANDLE);
pAddr = (DPA_ADDR_PTR)handle;
 totalSize = valsize * pAddr->nativeCount;
 if((value != pAddr->pfield) && (pAddr->pfield != 0))
   memcpy((char *)(pAddr->pfield),(char *)value,totalSize);
 pAddr->field_size = valsize;
if(!pAddr->precord)
	return(DPA_NULLHANDLE);
entry = (CHANNEL_INFO_PTR)pAddr->precord;
if(lstFind((LIST *)&chanInfoTable,(NODE *)entry) == -1)
	return(DPA_NULLHANDLE);
if(!dpaIsValid(entry))
	return(DPA_NULLHANDLE);
if(!pAddr->sendHandles)
	return(DPA_NULLHANDLE);
if(!pAddr->init)
	return(DPA_NULLHANDLE);
oldstat = entry->chanStat;				/* save these for later */
oldsevr = entry->chanSevr;
if(entry->chanAenb)
	{
	entry->chanStat = stat;
	entry->chanSevr = sevr;
	}
else
	{
	entry->chanStat = NO_ALARM;
	entry->chanSevr = NO_ALARM;
	}
msgType			= htons(CHAN_MONDATA);
mMsg.chMask		= AGNT_VALUE;
/*
Send messages for all INTERESTED handles;
*/
hp = pAddr->sendHandles;
while(hp)
	{
	mMsg.chHandle = hp->handle;
	mMsg.chCount   	= hp->requestedCount;				/* one element for static fields */
	mMsg.chDataType	= hp->requestedType;
/* 	if((mMsg.chDataType & 0xff00) == 0) */
/* 	  { */
	    if((mMsg.chDataType & 0xff) == AGNT_STRING)
	      mMsg.chDataType |= (AGNT_STAT );
	    else
	      mMsg.chDataType |= (AGNT_STAT | AGNT_CNTRL | AGNT_GRAPH);
/* 	  } */
	mMsg.chDataLen 	= dpaAgentField(respData,mMsg.chDataType,mMsg.chCount,0,entry,pAddr); /* get field data an size */
	send(dpaInfo.appFd,(char *)&msgType,sizeof(msgType),0);	       	/* send the message type... */
	send(dpaInfo.appFd,(char *)&mMsg,sizeof(CH_MONDATA),0);	       	/* followed by the message header... */
	send(dpaInfo.appFd,respData,mMsg.chDataLen,0);			/* followed by the data */
	hp = hp->nextHandle;
	}
dpaWriteField(dpaNameToAddr("ACK",entry));
dpaWriteField(dpaNameToAddr("SEVR",entry));
dpaWriteField(dpaNameToAddr("STAT",entry));
dpaTrend((void *)pAddr);						/* send trend message to CA */
entry->chanStat = oldstat;
entry->chanSevr = oldsevr;
return(DPA_NORMAL);
}
/*
	Send trend data even if there is no channel open to channel access!
*/
void	dpaTrend(void *handle)
{
CH_TRDATA	trMsg;
short		msgType;
CHANNEL_INFO_PTR	entry;
DPA_ADDR_PTR	pAddr = (DPA_ADDR_PTR)handle;
entry = (CHANNEL_INFO_PTR)pAddr->precord;
if(!entry->chanTenb)								/* see if I should send a trend data message */
	return;
memset(respData,0,DPA_CHAN_DATA_SIZE);
trMsg.chNameLen = strlen(entry->chanName)+1;			/* length of point name */
if((trMsg.chNameLen & 1) != 0) trMsg.chNameLen++;		/* pad point name to word boundary */
sprintf(respData,"%s\0",entry->chanName);
trMsg.chDataType = entry->chanDataType | AGNT_STAT | AGNT_TIME | AGNT_LOG;	/* include the time & status & severity*/
trMsg.chDataLen = dpaAgentField(respData+trMsg.chNameLen,trMsg.chDataType,1,0,entry,(void *)pAddr); /* get field data and size */
msgType = htons(CHAN_TRDATA);
send(dpaInfo.appFd,(char *)&msgType,sizeof(msgType),0);					/* send the message type... */
send(dpaInfo.appFd,(char *)&trMsg,sizeof(CH_TRDATA),0);					/* followed by the message header... */
send(dpaInfo.appFd,respData,trMsg.chDataLen+trMsg.chNameLen,0);	/* followed by the name+data */
}
int	dpaWriteField(DPA_ADDR_PTR pAddr)
{
CHANNEL_INFO_PTR	entry;
CH_MONDATA	wMsg;
short	msgType;
DPA_HANDLES_PTR	hp;

entry = (CHANNEL_INFO_PTR)pAddr->precord;

if(!dpaInfo.appResourceState)
	return(DPA_NULLHANDLE);
if(!dpaIsValid(entry))
	return(DPA_NULLHANDLE);
if(!pAddr->init)
	return(DPA_NULLHANDLE);
memset(respData,0,DPA_CHAN_DATA_SIZE);

msgType = htons(CHAN_MONDATA);
wMsg.chMask	= AGNT_VALUE;
hp = pAddr->sendHandles;
while(hp)
  {
    wMsg.chHandle = hp->handle;
    wMsg.chDataType = hp->requestedType;
    if((wMsg.chDataType & 0xff) == AGNT_STRING)
      wMsg.chDataType |= (AGNT_STAT );
    else
      wMsg.chDataType |= (AGNT_STAT | AGNT_CNTRL | AGNT_GRAPH);
    wMsg.chCount	= pAddr->nativeCount;					/* one element for static fields */
    wMsg.chDataLen	= dpaAgentField(respData,wMsg.chDataType,wMsg.chCount,0,entry,pAddr); /* get field data and size */
    send(dpaInfo.appFd,(char *)&msgType,sizeof(msgType),0);		/* send the message type... */
    send(dpaInfo.appFd,(char *)&wMsg,sizeof(CH_MONDATA),0);		/* followed by the message header... */
    send(dpaInfo.appFd,respData,wMsg.chDataLen,0);		/* followed by the data */
    hp = hp->nextHandle;
  }
return(DPA_NORMAL);
}
