/*drvcommon.c,v 1.1.1.1 1999/08/03 14:42:53 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvcommon.c											
**  Edit:  01/20/94     WEP: holds common data structures for primary/secondary driver semaphore logic. 
**         07/07/94     WEP: added pstatewait and initialized to one second. also added wait set call.  
**         10/24/94     WEP: increased common driver support to 32 lines.
**
*/  	

#include <ctype.h>

#include <vxWorks.h>
#include <inetLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include "dbDefs.h"
#include "drvSup.h"
#include "drvcommon.h"		          /* NOTE: change here */
#include "drvcommon_proto.h" 		  /* NOTE: change here */
#include "restable.h"


/* static long	init(); */
void common_driver ();

struct	{
		long		number;	/* number of driver support functions in this structure */
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvcommon={ 2,
		 NULL,
		 init };

/*
**      Declare Global Data Structures: General
**
*/
        unsigned char	resnames[IOCLINES][RESNAMELEN];	/* array of resource name strings.		*/

        RES_TABLE	*prestable[IOCLINES] =		/* array of pointers to resource tables 	*/
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL} ;


        unsigned short	resresponse[IOCLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

        unsigned short	line_activity[IOCLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
        unsigned short	lastactivity[IOCLINES];		/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

        unsigned short	modtrace[IOCLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
        unsigned short	mltrace[IOCLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
        unsigned short	modrestrace[IOCLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/


/*        OUTPUTQUE	*oq[IOCLINES];			/ * array of ptrs to the line output queues and	*/
							/* their control structures 			*/

        SEM_ID		semids[IOCLINES][2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

        short		linetimers[IOCLINES];		/* except on init (init_line_tabs), all		*/
							/* references are commented out		 	*/

        SEM_ID		linesems[IOCLINES];		/* not used. no references in the code at all	*/
                                                	
        unsigned short	intermsgdelay[IOCLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
        unsigned short	pretxdelay[IOCLINES];		/* holds post RTS delay before TX. 		*/
        unsigned short	posttxdelay[IOCLINES];		/* holds post TX delay before dropping RTS. 	*/

        long		activity_time[IOCLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

	SEM_ID		linemux[IOCLINES] =		/* 1/18/94: global mutual-exclusion semaphore	*/
			{NULL, NULL, NULL, NULL, NULL,  /* for shared resource of the data array of	*/
			 NULL, NULL, NULL, NULL, NULL,  /* pointers to dynamically allocated comm	*/
			 NULL, NULL, NULL, NULL, NULL,  /* controls/buffers link controls access to 	*/
			 NULL, NULL, NULL, NULL, NULL,  /* common path shared by data and diagnostic	*/
                         NULL, NULL, NULL, NULL, NULL,  /* channels. originally designed for use with   */
                         NULL, NULL, NULL, NULL, NULL,  /*  MDS remote radio diagnostics.               */
			 NULL, NULL};
			 
        unsigned short  halfduplex[IOCLINES];           /* store half/full duplex line status           */

	unsigned long	releasetime[IOCLINES];		/* holds tick value needed to release the       */
                                                        /* semaphore to the primary.	                */

	unsigned short	prime_state[IOCLINES] = 	
			{NULL, NULL, NULL, NULL, NULL,  
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL, NULL, NULL, NULL, 
			 NULL, NULL} ;

        unsigned long	release_time[IOCLINES];		/* holds tick value needed to release the	*/
							/* semaphore to the primary.			*/

        unsigned long	master_time[IOCLINES];		/* holds tick value needed to begin next master	*/
							/* radio poll.					*/

        unsigned long	remote_time[IOCLINES];		/* holds tick value needed to begin next remote	*/
							/* radio poll.					*/

        unsigned short  nextradio[IOCLINES];            /* holds number of next radio to be time polled */

        unsigned short  nextoffline[IOCLINES];          /* holds number of next radio to be checked for */
                                                        /* offline status and attempted reconnection.   */

        unsigned short	prime_line[IOCLINES];           /* store the primeline value from the MAIN call */


        unsigned short pstatewait[IOCLINES] =
			{60, 60, 60, 60, 60,
			 60, 60, 60, 60, 60,
			 60, 60, 60, 60, 60,
			 60, 60, 60, 60, 60,
			 60, 60, 60, 60, 60,
			 60, 60, 60, 60, 60,
			 60, 60}  ;                     /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

/*
**      Declare Global Data Structures: Communication Control Structures
**
*/
/*	RXLINE          *rxlinetab[IOCLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ;	*/	/* array of pointers to dynamically */
						/* allocated comm controls/buffers  */

/*	TXLINE          *txlinetab[IOCLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ;  */  /* array of pointers to dynamically	*/
					    /* allocated comm controls/buffers	*/


/*
**      Declare Private Data Structures
**
*/

static unsigned short	trace;	    /* controls output of certain resource related log messages (level)  */
static unsigned short	restrace;   /* controls output of MASTER/SLAVE arbitration log messages (binary) */

static int	taskId;

static char	*taskname = "Common"; 	/* displayed when debugging */


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
    {
	return (0);
    }
/********
**
**	This routine provides for setting the pstatewait value for ANY driver on ANY line.              
**      (regardless of whether the specific driver actually implements the associated function)         
**
********/
void setpstatewait(unsigned short line, unsigned short seconds)
    {
	pstatewait[line] = seconds*60;
    }

/********
**
**	This routine enables logging of resource trace messages
**
********/
void Rcommontraceon ()
    {
	restrace = TRUE;
    }

/********
**
**	This routine disables logging of resource trace messages
**
********/
void Rcommontraceoff ()
    {
	restrace = FALSE;
    }

/********
**
**	This routine controls logging of trace messages
**
********/
void commontrlv ( unsigned short level)
    {
	trace = level;
    }

#ifndef TEST
int stopcommon ()
{
	    taskDelete (taskId);
	    return (1);
}

int startcommon ()
{
    taskId = taskSpawn (taskname, COM_PRIORITY, COM_TASK_OPTIONS, COM_STACK, (FUNCPTR)common_driver, 0,0,0,0,0,0,0,0,0,0);
    return 0;
}
#endif
/*
**      common_driver	                                                                      	
**                                                                                     	
**      The purpose of this task is to provide a common location for IOC-wide           
**      diagnostic code.                                                                
**                                                                                      
*/                                                                                      
/* not called from within this driver 						      */

void common_driver ()
    {
	int     i;
        long	this_time, last_time;

/* Initialize the data structures */

        for (i=0; i < IOCLINES; i++)
        {
                resnames[i][0] = 0;	/* initialize array of resource name strings.	*/
        }

	while(TRUE)
	{
		this_time = last_time;
		taskDelay(60);
	}
     }

/*	End of File:	drvcommon.c */
