/*snwsUnique.c,v 1.1.1.1 1999/08/03 14:43:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: unique.c
/*  Edit: 07/31/96      WEP: original code                                      
/*                         :                                                    
*/

#include <stdio.h>
#include <string.h>

#include "msgMon.h"

#define   TRUE   1
#define   FALSE  0


void usage()
{
    printf("Usage:\n unique {Source} (Destination)        where:");
    printf("\t{Source}      = input file to be stripped of duplicate records.");
    printf("\t(Destination) = output file to be created.");
}

/******************/
void main(int argc, char *argv[])

{
    FILE           *destination;
    FILE           *source;
    unsigned long   i, j;

    unsigned char   oldrecord[81];
    unsigned char   record[81];

    tisOpenLog ("snwsUnique", 6, 2, NULL, NULL);

    /***********************************************************/
    /* determine that correct number of parameters was passed. */
    /***********************************************************/

    if (argc != 3)
    {
        usage();
        exit(1);
    }

    /******************************************************************************/
    /* open the source file, verifying its existence: if it does not exist, exit. */
    /******************************************************************************/

    /* Open File for Read Only */
    if ((source = fopen(argv[1],"r")) == NULL)
    {
        tisSysLog(0,0,"ERROR : Cannot open Source file %s.",argv[1]);
        usage();
        exit(1);
    }

    /******************************************************************************/
    /* open the destination file, verifying its non-existence: if it exist, exit. */
    /******************************************************************************/

    /* Open File for Read Only */
    if ((destination = fopen(argv[2],"r")) != NULL)
    {
        fclose (destination);
        fclose (source);
        tisSysLog(0,0,"ERROR : Destination file  %s already exists.",argv[2]);
        usage();
        exit(1);
    }
   
    /**************************************************************/
    /* create the destination file: if it cannot be opened, exit. */
    /**************************************************************/

    /* Open File for Write Only */
    if ((destination = fopen(argv[2],"w")) == NULL)
    {
        fclose (destination);
        fclose (source);
        tisSysLog(0,0,"ERROR : Cannot create Destination file %s.",argv[2]);
        usage();
        exit(1);
    }
   
    /*********************************************/
    /* read the current source record. if it is  */
    /* unique, write it to the destination file. */
    /*********************************************/

    i = 0;
    j = 0;
    oldrecord[0] = 0;

    while (fgets(record, 80, source))
    {
        i++;
        /* test for record uniqueness */
        if (strcmp (&record[0], &oldrecord[0]) != 0)
        {
            fputs(&record[0], destination);
        }
        else
        {
            j++;
            tisSysLog(0,0,"Duplicate record [%d:%d]:\t %s", i, j, &record[0]);
        }
        /* copy the input buffer as the previous buffer */
        strcpy(&oldrecord[0], &record[0]);
    }

   /*************************/
    /* close the source file */
    /*************************/
      fclose (source);

    /******************************/
    /* close the destination file */
    /******************************/
      fclose(destination);

    /***********/
    /* go home */
    /***********/
      exit(0);
}
