/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
  bootline.h
  1993.10.27,ktb
*/
#ifndef	INCbootlineH
#define	INCbootlineH

#define	BOOTLPORT		"9998"

#define LEN_IFCNAME 8
#define LEN_PHYSADDR 16
#define LEN_NODENAME 32
#define LEN_USERNAME 32
#define LEN_PASSWORD 32
#define LEN_MISCDATA 64
#define LEN_FILEPATH 128

struct _bootline_request
{
  u_short msgtype;
};

struct _bootline_response
{
  u_short msgtype;
  u_short proc_num;				/*usually 0*/
  u_long target_IPaddr;				/*e.g. 0xC0F612C8 = 192.246.18.200*/
  u_long target_subnetmask;			/*e.g. 0xFFFFFF00*/
  u_long bkplane_IPaddr;
  u_long bkplane_subnetmask;
  u_long boothost_IPaddr;
  u_long gateway_IPaddr;
  u_short boot_flags;				/*usually 0*/
  char bootinterface[ LEN_IFCNAME ];		/*e.g. "ln"*/
  char boothost_name[ LEN_NODENAME ];		/*e.g. "bud"*/
  char target_name[ LEN_NODENAME ];		/*e.g. "tateioc"*/
  char imagefile[ LEN_FILEPATH ];		/*e.g. "/tis/vw510/config/mv147/vxWorks"*/
  char scriptfile[ LEN_FILEPATH ];		/*e.g. "/home/epics/apple/ioc/startup.cmd"*/
  char default_user[ LEN_USERNAME ];		/*e.g. "epics"*/
  char default_pass[ LEN_PASSWORD ];		/*e.g. "tunnel"*/
  char other[ LEN_MISCDATA ];			/*usually null*/
};

typedef struct _bootline_request bootreq;
typedef struct _bootline_response bootrsp;

#endif	INCbootlineH
