/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/param.h>
#include <memory.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>
#include "dataTypes.h"
#include "dbDefs.h"
#include "dbRecType.h"
#include "dbRecDes.h"
#include "dbRecords.h"
#include "avl.h"
#include "alarm.h"
#include "choice.h"
#include "choiceGbl.h"
#include "cadef.h"
/*
structure for point data either import or export
*/
typedef struct
{
  char  imsPointName[PVNAME_SZ+1];
  char  imsPointValue[30];
  short imsPointStatus;
  short imsPointSeverity;
  int   imsRate;	/* in seconds */
  int   imsSaveRate;
  char  imsDoTrend;
  char  imsDoAlarm;
  char  imsDataType;
  chid  imsCHID;	/* this is for the channel access stuff */
  chid  imsStatCHID;	/* STAT & SEVR must be specified seperately */
  chid  imsSevrCHID;
} POINT_INFO, *POINT_INFO_PTR;

typedef struct
{
  char     imsImportFileName[64];
  char     imsImportScript[64];
  AVL_TREE *imsImportPoints;
  char     imsExportFileName[64];
  int      imsExportRate;	/* in seconds */
  int      imsRateSave;
  int      imsMaxRate;
  AVL_TREE *imsExportPoints;
  FILE     *imsImportFile;
  FILE     *imsExportFile;
} CONTROL_INFO,*CONTROL_INFO_PTR;

/* Global varibles */
extern FILE   *imsControlFile;			/* used for main control file...if zero then exit */
extern int  caSocket,maxFd;
extern fd_set  myFds,saveFds;
extern CONTROL_INFO imsControl;

/* function prototypes */
void imsSignalHandler(int);
int  imsParseControl(CONTROL_INFO_PTR);
int  imsParseExport(CONTROL_INFO_PTR);
int  imsPointCompare(void *, void *);
void imsAddToImportTree(CONTROL_INFO_PTR,char *);
void imsAddToExportTree(CONTROL_INFO_PTR,char *);
void imsWriteExportPoints(void *,void *);
void imsWriteImportPoints(void *,void *);
void imsWriteImportFile(CONTROL_INFO_PTR);
char *imsGetToken(void);
void imsRegisterCA(void *, int, int);	/* Reconnect to CA */
void imsCAConnect(struct connection_handler_args);
void imsCAMonitor(struct event_handler_args);
void imsCARead(struct event_handler_args);


/* defines */
#define  POINT_INFO_SIZE sizeof(POINT_INFO)
#define  CONTROL_INFO_SIZE sizeof(CONTROL_INFO)
#define  LOG_OPTIONS (LOG_ALERT|LOG_LOCAL1)
#define  DB_PATH "/tis4000db"
#define  ERR_LOG_NAME "ims"
#define  IMS_APP_NAME "ims"



