/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <ims.h>
void imsWriteExportPoints(void *p1,void *p2)
{
  POINT_INFO_PTR point = (POINT_INFO_PTR)p2;
  double  dval;
  if(point->imsDataType == 'N')
    {
      memcpy((char *)&dval,&point->imsPointValue[0],sizeof(double));
      ca_put(OLD_DBF_DOUBLE,point->imsCHID,&dval);
    }
  else
    {
      ca_put(OLD_DBF_STRING,point->imsCHID,&point->imsPointValue[0]);
      ca_pend_io(0);		/* get data from CA */
    }
}
void imsWriteImportPoints(void *p1,void *p2)
{
  struct	tm *localTime,*reqTime;
  time_t tempTime,retval;				/* for GMT conversions */
  POINT_INFO_PTR point = (POINT_INFO_PTR)p2;
  CONTROL_INFO_PTR ctl = (CONTROL_INFO_PTR)p1;
  char valString[80],outStr[80],statStr[40],sevStr[40],*pChoice;
  double dval;
  struct choiceSet *set;

  if(--point->imsRate <= 0)
    {
      point->imsRate = point->imsSaveRate;	/* reset rate here */
      if(!ctl->imsImportFile)			/* open with first use */
	ctl->imsImportFile = fopen(&ctl->imsImportFileName[0],"w");
      /* calculate local time as GMT */
      tempTime = time(0);
      reqTime = localtime(&tempTime);
#if !defined(MIPSEL) && !defined(AXP)
#if !defined(SOLARIS)
      retval = timelocal (reqTime);
#else
      retval = mktime (reqTime);
#endif
#else
      retval = mktime (reqTime);
#endif
      localTime = (struct tm *)gmtime(&retval);			/* get local time for this cell */

      if(point->imsDataType == 'A')
	strcpy(valString,point->imsPointValue);
      else
	{
	  memcpy((char *)&dval,&point->imsPointValue[0],sizeof(double));
	  sprintf(valString,"%f\0",dval);
	}
      if(strchr(valString,' '))
	sprintf(outStr," \"%s\"\0",valString);
      else
	sprintf(outStr," %s\0",valString);

      set = GET_PCHOICE_SET(choiceGbl,GBL_ALARM_STAT);
      pChoice = GET_CHOICE(set,point->imsPointStatus);
      if(strlen(pChoice) == 0)pChoice = "NO ALARM";
      if(strchr(pChoice,' '))
	sprintf(statStr," \"%s\"\0",pChoice);
      else
	sprintf(statStr," %s\0",pChoice);

      set = GET_PCHOICE_SET(choiceGbl,GBL_ALARM_SEV);
      pChoice = GET_CHOICE(set,point->imsPointSeverity);
      if(strlen(pChoice) == 0)pChoice = "NO ALARM";
      if(strchr(pChoice,' '))
	sprintf(sevStr," \"%s\"\0",pChoice);
      else
	sprintf(sevStr," %s\0",pChoice);

      fprintf(ctl->imsImportFile,"%s %4d%02d%02d %02d:%02d:%02d%s%s%s\n",
	     point->imsPointName,
	     localTime->tm_year+1900,
	     localTime->tm_mon+1,
	     localTime->tm_mday,
	     localTime->tm_hour,
	     localTime->tm_min,
	     localTime->tm_sec,
	     outStr,statStr,sevStr);
    }
}

void imsWriteImportFile(CONTROL_INFO_PTR ctl)
{
avl_traverse(ctl->imsImportPoints,INORDER,imsWriteImportPoints,ctl);
/* If file was opened in the imsWriteImportPoints function, then close it here and start the script */
if(ctl->imsImportFile)
  {
    fclose(ctl->imsImportFile);
    ctl->imsImportFile = 0;
    if(strlen(ctl->imsImportScript))
      system(ctl->imsImportScript);
  }
}
