/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#if defined(SOLARIS) || defined(WIN32)
#include	<string.h>
#else
#include	<strings.h>
#endif
#ifdef WIN32
#else
#include	<syslog.h>
#endif WIN32

#define	STR_BUFF_SIZE	256

int	tisLoadStrings(file,table,size)
char	*file;
char	*table[];
int		size;
{
FILE	*fp;
char	buff[STR_BUFF_SIZE],*iStr,*sStr,*from,*to,numstr[10];
char	temp[STR_BUFF_SIZE];
int		index,iTemp,i;

/*openlog("tisLoadStrings:",LOG_PID,LOG_DAEMON);*/
if((fp = fopen(file,"r")) != 0)
	{
	memset(buff,0,STR_BUFF_SIZE);
	for(i = 0;i < size;i++) table[i] = "UNKNOWN";
	size = 0;
	while(fgets(buff,STR_BUFF_SIZE-1,fp))
		{
		if((buff[0] != '\n') && (buff[0] <= '9'))
			{
			iStr = (char *)strtok(buff,"\"");
			index = atoi(iStr);
			sStr = (char *)strtok(NULL,"\"");
			to = &temp[0];
			from = sStr;
/*
	process escape characters

	\n,\r,\t,\a,\b,\0aaa,\0xhh
*/
			while(*from)
				{
				if(*from == '\\')
					{
					from++;
					switch(*from)
						{
						case 'n':
							*to = '\n';
							break;
						case 'r':
							*to = '\r';
							break;
						case 'b':
							*to = '\b';
							break;
						case 'f':
							*to = '\f';
							break;
						case 'a':
							*to = '\a';
							break;
						case 't':
							*to = '\t';
							break;
						case '0':		/* convert octal/hex digits to one byte */
							if(*(from+1) == 'x')
								{		/* process HEX number */
								int	i = 0;
								from += 2;
								while(((*from >= '0') && (*from <= '9')) || ((*from >= 'a') && (*from <= 'f')))
									{
									numstr[i] = *from;
									from++;
									i++;
									}
								from--;
								numstr[i] = 0;
								sscanf(&numstr[0],"%x",&iTemp);
								*to = iTemp;
								}
							else
								{		/* process octal number */
								int	i = 0;
								while((*from >= '0') && (*from <= '7'))
									{
									numstr[i] = *from;
									from++;
									i++;
									}
								from--;
								numstr[i] = 0;
								sscanf(&numstr[0],"%o",&iTemp);
								*to = iTemp;
								}
							break;
						}
					}
				else
					{
					*to = *from;
					}
				to++;
				from++;
				}
			*to = '\0';
			table[index] = (char *)calloc(1,strlen(&temp[0])+1);
			memcpy((char *)table[index],&temp[0],strlen(&temp[0]));
			size++;
			}
		}
	}
else
	{
#ifdef WIN32
	perror ("Error opening string table file");
#else
	syslog(LOG_ALERT | LOG_DAEMON,"Error opening string table file - %m");
#endif WIN32
	exit(0);
	}
fclose(fp);
return(size);
}
