/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#include <stdio.h>
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#include "resolveLinks.h"
#include "OperPrvDefs.h"
#include "trak.c"

/************************************************************************/
/*									*/
/*		         TRAK DATA MAINTENANCE    		       	*/
/*									*/
/************************************************************************/

int main(argc, argv)
int	argc;
char	*argv[];
{
  char		destinationFile[100];	/* Should be plenty */
  char		sourceFile[100];	/* Should be plenty */

  int     	ArchCutOff, CleanCutOff;
  long		ArchStop;
  long		CleanStop;




  int		enableArchive = 0;
  int		enableClean = 0;

	/* get archive data */

  if (argc != 6)
  {
      printf ("Usage: CleanAndArchTrak <archEnb> <archDays> <archFileName> <cleanEnb> <cleanDays>\n");
      exit (-1);
  }
  enableArchive = atoi( argv[1] );
  ArchCutOff = 24 * atoi( argv[2] );
  memset( destinationFile, 0, sizeof destinationFile );
  sprintf(sourceFile, "/tisarch/%s", argv[3]);
  resolveLinks (sourceFile, destinationFile);

	/* get clean data */

  enableClean = atoi( argv[4] );
  CleanCutOff = 24 * atoi( argv[5] );

  if (enableArchive)
    {
      ArchStop = getCutOffTime ( ArchCutOff);
    }
  if (enableClean)
    {
      CleanStop = getCutOffTime ( CleanCutOff);
    }
#ifdef WIN32
  strcpy(sourceFile, "\\tis4000db\\op_trak.dbf");
#else
  strcpy(sourceFile, "/tis4000db/op_trak.dbf");
#endif WIN32
  openDataFiles(sourceFile, destinationFile, enableArchive);

  /* step through the source */

  for( d4top( source ); !d4eof( source ); d4skip( source, 1 ))
    {
      d4unlock_all(source);
      /* Is the current record marked for deletion?  If it is, skip it. */
      if( d4deleted( source ))
	{
	  /* Record is already marked for deletion. */
	  continue;
	}
      if (enableArchive)
	{
	  /*
	    do the d4top only if archiving is enabled. This will ensure that
	    the destination file is open.
	    */
	  d4top(destination); /* GCT 18-Jun-1996 moved here to avoid -930 error */
	  d4unlock_all(destination);
	  if( (CmpRecTime( source, ArchStop )) &&
	      (!FindRecord(source, destination)) )
	    {
	      AddToList( destination );
	    }
	}
      if (enableClean)
	{
	  if (CmpRecTime( source, CleanStop))
	    {
	      d4blank(source);
	      d4delete(source);
	      UpdateTrak(source);
	    }
	}
    }
  UpdateTrak(source);
  closeTrak( source );
  if (enableArchive)
    {
      UpdateTrak(destination);
      closeTrak(destination);
    }
  return( 0 );
}

