/*OperPrvDefs.h,v 1.1.1.1 1999/08/03 14:43:10 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
 /* 	FILE NAME   :	OperPrvDefs.h
  *	PURPOSE	    :	Definitions for operator privilege checking and operator tracking.
  *
  *	AUTHOR	    :	Donald E. Kyne, Jr.
  *	DATE	    :	21-Sep-1992
  *
  *					M O D I F I C A T I O N S
  *
  *	DATE		INITIALS	DETAILS
  *
  *	Copyright 1992, Tate Integrated Systems, L.P.  All rights reserved.
  */

#ifndef	operprvdefsH
#define	operprvdefsH

#include "dbDefs.h"

/******
	Definitions for dBase file creation
 ******/

F4FIELD_INFO	TrakFlds[] =	{

	/* Field name,		Type,	Width,		Decimals */
	{ "OPERATOR",		'C',	OPERATOR_SZ,	0},
	{ "TRK_DATE",		'C',	8,		0},
	{ "TRK_TIME",		'C',	8,		0},
	{ "DESCRIPTOR",		'C',	28,		0},
	{ "POINTNAME",		'C',	PVNAME_SZ,	0},
	{ "FIELDNAME",		'C',	FLDNAME_SZ,	0},
	{ "OLD_VALUE",		'C',	25,		0},
	{ "NEW_VALUE",		'C',	25,		0},
	{ "PRINT_FLAG",		'C',	1,		0},
	{ "UNIX_TIME",		'N',	10,		0}, /* unix time GMT */
	{0, 0, 0, 0}		/* NULL-record terminator */
};

T4TAG_INFO	TrakTag[] =	{
	/* Tag Name,	Key Expression,		Filter Expression,	Unique,	Descending */
	{ "OPERATOR",	"OPERATOR",			0,		  0,	    0	},
	{ "DATETIME",	"TRK_DATE+TRK_TIME+STR(RECNO(),8,0)",	0,	0,	0},
	{ "UNIXTIME",	"STR(UNIX_TIME,10,0)+STR(RECNO(),8,0)",	0,	0,	0},
	{0, 0, 0, 0, 0 }	/* NULL-record terminator */
};

/******
	Definitions for field numbers frequently accessed
 ******/

#define	PRIV_OPER	1		/* Operator name */
#define PRIV_GROUP	2		/* Privilege Group */
#define PRIV_LEVEL	3		/* Privilege Level */


/*******
	Operator Tracking file definitions for field numbers 
 *******/
#define TRAK_OPER	1		/* Operator Name */
#define TRAK_DATE	2		/* Date */
#define TRAK_TIME	3		/* Time */
#define	TRAK_TEXT	4		/* Text */
#define TRAK_CHANNEL	5		/* Channel */
#define	TRAK_OLDVAL	6		/* Old Value */
#define	TRAK_NEWVAL	7		/* New Value */


/*******
	PVMAP.DBF definitions
 *******/
#define	PT_TYPE		2		/* Point type field number */
#define	PT_GROUP	1		/* Point Protection Group field number */


/*******
	Field Protection Table definitions
 *******/
#define FIELD_PTYPE		1		/* Field number of point type */
#define FIELD_NAME		2		/* Field number of field name */
#define FIELD_LEVEL		3		/* Field number of protection level for field being accessed */

/*******
        Error String definitions
 *******/

char 	*( InitMsg[] )  =  	{
				"Can't access the database files that control",
				"operator authorization.  Please check the",
				"directory /tis4000db.\n",
						0
				};

char	*( NoPtMsg[] )  =	{
				"Can't find this point in the operator",
				"authorization database.  Please check the file",
				"/tis4000db/pvmap.dbf.\n",
						0
				};

char	*( NoOprMsg[] )  =	{
				"You are not allowed to manipulate points in",
				"this protection group.\n",
						0
				};

char	*( NoOpFldMod[] )  =	{
				"Your privilege level in this point's protection",
				"group is not high enough to do this.\n",
						0
				};

char	*( NoTrkWrite[] )  =	{
				"Can't write a record of what you have done into",
				"the tracking database.  Please check the file",
				"/tis4000db/op_trak.dbf.\n",
						0
				};

char	*( NoErrCode[] )  =	{
				"Undefined error code.\n",
						0
				};

char	*( FldTagged[] )  =	{
				"You can't do this while the point is tagged.\n",
						0
				};

char	*( NoPrinter[] )  =	{
				"Can't connect to the operator tracking printer.\n",
						0
				};

char	*( NoNetAccess[] )  =	{
				"Can't access the point to complete authorization check.",
				"Check network connection.\n",
						0
				};
char	*( NoAccess[] )  =	{
				"You can't do this because you are listed as a",
				"trainee in this point's protection group.\n",
						0
				};
#endif	operprvdefsH
