/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include	<stdio.h>
#include	<msmain.h>
#include	<string.h>
#include	<sys/fcntl.h>

#include	"msgMon.h"

int	appMyHandle;
char	applicationName [APP_NAME_LEN+1];

extern	int	appHostState;

/*----------*/
int appRegister (appName, appHandle)

    char	*appName;
    int		*appHandle;

    {

	struct hostent 	*ent;
	int		optval = 1, result;
	int		len, appSocket, bytesSent;
	struct		sockaddr_in	setAddr;
	int		myaddr;
	AppRegisterMsg	msg;
	Msg		stateMsg;
	char		hostName [100];

	gethostname (hostName, sizeof (hostName));
	if  (ent = gethostbyname (hostName)) {
	    len = sizeof(optval);
	    myaddr = ntohl (*(unsigned int *)*ent->h_addr_list);
	    if ((appSocket = socket (AF_INET, SOCK_STREAM,0)) < 0)
		return 0;
	    if (setsockopt (appSocket, SOL_SOCKET, SO_KEEPALIVE, (caddr_t)&optval, sizeof(optval)) < 0)
		return 0;
	    memset (&setAddr, 0, sizeof (setAddr));
	    setAddr.sin_family = AF_INET;
	    setAddr.sin_addr.s_addr = htonl (myaddr);
	    setAddr.sin_port = htons (LISTEN_PORT);
	    fcntl (appSocket, F_SETOWN, getpid());
	    if ((result = connect (appSocket, (struct sockaddr *)&setAddr, sizeof (setAddr))) < 0) {
		close (appSocket);
		return 0;
	    }
	    *appHandle = appSocket;
	    appMyHandle = appSocket;
	    setsockopt (appSocket, SOL_SOCKET, SO_KEEPALIVE, (caddr_t) &optval, sizeof (optval));

	    /* Tell msArbiter who we are. */

	    msg.magic = htonl (MSG_MAGIC_NUMBER);
	    msg.size = htonl (sizeof (msg));
	    msg.type = htonl (APP_REGISTER);
	    strcpy (msg.name, appName);
	    bytesSent = send (appSocket, (char *)&msg, ntohl (msg.size), 0);
	    if (bytesSent <= 0)
		return 0;
	    strcpy (applicationName, appName);

	    /* Wait here for a state message */

	    result = recv (appSocket, (char *)&stateMsg, sizeof (AppStateMsg), 0);
	    if (ntohl (stateMsg.msgHeader.magic) != MSG_MAGIC_NUMBER) {
		tisSysLog (0,0, "appRegister(%d): Bad magic number in app state message -- app not registered.",
				getpid ());
		return 0;
	    }
	    if (ntohl (stateMsg.msgHeader.type) != APP_STATE) {
		tisSysLog (0,0, "appRegister(%d): State message not received from msArbiter, type=%d",
			getpid (), ntohl (stateMsg.msgHeader.type));
		return 0;
	    }

	    appHostState = ntohl (((AppStateMsg *)&stateMsg)->state);

	    /* Now set the socket to non-blocking */

	    setsockopt (appSocket, IPPROTO_TCP, TCP_NODELAY, (caddr_t) &optval, sizeof (optval));

	    return 1;	/* success */

	}

	return 0;

    }
