/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* Write all records to an oracle table */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "mlist.h"
#include "oracleSnap.h"
#include "oracleSnapLib.h"

OracleDesc *od;
SnapRec	snaprec;

/*----------*/
main (int argc, char *argv[])
{
    int		i;
    int		num;
    time_t	start;
    char	egutag [17];
    double	disp_low;
    double	disp_high;
    double	values[512];
    unsigned char status[512][3];
    double	values2[512];
    struct tm	tmblock;
    long	dbrate;
    struct tm *tmvalue;

    if ((argc != 7) || (strlen(argv[4]) < 17))
    {
	printf ("Usage: arLibTest <point> <dbred> <red> <time-MM/DD/YY hh:mm:ss> <rate> <samples>\n");
	exit (-1);
    }

    OpenOracle ();

    tmblock.tm_mon = atoi (argv[4])-1;
    tmblock.tm_mday = atoi (argv[4]+3);
    tmblock.tm_year = atoi (argv[4]+6);
    tmblock.tm_hour = atoi (argv[4]+9);
    tmblock.tm_min = atoi (argv[4]+12);
    tmblock.tm_sec = atoi (argv[4]+15);
    start = mktime (&tmblock) - timezone;

    tmvalue = localtime(&start);

    printf ("Getting %d values for %s|%s at %s(%d) rate %d, reduction %s\n",
		atoi(argv[6]), argv[1], argv[2], argv[4], start, atoi(argv[5]),
		argv[3]);

    if (num = GetSnapValues (argv[1], argv[2], argv[3],
	       atoi(argv[5]), start, &dbrate,
	       egutag, &disp_low, &disp_high,
	       atoi(argv[6]), values, status, values2))
    {
	for (i = 0; i < num; i++)
	    printf ("%d - %f %3.3s %f\n", start + (atoi(argv[5]) * i), values[i], status[i], values2[i]);
    }
    else
    {
	printf ("Call returned 0\n");
    }

    printf ("arLibTest completed\n");
    return 1;
}
