/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#ifdef WIN32
#include <process.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "NTUnixSubs.h"
#else
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <signal.h>
#include <syslog.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <error.h>
#endif WIN32
#include <time.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "mlist.h"
#include "trendDefs.h"
#include "arSnapRecord.h"
#include "dbase.h"
#include "utils.h"
#include "archive.h"
#include "dbRequests.h"
#include "rb.h"
#include "msgMon.h"
/* Data */

int	running = TRUE;
int     debugLevel, myPid;
int	dbOpen = 0;
int	archiveInProgress = FALSE;
/* External data */
extern  int     errno;
/*----------*/
main (int argc, char *argv[])
{
  int currHour;
  int c;
  extern char *optarg;
  myPid = getpid();
  debugLevel = 0;
  tisOpenLog("trendArchiver",3,0,0,0);
  /* Process command line options */
  while((c = getopt(argc, argv, "h:l:dvs")) != -1)
    {
      switch(c)
	{
	case 'h':	/* Set archive time on command line */
	  currHour = atoi (optarg);
	  break;
	case 'l':	/* Explicitly set debug level */
	  debugLevel = atoi (optarg);
	  break;
	case 'd':	/* Debugging on */
	  debugLevel = 3;
	  break;
	case 'v':	/* Verbose mode on */
	  debugLevel = 2;
	  break;
	case 's':	/* Status mode */
	  debugLevel = 1;
	  break;
	}
    }
  
  tisBumpLogLevel(debugLevel);
  if (debugLevel > 0)
    tisSysLog(0, 2, "Started, debug level = %d,Hour = %d.\n", debugLevel,currHour);
  else
    tisSysLog(0, 2, "Started.\n");
  serverInit("trendArchiver", "/tis4000/tasks/trendArchiver.lock", "lock");
  /* Initialize the CodeBase system */
  initCodebase();
  /* Read the archiving parameters */
  readArchiveConfig();
  archiveAndClean(currHour);
  if(dbOpen)
    {
      closeArSnap();
#ifdef ORACLESNAP
      CloseOracle();
#endif ORACLESNAP
      dbOpen = FALSE;
    }
  tisSysLog(0, 2, "Terminated.\n");
  exit(0);
}
