/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* transfer oracle table records to xbase snap file */


#include <stdio.h>
#include <stdlib.h>
#include "d4all.h"
#include "mlist.h"
#include "oracleSnap.h"
#include "oracleSnapLib.h"

#define C_EPOCHSTART	2440588L	/* dif from db4 date to 01/01/1970 */
#define C_SECSPERDAY 86400L	/* number of seconds per day */

C4CODE  cb;
D4DATA	*arSnapDesc;
F4FIELD	*pointNameFld, *eguTagFld, *dispLowFld, *dispHighFld, *yearFld, *dayOfYearFld, *hourFld;
F4FIELD	*offsetMinFld, *sampleCntFld, *redMethodFld, *rateFld, *valueFld [60], *statusFld [60];  

	void	stripBlanks ();
static	void	openSnap ();
static	void	closeSnap ();
static	void	xbaseWriteRecord (SnapRec *snaprec);

extern	C4CODE	cb;
OracleDesc *od;
OracleDesc *catDesc;
SnapRec	snaprec;
char	catTable [40];
char	catTablespace [40];
int	targetSize;
char	*tablepath;
int	rateIsSeconds;

/* ar_snap field and tag definitions */
FIELD4INFO	snapFields[] =	{

	/* Field name,		Type,	Width,		Decimals */
	{ "POINTNAME",		'C',	POINTNAME_SIZE,	        0},
	{ "EGUTAG",		'C',	EGUTAG_SIZE,	        0},
	{ "DISP_LOW",		'C',	LIMITS_SIZE, 	        0},
	{ "DISP_HIGH",		'C',	LIMITS_SIZE,	        0},
	{ "YEAR",		'N',	YEAR_SIZE,	        0},
	{ "DAYOFYEAR",		'N',	DAY_SIZE,	        0},
	{ "HOUR",		'N',	HOUR_SIZE,  	        0},
	{ "OFFSET_MIN",		'N',	MIN_SIZE, 	        0},
	{ "SAMPLE_CNT",		'N',	SAMPLECNT_SIZE,         0},
	{ "RED_METHOD",		'C',	METHOD_SIZE,	        0},
	{ "RATE",		'C',	RATE_SIZE,              0},
	{ "VALUE1",		'C',	VALUE_SIZE,		0},
	{ "STATUS1",		'C',	STATUS_SIZE,		0},
	{ "VALUE2",		'C',	VALUE_SIZE,		0},
	{ "STATUS2",		'C',	STATUS_SIZE,		0},
	{ "VALUE3",		'C',	VALUE_SIZE,		0},
	{ "STATUS3",		'C',	STATUS_SIZE,		0},
	{ "VALUE4",		'C',	VALUE_SIZE,		0},
	{ "STATUS4",		'C',	STATUS_SIZE,		0},
	{ "VALUE5",		'C',	VALUE_SIZE,		0},
	{ "STATUS5",		'C',	STATUS_SIZE,		0},
	{ "VALUE6",		'C',	VALUE_SIZE,		0},
	{ "STATUS6",		'C',	STATUS_SIZE,		0},
	{ "VALUE7",		'C',	VALUE_SIZE,		0},
	{ "STATUS7",		'C',	STATUS_SIZE,		0},
	{ "VALUE8",		'C',	VALUE_SIZE,		0},
	{ "STATUS8",		'C',	STATUS_SIZE,		0},
	{ "VALUE9",		'C',	VALUE_SIZE,		0},
	{ "STATUS9",		'C',	STATUS_SIZE,		0},
	{ "VALUE10",		'C',	VALUE_SIZE,		0},
	{ "STATUS10",		'C',	STATUS_SIZE,		0},
	{ "VALUE11",		'C',	VALUE_SIZE,		0},
	{ "STATUS11",		'C',	STATUS_SIZE,		0},
	{ "VALUE12",		'C',	VALUE_SIZE,		0},
	{ "STATUS12",		'C',	STATUS_SIZE,		0},
	{ "VALUE13",		'C',	VALUE_SIZE,		0},
	{ "STATUS13",		'C',	STATUS_SIZE,		0},
	{ "VALUE14",		'C',	VALUE_SIZE,		0},
	{ "STATUS14",		'C',	STATUS_SIZE,		0},
	{ "VALUE15",		'C',	VALUE_SIZE,		0},
	{ "STATUS15",		'C',	STATUS_SIZE,		0},
	{ "VALUE16",		'C',	VALUE_SIZE,		0},
	{ "STATUS16",		'C',	STATUS_SIZE,		0},
	{ "VALUE17",		'C',	VALUE_SIZE,		0},
	{ "STATUS17",		'C',	STATUS_SIZE,		0},
	{ "VALUE18",		'C',	VALUE_SIZE,		0},
	{ "STATUS18",		'C',	STATUS_SIZE,		0},
	{ "VALUE19",		'C',	VALUE_SIZE,		0},
	{ "STATUS19",		'C',	STATUS_SIZE,		0},
	{ "VALUE20",		'C',	VALUE_SIZE,		0},
	{ "STATUS20",		'C',	STATUS_SIZE,		0},
	{ "VALUE21",		'C',	VALUE_SIZE,		0},
	{ "STATUS21",		'C',	STATUS_SIZE,		0},
	{ "VALUE22",		'C',	VALUE_SIZE,		0},
	{ "STATUS22",		'C',	STATUS_SIZE,		0},
	{ "VALUE23",		'C',	VALUE_SIZE,		0},
	{ "STATUS23",		'C',	STATUS_SIZE,		0},
	{ "VALUE24",		'C',	VALUE_SIZE,		0},
	{ "STATUS24",		'C',	STATUS_SIZE,		0},
	{ "VALUE25",		'C',	VALUE_SIZE,		0},
	{ "STATUS25",		'C',	STATUS_SIZE,		0},
	{ "VALUE26",		'C',	VALUE_SIZE,		0},
	{ "STATUS26",		'C',	STATUS_SIZE,		0},
	{ "VALUE27",		'C',	VALUE_SIZE,		0},
	{ "STATUS27",		'C',	STATUS_SIZE,		0},
	{ "VALUE28",		'C',	VALUE_SIZE,		0},
	{ "STATUS28",		'C',	STATUS_SIZE,		0},
	{ "VALUE29",		'C',	VALUE_SIZE,		0},
	{ "STATUS29",		'C',	STATUS_SIZE,		0},
	{ "VALUE30",		'C',	VALUE_SIZE,		0},
	{ "STATUS30",		'C',	STATUS_SIZE,		0},
	{ "VALUE31",		'C',	VALUE_SIZE,		0},
	{ "STATUS31",		'C',	STATUS_SIZE,		0},
	{ "VALUE32",		'C',	VALUE_SIZE,		0},
	{ "STATUS32",		'C',	STATUS_SIZE,		0},
	{ "VALUE33",		'C',	VALUE_SIZE,		0},
	{ "STATUS33",		'C',	STATUS_SIZE,		0},
	{ "VALUE34",		'C',	VALUE_SIZE,		0},
	{ "STATUS34",		'C',	STATUS_SIZE,		0},
	{ "VALUE35",		'C',	VALUE_SIZE,		0},
	{ "STATUS35",		'C',	STATUS_SIZE,		0},
	{ "VALUE36",		'C',	VALUE_SIZE,		0},
	{ "STATUS36",		'C',	STATUS_SIZE,		0},
	{ "VALUE37",		'C',	VALUE_SIZE,		0},
	{ "STATUS37",		'C',	STATUS_SIZE,		0},
	{ "VALUE38",		'C',	VALUE_SIZE,		0},
	{ "STATUS38",		'C',	STATUS_SIZE,		0},
	{ "VALUE39",		'C',	VALUE_SIZE,		0},
	{ "STATUS39",		'C',	STATUS_SIZE,		0},
	{ "VALUE40",		'C',	VALUE_SIZE,		0},
	{ "STATUS40",		'C',	STATUS_SIZE,		0},
	{ "VALUE41",		'C',	VALUE_SIZE,		0},
	{ "STATUS41",		'C',	STATUS_SIZE,		0},
	{ "VALUE42",		'C',	VALUE_SIZE,		0},
	{ "STATUS42",		'C',	STATUS_SIZE,		0},
	{ "VALUE43",		'C',	VALUE_SIZE,		0},
	{ "STATUS43",		'C',	STATUS_SIZE,		0},
	{ "VALUE44",		'C',	VALUE_SIZE,		0},
	{ "STATUS44",		'C',	STATUS_SIZE,		0},
	{ "VALUE45",		'C',	VALUE_SIZE,		0},
	{ "STATUS45",		'C',	STATUS_SIZE,		0},
	{ "VALUE46",		'C',	VALUE_SIZE,		0},
	{ "STATUS46",		'C',	STATUS_SIZE,		0},
	{ "VALUE47",		'C',	VALUE_SIZE,		0},
	{ "STATUS47",		'C',	STATUS_SIZE,		0},
	{ "VALUE48",		'C',	VALUE_SIZE,		0},
	{ "STATUS48",		'C',	STATUS_SIZE,		0},
	{ "VALUE49",		'C',	VALUE_SIZE,		0},
	{ "STATUS49",		'C',	STATUS_SIZE,		0},
	{ "VALUE50",		'C',	VALUE_SIZE,		0},
	{ "STATUS50",		'C',	STATUS_SIZE,		0},
	{ "VALUE51",		'C',	VALUE_SIZE,		0},
	{ "STATUS51",		'C',	STATUS_SIZE,		0},
	{ "VALUE52",		'C',	VALUE_SIZE,		0},
	{ "STATUS52",		'C',	STATUS_SIZE,		0},
	{ "VALUE53",		'C',	VALUE_SIZE,		0},
	{ "STATUS53",		'C',	STATUS_SIZE,		0},
	{ "VALUE54",		'C',	VALUE_SIZE,		0},
	{ "STATUS54",		'C',	STATUS_SIZE,		0},
	{ "VALUE55",		'C',	VALUE_SIZE,		0},
	{ "STATUS55",		'C',	STATUS_SIZE,		0},
	{ "VALUE56",		'C',	VALUE_SIZE,		0},
	{ "STATUS56",		'C',	STATUS_SIZE,		0},
	{ "VALUE57",		'C',	VALUE_SIZE,		0},
	{ "STATUS57",		'C',	STATUS_SIZE,		0},
	{ "VALUE58",		'C',	VALUE_SIZE,		0},
	{ "STATUS58",		'C',	STATUS_SIZE,		0},
	{ "VALUE59",		'C',	VALUE_SIZE,		0},
	{ "STATUS59",		'C',	STATUS_SIZE,		0},
	{ "VALUE60",		'C',	VALUE_SIZE,      	0},
	{ "STATUS60",		'C',	STATUS_SIZE,		0},
	{0, 0, 0, 0}		/* NULL-record terminator */
};


TAG4INFO	snapTags [] =	{
	{ "METH_RATE",	"STR(YEAR,4,0)+STR(DAYOFYEAR,3,0)+STR(HOUR,2,0)+STR(OFFSET_MIN,2,0)+POINTNAME+RED_METHOD+RATE+STR(RECNO(),8,0)", 0, 0, 0},
	{ "METHOD_REC",	"POINTNAME+RED_METHOD+STR(YEAR,4,0)+STR(DAYOFYEAR,3,0)+STR(HOUR,2,0)+STR(OFFSET_MIN,2,0)+STR(RECNO(),8,0)", 0, 0, 0},
	{0, 0, 0, 0, 0}		/* NULL-record terminator */
};

FIELD4INFO	notesFields [] = {
   /* field name,   type, width, decimals */
   { "POINTNAME",   'C',    POINTNAME_SIZE, 0 },
   { "YEAR",	    'N',    YEAR_SIZE,      0 },
   { "DAYOFYEAR",   'N',    DAY_SIZE,       0 },
   { "HOUR",	    'N',    HOUR_SIZE,      0 },
   { "MINUTE",	    'N',    MIN_SIZE,       0 },
   { "SECOND",	    'N',    SECOND_SIZE,    0 },
   { "NOTE",	    'M',    10,    0 },
   { 0, 0, 0, 0 },
};

TAG4INFO notesTags [] = {
   /* name,	    expression,	filter, unique,	     descending */
   { "MEMO_REC", "POINTNAME+STR(YEAR,4)+STR(DAYOFYEAR,3)+STR(HOUR,2)+STR(MINUTE,2)+STR(SECOND,2)",	"", 0, 0 },
   { 0, 0, 0, 0, 0 },
};

/*----------*/
main (int argc, char *argv[])
{
    int		year, dayOfYear, hour, min, stat, sampleCnt, cnt;
    char	tablename [200];
    char	pointName [50], method [40];
    char	recPointName [50], recMethod [4];
    char	key [50], value [10], status [4];
    double	recInterval, interval;
    char	tempstring [80];
    int		i;
    int		numrecs;
    int		rateIsSeconds = 0;
    time_t	earliest_time;
    time_t	cat_time;
    time_t	latest_time;
    time_t	startDate;
    time_t	endDate;
    time_t	prevDay;
    time_t	currentDay;
    int		online;
    struct tm	*tmblock;

	if (argc != 3)
	{
	    printf ("Usage: xbaseSnap <table_name> <fileName>\n");
	    printf ("  Exports X-base data from oracle tables.\n");
	    printf ("    target fileName (an X-base file)\n");
	    printf ("      '-' for <fileName> means /tis4000db/ar_snap\n");
	    exit (-1);
	}

	d4init (&cb);
	cb.open_error = 0;
	cb.create_error = 0;

	openSnap ((strcmp (argv [1], "-") == 0) ? "/tis4000db/ar_snap" : argv [2]);

	strncpy (tablename, argv[1], sizeof(tablename));

	OpenOracle ();
	od = MakeSnapDesc (NULL, tablename);
	if (od == NULL)
	{
	    printf ("Can't set up snap descriptor\n");
	    exit (-2);
	}
	OpenSnapTable ( od, NULL );

	rateIsSeconds = (f4len(rateFld) != 2);
 	numrecs = 0;
	/* get eldest date in trend_data, start archiving records stamped before the next day */
	stat = GetSnapRecsByTime (od, 0, time(0), &snaprec);
	prevDay = 0;
        if (stat)
	{   
	    tmblock = gmtime ((time_t *)&snaprec.rec_time);
	    currentDay = snaprec.rec_time - (tmblock->tm_hour*3600 + tmblock->tm_min*60 + tmblock->tm_sec)
			 + 86400 /* 1 day in seconds */;

	    /* Transfer each day of data for each point into the archive */
	    stat = GetSnapRecsByTime (od, prevDay, currentDay, &snaprec);
	    while (stat)
	    {
		/* write the records into the xbase file */
		do {
		    xbaseWriteRecord (&snaprec);
		    numrecs++;
		} while (NextSnapRecByTime (od, &snaprec));
		CommitAll ();
		prevDay = currentDay; /* move record set forward */
		currentDay += 86400; /* add 1 days worth of seconds */
		stat = GetSnapRecsByTime (od, prevDay, currentDay, &snaprec);
		printf ("Processed %d records\n", numrecs);
	    }
	    EndSnapRecByTime (od);
	}
/***** move the notes table too!! *****/

	closeSnap ();
	CloseOracle ();
	printf ("\nOracleSnap completed, processed %d records\n", numrecs);
	return 1;
}

/*----------*/
static void openSnap (fileName)
char	*fileName;
{
    int		i;
    char	buf [20];
    T4TAG	*t;

	/* Open the ar_snap database.  If it does not exist, make it */
	arSnapDesc = d4open (&cb, fileName);
	if (arSnapDesc == NULL)
	{
	    arSnapDesc = d4create (&cb, fileName, snapFields, snapTags);
	    if (arSnapDesc == NULL)
	    {
		printf ("Unable to create xbase file %s\n", fileName);
		exit (1);
	    }
	}
	t = d4tag (arSnapDesc, "METHOD_REC");
	d4tag_select (arSnapDesc, t);
	d4top (arSnapDesc);
	d4unlock_all (arSnapDesc);

	/* Open up all the fields */
	pointNameFld = d4field (arSnapDesc, "POINTNAME");
	eguTagFld = d4field (arSnapDesc, "EGUTAG");
	dispLowFld = d4field (arSnapDesc, "DISP_LOW");
	dispHighFld = d4field (arSnapDesc, "DISP_HIGH");
	yearFld = d4field (arSnapDesc, "YEAR");
	dayOfYearFld = d4field (arSnapDesc, "DAYOFYEAR");
	hourFld = d4field (arSnapDesc, "HOUR");
	offsetMinFld = d4field (arSnapDesc, "OFFSET_MIN");
	sampleCntFld = d4field (arSnapDesc, "SAMPLE_CNT");
	redMethodFld = d4field (arSnapDesc, "RED_METHOD");
	rateFld = d4field (arSnapDesc, "RATE");
	for (i=0 ; i < 60 ; i++)
	{
	    sprintf (buf, "VALUE%d", i + 1); 
	    valueFld [i] = d4field (arSnapDesc, buf);
	    sprintf (buf, "STATUS%d", i + 1); 
	    statusFld [i] = d4field (arSnapDesc, buf);
	}
}

/*----------*/
static void closeSnap ()
{
	d4close (arSnapDesc);
}

/*----------*/
void stripBlanks (buf)	/* Strip blanks from a string */
char	*buf;
{
	while (*buf)
	{
	    if (*buf == ' ')
	    {
		*buf = '\0';
		return;
	    }
	    buf++;
	}
}

static void xbaseWriteRecord (SnapRec *snaprec)
{
    int		ix;
    char	valstring [12];
    struct tm	*tmblock;

	/* Create a new record */
	d4top (arSnapDesc);
	if (d4deleted (arSnapDesc))
	{
	    /* load 'em up */
	    f4assign (pointNameFld, snaprec->pointname);
	    f4assign (redMethodFld, snaprec->red_method);
	    tmblock = gmtime (&snaprec->rec_time);
	    f4assign_int (yearFld, tmblock->tm_year+1900);
	    f4assign_int (dayOfYearFld, tmblock->tm_yday);
	    f4assign_int (hourFld, tmblock->tm_hour);
	    f4assign_int (offsetMinFld, tmblock->tm_min);
	    if (rateIsSeconds)
	    {
		f4assign_int (rateFld, snaprec->rate);
	    }
	    else
	    {
		sprintf (valstring, "%f", ((double)snaprec->rate)/60.);
		if (valstring[0] == '0')
		    f4assign_n (rateFld, &valstring[1], 2);
		else
		    f4assign_int (rateFld, snaprec->rate/60);
	    }
	    f4assign_int (sampleCntFld, snaprec->sample_cnt);
	    f4ncpy (eguTagFld, snaprec->egutag, sizeof(snaprec->egutag));
	    f4assign_double (dispLowFld, snaprec->disp_low);
	    f4assign_double (dispHighFld, snaprec->disp_high);
	    for (ix = 0; ix < snaprec->sample_cnt; ix++)
	    {
		sprintf (valstring, "%.9f", snaprec->value[ix]);
		f4assign (valueFld [ix], valstring);
		f4assign (statusFld [ix], snaprec->status[ix]);
	    }
	    d4recall(arSnapDesc);
	}
	else
	{
	    d4append_start (arSnapDesc, 0);
	    d4blank (arSnapDesc);
	    /* load 'em up */
	    f4assign (pointNameFld, snaprec->pointname);
	    f4assign (redMethodFld, snaprec->red_method);
	    tmblock = gmtime (&snaprec->rec_time);
	    f4assign_int (yearFld, tmblock->tm_year+1900);
	    f4assign_int (dayOfYearFld, tmblock->tm_yday);
	    f4assign_int (hourFld, tmblock->tm_hour);
	    f4assign_int (offsetMinFld, tmblock->tm_min);
	    if (rateIsSeconds)
	    {
		f4assign_int (rateFld, snaprec->rate);
	    }
	    else
	    {
		sprintf (valstring, "%f", ((double)snaprec->rate)/60.);
		if (valstring[0] == '0')
		    f4assign_n (rateFld, &valstring[1], 2);
		else
		    f4assign_int (rateFld, snaprec->rate/60);
	    }
	    f4assign_int (sampleCntFld, snaprec->sample_cnt);
	    f4ncpy (eguTagFld, snaprec->egutag, sizeof(snaprec->egutag));
	    f4assign_double (dispLowFld, snaprec->disp_low);
	    f4assign_double (dispHighFld, snaprec->disp_high);
	    for (ix = 0; ix < snaprec->sample_cnt; ix++)
	    {
		sprintf (valstring, "%.9f", snaprec->value[ix]);
		f4assign (valueFld [ix], valstring);
		f4assign (statusFld [ix], snaprec->status[ix]);
	    }
	    d4append (arSnapDesc);
	    d4flush_all (arSnapDesc);
#ifndef CB51
	    d4update_header (arSnapDesc, TRUE, TRUE);
#endif
	}
}
