/*
// This is the re-write of the ODSS program. C++ was chosen to bring the code into
// the 90's. The main class "odssClass" contains all the data and functions used to 
// implement the program. The constructor connect with the client. The "run" method
// checks the incoming network stream for known message types and switches to the proper
// member function to handle the command.
//
// Greg Tomalesky
*/
#ifndef	INCodssappH
#define	INCodssappH

#include "odss.h"

#ifndef	WIN32
#define	SOCKET		    int
#define	INVALID_SOCKET	    (-1)
#define	SOCKET_ERROR	    (-1)
#else
typedef	char *		    caddr_t;
#endif

/* unions of msgs */
#define ODSS_ERROR_SUCCESS 0
#define ODSS_ERROR_CA 1
#define	V_DEBUG	3
#define	V_STATUS 2
#define	V_INFO	1
#define CTL_ALLOC	50
#define CA_CHECK_TIME 2 /* 2 seconds between checks */
#define CA_ACK_TIME 10 /* 10 seconds to wait for CA activity */
typedef struct odssCtl ODSSCTL;

struct odssCtl
{
  ODSSCTL *nextCtl;
  chid channel;
  evid event;
  int handle;
  short	nativeType;
  short	nativeCount;

  time_t buildAckTimer;
  short	awaitAck;

  time_t readTimer;
  short readTimeout;
  short	readPending;

  time_t writeTimer;
  short	writeRdbkPending;
  short	writeRdbkTimeout;
};
  ODSSCTL *newCtl(void);
  ODSSCTL *findCtl(int handle);
  int appRun(SOCKET fd);
  /* message handler functions */
  int buildChannel();
  /* support functions */
  void connectionHandler(struct connection_handler_args connArgs);
  void monitorHandler(struct event_handler_args args);
  void readHandler(struct event_handler_args args);
  void writeHandler(struct event_handler_args args);
  void odssSignalHandler(int whichone);
  int flushClient(void);
  int fillClientBuffer(void);
  int handleClientMsgs();
  int haveCompleteClientMsg(void);
  void readClient(char *buff, int nbytes);
  void closeClientChannels(void);
  int writeClient(short msgType, char *buff1, int buff1Size, char *buff2, int buff2Size);
  void deleteCtl(ODSSCTL *oldCtl);

#endif	INCodssappH
