#ifndef opnotedb_h
#define opnotedb_h

#ifdef __cplusplus
extern "C"
{
#endif __cplusplus
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#ifdef __cplusplus
}
#endif __cplusplus

#ifdef	WIN32
#    define OPNOTEDATABASE	"\\tis4000db\\opnotes.dbf"
#else
#    define OPNOTEDATABASE	"/tis4000db/opnotes.dbf"
#endif	WIN32

#define	TIME_SIZE	10	/* must agree with TIME field in 
				   opnotes.dbf def see opnotedb.c
				*/
#define OP_SIZE		30
#define KEY_SIZE	32
#define MAX_NOTE	1024
#define MAXKEYITEMS	512
#define MAXKEYLEN	132
#define	MAXERRMSG	128
#define	MAXBLOCK_SIZE	1024
#define	MAX_NOTEPATH	80

#define DBNOTFOUND	0
#define DBOK		1
#define DBNOTESERR	2
#define	DBSERVERERR	3

#define NORECORD	0
#define RECFOUND	1
#define RECAFTER	2

#define FILTOK		0
#define FILTOUT		1
#define FILTOUTOFRANGE	2

typedef struct
{
    time_t	time;			/* note time */
    char	op [OP_SIZE+1];		/* operator */
    char	keytype [KEY_SIZE+1];	/* key class */
    char	keyvalue [KEY_SIZE+1];	/* key value */
    char	text [MAX_NOTE+1];	/*note text */
} OpNoteRecord;

typedef struct {
    time_t	start;			/* start time */
    time_t	end;			/* end time */
    char	op [OP_SIZE+1];		/* operator */
    char	keytype [KEY_SIZE+1];	/* key class */
    char	keyvalue [KEY_SIZE+1];	/* key value */
    char	search_text [MAX_NOTE+1]; /*note text */
} Filter;

#ifdef __cplusplus
extern "C"
{
#endif __cplusplus
/* for TIS functions */
int OperPriv (C4CODE *codeBaseDesc, char *privilege);
#ifdef __cplusplus
}
#endif __cplusplus

int		openNotefile ( char *dbfile, int create );
void		RelNotes (void );
int		CloseNotes (void );
OpNoteRecord	*GetNote ( Filter *filt, long time );
OpNoteRecord	*NextNote ( Filter *filt, long time );
OpNoteRecord	*GetPrevNote ( Filter *filt, long time );
int		SaveNote ( OpNoteRecord *rec, char *dbfile );
int		DeleteNote ( OpNoteRecord *rec );
void		trimblanks (char *pstr);

char		**GetKeytypes (char *errmsg );
char		**GetKeyValues ( char *keytype, char *errmsg );
int		WriteKeyValue ( char *keytype, char *keyvalue, char *msg);
int		DeleteKeyValue ( char *keytype, char *keyvalue, char *msg);
int		DeleteKeyType (char *keytype, char *msg);
void		freeItems (char **stringPtr);
int		getPrivilege (char *privilege);

#endif opnotedb_h

