/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This program will display a MOTIF style message box
	warning the user of a impending logout from the tis4000
	system. This is invoked from the "tisCard" utility 60
	seconds before the user is logout.

	Greg Tomalesky (from code by Grant Irani (from code by Greg Tomalesky))
	19-nov-1996
*/
#include	<X11/Intrinsic.h>
#include	<Xm/Xm.h>
#include	<Xm/MessageB.h>
#include	<time.h>

void	reqExit(Widget w,XtPointer tag,XtPointer reason);
Widget	reqCreateMessageBox(Widget parent, char *msgString, char *titleString, unsigned char msgType);
XtAppContext	app;
Widget		topLevel, msgBox;
Widget		operToplevel;
String fallbacks[] =
{
  "autoLogWarn*XmMessageBox.background: gold",
  "autoLogWarn*XmMessageBox.foreground: black",
  "autoLogWarn*fontList: 8x13bold",
  NULL
};

/* autoLogoutWarning */
void	main(int argc, char *argv[])
{
/*  Display		*operdpy; */
  char		msgString[2048];
  unsigned char	type;

  type = XmDIALOG_WARNING;
  topLevel = XtVaAppInitialize(&app,"autoLogWarn", NULL, 0, &argc, argv, fallbacks,XmNallowShellResize, True, NULL);

/*   operdpy = XtOpenDisplay (app, ":0.0", argv[0], "autoLogoutWarning", NULL, 0, &argc, argv); */
/*   operToplevel = XtAppCreateShell (argv[0], "", applicationShellWidgetClass,operdpy, NULL,0); */
  sprintf(msgString,"User\n%s\n will be logged out in 60 seconds",argv[1]);
  type = XmDIALOG_WARNING;

  /* create the proper message box */
  msgBox = reqCreateMessageBox(topLevel, msgString, "Auto Logout Warning", type);

  XtRealizeWidget(topLevel);
  XtAppMainLoop(app);
}

/*
	generic message box creator
*/
Widget	reqCreateMessageBox (Widget parent, char *msgString, char *titleString, unsigned char msgType)
{
  XmString	msg, title;
  Widget	msgbox;

  msg = XmStringCreateLtoR (msgString,XmSTRING_DEFAULT_CHARSET);
  title = XmStringCreateSimple (titleString);
  msgbox = XtVaCreateManagedWidget ("Warning", xmMessageBoxWidgetClass, parent,
				    XmNdialogTitle,title,
				    XmNautoUnmanage,True,
				    XmNmessageAlignment,XmALIGNMENT_CENTER,
				    XmNdialogType,msgType,
				    XmNmessageString,msg,
				    NULL);
  XtAddCallback (msgbox,XmNokCallback, reqExit,0);
  XtUnmanageChild (XmMessageBoxGetChild(msgbox, XmDIALOG_HELP_BUTTON));
  XtUnmanageChild (XmMessageBoxGetChild(msgbox, XmDIALOG_CANCEL_BUTTON));
  XmStringFree (msg);
  XmStringFree (title);
  return(msgbox);
}


/*
	Cancel - exit program.
*/
void	reqExit(Widget w,XtPointer tag,XtPointer reason)
{
  exit(1);
}

