/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


// PasswdShell.C

#include <Gina/Gina.h>

extern "C"
{
#include "logutils.h"
#ifndef MIPSEL
#include "memory.h"
#endif
#include "msgMon.h"
}

#include <stdlib.h>

#include "passwdShell.h"
#include "operDefs.h"
#include "utilDialogs.h"
#include "crypt.h"

extern	PasswdShell	*thePasswdShell;
extern	OperatorList	operList;
extern	int		numOperators;
extern	char		loginFilePath [];
extern	char		displayHost [];
extern	PasswdShell	*thePasswdShell;

char userName [USERNAME_SIZE+2];

//----------
PasswdShell::PasswdShell (GnDocument *doc, int width, int height) : PasswdDialog (doc, width, height)

    {

	document = doc;

    }

//----------
PasswdShell::~PasswdShell (void)

    {

    }

//----------
void PasswdShell::after_create (void)

    {

	PasswdDialog :: after_create ();

	// Set up callbacks for the buttons

	okButton.add_activateCallback (CALLBACK (PasswdShell, okButtonCallback, this));
	cancelButton.add_activateCallback (CALLBACK (PasswdShell, cancelButtonCallback, this));

	// Read in the current user name

	char pathName [100];
	sprintf (pathName, "/tis4000/operators/logins/%s", getDisplayHost ());
	FILE *f = fopen (pathName, "r");
	if (f == NULL) {
	    tisSysLog (0,0, "tisPasswd(%d): Cannot change password when no operator logged in!",
			getpid ());
	    exit (-1);
	}

	fgets (userName, sizeof (userName), f);
	fclose (f);
	userName [strlen (userName) - 1] = '\0';	// Strip newline

	if (strcmp (userName, "nooperator") == 0) {
	    tisSysLog (0,0, "tisPasswd(%d): Cannot change password when no operator logged in!",
			getpid ());
	    exit (-1);
	}

    }

//----------
void PasswdShell::okButtonCallback (caddr_t)

    {

	// Find the selection in the list

	for (int i=0 ; i<numOperators ; i++)
	    if (strcmp (operList [i].name, userName) == 0)
		break;

	// See if the old password matches

	char cryptedPassword [PASSWORD_SIZE*2+1], password [PASSWORD_SIZE+1];
	strcpy (password, oldPasswordField.get_string ());
	strcpy (cryptedPassword, password);
	encryptPassword (cryptedPassword);
	if (((strcmp (operList [i].password, "*") == 0) && (strlen (password) == 0))
			|| (strcmp (operList [i].password, cryptedPassword) == 0)) {

	    char newPassword [PASSWORD_SIZE*2+1];
	    strcpy (newPassword, newPassword1Field.get_string ());
	    if (strcmp (newPassword, newPassword2Field.get_string ()) == 0) {

		// Put the new password file in the operator list

		if (strlen (newPassword) > 0)
		    encryptPassword (newPassword);
		strcpy (operList [i].password, newPassword);
		makeLogEntry (userName, displayHost, PASSWD_CHANGE_BYUSER);

		// Write the operators file

		FILE *f = fopen ("/tis4000/operators/tisOperators", "w");
		for (int i=0 ; i<numOperators ; i++)
		    if (!operList [i].deleted)
			if (strlen (operList [i].password))
			    fprintf (f, "%s %s\n", operList [i].name, operList [i].password);
			else
			    fprintf (f, "%s *\n", operList [i].name);
		fclose (f);

		exit (0);
	    } else {
		error_dialog (mainForm, "New passwords do not match!");
		makeLogEntry (userName, displayHost, PASSWD_CHANGE_NOMATCH);
	    }
	} else {
	    error_dialog (mainForm, "Invalid old password!");
	    makeLogEntry (userName, displayHost, PASSWD_CHANGE_BADOLD);
	}
    }

//----------
void PasswdShell::cancelButtonCallback (caddr_t)

    {

	exit (-1);

    }

