/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#ifdef SOLARIS
#include <string.h>
#else
#include <strings.h>
#endif

#include <Gina/Gina.h>

extern "C"
{
#include "ctype.h"
#include "logutils.h"

#ifndef MIPSEL
#include "memory.h"
#endif
}

#include "passwdShell.h"
#include "operDefs.h"

// System error passwds options

#define	LOG_OPTIONS	LOG_ALERT | LOG_LOCAL1

class PasswdDocument : public GnDocument {
public:
    void	CreateWindows(int new_width, int new_height);    
protected:
    PasswdDialog *passwdDialog;
};

class PasswdApplication : public GnApplication {
public:
		PasswdApplication (void);
    GnDocument	*CreateDocument ( );
    char	*app_class () { return "tispasswd" ; }
    char	*app_signature() { return "tispasswd" ; }
    char	*app_file_type() { return ".tispasswd" ; }
    void	IdleAction ();
private:
    GnDocument	*document;
    int		titlesInitialized;
};

PasswdDocument		*thePasswdDocument;
PasswdShell		*thePasswdShell;

// List of possible operators

OperatorList	operList;
int		numOperators;
char		displayHost [50];

//----------
PasswdApplication :: PasswdApplication (void)

    {


	titlesInitialized = 0;

	// Build a list of names and passwords

	FILE *f;
	f = fopen ("/tis4000/operators/tisOperators", "r");
	numOperators = 0;
	while (fscanf (f, "%s %s", operList [numOperators].name, operList [numOperators].password) == 2)
	    numOperators++;
	fclose (f);

	// Get the display host

	strcpy (displayHost, getDisplayHost ());

    }

//----------
GnDocument *PasswdApplication :: CreateDocument ( )

    {

	PasswdDocument *document;

	// Initialize things

	document = new PasswdDocument;

	thePasswdDocument = document;
	thePasswdShell = NULL;

	return document;

    }

//----------
void PasswdApplication :: IdleAction ()

    {

	if (!titlesInitialized) {
	    thePasswdDocument->GetMainShell ()->setR_title ("TIS4000 Change Passwd");
	    thePasswdDocument->GetMainShell ()->setR_iconName("tisPasswd");
	    thePasswdDocument->GetMainShell ()->SetValues();
	    titlesInitialized = 1;
	}

    }

//----------
void PasswdDocument :: CreateWindows(int /*new_width*/, int /*new_height*/)

    {

	thePasswdShell = new PasswdShell (this, 500, 800);

	SetMainShell (thePasswdShell);
	GetMainShell ()->create(APPLICATION->GetApplicationShell(), "shell");

    }

//----------
int main (unsigned int /*argc*/, char ** argv)

    {

    PasswdApplication app;

    // Set up the idle timeout

    app.SetIdleTimeout (1000);

    app.Run ( 1, argv );
}

