/*dmMenus.c,v 1.1.1.1 1999/08/03 14:43:48 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifndef _XLIB_H_
#include <Xlib.h>
#endif
#ifndef _XUTIL_H_
#include <Xutil.h>
#endif
#include <cadef.h>
#include <dldef.h>
#include <dl_context.h>
#include <gizmo.h>
#include <GraphX.h>
#include <dynamic_def.h>
#include <dmMenus.h>

/****************************************************************************
*
*	dmMenus.c
*
*	Modification History
*	
*	    04/21/92	dk	Exit_display--added params to delete_plot for
*				fix that caused crash when plot display deleted
*/


init_dmMenu(pDisplay,pDm_llist_hdr)
Display *pDisplay;
struct dm_llist_hdr *pDm_llist_hdr;
{
/*
	GCT 21-Nov-1994

	The menu strings originally set in dmMenus.h must be set here
	to avoid compiler errors.
*/
display_menu[0] = "~cancel";
display_menu[1] = "~print display";
display_menu[2] = "~exit display window";
display_menu[3] = 0;

plot_menu[0] = "~clear plot";
plot_menu[1] = "~pause plot";
plot_menu[2] = "~print plot";
plot_menu[3] = "~autorange";
plot_menu[4] = "~cancel";
plot_menu[5] = 0;

strip_menu[0] = "~pause strip chart";
strip_menu[1] = "~resume strip chart";
strip_menu[2] = "~print strip_chart";
strip_menu[3] = "~cancel";
strip_menu[4] = 0;

	/* set up ptr to dm_llist_hdr to use in handler (dmExit_display)*/
	display_mc.pactions[EXIT_SELECT].arg = pDm_llist_hdr;
	init_menu(pDisplay, &display_mc);
}




do_dmMenu(pEvent, pDm_llist_el )
void *pEvent;
struct dm_llist_el *pDm_llist_el;
{
	post_menu(pEvent, &display_mc, pDm_llist_el);
}


void dmPrint_display(pUser, pDm_llist_el, event)
void *pUser;
struct dm_llist_el *pDm_llist_el;
XEvent *event;
{
    utilPrint(pDm_llist_el->dl_context.d,
		pDm_llist_el->dl_context.w,
		"/tis4000/temp/tmppspr");
    display_mc.selection = 0;
}

void dmExit_display(pDm_llist_hdr,pDm_llist_el,event)
struct dm_llist_hdr *pDm_llist_hdr;
struct dm_llist_el *pDm_llist_el;
XEvent *event;
{
	/* If the exit action is to iconize, do it and return */

	if ((event != -1) && (pDm_llist_el->pdl_hdr->exitaction == 1 /* iconize */) ) {
		XIconifyWindow (pDm_llist_el->dl_context.d, pDm_llist_el->dl_context.w,
				DefaultScreen (pDm_llist_el->dl_context.d));
		return;
	}

 	/* get rid of any associated plot windows, etc. */
	if(pDm_llist_el->prti_plot){
		delete_plots(pDm_llist_el->dl_context.d, pDm_llist_hdr->pNew_llist->win_context,
			pDm_llist_el->prti_plot, pDm_llist_el->pdl_hdr->nplot);
	}

	/* keep further events for this element from being processed after window deletion */

	XDeleteContext(pDm_llist_el->dl_context.d,
		pDm_llist_el->dl_context.w, 
		pDm_llist_hdr->pNew_llist->win_context);
	  
	/* delete from dm_llist and free associated  memory */
	delete_display(pDm_llist_hdr, pDm_llist_el);
}


void dmQuit_menu(pUser,pParam, event)
void *pUser;
void *pParam;
XEvent *event;
{
}


void dmPrint_plot(pUser, pRti_plot, the_event)
void *pUser;
struct rti_update_plot *pRti_plot;
XEvent the_event;
{
     pfoWinWritePSFile(pRti_plot->pPlot,
	"~psPrintFile");
    system("~lpr -Pcx1 psPrintFile");
}

void dmPause_plot(pUser, pRti_plot, the_event)
void *pUser;
struct rti_update_plot *pRti_plot;
XEvent *the_event;
{
}


void dmAutorange_plot(pUser, pRti_plot, the_event)
void *pUser;
struct rti_update_plot *pRti_plot;
XEvent *the_event;
{
     switch(pRti_plot->rti_plottype){
	case(5):
	case(6):
	case(7):
 	    break;
	default:
   	    pfoWinAutoRange( pRti_plot->pPlot);
    	    pfoWinRepaint( pRti_plot->pPlot,
		(enum dl_plot_style)((struct dl_plot *)pRti_plot->pDl_plot)->style,
		pRti_plot->rti_plottype);
	    break;
    }
}


void dmInitPlotMenu(pDisplay,pDm_llist_hdr)
Display *pDisplay;
struct dm_llist_hdr *pDm_llist_hdr;
{

	init_menu(pDisplay, &plot_mc);
}



void dmPlotMenu(pEvent, pRti_plot )
void *pEvent;
struct rti_update_plot *pRti_plot;
{
	post_menu(pEvent, &plot_mc, pRti_plot);
}





void dmClear_plot(pUser, pRti_plot, the_event)
void *pUser;
struct rti_update_plot *pRti_plot;
XEvent *the_event;
{

    enum dl_plot_style plot_style;
     switch(pRti_plot->rti_plottype){
	case(5):
	case(6):
	case(7):
	    plot_style = dl_point_plot;
 	    break;
	default:
	    plot_style = (enum dl_plot_style)((struct dl_plot *)pRti_plot->pDl_plot)->style;
	    break;
    }
     pfoWinRestart(pRti_plot->pPlot,
	plot_style,
	pRti_plot->rti_plottype);
}


void dmInitStripMenu(pDisplay,pDm_llist_hdr)
Display *pDisplay;
struct dm_llist_hdr *pDm_llist_hdr;
{
	init_menu(pDisplay, &strip_mc);
}



void dmStripMenu(pEvent, pStrip )
void *pEvent;
Strip 	*pStrip;
{
	post_menu(pEvent, &strip_mc, pStrip);
}

void dmPrint_strip(pArg, pStrip, event)
Strip 	*pStrip;
void 	*pArg;
XEvent 	*event;
{
    stripPrint(pStrip);
}

void dmPause_strip(pArg, pStrip, event)
Strip 	*pStrip;
void 	*pArg;
XEvent 	*event;
{
   stripPause(pStrip);
}
void dmUnpause_strip(pArg, pStrip, event)
Strip 	*pStrip;
void 	*pArg;
XEvent 	*event;
{
    stripResume(pStrip);
}
