#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/*t_updates.c,v 1.1.1.1 1999/08/03 14:43:51 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* this is the set of object update routines */
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include "dldef.h"
#include "dl_context.h"
#include "cadef.h"
#include "gizmo.h"
#include "dynamic_def.h"
#include "draw_strings.h"

FillRecLtToRt(pdl_context, prec, value, low_val, high_val, prectangle)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle *prectangle;
float value, low_val,high_val;
{
float percentage = (float)0.0;
int new_x, whereonrectangle, new_width;
unsigned long saveforegroundcolor;
short out_of_range;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;
if (prectangle->range == 0.0) 
	whereonrectangle = 0;
else 
	percentage = (float)((value - low_val)/prectangle->range);
if((prectangle->label_flag == dl_label_limits)||(prectangle->label_flag ==
							dl_label_channel)) {
/* the following is for testing out of range conditions for labels */
if(percentage < 0.0) {
	out_of_range = 1;
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->leftlimit_rectangle.x, 
		prectangle->leftlimit_rectangle.y,
		prectangle->leftlimit_rectangle.width,
		prectangle->leftlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, prectangle->out_of_range.string,
			prectangle->hdr.precision);
	prectangle->out_of_range.len =
			 strlen(prectangle->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->leftlimit_rectangle, pdl_context->pfont_table,
		prectangle->out_of_range.string,
		prectangle->out_of_range.len,
		box_begin);
}
else if(percentage > 1.0) {
	out_of_range = 1;
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
        XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->rightlimit_rectangle.x,
 		prectangle->rightlimit_rectangle.y,
		prectangle->rightlimit_rectangle.width,
		prectangle->rightlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, prectangle->out_of_range.string, 
			prectangle->hdr.precision);
	prectangle->out_of_range.len =
			 strlen(prectangle->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->rightlimit_rectangle, pdl_context->pfont_table,
		prectangle->out_of_range.string,
		prectangle->out_of_range.len,
		box_end);
}
else
	out_of_range = 0;
} /* end of label_flag check for labeling */
if(percentage > 1.0) percentage = (float)1.0;
    else
 	if(percentage < 0.0) percentage = (float)0.0;
	
whereonrectangle = (int)(prec->width*percentage);

/*new_x = prectangle->inside_x + whereonrectangle;
if(new_x == prectangle->inside_x + prec->width) new_x--;*//*stay off rectangle 
								outline*/ 
new_x = prec->x + whereonrectangle;
if(new_x == prec->x + prec->width) new_x--;
   else if((new_x==prec->x)&&(prectangle->label_flag != dl_label_none)) new_x++;
if(new_x < prectangle->old_x) {  /* erase part of rectangle */
	/* make foreground color = background for erasing */
	XSetForeground(pdl_context->d, pdl_context->gc, 
			values.background);
	/*new_width = prectangle->old_x - new_x;*/
	new_width = prec->x + prec->width - new_x;
	if(prectangle->label_flag == dl_label_none)
	   XFillRectangle(pdl_context->d, pdl_context->w, 
		pdl_context->gc, new_x, prec->y,
		new_width, prectangle->new_height+1);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, 
		pdl_context->gc, new_x, prectangle->inside_y,
		new_width, prectangle->new_height);
	/* put back original foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);	
	/* redraw other part of rectangle to pick up newest foreground color*/
	new_width = whereonrectangle;
	if(new_width != 0)
	   if(prectangle->label_flag == dl_label_none) {
	 	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		   prec->x, prec->y,
		   new_width, prectangle->new_height+1);
	   } else {
	       XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		   prectangle->inside_x, prectangle->inside_y,
		   new_width, prectangle->new_height);
	   }
	}
else
if(new_x > prectangle->old_x) {  /* add to part of filled rectangle */ 
	new_width = whereonrectangle - 1;
	if(new_width > 0)
	   if(prectangle->label_flag == dl_label_none){ 
		 XFillRectangle(pdl_context->d, pdl_context->w, 
		     pdl_context->gc, prec->x, 
		     prec->y, new_width+1, prectangle->new_height+1);
	   }
	   else {
	   XFillRectangle(pdl_context->d, pdl_context->w, 
		pdl_context->gc, prectangle->inside_x, 
		prectangle->inside_y, new_width, prectangle->new_height);
	   }

}
prectangle->old_x = new_x;

if((prectangle->label_flag == dl_label_limits) || (prectangle->label_flag ==
							dl_label_channel)) {
   /* decide whether to redraw limits in outline color */
   if((out_of_range) && (!prectangle->outofrange))
	prectangle->outofrange = 1;
   else if((!out_of_range) && (prectangle->outofrange)) {
	   prectangle->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->leftlimit_rectangle.x, 
		prectangle->leftlimit_rectangle.y,
		prectangle->leftlimit_rectangle.width,
		prectangle->leftlimit_rectangle.height);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->rightlimit_rectangle.x, 
		prectangle->rightlimit_rectangle.y,
		prectangle->rightlimit_rectangle.width,
		prectangle->rightlimit_rectangle.height);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  prectangle->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prectangle->leftlimit_rectangle, pdl_context->pfont_table,
		prectangle->left_limit.string, prectangle->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prectangle->rightlimit_rectangle, pdl_context->pfont_table,
		prectangle->right_limit.string, prectangle->right_limit.len,
		box_end);
     }
} /* end of label_flag check */
return 0;
}

update_meter(pdl_context, value, pmeter)

struct dl_context *pdl_context;
struct meter *pmeter;
float value;

{
int new_degree, old_degree;
unsigned long saveforegroundcolor;
/* the following should be in structure */
short out_of_range;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;


/* erase old vector.  draw new meter indicator */
old_degree = pmeter->old_degree;
if(pmeter->full_range ==  0.0)
	new_degree = 0;
else  
	new_degree = (int)((value - pmeter->low_val)*180/pmeter->full_range);
if((pmeter->label_flag == dl_label_limits)||(pmeter->label_flag ==
							dl_label_channel)) {
/* the following is for testing out of range conditions for labels */
if(new_degree < 0.0) {
	out_of_range = 1;
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->leftlimit_rectangle.x, pmeter->leftlimit_rectangle.y+1,
		pmeter->leftlimit_rectangle.width,
		pmeter->leftlimit_rectangle.height-1);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, pmeter->out_of_range.string, pmeter->hdr.precision);
	pmeter->out_of_range.len =
			 strlen(pmeter->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pmeter->leftlimit_rectangle, pdl_context->pfont_table,
		pmeter->out_of_range.string,
		pmeter->out_of_range.len,
		box_begin);
}
else if(new_degree > 180.0) {
	out_of_range = 1;
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
        XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,			      			pmeter->rightlimit_rectangle.x, 						     pmeter->rightlimit_rectangle.y+1,
		pmeter->rightlimit_rectangle.width,
		pmeter->rightlimit_rectangle.height-1);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, pmeter->out_of_range.string, pmeter->hdr.precision);
	pmeter->out_of_range.len =
			 strlen(pmeter->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pmeter->rightlimit_rectangle, pdl_context->pfont_table,
		pmeter->out_of_range.string,
		pmeter->out_of_range.len,
		box_end);
}
else
	out_of_range = 0;
} /* end of label_flag check for labeling */
if(new_degree > 180) new_degree = 180;
	else 
	   if(new_degree < 0) new_degree = 0;

/* erase old line */
XSetForeground(pdl_context->d, pdl_context->gc,
			 values.background);
XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->center_x, pmeter->center_y, 
		pmeter->ppixels[old_degree].x1,
		pmeter->ppixels[old_degree].y1);
/* draw new line */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->center_x, pmeter->center_y,
		pmeter->ppixels[new_degree].x1,
		pmeter->ppixels[new_degree].y1);
/* draw small rectangle with foreground color */
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->center_x - pmeter->meter_width/8,
		pmeter->center_y - pmeter->meter_height/8,
		pmeter->meter_width/4, pmeter->meter_height/8);

/* redraw any needed tick marks.  redraw in outline color*/
XSetForeground(pdl_context->d, pdl_context->gc, pmeter->hdr.foregroundcolor);
if(pmeter->label_flag != dl_label_none) {
if(old_degree >= 90) {
	if(old_degree < 100)
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[90].x1, pmeter->ppixels[90].y1 - 2,
		pmeter->ppixels[90].x1, pmeter->ppixels[90].y1 +6);
        else if((old_degree > 102) && (old_degree < 122))
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[112].x1, pmeter->ppixels[112].y1,
		pmeter->ppixels[112].x1 - 1, pmeter->ppixels[112].y1 + 2);
	else if((old_degree > 125) && (old_degree < 145))
  	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[135].x1, pmeter->ppixels[135].y1,
		pmeter->ppixels[135].x1 - 4, pmeter->ppixels[135].y1 + 4);
	else if((old_degree > 147) && (old_degree < 167))
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[157].x1, pmeter->ppixels[157].y1,
		pmeter->ppixels[157].x1 - 2, pmeter->ppixels[157].y1 + 1);
}
else
   if(old_degree <= 90) {
	if(old_degree > 80)
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[90].x1, pmeter->ppixels[90].y1,
		pmeter->ppixels[90].x1, pmeter->ppixels[90].y1 + 6);
	else if((old_degree > 57) && (old_degree < 77))
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[67].x1, pmeter->ppixels[67].y1,
		pmeter->ppixels[67].x1 + 1, pmeter->ppixels[67].y1 +2);
	else if((old_degree > 35) && (old_degree < 55))
	    XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[45].x1, pmeter->ppixels[45].y1,
		pmeter->ppixels[45].x1 + 4, pmeter->ppixels[45].y1 + 4);
	else if((old_degree > 12) && (old_degree < 32))
	     XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[22].x1, pmeter->ppixels[22].y1,
		pmeter->ppixels[22].x1 + 2, pmeter->ppixels[22].y1 + 1);
}
if((pmeter->label_flag == dl_label_limits) || (pmeter->label_flag ==
							dl_label_channel)) {
   /* decide whether to redraw limits in outline color */
   if((out_of_range) && (!pmeter->outofrange))
	pmeter->outofrange = 1;
   else if((!out_of_range) && (pmeter->outofrange)) {
	   pmeter->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->leftlimit_rectangle.x, pmeter->leftlimit_rectangle.y+1,
		pmeter->leftlimit_rectangle.width,
		pmeter->leftlimit_rectangle.height-1);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->rightlimit_rectangle.x,
		pmeter->rightlimit_rectangle.y+1,
		pmeter->rightlimit_rectangle.width,
		pmeter->rightlimit_rectangle.height-1);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  pmeter->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pmeter->leftlimit_rectangle, pdl_context->pfont_table,
		pmeter->left_limit.string, pmeter->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pmeter->rightlimit_rectangle, pdl_context->pfont_table,
		pmeter->right_limit.string, pmeter->right_limit.len,
		box_end);
     }
} /* end of label_flag check */
}

/*reset to foreground color*/
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
pmeter->old_degree = new_degree;
return 0;
}

update_indicatorD(pdl_context, value, pindicator)

struct dl_context *pdl_context;
struct indicator *pindicator;
float value;
{
int new_x, whereonrectangle, tick, index;
float percentage;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;
/* erase old indicator value.  save current pixmap first*/
/*pindicator->indicator_save_pixmap = values.clip_mask;*/
/*XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);*/

XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
if((pindicator->points_array[1].x < pindicator->origin_x) ||
    (pindicator->points_array[2].x > pindicator->origin_x+ pindicator->width)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);	

/* decide whether to redraw a tick mark that may have been erased */
if(pindicator->space == 0) index = 0;
else
     index = (pindicator->old_x - pindicator->origin_x + 
			pindicator->half_space) /pindicator->space;
if(index == 2 || index == 4 || index == 6 || index == 8)
	tick = 5;
else
	tick = 3;
if(((pindicator->old_x + pindicator->run/2) >
	 pindicator->ticks[index].x1) &&
	((pindicator->old_x - pindicator->run/2)<pindicator->ticks[index].x1)) {
	/*set foreground color to original object outline color */
	   XSetForeground(pdl_context->d, pdl_context->gc,
		pindicator->hdr.foregroundcolor);
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks[index].x1, pindicator->origin_y - 1,
		pindicator->ticks[index].x2, pindicator->origin_y - 1 - tick);
}
/* set foreground color back to current foreground color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/*now draw new value */

if(pindicator->full_range == 0.0)
	whereonrectangle = 0;
else 
	percentage = (float)((value-pindicator->low_val)/pindicator->full_range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range = 2;
}
else 
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = 1;
	}

whereonrectangle = (int)(pindicator->width*percentage);

new_x = pindicator->origin_x + whereonrectangle; 
pindicator->points_array[0].x = new_x; 
pindicator->points_array[1].x = new_x - pindicator->run/2;
pindicator->points_array[2].x = new_x + pindicator->run/2; 
pindicator->points_array[3].x = new_x;
pindicator->points_array[0].y = pindicator->origin_y - 1; 
pindicator->points_array[1].y = pindicator->origin_y - pindicator->new_height;
pindicator->points_array[2].y = pindicator->origin_y - pindicator->new_height; 
pindicator->points_array[3].y = pindicator->origin_y - 1;

/* now draw new indicator value */
if((pindicator->points_array[1].x < pindicator->origin_x) ||
    (pindicator->points_array[2].x> pindicator->origin_x + pindicator->width)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/
/*reset clip mask*/
/*XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);*/
pindicator->old_x = new_x;

if((pindicator->label_flag == dl_label_limits)||(pindicator->label_flag ==
							dl_label_channel)) {
/* the following is for testing out of range conditions for labels */
if(out_of_range == 1) {     /* value was < 0.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->leftlimit_rectangle.x,
		pindicator->leftlimit_rectangle.y,
		pindicator->leftlimit_rectangle.width,
		pindicator->leftlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value,pindicator->out_of_range.string,
			pindicator->hdr.precision);
	pindicator->out_of_range.len =
			 strlen(pindicator->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pindicator->leftlimit_rectangle, pdl_context->pfont_table,
		pindicator->out_of_range.string,
		pindicator->out_of_range.len,
		box_begin);
}
else if(out_of_range == 2) {  /*value was > 1.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
        XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->rightlimit_rectangle.x,
 		pindicator->rightlimit_rectangle.y,
		pindicator->rightlimit_rectangle.width,
		pindicator->rightlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, pindicator->out_of_range.string,
			pindicator->hdr.precision);
	pindicator->out_of_range.len =
			 strlen(pindicator->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pindicator->rightlimit_rectangle, pdl_context->pfont_table,
		pindicator->out_of_range.string,
		pindicator->out_of_range.len,
		box_end);
	/*XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);*/
}

   /* decide whether to redraw limits in outline color */
   if((out_of_range != 0) && (!pindicator->outofrange))
	pindicator->outofrange = 1;
   else if((!out_of_range) && (pindicator->outofrange)) {
	   pindicator->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->leftlimit_rectangle.x,
		pindicator->leftlimit_rectangle.y+1,
		pindicator->leftlimit_rectangle.width,
		pindicator->leftlimit_rectangle.height);
 	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->rightlimit_rectangle.x,
		pindicator->rightlimit_rectangle.y+1,
		pindicator->rightlimit_rectangle.width,
		pindicator->rightlimit_rectangle.height);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  pindicator->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pindicator->leftlimit_rectangle, pdl_context->pfont_table,
		pindicator->left_limit.string, pindicator->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pindicator->rightlimit_rectangle, pdl_context->pfont_table,
		pindicator->right_limit.string, pindicator->right_limit.len,
		box_end);
     }
} /* end of label_flag check */
return 0;
}

update_indicatorU(pdl_context, value, pindicator)

struct dl_context *pdl_context;
struct indicator *pindicator;
float value;
{
int new_x, whereonrectangle, tick, index;
float percentage;
unsigned long saveforegroundcolor;
short out_of_range=0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;

/*erase old indicator value. first save current pixmap */
/*pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;*/
/*XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);*/

XSetForeground(pdl_context->d, pdl_context->gc, 
			values.background);
if((pindicator->points_array[1].x < pindicator->origin_x) ||
    (pindicator->points_array[2].x > pindicator->origin_x+ pindicator->width)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);	
/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4,Complex, CoordModeOrigin);*/


/* decide whether to redraw a tick mark that may have been erased */
if(pindicator->space == 0) index = 0;
else
     index = (pindicator->old_x - pindicator->origin_x + 
			pindicator->half_space) /pindicator->space;
if(index == 1 || index == 3 || index == 5 || index == 7)
	tick = 3;
else
	tick = 5;
if(((pindicator->old_x + pindicator->run/2) >
	 pindicator->ticks[index].x1) &&
	((pindicator->old_x - pindicator->run/2)<pindicator->ticks[index].x1)) {
        /* set foreground color to original outline color */
	   XSetForeground(pdl_context->d, pdl_context->gc, 
				pindicator->hdr.foregroundcolor);
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks[index].x1, pindicator->origin_y + 1,
		pindicator->ticks[index].x2, pindicator->origin_y + 1 + tick);
}
/* set foreground color back to original color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

if(pindicator->full_range == 0.0) {
   whereonrectangle = 0;
   percentage = (float)0.0;
}
else 
   percentage = (float)((value - pindicator->low_val)/pindicator->full_range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range = 2;
}
	else 
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = 1;
	   }

whereonrectangle = (int)(pindicator->width*percentage);

new_x = pindicator->origin_x + whereonrectangle;

pindicator->points_array[0].x = new_x; 
pindicator->points_array[1].x = new_x - pindicator->run/2;
pindicator->points_array[2].x = new_x + pindicator->run/2; 
pindicator->points_array[3].x = new_x;
pindicator->points_array[0].y = pindicator->origin_y + 1; 
pindicator->points_array[1].y = pindicator->origin_y + pindicator->new_height;
pindicator->points_array[2].y = pindicator->origin_y+pindicator->new_height; 
pindicator->points_array[3].y = pindicator->origin_y + 1;

if((pindicator->points_array[1].x < pindicator->origin_x) ||
    (pindicator->points_array[2].x > pindicator->origin_x+ pindicator->width)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);

/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/
/*reset clip mask*/
/*XSetClipMask(pdl_context->d,pdl_context->gc, pindicator->indicator_save_pixmap);*/

pindicator->old_x = new_x;
if((pindicator->label_flag == dl_label_limits)||(pindicator->label_flag ==
							dl_label_channel)) {
/* the following is for testing out of range conditions for labels */
if(out_of_range == 1) {     /* value was < 0.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->leftlimit_rectangle.x, 
		pindicator->leftlimit_rectangle.y,
		pindicator->leftlimit_rectangle.width,
		pindicator->leftlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value,pindicator->out_of_range.string,
			pindicator->hdr.precision);
	pindicator->out_of_range.len =
			 strlen(pindicator->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pindicator->leftlimit_rectangle, pdl_context->pfont_table,
		pindicator->out_of_range.string,
		pindicator->out_of_range.len,
		box_begin);
}
else if(out_of_range == 2) {  /*value was > 1.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
        XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,	
			  											pindicator->rightlimit_rectangle.x, 						  pindicator->rightlimit_rectangle.y,
		pindicator->rightlimit_rectangle.width,
		pindicator->rightlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value,pindicator->out_of_range.string,
				pindicator->hdr.precision);
	pindicator->out_of_range.len =
			 strlen(pindicator->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&pindicator->rightlimit_rectangle, pdl_context->pfont_table,
		pindicator->out_of_range.string,
		pindicator->out_of_range.len,
		box_end);
}

   /* decide whether to redraw limits in outline color */
   if((out_of_range != 0) && (!pindicator->outofrange))
	pindicator->outofrange = 1;
   else if((!out_of_range) && (pindicator->outofrange)) {
	   pindicator->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->leftlimit_rectangle.x,
		pindicator->leftlimit_rectangle.y+1,
		pindicator->leftlimit_rectangle.width,
		pindicator->leftlimit_rectangle.height);
 	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->rightlimit_rectangle.x,
		pindicator->rightlimit_rectangle.y+1,
		pindicator->rightlimit_rectangle.width,
		pindicator->rightlimit_rectangle.height);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  pindicator->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pindicator->leftlimit_rectangle, pdl_context->pfont_table,
		pindicator->left_limit.string, pindicator->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&pindicator->rightlimit_rectangle, pdl_context->pfont_table,
		pindicator->right_limit.string, pindicator->right_limit.len,
		box_end);
     }
} /* end of label_flag check */
return 0;
}

FillRecFromMid(pdl_context, prec, value, low_val, high_val, prec_mid)
struct dl_context *pdl_context;
struct rec_mid *prec_mid;
XRectangle *prec;
float low_val, high_val, value;

{

double percentage;
int  new_pixel_x, new_width, whereonrectangle;
unsigned long saveforegroundcolor, savebackgroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;
savebackgroundcolor = values.background;
if(value < 0) {
	percentage = value/prec_mid->low_val;
	if(percentage > 1.0) { 
		percentage = 1.0;
		out_of_range = 1;
	}
	
	whereonrectangle = (int)(prec_mid->negative_pixel_width * percentage);
	new_pixel_x = prec_mid->zero_point_x - whereonrectangle;
	if(prec_mid->old_x > prec_mid->zero_point_x) {
		/* then previous value was positive. erase positive rectangle,
		    then draw negative rectangle */
		new_width = prec_mid->old_x - prec_mid->zero_point_x;
/* reset foreground color to background color for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc, 
			values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 prec_mid->pos_x,
			 prec_mid->pos_y, prec_mid->positive_pixel_width,
			 prec_mid->inside_height);
/* reset foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		new_width = whereonrectangle;
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			new_pixel_x, prec_mid->pos_y,
			new_width, prec_mid->inside_height);
	}
	else
	if(prec_mid->old_x > new_pixel_x) {
		/* then need to add to negative filled area */
		new_width = whereonrectangle;
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 new_pixel_x, prec_mid->neg_y,
			new_width, prec_mid->inside_height);
		}
	else
	if(prec_mid->old_x < new_pixel_x) {
		/* then need to erase part of negative rectangle */
		new_width = new_pixel_x - prec_mid->old_x;
/* set foreground color to background color for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 prec_mid->old_x, 
			prec_mid->neg_y, new_width, prec_mid->inside_height);
/* reset foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		/* redraw remaining active area with current foreground color*/
		new_width = prec_mid->zero_point_x - new_pixel_x;
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 new_pixel_x, 
			prec_mid->neg_y, new_width, prec_mid->inside_height);

	}
}

else
if(value > 0) {
	percentage = value/prec_mid->high_val;
	if(percentage > 1.0) {
		percentage = 1.0;
		out_of_range = 2;
	}
			
	whereonrectangle = (int)(prec_mid->positive_pixel_width * percentage);
	new_pixel_x = prec_mid->pos_x + whereonrectangle;
	if(prec_mid->old_x < prec_mid->zero_point_x) {
		/* then previous value was negative.  erase entire negative
			 rectangle, then draw positive rectangle */
/* set foreground color to background color for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
 			prec_mid->neg_x, prec_mid->neg_y,
			prec_mid->negative_pixel_width,
			prec_mid->inside_height);
/* reset foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		new_width = new_pixel_x - prec_mid->pos_x;
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_mid->pos_x, prec_mid->pos_y, new_width,
			prec_mid->inside_height);
	}
	else
	if(prec_mid->old_x > new_pixel_x) {
		/* then need to erase part of positive area */
		new_width = prec_mid->old_x - new_pixel_x;
/* set foreground color to background for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 new_pixel_x, prec_mid->pos_y, new_width,
	 		 prec_mid->inside_height);
/* reset foreground color  to foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		new_width = new_pixel_x - prec_mid->pos_x;
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 prec_mid->pos_x, prec_mid->pos_y, new_width,
	 		 prec_mid->inside_height);

		}
	else
	if(prec_mid->old_x < new_pixel_x){
		/* then need to add to part of positive area */
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc, 
			prec_mid->pos_x, prec_mid->pos_y, whereonrectangle,
			prec_mid->inside_height);
	}
	
}
else
if(value == 0) {  /* erase all positive and negative rectangles */
/* set foreground color to background color for erasing */
	XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc, 
		prec_mid->pos_x, prec_mid->pos_y, 
		prec_mid->positive_pixel_width, 
		prec_mid->inside_height);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc, 
		prec_mid->neg_x, prec_mid->neg_y,
		prec_mid->negative_pixel_width, 
		prec_mid->inside_height);
	new_pixel_x = prec_mid->zero_point_x;
/* reset foreground color to foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);
} 

prec_mid->old_x = new_pixel_x;
if((prec_mid->label_flag == dl_label_limits) || (prec_mid->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, prec_mid->limits_rectangle.x,
				prec_mid->limits_rectangle.y,
				prec_mid->limits_rectangle.width/2,
				prec_mid->limits_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_mid->out_of_range.string,
					prec_mid->hdr.precision);
		   prec_mid->out_of_range.len =
				 strlen(prec_mid->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_mid->limits_rectangle,
			pdl_context->pfont_table, prec_mid->out_of_range.string,
			prec_mid->out_of_range.len, box_begin);
 		   XSetForeground(pdl_context->d, pdl_context->gc,
		  	prec_mid->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_mid->limits_rectangle,
			pdl_context->pfont_table, prec_mid->zero_index.string,
			prec_mid->zero_index.len, box_center);
		   break;
		case 2:    /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, prec_mid->limits_rectangle.x +
				prec_mid->limits_rectangle.width/2,
				prec_mid->limits_rectangle.y,
				prec_mid->limits_rectangle.width/2,
				prec_mid->limits_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_mid->out_of_range.string,
				prec_mid->hdr.precision);
		   prec_mid->out_of_range.len =
				 strlen(prec_mid->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_mid->limits_rectangle,
			pdl_context->pfont_table, prec_mid->out_of_range.string,
			prec_mid->out_of_range.len, box_end);
 		   XSetForeground(pdl_context->d, pdl_context->gc,
		  	prec_mid->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_mid->limits_rectangle,
			pdl_context->pfont_table, prec_mid->zero_index.string,
			prec_mid->zero_index.len, box_center);
		   break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
   if((out_of_range != 0) && (!prec_mid->outofrange))
	prec_mid->outofrange = 1;
   else if((!out_of_range) && (prec_mid->outofrange)) {
	   prec_mid->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_mid->limits_rectangle.x,prec_mid->limits_rectangle.y,
		prec_mid->limits_rectangle.width,
		prec_mid->limits_rectangle.height);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  prec_mid->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prec_mid->limits_rectangle, pdl_context->pfont_table,
		prec_mid->left_limit.string, prec_mid->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prec_mid->limits_rectangle, pdl_context->pfont_table,
		prec_mid->right_limit.string, prec_mid->right_limit.len,
		box_end);
	   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_mid->limits_rectangle,
			pdl_context->pfont_table, prec_mid->zero_index.string,
			prec_mid->zero_index.len, box_center);

     }
} /* end of label_flag check */
return 0;
}

fill_rect(pdl_context, prec, value, low_val, high_val, prec_v)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle_v *prec_v;
float low_val, value, high_val;

{
int whereonrectangle, new_y, new_height;
float percentage;
unsigned long saveforegroundcolor, savebackgroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;
savebackgroundcolor = values.background;

if(prec_v->full_range == 0.0) {
	whereonrectangle = 0;
	percentage = (float)0.0;
}
else 
   percentage = (float)((value-low_val)/prec_v->full_range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range =  prec_v->outofrange = 2;
}
	else
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = prec_v->outofrange = 1;
	   }
		
whereonrectangle = (int)(((unsigned int)(prec->height)-1)*percentage);

new_y = prec->y + 1 + whereonrectangle;
if(new_y > prec_v->old_y) {          /* add to filled area */
	new_height = new_y - (prec->y+2);  /*+2 to not write over end pt*/
	if(prec_v->label_flag == dl_label_none) 
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, prec->y, prec->width, whereonrectangle+1);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x,prec->y+1, prec_v->new_width, whereonrectangle);
}
else
if(new_y < prec_v->old_y) {         /* erase from filled area */
	new_height = prec_v->old_y - new_y;  
/* set foreground color to background color to erase */
	XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
	if(prec_v->label_flag == dl_label_none)
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, new_y, prec->width, new_height);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x, new_y, prec_v->new_width, new_height);
/*reset foreground color to foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
/* redraw remainder of rectangle in newest foreground color */
	new_height = new_y - (prec->y+1) ;
	if(prec_v->label_flag == dl_label_none)
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, prec->y, prec->width, new_height);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x, prec->y+1, prec_v->new_width, new_height);	
}
prec_v->old_y = new_y;
if((prec_v->label_flag == dl_label_limits) || (prec_v->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, prec_v->toplimit_rectangle.x,
				prec_v->toplimit_rectangle.y,
				prec_v->toplimit_rectangle.width,
				prec_v->toplimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_v->out_of_range.string,
					prec_v->hdr.precision);
		   prec_v->out_of_range.len =
				 strlen(prec_v->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->toplimit_rectangle,
			pdl_context->pfont_table, prec_v->out_of_range.string,
			prec_v->out_of_range.len, box_end);
		   break;
		case 2:    /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, 
				prec_v->bottomlimit_rectangle.x,
				prec_v->bottomlimit_rectangle.y,
				prec_v->bottomlimit_rectangle.width,
				prec_v->bottomlimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value, prec_v->out_of_range.string,
					prec_v->hdr.precision);
 		   prec_v->out_of_range.len =
				 strlen(prec_v->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->bottomlimit_rectangle,
			pdl_context->pfont_table, prec_v->out_of_range.string,
			prec_v->out_of_range.len, box_end);
		   break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
  
  if((out_of_range == 0) && (prec_v->outofrange)) {
	  
	   switch(prec_v->outofrange) {
		case 1:
	           XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
		      prec_v->toplimit_rectangle.x,prec_v->toplimit_rectangle.y,
		      prec_v->toplimit_rectangle.width,
	              prec_v->toplimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_v->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->toplimit_rectangle,
			pdl_context->pfont_table, prec_v->top_limit.string,
			prec_v->top_limit.len, box_end);       
		   break;
		case 2:
		    XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
			prec_v->bottomlimit_rectangle.x,
			prec_v->bottomlimit_rectangle.y,
		        prec_v->bottomlimit_rectangle.width,
	                prec_v->bottomlimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_v->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->bottomlimit_rectangle,
			pdl_context->pfont_table, prec_v->bottom_limit.string,
			prec_v->bottom_limit.len, box_end);       
		   break;
		case 0:
		   break;
	   } /* end of switch statement */
	prec_v->outofrange = 0;	
   } /* end of if stmt for redrawing limits in green */
} /* end of label_flag check */
return 0;
}


fill_recv(pdl_context, prec, value, low_val,high_val,prec_v)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle_v *prec_v;
float low_val, value, high_val;

{
int whereonrectangle, new_y, new_height;
float percentage;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;
if(prec_v->full_range == 0.0) {
	whereonrectangle = 0;
	percentage = (float)0.0;
}
else 
   percentage = (float)((value-low_val)/prec_v->full_range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range = prec_v->outofrange = 2;
}
	else
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = prec_v->outofrange = 1;
	   }
		
whereonrectangle = (int)(((unsigned int)(prec->height)-1)*percentage);

new_y = (prec->y+1) + (prec->height-1) - whereonrectangle;
if(new_y < prec_v->old_y) {          /* add to filled area */
	if(prec_v->label_flag == dl_label_none)
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, new_y-1, prec->width, whereonrectangle+1);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x, new_y, prec_v->new_width, whereonrectangle);
}
else
if(new_y > prec_v->old_y) {         /* erase from filled area */
	new_height = new_y - prec_v->old_y;
/* set foreground color to background color to erase */
	XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
	if(prec_v->label_flag == dl_label_none)
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, prec_v->old_y-1, prec->width, new_height+1);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x, prec_v->old_y, prec_v->new_width, new_height);
/*reset foreground color to foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
/* redraw remainder of rectangle in newest foreground color */
	new_height = (prec->y+1) + (prec->height-1) - new_y;
	if(prec_v->label_flag == dl_label_none)
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, new_y, prec->width, new_height);
	else
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 prec_v->left_x, new_y, prec_v->new_width, new_height);	
}
prec_v->old_y = new_y;
if((prec_v->label_flag == dl_label_limits) || (prec_v->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc,prec_v->bottomlimit_rectangle.x,
				prec_v->bottomlimit_rectangle.y,
				prec_v->bottomlimit_rectangle.width,
				prec_v->bottomlimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_v->out_of_range.string,
				prec_v->hdr.precision);
		   prec_v->out_of_range.len =
				 strlen(prec_v->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->bottomlimit_rectangle,
			pdl_context->pfont_table, prec_v->out_of_range.string,
			prec_v->out_of_range.len, box_end);
		   break;
		case 2:    /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, 
				prec_v->toplimit_rectangle.x,
				prec_v->toplimit_rectangle.y,
				prec_v->toplimit_rectangle.width,
				prec_v->toplimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_v->out_of_range.string,
					prec_v->hdr.precision);
 		   prec_v->out_of_range.len =
				 strlen(prec_v->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->toplimit_rectangle,
			pdl_context->pfont_table, prec_v->out_of_range.string,
			prec_v->out_of_range.len, box_end);
		   break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
  
  if((out_of_range == 0) && (prec_v->outofrange)) {
	  
	   switch(prec_v->outofrange) {
		case 1:
	           XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
		      prec_v->bottomlimit_rectangle.x,
		      prec_v->bottomlimit_rectangle.y,
		      prec_v->bottomlimit_rectangle.width,
	              prec_v->bottomlimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_v->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->bottomlimit_rectangle,
			pdl_context->pfont_table, prec_v->bottom_limit.string,
			prec_v->bottom_limit.len, box_end);       
		   break;
		case 2:
		    XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
			prec_v->toplimit_rectangle.x,
			prec_v->toplimit_rectangle.y,
		        prec_v->toplimit_rectangle.width,
	                prec_v->toplimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_v->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_v->toplimit_rectangle,
			pdl_context->pfont_table, prec_v->top_limit.string,
			prec_v->top_limit.len, box_end);       
		   break;
		case 0:
		   break;
	   } /* end of switch statement */
	prec_v->outofrange = 0;	
   }  /* end of if stmt for redrawing limits */
} /* end of label_flag check */

return 0;
}

FillRecRtToLt(pdl_context, prec, value, low_val,high_val, prectangle)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle *prectangle;
float low_val, high_val, value;
{
float percentage;
int new_x, whereonrectangle, new_width;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;

if(prectangle->range == 0.0) {
	whereonrectangle = 0;
	percentage = (float)0.;
}
else 
   percentage = (float)((value - low_val)/prectangle->range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range = 2;
}
	else
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = 1;
	   }
whereonrectangle = (int)(((unsigned int)(prec->width)-1) * percentage);

new_x = (prec->x+1) + (prec->width-1) - whereonrectangle;
if(new_x < prectangle->old_x)   /* add to rectangle */
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		 new_x, prectangle->inside_y,
		whereonrectangle, prectangle->new_height);    
else 
if(new_x > prectangle->old_x) {  /* erase part of filled rectangle */
	new_width = new_x - prectangle->old_x;
/* set foreground color to background color for erasing */
	XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			 prectangle->old_x, prectangle->inside_y, 
			 new_width, prectangle->new_height);  
/*reset foreground color to foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);
/* redraw the data area with the newest foreground color */
	new_width = (prec->x+1) + (prec->width-1) - new_x;
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			new_x, prectangle->inside_y, new_width,    
			prectangle->new_height);        
}
prectangle->old_x = new_x;
if((prectangle->label_flag == dl_label_limits)||(prectangle->label_flag ==
							dl_label_channel)) {
/* the following is for testing out of range conditions for labels */
if(out_of_range == 1) {     /* value was < 0.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
	    prectangle->rightlimit_rectangle.x,
	    prectangle->rightlimit_rectangle.y,
	    prectangle->rightlimit_rectangle.width,
	    prectangle->rightlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value,prectangle->out_of_range.string,
				prectangle->hdr.precision);
	prectangle->out_of_range.len =
			 strlen(prectangle->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->rightlimit_rectangle, pdl_context->pfont_table,
		prectangle->out_of_range.string,
		prectangle->out_of_range.len,
		box_end);
}
else if(out_of_range == 2) {  /*value was > 1.0 */
	XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
        XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->leftlimit_rectangle.x,
 		prectangle->leftlimit_rectangle.y,
		prectangle->leftlimit_rectangle.width,
		prectangle->leftlimit_rectangle.height);
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	f_to_str(value, prectangle->out_of_range.string,
				prectangle->hdr.precision);
	prectangle->out_of_range.len =
			 strlen(prectangle->out_of_range.string);
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->leftlimit_rectangle, pdl_context->pfont_table,
		prectangle->out_of_range.string,
		prectangle->out_of_range.len,
		box_begin);
}

   /* decide whether to redraw limits in outline color */
   if((out_of_range != 0) && (!prectangle->outofrange))
	prectangle->outofrange = 1;
   else if((!out_of_range) && (prectangle->outofrange)) {
	   prectangle->outofrange = 0;
	   XSetForeground(pdl_context->d, pdl_context->gc,
		 values.background);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->leftlimit_rectangle.x,
		prectangle->leftlimit_rectangle.y,
		prectangle->leftlimit_rectangle.width,
		prectangle->leftlimit_rectangle.height);
	   XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prectangle->rightlimit_rectangle.x,
		prectangle->rightlimit_rectangle.y,
		prectangle->rightlimit_rectangle.width,
		prectangle->rightlimit_rectangle.height);
	   XSetForeground(pdl_context->d, pdl_context->gc,
		  prectangle->hdr.foregroundcolor);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prectangle->leftlimit_rectangle, pdl_context->pfont_table,
		prectangle->left_limit.string, prectangle->left_limit.len,
		box_begin);
	   draw_horizontal_string(pdl_context->d,pdl_context->w,pdl_context->gc,
		&prectangle->rightlimit_rectangle, pdl_context->pfont_table,
		prectangle->right_limit.string, prectangle->right_limit.len,
		box_end);
     }
} /* end of label_flag check */
return 0;
}


update_indicatorR(pdl_context, value, pindicator)

struct dl_context *pdl_context;
struct indicator *pindicator;
float value;
{
int whereonrectangle, tick, index, new_y;
float percentage;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;

/* erase old indicator value*/
/*pindicator->indicator_save_pixmap = values.clip_mask;*/
/*XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);*/
XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
if((pindicator->points_array[1].y < pindicator->origin_y - 
					pindicator->indicator_height) ||
    (pindicator->points_array[2].y> 
			pindicator->origin_y)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);

	
/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/

/* set to outline color for redrawing tick marks */
XSetForeground(pdl_context->d,pdl_context->gc,pindicator->hdr.foregroundcolor);

/* Redraw the tick marks */
for(index=1; index <= 7; index++) {
	tick = 3;
	switch (index) {
		case 2:
		case 4:
		case 6: 
		   tick = 5;
		   break;
	} 
	XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->origin_x - 1, pindicator->ticks[index].y1,
		pindicator->origin_x - tick, pindicator->ticks[index].y2);
} 
	
/* set foreground color back to foreground color */
XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);

/*now draw current value */

if(pindicator->full_range == 0.0)
	whereonrectangle = 0;
else 
   percentage = (float)((value - pindicator->low_val)/pindicator->full_range);
if(percentage > 1.0) {
		percentage = (float)1.0;
		out_of_range = pindicator->outofrange = 2;
}
	else 
	   if(percentage < 0.0)  {
		percentage = (float)0.0;
		out_of_range = pindicator->outofrange = 1;
	   }

whereonrectangle = (int)(pindicator->indicator_height * percentage);

new_y = pindicator->origin_y - whereonrectangle; 
pindicator->points_array[0].x = pindicator->origin_x; 
pindicator->points_array[1].x = pindicator->origin_x - pindicator->width + 1;
pindicator->points_array[2].x = pindicator->origin_x - pindicator->width + 1; 
pindicator->points_array[3].x = pindicator->origin_x;
pindicator->points_array[0].y = new_y; 
pindicator->points_array[1].y = new_y - pindicator->run/2;
pindicator->points_array[2].y = new_y + pindicator->run/2;
pindicator->points_array[3].y = new_y; 

/* now draw new indicator value */
if((pindicator->points_array[1].y < pindicator->origin_y - 
					pindicator->indicator_height) ||
    (pindicator->points_array[2].y> 
			pindicator->origin_y)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/
/* reset clip_mask of gc*/
/*XSetClipMask(pdl_context->d, pdl_context->gc,
				pindicator->indicator_save_pixmap);*/
pindicator->old_x = new_y;
if((pindicator->label_flag == dl_label_limits) || (pindicator->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc,pindicator->bottomlimit_rectangle.x,
				pindicator->bottomlimit_rectangle.y,
				pindicator->bottomlimit_rectangle.width,
				pindicator->bottomlimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,pindicator->out_of_range.string,
					pindicator->hdr.precision);
		   pindicator->out_of_range.len =
				 strlen(pindicator->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table, 
			pindicator->out_of_range.string,
			pindicator->out_of_range.len, box_end);
		   break;
		case 2:    /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, 
				pindicator->toplimit_rectangle.x,
				pindicator->toplimit_rectangle.y,
				pindicator->toplimit_rectangle.width,
				pindicator->toplimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,pindicator->out_of_range.string,
					pindicator->hdr.precision);
 		   pindicator->out_of_range.len =
				 strlen(pindicator->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table,
			pindicator->out_of_range.string,
			pindicator->out_of_range.len, box_end);
		   break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
  
  if((out_of_range == 0) && (pindicator->outofrange)) {
	  
	   switch(pindicator->outofrange) {
		case 1:
	           XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
		      pindicator->bottomlimit_rectangle.x,
		      pindicator->bottomlimit_rectangle.y,
		      pindicator->bottomlimit_rectangle.width,
	              pindicator->bottomlimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      pindicator->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table, 
			pindicator->bottom_limit.string,
			pindicator->bottom_limit.len, box_end);       
		   break;
		case 2:
		    XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
			pindicator->toplimit_rectangle.x,
			pindicator->toplimit_rectangle.y,
		        pindicator->toplimit_rectangle.width,
	                pindicator->toplimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      pindicator->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table, pindicator->top_limit.string,
			pindicator->top_limit.len, box_end);       
		   break;
		case 0:
		   break;
	   } /* end of switch statement */
	pindicator->outofrange = 0;	
   }  /* end of if stmt for redrawing limits */
} /* end of label_flag check */
return 0;
}

update_indicatorL(pdl_context, value, pindicator)

struct dl_context *pdl_context;
struct indicator *pindicator;
float value;
{
int whereonrectangle, tick, index, new_y;
float percentage;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;

/* erase old indicator value*/
/*pindicator->indicator_save_pixmap = values.clip_mask;*/
/*XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);*/
XSetForeground(pdl_context->d, pdl_context->gc,
		values.background);
if((pindicator->points_array[1].y < pindicator->origin_y - 
					pindicator->indicator_height) ||
    (pindicator->points_array[2].y> 
			pindicator->origin_y)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);

	
/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/
/* set to outline color for redrawing tick marks */
XSetForeground(pdl_context->d, pdl_context->gc, 
				pindicator->hdr.foregroundcolor);

/* Redraw the tick marks */
for(index=1; index <= 7; index++) {
	tick = 3;
	switch (index) {
		case 2:
		case 4:
		case 6: 
		   tick = 5;
		   break;
	} 
	XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->origin_x + 1, pindicator->ticks[index].y1,
		pindicator->origin_x + tick, pindicator->ticks[index].y2);
} 	
/* set foreground color back to foreground color */
XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);

/* now draw current value */

if(pindicator->full_range == 0.0)
	whereonrectangle = 0;
else 
   percentage = (float)((value - pindicator->low_val)/pindicator->full_range);
if(percentage > 1.0) {
	percentage = (float)1.0;
	out_of_range = pindicator->outofrange = 2;
}
	else 
	   if(percentage < 0.0) {
		percentage = (float)0.0;
		out_of_range = pindicator->outofrange = 1;
	   }
whereonrectangle = (int)(pindicator->indicator_height * percentage);

new_y = pindicator->origin_y - whereonrectangle; 
pindicator->points_array[0].x = pindicator->origin_x + 1; 
pindicator->points_array[1].x = pindicator->origin_x + pindicator->width - 1;
pindicator->points_array[2].x = pindicator->origin_x + pindicator->width - 1; 
pindicator->points_array[3].x = pindicator->origin_x + 1;;
pindicator->points_array[0].y = new_y; 
pindicator->points_array[1].y = new_y - pindicator->run/2;
pindicator->points_array[2].y = new_y + pindicator->run/2;
pindicator->points_array[3].y = new_y; 

/* now draw new indicator value */
if((pindicator->points_array[1].y < pindicator->origin_y - 
					pindicator->indicator_height) ||
    (pindicator->points_array[2].y> 
			pindicator->origin_y)) {
	XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);
	/*reset clip mask*/
	XSetClipMask(pdl_context->d, pdl_context->gc,
		pindicator->indicator_save_pixmap);
}
else
	XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pindicator->points_array, 4, Complex, CoordModeOrigin);

/*XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);*/
/* reset clip_mask of gc*/
/*XSetClipMask(pdl_context->d, pdl_context->gc,
				pindicator->indicator_save_pixmap);*/
pindicator->old_x = new_y;
if((pindicator->label_flag == dl_label_limits) || (pindicator->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc,pindicator->bottomlimit_rectangle.x,
				pindicator->bottomlimit_rectangle.y,
				pindicator->bottomlimit_rectangle.width,
				pindicator->bottomlimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,pindicator->out_of_range.string,
					pindicator->hdr.precision);
		  pindicator->out_of_range.len =
				 strlen(pindicator->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table, 
			pindicator->out_of_range.string,
			pindicator->out_of_range.len, box_begin);
		   break;
		case 2:    /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, 
				pindicator->toplimit_rectangle.x,
				pindicator->toplimit_rectangle.y,
				pindicator->toplimit_rectangle.width,
				pindicator->toplimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,pindicator->out_of_range.string,
					pindicator->hdr.precision);
		   pindicator->out_of_range.len =
				 strlen(pindicator->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table,
			pindicator->out_of_range.string,
			pindicator->out_of_range.len, box_begin);
		   break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
  
  if((out_of_range == 0) && (pindicator->outofrange)) {
	  
	   switch(pindicator->outofrange) {
		case 1:
	           XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
		      pindicator->bottomlimit_rectangle.x,
		      pindicator->bottomlimit_rectangle.y,
		      pindicator->bottomlimit_rectangle.width,
	              pindicator->bottomlimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      pindicator->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table, 
			pindicator->bottom_limit.string,
			pindicator->bottom_limit.len, box_begin);       
		   break;
		case 2:
		    XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
			pindicator->toplimit_rectangle.x,
			pindicator->toplimit_rectangle.y,
		        pindicator->toplimit_rectangle.width,
	                pindicator->toplimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      pindicator->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table, pindicator->top_limit.string,
			pindicator->top_limit.len, box_begin);       
		   break;
		case 0:
		   break;
	   } /* end of switch statement */
	pindicator->outofrange = 0;	
   }  /* end of if stmt for redrawing limits */
} /* end of label_flag check */
return 0;
}
FillRecFromMidv2(pdl_context, prec, value, low_val, high_val, prec_midv)

struct dl_context *pdl_context;
struct rec_midv *prec_midv;
float value, low_val, high_val;
XRectangle *prec;
{
return 0;
}
FillRecFromMidv(pdl_context, prec, value, low_val, high_val, prec_midv)

struct dl_context *pdl_context;
struct rec_midv *prec_midv;
float value, low_val, high_val;
XRectangle *prec;
{
double percentage;
int new_pixel_y, new_height, whereonrectangle;
unsigned long saveforegroundcolor;
short out_of_range = 0;
XGCValues values;

#ifdef ILLEGAL_X_USAGE
values = pdl_context->gc->values;
#else
if (!XGetGCValues (pdl_context->d, pdl_context->gc, GCForeground | GCBackground, &values))
{
    values.foreground = WhitePixel(pdl_context->d, DefaultScreen(pdl_context->d));
    values.background = BlackPixel(pdl_context->d, DefaultScreen(pdl_context->d));
}
#endif ILLEGAL_X_USAGE

saveforegroundcolor = values.foreground;

if(value < 0) {
	percentage = value/prec_midv->low_val;
	if(percentage > 1.0) { 
		percentage = 1.0;
		out_of_range = prec_midv->outofrange = 1;
	} 
	whereonrectangle = (int)(prec_midv->negative_pixel_height * percentage);
	new_pixel_y = prec_midv->zero_point_y + whereonrectangle;
	if(prec_midv->old_y < prec_midv->zero_point_y) {
	/* then previous value was positive. erase positive rectangle, then
	   draw negative rectangle */
	        /* reset foreground color to background for erasing */
	     	new_height = prec_midv->zero_point_y - prec_midv->old_y;
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		if(prec_midv->label_flag == dl_label_none)
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc,prec_midv->pos_x-1, prec_midv->pos_y,
			prec_midv->inside_width+1,
			prec_midv->positive_pixel_height);
		else
		 XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->pos_x, prec_midv->pos_y,
			prec_midv->inside_width,
			prec_midv->positive_pixel_height);
	     	/*reset foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		new_height = whereonrectangle;
		if(new_height >= 0) {
		   if( prec_midv->label_flag == dl_label_none)
			XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, prec_midv->neg_x-1,
				prec_midv->neg_y,
			 	prec_midv->inside_width + 1, new_height+1);
		   else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->neg_x, prec_midv->neg_y,
			prec_midv->inside_width, new_height);
		}
	}
	else
	if(prec_midv->old_y < new_pixel_y) {
	/* then need to add to negative filled area */
		new_height = whereonrectangle;
		if(new_height >= 0) {
	  	   if(prec_midv->label_flag == dl_label_none)
			XFillRectangle(pdl_context->d, pdl_context->w,
			   pdl_context->gc, prec_midv->neg_x - 1,
			   prec_midv->neg_y, prec_midv->inside_width+1,
			   new_height+1);
		  else 
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->neg_x, prec_midv->neg_y, 
			prec_midv->inside_width, new_height);
	         }

	}
	else
	if(prec_midv->old_y > new_pixel_y) {
		/* then need to erase part of negative rectangle */
		new_height = prec_midv->old_y - new_pixel_y + 1;
		/*set foreground color to background for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		if(prec_midv->label_flag == dl_label_none)
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc,prec_midv->neg_x-1, new_pixel_y,
			prec_midv->inside_width+1,new_height+1);
		else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->neg_x, new_pixel_y, prec_midv->inside_width,
			new_height);

		/* reset foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc, 
			saveforegroundcolor);
		/*redraw remaining active area with current foregroune color */
		new_height = new_pixel_y - prec_midv->zero_point_y - 1;
		if(new_height >= 0) {
		    if(prec_midv->label_flag == dl_label_none) 
			XFillRectangle(pdl_context->d, pdl_context->w,
				pdl_context->gc, prec_midv->neg_x-1,
				prec_midv->neg_y, prec_midv->inside_width+1,
				new_height+1);
		   else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->neg_x, prec_midv->neg_y, 
			prec_midv->inside_width, new_height);
		}

	}
}
else
if(value > 0) {
	percentage = value/prec_midv->high_val;
	if(percentage > 1.0) {
		percentage = 1.0;
		out_of_range = prec_midv->outofrange = 2;
	}
	else
	   if(percentage < 0.0)
		percentage = 0.0;
	whereonrectangle = (int)(prec_midv->positive_pixel_height * percentage);
	new_pixel_y = prec_midv->zero_point_y - whereonrectangle;
	if(prec_midv->old_y > prec_midv->zero_point_y) {
		/* then previous value was negative. erase entire negative
			rectangle, then draw positive rectangle */
		/* set foreground color to background for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		if(prec_midv->label_flag == dl_label_none)
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->neg_x-1, prec_midv->neg_y,
			prec_midv->inside_width+1,
			prec_midv->negative_pixel_height);
		else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->neg_x, prec_midv->neg_y,
			prec_midv->inside_width,
			prec_midv->negative_pixel_height);
		/*reset foreground color to foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc,	
			saveforegroundcolor);
		new_height = prec_midv->zero_point_y - new_pixel_y;
		if(new_height >= 0) {
		    if(prec_midv->label_flag == dl_label_none)
		      XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->pos_x-1,
			new_pixel_y, prec_midv->inside_width+1, new_height);
		   else 
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->pos_x, new_pixel_y, prec_midv->inside_width,
			new_height);
		}
	}
	else
	if(prec_midv->old_y < new_pixel_y) {
		/* then need to erase part of positive area */
		new_height = new_pixel_y - prec_midv->old_y;
		/*set foreground color to background color for erasing */
		XSetForeground(pdl_context->d, pdl_context->gc,
			values.background);
		if(prec_midv->label_flag == dl_label_none)
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc,
			prec_midv->pos_x-1, prec_midv->old_y,
			prec_midv->inside_width+1, new_height);
		else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->pos_x, prec_midv->old_y,
			prec_midv->inside_width, new_height);

		/*reset foreground color to foreground color */
		XSetForeground(pdl_context->d, pdl_context->gc, 
			saveforegroundcolor);
		new_height = prec_midv->zero_point_y - new_pixel_y;
		if(new_height >= 0) {
		   if(prec_midv->label_flag == dl_label_none)
		      XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->pos_x-1, new_pixel_y,
			prec_midv->inside_width+1, new_height);
		   else 
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->pos_x, new_pixel_y, prec_midv->inside_width, 
			new_height);
	        }
	}
	else
	if(prec_midv->old_y > new_pixel_y) {
		/* then need to add to part of positive area */
		new_height = prec_midv->zero_point_y - new_pixel_y;
		if(new_height >= 0) {
		    if(prec_midv->label_flag == dl_label_none)
		      XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->pos_x-1, new_pixel_y,
			prec_midv->inside_width+1, new_height);
		   else
		XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_midv->pos_x, new_pixel_y, prec_midv->inside_width,
			new_height);
		}
	}
}
else
if(value == 0) { /* erase all positive and negative rectangles */
	/*set foreground color to background color for erasing */
	XSetForeground(pdl_context->d, pdl_context->gc, 
		values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_midv->pos_x, prec_midv->pos_y,
		prec_midv->inside_width, prec_midv->positive_pixel_height);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_midv->neg_x, prec_midv->neg_y,
		prec_midv->inside_width, prec_midv->negative_pixel_height);
	/* reset foreground color to foreground color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
}
prec_midv->old_y = new_pixel_y;
if((prec_midv->label_flag == dl_label_limits) || (prec_midv->label_flag ==
							dl_label_channel)) {
	switch (out_of_range) {
		case 1:     /* value was less that lowest displayed value */
		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->bottomlimit_rectangle.x,
				prec_midv->bottomlimit_rectangle.y,
				prec_midv->bottomlimit_rectangle.width,
				prec_midv->bottomlimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_midv->out_of_range.string,
					prec_midv->hdr.precision);
		   prec_midv->out_of_range.len =
				 strlen(prec_midv->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_midv->bottomlimit_rectangle,
			pdl_context->pfont_table,prec_midv->out_of_range.string,
			prec_midv->out_of_range.len, box_end);
		  	break;
		case 2:   /* value was greater than highest displayed value */
 		   XSetForeground(pdl_context->d, pdl_context->gc,
					values.background);
		   XFillRectangle(pdl_context->d, pdl_context->w,
			pdl_context->gc, prec_midv->toplimit_rectangle.x,
				prec_midv->toplimit_rectangle.y,
				prec_midv->toplimit_rectangle.width,
				prec_midv->toplimit_rectangle.height);
		   XSetForeground(pdl_context->d, pdl_context->gc,
			saveforegroundcolor);
		   f_to_str(value,prec_midv->out_of_range.string,
				prec_midv->hdr.precision);
		   prec_midv->out_of_range.len =
				 strlen(prec_midv->out_of_range.string);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_midv->toplimit_rectangle,
		        pdl_context->pfont_table,prec_midv->out_of_range.string,
			prec_midv->out_of_range.len, box_end);
		  	break;
		case 0:      /* value was not out of range */
		   break;
	} /* end of switch */	
 /* decide whether to redraw limits in outline color */
if((out_of_range == 0) && (prec_midv->outofrange)) {
	  
	   switch(prec_midv->outofrange) {
		case 1:
	           XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
		      prec_midv->bottomlimit_rectangle.x,
		      prec_midv->bottomlimit_rectangle.y,
		      prec_midv->bottomlimit_rectangle.width,
	              prec_midv->bottomlimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_midv->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_midv->bottomlimit_rectangle,
			pdl_context->pfont_table, 
			prec_midv->bottom_limit.string,
			prec_midv->bottom_limit.len, box_end);      
		   break;
		case 2:
		    XSetForeground(pdl_context->d, pdl_context->gc,
		        values.background);
	           XFillRectangle(pdl_context->d,pdl_context->w,pdl_context->gc,
			prec_midv->toplimit_rectangle.x,
			prec_midv->toplimit_rectangle.y,
		        prec_midv->toplimit_rectangle.width,
	                prec_midv->toplimit_rectangle.height);
	           XSetForeground(pdl_context->d, pdl_context->gc,
		      prec_midv->hdr.foregroundcolor);
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &prec_midv->toplimit_rectangle,
			pdl_context->pfont_table, prec_midv->top_limit.string,
			prec_midv->top_limit.len, box_end);       
		   break;
		case 0:
		   break;
	   } /* end of switch statement */
	prec_midv->outofrange = 0;	
   }  /* end of if stmt for redrawing limits */
} /* end of label_flag check */   
return 0;
}



		


