/*edd_stream_io.c,v 1.1.1.1 1999/08/03 14:43:52 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *
 *	E D D _ S T R E A M _ I O . C
 *
 *	Author	Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		505 665 1831
 *
 *	Allow segment output to switch between a file and an X resource
 *
 *
 *
 *
 *
 * 	History
 *
 *
 */

#ifdef AXP
#include <string.h>
#include <stdlib.h>
#endif

#include	<edd.h>

void *tisMalloc();
void *tisCalloc();
void tisFree();

/*
 *	edd_write()
 */
edd_write(pstream, ptr, nbytes)
edd_stream	*pstream;
void		*ptr;
unsigned	nbytes;
{
	int	status;
	int	mode;
#	define 	NITEMS 1

	switch(pstream->type)
	{
	case use_stdio:
		status = fwrite(	ptr, 
					nbytes,
					NITEMS,
					pstream->io_info.pfile);
		if(status != NITEMS)
			return ERROR;
		break;

	case use_xresource:

		if(!pstream->nbytes)
			mode = PropModeReplace;
		else
			mode = PropModeAppend;

		/* 8 specifies no byte swapping */
		XChangeProperty(	pstream->io_info.xsel.display,
					pstream->io_info.xsel.requestor,
					pstream->io_info.xsel.property,
					pstream->io_info.xsel.target,
					8,
					mode,
					ptr,
					nbytes);
		break;
	case use_memory:
	{
		char	*pnewbuf;

		if(pstream->io_info.mem.pbuf){
printf("WARNING! realloc called in edd_stream_io.c!\n");
			pnewbuf = (char *) realloc(	
					pstream->io_info.mem.pbuf, 
					pstream->nbytes+nbytes);
		}
		else{
			/*pnewbuf = (char *) calloc(1, nbytes);*/
			pnewbuf = (char *) tisCalloc(__FILE__, __LINE__, 1, nbytes);
			pstream->nbytes = 0;
		}	

		if(!pnewbuf){
			return ERROR;
		}
		memcpy(	pnewbuf+pstream->nbytes, 
			ptr,
			nbytes);
		pstream->io_info.mem.pbuf = pnewbuf;
		break;
	}
	default:
		assert(FALSE);
	}

	pstream->nbytes += nbytes;
	return OK;
}
