#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/*t_edd.c,v 1.1.1.1 1999/08/03 14:43:54 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *	E D D . C
 *	Author	Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		505 665 1831
 *
 *	OPI editor root module - contains main()
 *
 *
 *
 *
 *	Improvements
 *	01	Turn on backing store on the edit window ?
 *
 *
 *	History
 *	joh 031991	Added command line display name entry
 *
 */

#include	<stdio.h>
#if (defined(SOLARIS) || defined(WIN32))
#include	<string.h>
#else
#include	<strings.h>
#endif
#include	<fcntl.h>
#include	<X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include	<X11/Xutil.h>
#include	<X11/Xatom.h>
#include	<X11/Intrinsic.h>
#ifdef WIN32
#include <direct.h>
#include <io.h>
#include <time.h>
#include <winsock.h>
#else
#include	<sys/time.h>
#endif WIN32
#ifdef AXP
#include <stdlib.h>
#endif
#ifdef TOKENPTRS
#include <tokenSupport.h>
#endif

#include	<X11/cursorfont.h>
#include	<select_stipple.h>

#define		EDD_GLOBAL_SOURCE
#include	<edd.h>
#include	<dlinfo.h>
#include	<plain_menus.h>

#define		EDD_MENUS_GLOBAL_SOURCE
#include	<edd_menus.h>
#include	<edd_icon.h>

#ifndef WIN32
extern void *fdmgr_init();
#endif WIN32
extern void *tisMalloc();
extern void *tisCalloc();
extern void tisFree();

/*
 * Command Line Options
 *
 *	lifted from /.../lib/Xt/Initialize.c
 *
 *	most of these are not integrated yet
 */
static XrmOptionDescRec opTable[] = {
{"+rv",				"*reverseVideo",	XrmoptionNoArg,  (caddr_t) "off"},
{"+synchronous",		"*synchronous",		XrmoptionNoArg,  (caddr_t) "off"},
{"-background",			"*background",		XrmoptionSepArg, (caddr_t) NULL},
{"-bd",				"*borderColor",		XrmoptionSepArg, (caddr_t) NULL},
{"-bg",				"*background",		XrmoptionSepArg, (caddr_t) NULL},
{"-bordercolor",		"*borderColor",		XrmoptionSepArg, (caddr_t) NULL},
{"-borderwidth",		".borderWidth",		XrmoptionSepArg, (caddr_t) NULL},
{"-bw",				".borderWidth",		XrmoptionSepArg, (caddr_t) NULL},
{"-display",			".display",		XrmoptionSepArg, (caddr_t) NULL},
{"-fg",				"*foreground",		XrmoptionSepArg, (caddr_t) NULL},
{"-fn",				"*font",		XrmoptionSepArg, (caddr_t) NULL},
{"-font",			"*font",		XrmoptionSepArg, (caddr_t) NULL},
{"-foreground",			"*foreground",		XrmoptionSepArg, (caddr_t) NULL},
{"-geometry",			".geometry",		XrmoptionSepArg, (caddr_t) NULL},
{"-iconic",			".iconic",		XrmoptionNoArg,  (caddr_t) "on"},
{"-name",			".name",		XrmoptionSepArg, (caddr_t) NULL},
{"-reverse",			"*reverseVideo",	XrmoptionNoArg,  (caddr_t) "on"},
{"-rv",				"*reverseVideo",	XrmoptionNoArg,  (caddr_t) "on"},
{"-selectionTimeout",		".selectionTimeout",	XrmoptionSepArg, (caddr_t) NULL},
{"-synchronous",		"*synchronous",		XrmoptionNoArg,  (caddr_t) "on"},
{"-title",			".title",		XrmoptionSepArg, (caddr_t) NULL},
{"-xnllanguage",		".xnlLanguage",		XrmoptionSepArg, (caddr_t) NULL},
{"-xrm",			NULL,			XrmoptionResArg, (caddr_t) NULL},
};

static char	*GetHomeDir();
static 		check_all_string_offsets();
char		*strrchr();
int		opi_x_error_handler();

void		*pfdctx;
static struct timeval	timeout	= {30, 0};

int	invisibleColor = DEFAULT_INVISIBLE_COLOR;
int	converting = 0;
char	*opiStringTab[OPI_NUM_STRINGS];
#ifdef WIN32
XtAppContext	app_context;
#endif WIN32

/*
 *	MAIN
 */
main(argc, argv)
int	argc;
char	**argv;
	{
	void			x_evhandler();
	due			*pdue;
	XSizeHints		xsh;
	XGCValues		GC_values;
	XSetWindowAttributes	xswa;
	Status			status;
	XColor			dbclr;
	enum			args{program_name, display_name};
	XrmValue		value;
	char			*ptype;
	char			Xdefaults[BUFSIZ];
	char			*pdisplay_name	= "";

#ifdef WIN32
extern int _fmode;
	_fmode = _O_BINARY;

	XtToolkitInitialize ();
#ifdef Xm
	HCLXmInit();		/* HCL - initialize the Xm DLL */
#endif Xm
#endif WIN32
	/*
	Handle TIS Licensing
	*/

#if !(defined(ultrix) || defined(WIN32))
	tisSoftLicense();
#endif
/*
	Load all strings here.
*/
	if (getenv ("OPISTRINGTABLE"))
	    tisLoadStrings (getenv ("OPISTRINGTABLE"), opiStringTab, OPI_NUM_STRINGS);
	else
#if !(defined(AXP) || defined(SOLARIS))
#ifdef WIN32
	    tisLoadStrings("/tis4000/tasks/opiStringTable",opiStringTab,OPI_NUM_STRINGS);
#else
	    tisLoadStrings("/home/tis4000/tasks/opiStringTable",opiStringTab,OPI_NUM_STRINGS);
#endif WIN32
#else
	    tisLoadStrings("/tis4000/tasks/opiStringTable",opiStringTab,OPI_NUM_STRINGS);
#endif
	einfoStringInit();			/* dialog box extra strings */
	sinfoStringInit();			/* dialog box strings */
/*
	28-Nov-1994 GCT
	Initialize menu strings here. This is done because the compiler doesn't want to
	at compile time.
*/

	modifymc[0] = opiStringTab[STR_attributes                  ];
	modifymc[1] = opiStringTab[STR_color_table                 ];
	modifymc[2] = opiStringTab[STR_color_rules_                ]; 
	modifymc[3] = 0;

	globalmc[0] = opiStringTab[STR_load_____display            ];
	globalmc[1] = opiStringTab[STR_modify___display            ];
	globalmc[2] = opiStringTab[STR_save_____display            ];
	globalmc[3] = opiStringTab[STR_copy_____display            ];
	globalmc[4] = opiStringTab[STR_report___display            ];
	globalmc[5] = opiStringTab[STR_activate_display            ];
	globalmc[6] = opiStringTab[STR_quit                        ];
	globalmc[7] = 0;

	monitormc[0] = opiStringTab[STR_indicator                   ];
	monitormc[1] = opiStringTab[STR_bar                         ];
	monitormc[2] = opiStringTab[STR_text                        ];
	monitormc[3] = opiStringTab[STR_meter                       ];
	monitormc[4] = 0;

	controlmc[0] = opiStringTab[STR_valuator                    ];
	controlmc[1] = opiStringTab[STR_text_entry                  ];
	controlmc[2] = opiStringTab[STR_choice_button               ];
	controlmc[3] = opiStringTab[STR_message_button              ];
	controlmc[4] = opiStringTab[STR_menu                        ];
	controlmc[5] = opiStringTab[STR_related_display_callup      ];
	controlmc[6] = opiStringTab[STR_execute_script              ];
	controlmc[7] = opiStringTab[STR_kill_display                ];
	controlmc[8] = 0;

	plotmc[0] = opiStringTab[STR_cartesian_plot              ];
	plotmc[1] = opiStringTab[STR_surface_plot                ];
	plotmc[2] = opiStringTab[STR_strip_chart                 ];
	plotmc[3] = opiStringTab[STR_smith_overlay_plot          ];
	plotmc[4] = 0;

	createmc[0] = opiStringTab[STR_rectangle                   ];
	createmc[1] = opiStringTab[STR_line                        ];
	createmc[2] = opiStringTab[STR_oval                        ];
	createmc[3] = opiStringTab[STR_arc                         ];
	createmc[4] = opiStringTab[STR_text                        ];
	createmc[5] = opiStringTab[STR_monitor                     ];
	createmc[6] = opiStringTab[STR_controller                  ];
	createmc[7] = opiStringTab[STR_plot                        ];
	createmc[8] = 0;

	nseditmc[0] = opiStringTab[STR_create                      ];
	nseditmc[1] = opiStringTab[STR_paste                       ]; 
	nseditmc[2] = opiStringTab[STR_undo                        ];
	nseditmc[3] = opiStringTab[STR_select_all                  ];
	nseditmc[4] = 0;

	distributemc[0] = opiStringTab[STR_left_edges                  ];
	distributemc[1] = opiStringTab[STR_right_edges                 ];
	distributemc[2] = opiStringTab[STR_top_edges                   ];
	distributemc[3] = opiStringTab[STR_bottom_edges                ];
	distributemc[4] = opiStringTab[STR_horizontal_centers          ];
	distributemc[5] = opiStringTab[STR_vertical_centers            ];
	distributemc[6] = 0;

	alignmc[0] = opiStringTab[STR_left_edges                  ];
	alignmc[1] = opiStringTab[STR_right_edges                 ];
	alignmc[2] = opiStringTab[STR_top_edges                   ];
	alignmc[3] = opiStringTab[STR_bottom_edges                ];
	alignmc[4] = opiStringTab[STR_horizontal_centers          ];
	alignmc[5] = opiStringTab[STR_vertical_centers            ];
	alignmc[6] = opiStringTab[STR_centers                     ];
	alignmc[7] = 0;

	moremc[0] = opiStringTab[STR_group                       ];
	moremc[1] = opiStringTab[STR_ungroup                     ]; 
	moremc[2] = opiStringTab[STR_front                       ]; 
	moremc[3] = opiStringTab[STR_back                        ];
	moremc[4] = opiStringTab[STR_align                       ];
	moremc[5] = opiStringTab[STR_distribute                  ];
#ifdef UNFINISHED
	moremc[6] = opiStringTab[STR_open                        ];
	moremc[7] = opiStringTab[STR_close                       ];
#endif
	moremc[8] = 0;

	seditmc[0] = opiStringTab[STR_modify                      ];
	seditmc[1] = opiStringTab[STR_modify_channel_names        ];
	seditmc[2] = opiStringTab[STR_cut                         ]; 
	seditmc[3] = opiStringTab[STR_copy                        ]; 
	seditmc[4] = opiStringTab[STR_move                        ];
	seditmc[5] = opiStringTab[STR_resize                      ];
	seditmc[6] = opiStringTab[STR_deselect                    ];
	seditmc[7] = opiStringTab[STR_more                        ];
	seditmc[8] = 0;

	rmtseditmc[0] = opiStringTab[STR_cut                         ];
	rmtseditmc[1] = opiStringTab[STR_copy                        ];
	rmtseditmc[2] = opiStringTab[STR_deselect                    ];
	rmtseditmc[3] = 0;

	/* Check if we are performing a conversion from dl to adl format. */

	if (argc == 4) {
	    if (strcmp (argv [1], "-a") == 0) {

		FILE	*f;

		printf (opiStringTab[STR_Converting_Hs_dl_file_to_Hs_],
			argv [2], argv [3]);

		f = fopen (argv [2], "r+b");
		if (f == NULL) {
		    printf (opiStringTab[STR_Unable_to_open_Hsn          ], argv [2]);
		    exit (-1);
		}
		fclose (f);

		f = fopen (argv [3], "w");  /* ADLs are text format */
		if (f == NULL) {
		    printf (opiStringTab[STR_Unable_to_create_Hsn        ], argv [3]);
		    exit (-1);
		}

		dump_display (argv [2], f, argv [2]);

		fclose (f);
		
		exit (0);
	    } else if (strcmp (argv [1], "-d") == 0) {
		int	fd;

		printf (opiStringTab[STR_Converting_Hs_adl_file_to_Hs],
			argv [2], argv [3]);

#ifdef WIN32
		fd = _open (argv [2], _O_TEXT|_O_RDONLY);   /* ADLs are text format */
#else
		fd = open (argv [2], O_RDONLY);
#endif WIN32
		if (fd == -1) {
		    printf (opiStringTab[STR_Unable_to_open_Hsn          ], argv [2]);
		    exit (-1);
		}

		/*pdue = (due *) calloc(1, sizeof(due));*/
		pdue = (due *) tisCalloc(__FILE__, __LINE__, 1, sizeof(due));

		if ((pdue->d = XOpenDisplay(pdisplay_name)) == NULL) {
		    printf( opiStringTab[STR_edd_cant_open_display_Hsn   ], pdisplay_name);
		    return ERROR;
		}

/*		init_due (pdue); */
		converting = 1;
		load_adl (pdue, fd);
#ifdef WIN32
		_close (fd);
#else
		close (fd);
#endif WIN32
		save_display (pdue, argv [3]);
		exit (0);
	    }		
	}

	check_all_string_offsets();

	/*
	 * install an error handler that makes a core file when
	 * an X Error occurs. This can be usefull if XSync is on.
	 *
	 */
	XSetErrorHandler(opi_x_error_handler);

	pdue = (due *) tisCalloc(__FILE__, __LINE__, 1, sizeof(due));
	assert(pdue != NULL);

	/*
	 * Extract standard command line options and store them in a X resource manager database.
	 */
	XrmInitialize();
	XrmParseCommand(&pdue->xrmdb, opTable, NELEMENTS(opTable), "edd", &argc, argv);
#ifdef WIN32
	XrmMergeDatabases(XrmGetFileDatabase(strcat(GetHomeDir(Xdefaults), "\\Xdefaults")), &pdue->xrmdb);
#else
	XrmMergeDatabases(XrmGetFileDatabase(strcat(GetHomeDir(Xdefaults), "/.Xdefaults")), &pdue->xrmdb);
#endif WIN32

	/*
	 * get any display name and open it
	 */
	if(XrmGetResource(pdue->xrmdb, "edd.display", "TopLevelShell", &ptype, &value) == True)
		pdisplay_name = value.addr;

#ifdef WIN32xx
	if ((pdue->d = XtOpenDisplay(app_context, pdisplay_name, argv[0], "edd", "", 0, &argc, argv)) == NULL)
#else
	if ((pdue->d = XOpenDisplay(pdisplay_name)) == NULL)
#endif WIN32xx
		{
		printf( opiStringTab[STR_edd_cant_open_display_Hsn   ], pdisplay_name);
		return ERROR;
		}

	/*
	 * initialize to fd manager and give it the X fd for X events
	 */
#ifndef WIN32
	pfdctx = fdmgr_init();
	assert(pfdctx != NULL);
	fdmgr_add_fd(pfdctx, ConnectionNumber(pdue->d), x_evhandler, pdue);
#endif WIN32

	/*
	 * get any sync value
	 */
/* for testing!!! */
XSynchronize(pdue->d, (Bool) TRUE);
	if(XrmGetResource(pdue->xrmdb, "edd.synchronous", "TopLevelShell", &ptype, &value) == True)
		if(strcmp(value.addr,"on") == 0)
			{
			printf(opiStringTab[STR_edd_X_sync_is_onn           ]);
			XSynchronize(pdue->d, (Bool) TRUE);
			}

	pdue->s					= ScreenOfDisplay(pdue->d, DefaultScreen(pdue->d));
	pdue->dlc.d				= pdue->d;
	pdue->dlc.pfont_table	= init_font_table(pdue->d);
	assert(pdue->dlc.pfont_table != NULL);

	pdue->dl_seg_atom		= XInternAtom(pdue->d, DL_SEGMENT,  False);
	pdue->XA_CLIPBOARD		= XInternAtom(pdue->d, "CLIPBOARD", False);
	pdue->XA_DELETE			= XInternAtom(pdue->d, "DELETE",    False);
	assert(pdue->dl_seg_atom  != None);
	assert(pdue->XA_CLIPBOARD != None);
	assert(pdue->XA_DELETE	  != None);

	/* This allocates a color which represents the "invisible" color.  This color is not */
	/* actually ever used but the pixel number represents the invisible color. */

/*	{
	    Status	status;
	    long	plane_mask [1];
	    long	ppixel [1];
	    XColor	color, xcolor;

	    if (invisibleColor == DEFAULT_INVISIBLE_COLOR) {		
		status = XAllocColorCells(	
			pdue->d,
			DefaultColormap(pdue->d, DefaultScreen(pdue->d)),
			False,
			plane_mask,
			0,
			ppixel,
			1);
		assert(status != 0);
		invisibleColor = ppixel [0];
printf (opiStringTab[STR_Invisible_color_is_Hdn      ], invisibleColor);


	    }
	}
*/
	/*
	 * queries will slow down startup somewhat
	 * - could use XQueryColors
	 */

	/*
	 * get any foreground and background colors
	 */
	if(XrmGetResource(pdue->xrmdb, "edd.foreground", "TopLevelShell", &ptype, &value) == True)
		{
		char    color_string[50];

		strncpy(color_string, value.addr, (int)value.size);
		status = XAllocNamedColor(pdue->d,
					      DefaultColormapOfScreen(pdue->s),
					      color_string,
					      &pdue->foreground,
					      &dbclr);
		if(!status)
			{
			printf(opiStringTab[STR_edd_bad_foreground_color_Hsn], color_string);
			pdue->foreground.pixel = WhitePixelOfScreen(pdue->s);
			XQueryColor(pdue->d, DefaultColormapOfScreen(pdue->s), &pdue->foreground);
			}
		}
	else
		{
		pdue->foreground.pixel = WhitePixelOfScreen(pdue->s);
		XQueryColor(pdue->d, DefaultColormapOfScreen(pdue->s), &pdue->foreground);
		}
	if(XrmGetResource(pdue->xrmdb, "edd.background", "TopLevelShell", &ptype, &value) == True)
		{
		char    color_string[50];

		strncpy(color_string, value.addr, (int)value.size);
		status = XAllocNamedColor(pdue->d,
					      DefaultColormapOfScreen(pdue->s),
					      color_string,
					      &pdue->background,
					      &dbclr);
		if(!status)
			{
			printf(opiStringTab[STR_edd_bad_background_color_Hsn], color_string);
			pdue->background.pixel = BlackPixelOfScreen(pdue->s);
			XQueryColor(pdue->d, DefaultColormapOfScreen(pdue->s), &pdue->background);
			}
		}
	else
		{
		status = XAllocNamedColor(pdue->d,
					      DefaultColormapOfScreen(pdue->s),
					      "dark slate grey",
					      &pdue->background,
					      &dbclr);
		if(!status)
			{
			pdue->background.pixel = BlackPixelOfScreen(pdue->s);
			XQueryColor(pdue->d, DefaultColormapOfScreen(pdue->s), &pdue->background);
			}
		}

	/*
	 * I use the default visual since most servers can only load one
	 * color map at a time which leads me to use the default color map
	 * which must be used with the default visual.
	 */
	pdue->dlc.color = color_visual_test(pdue->d, DefaultScreen(pdue->d));

	/*
	 * convert from mm to pixels
	 */
	pdue->pixel_tolerence	= mm_to_xpixel(MM_TOLERENCE,		pdue->s);
	pdue->gizmo_width	= mm_to_xpixel(FORM_GIZSMO_WIDTH_MM,	pdue->s);
	pdue->gizmo_height	= mm_to_ypixel(FORM_GIZSMO_HEIGHT_MM,	pdue->s);
	pdue->gizmo_pad		= mm_to_xpixel(FORM_GIZSMO_PAD_MM,      pdue->s);
	pdue->xselect_border	= mm_to_xpixel(SELECT_BORDER_MM,	pdue->s);
	pdue->yselect_border	= mm_to_ypixel(SELECT_BORDER_MM,	pdue->s);

	/*
	 * read in the default load path from an environment variable
	 */
	pdue->penv_path = getenv("EPICS_DISPLAY_PATH");

	/*
	 * Setup the default display under edit parameters
	 * (must be done after dlc.color is set)
	 */
	init_due(pdue);

	/*
	 * setup the header geometry
	 */
	pdue->header_geom.x		= pdue->gizmo_height;
	pdue->header_geom.y		= pdue->gizmo_height;
	pdue->header_geom.width		= pdue->dl_hdr.object.width;
	pdue->header_geom.height	= pdue->gizmo_height*3;

	/*
	 * let them size down the display under edit no smaller than 3 gizmo widths
	 */
	xsh.min_height	= pdue->header_geom.height + pdue->gizmo_height*6;
	xsh.min_width	= pdue->gizmo_height*5; 
	xsh.width	= pdue->dl_hdr.object.width  + pdue->gizmo_height*2;
	xsh.height	= pdue->dl_hdr.object.height + pdue->header_geom.height + pdue->gizmo_height*3;
	xsh.flags	= PSize|PPosition|PMinSize;

	pdue->edd_geom.x	= xsh.x	= 0;
	pdue->edd_geom.y	= xsh.y	= 0;
	pdue->edd_geom.width	= xsh.width;
	pdue->edd_geom.height	= xsh.height;

	/*
	 * Create the top level window with input from the wm its an IO
	 * window to accomadate its siblings
	 */
	xswa.border_pixel	= pdue->foreground.pixel;
	xswa.bit_gravity	= NorthWestGravity;
	xswa.background_pixel	= pdue->background.pixel;
	xswa.event_mask		= StructureNotifyMask|ExposureMask|ButtonPressMask|PLAIN_MENU_MIN_EVENT_MASK;
	pdue->w = XCreateWindow(pdue->d,
				DefaultRootWindow(pdue->d),
				xsh.x,
				xsh.y,
				xsh.width,
				xsh.height,
				DUE_BORDER_WIDTH,
				CopyFromParent,		/* take depth from parent */
				InputOutput,
				CopyFromParent,		/* use the default visual */
				CWBorderPixel|CWBitGravity|CWEventMask|CWBackPixel,
				&xswa);
	{
		XWMHints	xwmh;
		char		banner[100];

		sprintf(banner, opiStringTab[STR_TIS4000_Display_Editor_VHdHd], DL_MAJOR_VERSION, DL_MINOR_VERSION);
		XSetNormalHints(pdue->d, pdue->w, &xsh);
		XStoreName(pdue->d, pdue->w, banner);
		XSetIconName(pdue->d, pdue->w, "edd");

		xwmh.window_group	= pdue->w;
		xwmh.input		= TRUE;
		xwmh.icon_pixmap	= XCreateBitmapFromData(pdue->d, 
								pdue->w,
								edd_icon_bits,
								edd_icon_width,
								edd_icon_height);
		xwmh.flags		= WindowGroupHint|IconPixmapHint|InputHint;
		XSetWMHints(pdue->d, pdue->w, &xwmh);
	}

	/*
	 * Create the display under edit window
	 */
	xswa.border_pixel	= CLIPCLRIX(pdue, pdue->dl_hdr.clr);
	xswa.background_pixel	= CLIPCLRIX(pdue, pdue->dl_hdr.bclr);
	xswa.bit_gravity	= NorthWestGravity;
	xswa.event_mask		= ExposureMask|ButtonPressMask|PLAIN_MENU_MIN_EVENT_MASK;
	pdue->dlc.w = XCreateWindow(pdue->d,
				pdue->w,
				pdue->gizmo_height,				/* x */
				pdue->gizmo_height*2+pdue->header_geom.height,	/* y */
				pdue->dl_hdr.object.width,
				pdue->dl_hdr.object.height,
				DUE_BORDER_WIDTH,
				CopyFromParent,		/* take depth from parent */
				InputOutput,
				CopyFromParent,		/* use the default visual */
				CWBorderPixel| CWBackPixel| CWBitGravity| CWEventMask,
				&xswa);

	GC_values.foreground	= pdue->background.pixel;
	GC_values.background	= pdue->foreground.pixel;
	pdue->back_GC		= XCreateGC(pdue->d, pdue->w, GCForeground|GCBackground, &GC_values);

	GC_values.foreground	= pdue->foreground.pixel;
	GC_values.background	= pdue->background.pixel;
	pdue->fore_GC		= XCreateGC(pdue->d, pdue->w, GCForeground|GCBackground, &GC_values);

	GC_values.foreground	= pdue->foreground.pixel;
	GC_values.background	= pdue->background.pixel;
	GC_values.plane_mask	= 1; 
	GC_values.line_style	= LineOnOffDash; 
	GC_values.function	= GXinvert; 
	pdue->invert_GC		= XCreateGC(pdue->d, pdue->w,
								GCForeground|GCBackground|GCPlaneMask|GCFunction|GCLineStyle, &GC_values);

	GC_values.line_style	= LineDoubleDash; 
	GC_values.dashes	= pdue->pixel_tolerence; 
	pdue->dyn_GC		= XCreateGC(pdue->d, pdue->w, GCLineStyle|GCDashList, &GC_values);

	GC_values.foreground	= pdue->foreground.pixel;
	GC_values.background	= pdue->background.pixel;
	GC_values.cap_style	= CapProjecting;
	GC_values.join_style	= JoinRound;
	GC_values.fill_rule	= WindingRule;
	pdue->dlc.gc		= XCreateGC(pdue->d, pdue->w, GCForeground|GCBackground|GCCapStyle|GCJoinStyle|GCFillRule, &GC_values);

	GC_values.foreground	= pdue->foreground.pixel;
	GC_values.background	= pdue->background.pixel;
	pdue->select_GC		= XCreateGC(pdue->d, pdue->w, GCForeground|GCBackground|GCCapStyle|GCJoinStyle|GCFillRule, &GC_values);

	pdue->create_cursor	= XCreateFontCursor(pdue->d, XC_dotbox);
	pdue->pick_cursor	= XCreateFontCursor(pdue->d, XC_crosshair);
	XRecolorCursor( pdue->d, pdue->create_cursor, &pdue->foreground, &pdue->background);
	XRecolorCursor( pdue->d, pdue->pick_cursor, &pdue->foreground, &pdue->background);

	pdue->dlc.pstring_table = (char **) &pdue->st;

	init_palette_menus(pdue->d);
	init_menu(pdue->d, &global_mc), update_color_rule_menu(pdue);
	init_menu(pdue->d, &nsedit_mc);
	init_menu(pdue->d, &sedit_mc);
	init_menu(pdue->d, &rmtsedit_mc);

	XMapWindow(pdue->d, pdue->dlc.w);
	XMapWindow(pdue->d, pdue->w);

	XSetSelectionOwner(pdue->dlc.d, XA_PRIMARY, None, CurrentTime);

	/*
	 * rudimentary command line arguments
	 */
	if(argc > display_name)
		{
		char	*pslash;

		pslash = strrchr(argv[display_name], '/');
#ifdef WIN32
		/* check for windows format directory separator */
		if (!pslash)
		    pslash = strrchr(argv[display_name], '\\');
#endif WIN32
		if(pslash)
			{
			memcpy(pdue->pldpath, argv[display_name], pslash-argv[display_name]);
			strcpy(pdue->pldname, pslash+1);
			}
		else
			{
			pdue->pldpath[0] = 0;
			strcpy(pdue->pldname, argv[display_name]);
			}
		load_display(pdue);
		}
	else
		/*
		 * resize windows for the default display
		 */
		configure_due(pdue, NULL);

	/*
	 * service any X events that may have already been generated
	 * and wait for new X events or blink timers to expire
	 */
#ifdef WIN32
	x_evhandler(pdue);
	while(1)
	{
	    x_evhandler(pdue);
	    Sleep(10);
	}
//	XtAppMainLoop (app_context);
#else
	x_evhandler(pdue);
	while(1)
		fdmgr_pend_event(pfdctx, &timeout);
#endif WIN32
	}

void	x_evhandler(pdue)
due	*pdue;
	{
#ifdef WIN32xx
	    while (XtAppPending(app_context))
#else
	    while (XPending(pdue->d))
#endif WIN32xx
		{
		XEvent  xevent;

#ifdef WIN32xx
		XtAppNextEvent(app_context, &xevent);
#else
		XNextEvent(pdue->d, &xevent);
#endif WIN32xx
		pdue->undo_sequence++;
		if(filter_gizmo_events(&xevent))
			continue;

		switch(xevent.type)
		  {
		  case Expose:
			if(xevent.xany.window == pdue->dlc.w)
				{
				XRectangle	rec;
				
				rec.x		= xevent.xexpose.x;
				rec.y		= xevent.xexpose.y;
				rec.width	= xevent.xexpose.width;
				rec.height	= xevent.xexpose.height;
				redraw_dl(pdue, &rec);
				}
			if(xevent.xany.window == pdue->w)
				{
				int	x2  = pdue->header_geom.x + pdue->header_geom.width;
				int	y2  = pdue->header_geom.y + pdue->header_geom.height;
				int	ex2 = xevent.xexpose.x + xevent.xexpose.width;
				int	ey2 = xevent.xexpose.y + xevent.xexpose.height;

				if(xevent.xexpose.x <= x2 && xevent.xexpose.y <= y2 &&
				   ex2 >= pdue->header_geom.x && ey2 >= pdue->header_geom.y)
				   	{
					redraw_header(pdue);
					}
				}
			break;

		  case ButtonPress:
			{
			XButtonEvent    *xbe    = &xevent.xbutton;

			if (xbe->window == pdue->w)	      /* display info (top) part of frame */
				switch(xbe->button)
				  {
				  case MENU_BUTTON:
				      post_menu(&xevent, &global_mc, pdue);
				      break;
				  }
			else if(xbe->window == pdue->dlc.w)     /* display (bottom) part of frame */
				switch(xbe->button)
				  {
				  case MENU_BUTTON:
					{
					struct menu_configuration	*pmc;
					Window						owner;

					/*
					 * makes a round trip to the server
					 * (seems to not cause unreasonable delays)
					 */
					owner = XGetSelectionOwner(pdue->d, XA_PRIMARY);
					if(owner == None)
						pmc = &nsedit_mc;		/* create... */
					else
						{
						if(owner == pdue->dlc.w && pdue->selections.count)
							pmc = &sedit_mc;	/* modify... */
						else
							pmc = &rmtsedit_mc;	/* cut, copy... */
						}
					post_menu(&xevent, pmc, pdue);
					break;
					}
				  case SELECT_TOGGLE_BUTTON:
					find_selection(&xevent, pdue);
					break;
				  case SELECT_BUTTON:
					if(pdue->selections.count > 0)
						{	      
						if(!adjust_with_handle(pdue, xbe->x, xbe->y))
							{
							/*
							 * could not adjust with handle, try to move if x,y is in
							 * one of the selected objects
							 */
							if(in_a_selected_object(pdue, xbe->x, xbe->y))
								move_selections(0, pdue);
							else
								find_selection(&xevent, pdue);
							}
						}
					else
						find_selection(&xevent, pdue);
					break;
					}
				break;
				}
		  case SelectionClear:
			/* This event does not require window enable */
			if(xevent.xselectionclear.window == pdue->dlc.w)
				sel_clear_action(pdue, &xevent.xselectionclear);
			break;

		  case SelectionRequest:
			/* This event does not require window enable */
			if(xevent.xselectionrequest.owner == pdue->dlc.w)
				send_selections(pdue, &xevent.xselectionrequest);
			break;

		  case SelectionNotify:
			/* This event does not require window enable */
			if(xevent.xselection.requestor == pdue->dlc.w)
				recv_selections(pdue, &xevent.xselection);
			break;

		  case ConfigureNotify:
			if(xevent.xconfigure.window == pdue->w)
				{
				XConfigureEvent	*pxce	= &xevent.xconfigure;

				/*
				 * update their display size
				 */
				pdue->dl_hdr.object.width	= pxce->width - pdue->gizmo_height*2;
				pdue->dl_hdr.object.height	= pxce->height - pdue->header_geom.height - pdue->gizmo_height*3;
				pdue->header_geom.width		= pdue->dl_hdr.object.width;
				XResizeWindow(pdue->d, pdue->dlc.w, pdue->dl_hdr.object.width, pdue->dl_hdr.object.height);
				}
			break;

		  case ButtonRelease:	break;
		  case MotionNotify:	break;
		  case EnterNotify:	break;
		  case LeaveNotify:	break;
		  case MapNotify:		break;
		  case UnmapNotify:	break;
		  }
		}
	}



/*
 * CONFIGURE DUE
 */
#define FDCHK(PFDCMP,PFDNAME) ((PFDNAME)?strcmp((PFDCMP),(PFDNAME))==0:TRUE)

void configure_due(pdue, pfdname)
due		*pdue;
char	*pfdname;
	{
	XWindowChanges	xwc;
	int				redraw = FALSE;

	/*
	 * not an ifelse list since all are executed if pfdname is nill
	 */
	if(FDCHK("cmap",pfdname))
		{
		XRectangle	rec;

		/*
		 * background set and redraw occur in edd_install_cmap()
		 */ 
		edd_load_cmap_from_display_file(pdue);
		if(!pdue->dlc.pcmap)
			{
			add_default_color_map(pdue);
			add_default_color_rules(pdue);
			}
		rec.x		= pdue->dl_hdr.object.x;
		rec.y		= pdue->dl_hdr.object.y;
		rec.width	= pdue->dl_hdr.object.width;
		rec.height	= pdue->dl_hdr.object.height;
		redraw_dl(pdue, &rec);
		}
	if(!pdue->dlc.pcmap)
		{
		add_default_color_map(pdue);
		add_default_color_rules(pdue);
		}
	if(FDCHK("width",pfdname))
		{
		xwc.width = pdue->dl_hdr.object.width + pdue->gizmo_height*2;
		xwc.width = max(xwc.width, pdue->gizmo_height*5);
		XConfigureWindow(pdue->d, pdue->w, CWWidth, &xwc);
		}
	if(FDCHK("height",pfdname))
		{
		xwc.height = pdue->dl_hdr.object.height + pdue->header_geom.height + pdue->gizmo_height;
		xwc.height = max(xwc.height,
				pdue->dl_hdr.object.height + pdue->header_geom.height + pdue->gizmo_height*3);
		XConfigureWindow(pdue->d, pdue->w, CWHeight, &xwc);
		}
	if(FDCHK("bclr",pfdname))
		{
		XSetWindowBackground(pdue->d, pdue->dlc.w, CLIPCLRIX(pdue, pdue->dl_hdr.bclr));
		redraw=TRUE;
		}
	if(FDCHK("clr",pfdname))
		{
		XSetWindowBorder(pdue->d, pdue->dlc.w, CLIPCLRIX(pdue, pdue->dl_hdr.clr));
		}
	if(redraw)
		redraw_dl(pdue, NULL);
	}


/*
 *	REDRAW_HEADER
 *
 *	redraw the editor status window
 *
 *	NOTE: acall to XClearArea for this window is a
 *	good way to force an expose with redraw.
 */
void redraw_header(pdue)
due	*pdue;
	{
	XRectangle	rec;
	
	XClearArea(pdue->d, 
		pdue->w, 
		pdue->header_geom.x,
		pdue->header_geom.y,
		0,				/* clear out to the end of the window */
		pdue->header_geom.height+1,	/* +1 get the rectangle */
		False);

      rec.x			= pdue->header_geom.x;
      rec.y			= pdue->header_geom.y;
      rec.width		= pdue->header_geom.width;
      rec.height	= pdue->gizmo_height;
      draw_string(pdue->d, pdue->w, pdue->fore_GC, &rec, pdue->dlc.pfont_table, pdue->ppath, strlen(pdue->ppath), box_begin);

      rec.y	+= rec.height;
      draw_string(pdue->d, pdue->w, pdue->fore_GC, &rec, pdue->dlc.pfont_table, pdue->pname, strlen(pdue->pname), box_begin);

	redraw_msg(pdue);
	}

/*
 *	REDRAW_MSG
 *
 *	redraw the editor msg line
 */
void redraw_msg(pdue)
due	*pdue;
	{
	XRectangle rec;

	rec.x		= pdue->header_geom.x;
	rec.y		= pdue->header_geom.y + (pdue->gizmo_height<<1);
	rec.width	= pdue->header_geom.width;
	rec.height	= pdue->gizmo_height;
	XClearArea(pdue->d, 
			pdue->w, 
			rec.x,
			rec.y,
			0,		      /* clear out to the end of the window */
			rec.height+1,	      /* +1 get the rectangle */
			False);

	if(pdue->pmsg[0])
		draw_string(pdue->d, 
			pdue->w, 
			pdue->fore_GC, 
			&rec, 
			pdue->dlc.pfont_table, 
			pdue->pmsg,
			strlen(pdue->pmsg),
			box_begin);

	/*
	 * so messages will display while edd is busy
	 */
	XFlush(pdue->d);
	}



/*
 *	INIT_DUE
 *
 */
void init_due(pdue)
due	*pdue;
	{
	stringInitList(&pdue->st);
	stringInitList(&pdue->ct);
	open_structure(dl_hdr_sinfo, &pdue->dl_hdr, pdue);
	pdue->dl_hdr.object			= default_display_geometry;
	mmgo_to_pixelgo(pdue->d, &pdue->dl_hdr.object);
	pdue->dl_hdr.nwords_dspy	= sizeof(pdue->dl_hdr);
	pdue->dl_mdt				= FALSE;
	pdue->dl_hdr.magic			= DL_MAGIC;
	pdue->dl_hdr.majv			= DL_MAJOR_VERSION;
	pdue->dl_hdr.mnrv			= DL_MINOR_VERSION;
	pdue->dl_hdr.clr			= white;
	pdue->dl_hdr.bclr			= black;
	pdue->next_groupid			= NO_GROUP+1;

	/*
	 * set the default display path as the current wd
	 * set the display name to none
	 */
	pdue->pname[0] = 0;
#ifdef SOLARIS
	getcwd (pdue->ppath, sizeof(pdue->ppath));
#else
#ifdef WIN32
		_getcwd(pdue->ppath, sizeof(pdue->ppath));
#else
		getwd(pdue->ppath);
#endif WIN32
#endif

	/*
	 * create a default color map with only white and black
	 * and an empty color rule table
	 */
	add_default_color_map(pdue);
	add_default_color_rules(pdue);
	}



/*
 *	ADD_DEFAULT_COLORMAP
 *
 * create a default color map with only white and black
 */
void add_default_color_map(pdue)
due	*pdue;
	{
#define LITE	(unsigned char)~0
#define OUT_VAL	(unsigned char)0
	struct dl_color		dlc[number_of_default_colors];

	dlc[white].r			= LITE;
	dlc[white].g			= LITE;
	dlc[white].b			= LITE;
	dlc[white].inten		= LITE;
	dlc[white].blink		= FALSE;

	dlc[black].r			= OUT_VAL;
	dlc[black].g			= OUT_VAL;
	dlc[black].b			= OUT_VAL;
	dlc[black].inten		= OUT_VAL;
	dlc[black].blink		= FALSE;

	dlc[red].r			= LITE;
	dlc[red].g			= OUT_VAL;
	dlc[red].b			= OUT_VAL;
	dlc[red].inten			= LITE;
	dlc[red].blink			= FALSE;

	dlc[blinking_red].r		= LITE;
	dlc[blinking_red].g		= OUT_VAL;
	dlc[blinking_red].b		= OUT_VAL;
	dlc[blinking_red].inten		= LITE;
	dlc[blinking_red].blink		= TRUE;

	dlc[yellow].r			= LITE;
	dlc[yellow].g			= LITE;
	dlc[yellow].b			= OUT_VAL;
	dlc[yellow].inten		= LITE;
	dlc[yellow].blink		= FALSE;

	dlc[blinking_yellow].r		= LITE;
	dlc[blinking_yellow].g		= LITE;
	dlc[blinking_yellow].b		= OUT_VAL;
	dlc[blinking_yellow].inten	= LITE;
	dlc[blinking_yellow].blink	= TRUE;

	dlc[blue].r			= OUT_VAL;
	dlc[blue].g			= OUT_VAL;
	dlc[blue].b			= LITE;
	dlc[blue].inten			= LITE;
	dlc[blue].blink			= FALSE;

	dlc[blinking_blue].r		= OUT_VAL;
	dlc[blinking_blue].g		= OUT_VAL;
	dlc[blinking_blue].b		= LITE;
	dlc[blinking_blue].inten	= LITE;
	dlc[blinking_blue].blink	= TRUE;

	edd_create_cmap(pdue, dlc, NELEMENTS(dlc), 0, TRUE);

	if(pdue->w)
		{
		sprintf(pdue->pmsg, opiStringTab[STR_Default_color_map_installedn]);
		redraw_msg(pdue);
		}
	}



/*
 *	ADD_DEFAULT_COLORRULES
 *
 * create a default color rules with only white and black
 */
void add_default_color_rules(pdue)
due	*pdue;
	{
	struct dl_color_rule	default_color_rule;
	int	i;

#ifndef TOKENPTRS

	/* Setup default alarm color rule */

	pdue->dl_hdr.clrrule			= stringInsert(&pdue->st, opiStringTab[STR_alarm                       ]);
	default_color_rule.name			= stringInsert(&pdue->st, opiStringTab[STR_alarm                       ]);

	default_color_rule.info[0].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[0].value	= stringInsert(&pdue->st, opiStringTab[STR_MAJOR                       ]);
	default_color_rule.info[0].connector	= dl_clrrule_and;
	default_color_rule.info[0].operation	= dl_clrrule_eq;
	default_color_rule.info[0].clr		= black;
	default_color_rule.info[1].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCACK                       ]);
	default_color_rule.info[1].value	= stringInsert(&pdue->st, opiStringTab[STR_YES                         ]);
	default_color_rule.info[1].connector	= dl_clrrule_use;
	default_color_rule.info[1].operation	= dl_clrrule_eq;
	default_color_rule.info[1].clr		= blinking_red;

	default_color_rule.info[2].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[2].value	= stringInsert(&pdue->st, opiStringTab[STR_MAJOR                       ]);
	default_color_rule.info[2].connector	= dl_clrrule_use;
	default_color_rule.info[2].operation	= dl_clrrule_eq;
	default_color_rule.info[2].clr		= red;

	default_color_rule.info[3].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[3].value	= stringInsert(&pdue->st, opiStringTab[STR_MINOR                       ]);
	default_color_rule.info[3].connector	= dl_clrrule_and;
	default_color_rule.info[3].operation	= dl_clrrule_eq;
	default_color_rule.info[3].clr		= black;
	default_color_rule.info[4].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCACK                       ]);
	default_color_rule.info[4].value	= stringInsert(&pdue->st, opiStringTab[STR_YES                         ]);
	default_color_rule.info[4].connector	= dl_clrrule_use;
	default_color_rule.info[4].operation	= dl_clrrule_eq;
	default_color_rule.info[4].clr		= blinking_yellow;

	default_color_rule.info[5].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[5].value	= stringInsert(&pdue->st, opiStringTab[STR_MINOR                       ]);
	default_color_rule.info[5].connector	= dl_clrrule_use;
	default_color_rule.info[5].operation	= dl_clrrule_eq;
	default_color_rule.info[5].clr		= yellow;

	default_color_rule.info[6].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[6].value	= stringInsert(&pdue->st, opiStringTab[STR_INFO                        ]);
	default_color_rule.info[6].connector	= dl_clrrule_and;
	default_color_rule.info[6].operation	= dl_clrrule_eq;
	default_color_rule.info[6].clr		= black;
	default_color_rule.info[7].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCACK                       ]);
	default_color_rule.info[7].value	= stringInsert(&pdue->st, opiStringTab[STR_YES                         ]);
	default_color_rule.info[7].connector	= dl_clrrule_use;
	default_color_rule.info[7].operation	= dl_clrrule_eq;
	default_color_rule.info[7].clr		= blinking_blue;

	default_color_rule.info[8].chan		= stringInsert(&pdue->st, opiStringTab[STR_GCSEVR                      ]);
	default_color_rule.info[8].value	= stringInsert(&pdue->st, opiStringTab[STR_INFO                        ]);
	default_color_rule.info[8].connector	= dl_clrrule_use;
	default_color_rule.info[8].operation	= dl_clrrule_eq;
	default_color_rule.info[8].clr		= blue;

	for (i=9 ; i<MAX_RULE_LINES ; i++) {
	    default_color_rule.info[i].chan		= stringInsert(&pdue->st, "");
	    default_color_rule.info[i].value		= stringInsert(&pdue->st, "");
	    default_color_rule.info[i].connector	= dl_clrrule_use;
	    default_color_rule.info[i].operation	= dl_clrrule_eq;
	    default_color_rule.info[i].clr		= black;
	}

#else
	pdue->dl_hdr.clrrule			= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_alarm                       ]));
	default_color_rule.name			= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_alarm                       ]));

	default_color_rule.info[0].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[0].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_MAJOR                       ]));
	default_color_rule.info[0].connector	= dl_clrrule_and;
	default_color_rule.info[0].operation	= dl_clrrule_eq;
	default_color_rule.info[0].clr		= black;
	default_color_rule.info[1].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCACK                       ]));
	default_color_rule.info[1].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_YES                         ]));
	default_color_rule.info[1].connector	= dl_clrrule_use;
	default_color_rule.info[1].operation	= dl_clrrule_eq;
	default_color_rule.info[1].clr		= blinking_red;

	default_color_rule.info[2].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[2].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_MAJOR                       ]));
	default_color_rule.info[2].connector	= dl_clrrule_use;
	default_color_rule.info[2].operation	= dl_clrrule_eq;
	default_color_rule.info[2].clr		= red;

	default_color_rule.info[3].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[3].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_MINOR                       ]));
	default_color_rule.info[3].connector	= dl_clrrule_and;
	default_color_rule.info[3].operation	= dl_clrrule_eq;
	default_color_rule.info[3].clr		= black;
	default_color_rule.info[4].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCACK                       ]));
	default_color_rule.info[4].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_YES                         ]));
	default_color_rule.info[4].connector	= dl_clrrule_use;
	default_color_rule.info[4].operation	= dl_clrrule_eq;
	default_color_rule.info[4].clr		= blinking_yellow;

	default_color_rule.info[5].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[5].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_MINOR                       ]));
	default_color_rule.info[5].connector	= dl_clrrule_use;
	default_color_rule.info[5].operation	= dl_clrrule_eq;
	default_color_rule.info[5].clr		= yellow;

	default_color_rule.info[6].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[6].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_INFO                        ]));
	default_color_rule.info[6].connector	= dl_clrrule_and;
	default_color_rule.info[6].operation	= dl_clrrule_eq;
	default_color_rule.info[6].clr		= black;
	default_color_rule.info[7].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCACK                       ]));
	default_color_rule.info[7].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_YES                         ]));
	default_color_rule.info[7].connector	= dl_clrrule_use;
	default_color_rule.info[7].operation	= dl_clrrule_eq;
	default_color_rule.info[7].clr		= blinking_blue;

	default_color_rule.info[8].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_GCSEVR                      ]));
	default_color_rule.info[8].value	= dmTokenFromPointer64 (stringInsert (&pdue->st, opiStringTab[STR_INFO                        ]));
	default_color_rule.info[8].connector	= dl_clrrule_use;
	default_color_rule.info[8].operation	= dl_clrrule_eq;
	default_color_rule.info[8].clr		= blue;

	for (i=9 ; i<MAX_RULE_LINES ; i++) {
	    default_color_rule.info[i].chan		= dmTokenFromPointer64 (stringInsert (&pdue->st, ""));
	    default_color_rule.info[i].value		= dmTokenFromPointer64 (stringInsert (&pdue->st, ""));
	    default_color_rule.info[i].connector	= dl_clrrule_use;
	    default_color_rule.info[i].operation	= dl_clrrule_eq;
	    default_color_rule.info[i].clr		= black;
	}

#endif

	default_color_rule.fg_enable		= 1;
	default_color_rule.default_fg		= white;
	default_color_rule.bg_enable		= 1;
	default_color_rule.default_bg		= black;

	edd_create_crules(pdue, &default_color_rule, 1, 0);
	}


/*
 *	INIT_BLINK
 */
struct timeval	blinkrate	= {1, 0};
due				*saved_pdue;

init_blink(pdue)
due	*pdue;
	{
	void			edd_do_blink();
	static int		first_time	= 1;

	if (first_time && !converting)
		{
		first_time = 0;		/* we only need to do this once */
#ifdef WIN32
		XtAddTimeOut (blinkrate.tv_sec*1000, edd_do_blink, pdue);
#else
		fdmgr_add_timeout(pfdctx, &blinkrate, edd_do_blink, pdue);
#endif WIN32
		saved_pdue = pdue;	/* this better not change! */
		}
	return 0;
	}


/*
 *	EDD_DO_BLINK
 */
void	edd_do_blink(pdue)
due	*pdue;
	{
	static int	toggle = 0;

	toggle ^= 1;
	do_blink(pdue->d, pdue->dlc.pcmap, toggle);
#ifdef WIN32
	x_evhandler(pdue);
	XtAddTimeOut (blinkrate.tv_sec*1000, edd_do_blink, pdue);
#else
	fdmgr_add_timeout(pfdctx, &blinkrate, edd_do_blink, pdue);
#endif WIN32
	}

kludgeblinker()
	{
	static int	toggle				= 0;
	static long	last_toggle_time	= 0;
	long		current_time		= time(0);

	if((current_time - last_toggle_time) > 0)
		{
		toggle ^= 1;
		do_blink(saved_pdue->d, saved_pdue->dlc.pcmap, toggle);
		last_toggle_time = current_time;
		}
	return 0;
	}

#ifdef WIN32
static char *
GetHomeDir(dest)
char  *dest;
	{
	char					*ptr;

	if((ptr = getenv("HOME")) != NULL)
		return strcpy(dest, ptr);
	if((ptr = getenv("\\tis4000")) != NULL)
		{
		strcpy (dest, ptr);
		strcat (dest, "\\tasks");
		return dest;
		}
	return strcpy(dest, "\\tis4000\\tasks");
	}
#else
#include <pwd.h>

static char *
GetHomeDir(dest)
char  *dest;
	{
	extern char				*getenv();
	extern int				getuid();
	extern struct passwd	*getpwuid();
	struct passwd			*pw;
	char					*ptr;

	if((ptr = getenv("HOME")) != NULL)
		return strcpy(dest, ptr);

	if((pw = ((ptr = getenv("USER")) != NULL) ? getpwnam(ptr) : getpwuid(getuid())) != NULL)
		return strcpy(dest, pw->pw_dir);

	*dest = '\0';
	return dest;
	}
#endif WIN32

static check_all_string_offsets()
	{
	struct ginfo	*pginfo;

	check_string_offsets(dl_hdr_sinfo);	
	check_string_offsets(dl_dynamic_attribute_sinfo);
	check_string_offsets(dl_color_rule_sinfo);
	for (pginfo = &dl_elements_ginfo[0]; pginfo->sinfo; pginfo++)
		check_string_offsets(pginfo->sinfo);
	return 0;
	}
