/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/******************************************************************************
 *                                                                            *
 *      path:  ca_strip.h                                                     *
 *                                                                            *
 ******************************************************************************/

#include "cadef.h"

typedef struct
{
    char name [34];		/* point name ( + field name + '.'+'\0' */
    chid caChid;		/* channel access id */
    int chid_status;		/* connected, disconnected */
    evid evId;			/* event id for monitor */
    chid rateChid;		/* channel access id */
    long chanrate;		/* time between samples for waveforms in ms */
    TS_STAMP sampletime;	/* time for first sample in array */
    int nsamples;		/* number of samples in array */
    int samplerate;		/* time between samples */
    double *samples;		/* plot data, or HUGE for disconnected values */
} strip_channel;


strip_channel	*OpenStripChannel (char *ca_name, int nsamples,
				   int samplerate, double *databuffer);
void		CAStripSync (strip_channel *sp);
void		StopMonitor (strip_channel *sp);

