/*color_map.h,v 1.1.1.1 1999/08/03 14:44:02 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifndef INCcolor_maph
#define INCcolor_maph

#ifndef INCgizmoh
#include <gizmo.h>
#endif


struct color_map
	{
	unsigned short	ncolors;
	unsigned long	*pcolor_pixels;
	unsigned long	*pinten_pixels;
	struct dl_color	*pdl_colors;
	gizmo			*ppopg;
	};

struct color_map 	*create_cmap();
struct color_map 	*load_cmap_from_display_file();

int		color_visual_test();
void	delete_cmap();
enum	mapping {color_mapping, intensity_mapping};
enum	get_color_option {reuse_pixel, dont_reuse_pixel};

/*
 * converts a software color index to a hardware color map index (or pixel using X language).
 * If INDEX (i) is outside of NPIXELS (n) then use CLIPINDEX (ci).
 * If CLIPINDEX is outside of NPIXELS then use WhitePixel() for the DISPLAY (d).
 * Uses white for invisibleColor for editing purposes.
 */
extern	int	invisibleColor;
#define	DEFAULT_INVISIBLE_COLOR		252 /* -2L */
#define INDEX_TO_PIXEL(i, n, p, ci, d) (((i) == invisibleColor) ? WhitePixel(d, DefaultScreen(d)) : CLIP_INDEX(i, n, p, \
		CLIP_INDEX(ci, n, p, WhitePixel(d, DefaultScreen(d)))))

#define CLIP_INDEX(i, n, p, cp) (((i)<(n)) ? (p)[i] : (cp))

#define	COLOR_LOOKUP(x,i)	(((i) == invisibleColor) ? invisibleColor : x[i])

#endif
