/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *** xwd2ps.h - defines for xwd2ps
 */

/*
 * define the various types of dumps we might print
 */

#define UNKNOWN   0
#define COLOR24   1
#define PSEUDO12  2
#define PSEUDO8   3
#define PSEUD04   4
#define GRAY24    5
#define GRAY12    6
#define GRAY8     7
#define GRAY4     8
#define GRAY2     9
#define GRAY1    10

#define INTENSITY(color) (39L*color.red + 50L*color.green + 11L*color.blue)
#define FALSE     0
#define TRUE      1
#define PORTRAIT  0
#define LANDSCAPE 1
#define LOGOHEIGHT 0.5

#define MAPMAXPERLINE 35    /* PostScript colormap data line length-1 */
#define MAXPERLINE    35    /* PostScript image data line length-1 */

typedef struct Image {
  float height;
  float width;
  float gamma;             /* gamma correction factor for brightening images */
  float width_frac;        /* fraction of horizontal raster to use for image */
  float height_frac;       /* fraction of vertical raster to use for image */
  int   orientation;
  int   pixels_width;
  int   ps_width;
  int   ps_height;
} Image;

typedef struct Page {
  char  type[20];        /* page size, e.g. A or letter, B, A4, A3 */
  float ximagepos;
  float yimagepos;
  float maxhsize;
  float maxwsize;
  float xcenter;
  float ycenter;
  float default_height;
  float default_width;
  float yoffset;
  float height_adjust;
  float time_date_height;
} Page;

typedef struct Flag {
  int logo;
  int black2white; /* map black values to white */
  int date;
  int title;
  int time;
  int w;
  int h;
  int gamma;      /* gamma correction flag */
  int mono;       /* monochrome flag: TRUE = create monochrome PS */
  int inc_file;    /* include file flag: TRUE = append a file */
  int landscape;
  int portrait;
  int border;
  int invert;
  int xtitle;	/* use window title as title of output */
  int error;            /* option error flag */
} Flag;

typedef struct Title {
  char  *string;
  int   font_size;
  float height;
} Title;

typedef struct File {
    FILE *pointer;
    char *name;
} File;

typedef struct Options {
  Title title;
  int   ncopies;
  File  input_file;
  File  inc_file;
} Options;
