/*platform.c,v 1.1.1.1 1999/08/03 14:44:12 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*		PLATFORM SPECIFIC ROUTINE STARTUP		*/
/*								*/
/*	The startup.cmd file is to contain a call to the	*/
/*	platform routine passing the name of the vxWorks	*/
/*	target computer type (e.g., platform("mv147")).		*/
/*	This routine will launch all the appropriate tasks	*/
/*	for that specific hardware platform.			*/
/*								*/
/****************************************************************/

#include <vxWorks.h>
#include <logLib.h>
#include <string.h>

#include "platform.h"

int platform (char *target, int priority, int rate)
{
	if (!target)
		{
		logMsg("No platform specified. Command ignored.\n",0,0,0,0,0,0);
		return (-1);
		}

	if (strcmp(target, "mv147") == 0)
		{
#if (CPU_FAMILY == MC680X0)
		start_mv147();
#endif
		}

	else if (strcmp(target, "mv167") == 0)
		{
#if (CPU_FAMILY == MC680X0)
		start_mv167(rate);
#endif
		}
	else if (strcmp(target, "x486") == 0)
		{
#if (CPU_FAMILY == I80X86)
		start_x486(priority, rate);
#endif
		}
	else
		{
		logMsg("Platform %s is not recognized. Command ignored.\n", 
			(int)target,0,0,0,0,0);
		return (-1);
		}
	
	return (1);
}
