/* p4port.h (c)Copyright Sequiter Software Inc., 1990-1994.  All rights reserved.

   Declarations for non-standard C runtime library functions.

   CB 5.1 MULTI-PLATFORM RELEASE DATE:   NOVEMBER 21/94
*/

/****************************************************************************/
/************************* Tate Supported Platforms *************************/
/****************************************************************************/

#if (defined(SOLARIS))
#if (defined(BYTEORDER_0123))
#define SUN_SOLARIS2_X86
#else
#define SUN_SOLARIS2_SPARC
#endif
#else
#if (defined(MIPSEL))
#define DEC_ULTRIX_MIPSEL
#endif
#if (defined(AXP))
#define DEC_OSF1_AXP
#endif
#endif

#ifdef SUN_SOLARIS1_SPARC        
#define S4SUN
#define S4DEBUG
#endif

#ifdef SUN_SOLARIS2_SPARC
#define S4SOLARIS
#define S4DEBUG   
#endif

#ifdef SUN_SOLARIS2_X86    
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */
#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#define	S4DEBUG
#endif

#ifdef DEC_ULTRIX_MIPSEL    
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */
#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#define	S4DEBUG
#endif

#ifdef DEC_OSF1_AXP    
#define S4DEC
#endif

/****************************************************************************/

#ifdef S4SCO        
   error - This version of CodeBase Multi-Platform 5.1 does not support the 
   error - SCO operating system.  Please contact Sequiter Software.
#endif

#ifdef S4COHERENT   
   error - This version of CodeBase Multi-Platform 5.1 does not support the 
   error - Coherent operating system.  Please contact Sequiter Software.
#endif

#ifdef S4UNIXWARE   
   error - This version of CodeBase Multi-Platform 5.1 does not support the 
   error - UnixWare operating system.  Please contact Sequiter Software.
#endif

#ifdef S4INTERACTIVE
   error - This version of CodeBase Multi-Platform 5.1 does not support the 
   error - Interactive operating system.  Please contact Sequiter Software.
#endif

#ifdef S4MACINTOSH  
   error - This version of CodeBase Multi-Platform 5.1 does not support the 
   error - MacIntosh operating system.  Please contact Sequiter Software.
#endif

#ifdef S4SUN        
#define S4BYTEORDER_3210  /* use for 3210 systems */
#define S4BYTE_SWAP       /* use for swapping bytes on 3210 systems */
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */
#define	S4NO_MEMMOVE

#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#endif

#ifdef S4DEC
#define S4MEMCMP 
#define S464BIT            /* #define S4LONG int  */
   extern int Toupper( int );
#endif

#ifdef S4SOLARIS    
#define S4BYTEORDER_3210  /* use for 3210 systems */
#define S4BYTE_SWAP       /* use for swapping bytes on 3210 systems */
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */

#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#endif

#ifdef S4HPUX       
#define S4BYTEORDER_3210  /* use for 3210 systems */
#define S4BYTE_SWAP       /* use for swapping bytes on 3210 systems */
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */

#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#endif

#ifdef S4AIX        
#define S4BYTEORDER_3210  /* use for 3210 systems */
#define S4BYTE_SWAP       /* use for swapping bytes on 3210 systems */
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */
#endif

#ifdef S4SGI        
#define S4BYTEORDER_3210  /* use for 3210 systems */
#define S4BYTE_SWAP       /* use for swapping bytes on 3210 systems */
#define S4MEMCMP          /* use if memcmp() uses signed byte comparison */

#define USHRT_MAX      0xFFFF 
#define INT_MAX        0x7FFF 
#define UINT_MAX       0xFFFF
#endif

/* Define the size of a long */

#ifdef S464BIT
#define	S4LONG	int
#else
#define	S4LONG	long
#endif
	
/* CodeBase Multi-Platform defines */

#define S4OPTIMIZE_OFF
#define S4LOCKF          /* use function lockf() for locking  */
#define S4ERRNO            /* use global variable, 'errno'          */
#define S4NO_CHSIZE        /* use if chsize() not found             */
#define S4NO_DUP           /* use if dup() not found/not required   */
#define S4NO_FILELENGTH    /* use if filelength() not found         */
#define S4NO_NEGATIVE_LOCK /* use if negative locking not supported */
#define S4NO_POW           /* use if pow() not found                */
#define S4NO_REMOVE        /* use if remove() not found             */
#define S4NO_RENAME        /* use if rename() not found             */
#define S4NO_STRLWR        /* use if strlwr() not found             */
#define S4NO_STRNICMP      /* use if strnicmp() not found           */
#define S4NO_STRUPR        /* use if strupr() not found             */

/* #define S4LSEEK           */ /* use if lseek() cannot seek past EOF */
/* #define S4NO_ATOF         */ /* use if atof() not found */
/* #define S4NO_ECVT         */ /* use if ecvt() not found */
/* #define S4NO_FCVT         */ /* use if fcvt() not found */
/* #define S4NO_SIZE_T       */ /* use if variable size_t not found */

#define  S4CMP_PARM  void *          
#include <unistd.h>

#ifndef S4NO_ECVT 
#ifndef S4HPUX
   char *ecvt( double, int, int*, int* ) ; 
#endif
#endif

#ifndef S4NO_FCVT 
#ifndef S4HPUX
   char *fcvt( double, int, int*, int* ) ;
#endif
#endif

#ifdef S4LOCKF
#define S4LOCKING
#endif

#ifdef S4NO_SIZE_T
   typedef unsigned size_t ;
#endif

#ifdef __cplusplus
   extern "C"   {
#endif

#ifdef S4NO_STRNICMP
   int strnicmp(char *, char *, size_t ) ;
#endif

#ifdef S4NO_MEMMOVE
   void *memmove(void *, void *, size_t) ;
#endif

#ifdef S4LSEEK
#define S4OFF_OPTIMIZE 
   S4LONG f4lseek(FILE4 *, S4LONG, int, int ) ;
#endif

#ifdef S4NO_FCVT 
   char *f4fcvt( double, int, int *, int * ) ;
#endif

#ifdef S4NO_ECVT 
   char *f4ecvt( double, int, int *, int * ) ;
#endif

#ifdef S4NO_ATOF
   double c4atof(char *) ;
#endif

#ifdef __cplusplus
   }
#endif

#ifdef S4BYTEORDER_3210
#define S4DO_BYTEORDER
#endif

#ifdef S4BYTEORDER_2301
#define S4DO_BYTEORDER
#endif
