#include "d4all.h"

F4FIELD_INFO  field_info [] = {
	{"FIELD1",	'C',	20,	0},
	{"FIELD2",	'C',	20,	0},
	{"FIELD3",	'C',	20,	0},
	{"FIELD4",	'C',	20,	0},
	{"FIELD5",	'C',	20,	0},
	{0,		0,	0,	0},
};

T4TAG_INFO tag_info [] = {
	{"TAG1",	"FIELD1",	0,			0,	0},
	{"TAG2",	"FIELD2",	".NOT. DELETED()",	0,	0},
	{0,		0,		0,			0,	0}
};

int	Verbose=1, Debug=0, Trace=0, Redundancy=1;
extern	int	noInetd;
static	void	writeStuff ();

main ()
{
	C4CODE		cb;
	D4DATA		*data1, *data2, *data3;
	F4FIELD		*fld11, *fld12, *fld13, *fld14, *fld15;
	F4FIELD		*fld21, *fld22, *fld23, *fld24, *fld25;
	F4FIELD		*fld31, *fld32, *fld33, *fld34, *fld35;
	char		buf [20];
	int		i;
	T4TAG		*tag1, *tag2, *tag3;

	system ("rm -f /tis4000db/test1.*");
	system ("rm -f /tis4000db/test2.*");
	system ("rm -f /tis4000db/test3.*");

	noInetd = 0;
	d4init (&cb);

	data1 = d4create (&cb, "/tis4000db/test1", field_info, tag_info);
	fld11 = d4field (data1, "FIELD1");
	fld12 = d4field (data1, "FIELD2");
	fld13 = d4field (data1, "FIELD3");
	fld14 = d4field (data1, "FIELD4");
	fld15 = d4field (data1, "FIELD5");
	tag1 = d4tag (data1, "TAG1");
	d4tag_select (data1, tag1);

	data2 = d4create (&cb, "/tis4000db/test2", field_info, tag_info);
	fld21 = d4field (data2, "FIELD1");
	fld22 = d4field (data2, "FIELD2");
	fld23 = d4field (data2, "FIELD3");
	fld24 = d4field (data2, "FIELD4");
	fld25 = d4field (data2, "FIELD5");
	tag2 = d4tag (data2, "TAG1");
	d4tag_select (data2, tag2);

	data3 = d4create (&cb, "/tis4000db/test3", field_info, tag_info);
	fld31 = d4field (data3, "FIELD1");
	fld32 = d4field (data3, "FIELD2");
	fld33 = d4field (data3, "FIELD3");
	fld34 = d4field (data3, "FIELD4");
	fld35 = d4field (data3, "FIELD5");
	tag3 = d4tag (data3, "TAG1");
	d4tag_select (data3, tag3);

	for (i=0 ; i<10000 ; i++) {
	    writeStuff (1, data1, fld11, fld12, fld13, fld14, fld15, i);
	    writeStuff (2, data2, fld21, fld22, fld23, fld24, fld25, i);
	    writeStuff (3, data3, fld31, fld32, fld33, fld34, fld35, i);
	}
	
	d4close (data1);
	d4close (data2);
	d4close (data3);

}

/*----------*/
static void writeStuff (file, data, fld1, fld2, fld3, fld4, fld5, i)

    D4DATA	*data;
    F4FIELD	*fld1, *fld2, *fld3, *fld4, *fld5;
    int		i, file;

    {

	char	buf [50];

	d4append_start (data, 0);
	d4blank (data);

	sprintf (buf, "File %d,Field 1.%d", file, i);
	f4assign (fld1, buf);
	sprintf (buf, "File %d,Field 2.%d", file, i);
	f4assign (fld2, buf);
	sprintf (buf, "File %d,Field 3.%d", file, i);
	f4assign (fld3, buf);
	sprintf (buf, "File %d,Field 4.%d", file, i);
	f4assign (fld4, buf);
	sprintf (buf, "File %d,Field 5.%d", file, i);
	f4assign (fld5, buf);

	d4append (data);

    }

	    	

