
# line 2 "../../../share/src/sequencer/snc.y"
/**************************************************************************
			GTA PROJECT   AT division
	Copyright, 1990, The Regents of the University of California.
		         Los Alamos National Laboratory

	@(#)snc.y	1.5	2/3/92
	ENVIRONMENT: UNIX
	HISTORY:
20nov91,ajk	Added new "option" statement.
***************************************************************************/
/*	SNC - State Notation Compiler.
 *	The general structure of a state program is:
 *		program-name
 *		declarations
 *		ss  { state { event { action ...} new-state } ... } ...
 *
 *	The following yacc definitions call the various parsing routines, which
 *	are coded in the file "parse.c".  Their major action is to build
 *	a structure for each SNL component (state, event, action, etc.) and
 *	build linked lists from these structures.  The linked lists have a
 *	hierarchical structure corresponding to the SNL block structure.
 *	For instance, a "state" structure is linked to a chain of "event",
 *	structures, which are, in turn, linked to a chain of "action"
 *	structures.
 *	The lexical analyser (see snc_lax.l) reads the input
 *	stream and passes tokens to the yacc-generated code.  The snc_lex
 *	and parsing routines may also pass data elements that take on one
 *	of the types defined under the %union definition.
 *
 */
#include	<stdio.h>
#include	<ctype.h>
#include	"parse.h"
/* in snc_main.c */
void snc_err (char *err_txt);
void yyerror (char *err);

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif	TRUE

extern	int line_num; /* input file line no. */

# line 46 "../../../share/src/sequencer/snc.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
	int	ival;
	char	*pchar;
	void	*pval;
	Expr	*pexpr;
} YYSTYPE;
# define STATE 257
# define STATE_SET 258
# define NUMBER 259
# define NAME 260
# define DEBUG_PRINT 261
# define PROGRAM 262
# define EXIT 263
# define OPTION 264
# define R_SQ_BRACKET 265
# define L_SQ_BRACKET 266
# define BAD_CHAR 267
# define L_BRACKET 268
# define R_BRACKET 269
# define COLON 270
# define SEMI_COLON 271
# define EQUAL 272
# define L_PAREN 273
# define R_PAREN 274
# define PERIOD 275
# define POINTER 276
# define COMMA 277
# define OR 278
# define AND 279
# define MONITOR 280
# define ASSIGN 281
# define TO 282
# define WHEN 283
# define CHAR 284
# define SHORT 285
# define INT 286
# define LONG 287
# define FLOAT 288
# define DOUBLE 289
# define STRING_DECL 290
# define EVFLAG 291
# define SYNC 292
# define ASTERISK 293
# define AMPERSAND 294
# define AUTO_INCR 295
# define AUTO_DECR 296
# define PLUS 297
# define MINUS 298
# define SLASH 299
# define GT 300
# define GE 301
# define EQ 302
# define LE 303
# define LT 304
# define NE 305
# define NOT 306
# define BIT_OR 307
# define BIT_AND 308
# define L_SHIFT 309
# define R_SHIFT 310
# define COMPLEMENT 311
# define MODULO 312
# define PLUS_EQUAL 313
# define MINUS_EQUAL 314
# define MULT_EQUAL 315
# define DIV_EQUAL 316
# define AND_EQUAL 317
# define OR_EQUAL 318
# define MODULO_EQUAL 319
# define LEFT_EQUAL 320
# define RIGHT_EQUAL 321
# define CMPL_EQUAL 322
# define STRING 323
# define C_STMT 324
# define IF 325
# define ELSE 326
# define WHILE 327
# define FOR 328
# define BREAK 329
# define PP_SYMBOL 330
# define CR 331
# define UOP 332
# define SUBSCRIPT 333

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#ifdef WIN32
#else
#include <values.h>
#endif WIN32

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 323 "../../../share/src/sequencer/snc.y"


yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 35,
	0, 1,
	-2, 0,
-1, 38,
	0, 44,
	-2, 18,
-1, 56,
	266, 68,
	269, 113,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 67,
	0, 3,
	-2, 0,
-1, 72,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 84,
	266, 68,
	269, 113,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 94,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 159,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 198,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 199,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 216,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 217,
	266, 68,
	269, 113,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
-1, 219,
	266, 68,
	271, 68,
	272, 68,
	275, 68,
	276, 68,
	277, 68,
	278, 68,
	279, 68,
	299, 68,
	300, 68,
	301, 68,
	302, 68,
	303, 68,
	304, 68,
	305, 68,
	307, 68,
	308, 68,
	309, 68,
	310, 68,
	311, 68,
	312, 68,
	313, 68,
	314, 68,
	315, 68,
	316, 68,
	317, 68,
	318, 68,
	319, 68,
	320, 68,
	321, 68,
	322, 68,
	-2, 0,
	};
# define YYNPROD 131
# define YYLAST 991
yytabelem yyact[]={

   124,    70,   113,   102,    68,    50,   147,   172,   216,   145,
   146,   144,   136,   137,    54,    57,    39,    46,    47,   197,
   195,    40,   196,   196,   112,   211,   209,   128,   169,   122,
   123,   127,   126,   129,   130,   131,   132,   134,   135,   133,
   204,   140,   141,   138,   139,   142,   143,   148,   149,   153,
   152,   150,   151,   154,   155,   156,   157,   124,     4,    64,
   168,   166,   164,   147,     5,   215,   145,   146,   144,   136,
   137,   173,    58,    69,   217,   193,   163,    49,    59,   104,
   105,    63,    53,   192,   128,   191,   122,   123,   127,   126,
   129,   130,   131,   132,   134,   135,   133,   175,   140,   141,
   138,   139,   142,   143,   148,   149,   153,   152,   150,   151,
   154,   155,   156,   157,   124,   203,   178,   117,   171,   212,
   147,   170,   158,   145,   146,   144,   136,   137,   110,   176,
   222,    61,     6,   109,   108,    62,    71,    56,   174,     5,
   179,   128,   204,   122,   123,   127,   126,   129,   130,   131,
   132,   134,   135,   133,   107,   140,   141,   138,   139,   142,
   143,   148,   149,   153,   152,   150,   151,   154,   155,   156,
   157,   124,    66,    65,    55,    45,   200,   147,    43,    42,
   145,   146,   144,   136,   137,    41,    33,   106,   103,    44,
    34,   116,   117,   221,   184,   115,    35,     7,   128,   202,
   122,   123,   127,   126,   129,   130,   131,   132,   134,   135,
   133,    14,   140,   141,   138,   139,   142,   143,   148,   149,
   153,   152,   150,   151,   154,   155,   156,   157,   124,     2,
    48,    51,    37,    32,   147,    13,   199,   145,   146,   144,
   136,   137,    12,     8,    11,    67,    10,     9,    80,    79,
    78,    36,    77,    74,   201,   128,   114,   122,   123,   127,
   126,   129,   130,   131,   132,   134,   135,   133,    52,   140,
   141,   138,   139,   142,   143,   148,   149,   153,   152,   150,
   151,   154,   155,   156,   157,   124,    85,   121,   120,    60,
    20,   147,    36,   198,   145,   146,   144,   136,   137,   111,
    52,     1,     0,     0,     0,     0,     0,     0,     0,     0,
   177,     0,   128,     0,   122,   123,   127,   126,   129,   130,
   131,   132,   134,   135,   133,     0,   140,   141,   138,   139,
   142,   143,   148,   149,   153,   152,   150,   151,   154,   155,
   156,   157,   194,   124,     0,     0,     0,     0,     0,   147,
     0,     0,   145,   146,   144,   136,   137,     0,     0,   186,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   128,     0,   122,   123,   127,   126,   129,   130,   131,   132,
   134,   135,   133,     0,   140,   141,   138,   139,   142,   143,
   148,   149,   153,   152,   150,   151,   154,   155,   156,   157,
   124,   210,     0,     0,     0,     0,   147,     0,   187,   145,
   146,   144,   136,   137,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   128,     0,   122,
   123,   127,   126,   129,   130,   131,   132,   134,   135,   133,
     0,   140,   141,   138,   139,   142,   143,   148,   149,   153,
   152,   150,   151,   154,   155,   156,   157,   124,     0,     0,
     0,     0,   125,   147,     0,     0,   145,   146,   144,   136,
   137,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   128,     0,   122,   123,   127,   126,
   129,   130,   131,   132,   134,   135,   133,     0,   140,   141,
   138,   139,   142,   143,   148,   149,   153,   152,   150,   151,
   154,   155,   156,   157,   124,     0,     0,     0,     0,    72,
   147,    73,     0,   145,   146,   144,   136,   137,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   128,     0,   122,   123,   127,   126,   129,   130,   131,
   132,   134,   135,   133,     0,   140,   141,   138,   139,   142,
   143,   148,   149,   153,   152,   150,   151,   154,   155,   156,
   157,    83,     0,     0,    88,    90,     0,     0,    91,     0,
     0,     0,     0,    84,   220,     0,    83,     0,    92,    88,
    90,     0,     0,    91,   119,     0,     0,     0,    84,   183,
     0,     0,     0,    92,   159,     0,     0,     0,    99,   100,
    86,    87,    97,    98,    82,     3,   167,    16,     0,     0,
     0,   101,    16,    99,   100,    86,    87,    97,    98,     0,
     0,     0,     0,     0,     0,     0,   101,     0,    89,    81,
    93,    94,    95,    96,    76,     6,     0,    16,     0,     0,
     0,     0,     0,    89,    81,    93,    94,    95,    96,    76,
     6,    83,     0,    16,    88,    90,     0,     0,    91,     0,
     0,     0,     0,    84,   118,     0,    83,     0,    92,    88,
    90,   119,     0,    91,     0,     0,     0,     0,    84,     0,
     0,     0,     0,    92,     0,     0,     0,     0,    99,   100,
    86,    87,    97,    98,     0,     0,     0,     0,     0,     0,
     0,   101,     0,    99,   100,    86,    87,    97,    98,     0,
   206,   207,     0,     0,     0,     0,   101,     0,    89,    81,
    93,    94,    95,    96,    76,     6,     0,   219,   218,     0,
     0,   119,     0,    89,    81,    93,    94,    95,    96,    76,
     6,    38,     0,    39,     0,     0,    21,     0,    40,    23,
     0,     0,     0,     0,    17,     0,     0,     0,     0,    21,
     0,     0,    23,     0,     0,    19,    18,    75,     0,    24,
    25,    26,    27,    28,    29,    30,    31,    22,    19,    18,
     0,     0,    24,    25,    26,    27,    28,    29,    30,    31,
    22,   124,     0,     0,     0,     0,     0,   147,     0,     0,
   145,   146,   144,     0,     0,     0,     0,     0,     0,    15,
     0,     0,     0,     0,     0,     6,     0,     0,     0,     0,
   122,   123,    15,     0,     0,     0,     0,     0,     6,     0,
     0,     0,   140,   141,   138,   139,   142,   143,   148,   149,
   153,   152,   150,   151,   154,   155,   156,   157,    88,    90,
     0,     0,    91,   160,   161,   162,     0,     0,     0,     0,
   165,     0,    92,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    99,   100,    86,    87,    97,    98,   180,   181,
     0,     0,   182,     0,     0,   101,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    89,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   185,   185,     0,   188,     0,   189,   190,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   205,     0,     0,     0,   208,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
   214 };
yytabelem yypact[]={

  -198,-10000000,   508,  -123,-10000000,   -74,   -69,   495,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   -75,   -81,
   -82,   -70,   -85,  -280,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,   508,  -196,  -318,  -242,-10000000,-10000000,-10000000,   -86,
  -131,  -267,  -199,  -135,  -136,  -201,   -87,   -88,   495,  -319,
  -258,-10000000,-10000000,-10000000,-10000000,  -132,   420,  -320,-10000000,   -71,
  -192,   -72,-10000000,  -106,  -137,  -138,  -143,  -242,  -250,-10000000,
  -329,   -65,   405,-10000000,-10000000,   191,  -149,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,   420,   599,   599,   599,-10000000,-10000000,
  -197,  -211,   599,  -212,   420,  -213,  -245,-10000000,-10000000,-10000000,
-10000000,-10000000,  -150,  -153,-10000000,  -252,  -127,  -174,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -140,-10000000,-10000000,  -120,-10000000,-10000000,
   599,   599,-10000000,-10000000,   599,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   330,
   535,   535,   535,   599,   599,   134,   599,-10000000,   599,   599,
-10000000,-10000000,  -186,  -188,-10000000,-10000000,-10000000,-10000000,-10000000,  -193,
   248,   248,    77,-10000000,  -254,   248,  -255,-10000000,    19,   -38,
   -95,-10000000,-10000000,  -141,-10000000,-10000000,   599,-10000000,   420,   420,
   599,  -243,-10000000,-10000000,  -248,   248,-10000000,-10000000,  -152,-10000000,
-10000000,   599,   599,  -209,  -266,  -194,   420,   420,-10000000,   315,
   -64,  -130,-10000000 };
yytabelem yypgo[]={

     0,   301,   290,   289,   288,   287,   286,   196,   232,   256,
   195,   254,   199,   194,   777,   521,   519,   253,   252,   250,
   249,   248,   229,   197,   231,   614,   243,   247,   246,   244,
   242,   235,   211 };
yytabelem yyr1[]={

     0,     1,     1,     1,     1,     1,    22,    22,    23,    23,
    26,    26,    26,    26,    26,    26,    26,    26,    26,    27,
    28,    28,     3,     3,    30,    29,    29,    29,     2,     2,
     2,     2,     2,     2,     2,     2,    31,    31,    32,    32,
     7,     7,     8,     8,     8,     9,     9,     9,    10,    10,
    11,    11,    11,    12,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,     6,
     6,     6,     6,     6,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,    13,    13,    13,    17,
    17,    16,    16,    16,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    18,    19,    20,    21,    25,    25,
    24 };
yytabelem yyr2[]={

     0,     7,     9,     9,    11,     3,     5,    11,     2,     4,
     2,     2,     2,     2,     2,     2,     3,     2,     3,    11,
     7,    11,     1,     7,     7,     9,    13,    13,     3,     3,
     3,     3,     3,     3,     3,     3,    11,     9,     9,     9,
     3,     5,    11,     9,     3,     3,     5,     3,    11,     3,
     3,     5,     3,    19,     7,     7,     5,     5,     5,     5,
     5,     3,     3,     3,     9,     9,     7,     9,     1,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     7,     1,     7,
     3,     3,     5,     1,     3,     5,     5,     3,     3,     3,
     3,     3,     3,     3,    11,     5,    11,    19,     9,    11,
     3 };
yytabelem yychk[]={

-10000000,    -1,   -22,   -25,   256,   262,   330,   -23,   -26,   -27,
   -28,   -29,   -30,   -31,   -32,   324,   -25,   256,   281,   280,
    -2,   261,   292,   264,   284,   285,   286,   287,   288,   289,
   290,   291,   -22,   260,   259,    -7,   -26,    -8,   256,   258,
   263,   260,   260,   260,   259,   260,   297,   298,   -23,   273,
   323,   -24,    -8,   324,   256,   260,   268,   282,   271,   277,
    -3,   266,   271,   282,   260,   260,   260,    -7,   323,   331,
   259,   268,   -16,   -15,   -17,   -14,   329,   -18,   -19,   -20,
   -21,   324,   -25,   256,   268,    -6,   295,   296,   259,   323,
   260,   263,   273,   325,   326,   327,   328,   297,   298,   293,
   294,   306,   323,   259,   271,   272,   259,   260,   271,   271,
   271,   -24,   274,   331,    -9,   -10,   256,   257,   269,   -15,
    -4,    -5,   295,   296,   266,   271,   298,   297,   293,   299,
   300,   301,   302,   305,   303,   304,   278,   279,   309,   310,
   307,   308,   311,   312,   277,   275,   276,   272,   313,   314,
   317,   318,   316,   315,   319,   320,   321,   322,   271,   -16,
   -14,   -14,   -14,   273,   273,   -14,   273,   -15,   273,   273,
   271,   271,   259,   323,   265,   271,   269,   -10,   256,   260,
   -14,   -14,   -14,   269,   -13,   -14,   -13,   274,   -14,   -14,
   -14,   271,   271,   268,   265,   274,   277,   274,   274,   274,
   271,   -11,   -12,   256,   283,   -14,   -15,   -15,   -14,   269,
   -12,   273,   271,   -14,   -14,   274,   274,   268,   -15,   -16,
   269,   257,   260 };
yytabelem yydef[]={

     0,    -2,     0,     0,     5,     0,     0,     0,     8,    10,
    11,    12,    13,    14,    15,    16,    17,    18,     0,     0,
     0,     0,     0,     0,    28,    29,    30,    31,    32,    33,
    34,    35,     0,     6,     0,    -2,     9,    40,    -2,     0,
     0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
     0,     2,    41,   130,    44,     0,    -2,     0,    20,     0,
     0,     0,    24,     0,     0,     0,     0,    -2,     0,   128,
     0,     0,    -2,   111,   114,     0,     0,   117,   118,   119,
   120,   121,   122,   110,    -2,    68,    68,    68,    61,    62,
    63,     0,    68,     0,    -2,     0,     0,    69,    70,    71,
    72,    73,     0,     0,    25,     0,     0,     0,    37,    38,
    39,     4,     7,   129,     0,    45,    47,     0,    43,   112,
    68,    68,    59,    60,    68,   115,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   101,   102,   103,   104,   105,   116,    -2,
    56,    57,    58,    68,    68,     0,    68,   125,    68,    68,
    19,    21,     0,     0,    23,    36,    42,    46,    49,     0,
    54,    55,     0,   109,     0,   106,     0,    66,     0,     0,
     0,    26,    27,     0,    67,    64,    68,    65,    -2,    -2,
    68,     0,    50,    52,     0,   107,   124,   126,     0,    48,
    51,    68,    68,     0,     0,     0,    -2,    -2,   127,    -2,
     0,     0,    53 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"STATE",	257,
	"STATE_SET",	258,
	"NUMBER",	259,
	"NAME",	260,
	"DEBUG_PRINT",	261,
	"PROGRAM",	262,
	"EXIT",	263,
	"OPTION",	264,
	"R_SQ_BRACKET",	265,
	"L_SQ_BRACKET",	266,
	"BAD_CHAR",	267,
	"L_BRACKET",	268,
	"R_BRACKET",	269,
	"COLON",	270,
	"SEMI_COLON",	271,
	"EQUAL",	272,
	"L_PAREN",	273,
	"R_PAREN",	274,
	"PERIOD",	275,
	"POINTER",	276,
	"COMMA",	277,
	"OR",	278,
	"AND",	279,
	"MONITOR",	280,
	"ASSIGN",	281,
	"TO",	282,
	"WHEN",	283,
	"CHAR",	284,
	"SHORT",	285,
	"INT",	286,
	"LONG",	287,
	"FLOAT",	288,
	"DOUBLE",	289,
	"STRING_DECL",	290,
	"EVFLAG",	291,
	"SYNC",	292,
	"ASTERISK",	293,
	"AMPERSAND",	294,
	"AUTO_INCR",	295,
	"AUTO_DECR",	296,
	"PLUS",	297,
	"MINUS",	298,
	"SLASH",	299,
	"GT",	300,
	"GE",	301,
	"EQ",	302,
	"LE",	303,
	"LT",	304,
	"NE",	305,
	"NOT",	306,
	"BIT_OR",	307,
	"BIT_AND",	308,
	"L_SHIFT",	309,
	"R_SHIFT",	310,
	"COMPLEMENT",	311,
	"MODULO",	312,
	"PLUS_EQUAL",	313,
	"MINUS_EQUAL",	314,
	"MULT_EQUAL",	315,
	"DIV_EQUAL",	316,
	"AND_EQUAL",	317,
	"OR_EQUAL",	318,
	"MODULO_EQUAL",	319,
	"LEFT_EQUAL",	320,
	"RIGHT_EQUAL",	321,
	"CMPL_EQUAL",	322,
	"STRING",	323,
	"C_STMT",	324,
	"IF",	325,
	"ELSE",	326,
	"WHILE",	327,
	"FOR",	328,
	"BREAK",	329,
	"PP_SYMBOL",	330,
	"CR",	331,
	"UOP",	332,
	"SUBSCRIPT",	333,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"state_program : program_name definitions state_set_list",
	"state_program : program_name definitions state_set_list global_c",
	"state_program : pp_code program_name definitions state_set_list",
	"state_program : pp_code program_name definitions state_set_list global_c",
	"state_program : error",
	"program_name : PROGRAM NAME",
	"program_name : PROGRAM NAME L_PAREN STRING R_PAREN",
	"definitions : defn_stmt",
	"definitions : definitions defn_stmt",
	"defn_stmt : assign_stmt",
	"defn_stmt : monitor_stmt",
	"defn_stmt : decl_stmt",
	"defn_stmt : debug_stmt",
	"defn_stmt : sync_stmt",
	"defn_stmt : option_stmt",
	"defn_stmt : C_STMT",
	"defn_stmt : pp_code",
	"defn_stmt : error",
	"assign_stmt : ASSIGN NAME TO STRING SEMI_COLON",
	"monitor_stmt : MONITOR NAME SEMI_COLON",
	"monitor_stmt : MONITOR NAME COMMA NUMBER SEMI_COLON",
	"subscript : /* empty */",
	"subscript : L_SQ_BRACKET NUMBER R_SQ_BRACKET",
	"debug_stmt : DEBUG_PRINT NUMBER SEMI_COLON",
	"decl_stmt : type NAME subscript SEMI_COLON",
	"decl_stmt : type NAME subscript EQUAL NUMBER SEMI_COLON",
	"decl_stmt : type NAME subscript EQUAL STRING SEMI_COLON",
	"type : CHAR",
	"type : SHORT",
	"type : INT",
	"type : LONG",
	"type : FLOAT",
	"type : DOUBLE",
	"type : STRING_DECL",
	"type : EVFLAG",
	"sync_stmt : SYNC NAME TO NAME SEMI_COLON",
	"sync_stmt : SYNC NAME NAME SEMI_COLON",
	"option_stmt : OPTION PLUS NAME SEMI_COLON",
	"option_stmt : OPTION MINUS NAME SEMI_COLON",
	"state_set_list : state_set",
	"state_set_list : state_set_list state_set",
	"state_set : STATE_SET NAME L_BRACKET state_list R_BRACKET",
	"state_set : EXIT L_BRACKET stmt_list R_BRACKET",
	"state_set : error",
	"state_list : state",
	"state_list : state_list state",
	"state_list : error",
	"state : STATE NAME L_BRACKET transition_list R_BRACKET",
	"state : error",
	"transition_list : transition",
	"transition_list : transition_list transition",
	"transition_list : error",
	"transition : WHEN L_PAREN expr R_PAREN L_BRACKET stmt_list R_BRACKET STATE NAME",
	"expr : expr binop expr",
	"expr : expr asgnop expr",
	"expr : unop expr",
	"expr : AUTO_INCR expr",
	"expr : AUTO_DECR expr",
	"expr : expr AUTO_INCR",
	"expr : expr AUTO_DECR",
	"expr : NUMBER",
	"expr : STRING",
	"expr : NAME",
	"expr : NAME L_PAREN parameter R_PAREN",
	"expr : EXIT L_PAREN parameter R_PAREN",
	"expr : L_PAREN expr R_PAREN",
	"expr : expr L_SQ_BRACKET expr R_SQ_BRACKET",
	"expr : /* empty */",
	"unop : PLUS",
	"unop : MINUS",
	"unop : ASTERISK",
	"unop : AMPERSAND",
	"unop : NOT",
	"binop : MINUS",
	"binop : PLUS",
	"binop : ASTERISK",
	"binop : SLASH",
	"binop : GT",
	"binop : GE",
	"binop : EQ",
	"binop : NE",
	"binop : LE",
	"binop : LT",
	"binop : OR",
	"binop : AND",
	"binop : L_SHIFT",
	"binop : R_SHIFT",
	"binop : BIT_OR",
	"binop : BIT_AND",
	"binop : COMPLEMENT",
	"binop : MODULO",
	"binop : COMMA",
	"binop : PERIOD",
	"binop : POINTER",
	"asgnop : EQUAL",
	"asgnop : PLUS_EQUAL",
	"asgnop : MINUS_EQUAL",
	"asgnop : AND_EQUAL",
	"asgnop : OR_EQUAL",
	"asgnop : DIV_EQUAL",
	"asgnop : MULT_EQUAL",
	"asgnop : MODULO_EQUAL",
	"asgnop : LEFT_EQUAL",
	"asgnop : RIGHT_EQUAL",
	"asgnop : CMPL_EQUAL",
	"parameter : expr",
	"parameter : parameter COMMA expr",
	"parameter : /* empty */",
	"compound_stmt : L_BRACKET stmt_list R_BRACKET",
	"compound_stmt : error",
	"stmt_list : statement",
	"stmt_list : stmt_list statement",
	"stmt_list : /* empty */",
	"statement : compound_stmt",
	"statement : expr SEMI_COLON",
	"statement : BREAK SEMI_COLON",
	"statement : if_stmt",
	"statement : else_stmt",
	"statement : while_stmt",
	"statement : for_stmt",
	"statement : C_STMT",
	"statement : pp_code",
	"statement : error",
	"if_stmt : IF L_PAREN expr R_PAREN statement",
	"else_stmt : ELSE statement",
	"while_stmt : WHILE L_PAREN expr R_PAREN statement",
	"for_stmt : FOR L_PAREN expr SEMI_COLON expr SEMI_COLON expr R_PAREN statement",
	"pp_code : PP_SYMBOL NUMBER STRING CR",
	"pp_code : PP_SYMBOL NUMBER STRING NUMBER CR",
	"global_c : C_STMT",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 90 "../../../share/src/sequencer/snc.y"
{ program(yypvt[-0].pexpr); } break;
case 2:
# line 91 "../../../share/src/sequencer/snc.y"
{ program(yypvt[-1].pexpr); } break;
case 3:
# line 92 "../../../share/src/sequencer/snc.y"
{ program(yypvt[-0].pexpr); } break;
case 4:
# line 93 "../../../share/src/sequencer/snc.y"
{ program(yypvt[-1].pexpr); } break;
case 5:
# line 94 "../../../share/src/sequencer/snc.y"
{ snc_err("state program"); } break;
case 6:
# line 98 "../../../share/src/sequencer/snc.y"
{ program_name(yypvt[-0].pchar, ""); } break;
case 7:
# line 99 "../../../share/src/sequencer/snc.y"
{ program_name(yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 16:
# line 114 "../../../share/src/sequencer/snc.y"
{ defn_c_stmt(yypvt[-0].pchar); } break;
case 18:
# line 116 "../../../share/src/sequencer/snc.y"
{ snc_err("definitions/declarations"); } break;
case 19:
# line 120 "../../../share/src/sequencer/snc.y"
{ assign_stmt(yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 20:
# line 124 "../../../share/src/sequencer/snc.y"
{ monitor_stmt(yypvt[-1].pchar, "0"); } break;
case 21:
# line 125 "../../../share/src/sequencer/snc.y"
{ monitor_stmt(yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 22:
# line 129 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = 0; } break;
case 23:
# line 130 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = yypvt[-1].pchar; } break;
case 24:
# line 134 "../../../share/src/sequencer/snc.y"
{ set_debug_print(yypvt[-1].pchar); } break;
case 25:
# line 138 "../../../share/src/sequencer/snc.y"
{ decl_stmt(yypvt[-3].ival, yypvt[-2].pchar, yypvt[-1].pchar, (char *)0); } break;
case 26:
# line 139 "../../../share/src/sequencer/snc.y"
{ decl_stmt(yypvt[-5].ival, yypvt[-4].pchar, yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 27:
# line 140 "../../../share/src/sequencer/snc.y"
{ decl_stmt(yypvt[-5].ival, yypvt[-4].pchar, yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 28:
# line 144 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_CHAR; } break;
case 29:
# line 145 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_SHORT; } break;
case 30:
# line 146 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_INT; } break;
case 31:
# line 147 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_LONG; } break;
case 32:
# line 148 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_FLOAT; } break;
case 33:
# line 149 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_DOUBLE; } break;
case 34:
# line 150 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_STRING; } break;
case 35:
# line 151 "../../../share/src/sequencer/snc.y"
{ yyval.ival = V_EVFLAG; } break;
case 36:
# line 155 "../../../share/src/sequencer/snc.y"
{ sync_stmt(yypvt[-3].pchar, yypvt[-1].pchar); } break;
case 37:
# line 156 "../../../share/src/sequencer/snc.y"
{ sync_stmt(yypvt[-2].pchar, yypvt[-1].pchar); /* archaic syntax */ } break;
case 38:
# line 160 "../../../share/src/sequencer/snc.y"
{ option_stmt(yypvt[-1].pchar, TRUE); } break;
case 39:
# line 161 "../../../share/src/sequencer/snc.y"
{ option_stmt(yypvt[-1].pchar, FALSE); } break;
case 40:
# line 165 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 41:
# line 166 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = link_expr(yypvt[-1].pexpr, yypvt[-0].pexpr); } break;
case 42:
# line 171 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_SS, yypvt[-3].pchar, yypvt[-1].pexpr, 0); } break;
case 43:
# line 173 "../../../share/src/sequencer/snc.y"
{ exit_code(yypvt[-1].pexpr); yyval.pexpr = 0; } break;
case 44:
# line 175 "../../../share/src/sequencer/snc.y"
{ snc_err("state set"); } break;
case 45:
# line 179 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 46:
# line 180 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = link_expr(yypvt[-1].pexpr, yypvt[-0].pexpr); } break;
case 47:
# line 181 "../../../share/src/sequencer/snc.y"
{ snc_err("state set"); } break;
case 48:
# line 186 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_STATE, yypvt[-3].pchar, yypvt[-1].pexpr, 0); } break;
case 49:
# line 187 "../../../share/src/sequencer/snc.y"
{ snc_err("state block"); } break;
case 50:
# line 191 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 51:
# line 192 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = link_expr(yypvt[-1].pexpr, yypvt[-0].pexpr); } break;
case 52:
# line 193 "../../../share/src/sequencer/snc.y"
{ snc_err("transition"); } break;
case 53:
# line 198 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_WHEN, yypvt[-0].pchar, yypvt[-6].pexpr, yypvt[-3].pexpr); } break;
case 54:
# line 203 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_BINOP, yypvt[-1].pchar, yypvt[-2].pexpr, yypvt[-0].pexpr); } break;
case 55:
# line 204 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_ASGNOP, yypvt[-1].pchar, yypvt[-2].pexpr, yypvt[-0].pexpr); } break;
case 56:
# line 205 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_UNOP, yypvt[-1].pchar, yypvt[-0].pexpr, 0); } break;
case 57:
# line 206 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_PRE, "++", yypvt[-0].pexpr, 0); } break;
case 58:
# line 207 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_PRE, "--", yypvt[-0].pexpr, 0); } break;
case 59:
# line 208 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_POST, "++", yypvt[-1].pexpr, 0); } break;
case 60:
# line 209 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_POST, "--", yypvt[-1].pexpr, 0); } break;
case 61:
# line 210 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_CONST, yypvt[-0].pchar, 0, 0); } break;
case 62:
# line 211 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_STRING, yypvt[-0].pchar, 0, 0); } break;
case 63:
# line 212 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_VAR, yypvt[-0].pchar, 0, 0); } break;
case 64:
# line 213 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_FUNC, yypvt[-3].pchar, yypvt[-1].pexpr, 0); } break;
case 65:
# line 214 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_FUNC, "exit", yypvt[-1].pexpr, 0); } break;
case 66:
# line 215 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_PAREN, "", yypvt[-1].pexpr, 0); } break;
case 67:
# line 217 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_SUBSCR, "", yypvt[-3].pexpr, yypvt[-1].pexpr); } break;
case 68:
# line 218 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_EMPTY, "", 0, 0); } break;
case 69:
# line 222 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "+"; } break;
case 70:
# line 223 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "-"; } break;
case 71:
# line 224 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "*"; } break;
case 72:
# line 225 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "&"; } break;
case 73:
# line 226 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "!"; } break;
case 74:
# line 230 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "-"; } break;
case 75:
# line 231 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "+"; } break;
case 76:
# line 232 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "*"; } break;
case 77:
# line 233 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "/"; } break;
case 78:
# line 234 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = ">"; } break;
case 79:
# line 235 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = ">="; } break;
case 80:
# line 236 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "=="; } break;
case 81:
# line 237 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "!="; } break;
case 82:
# line 238 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "<="; } break;
case 83:
# line 239 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "<"; } break;
case 84:
# line 240 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "||"; } break;
case 85:
# line 241 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "&&"; } break;
case 86:
# line 242 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "<<"; } break;
case 87:
# line 243 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = ">>"; } break;
case 88:
# line 244 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "|"; } break;
case 89:
# line 245 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "&"; } break;
case 90:
# line 246 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "^"; } break;
case 91:
# line 247 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "%"; } break;
case 92:
# line 248 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = ","; } break;
case 93:
# line 249 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "."; } break;
case 94:
# line 250 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "->"; } break;
case 95:
# line 254 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "="; } break;
case 96:
# line 255 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "+="; } break;
case 97:
# line 256 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "-="; } break;
case 98:
# line 257 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "&="; } break;
case 99:
# line 258 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "|="; } break;
case 100:
# line 259 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "/="; } break;
case 101:
# line 260 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "*="; } break;
case 102:
# line 261 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "%="; } break;
case 103:
# line 262 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "<<="; } break;
case 104:
# line 263 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = ">>="; } break;
case 105:
# line 264 "../../../share/src/sequencer/snc.y"
{ yyval.pchar = "^="; } break;
case 106:
# line 268 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 107:
# line 269 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = link_expr(yypvt[-2].pexpr, yypvt[-0].pexpr); } break;
case 108:
# line 270 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = 0; } break;
case 109:
# line 274 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_CMPND, "",yypvt[-1].pexpr, 0); } break;
case 110:
# line 275 "../../../share/src/sequencer/snc.y"
{ snc_err("action statements"); } break;
case 111:
# line 279 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 112:
# line 280 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = link_expr(yypvt[-1].pexpr, yypvt[-0].pexpr); } break;
case 113:
# line 281 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = 0; } break;
case 114:
# line 285 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 115:
# line 286 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_STMT, "", yypvt[-1].pexpr, 0); } break;
case 116:
# line 287 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_BREAK, "", 0, 0); } break;
case 117:
# line 288 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 118:
# line 289 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 119:
# line 290 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 120:
# line 291 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = yypvt[-0].pexpr; } break;
case 121:
# line 292 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_TEXT, "", (Expr *)yypvt[-0].pchar, 0); } break;
case 122:
# line 293 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = 0; } break;
case 123:
# line 294 "../../../share/src/sequencer/snc.y"
{ snc_err("action statement"); } break;
case 124:
# line 298 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_IF, "", yypvt[-2].pexpr, yypvt[-0].pexpr); } break;
case 125:
# line 302 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_ELSE, "", yypvt[-0].pexpr, 0); } break;
case 126:
# line 306 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_WHILE, "", yypvt[-2].pexpr, yypvt[-0].pexpr); } break;
case 127:
# line 311 "../../../share/src/sequencer/snc.y"
{ yyval.pexpr = expression(E_FOR, "", expression(E_X, "", yypvt[-6].pexpr, yypvt[-4].pexpr),
				expression(E_X, "", yypvt[-2].pexpr, yypvt[-0].pexpr) ); } break;
case 128:
# line 316 "../../../share/src/sequencer/snc.y"
{ pp_code(yypvt[-2].pchar, yypvt[-1].pchar); } break;
case 129:
# line 317 "../../../share/src/sequencer/snc.y"
{ pp_code(yypvt[-3].pchar, yypvt[-2].pchar); } break;
case 130:
# line 321 "../../../share/src/sequencer/snc.y"
{ global_c_stmt(yypvt[-0].pchar); } break;
	}
	goto yystack;		/* reset registers in driver code */
}

