/*snlrepchans.c,v 1.1.1.1 1999/08/03 14:44:39 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* Get the status of all tasks in a program */

#include <stdio.h>
#include <stdlib.h>
#include "mon_defs.h"
#include "msgMon.h"

main (int argc, char *argv[])
{

    REPCHANS_REPLY	*repchansReply, *p;
    int			i, NumChans;
    long		taskId;

    tisOpenLog ("snlrepchans", 6, 2, NULL, NULL);

    /* Check for proper number of arguments */

    if (argc != 4) {
	printf ("Usage: snlrepchans <host-name> <program_name> <taskid>\n");
	exit (1);
    }

    /* Connect to the server. */

    if (!snlMonConnect (argv [1])) {
	printf ("Unable to connect to snlMon on %s\n", argv [1]);
	exit (1);
    }

    /* Send a start message */

    taskId = atol (argv[3]);
    snlMon_ReportChannels (argv [2], taskId, &repchansReply, &NumChans);

    /* Drop the connection to the server */

    snlMonDisconnect ();

    /* Print the status */

    for (i=0, p=repchansReply ; i<NumChans ; i++) {
	printf ("Name: %s\n", p->ChanName);
	printf ("Monitored: %d\n", p->Monitored);
	printf ("Connected: %d\n", p->Connected);
	printf ("Status: %d\n", p->Stat);
	printf ("Severity: %d\n\n", p->Severity);
	p++;
    }

    free (repchansReply);

    return 0;
}

