/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* client.h */

#ifndef vxWorks
#include <time.h>
#endif vxWorks

#ifdef WIN32
#include <winsock.h>
#else
#include <errno.h>

#ifdef vxWorks
#include <ioLib.h>
#include <types.h>
#include <sockLib.h>
#include <inetLib.h>
#else
#include <sys/filio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

#ifndef NULL
#define NULL	0
#endif

#ifndef INADDR_NONE
#define INADDR_NONE	0
#endif INADDR_NONE
#define SOCKADDR_IN	struct sockaddr_in
#define SOCKADDR	struct sockaddr
#define SOCKET		int
#define INVALID_SOCKET	(-1)
#define SOCKET_ERROR	(-1)
#define WSAEWOULDBLOCK	EWOULDBLOCK
#define WSAGetLastError() errno
#define closesocket(fd)	close(fd)
#endif

#define ACCRATE	    5		/* number of second between broadcasts */
#define MAXADVERTS  5		/* number of broadcasts before failure */

#include "tisservice.h"

/* CLIENT - structure for a client access point */
typedef struct {
    void	*next;		/* server links */
    SOCKET	s;		/* the clients active server socket */
    short int	seq;		/* the clients request sequence number */
    SOCKET	sudp;		/* the client's udp port */
    SOCKADDR_IN	sa;		/* the clients bind point */
    SOCKADDR_IN	srva;		/* the servers bind point */
    time_t	created;	/* when client opened server link */
    time_t	lastRx;		/* time of last data in */
    time_t	lastTx;		/* time of last data out */
    short int	rxlen;		/* msg received so far */
    ServHdr	hdr;		/* current message header info */
    SVRMSG	*inmsg;		/* current massage */
    SVRMSG	*resp;		/* current response */
    SVRMSG	*msgs;		/* list of received messages */
    SVRMSG	*txmsgs;	/* list of output messages */
    int		sync;		/* synchronous flag */
    u_char	SrvID [40];	/* server ID value */
    char *	(*ClientInfo)();/* return client connect information */
} CLIENT;

/* function prototypes for the client */
CLIENT* OpenServer (char *server, int sync, char *connectinfo);
int CloseSession (CLIENT *client);
char *GetClientInfo (void);
void *SendReq (CLIENT *client, void *msg, short int length);
void *SendReqLen (CLIENT *client, void *msg, short int length, short int *retLen);
void *GetRsp (CLIENT *client);
void *GetRspLen (CLIENT *client, short int *len);
void *GetMsg (CLIENT *client);



