
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/************************************************************************/
/*                                                                      */
/*            IOC TREND UPDATE DEFINITIONS				*/
/*                                                                      */
/************************************************************************/

typedef struct {		/* queue structure */
    NODE *nextEntry;		/* queue chain */
    NODE *prevEntry;		/* queue chain */
    char *statusLoc;		/* address of indicator bit */
    char statusBit;		/* bit to Or into indicator */
    short dataSize;		/* size of allocated raw trend area */
    short dataLen;		/* length of data area  (in words) */
    long snapTime;		/* time of data snapshot */
    short line;			/* PLC line number */
    short address;		/* PLC address */
    short dataPtr;		/* raw trend data area */
} QENTRY;

/*
**	StartTrendUpdate - routine to initialize and start
**		the update task in the IOC
**	returns:	0 always.
*/
int StartTrendUpdate (char *IOCName,	/* the name of this IOC as specified in plctrend.txt */
		      char *ip1,	/* workstation IP address (string in dot format) */
		      char *ip2);	/* workstation IP address (string in dot format) */

/*
**	QueueTrendUpdate - routine to queue update information for transmission to workstation
**	returns:	TRUE if custody of data accepted into queue,
**			FALSE otherwise.
*/
int QueueTrendUpdate (long updTime,	/* update time (UNIX time_t) */
		  short plcline,	/* the plc line */
		  short plcaddr,	/* the plc address on line specified */
		  void *updData,	/* the data values (shorts in local byte order */
		  short datalen,	/* the number of data values */
		  char *statPtr,	/* the address of the indicator bit */
		  char statBit);	/* mask to be ORed into indicator bit address */

/*
**	TrendingActive - routine to check for registered trend consumers
**	returns:	TRUE if CA has a registered trend active,
**			FALSE otherwise.
*/
int TrendingActive ();

