/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* server.h */

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <sys/types.h>

#ifdef WIN32
#include <winsock.h>
#else
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/filio.h>
#define	SOCKET		int
#define SOCKADDR_IN	struct sockaddr_in
#define INVALID_SOCKET	(-1)
#define SOCKET_ERROR	(-1)
#define WSAEWOULDBLOCK	EWOULDBLOCK
#define WSAEINTR	EINTR
#define WSAGetLastError() errno
#define closesocket(fd)	close(fd)
#endif

#include "tisservice.h"

/* SERVER - structure for a server access point */
typedef struct {
    void	*next;		/* server links */
    SOCKET	s;		/* client comm socket */
    int		seq;		/* current request sequence number */
    time_t	created;	/* when server opened server link */
    time_t	lastRx;		/* time of last data in */
    time_t	lastTx;		/* time of last data out */
    short int	rxlen;		/* msg received so far */
    ServHdr	hdr;		/* current message header info */
    SVRMSG	*inmsg;		/* current massage */
    SVRMSG	*msgs;		/* list of input messages */
    SVRMSG	*txmsgs;	/* list of output messages */
    int		sync;		/* synchronous flag */
    char	SrvID[40];	/* service ID */
} SERVER;

/* socket handle for NT must be passed to service implementation */
#ifdef WIN32
extern SOCKET tisSvcSocket;
#endif WIN32

/* function prototypes for the server */
#ifdef WIN32
#define OpenTisService(svc,sync,info) OpenMultiService (svc, sync, info, atoi(argv[argc-1]))
#else
#define OpenTisService(svc,sync,info) OpenMultiService (svc, sync, info, 0)
#endif WIN32

SERVER* OpenMultiService (char *service, int sync, char *connectinfo, SOCKET svcSocket);

void SetSocketNum (SERVER *server, int port);
int CloseSvcSession (SERVER *server);
int CheckSvcSession (SERVER *server);
int ServerWait (SERVER *server, long delay);
void *GetReq (SERVER *server);
void *GetReqLen (SERVER *server, short *len);
void SendRsp (SERVER *server, unsigned char *msg, short int length);
void SendMsg (SERVER *server, unsigned char *msg, short int length);



