#include "slm.h"

extern char entryChanged,notSaved;
/* create and manage the RTU dialog box */
static Widget admList;
void slmCreateAdmit(Widget parent)
{
  int n=0;
  Arg args[10];
  XmString title,listLabel,okLabel,cancelLabel;
#ifdef SOLARIS
  title = XmStringCreateLocalized("RTU Admission List");
  listLabel = XmStringCreateLocalized("RTU:");
  okLabel = XmStringCreateLocalized("Update");
  cancelLabel = XmStringCreateLocalized("Dismiss");
#else
  title = XmStringCreateSimple("RTU Admission List");
  listLabel = XmStringCreateSimple("RTU:");
  okLabel = XmStringCreateSimple("Update");
  cancelLabel = XmStringCreateSimple("Dismiss");
#endif
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  /* create dialog */
  w_adm = XmCreateSelectionDialog(parent,"RTU",args,n);
  XtVaSetValues(w_adm,	XmNresizePolicy,XmRESIZE_NONE,
		XmNnoResize,True,
		XmNdialogStyle,XmDIALOG_PRIMARY_APPLICATION_MODAL,
		XmNdialogTitle,title,NULL);
  XtUnmanageChild(XmSelectionBoxGetChild(w_adm,XmDIALOG_HELP_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(w_adm,XmDIALOG_APPLY_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(w_adm,XmDIALOG_TEXT));
  /* get children */
  admList = XmSelectionBoxGetChild(w_adm,XmDIALOG_LIST);
  slmLoadRTUList(admList);
  XmListDeselectAllItems(admList);
  XtVaSetValues(admList,XmNselectionPolicy,XmEXTENDED_SELECT,NULL);
  /* free strings */
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(cancelLabel);
}
void slmAdmUpdate(Widget w, XtPointer client_data, XtPointer call_data)
{
  int numSelected,i;
  XmString *okSel;
  char *okPV;
  ACCESS_ENTRY_PTR node = (ACCESS_ENTRY_PTR)client_data;
  RTU_ENTRY_PTR  newNode,found;

  slmEmptyList(node->slmRTUList);					/* clear the RTU list */
  node->slmRTUList = 0;
  XtVaGetValues(admList,
                XmNselectedItemCount,&numSelected,
                XmNselectedItems,&okSel,
                NULL);							/* get pointer to selected items and count*/
  if(numSelected)
    {
      entryChanged = 1;
      notSaved |= entryChanged;
      for(i = 0;i < numSelected; i++)
        {
          XmStringGetLtoR(okSel[i],XmSTRING_DEFAULT_CHARSET,&okPV);
	  if((found = searchGlobalRTUList(okPV)) != 0)
	    {
	      newNode = (RTU_ENTRY_PTR)malloc(RTU_ENTRY_SIZE);		/* create new node */
	      memcpy((char *)newNode,(char *)found,RTU_ENTRY_SIZE);		       		/* copy contents */
	      newNode->next = (RTU_ENTRY_PTR )node->slmRTUList;
	      node->slmRTUList = newNode;
	      node->slmIsGlobal = 0;					/* might not be global any more */
	    }
	  else								/* might be redundant */
	    {
	      char aName[20],bName[20];
	      sprintf(aName,"%sa\0",okPV);
	      sprintf(bName,"%sb\0",okPV);
	      /* try a side first */
	      if((found = searchGlobalRTUList(aName)) != 0)
		{
		  newNode = (RTU_ENTRY_PTR)malloc(RTU_ENTRY_SIZE);		/* create new node */
		  memcpy((char *)newNode,(char *)found,RTU_ENTRY_SIZE);		       		/* copy contents */
		  newNode->next = (RTU_ENTRY_PTR )node->slmRTUList;
		  node->slmRTUList = newNode;
		  node->slmIsGlobal = 0;					/* might not be global any more */
		}
	      if((found = searchGlobalRTUList(bName)) != 0)
		{
		  newNode = (RTU_ENTRY_PTR)malloc(RTU_ENTRY_SIZE);		/* create new node */
		  memcpy((char *)newNode,(char *)found,RTU_ENTRY_SIZE);		       		/* copy contents */
		  newNode->next = (RTU_ENTRY_PTR )node->slmRTUList;
		  node->slmRTUList = newNode;
		  node->slmIsGlobal = 0;					/* might not be global any more */
		}
	    }
          XtFree((char *)okPV);
        }
    }
}
/*
  return pointer to rtu structure or
  return 0 if not found.
*/
RTU_ENTRY_PTR searchGlobalRTUList(char *name)
{
  RTU_ENTRY_PTR rtu;

  rtu = slmRTUNameTree;
  while(rtu)
    {
      if(!strcmp(rtu->slmRTUName,name))
	break;
      rtu = rtu->next;
    }
  return(rtu);
}
