/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "slm.h"

/* create and manage the Download dialog box */
static Widget dnlList;
void slmCreateDownload(Widget parent)
{
  int n=0;
  Arg args[10];
  XmString title,listLabel,okLabel,cancelLabel,applyLabel;
#ifdef SOLARIS
  title = XmStringCreateLocalized("Select RTUs for Access Control Download");
  listLabel = XmStringCreateLocalized("RTU:             File Date:               RTU Date:");
  okLabel = XmStringCreateLocalized("Select All");
  applyLabel = XmStringCreateLocalized("Download");
  cancelLabel = XmStringCreateLocalized("Dismiss");
#else
  title = XmStringCreateSimple("Select RTUs for Access Control Download");
  listLabel = XmStringCreateSimple("RTU:             File Date:               RTU Date:");
  okLabel = XmStringCreateSimple("Select All");
  applyLabel = XmStringCreateSimple("Download");
  cancelLabel = XmStringCreateSimple("Dismiss");
#endif
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNapplyLabelString,applyLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNautoUnmanage,False);n++;
  /* create dialog */
  w_download = XmCreateSelectionDialog(parent,"DOWNLOAD",args,n);
  XtVaSetValues(w_download,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogStyle,XmDIALOG_PRIMARY_APPLICATION_MODAL,
		XmNdialogTitle,title,NULL);
  XtUnmanageChild(XmSelectionBoxGetChild(w_download,XmDIALOG_HELP_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(w_download,XmDIALOG_TEXT));
  XtUnmanageChild(XmSelectionBoxGetChild(w_download,XmDIALOG_SELECTION_LABEL));
  XtAddCallback(XmSelectionBoxGetChild(w_download,XmDIALOG_CANCEL_BUTTON),XmNactivateCallback,slmDnlDismiss,(XtPointer)0);
  XtAddCallback(XmSelectionBoxGetChild(w_download,XmDIALOG_OK_BUTTON),XmNactivateCallback,slmDnlSelectAll,(XtPointer)0);
  XtAddCallback(XmSelectionBoxGetChild(w_download,XmDIALOG_APPLY_BUTTON),XmNactivateCallback,slmDnlDownload,(XtPointer)0);
  /* get children */
  dnlList = XmSelectionBoxGetChild(w_download,XmDIALOG_LIST);
  XmListDeselectAllItems(dnlList);
  XtVaSetValues(dnlList,XmNselectionPolicy,XmEXTENDED_SELECT,NULL);
  /* free strings */
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(applyLabel);
  XmStringFree(cancelLabel);
}

void slmDnlDismiss(Widget w, XtPointer client_data, XtPointer call_data)
{
XtUnmanageChild(w_download);
}
/* Select all the items in the list */
void slmDnlSelectAll(Widget w, XtPointer client_data, XtPointer call_data)
{
  int	numItems;
  XmStringTable	okSel;
  XtVaGetValues(dnlList,XmNitemCount,&numItems,XmNitems,&okSel,NULL);
  if(numItems)
    XtVaSetValues(dnlList,XmNselectedItemCount,numItems,XmNselectedItems,okSel,NULL);
}
/* Get the selected RTUs to come and get their stuff */
void slmDnlDownload(Widget w, XtPointer client_data, XtPointer call_data)
{
  int	numItems,castat;
  short flag=1;
  char *item,msg[80],*name;
  XmStringTable	okSel;
  RTU_ENTRY  *rtu;

  XtVaGetValues(dnlList,XmNselectedItemCount,&numItems,XmNselectedItems,&okSel,NULL);
  while(--numItems >= 0)
    {
      XmStringGetLtoR(okSel[numItems],XmSTRING_DEFAULT_CHARSET,&item);
      name = strtok(item," ");
      rtu = slmRTUNameTree;
      while(rtu)
	{
 	  if(!strcmp(name,rtu->slmRTUName))
	    {
	      if(rtu->slmChannelA)
		{
		  if((castat = ca_put(OLD_DBF_SHORT,rtu->slmChannelA,&flag)) == ECA_NORMAL)
		    {
		      ca_pend_io(0);
		    }
		  else
		    {
		      sprintf(msg,"Error from ca_put\n%s\n",ca_message(castat));
		      slmCreateInfo(msg,"SLM");
		    }
		}
	      if(rtu->slmChannelB)
		{
		  if((castat = ca_put(OLD_DBF_SHORT,rtu->slmChannelB,&flag)) == ECA_NORMAL)
		    {
		      ca_pend_io(0);
		    }
		  else
		    {
		      sprintf(msg,"Error from ca_put\n%s\n",ca_message(castat));
		      slmCreateInfo(msg,"SLM");
		    }
		}
	    }
	  rtu = rtu->next;
	}
      XtFree(item);
    }
}
