#ifndef	INCsnlvuchannelsdialogHXX
#define	INCsnlvuchannelsdialogHXX

class ChannelsListView;
class ChannelsExitButton;


class ChannelsDialog : public vdialog
{
    MainDialog		*mainDialog;
    vruler		*channelsRuler;
    ChannelsListView	*channelsListView;
    ChannelsExitButton	*exitButton;

    void		SetChannelsTitle (void);

    // remember the current channels displayed
    REPCHANS_REPLY	*PrevChannels;
    char		programName [PROGRAM_NAME_SIZE + 1];
    long		TaskId;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(ChannelsDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ChannelsDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override a dialog reconfigure event
    int HandleConfigure (vevent *event);

    // open 
    void OpenChannels (MainDialog *dlg, char *progName, long tid);

    void UpdateChannelsList (void);

    vruler *GetChannelsRuler (void)
	{ return (channelsRuler); }
};


class  ChannelsListView : public vlistview
{
    ChannelsDialog	*channelsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ChannelsListView);
    vloadableINLINE_CONSTRUCTORS(ChannelsListView, vlistview);

    // override 
    void Destroy ();

    // override
    void DrawCellContents (int row, int col, int selected, vrect *cellRect);

    void BuildList (REPCHANS_REPLY *channels, int numChannels);

    // set columns width based on current ruler item widths
    void SetColumnsWidths (void);

    void StoreChannelsDialog (ChannelsDialog *dlg)
	{ channelsDialog = dlg; }
};


class  ChannelsExitButton : public vbutton
{
    ChannelsDialog	*channelsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ChannelsExitButton);
    vloadableINLINE_CONSTRUCTORS(ChannelsExitButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreChannelsDialog (ChannelsDialog *dlg)
	{ channelsDialog = dlg; }
};

#endif	INCsnlvuchannelsdialogHXX

