#ifndef	INCsnlvuexpanddialogHXX
#define	INCsnlvuexpanddialogHXX

class ExpandListView;
class ExpandModifyButton;
class ExpandExitButton;

class ExpandDialog : public vdialog
{
    MainDialog		*mainDialog;
    ExpandListView	*expandListView;
    ExpandModifyButton	*modifyButton;
    ExpandExitButton	*exitButton;

    void		SetExpandTitle (void);

    // remember the current expand displayed
    REPVARS_REPLY	*variable;
    char		programName [PROGRAM_NAME_SIZE + 1];
    long		TaskId;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(ExpandDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ExpandDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // open 
    void OpenExpand (MainDialog *dlg, char *progName, long tid, REPVARS_REPLY *var);

    void UpdateExpandList (void);

    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

    char *GetProgramName (void)
	{ return (programName); }

    long GetTaskId (void)
	{ return (TaskId); }

    ExpandListView *GetExpandListView (void)
	{ return (expandListView); }

    REPVARS_REPLY *GetVariable (void)
	{ return (variable); }

    int	InUse;
};


class  ExpandListView : public vlistview
{
    ExpandDialog	*expandDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ExpandListView);
    vloadableINLINE_CONSTRUCTORS(ExpandListView, vlistview);

    // override 
    void Destroy ();

    // override
    void ObserveSelect (int state);

    void BuildList (char *variable, int length);

    void StoreExpandDialog (ExpandDialog *dlg)
	{ expandDialog = dlg; }
};


class  ExpandModifyButton : public vbutton
{
    ExpandDialog	*expandDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ExpandModifyButton);
    vloadableINLINE_CONSTRUCTORS(ExpandModifyButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreExpandDialog (ExpandDialog *dlg)
	{ expandDialog = dlg; }
};


class  ExpandExitButton : public vbutton
{
    ExpandDialog	*expandDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(ExpandExitButton);
    vloadableINLINE_CONSTRUCTORS(ExpandExitButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreExpandDialog (ExpandDialog *dlg)
	{ expandDialog = dlg; }
};

#endif	INCsnlvuexpanddialogHXX

