/****
*
*	File name :		l1_sslx.c
*	Author :		Steve Johnson
*	Creation date :	December 1, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		l1ssl_init
*		l1ssl_connect
*		l1ssl_publish
*		l1ssl_accept
*		l1ssl_write
*		l1ssl_poll
*		l1ssl_read
*		l1ssl_clear
*		l1ssl_shutdown
*		l1ssl_exit
*
*	Entry point stub layer for using ssl/IP to a telnet session
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl1ssl.h>

/****
*
****/

LEVEL1_STATUS l1ssl_init (void)
{
	TRACE ("l1ssl_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS l1ssl_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("l1ssl_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("l1ssl_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_accept (LEVEL1_HANDLE	*client_handle
						  , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("l1ssl_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_write (LEVEL1_HANDLE		user_handle
						 , size_t				buffer_size
						 , void 				*buffer)
{
	ERROR_TRACE ("l1ssl_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("l1ssl_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_read (LEVEL1_HANDLE	user_handle
						, size_t		buffer_size
						, void			*buffer
						, size_t		*return_length)
{
	ERROR_TRACE ("l1ssl_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("l1ssl_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("l1ssl_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1ssl_exit (void)
{
	TRACE ("digi_exit, stub");
	return LEVEL1_NORMAL;
}
