/****
*
*	File name :		l1_unixx.c
*	Author :		Steve Johnson
*	Creation date :	December 1, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		unix_init
*		unix_connect
*		unix_publish
*		unix_accept
*		unix_write
*		unix_poll
*		unix_read
*		unix_clear
*		unix_shutdown
*		unix_exit
*
*	Entry point stub layer for UNIX tty type devices
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl1unix.h>

/****
*
****/

LEVEL1_STATUS unix_init (void)
{
	TRACE ("unix_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS unix_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("unix_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("unix_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_accept (LEVEL1_HANDLE	*client_handle
						 , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("unix_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_write (LEVEL1_HANDLE	user_handle
						, size_t		buffer_size
						, void			*buffer)
{
	ERROR_TRACE ("unix_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("unix_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_read (LEVEL1_HANDLE	user_handle
					   , size_t			buffer_size
					   , void			*buffer
					   , size_t			*return_length)
{
	ERROR_TRACE ("unix_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("unix_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("unix_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS unix_exit (void)
{
	TRACE ("unix_exit, stub");
	return LEVEL1_NORMAL;
}
