/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vtimeHEADER
#include vmemHEADER
#include vcontrolHEADER
#include "tagvunames.h"
extern "C"
{
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
}
extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "cadef.h"
#include "msgMon.h"
}
typedef char *caddr_t;
#include "tagvu.h"
#include "tagvuMainDialogClass.h"
/*******************************************************************
*
*    Main ()
*
*******************************************************************/

int main (int argc, char **argv)
{

    // Initialize Galaxy
    vstartup (argc, argv);
    tisOpenLog("tagVu",3,0,0,0);
    tisBumpLogLevel(2);
    vapplication *app = vapplication::GetCurrent();
    vresource appres = app->GetResources();
    tagvunamesInternNames();

    // load the main dialog
    vresource mainDialogResource = vresourceGet(appres,tagvunames_tagvuMain);
    tagvuMainDialogClass *mainDialog = new tagvuMainDialogClass(mainDialogResource);
    if(mainDialog->getErrorCode() == TAGVU_ERROR_SUCCESS)
    {
	mainDialog -> Open();
	veventProcess();				/* Enter the event loop */
    }
    delete mainDialog;
    exit (EXIT_SUCCESS);
    return EXIT_FAILURE;
}
