/*csl.y,v 1.1.1.1 1999/08/03 14:44:52 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


 /*
*	CSL Grammer
*/
%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "symtab.h"
#include "csldefs.h"
#include "tree.h"

typedef	TreeNode	*NODEPTR;
#define	YYSTYPE		NODEPTR

extern	Symbol	*yylexptr;
extern	int	TokenType;

TreeNode	*p, *q;
Symbol		*s, *u;
char		*t;
char		Buf [50];
extern char	yytext[];
%}

/*
*	Terminal symbols
*/

%token	Identifier
%token	Constant
%token	Channel
%token	Timer
%token	Time
%token	Literal
%token	Label
%token	Function

%token	ACTIVITY
%token	ADD
%token	AFTER
%token	ALARM
%token	AND
%token	AS
%token	AT
%token	BE
%token	CAN
%token	CANNOT
%token	COMMAND
%token	COMPLETE
%token	COMPLETES
%token	CONTINUE
%token	CSL
%token	DIVIDE
%token	DO
%token	ELSE
%token	END
%token	EQ
%token	EQUAL
%token	EVENT
%token	EXECUTE
%token	EXPIRED
%token	EXPIRES
%token	EXPONENT
%token	FOR
%token	GE
%token	GO
%token	GOTO
%token	GREATER
%token	GT
%token	HAS
%token	HOURS
%token	IF
%token	IMMEDIATELY
%token	IN
%token	INFORMATIONAL
%token	IS
%token	LE
%token	LESS
%token	LT
%token	MAJOR
%token	MINOR
%token	MINUTES
%token	MULTIPLY
%token	NE
%token	NOT
%token	OF
%token	ON
%token	OR
%token	REACHED
%token	SECONDS
%token	SET
%token	START
%token	STOP
%token	SUBTRACT
%token	THAN
%token	THEN
%token	TIMEOUT
%token	TO
%token	UNTIL
%token	VERIFY
%token	WAIT
%token	WHILE
%token	WITH
%token	WITHIN

%token	'('
%token	')'

/*
*	Operator associativities and precedence
*/

%left	IS WITHIN OF 
%left	OR
%left	AND
%left	LT LE GT GE EQ NE
%left	ADD SUBTRACT	
%left	MULTIPLY DIVIDE
%left	EXPONENT
%right	NOT
%nonassoc TIMEOUT COMPLETE TO IN

%%

program
	: ;
	| statements
		{ SetRoot ($1); }

statements
	: statement
		{ $$ = NewNode (STATEMENTS, $1, NULL, NULL, NULL, NULL); }
	| statement statements 
		{ $$ = NewNode (STATEMENTS, $1, $2, NULL, NULL, NULL); }

statement
	: command_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| wait_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| if_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| while_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| set_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| alarm_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| start_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| execute_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| activity_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| goto_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| stop_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }
	| label_statement
		{ $$ = NewNode (STATEMENT, $1, NULL, NULL, NULL, NULL); }

command_statement
	: COMMAND Identifier TO Identifier
		{ $2->Sym->Type = DEFUNCT; 
		  strcpy (Buf, $2->Sym->String);
		  strcat (Buf, ".CMDS");
		  t = malloc (strlen (Buf) + 1);
		  strcpy (t, Buf);
		  u = LookUp (t, CHAN); 
		  q = NewTermNode (CHANNEL_NODE, u);
		  s = LookUp ($4->Sym->String, LITERAL);
		  s->Type = LITERAL;
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (COMMAND_STATEMENT, q, p, NULL, NULL, COMD_DEVICE); }
	| COMMAND Identifier TO Literal
		{ $2->Sym->Type = DEFUNCT;
		  strcpy (Buf, $2->Sym->String);
		  strcat (Buf, ".CMDS");
		  t = malloc (strlen (Buf) + 1);
		  strcpy (t, Buf);
		  u = LookUp (t, CHAN); 
		  q = NewTermNode (CHANNEL_NODE, u);
		  $$ = NewNode (COMMAND_STATEMENT, q, $4, NULL, NULL, COMD_DEVICE); }
	| COMMAND Identifier TO START
		{ $2->Sym->Type = DEFUNCT;
		  strcpy (Buf, $2->Sym->String);
		  strcat (Buf, ".CMDS");
		  t = malloc (strlen (Buf) + 1);
		  strcpy (t, Buf);
		  u = LookUp (t, CHAN); 
		  q = NewTermNode (CHANNEL_NODE, u);
 /* **** Using yytext here is really risky but it seems to work **** */
		  s = LookUp (yytext, LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (COMMAND_STATEMENT, q, p, NULL, NULL, COMD_DEVICE); }
	| COMMAND Identifier TO STOP
		{ $2->Sym->Type = DEFUNCT;
		  strcpy (Buf, $2->Sym->String);
		  strcat (Buf, ".CMDS");
		  t = malloc (strlen (Buf) + 1);
		  strcpy (t, Buf);
		  u = LookUp (t, CHAN); 
		  q = NewTermNode (CHANNEL_NODE, u);
		  s = LookUp (yytext, LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (COMMAND_STATEMENT, q, p, NULL, NULL, COMD_DEVICE); }
 	| COMMAND Timer TO START
		{ $$ = NewNode (COMMAND_STATEMENT, $2, NULL, NULL, NULL, COMD_TIMERSTART); }
	| COMMAND Timer TO STOP
		{ $$ = NewNode (COMMAND_STATEMENT, $2, NULL, NULL, NULL, COMD_TIMERSTOP); }

wait_statement
	: WAIT FOR expression time_units
		{ $$ = NewNode (WAIT_STATEMENT, $3, $4, NULL, NULL, WAIT_INTERVAL); }
	| WAIT FOR Identifier TO COMPLETE
		{ $$ = NewNode (WAIT_STATEMENT, $3, NULL, NULL, NULL, WAIT_COMP); }
	| WAIT FOR Identifier TO COMPLETE OR TIMEOUT IN expression time_units
		{ $$ = NewNode (WAIT_STATEMENT, $3, $9, $10, NULL, WAIT_COMP_TIME); }
	| WAIT UNTIL Identifier COMPLETES
		{ $$ = NewNode (WAIT_STATEMENT, $3, NULL, NULL, NULL, WAIT_COMP); }
	| WAIT UNTIL Time
		{ $$ = NewNode (WAIT_STATEMENT, $3, NULL, NULL, NULL, WAIT_TIME); }
	| WAIT UNTIL expression
		{ $$ = NewNode (WAIT_STATEMENT, $3, NULL, NULL, NULL, WAIT_EXPR); }

if_statement
	: IF expression GOTO Identifier 
		{ $$ = NewNode (IF_STATEMENT, $2, $4, NULL, NULL, IF_GOTO);
		  $4->NodeType = LABEL_STATEMENT;
		  $4->Sym->Type = LABEL; }
	| IF expression GO TO Identifier
		{ $$ = NewNode (IF_STATEMENT, $2, $5, NULL, NULL, IF_GOTO);
		  $5->Sym->Type = LABEL; }
	| IF expression THEN statements END IF
		{ $$ = NewNode (IF_STATEMENT, $2, $4, NULL, NULL, IF_THEN); }
	| IF expression THEN statements ELSE statements END IF
		{ $$ = NewNode (IF_STATEMENT, $2, $4, $6, NULL, IF_THEN_ELSE); }

while_statement
	: WHILE expression DO statements END WHILE
		{ $$ = NewNode (WHILE_STATEMENT, $2, $4, NULL, NULL, NULL); }

set_statement
	: SET Identifier TO expression
		{ $$ = NewNode (SET_STATEMENT, $2, $4, NULL, NULL, SET_VARIABLE); }
	| SET Timer TO expression time_units
		{ $$ = NewNode (SET_STATEMENT, $2, $4, $5, NULL, SET_TIMER); }
	| SET Channel TO expression
		{ $$ = NewNode (SET_STATEMENT, $2, $4, NULL, NULL, SET_CHANNEL); }
	| SET WITH VERIFY Channel TO expression
		{ $$ = NewNode (SET_STATEMENT, $4, $6, NULL, NULL, SET_CHANNELV); }

alarm_statement
	: ALARM Identifier AS MINOR Literal
		{ s = LookUp ("minor", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (ALARM_STATEMENT, $2, p, $5, NULL, NULL); }
	| ALARM Identifier AS MAJOR Literal
		{ s = LookUp ("major", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (ALARM_STATEMENT, $2, p, $5, NULL, NULL); }
	| ALARM Identifier AS INFORMATIONAL Literal
		{ s = LookUp ("informational", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (ALARM_STATEMENT, $2, p, $5, NULL, NULL); }
	| ALARM Identifier AS EVENT Literal
		{ s = LookUp ("event", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (ALARM_STATEMENT, $2, p, $5, NULL, NULL); }

start_statement
	: START CSL Literal 
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, WITHWAIT); }
	| START CSL Literal AND CONTINUE
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, NOWAIT); }
	| START CSL Literal AND WAIT
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, WITHWAIT); }
	| START CSL Literal IMMEDIATELY
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, WITHWAIT); }
	| START CSL Literal IMMEDIATELY AND CONTINUE
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, NOWAIT); }
	| START CSL Literal IMMEDIATELY AND WAIT
		{ $$ = NewNode (START_STATEMENT, $3, NULL, NULL, NULL, WITHWAIT); }
	| START CSL Literal AT Time
		{ $$ = NewNode (START_STATEMENT, $3, $5, NULL, NULL, WITHWAIT); }
	| START CSL Literal AT Time AND CONTINUE
		{ $$ = NewNode (START_STATEMENT, $3, $5, NULL, NULL, NOWAIT); }
	| START CSL Literal AT Time AND WAIT
		{ $$ = NewNode (START_STATEMENT, $3, $5, NULL, NULL, WITHWAIT); }
	| START CSL Literal AFTER expression time_units
		{ $$ = NewNode (START_STATEMENT, $3, $5, $6, NULL, WITHWAIT); }
	| START CSL Literal AFTER expression time_units AND CONTINUE
		{ $$ = NewNode (START_STATEMENT, $3, $5, $6, NULL, NOWAIT); }
	| START CSL Literal AFTER expression time_units AND WAIT
		{ $$ = NewNode (START_STATEMENT, $3, $5, $6, NULL, WITHWAIT); }

execute_statement
	: EXECUTE Literal 
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, NOWAIT); }
	| EXECUTE Literal AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal IMMEDIATELY
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal IMMEDIATELY AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, NOWAIT); }
	| EXECUTE Literal IMMEDIATELY AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal AT Time 
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal AT Time AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, NULL, NOWAIT); }
	| EXECUTE Literal AT Time AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, NULL, WITHWAIT); }
	| EXECUTE Literal AFTER expression time_units
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, NULL, WITHWAIT); }
	| EXECUTE Literal AFTER expression time_units AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, NULL, NOWAIT); }
	| EXECUTE Literal AFTER expression time_units AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, NULL, WITHWAIT); }
	| EXECUTE Literal ON Literal 
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, $4, WITHWAIT); }
	| EXECUTE Literal ON Literal AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, $4, NOWAIT); }
	| EXECUTE Literal ON Literal AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, NULL, NULL, $4, WITHWAIT); }
	| EXECUTE Literal AT Time ON Literal 
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, $6, WITHWAIT); }
	| EXECUTE Literal AT Time ON Literal AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, $6, NOWAIT); }
	| EXECUTE Literal AT Time ON Literal AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, NULL, $6, WITHWAIT); }
	| EXECUTE Literal AFTER expression time_units ON Literal
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, $7, WITHWAIT); }
	| EXECUTE Literal AFTER expression time_units ON Literal AND CONTINUE
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, $7, NOWAIT); }
	| EXECUTE Literal AFTER expression time_units ON Literal AND WAIT
		{ $$ = NewNode (EXECUTE_STATEMENT, $2, $4, $5, $7, WITHWAIT); }

activity_statement
	: ACTIVITY IS Literal
		{ $$ = NewNode (ACTIVITY_STATEMENT, $3, NULL, NULL, NULL, NULL); }

goto_statement
	: GOTO Identifier 
		{ $$ = NewNode (GOTO_STATEMENT, $2, NULL, NULL, NULL, NULL);
		  $2->NodeType = LABEL_STATEMENT;
		  $2->Sym->Type = LABEL; }
	| GO TO Identifier 
		{ $$ = NewNode (GOTO_STATEMENT, $3, NULL, NULL, NULL, NULL);
		  $3->NodeType = LABEL_STATEMENT;
		  $3->Sym->Type = LABEL; } 

stop_statement
	: STOP expression
		{ $$ = NewNode (STOP_STATEMENT, $2, NULL, NULL, NULL, NULL); }
	| STOP
		{ $$ = NewNode (STOP_STATEMENT, NULL, NULL, NULL, NULL, NULL); }
	| STOP CSL Identifier 
		{ $$ = NewNode (STOPCSL_STATEMENT, $3, NULL, NULL, NULL, NULL); }

label_statement
	: Label
		{ $$ = NewNode (LABEL_STATEMENT, $1, NULL, NULL, NULL, NULL); }

time_units
	: SECONDS
		{ s = LookUp ("seconds", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (TIME_UNITS, p, NULL, NULL, NULL, NULL); }
	| MINUTES
		{ s = LookUp ("minutes", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (TIME_UNITS, p, NULL, NULL, NULL, NULL); }
	| HOURS
		{ s = LookUp ("hours", LITERAL);
		  p = NewTermNode (LITERAL_NODE, s);
		  $$ = NewNode (TIME_UNITS, p, NULL, NULL, NULL, NULL); }
	 
expression
	: Identifier
		{ $$ = NewNode (EXPRESSION, $1, NULL, NULL, NULL, NULL);
		  $$->Type = NUMERIC; } 
	| Channel
		{ $$ = NewNode (EXPRESSION, $1, NULL, NULL, NULL, NULL);
		  $$->Type = NUMERIC; } 
	| Constant
		{ $$ = NewNode (EXPRESSION, $1, NULL, NULL, NULL, NULL);
		  $$->Type = NUMERIC; } 
	| Timer
		{ $$ = NewNode (EXPRESSION, $1, NULL, NULL, NULL, NULL);
		  $$->Type = NUMERIC; } 
	| Literal
		{ $$ = NewNode (EXPRESSION, $1, NULL, NULL, NULL, NULL);
		  $$->Type = LITERAL; } 
	| '(' expression ')'
		{ $$ = $2; }
	| Function '(' optional_argument_list ')'
		{ $$ = NewNode (EXPRESSION, $3, NULL, NULL, NULL, FUNCTIONCALL);
		  $$->FuncType = TokenType;
		  $$->Type = NUMERIC; }
	| expression ADD expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, ADDOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression SUBTRACT expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, SUBTRACTOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression MULTIPLY expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, MULTIPLYOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression DIVIDE expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, DIVIDEOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression EXPONENT expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, EXPONENTOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression LT expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, LTOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression LE expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, LEOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression GT expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, GTOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression GE expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, GEOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression EQ expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, EQOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression NE expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, NEOP);
		  if ($1->Type != $3->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS WITHIN expression OF expression
		{ $$ = NewNode (EXPRESSION, $1, $4, $6, NULL, ISWITHINOP);
		  if (($1->Type != NUMERIC) || ($4->Type != NUMERIC) || ($6->Type != NUMERIC))
			Error ("Operands must be numeric.");
		  $$->Type = NUMERIC; }
	| expression IS NOT WITHIN expression OF expression
		{ $$ = NewNode (EXPRESSION, $1, $5, $7, NULL, ISNOTWITHINOP); 
		  if (($1->Type != NUMERIC) || ($5->Type != NUMERIC) || ($7->Type != NUMERIC))
			Error ("Operands must be numeric.");
		  $$->Type = NUMERIC; }
	| expression IS GREATER THAN expression
		{ $$ = NewNode (EXPRESSION, $1, $5, NULL, NULL, GTOP);
		  if ($1->Type != $5->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS GREATER THAN OR EQUAL TO expression
		{ $$ = NewNode (EXPRESSION, $1, $8, NULL, NULL, GEOP);
		  if ($1->Type != $8->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS LESS THAN expression
		{ $$ = NewNode (EXPRESSION, $1, $5, NULL, NULL, LTOP);
		  if ($1->Type != $5->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS LESS THAN OR EQUAL TO expression
		{ $$ = NewNode (EXPRESSION, $1, $8, NULL, NULL, LEOP);
		  if ($1->Type != $8->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS EQUAL TO expression
		{ $$ = NewNode (EXPRESSION, $1, $5, NULL, NULL, EQOP);
		  if ($1->Type != $5->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression IS NOT EQUAL TO expression
		{ $$ = NewNode (EXPRESSION, $1, $6, NULL, NULL, NEOP);
		  if ($1->Type != $6->Type)
			Error ("Incompatible operands.");
		  $$->Type = $1->Type; }
	| expression AND expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, ANDOP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| expression OR expression
		{ $$ = NewNode (EXPRESSION, $1, $3, NULL, NULL, OROP);
		  if (($1->Type == LITERAL) || ($3->Type == LITERAL))
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| NOT expression
		{ $$ = NewNode (EXPRESSION, $2, NULL, NULL, NULL, NOTOP);
		  if ($2->Type == LITERAL)
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| SUBTRACT expression
		{ $$ = NewNode (EXPRESSION, $2, NULL, NULL, NULL, NEGOP);
		  if ($2->Type == LITERAL)
			Error ("Invalid operation for a literal.");
		  $$->Type = NUMERIC; }
	| Timer HAS EXPIRED
		{ $$ = NewNode (TEXP_NODE, $1, NULL, NULL, NULL, HASEXPIREDOP);
		  $$->Sym = yylexptr;
		  $$->Type = NUMERIC; }
	| Timer EXPIRES
		{ $$ = NewNode (TEXP_NODE, $1, NULL, NULL, NULL, HASEXPIREDOP);
		  $$->Sym = yylexptr;
		  $$->Type = NUMERIC; }
	| Channel CAN BE REACHED
		{ $$ = NewNode (TACCESS_NODE, $1, NULL, NULL, NULL, REACHABLEOP);
		  $$->Sym = yylexptr;
		  $$->Type = NUMERIC; }
	| Channel CANNOT BE REACHED
		{ $$ = NewNode (TACCESS_NODE, $1, NULL, NULL, NULL, NOTREACHABLEOP);
		  $$->Sym = yylexptr;
		  $$->Type = NUMERIC; }
	
optional_argument_list
	: /* no actual argument */
		{ $$ = NULL; }
	| argument_list
		{ $$ = NewNode (OPTIONAL_ARGUMENT_LIST, $1, NULL, NULL, NULL, NULL); }

argument_list
	: expression
		{ $$ = NewNode (ARGUMENT_LIST, $1, NULL, NULL, NULL, NULL); }
	| expression ',' argument_list
		{ $$ = NewNode (ARGUMENT_LIST, $1, $3, NULL, NULL, NULL); }

