/*tree.h,v 1.1.1.1 1999/08/03 14:44:57 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software was developed for DLA by Tate Integrated  */
/*	Systems, L.P. via a contract with Vitro Corporation.	*/
/*	It is designed to work with TIS4000 Release 4.2.	*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*	File:	tree.h		CSL parse tree definitions
/*	Author:	Douglas P. Dotson
/*	Date:	09 Apr 1993
/*	Edit:	07 Oct 1993	1214	DPD
*/

/* Parse tree node */

typedef struct treenode {
    int			NodeType; 
    int			Type;		/* Applies to expressions only */
    struct treenode	*Left;
    struct treenode	*Middle;
    struct treenode	*Right;
    struct treenode	*Extra;		/* A few need a fourth pointer */
    Symbol		*Sym;		/* Only valid for terminal nodes */
    int			MoreInfo;
    int			FuncType;
    int			LineNumber;
} TreeNode;
    
/* Node Types - Non-Terminals */

#define	PROGRAM			0
#define	STATEMENTS		1
#define	STATEMENT		2
#define	COMMAND_STATEMENT	3
#define	WAIT_STATEMENT		4
#define	IF_STATEMENT		5
#define	WHILE_STATEMENT		6
#define	SET_STATEMENT		7
#define	ALARM_STATEMENT		8
#define	START_STATEMENT		9
#define	EXECUTE_STATEMENT	10
#define	ACTIVITY_STATEMENT	11
#define	GOTO_STATEMENT		12
#define	STOP_STATEMENT		13
#define	STOPCSL_STATEMENT	14
#define	LABEL_STATEMENT		15
#define	TIME_UNITS		16
#define	EXPRESSION		17
#define	OPTIONAL_ARGUMENT_LIST	18
#define	ARGUMENT_LIST		19

/* Node Types - Terminals */

#define	IDENTIFIER_NODE		20
#define	CONSTANT_NODE		21
#define	CHANNEL_NODE		22
#define	TIMER_NODE		23
#define	TIME_NODE		24
#define	LITERAL_NODE		25
#define	TEXP_NODE		26
#define	TACCESS_NODE		27

/* Expression types */

#define	NUMERIC			0
#define	STRING			1

/* Node manipulation functions */

TreeNode	*NewNode ();
TreeNode	*NewTermNode ();

