#ifndef	grpmaintdialogH
#define	grpmaintdialogH

class MembersListView;
class UsersListView;
class GrpMaintAddButton;
class GrpMaintRemoveButton;
class GrpMaintOkButton;
class GrpMaintCancelButton;
class GrpMaintUtilAccButton;

class GroupMaintDialog : public vdialog
{
    MainDialog	    *mainDialog;
    vchar	    group [GROUPNAME_SZ + 1];

    void	    SetDialogTitle (void);

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GroupMaintDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GroupMaintDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // overrides 
    void Destroy ();
    void ObserveWindow (vevent *event);

    void OpenGrpMaint (MainDialog *mainDlg, vchar *group);

    MembersListView	    *membersListView;
    UsersListView	    *usersListView;
    GrpMaintAddButton	    *addButton;
    GrpMaintRemoveButton    *removeButton;
    GrpMaintOkButton	    *okButton;
    GrpMaintCancelButton    *cancelButton;
    GrpMaintUtilAccButton   *utilAccButton;

    // some public funcs
    vchar *GetGroupName (void)
	{ return (group); }
    MainDialog *GetMainDialog (void)
    { return (mainDialog); }
};


class  MembersListView : public vlistview
{
    vliststr		*list;
    GroupMaintDialog	*grpMaintDialog;
    int			modified;
    int			flag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(MembersListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(MembersListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    void Destroy ();
    void ObserveSelect (int state);
    
    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }

    void BuildList (vchar *group);

    int GetFlag (void )
	{ return (flag); }
    void SetFlag (int flg)
	{ flag = flg; }
    void SetModified (int mod)
	{ modified = mod; }
    int GetModified (void)
	{ return (modified); }
};


class  UsersListView : public vlistview
{
    vliststr		*list;
    GroupMaintDialog	*grpMaintDialog;
    int			flag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(UsersListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(UsersListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    void Destroy ();
    void ObserveSelect (int state);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }

    void BuildList (vchar *group);

    int GetFlag (void)
	{ return (flag); }
    void SetFlag (int flg)
	{ flag = flg; }
};


class  GrpMaintAddButton : public vbutton
{
    GroupMaintDialog	*grpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GrpMaintAddButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GrpMaintAddButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }
};


class  GrpMaintRemoveButton : public vbutton
{
    GroupMaintDialog	*grpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GrpMaintRemoveButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GrpMaintRemoveButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }
};


class  GrpMaintOkButton : public vbutton
{
    GroupMaintDialog	*grpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GrpMaintOkButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GrpMaintOkButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }
};


class  GrpMaintCancelButton : public vbutton
{
    GroupMaintDialog	*grpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GrpMaintCancelButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GrpMaintCancelButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }
};


class  GrpMaintUtilAccButton : public vbutton
{
    GroupMaintDialog	*grpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GrpMaintUtilAccButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GrpMaintUtilAccButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetGrpMaintDialog (GroupMaintDialog *dlg)
        { grpMaintDialog = dlg; }
};

#endif	grpmaintdialogH

