/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	INSTALL KEYS IN THE /tis4000/tasks/keys DIRECTORY	*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include "msgMon.h"

#ifdef	WIN32
static char filePrefix[] = "\\tis4000\\tasks\\keys\\";
#else
static char filePrefix[] = "/tis4000/tasks/keys/";
#endif	WIN32

void main()
{
    unsigned char	key[6];
    unsigned char	keyCopy[6];
    unsigned char	buff[100];
    char		fileName[100];
    char		feature[100];
    int			year;
    int			month;
    int			day;
    FILE		*fd;
    int			i;
    int			len;
    int			idx;

    tisOpenLog ("tlmInstall", 6, 2, NULL, NULL);

    getKey(key);
    printf("Workstation key is: %02X%02X%02X%02X%02X%02X\n\n",
	key[0], key[1], key[2], key[3], key[4], key[5], key[6]);

    printf("Install keys? [Y]   ");
    gets(buff);
    if ((buff[0] != 0) && (buff[0] != 'y') && (buff[0] != 'Y'))
	exit(0);

    for (;;)
	{
	printf("Feature name?   ");
	gets(buff);
	if (buff[0] == 0)
	    exit(0);
	strcpy(fileName, filePrefix);
	strcat(fileName, buff);
	strcpy(feature, buff);
	if ((fd = fopen(fileName, "w")) == NULL)
	    {
	    perror("Can't create file");
	    continue;
	    }
	memcpy(keyCopy, key, sizeof(keyCopy));
	strcpy(buff, "FREITAG");
	code(buff, strlen(buff), keyCopy, sizeof(keyCopy));
	for (i = 0; i < 7; i++)
	    fprintf(fd, "%02X", buff[i]);
	fprintf(fd, "\n");

	for (;;)
	    {
	    printf("Key?   ");
	    gets(buff);
	    if ((len = strlen(buff)) <= 16)
	        {
	        printf("This key has an invalid length!\n");
		continue;
		}
	    len >>= 1;
	    for (i = 0, idx = 0; buff[i]; i += 2, idx++)
		{
		if ((buff[i] >= '0') && (buff[i] <= '9'))
		    buff[idx] = (buff[i] - '0') << 4;
		else if ((buff[i] >= 'A') && (buff[i] <= 'F'))
		    buff[idx] = (buff[i] - 'A' + 10) << 4;
		else if ((buff[i] >= 'a') && (buff[i] <= 'f'))
		    buff[idx] = (buff[i] - 'a' + 10) << 4;
		else
		    break;

		if ((buff[i + 1] >= '0') && (buff[i + 1] <= '9'))
		    buff[idx] += buff[i + 1] - '0';
		else if ((buff[i + 1] >= 'A') && (buff[i + 1] <= 'F'))
		    buff[idx] += buff[i + 1] - 'A' + 10;
		else if ((buff[i + 1] >= 'a') && (buff[i + 1] <= 'f'))
		    buff[idx] += buff[i + 1] - 'a' + 10;
		else
		    break;
		}
	    if (i < 16)
		{
		printf("This key contains an invalid character\n");
		continue;
		}
	    memcpy(keyCopy, key, sizeof(keyCopy));
	    code(buff, len, keyCopy, sizeof(keyCopy));
	    if (!strncmp(buff, "!PAIDUP!", 8))
		printf("This is a permanent key.\n");
	    else
		{
		strncpy(fileName, buff, 4);
		fileName[4] = 0;
		year = atoi(fileName);
		if (year < 1995)
		    {
		    printf("This key is invalid.\n");
		    continue;
		    }
		strncpy(fileName, buff + 4, 2);
		fileName[2] = 0;
		month = atoi(fileName);
		if ((month < 0) || (month > 11))
		    {
		    printf("This key is invalid.\n");
		    continue;
		    }
		month++;
		strncpy(fileName, buff + 6, 2);
		fileName[2] = 0;
		day = atoi(fileName);
		if ((day < 1) || (day > 31))
		    {
		    printf("This key is invalid.\n");
		    continue;
		    }
		printf("This key expires on %d/%d/%d\n", month, day, year);
		}

	    if (strncmp(feature, buff + 8, strlen(feature)))
		printf("This key is invalid for this feature.\n");
		
	    /*
	    Re-encrypt the key and then write it to the file.
	    */

	    memcpy(keyCopy, key, sizeof(keyCopy));
	    code(buff, len, keyCopy, sizeof(keyCopy));
	    for (i = 0; i < len; i++)
		if (fprintf(fd, "%02X", buff[i]) == EOF)
		    {
		    perror("Can't write to key file");
		    fclose(fd);
		    break;
		    }
	    if (fprintf(fd, "\n") == EOF)
		perror("Can't write to key file");
	    fclose(fd);
	    break;
	    }
	}
}
	    
