
#ifndef TREND_DEFINES_H
#define TREND_DEFINES_H

/* use common definitions from newtrend directory */
#include "trendSizes.h"

/* Constants */
#define MAXSYM 30

/* result codes */
#define RESULT_OK   0
#define RESULT_CANCEL 1

/* DB access result codes */
#define DBOK	0
#define DBREDUCERR 1
#define DBSNAPERR 2
#define DBTRENDERR 3
#define DBNOTESERR 4

#define C_MAXPATHLEN 132 /* max length for a filename */

#define C_STATUSLEN 50	/* max length of the search status string */
#define C_SEVLEN    6	/* max length of the severity severity string */
#define C_TRENDPTS  8
#define C_PTNMLEN   29	/* max length of the epn name */
#define C_TAGLEN    17	/* max length of egu tag */
#define C_DATELEN   40	/* max length for a date string */
#define C_OFFSETLEN 40	/* max len for an offset (span) string */
#define C_TRENDDESCLEN 80   /* max length of the trend descriptor field */
#define C_TRENDSAMPLES 512  /* number of samples to plot */
#define C_SPECLEN   80  /* max length of a trend spec string */

#define C_EPOCHSTART	2440588L    /* dif from db4 date to 01/01/1970 */
#define C_SECSPERDAY	86400L	/* number of seconds per day */
#define C_MAXRES    65535	/* max resolution we will match to */

#define C_NEWRADIOBUTTONS 5 /* number of radio buttons in New dialog */


/* packed color manipulation */
#define Color(r,g,b) ((r<<16) + (g<<8) + b)
#define Red(c)       ((c>>16) & 255)
#define Green(c)     ((c>>8) & 255)
#define Blue(c)      (c & 255)

/* typedefs */
typedef struct {
#ifdef ORACLESNAP
	time_t	rec;
#else
	int	rec;
#endif ORACLESNAP
	int	fld;
	long	time;
	double	value;
	unsigned char status[4];
} ITEM;

/* status bit definition (make sure that these match data
** in trendfil.h)
*/
#define SEVMASK		0xF8000000
#define QUALMASK	0x07C00000
#define ALMMASK		0x003FFFFF
#define EDITBIT		0x04000000
#define QERRBIT		0x02000000
#define CONNERRBIT	0x01000000

#endif TREND_DEFINES_H
