/* trenddocs.h,v 1.1.1.1 1999/08/03 14:45:09 tis4000 Exp
 *
 */

/*
 * Trenddocs.h - trend document classes
 */

class TrendData
{
    public:
	TrendData ();
	void UpdateData (CHARSPEC trspec, int vuzoom);
	void UpdateData (long vustarttime, int vuzoom);
	void UpdateData (TrendData *ds);
	void AddData (TrendData *ds);
	void SubtractData (TrendData *ds);
	int Search (SEARCH *search, int cursloc);
	void GetTrendSpec (CHARSPEC trspec, int convertAbs);
	time_t GetNoteTime (time_t when);
	void GetDetailString (char *text, int textlen, int cursloc);
	void GetValueString (char *text, int textlen, int cursloc);
	char *PointName ();
	char *PointReduc ();
	char *PointDBReduc ();
	char *PointTag ();
	char *PointDate (int cursloc);
	char *PointTime (int cursloc);
	long PointTick (int cursloc);
	char *dValue (int cursloc);
	char *dValue2 (int cursloc);
	char *dStatus (int cursloc);
	char *PointHiLim (void);
	char *PointLoLim (void);

	char	pointname [POINTNAME_SIZE+1];
	char	egutag [EGUTAG_SIZE+1];
	int	dbreduc;
	int	reduc;
	char	date[C_DATELEN];	/* as in original specification */
	char	off[C_OFFSETLEN];	/* as in original specification */
	time_t	starttime;
	int	zoom;
	long	dbrate;
	double	dispLo;
	double	dispHi;
	double	dbdispLo;
	double	dbdispHi;
	double	ctlLo;
	double	ctlHi;
	int	ctlEnable;
	int	enable;
	double	value1 [C_TRENDSAMPLES];
	double	value2 [C_TRENDSAMPLES];
	unsigned char	status [C_TRENDSAMPLES][3];
};

class TrendSet
{
    public:
	TrendSet ();
	void ChangeSet (char *setName);
	void SaveSet (char *setName, int convertAbs);
	void UpdateSet (long vustarttime, int vuzoom);
	void AdjustTime (long t);
	time_t GetStartTime (void);
	time_t GetEndTime (void);

	char	setname [C_TRENDDESCLEN + 1];
	long	zoom;
	long	autoupdate;
	int	numTrends;
	CHARSPEC specs [C_TRENDPTS];
	TrendData trends[C_TRENDPTS];
};

