/* trendeditdlg.cxx,v 1.1.1.1 1999/08/03 14:45:09 tis4000 Exp
 *
 */

/*
 * TrendEditDialog - trend set editor dialog class
 */

#include <vport.h>		/* for v*HEADER */
#include vstdlibHEADER		/* for random, exit, EXIT_SUCCESS */
#include vlistHEADER
#include vlistviewHEADER
#include vstartupHEADER
#include vmemHEADER
#include vprefHEADER
#include vtextitemHEADER
#include vbuttonHEADER
#include vcharHEADER
#include vdialogHEADER
#include vcomboboxHEADER
#include vnumHEADER

#ifdef WIN32
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#endif WIN32

extern "C"
{
    #include "trendutils.h"
    extern char    * RedStrings[];
}
#include "trenddocs.h"
#include "trendeditdlg.h"
#include "trendlistdlg.h"
#include "trendmacrodlg.h"
#include "tisgalaxylib.hxx"

extern TrendListDialog  *listDialog;
extern TrendMacroDialog	*macroDialog;

// Help functions
class teDurType : public vcontainerExclusiveGroup {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teDurType);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teDurType, vcontainerExclusiveGroup);
  
  // virtual member function overrides
  void ObserveDialogItem (vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teDurType, vcontainerExclusiveGroup, NULL);
void teDurType::ObserveDialogItem (vevent *event)
{
    parent->DurTypeClick (event->type );
}

class teSpecList : public vlistview {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teSpecList);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teSpecList, vlistview);
  
  // virtual member function overrides
  void ObserveSelect(int state);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teSpecList, vlistview, NULL);
void teSpecList::ObserveSelect(int state)
{
    int	    row;
    int	    column;

    if (state == vlistviewSELECTION_HAS_CHANGED)
    {
	vliststr *ptListData = (vliststr *)GetList();
	if (GetLastPointerClickCount() == 1)
	{
	    ptListData->GetSelectedCell(GetSelection(), &row, &column);
	    parent->ListClick (row);
	}
    }
}

class teAddButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teAddButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teAddButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teAddButton, vbutton, NULL);
void teAddButton::ObserveDialogItem (vevent *event)
{
    parent->AddClick();
}

class teDeleteButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teDeleteButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teDeleteButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teDeleteButton, vbutton, NULL);
void teDeleteButton::ObserveDialogItem (vevent *event)
{
    parent->DeleteClick();
}

class teAcceptButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teAcceptButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teAcceptButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teAcceptButton, vbutton, NULL);
void teAcceptButton::ObserveDialogItem (vevent *event)
{
    parent->AcceptClick();
}

class teBrowseButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teBrowseButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teBrowseButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teBrowseButton, vbutton, NULL);
void teBrowseButton::ObserveDialogItem (vevent *event)
{
    parent->BrowseClick();
}

class teCancelButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(teCancelButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(teCancelButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendEditDialog *p) { parent = p; }
private:
    TrendEditDialog *parent;
};

vkindTYPED_FULL_DEFINITION(teCancelButton, vbutton, NULL);
void teCancelButton::ObserveDialogItem (vevent *event)
{
    parent->CancelClick();
}

// macro definitions for vkindtyped overrides
vkindTYPED_FULL_DEFINITION(TrendEditDialog, vdialog, NULL);

// vloadable
void TrendEditDialog::LoadInit(vresource resource)
{
    // get handles to interesting elements
    descText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DescTextTag"));
    durText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DurTextTag"));
    durType = teDurType::RequestSubLoad (this, vnameInternGlobalLiteral("DurTypeGroupTag"));
    autoToggle = vcontrolToggle::RequestSubLoad (this, vnameInternGlobalLiteral("AutoTag"));
    defSpecText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DefSpecTextTag"));
    dateText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DateTextTag"));
    offsetText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("OffsetTextTag"));
    reducType = vcontainerExclusiveGroup::RequestSubLoad (this, vnameInternGlobalLiteral("RedGrpTag"));
    dspLoText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DspLoTextTag"));
    dspHiText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DspHiTextTag"));
    addPt = teAddButton::RequestSubLoad (this, vnameInternGlobalLiteral("AddPtButtonTag"));
    timeToggle = vcontrolToggle::RequestSubLoad (this, vnameInternGlobalLiteral("TimeCheckTag"));
    ctlLoText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("CtlLoTextTag"));
    ctlHiText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("CtlHiTextTag"));
    delPt = teDeleteButton::RequestSubLoad (this, vnameInternGlobalLiteral("DelPtButtonTag"));
    itemList = teSpecList::RequestSubLoad (this, vnameInternGlobalLiteral("ItemListTag"));
    accept = teAcceptButton::RequestSubLoad (this, vnameInternGlobalLiteral("AcceptButtonTag"));
    browse = teBrowseButton::RequestSubLoad (this, vnameInternGlobalLiteral("BrowseButtonTag"));
    cancel = teCancelButton::RequestSubLoad (this, vnameInternGlobalLiteral("CancelButtonTag"));

    vdialog::LoadInit(resource);

    durType->SetParent (this);
    itemList->SetParent (this);
    addPt->SetParent (this);
    delPt->SetParent (this);
    accept->SetParent (this);
    browse->SetParent (this);
    cancel->SetParent (this);
}

/*********
 *  TrendEditDialog::ObserveWindow()
 *
 *  The dialog notification procedure gets called whenever any 
 *  major event applies to the dialog as a whole.  We need to
 *  look for the event which tells us that the dialog has
 *  closed.
 *
 **********/
void TrendEditDialog::ObserveWindow (vevent *event)
{
    result = RESULT_CANCEL;
    if (event->GetType() == veventWINDOW_STATE && event->IsClose ())
    {
	vevent::StopProcessing ();

	if (itemList->GetList ())
	    delete itemList->GetList ();
	itemList->SetList (NULL);
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}

/*********
 *  TrendEditDialog::DurTypeClick (int type)
 *
 *  The procedure gets called whenever the duration type box is clicked 
 *
 **********/
void TrendEditDialog::DurTypeClick (int type)
{
    char    tempstring [40];

    durText->GetText((unsigned char *)tempstring, sizeof(tempstring));
    if (curtype)
    {
	workset.zoom = atoi(tempstring);
    }
    else
    {
	workset.zoom = (SpanVal(tempstring) + 511L)/512L;
    }
    curtype = durType->GetItemIndex (durType->GetSelection());
    if (curtype)
    {
	sprintf (tempstring, "%i", workset.zoom, tempstring);
	durText->SetText ((unsigned char *)tempstring);
    }
    else
    {
	durText->SetText ((unsigned char *)StrSpan (workset.zoom*512L, tempstring));
    }
}

/*********
 *  TrendEditDialog::ListClick (int which)
 *
 *  The procedure gets called whenever the list box is clicked 
 *
 **********/
void TrendEditDialog::ListClick (int which)
{
    char epn [C_PTNMLEN + 1];
    char epntext [C_PTNMLEN + 5];
    int  dbreduc, reduc;
    char date [40];
    char off [40];
    long time;
    double dl, dh, cl, ch;

    GetTSpec ( workset.specs[which], epn,
               &dbreduc, &reduc,
               date, off, &time,
               &dl, &dh, &cl, &ch, workset.zoom );
    // unpack selected trendset into edit fields
    if (epn[0] != '>')
	sprintf (epntext, "%s|%s", epn, RedStrings[dbreduc]);
    else
	sprintf (epntext, "%s|%s", &epn[1], RedStrings[dbreduc]);
    defSpecText->SetText ((unsigned char *)epntext);

    dateText->SetText ((unsigned char *)date);
    offsetText->SetText ((unsigned char *)off);
    reducType->SetSelection (reducType->GetItemAt (reduc));
    dspLoText->SetTextScribed (vnum::ScribeFloat(dl));
    dspHiText->SetTextScribed (vnum::ScribeFloat(dh));
    timeToggle->SetValue (epn[0] == '>');
    ctlLoText->SetTextScribed (vnum::ScribeFloat(cl));
    ctlHiText->SetTextScribed (vnum::ScribeFloat(ch));
}

/*********
 *  TrendEditDialog::AddClick (int which)
 *
 *  The procedure gets called whenever the add button is clicked 
 *
 **********/
void TrendEditDialog::AddClick (void)
{
    char epn [C_PTNMLEN];
    int  dbreduc, reduc;
    char date [40];
    char off [40];
    double dl, dh, cl, ch;
    int	    ix;
    int	    row;
    int	    column;
    char    tempstring[132];
    char    textstring[132];
    char    *cp;
    char    *endptr;

    //recover dbreduc from point name entry
    defSpecText->GetText ((unsigned char *)tempstring, sizeof(tempstring));
    dbreduc = 0;
    if ((endptr = strchr (tempstring, '|')) != NULL)
    {
        *endptr++ = 0;
        for (ix = 0; (ix < C_NEWRADIOBUTTONS) && (strcmp (RedStrings[ix], endptr) != 0); ix++)
            /* all the work is done in the for statement */ ;
        if (ix < C_NEWRADIOBUTTONS)
            dbreduc = ix;
        else
            dbreduc = 0;
    }

    // trim leading blanks
    for (cp = tempstring; *cp == 0x20; cp++);
    // check for composite point spec (leading #)
    strncpy (epn, cp, C_PTNMLEN);
    if (epn[0] == '#')
    {
        for (cp = epn; *cp; cp++)
        {
            if (*cp == '#')
            {
                cp++;
                if (isdigit (*cp))
                {
                    if ((*cp -'0') > workset.numTrends)
                    {
                        infoNotice (this, (unsigned char *)"Specification error", (unsigned char *)"Undefined reference in composite spec");
                        epn [0] = 0;
                        break;
                    }
                }
                else
                {
                    infoNotice (this, (unsigned char *)"Specification error", (unsigned char *)"Illegal composite spec");
                    epn [0] = 0;
                    break;
                }
            }
            else if ((*cp != ' ') && (*cp != '+') && (*cp != '-'))
            {
                infoNotice (this, (unsigned char *)"Specification error", (unsigned char *)"Illegal character in composite spec");
                epn [0] = 0;
                break;
            }
        }                
    }
    else
    {
	/* be sure the name is expandable (use temporary space) */
	if (ResolveName (textstring, tempstring, sizeof(textstring)) == NULL)
	{
	    if (macroDialog->Alert ("Required Macro Substitution", tempstring) == RESULT_CANCEL)
		epn[0] = 0;
	}
        if (epn[0] == '>')
        {
            infoNotice (this, (unsigned char *)"Specification error", (unsigned char *)"Character '>' is reserved in TrendVu");
            epn [0] = 0;
        }
        else if (epn[0])
        {
            if (timeToggle->GetValue ())
            {
                epn[0] = '>';
                strncpy (&epn[1], cp, C_PTNMLEN-1);
            }
            if (!CheckReduc (epn, RedStrings[dbreduc]))
            {
	        // ask for save permission, and save text if entered
	        if (!cautionNotice (this, (unsigned char *)"Point not scheduled for trend!",
	                            (unsigned char *)"Save specification anyway?"))
		{
		    /* If he doesn't accept the warning we will discard the point. */
		    epn [0] = 0;
		}
            }
        }
    }
    if (epn [0])
    {
        reduc = reducType->GetItemIndex (reducType->GetSelection());
	dateText->GetText ((unsigned char *)date, sizeof(date));
	offsetText->GetText ((unsigned char *)off, sizeof(off));
	dl = dspLoText->GetTextAsFloat ();
	dh = dspHiText->GetTextAsFloat ();
	cl = ctlLoText->GetTextAsFloat ();
	ch = ctlHiText->GetTextAsFloat ();

        // clear any other time selects
        if (epn[0] == '>')
        {
            for (ix = 0; ix < workset.numTrends; ix++)
            {
                if (workset.specs[ix][0] == '>')
                {
                    strcpy (workset.specs[ix], &workset.specs[ix][1]);
                }
            }
        }
	vliststr *ptListData = (vliststr *)itemList->GetList();
	ptListData->GetSelectedCell(itemList->GetSelection(), &row, &column);
	if (row == vlistNO_CELLS_SELECTED)
	{
	    if (workset.numTrends < C_TRENDPTS)
		row = workset.numTrends++;
	    else
		// no room for more, ignore him
	        return;
	}
	MakeTSpec (workset.specs [row], epn, dbreduc, reduc,
		   date, off, dl, dh, cl, ch);
	/* delete and redisplay list */
	if (itemList->GetList ())
	    delete itemList->GetList ();
	itemList->SetList (NULL);

	vliststr *listdata = new vliststr;
	for (ix = 0; ix < workset.numTrends; ix++)
	{
	    trimblanks (workset.specs[ix]);
	    if (workset.specs[ix][0])
	    {
		sprintf (tempstring, "%1d) %s", ix+1, workset.specs[ix]);
		listdata->SetCellValueScribed (ix, 0,
			    vscribe::ScribeMulti (vnum::ScribeInt (ix), 
						  vcharScribeLiteral (") "),
						  vcharScribeSystem (workset.specs[ix]),
						  NULL)); // marks the end of the scribe
	    }
	}
	itemList->SetList (listdata);
    }
}

/*********
 *  TrendEditDialog::DeleteClick (int which)
 *
 *  The procedure gets called whenever the delete button is clicked 
 *
 **********/
void TrendEditDialog::DeleteClick (void)
{
    int	    ix;
    int	    row;
    int	    column;
    char    tempstring[132];

    vliststr *ptListData = (vliststr *)itemList->GetList();
    ptListData->GetSelectedCell(itemList->GetSelection(), &row, &column);
    if ((row != vlistNO_CELLS_SELECTED) || (workset.numTrends))
    {
	workset.numTrends--;
	// move all tspecs down over deleted item.
	for (ix = row; ix < workset.numTrends; ix++)
	    strcpy (workset.specs[ix], workset.specs[ix+1]);

	// clear used tspec to nullstring
	*workset.specs[ix] = 0;
	vliststr *listdata = (vliststr *)itemList -> GetList();
	if (listdata) 
	    listdata->Destroy();
	listdata = new vliststr;
	for (ix = 0; ix < workset.numTrends; ix++)
	{
	    trimblanks (workset.specs[ix]);
	    if (workset.specs[ix][0])
	    {
		sprintf (tempstring, "%1d) %s", ix+1, workset.specs[ix]);
		listdata->SetCellValueScribed (ix, 0,
			    vscribe::ScribeMulti (vnum::ScribeInt (ix), 
						  vcharScribeLiteral (") "),
						  vcharScribeSystem (workset.specs[ix]),
						  NULL)); // marks the end of the scribe
	    }
	}
	itemList->SetList (listdata);
    }
    else
    {
	/* delete with no trends or no selection */
    }
}

/*********
 *  TrendEditDialog::AcceptClick()
 *
 *  The procedure gets called whenever the accept button is clicked 
 *
 **********/
void TrendEditDialog::AcceptClick ()
{
    char    text[80];

    result = RESULT_OK;
    // get trend set values and store them (abort if unaccepted overwrite! 
    descText->GetText ((unsigned char *)workset.setname, sizeof(workset.setname));
    workset.setname[C_TRENDDESCLEN-1] = 0;
    trimblanks (workset.setname);
    if (workset.setname[0])
    {
	durText->GetText((unsigned char *)text, sizeof(text));
        if (durType->GetItemIndex (durType->GetSelection()))
        {
            workset.zoom = atoi(text);
        }
        else
        {
            workset.zoom = (SpanVal(text) + 511L)/512L;
        }
        workset.autoupdate = autoToggle->GetValue();
        if (!PutTrendInfo (workset.setname, workset.zoom, workset.autoupdate, workset.specs, FALSE))
        {
 	    // ask for save permission, and save text if entered
	    if (cautionNotice (this, (unsigned char *)"Duplicate Trend",
	                        (unsigned char *)"Trend already defined. Replace it?"))
	    {
                if (!PutTrendInfo (workset.setname, workset.zoom, workset.autoupdate, workset.specs, TRUE))
                {
                    infoNotice (this, (unsigned char *)"Database error",
			    (unsigned char *)"Trend save failed.");
                    return;
                }
            }
            else
            {
                return;
            }
        }
    }
    else
    {
        infoNotice (this, (unsigned char *)"Specification error",
		(unsigned char *)"Must enter descriptor name.");
	return;
    }
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();

	if (itemList->GetList ())
	    delete itemList->GetList ();
	itemList->SetList (NULL);
    }
}

/*********
 *  TrendEditDialog::BrowseClick()
 *
 *  The procedure gets called whenever the browse button is clicked 
 *
 **********/
void TrendEditDialog::BrowseClick ()
{
    int ix;
    int cnt;
    char **pvnames;
    char epn [C_PTNMLEN + 5];
    char *reducptr;
    int  dbreduc;
    double displo;
    double disphi;

    pvnames = GetReducs (&cnt);
    // bring up browse version of list dialog, etc...
    if (cnt && listDialog->Alert ("Browse Points", pvnames) == RESULT_OK)
    {
	// verify point, put into proper fields
	strncpy (epn, listDialog->ResultString(), sizeof(epn));
	dbreduc = 0;
	if ((reducptr = strchr (epn, '|')) != NULL)
	{
	    *reducptr++ = 0;
	    for (ix = 0; (ix < C_NEWRADIOBUTTONS) && (strcmp (RedStrings[ix], reducptr) != 0); ix++)
		/* all the work is done in the for statement */ ;
	    if (ix < C_NEWRADIOBUTTONS)
		dbreduc = ix;
	    else
		dbreduc = 0;
	}

        if (CheckReduc (epn, RedStrings[dbreduc])
	  || (cautionNotice (this, (unsigned char *)"Point not scheduled for trend!",
	                        (unsigned char *)"Save specification anyway?")))
	{
	    defSpecText->SetText ((unsigned char *)listDialog->ResultString());
	    dateText->SetText ((unsigned char *)"");
	    offsetText->SetText ((unsigned char *)"");
	    reducType->SetSelection (reducType->GetItemAt (dbreduc));
	    if (GetRecParams (epn, dbreduc, 0, &displo, &disphi))
	    {
		dspLoText->SetTextScribed (vnum::ScribeFloat(displo));
		dspHiText->SetTextScribed (vnum::ScribeFloat(disphi));
		ctlLoText->SetTextScribed (vnum::ScribeFloat(displo));
		ctlHiText->SetTextScribed (vnum::ScribeFloat(disphi));
	    }
	    else
	    {
		dspLoText->SetTextScribed (vnum::ScribeFloat(0.0));
		dspHiText->SetTextScribed (vnum::ScribeFloat(1000.0));
		ctlLoText->SetTextScribed (vnum::ScribeFloat(0.0));
		ctlHiText->SetTextScribed (vnum::ScribeFloat(1000.0));
	    }
	    timeToggle->SetValue (0);
	}
    }

    for (ix = 0; ix < cnt; ix++)
	free (pvnames[ix]);
    free (pvnames);
}

/*********
 *  TrendEditDialog::CancelClick()
 *
 *  The procedure gets called whenever the cancel button is clicked 
 *
 **********/
void TrendEditDialog::CancelClick ()
{
    result = RESULT_CANCEL;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();

	if (itemList->GetList ())
	    delete itemList->GetList ();
	itemList->SetList (NULL);
    }
}

int TrendEditDialog::Alert (TrendSet *trendSet)
{
    vliststr   *newlist;
    int	    ix;
    char    tempstring [80];
    char    *lineID [8] = {"1) ", "2) ", "3) ", "4) ", "5) ", "6) ", "7) ", "8) "};

    if (itemList->GetList ())
	delete itemList->GetList ();
    itemList->SetList (NULL);

    // place all values into fields
    if (trendSet == NULL)
    {
	// init a blank trendset
	strcpy (workset.setname, "");
	workset.autoupdate = 0;
	workset.zoom = 60;
	workset.numTrends = 0;
    }
    else
    {
	workset = *trendSet;
    }
    descText->SetText ((unsigned char *)workset.setname);

    durText->SetText ((unsigned char *)StrSpan (workset.zoom*512L, tempstring));
    curtype = 0;
    durType->SetSelection (durType->GetItemAt (curtype));
    autoToggle->SetValue (workset.autoupdate);
    defSpecText->SetText ((unsigned char *)"");
    dateText->SetText ((unsigned char *)"");
    offsetText->SetText ((unsigned char *)"");
    reducType->SetSelection (reducType->GetItemAt (0));
    dspLoText->SetText ((unsigned char *)"");
    dspHiText->SetText ((unsigned char *)"");
    timeToggle->SetValue (0);
    ctlLoText->SetText ((unsigned char *)"");
    // place items into list box
    newlist = new vliststr;
    for (ix = 0; ix < workset.numTrends; ix++)
    {
        trimblanks (workset.specs[ix]);
        if (workset.specs[ix][0])
        {
            sprintf (tempstring, "%1d) %s", ix+1, workset.specs[ix]);
            newlist->SetCellValueScribed (ix, 0,
			vscribe::ScribeMulti (vnum::ScribeInt (ix), 
					      vcharScribeLiteral (") "),
					      vcharScribeSystem (workset.specs[ix]),
					      NULL)); // marks the end of the scribe
//	    newlist->SetCellValue((ix, 0, lineID[ix]);
//          newlist->SetCellValue(ix, 1, workset.specs[ix]);
        }
    }
    itemList->SetList (newlist);

    result = RESULT_CANCEL;

    // Pop it up and handle events
    Open ();
    MakeTopMostDialog (this, NULL);
    // process events
    vevent::Process();

    // return answer
    return result;
}
