/* trendlimitlist.cxx,v 1.1.1.1 1999/08/03 14:45:10 tis4000 Exp
 *
 */

/*
 * TrendLimitList - trend graph container class
 */

#include <vport.h>		/* for v*HEADER */
#include vstdlibHEADER		/* for random, exit, EXIT_SUCCESS */
#include vlistHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vstartupHEADER
#include vmemHEADER
#include vprefHEADER
#include vtextitemHEADER
#include vcharHEADER
#include vnumHEADER

#ifdef WIN32
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#endif WIN32

extern "C"
{
    #include "trendutils.h"
}
#include "trenddocs.h"
#include "trendlimitlist.h"

// macro definitions for vkindtyped overrides

vkindTYPED_FULL_DEFINITION(TrendLimitList, vlistview, NULL);

// vloadable
void TrendLimitList::LoadInit(vresource resource)
{
    vlistview::LoadInit(resource);
    trendSet = NULL;
    vgrey.SetRGB ((192 * vcolorCOMPONENT_MAX)/256,
		  (192 * vcolorCOMPONENT_MAX)/256,
		  (192 * vcolorCOMPONENT_MAX)/256);
    greyColor = vcolor::Intern (&vgrey);
}

/*
 * TrendLimitList::Destroy
 *
 * Deletes the list
 */
void TrendLimitList::Destroy()
{
    // Destroy list
    delete GetList();  // !!! Same as vdialogItem::itemList ??

    vlistview::Destroy();
}

/*
 * TrendLimitList::DrawCellContents
 *
 * Draw resource entry in list cell
 */
void TrendLimitList::DrawCellContents(int row, int col, 
				      int selected, vrect *cellRect)
{
    char    ptstring [20];

    if ((trendSet == NULL) || (trendSet->numTrends <= row))
	return;

    vdrawGSave();
    vdrawRectsClip(cellRect, 1);

    vrect temp = *cellRect;
    temp.SetX(temp.GetX() + 3);
    temp.SetWidth(temp.GetWidth() - 3);
    vdrawRectClip(temp.GetX(), temp.GetY(), temp.GetWidth(), temp.GetHeight());
    // show buttons and text in proper colors
    if (trendSet->trends[row].enable)
    {
	vdrawSetColor(fgColors[row]);
    }
    else
    {
	vdrawSetColor (greyColor);
    }

    if (selected)
    {
	vdraw::SetFunction(vdrawFUNC_INVERT);
    }
    // this shows the text
    if (type == CTL_HILIMIT)
	sprintf (ptstring, "%9s", trendSet->trends[row].PointHiLim ());
    else
	sprintf (ptstring, "%9s", trendSet->trends[row].PointLoLim ());
    vdrawRectShowCenterY ((unsigned char *)ptstring, &temp);

    vdrawGRestore();
}

void TrendLimitList::SetPrefs (vcolorSpec fgColorSpec[C_TRENDPTS], vcolorSpec bgColorSpec)
{
    int i;

    // convert to vcolor and store
    for (i = 0; i < 8; i++)
    {
	fgColors[i] = vcolor::Intern (&fgColorSpec [i]);
    }
    bgColor = vcolor::Intern (&bgColorSpec);
    Inval (0);
}

/*
 * TrendLimitList::ObserveSelect
 *
 */
void TrendLimitList::ObserveSelect(int state)
{
    int row;
    int col;
    vlist *list = GetList();

    list->GetSelectedCell(GetSelection (), &row, &col);
    if (row == vlistNO_CELLS_SELECTED)
    {
	return;
    }

    if (state == vlistviewSELECTION_HAS_CHANGED)
    {
	NewLimit (type, row);
    }
}

void TrendLimitList::NewLimit (int id, int row) // override with change callback!
{
    // User code should adjust document for new value
}

void TrendLimitList::SetTrendSet (TrendSet *set)
{
    vliststr	*newlist;
    int		ix;

    trendSet = set;
    if ((GetList ()) != NULL)
    {
	delete GetList ();
	SetList (NULL);
    }
    newlist = new vliststr;
    for (ix = 0; ix < trendSet->numTrends; ix++)
    {
        trimblanks (trendSet->specs[ix]);
        if (trendSet->specs[ix][0])
        {
            newlist->SetCellValueScribed (ix, 0, vcharScribeSystem (trendSet->specs[ix]));
        }
    }
    SetList (newlist);
}
