/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*********************************************************************************
  launch_type

  input  :   pointname
	     [macro_replacement_string]

  given a pointname, get the points type, then execute the dm command with the 
  graphic name specified as
       
       <pointtype>.dl "V=<pointname>,[macro_replacement_string]".

********************************************************************************/
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#ifdef WIN32
#include <process.h>
#endif WIN32
#include <errno.h>
#include "msgMon.h"
#include "resolveLinks.h"

#define    TYPE_SZ         15

/*---------*/
int main (int argc, char *argv[])

    {
	D4DATA	*pvmap;
	F4FIELD	*nameFld, *typeFld;
	C4CODE	cb;
	char	type [TYPE_SZ+1], key [50];
	int	i;
	char	dbname[300], parms [100], command [100];

	if (argc < 2) {
	    tisSysLog (0, 2, "launchtype: Wrong number of arguments!");
	    exit (-1);
	}

	d4init(&cb);
#if defined(WIN32) || defined(USECB63)
	cb.errOpen = 0;
#else
	cb.open_error = 0;
#endif WIN32

	/* Open pvmap and the name field */

#ifdef WIN32
	resolveLinks ("\\tis4000db\\pvmap.dbf", dbname);
#else
	resolveLinks ("/tis4000db/pvmap.dbf", dbname);
#endif WIN32
	if ((pvmap = d4open(&cb, dbname)) == NULL) {
	    tisSysLog (0, 2, "launchtype: Unable to open pvmap!");
	    exit(-1);
	}
	d4tag_select (pvmap, d4tag(pvmap, "NAME"));
	d4top (pvmap);
	nameFld = d4field (pvmap, "NAME");
	typeFld = d4field (pvmap, "TYPE");

	/* Lookup the pv name */

	sprintf (key, "%-*s", f4len (nameFld), argv [1]);
	if (d4seek (pvmap, key) != 0) {
	    tisSysLog (0, 2, "launchtype: Display not found - %s", argv [1]);
	   exit (-1);
	}    

	/* Get the field type */

	strcpy (type, f4str(typeFld)); 
	for (i=0; i<TYPE_SZ && type[i] != ' '; i++);
	if (i <= TYPE_SZ) type[i] = '\0';

	/* If another parameter is present then just pass them along to dm */

	if (argc > 2)
	    sprintf (parms, "V=%s,%s", argv[1], argv[2]);
	else
	    sprintf (parms, "V=%s", argv[1]);
       
	/* Build the command line and execute it */

#ifdef WIN32
	sprintf (command, "%s.dl", type);
	_spawnl (_P_DETACH, "\\tis4000\\tasks/dm", "\\tis4000\\tasks/dm", command, parms, NULL);
#else
	sprintf (command, "/tis4000/tasks/dm %s.dl %s &",
			type, parms);
	system (command);
#endif WIN32

	return (0);
    }

