/*drvBailey.c,v 1.1.1.1 1999/08/03 14:41:53 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File:  drvBailey.c
**  Edit:  03/20/95     WEP: Created
**                         :
**         09/21/95     WEP: added CS mode output MBBO.
**         09/25/95     WEP: added line info diagnostic 'baileyline'
**
**	This file contains the data structures used by the Bailey CIU
**	I/O driver.                                                            	       	
**                                                                             	      	
*/

#define  MAIN           bailey_driver           /* NOTE: change here */
#define  AIDRIVER       bailey_aidriver         /* NOTE: change here */
#define  AODRIVER       bailey_aodriver         /* NOTE: change here */
#define  AOREAD         bailey_aoread           /* NOTE: change here */
#define  BIDRIVER       bailey_bidriver         /* NOTE: change here */
#define  BODRIVER       bailey_bodriver         /* NOTE: change here */
#define  BOREAD         bailey_boread           /* NOTE: change here */

#define  TRAFFICON      baileytrafficon         /* NOTE: change here */
#define  TRAFFICOFF     baileytrafficoff        /* NOTE: change here */
#define  TRAFFIC        baileytraffic           /* NOTE: change here */
#define  TRACEON        baileytraceon           /* NOTE: change here */
#define  TRACEOFF       baileytraceoff          /* NOTE: change here */
#define  RTRACE         baileyrestrlv           /* NOTE: change here */
#define  RTRACEON       baileyrestraceon        /* NOTE: change here */
#define  RTRACEOFF      baileyrestraceoff       /* NOTE: change here */
#define  TRACELEVEL     baileytrlv              /* NOTE: change here */
#define  CONTRACEON     baileycontraceon        /* NOTE: change here */
#define  CONTRACEOFF    baileycontraceoff       /* NOTE: change here */
#define  RUNTRACEON     baileyruntraceon        /* NOTE: change here */
#define  RUNTRACEOFF    baileyruntraceoff       /* NOTE: change here */
#define  REJECTTRACEON  baileyrejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF baileyrejecttraceoff    /* NOTE: change here */

#define  OKTRACEON      baileyoktraceon         /* NOTE: change here */
#define  OKTRACEOFF     baileyoktraceoff        /* NOTE: change here */
#define  STATETRACEON   baileystatetraceon      /* NOTE: change here */
#define  STATETRACEOFF  baileystatetraceoff     /* NOTE: change here */

#define  ERRTRACEON     baileyerrtraceon        /* NOTE: change here */
#define  ERRTRACEOFF    baileyerrtraceoff       /* NOTE: change here */
#define  CONFTRACEON    baileyconftraceon       /* NOTE: change here */
#define  CONFTRACEOFF   baileyconftraceoff      /* NOTE: change here */

#define  HUHTRACEON     baileyhuhtraceon        /* NOTE: change here */
#define  HUHTRACEOFF    baileyhuhtraceoff       /* NOTE: change here */

#define  DEFAULTTRACE   baileydefaulttrace      /* NOTE: change here */

#define  HELP           baileyhelp              /* NOTE: change here */
#define  SIMON          baileysimon             /* NOTE: change here */
#define  SIMOFF         baileysimoff            /* NOTE: change here */

#define  STOPDRIVER     stopbailey              /* NOTE: change here */
#define  STARTDRIVER    startbailey             /* NOTE: change here */
#define  SETCOMM        baileycomm              /* NOTE: change here */

#define  DUMPMSGCNTS    baileydumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   baileyclearmsgcnts      /* NOTE: change here */
#define  DUMPLINESTATS  baileydumplinestats     /* NOTE: change here */
#define  CLEARLINESTATS baileyclearlinestats    /* NOTE: change here */

#define  CIUSTATS       baileyciustats          /* NOTE: change here */
#define  LOOPSTATS      baileyloopstats         /* NOTE: change here */
#define  PCUSTATS       baileypcustats          /* NOTE: change here */
#define  MODULESTATS    baileymodulestats       /* NOTE: change here */

#define  CIUINFO        baileyciu               /* NOTE: change here */
#define  LOOPINFO       baileyloop              /* NOTE: change here */
#define  PCUINFO        baileypcu               /* NOTE: change here */
#define  MODULEINFO     baileymodule            /* NOTE: change here */
#define  ALLINFO        baileyall               /* NOTE: change here */
#define  CIUTREE        baileytree              /* NOTE: change here */
#define  LINEINFO       baileyline              /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvBailey.h>                  /* NOTE: change here */
#include <drvBailey_proto.h>            /* NOTE: change here */
#include <restable.h>


/* static long	init(); */
struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvBailey={ 2,	NULL, init};    /* NOTE: change here */

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
extern	unsigned char	resnames [NUMLINES] [RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE	*prestable [NUMLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [NUMLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	modtrace [NUMLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace [NUMLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace [NUMLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [NUMLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [NUMLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay [NUMLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay [NUMLINES];		/* holds post TX delay before dropping RTS. 	*/

extern  SEM_ID		linemux [NUMLINES];		/* 1/03/94: mutual-exclusion semaphore for	*/
							/* shared resource of the data link 		*/
							/* controls access to common path shared by	*/
							/* data and diagnostic channels. 		*/
							/* originally designed for use with MDS remote	*/
							/* radio diagnostics. 				*/

extern  unsigned short  halfduplex [NUMLINES];          /* store half/full duplex line status           */

extern  unsigned short  pstatewait [NUMLINES];          /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */
/*
**      Storage for Host-CIU Comm Line Structures
**
*/
static RXLINE          *rxlinetab [NUMLINES] = NULL;    /* array of pointers to dynamically           */
                                                        /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [NUMLINES] = NULL;    /* array of pointers to dynamically           */
                                                        /* allocated comm controls/buffers            */

/*
**      Storage for Bailey CIU Structures
**
*/
static unsigned int     baileysim [NUMLINES];           /* 0 = normal operation, 1 = CIU simulation.  */

static unsigned int	simdelay [NUMLINES];

static 		int	simlow [NUMLINES];

static 		int	simhigh [NUMLINES];

static		int	simdigon [NUMLINES];

static unsigned int     tick [NUMLINES][5];

static unsigned int     lastscan [NUMLINES];            /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [NUMLINES];            /* holds actual time taken to scan the CIU.     */

static unsigned int     loopoutmsgs [NUMLINES];

static unsigned int     loopmsgs [NUMLINES];

static LINESTATS	linestats [NUMLINES];		/* array of line level statistics.              */

static CIUALLOC	        *ciu [NUMLINES];                /* top structure for a multiple-linked sequence */
                                                        /* of pointers ultimately reaching to the       */
                                                        /* dynamically allocated module and block data  */
                                                        /* structures.                                  */

static	unsigned short	trace [NUMLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   tracetype [NUMLINES];
static  unsigned char   traceflag [NUMLINES];

static OUTPUTQUE	*oq [NUMLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static unsigned long	nextouttime [NUMLINES];

static unsigned long	outagain [NUMLINES];

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */

static unsigned long    activity_tick[NUMLINES];        /* holds timetick of RX interrupt. used to set  */
                                                        /* recent_activity flag.                        */
static unsigned long    recent_activity[NUMLINES];      /* flag indicating recent RX comm activity.     */

static unsigned long    activity_state[NUMLINES];      /* flag indicating MAIN loop activity state.     */


static  unsigned short  options [NUMLINES];             /* store half/full duplex line status           */

static char    *bools [] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [NUMLINES];
static short        watchdogId [NUMLINES];

/* used to control max number of tasks spawned. */
static short copies;
     

static char *tasknames [] = { "BAILEY_0","BAILEY_1","BAILEY_2","BAILEY_3",
                              "BAILEY_4","BAILEY_5","BAILEY_6","BAILEY_7",
                              "BAILEY_8","BAILEY_9","BAILEY_10","BAILEY_11",
                              "BAILEY_12","BAILEY_13","BAILEY 14",
                              "BAILEY_15","BAILEY_16","BAILEY 17",
                              "BAILEY_18","BAILEY_19","BAILEY 20",
                              "MAIN"
                            };
/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf ("Starting and Stopping the Bailey Host-CIU Driver:\n");
    printf ("\n");
    printf (" startbailey(N,C,t1,f,t2,t3)                                                    \n");
    printf ("                     N:  start the driver on line N.                            \n");
    printf ("                     C:  communications parameter string (comma delimited ascii)\n"); 
    printf ("                     t1: intermessage delay (in ticks)                          \n");
    printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex   \n");
    printf ("                     t2: post RTS assert, pre TX delay (in ticks)               \n");
    printf ("                     t3: post TX, pre RTS drop delay (in ticks)                 \n");
    printf ("                                                                                \n");
    printf (" Example: startbailey(2,\"9600,N,8,1\", 2,1,4,0)                                \n");
    printf ("                                                                                \n");
    printf (" stopbailey(N)                                                                  \n");
    printf ("                     N = line number                                            \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Bailey Host-CIU Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" baileytraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                            1) Major Scan loop Info:                                  \n");
    printf ("                              scan time, total output messages, and total messages.   \n"); 
    printf ("                            2) Output Queue Overflow.                                 \n");
    printf ("                            3) All communication errors encountered in msgxfer.       \n");
    printf ("*baileytraceoff(N)        Disable all of the baileytraceon debug messages for line N. \n");
    printf ("\n");
    printf (" baileyrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*baileyrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" baileyrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" baileycontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*baileycontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" baileyruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*baileyruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" baileyrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*baileyrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" baileynacktraceon(N)     Enable display of point deselection on command rejection.   \n");
    printf ("*baileynacktraceoff(N)    Disable display of point deselection on command rejection.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" baileytrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                            X=0,  display none of the messages below.               \n");
    printf ("                            X=1,  beginning of scan loop, bringing CIU online.      \n");
    printf ("                            X=2,  beginning of scan.                                \n");
    printf ("                            X=3,  AO queue actions (normal: AODRIVER & checkoutputs)\n");
    printf ("                            X=4,  BO queue actions (normal: BODRIVER & checkoutputs)\n");
    printf ("                            X=5 & 6, reserved.                                      \n");
    printf ("                            X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                            X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                            X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                            X=10 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" baileytrafficon(N)       Enable traffic tracing for all addresses                    \n");
    printf ("                           and all baileybus functions on line N.                     \n");
    printf ("*baileytrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" baileytraffic(N,X)       Modifies line N traffic tracing as follows:                 \n");
    printf ("                           X=0   disables tracing of all commands.                    \n");
    printf ("                           X=255 enables tracing of all commands.                     \n");
    printf ("                           0 < X < 255 enables tracing of command X traffic.          \n");
    printf ("\n");
    printf (" baileydefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

/*    printf (" baileysimon(N,D,L,H,T)   Enables the simulation of a responding CIU.                 \n");
    printf ("                           D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                           L: low value of analog simulation range.                   \n");
    printf ("                           H: high value of analog simulation range.                  \n");
    printf ("                           T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*baileysimoff(N)          Disables simulation, thus enabling normal driver function.  \n");
    printf ("\n");

    taskDelay (1 * 60); ** Time for operator to see it and pause the output */

    printf (" baileycomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                            t1: intermessage delay (in ticks).                        \n");
    printf ("                             f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                            t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                            t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" baileydumpmsgcnts(N)      Display line N communication statistics.                   \n");
    printf (" baileyclearmsgcnts(N)     Display and clear line N communication statistics.         \n");
    printf (" baileydumplinestats(N)    Display line N communication statistics.                   \n");
    printf (" baileyclearlinestats(N)   Display and clear line N xfers, status & errors.           \n");
    printf (" baileydumpmodule(N)       Display line N xfers, status, errors and input data.       \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" baileyciustats(N)         Display line N CIU reply statistics.                       \n");
    printf (" baileymodulestats(N,X,Y,Z) Display line N CIU stats for the specified module:        \n");
    printf ("                             X: Loop number of module.                                \n");
    printf ("                             Y: PCU number of module.                                 \n");
    printf ("                             Z: Module number of module.                              \n");
    printf (" baileyciu(N)              Display line N status and values for the CIU.              \n");
    printf (" baileymodule(N,X,Y,Z)     Display line N status and values for specified module:     \n");
    printf ("                             X: Loop number of module.                                \n");
    printf ("                             Y: PCU number of module.                                 \n");
    printf ("                             Z: Module number of module.                              \n");
    printf (" baileytree(N)             Display line N CIU/Loop/PCU/Modlue/Block allocation tree.  \n");
    printf (" baileyline                Display status info for all lines running Bailey drivers.  \n");
}

#include <ctype.h>
/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned short type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/

void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        tracetype [line] = 255; /* every message type */
}

void baileytraffic08 (unsigned short line)
{
	trace [line] = trace [line] | CIU08TRAFFIC;
}
void baileytraffic22 (unsigned short line)
{
	trace [line] = trace [line] | CIU22TRAFFIC;
}
void baileytraffic53 (unsigned short line)
{
	trace [line] = trace [line] | CIU53TRAFFIC;
}
/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] &
                      ~ALLTRAFFICTRACE &
                      ~CIU08TRAFFIC &
                      ~CIU22TRAFFIC &
                      ~CIU53TRAFFIC;
        tracetype [line] = 0;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	This routine enables the simulation of a responding CIU, reading all input values as zero.
**
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	baileysim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
**
**	This routine disables simulation, thus enabling normal driver function.
**
********/
void SIMOFF (unsigned short line)
{
	baileysim [line] = FALSE;
}

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
**
**	These routines enable and disable tracing of 'ok' responses to CIU commands
**
********/
void OKTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CIUOKTRACE;
    }
void OKTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CIUOKTRACE;
    }

/********
**
**	These routines enable and disable tracing of 'normal' responses to CIU commands
**
********/
void STATETRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CIUSTATETRACE;
    }
void STATETRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CIUSTATETRACE;
    }

/********
**
**	These routines enable and disable tracing of 'runtime error' responses to CIU commands
**
********/
void ERRTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CIUERRORTRACE;
    }
void ERRTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CIUERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of 'configuration error' responses to CIU commands
**
********/
void CONFTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CIUCONFIGTRACE;
    }
void CONFTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CIUCONFIGTRACE;
    }

/********
**
**	These routines enable and disable tracing of 'unknown' responses to CIU commands
**
********/
void HUHTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CIUUNKNOWNTRACE;
    }
void HUHTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CIUUNKNOWNTRACE;
    }


/********
**
**	This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        tracetype [line] = 255; /* every message type */
    }
/********
**
**	This routine turns on all error tracing.
**
********/
void baileyerrortrace (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	modrestrace [line] = 2;
	trace[line] = CONFIGURATIONTRACE |
                      RUNTIMEERRORTRACE |
                      CALLREJECTTRACE |
                      CIUSTATETRACE |
                      CIUERRORTRACE |
                      CIUCONFIGTRACE |
                      CIUUNKNOWNTRACE |
                      0;
        tracetype [line] = 255; /* every message type */
}

void smokin (unsigned line)
{
    baileyerrortrace (line);
    baileytraffic08 (line);
    baileytraffic22 (line);
    baileytraffic53 (line);
}


int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId[ln])
            {
                tisWatchDogDetach(taskId[ln]);
            }
	    taskDelete (taskId [ln]);
            copies--;
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,       /* the line number of this driver.                      */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2)    /* half duplex post TX, pre RTS drop delay.             */

{
        if (copies >= MAXLINES)
	{

	    logMsg ("Maximum number of Bailey driver tasks (%d) are already running.\n", copies);
	    return (-1);
	}

	if (line < NUMLINES)
	{
            copies++;
	    taskId [line] = taskSpawn (tasknames [line],
                                     BAILEY_PRIORITY,
                                     BAILEY_TASK_OPTIONS,
                                     BAILEY_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2);

	    logMsg ("Started the BAILEY Host-CIU driver on line %d\n",line);

	    remCurIdGet (user, password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}


/*                                                                                         
**      bailey_driver                                                                      
**                                                                                         
**      The purpose of this task is to read exception reports from the PCUs in the Bailey  
**      INFI-90 System via the Host-CIU interface. It will dynamically build and maintain  
**      a configuration list supporting online additions and replacement of modules, and   
**      maintain a table of most recently scanned values.                                  
**                                                                                         
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2)
{
    unsigned short  pstate, lstate, execute, command,i;
    long            this_time, last_time;
    CIUALLOC        *pciu;
    RXLINE          *rxp;
    unsigned int    temptick, tempdiff;
    int             temp;

    short  *ptable_id;

    /* Initialize the data structures */
    intermsgdelay [line] = delay;

    halfduplex [line]  = hdflag;
    pretxdelay [line]  = delay1;
    posttxdelay [line] = delay2;

    resresponse [line] = FALSE;
    resnames [line] [0] = 0;
    prestable [line] = NULL;

    activity_tick[line] = 0; /* forces 'recent_activity' test result to FALSE until first RX int. */
    recent_activity[line] = FALSE;

    nextouttime [line] = 0;
    outagain [line] = 0;

    pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

    /* initialize debug structures */
    DEFAULTTRACE (line);
    /* initialize debug structures */

    tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].msgxfercount = 0;
    linestats [line].startingtick = tickGet ();

    baileysim [line] = FALSE;              /* start with normal operation. */

    /* output queue initialization */
    oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
    if (!oq [line])
    {
        logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
        return;
    }
    outqueinit (line);

    /* communication initialization */
    rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
    if (!rxlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
        return;
    }
    txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
    if (!txlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
         return;
    }

    taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
    comm_init (line, mode, &tx_int_proc, &rx_int_proc);
    clear_rts (line);
    taskUnlock ();

    /* Initialize the Rx interrupts to receive once for activity check         */
    /* enable the receiver interrupt after set to ignore                       */
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    enable_rx_ints (line);

/*                                                                                                      
**         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put 
**         logic implemented below is designed to insure, under heavy diagnostic demand, that the       
**         scan_ciu and the on_line routine are executed once for every two diagnostic Take/Put         
**         sequences. Furthermore, diagnostic activities are suspended during master/slave arbitration  
**         by Taking the semaphore while the local state is not the master state.                       
**                                                                                                      
*/   
    taskLock ();
    linemux [line] = semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',    */
                                                      /* ready to be Taken.                           */
    if (!linemux [line])
    {
        logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
        taskUnlock ();
        return;
    }
    if ((semTake (linemux [line], MUXTIMEOUT)) == ERROR)
    {
        logMsg ("Bailey: Mutual-Exclusion Semaphore Timeout on Line\n",line);
        taskDelay(300);
    }
    taskUnlock ();
    taskDelay (120);/* short delay for diagnostic readability */

    /* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
    while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
    {
        if (modrestrace [line] > 1)
        {
            logMsg ( "No Resource Defined for line - %d \n", line);
        }
        taskDelay (600);
    }

    /* attach this driver task to the watchdog timer monitoring function. */
    ptable_id = &watchdogId[line];

    if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
    {
        logMsg("Attempt at watchdog attachment failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }
    if (tisWatchDogPulse(watchdogId[line]) != OK)
    {
        logMsg("First attempt at watchdog pulsing failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }

    /**********************/
    /* Start out as slave */
    /**********************/

    /******************************/
    tisWatchDogPulse(watchdogId[line]);
    /******************************/

    resClearCaAnswer (prestable [line]);		/* start quiet */
    resPutLocalState (prestable [line], RES_SLV);
    if (modrestrace [line])
    {
        logMsg ("1] Initialized as RES_SLV\n");
    }

    /* wait finite time for pstate to be resolved */
    logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
    for (i = 0; i <= pstatewait [line]; i++)
    {
        resGetStates (prestable [line], &lstate, &pstate);
        if ((pstate == RES_MSTR) ||
            (pstate == RES_SLV) ||
            (pstate == RES_SLVWANT) ||
            (pstate == RES_SLVWANTCA))
        {
            /* wait for the minimum activity time before exiting from loop, even if pstate is valid. */
            if (i > ACTIVITYTIME/60)
            {
                break;
            }
        }
        taskDelay (60);
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    if (i >= pstatewait[line])
    {
        logMsg ("Timeout of pstate wait.\n");
    }
    else
    {
        logMsg ("Completion of pstate[%d] wait.\n", i);
    }

    activity_state[line] = check_line_activity(line, 0);
    resGetStates (prestable [line], &lstate, &pstate);

    /******************************************/
    /* if the partner is not there, be master */

    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity_state[line]))
    {
        resSetCaAnswer (prestable [line]);
        resPutLocalState (prestable [line], RES_MSTR);

        lastscan [line] = tickGet ();
        scantime [line] = 0;

        lstate = RES_MSTR;

        if (modrestrace [line])
        {
            logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity_state[line]);
        }
        semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */

        /* when becoming master, we reset the CIU and start building the data structures */
        on_line (line);
    }

    last_time = tickGet (); /* Initialize the time  */

    while (TRUE)
    {
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        activity_tick[line] = 0; /* forces 'recent_activity' results FALSE until first RX int. */
        recent_activity[line] = FALSE;

        /********************************************************************************************/
        /* we arrive here because we are a slave.                                                   */
        /* we stay until:   asked to be master by partner. if we reach the CIU, we become master.   */
        /*                  or, until partner is not master and there is no activity on the line.   */
        /********************************************************************************************/

        while (lstate == RES_SLV)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for ciu simulated mode. */
            if (baileysim [line])
            {
                semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",
                             pstate, activity_state[line]);
                }
                break;
            }

            if (pstate != RES_SLVWANT)
            {
                clear_rts (line); 				/* make sure line is left for master 	*/
            }
            resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
            resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
            activity_state[line] = check_line_activity (line, 60); /* wait 1 second before checking 	*/
            resGetStates (prestable [line], &lstate, &pstate);

            /****************************************************************************************/
            /* see if needed by partner to be master. if yes, do it and break out of slave state.   */
            if (pstate == RES_SLVWANTCA)
            {
                semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("3] Became RES_MSTR  P= %x A= %d \n", pstate, activity_state[line]);
                }
                /* when becoming master, we reset the CIU and start building the data structures */
                on_line (line);
                break;
            }
            /***************************************************************/
            /* If partner is there and wants to give it up, try to take it */

            if (pstate == RES_SLVWANT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                execute = FALSE;
                taskDelay (2); /* Time for switch to occur */

                /* See if anyone is out there and able to respond to a restart command */

                pciu = ciu [line];
                if ((pciu) &&                        /* verify pointer validity prior to use */
                    (pciu->control.was_requested) && /* data points have been requested      */
                        (!pciu->cmd_force_offline))  /* user has NOT forced CIU offline      */
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                    on_line (line);

                    /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                    if ((pciu->is_responding) && (!pciu->cmd_force_offline))
                    {
                        execute = TRUE;
                    }
                }
                /* If someone answered, become master and make sure partner really gave it up */
                if (execute)
                {
                    resPutLocalState (prestable [line], RES_MSTR);
                    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

                    if (modrestrace [line])
                    {
                        logMsg ("4] Became RES_MSTR  P= %x A= %d \n", pstate, activity_state[line]);
                    }
                    execute = FALSE;

                    activity_tick[line] = 0; /* 'recent_activity' = FALSE until next RX int. */
                    recent_activity[line] = FALSE;

                    for (i = 0; (i < 90); i++)
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        activity_state[line] = check_line_activity (line, 2); /* pause before testing */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity_state[line]) )
                        {
                            execute = TRUE; /* Partner Gave It Up so take CA */
                            break;
                        }
                    }
                    if (!execute)
                    {   /* Partner did not give it up. go back to slave */
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        if (modrestrace [line])
                        {
                            if (pstate == RES_MSTR)
                            {
                                logMsg ("5] Partner Failed to Relinquish Master State  P= %x A= %d \n",
                                         pstate, activity_state[line]);
                            }
                            else
                            {
                                if (pstate == RES_SLVWANT)
                                {
                                    logMsg ("5] Partner Remained in Slave Want State  P= %x A= %d \n",
                                                pstate, activity_state[line]);
                                }
                                else
                                {
                                    logMsg ("5] Unexpected Activity Detected  P= %x A= %d \n",
                                                pstate, activity_state[line]);
                                }
                            }
                        }
                    }
                    else
                    { /* Assume control by taking the CA responsibilities */
                        semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
                        resSetCaAnswer (prestable [line]);
                        /* when becoming master, we reset the CIU and start all over again */
                        prepresponses (line);
                        break;
                    }
                }
            }

            /********************************************/
            /* if the partner is not talking, be master */

            if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity_state[line]))
            {
                semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("6] Became RES_MSTR P= %x A= %d \n", pstate, activity_state[line]);
                }
                prepresponses (line);
                /* when becoming master, we reset the CIU and start building the data structures */
                on_line (line);
            }
        }

        /****************************************************************************************/
        /* to arrive here, we used to be master, and had been told to relinquish master status. */
        /* stay in this loop until the partner takes over, or the command is canceled.          */
        while (lstate == RES_SLVWANTCA)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            taskDelay (2);                   /* Give OS a chance...  */
            clear_rts (line); 		/* Make sure line is left for master    */
            resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
            {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                if (modrestrace [line])
                {
                    logMsg ("7] Became RES_SLV  P= %x A= %d \n", pstate, activity_state[line]);
                }
                break;
            }
            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0); /* clear out commands */
            if (command == RES_CANCELREL)
            {
                semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("8] Became RES_MSTR  P= %x A= %d \n", pstate, activity_state[line]);
                }
                prepresponses (line);
                /* when becoming master, we reset the CIU and start building the data structures */
                on_line (line);
            }
        }

        /****************************************************************************************/
        /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
        /*  within this loop, but is never seen by the while loop conditional evaluation.       */
        /****************************************************************************************/
        while (lstate == RES_SLVWANT)
        {
            if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))
            {
                /* This condition should NEVER occur in a properly configured system. The only  */
                /* condition in which it is known to occur is when another driver is using this */
                /* driver's resource. It occurs when the other driver is in master state and is */
                /* trying to get its partner to become master. We get locked into this place    */
                /* until the other driver leaves this state. Driver behavior is unreliable.     */

                /* print error message every 5 seconds. */
                logMsg ("Illegal Local Resource State.\n");
                if (trace[line] & CONFIGURATIONTRACE)
                {
                    logMsg ("  Possible Resource Configuration Error:\n");
                    logMsg ("   Check for multiple drivers sharing single Resource.\n");
                }
                taskDelay (300);
            }
            taskDelay (6);
        }
        /****************************************************************************************/
        /* we come here because we have gone to, or are looping in, the master state.           */
        /* we stay in this loop until:    we have been told to give master state to the partner.*/
        /*                                we break out to RES_SLVWANTCA.                        */
        /*                                we have successfully handed master state to partner.  */
        /* While master, this task will process all modules sending outputs and getting inputs. */
        /* It will then try to configure requested non-responding modules.                      */
        /****************************************************************************************/

        last_time = tickGet ();		/* initialize gap */
        while (lstate == RES_MSTR)
        {
            if (mltrace [line] == 1)
            {
                logMsg ( "Top of Master Loop... \n");
            }
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for CIU simulated mode. */
            while (baileysim [line])
            {
                resresponse [line] = TRUE;  /* Make sure driver is responding.       */
                                            /* driver won't issue commands if reset. */
                pciu = ciu [line];          /* shorthand pointer.                    */
                if (pciu)                   /* verify pointer validity prior to use. */
                {
                    if (pciu->cmd_force_offline)
                    { 
                        /* if user has turned the CIU offline via pseudo commands,   */
                        /* mark it as not responding.                                */
                        pciu->is_responding = FALSE;
                    }
                    else
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        sim_ciu (line);          /* I/O done here!             */
                        taskDelay (simdelay [line]);
                    }
                }
            }
            /* initial stuff */
            resresponse [line] = TRUE; /* Make sure driver is responding. driver     */
                                       /* wont issue commands if not set.            */

            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0);        /* clear out commands */

            /************************************************************************/
            /* if relinquish command sent, change state and break out to outer loop */
            if (command == RES_RELINQUISH)
            {
                getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLVWANTCA);
                lstate = RES_SLVWANTCA;
                if (modrestrace [line])
                {
                   logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n", pstate, activity_state[line]);
                }
                break;
            }

            /* measure time between scans of the CIU. display if requested. */ 
            temptick = tickGet ();
            tempdiff = temptick - lastscan [line];

            if (modtrace [line])
            {
                logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                        scantime[line], loopoutmsgs[line], loopmsgs[line]);
            }

            loopoutmsgs [line] = 0;
            loopmsgs [line] = 0;
            lastscan [line] = temptick;

            /* scan CIU for data i/o, if allowed */
            pciu = ciu [line];                  /* shorthand pointer 			*/
            if (pciu)				/* verify pointer validity prior to use */
            {
                if (pciu->cmd_force_offline)
                {
                    /* if user has turned the CIU offline via pseudo commands,     */
                    /* mark it as not responding.                                  */
                    pciu->is_responding = FALSE;
                }
                else if (pciu->is_responding)
                {
                    /* local/partner lockstep recovery */
                    resGetStates (prestable [line], &lstate, &pstate);
                    if (pstate == RES_MSTR)
                    {
                        resClearCaAnswer (prestable [line]);
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        clear_rts (line); 		/* Make sure line is left for master */
                        if (modrestrace [line])
                        {
                            logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity_state[line]);
                        }
                        temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                        for ( i = 0; i < temp; i++)
                        {
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                        }
                        break;
                    }
                    getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                    scan_ciu (line);      	/* I/O done here! 		*/
                    semGive (linemux [line]);
                    if (!pciu->is_responding)
                    {
                        mark_not_valid (line);
                    }
                }
                /* if told to relinquish our master state, stop CIU scanning immediately. */
                /* don't trash the command, so that we can still read it on the next loop */
                /* through this while statement.                                          */
                resGetCommand (prestable [line], &command);
                if (command == RES_RELINQUISH)
                {
                    break;
                }
            } /* end of scan loop */

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* measure how long the scan took. to be displayed at beginning of next loop. */
            temptick = tickGet ();
            scantime [line] = temptick - lastscan [line];

            /* try and bring the nonresponding CIU on line. */

            pciu = ciu [line];                    /* shorthand pointer                    */
            if ((pciu) &&                         /* verify pointer validity prior to use */
                (!pciu->is_responding) &&
                 (pciu->control.was_requested) &&
                (!pciu->cmd_force_offline))
            {
                getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                on_line (line);                 /* restart testing done here! 	*/
                semGive (linemux [line]);
            }

            /* see if CIU has been responding.              */
            /* if not, try to get partner to become slave.  */
            /* Check for no one responding.                 */

            if (!any_responding (line))
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* See if it is time to let partner try */

                this_time = tickGet ();
                if ((this_time - last_time) > (3 * SLWWINDOW))
                {   /* #ticks for slave to try */

                    /* Switch States to let partner know it's its time to try */

                    /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                    /* task is quiescent while partner is checking the line with the restart    */
                    /* command. if local not master, then diagnostic won't try anyway, for       */
                    /* either master or remote radios, but it might have begun a 12 second test  */
                    /* sequence just before we got here.                                         */
                    getsemaphore(line);

                    /* we must semGive the semaphore back if and when we go to being the master */
                    resPutLocalState (prestable [line], RES_SLVWANT);
                    lstate = RES_SLVWANT;
                    if (modrestrace [line])
                    {
                        logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n", pstate, activity_state[line]);
                    }
                    /* Give partner access to the hardware */
                    clear_rts (line);

                    /* Remember the time of this try */
                    last_time = tickGet ();

                    activity_tick[line] = 0; /* 'recent_activity' = FALSE until next RX int. */
                    recent_activity[line] = FALSE;

                    for (i = 0; (i < SLWWINDOW); i += 10)
                    {       		/* SLWINDOW is the # of ticks for slave to try */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay (10);

                        /* If partner picked up let it have control */
                        activity_state[line] = check_line_activity (line, 0);  /* check immediately */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity_state[line]))
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            if (modrestrace [line])
                            {
                                logMsg ("11] Became RES_SLV  P= %x A= %d \n",
                                         pstate, activity_state[line]);
                            }
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            break;
                        }
                    }
                    /* Go Back to being the Master and take control of the hardware */
                    if (lstate != RES_SLV)
                    {
                        semGive (linemux [line]);	/* give back semaphore so diagnostics can run. */
                        resPutLocalState (prestable [line], RES_MSTR);
                        lstate = RES_MSTR;
                        if (modrestrace [line])
                        {
                            logMsg ("12] Became RES_MSTR  P= %x A= %d \n", pstate, activity_state[line]);
                        }
                        /* when becoming master, we reset the CIU and start building the data structures */
                        on_line (line);
                    }
                }
            }

            /* take CIU off hold status. the CIU data are not to be held off since now master. */
            pciu = ciu [line];          /* shorthand pointer.                                  */
            if (pciu)                   /* verify pointer validity prior to use.               */
            {        
                pciu->holdflag = FALSE;
            }

            activity_state[line] = check_line_activity (line, 0);
            taskDelay(2);
        }
   } /* end infinite task loop */
}


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}


/*
** Try to bring the CIU on line
**

** this routine only called from MAIN */

static void on_line (unsigned short line)
{
    CIUALLOC      *pciu;
    unsigned short status, i, j;

    pciu = ciu [line];              /* shorthand pointer                    */
    if (pciu)                       /* verify pointer prior to use          */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring CIU online\n" );
        }

        /* Use the restart function and determine if the unit is there and responding */
        status = baileyrestart (line);
        /* status = bailey69 (line); */

        if (status == CMDDONE)
        {
            restart_all (line);	        /* a CIU that has just been brought online must have it's data   */
                                        /* marked as being not valid and the CIU indices reestablished.  */
        }
    }
}

/*                                                                           	
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the CIU as on hold and the    	
**	data as not valid until read again from the CIU.                       	
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)
{
    CIUALLOC    *pciu;

    pciu = ciu [line];
    if (pciu)				/* verify pointer validity prior to use */
    {
        pciu->holdflag = TRUE;
        restart_all (line);
    }
}

/*                                                                      
** Set data prior to Mark all data elements as not valid     		
**                                             		                
*/                                             	
/* called from on_line and prepresponses      		*/

static void restart_all (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];
  pciu->control.data_valid = FALSE;
  pciu->is_responding = TRUE;
  pciu->time_requested = FALSE;
  pciu->time_valid = FALSE;

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      ploop->control.data_valid = FALSE;
      ploop->control.established = FALSE;
      ploop->control.connected = FALSE;
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
            ppcu->control.data_valid = FALSE;
            ppcu->control.established = FALSE;
            ppcu->control.connected = FALSE;
            for (j = LOWMODULE; (j <= HIGHMODULE); j++)
            {
                pmodule = ppcu->modules [j];
                if (pmodule)
                {
                    pmodule->control.data_valid = FALSE;
                    pmodule->control.established = FALSE;
                    pmodule->control.connected = FALSE;

                    for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
                    {
                        pblock100 = pmodule->blocks100 [k];
                        if (pblock100)
                        {
                            for (l = 0; (l < NUMBLOCKALLOC); l++)
                            {
                                pblock = pblock100->blocks[l];
                                if (pblock)
                                {
                                    ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
                                    ((COMMONALLOC *) pblock)->control.established = FALSE;
                                    ((COMMONALLOC *) pblock)->control.connected = FALSE;
                                }
                            }
                        }
                    }
                }
            }
        }
      }
    }
  }
  pciu->lastconnected = 0;
  return;
}

/*
** Mark all data elements as not valid     		
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
            for (j = LOWMODULE; (j <= HIGHMODULE); j++)
            {
                pmodule = ppcu->modules [j];
                if (pmodule)
                {
                    pmodule->control.data_valid = FALSE;

                    for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
                    {
                        pblock100 = pmodule->blocks100 [k];
                        if (pblock100)
                        {
                            for (l = 0; (l < NUMBLOCKALLOC); l++)
                            {
                                pblock = pblock100->blocks[l];
                                if (pblock)
                                {
                                    ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
                                }
                            }
                        }
                    }
                }
            }
        }
      }
    }
  }
  return;
}

/*                                                       
** make all data below CIU level as not valid            
**                                             		 
*/                                             	

static void invalidate_all (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];
  pciu->is_responding = TRUE;
  pciu->time_valid = FALSE;

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      ploop->control.data_valid = FALSE;
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
          ppcu->control.data_valid = FALSE;
          for (j = LOWMODULE; (j <= HIGHMODULE); j++)
          {
            pmodule = ppcu->modules [j];
            if (pmodule)
            {
              pmodule->control.data_valid = FALSE;
              for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
              {
                pblock100 = pmodule->blocks100 [k];
                if (pblock100)
                {
                  for (l = 0; (l < NUMBLOCKALLOC); l++)
                  {
                    pblock = pblock100->blocks[l];
                    if (pblock)
                    {
                      ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  return;
}


/*                                                                  
** test for bad CIU mode detected on last readmiscstatusexceptions  
**                                             		            
*/                                             	

static void badciutest (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];
  /* if CIU failure/error mode detected, invalidate all points below CIU level */
 if ((pciu->ciumode == 1) ||
     (pciu->ciumode == 2) ||
     (pciu->ciumode == 0xfe))
 {
  if (pciu->ciumode == 0xfe)
  {
    pciu->ciumode = 0xff; /* only do this twice */
  }
  else
  {
    pciu->ciumode = 0xfe; /* only do this twice */
  }

  pciu->is_responding = TRUE;
  pciu->time_valid = FALSE;

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      ploop->control.data_valid = FALSE;
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
          ppcu->control.data_valid = FALSE;
          for (j = LOWMODULE; (j <= HIGHMODULE); j++)
          {
            pmodule = ppcu->modules [j];
            if (pmodule)
            {
              pmodule->control.data_valid = FALSE;
              for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
              {
                pblock100 = pmodule->blocks100 [k];
                if (pblock100)
                {
                  for (l = 0; (l < NUMBLOCKALLOC); l++)
                  {
                    pblock = pblock100->blocks[l];
                    if (pblock)
                    {
                      ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
 }
  return;
}


/*                                 
** test for bad modules            
**                                 
*/                                             	

static void badmoduletest (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];
  pciu->is_responding = TRUE;
  pciu->time_valid = FALSE;

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
          for (j = LOWMODULE; (j <= HIGHMODULE); j++)
          {
            pmodule = ppcu->modules [j];
            if (pmodule)
            {
              /* detect Module failure/error mode and invalidate all points below Module level */
              if ((((MODULEALLOC *) pmodule)->modulemode == 1) ||
                  (((MODULEALLOC *) pmodule)->modulemode == 2) ||
                  (((MODULEALLOC *) pmodule)->modulemode == 0xfe))
              {

                  if ((((MODULEALLOC *) pmodule)->modulemode == 0xfe))
                  {
                      ((MODULEALLOC *) pmodule)->modulemode = 0xff; /* only do this twice */
                  }
                  else
                  {
                      ((MODULEALLOC *) pmodule)->modulemode = 0xfe; /* only do this twice */
                  }
                  for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
                  {
                    pblock100 = pmodule->blocks100 [k];
                    if (pblock100)
                    {
                      for (l = 0; (l < NUMBLOCKALLOC); l++)
                      {
                        pblock = pblock100->blocks[l];
                        if (pblock)
                        {
                          ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
                        }
                      }
                    }
                  }

              }
            }
          }
        }
      }
    }
  }
  return;
}





/*
** make all data below Module level as not valid         
**                                             		 
*/                                             	

static void invalidate_blocks (void *pointer)
{
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short k, l;
/*
  logMsg ("****************************\n");
  logMsg ("invalidate blocks: begin ...\n");
  logMsg ("****************************\n");
*/
  for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
  {
    pblock100 = ((MODULEALLOC *) pointer)->blocks100 [k];
    if (pblock100)
    {
      for (l = 0; (l < NUMBLOCKALLOC); l++)
      {
        pblock = pblock100->blocks[l];
        if (pblock)
        {
          ((COMMONALLOC *) pblock)->control.data_valid = FALSE;
          /* logMsg ("invalidate blocks: block100 = %d, block = %d\n", k, l); */
        }
      }
    }
  }
  return;
}

/*
**     establish and connect                                                      */
**                                                                             	  */
/*      The purpose of this routine is to run through the index table and         */
/*      establish unestablished and connect unconnected indices. if the establish */
/*      and connect is successful, then we bump the last_established index value  */
/*      so we don't search through the entire list each time we call this routine.*/

static void establishandconnect (unsigned short line)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    void           *pointer;
    unsigned short  index, status;
    unsigned short  bumplast;

    pciu = ciu [line];

    /* while this is true, we 'drag up behind us' the last established and connected index value */
    bumplast = TRUE;

    for (index = pciu->lastconnected+1; index < pciu->nextindex; index++)
    {
        pointer = pciu->indextable [index];
        if (!pointer)
        {
            /* something is wrong. there should be no holes in the index table */
            return;
        }

        /* create pointers for use by msgxfer statistics routines */
        ploop   = pciu-> loops  [((COMMONALLOC *) pointer)->control.loop];
        ppcu    = ploop->pcus   [((COMMONALLOC *) pointer)->control.pcu];
        pmodule = ppcu-> modules[((COMMONALLOC *) pointer)->control.module];

        pciu->ploop   = ploop;
        pciu->ppcu    = ppcu;
        pciu->pmodule = pmodule;

        if ( ((COMMONALLOC *) pointer)->control.was_requested == TRUE)
        {
            if ( ((COMMONALLOC *) pointer)->control.established == TRUE)
            {
                if ( ((COMMONALLOC *) pointer)->control.connected == TRUE)
                {
                    continue;  /* we only go after those blocks not establish and/or not connected */
                }
                else
                {
                    /* try to connect the point.       */
                    status = sendconnect(line, pointer);
                    switch (status)
                    {
                        case CMDDONE:
                            ((COMMONALLOC *) pointer)->control.connected = TRUE;
                            if (bumplast == TRUE)
                            {
                                pciu->lastconnected++;
                            }
                            break;
                        case CMDINIT:
                        case CMDFAIL:
                            return;  /* no sense going on. */

                        case CMDNADA:
                        case CMDNACK:
                        default:
                           bumplast = FALSE;
                           break;
                    }
                }
            }
            else /* point not established */
            {
                /* try to establish the point.     */
                status = sendestablish(line, pointer);
                switch (status)
                {
                    case CMDDONE:
                        ((COMMONALLOC *) pointer)->control.established = TRUE;
                        /* try to connect the point.       */
                        status = sendconnect(line, pointer);
                        switch (status)
                        {
                            case CMDDONE:
                                ((COMMONALLOC *) pointer)->control.connected = TRUE;
                                if (bumplast == TRUE)
                                {
                                    pciu->lastconnected++;
                                }
                                break;
                            case CMDINIT:
                            case CMDFAIL:
                                /* no sense going on. */
                                return;
                                break;
                            case CMDNADA:
                            case CMDNACK:
                            default:
                               bumplast = FALSE;
                               break;
                        }
                        break;

                    case CMDINIT:
                    case CMDFAIL:
                        /* no sense going on. */
                        return;
                        break;
                    case CMDNADA:
                    case CMDNACK:
                    default:
                       bumplast = FALSE;
                       break;
                }
            }
        }
        else
        {
            /* something is wrong if we reach this point.   */
            /* there should be no holes in the index space. */
            if (trace[line] & INDEXERRORTRACE)
            {
                logMsg ("*************************************************\n");
                logMsg ("establishandconnect: UNEXPECTED ERROR ENCOUNTERED\n");
                logMsg ("*************************************************\n");
                taskDelay(5*60);
            }
        }
    }
}

/*                                                                                                   
** scan ciu - Establish & Connect Indices, Output Values, and Request all Exceptions from Bailey CIU 
**                                                                                                   
*/
/* this routine only called from MAIN 		*/

static	void scan_ciu (unsigned short line)
{
    CIUALLOC    *pciu;
    unsigned short i, j, k;

    unsigned short breakout;
    unsigned short status;

    pciu = ciu [line];

    /***********************************************/
    /* before starting anything new, check outputs */
    /***********************************************/
    checkoutputs (line);

    /***********************************************/
    /* Establish and Connect Indices: All          */
    /***********************************************/

    if (mltrace [line] == 2)
    {
        logMsg ( "Establishing and Connecting Points ...\n" );
    }

    establishandconnect (line);

    checkoutputs (line);

    /***********************************************/
    /* Read Exceptions: AER, DER, RMSC             */
    /***********************************************/

    if (mltrace [line] == 2)
    {
        logMsg ( "Reading Exceptions ...\n" );
    }

    status = readexceptions (line);
    switch (status)
    {
        case CMDNADA:
            /* there were no exceptions returned on the last query */
            breakout = TRUE;
            break;
        case CMDDONE:
            /* do another, as last was successful. */
            break;
        case CMDINIT:
        case CMDNACK:
        case CMDFAIL:
        default:
            /* if something is wrong, abort the scanning */
            if (mltrace [line] == 2)
            {
                logMsg ("scan_ciu: Debug Point: exit[0]\n");
                taskDelay (2*60);
            }
            return;
    }
    checkoutputs (line);

    /***********************************************/
    /* Read Station Exceptions: CS                 */
    /***********************************************/

    if (mltrace [line] == 2)
    {
        logMsg ( "Reading Station Exceptions ...\n" );
    }

    /* maximum successive reads enforced to minimize output delays */
    status = readstationexceptions (line);
    switch (status)
    {
        case CMDNADA:
            /* there were no exceptions returned on the last query */
            breakout = TRUE;
            break;
        case CMDDONE:
            /* do another, as last was successful. */
            break;
        case CMDINIT:
        case CMDNACK:
        case CMDFAIL:
        default:
            /* if something is wrong, abort the scanning */
            if (mltrace [line] == 2)
            {
                logMsg ("scan_ciu: Debug Point: error exit[1]\n");
            }
            taskDelay (2*60);
            return;
    }
    checkoutputs (line);

    /**********************************************************/
    /* Read Miscellaneous Status Exceptions: RCM, DD, Modules */
    /**********************************************************/

/*    logMsg ( "Reading Miscellaneous Status Exceptions ...\n" ); */
    if (mltrace [line] == 2)
    {
        logMsg ( "Reading Miscellaneous Status Exceptions ...\n" );
    }

    /* maximum successive reads enforced to minimize output delays */
    status = readmiscstatusexceptions (line);
    switch (status)
    {
        case CMDNADA:
            /* there were no exceptions returned on the last query */
            breakout = TRUE;
            break;
        case CMDDONE:
            /* do another, as last was successful. */
            break;
        case CMDINIT:
        case CMDNACK:
        case CMDFAIL:
        default:
            /* if something is wrong, abort the scanning */
            if (mltrace [line] == 2)
            {
                logMsg ("scan_ciu: Debug Point: error exit[2]\n");
            }
            taskDelay (2*60);
            return;
    }
    checkoutputs (line);

    /***********************************************/
    /* Read Date/Time:                             */
    /***********************************************/

    pciu->time_requested = TRUE;

    if (pciu->time_requested)
    {
        if (mltrace [line] == 2)
        {
            logMsg ( "Reading Date/Time ...\n" );
        }
        status = readdatetime (line);
        switch (status)
        {
            case CMDNADA:
                /* time was not yet available from the CIU */
                break;
            case CMDDONE:
                /* time was successfully read from CIU. */
                pciu->time_requested = FALSE;
                break;
            case CMDINIT:
            case CMDNACK:
            case CMDFAIL:
            default:
                /* if something is wrong, abort the scanning */
                if (mltrace [line] == 2)
                {
                    logMsg ("scan_ciu: Debug Point: error exit[3]\n");
                }
                taskDelay (2*60);
                return;
        }
        checkoutputs (line);

    }
    badmoduletest (line); /* see if any of the Modules turned up bad on the last read. */
    badciutest (line);    /* see if the CIU turned up bad on the last read. */
}

/*                                                                                                     
** sim_ciu                                                                                             
**      simulate a happily responding CIU.                                                             
**                                                                                                     
*/                                                                                              
/* this routine only called from scan_ciu */

static	void sim_ciu (unsigned short line)
{
  unsigned short  h, i, j, k, l, val;
  unsigned long   bitmask;
  unsigned short  temp, cmd;

  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;
  unsigned char  *pchar;

  pciu = ciu [line];
  pciu->is_responding = pciu->control.was_requested;

  /* Fake out time: what should we do? */

  for (h = LOWLOOP; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if (ploop)
    {
      for (i = LOWPCU; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if (ppcu)
        {
            ppcu->is_responding = ppcu->control.was_requested;
            for (j = LOWMODULE; (j <= HIGHMODULE); j++)
            {
                pmodule = ppcu->modules [j];
                if (pmodule)
                {
                    pmodule->is_responding = pmodule->control.was_requested;

                    /* Fake out module status: what should we do? */

                    for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
                    {
                        pblock100 = pmodule->blocks100 [k];
                        if (pblock100)
                        {
                            for (l = 0; (l < NUMBLOCKALLOC); l++)
                            {
                                pblock = pblock100->blocks[l];
                                if (pblock)
                                {
                                    ((COMMONALLOC *) pblock)->control.data_valid =
                                     ((COMMONALLOC *) pblock)->control.was_requested;
                                    switch (((COMMONALLOC *) pblock)->control.type)
                                    {
                                        case AER_TYPE:
                                            temp = ((AERALLOC *) pblock)->data_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((AERALLOC *) pblock)->data_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((AERALLOC *) pblock)->data_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((AERALLOC *) pblock)->raw_read[0]);
                                            float_to_real3 (((AERALLOC *) pblock)->data_read, pchar);
                                            /*  Table 7: Quality = good, no alarms, no red tags */
                                            ((AERALLOC *) pblock)->status_read = 0+0+0+0+0;
                                            break;

                                        case DER_TYPE:
                                            /* preserve only the lowest bit (data). */
                                            temp = ((((DERALLOC *) pblock)->status_read) & 1);
                                            /*  Table 8: Quality = good, no alarms */
                                            temp = temp+0+0;
                                            if (simdigon [line])
                                            {
                                                temp = temp ^1;
                                            }
                                            (((DERALLOC *) pblock)->status_read) = temp;
                                            break;

                                        case RCM_TYPE:
                                            /*  Table 16:[0] good quality, no alarms, no tags, ov=0 */
                                            ((RCMALLOC *) pblock)->status_read[0] = 0+0+0+0;
                                            /*          [1] all inputs, values, & commands are zero */
                                            ((RCMALLOC *) pblock)->status_read[1] = 0+0+0+0+0+0+0;
                                            /*          [2] zero */
                                            ((RCMALLOC *) pblock)->status_read[2] = 0;
                                            /*          [3] zero */
                                            ((RCMALLOC *) pblock)->status_read[3] = 0;
                                            /*          [4] zero */
                                            ((RCMALLOC *) pblock)->status_read[4] = 0;
                                            break;

                                        case RMSC_TYPE:
                                            temp = ((RMSCALLOC *) pblock)->data_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((RMSCALLOC *) pblock)->data_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((RMSCALLOC *) pblock)->data_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((RMSCALLOC *) pblock)->raw_read[0]);
                                            float_to_real3 (((RMSCALLOC *) pblock)->data_read, pchar);
                                            /*  Table 7: Quality = good, no alarms, no red tags */
                                            ((RMSCALLOC *) pblock)->status_read = 0+0+0+0+0;
                                            break;

                                        case CS_TYPE:
                                            temp = ((CSALLOC *) pblock)->PV_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((CSALLOC *) pblock)->PV_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((CSALLOC *) pblock)->PV_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((CSALLOC *) pblock)->PVraw_read[0]);
                                            float_to_real3 (((CSALLOC *) pblock)->PV_read, pchar);


                                            temp = ((CSALLOC *) pblock)->SP_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((CSALLOC *) pblock)->SP_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((CSALLOC *) pblock)->SP_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((CSALLOC *) pblock)->SPraw_read[0]);
                                            float_to_real3 (((CSALLOC *) pblock)->SP_read, pchar);


                                            temp = ((CSALLOC *) pblock)->CO_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((CSALLOC *) pblock)->CO_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((CSALLOC *) pblock)->CO_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((CSALLOC *) pblock)->COraw_read[0]);
                                            float_to_real3 (((CSALLOC *) pblock)->CO_read, pchar);


                                            temp = ((CSALLOC *) pblock)->RI_read;
                                            if ((temp < simlow [line]) ||
                                                (temp >= simhigh [line]))
                                            {
                                                /* automatic type conversion. */
                                                ((CSALLOC *) pblock)->RI_read = simlow [line];
                                            }
                                            else
                                            {
                                                ((CSALLOC *) pblock)->RI_read += 1;
                                            }
                                            /* convert floating point to raw Bailey Real3 format. */
                                            pchar = &(((CSALLOC *) pblock)->RIraw_read[0]);
                                            float_to_real3 (((CSALLOC *) pblock)->RI_read, pchar);


                                            /*  Table 7: Quality = good, no alarms, no red tags */
                                            ((CSALLOC *) pblock)->status_read[0] = 0+0+0+0+0;
                                            /*  Table 9: good analog output, no manual interlock, */
                                            /*           no output tracking, Digital Station OK,  */
                                            /*           Computer OK, level is from computer,     */
                                            /*           not Cascade/ration, Auto mode.           */
                                            ((CSALLOC *) pblock)->status_read[1] = 0+0+0+0+8+4+0+1;

                                            break;

                                        case DD_TYPE:
                                            /*  Table 16:[0] good quality, no alarms, no tags, ov=0 */
                                            ((DDALLOC *) pblock)->status_read[0] = 0+0+0+0;
                                            /*          [1] all inputs, values, & commands are zero */
                                            ((DDALLOC *) pblock)->status_read[1] = 0+0+0+0+0+0+0;
                                            /*          [2] zero */
                                            ((DDALLOC *) pblock)->status_read[2] = 0;
                                            /*          [3] zero */
                                            ((DDALLOC *) pblock)->status_read[3] = 0;
                                            /*          [4] zero */
                                            ((DDALLOC *) pblock)->status_read[4] = 0;
                                            break;

                                        default:
                                            break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
      }
    }
  }
  return;
}

/*                                                                                                     
** checkoutputs                                                                                        
**      checks output queue and returns if empty. if there is something on the queue it attempts to    
**      process all pending outputs, doing immediate retries. If attempts fail the request is dropped. 
**                                                                                                     
*/
/* this routine only called from scan_ciu */

static	void checkoutputs (unsigned short line)
{
    OUTQENT        *optr;
    unsigned short  regaddr, regval, link, adapter, coiladdr, conv;
    unsigned short  card, signal, type, block, index;
    unsigned long   bovalue, mask, val;

    CIUALLOC       *pciu;

    double          dblaovalue;
    unsigned short  stringaddr, stringlen;
    unsigned char  *pstringval;
    unsigned short  write_status;

    unsigned char   *ptypestring;
    unsigned short  knowntype;
    unsigned short  localaction;

    if (mltrace [line] == 6)
    {
        logMsg ("Checking Output Queue ...\n"); 
    }

    while ((optr = ogetnextp (line)) != NULLP)
    {
        link    = optr->link;
        adapter = optr->adapter;
        card    = optr->card;
        signal  = optr->signal;

        dblaovalue = optr->dblaovalue;
        bovalue = optr->bovalue;
        type    = optr->tatetype;
        mask    = optr->mask;

        block   = optr->block;
        pciu    = ciu [line];

        pciu->ploop   = optr->ploop;
        pciu->ppcu    = optr->ppcu;
        pciu->pmodule = optr->pmodule;
        pciu->pblock  = optr->pblock;

        switch (optr->otype)
        {
            case RMSC_TYPE:
                if (type == ANALOG)
                {
                    knowntype = TRUE;
                    ptypestring = "AO (RMSC)";
                    localaction = 1;
                }
                else
                {
                    if (type == BINARY)
                    {
                        knowntype = TRUE;
                        ptypestring = "BO (RMSC)";
                        localaction = 2;
                    }
                    else
                    {
                        knowntype = FALSE;
                        ptypestring = "(??) (RMSC)";
                    }
                }
                break;

            case CS_TYPE:
                if (optr->tatetype == ANALOG)
                {
                    knowntype = TRUE;
                    ptypestring = "AO (CS)";
                    localaction = 3;
                }
                else
                {
                    if (type == BINARY)
                    {
                        knowntype = TRUE;
                        ptypestring = "BO (CS)";
                        localaction = 4;
                    }
                    else
                    {
                        knowntype = FALSE;
                        ptypestring = "(??) (CS)";
                    }
                }


                break;
            case RCM_TYPE:
                if (optr->tatetype == BINARY)
                {
                    knowntype = TRUE;
                    ptypestring = "BO (RCM)";
                    localaction = 5;
                }
                else
                {
                    knowntype = FALSE;
                    ptypestring = "(??) (RCM)";
                }
                break;

            case DD_TYPE:
                if (optr->tatetype == BINARY)
                {
                    knowntype = TRUE;
                    ptypestring = "BO (DD)";
                    localaction = 6;
                }
                else
                {
                    knowntype = FALSE;
                    ptypestring = "(??) (DD)";
                }
                break;

            default:
                ptypestring = "(??) (UNKNOWN)";
                knowntype = FALSE;
        }
        /* common code */
        if (knowntype)
        {
            if (mltrace [link] == 7)
            {
                if (type == ANALOG)
                    logMsg("%s IN QUEUE: L=%d, A=%d, C=%d, S=%d, Value=%6.1f\n",
                           ptypestring, link, adapter, card, signal, dblaovalue);
                else
                    logMsg("%s IN QUEUE: L=%d, A=%d, C=%d, S=%d, Value=0x%x%x\n",
                           ptypestring, link, adapter, card, signal, bovalue/16, bovalue%16);
            }

            if ((!pciu->cmd_force_offline) &&
                (resresponse [link]) &&
                (pciu->is_responding))
            {
                loopoutmsgs [line]++;
                /* pointer to block previously preserved. read the index and use it in the write. */

                switch (localaction)
                {
                    case 1: /* RMSC_TYPE, AO */
                        write_status = setrmsc_ao (link, signal, dblaovalue);
                        break;
                    case 2: /* RMSC_TYPE, BO */
                        write_status = setrmsc_bo (link, signal, bovalue, mask);
                        break;
                    case 3: /* CS_TYPE, AO */
                        write_status = setstation (link, signal, dblaovalue);
                        break;
                    case 4: /* CS_TYPE, BO */
                        write_status = setcs_bo (link, signal, bovalue, mask);
                        break;
                    case 5: /* RCM_TYPE, BO */
                        write_status = setrcm (link, signal, bovalue, mask);
                        break;
                    case 6: /* DD_TYPE, BO */
                        write_status = setrcm (link, signal, bovalue, mask);
                        break;
                }
                if (write_status != CMDDONE)
                {
                    pciu->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        if (type == ANALOG)
                            logMsg("%s DEQUEUE: Output failed:  L=%d, A=%d, C=%d, S=%d, Value=%6.1f\n",
                                   ptypestring, link, adapter, card, signal, dblaovalue);
                        else
                            logMsg("%s DEQUEUE: Output failed:  L=%d, A=%d, C=%d, S=%d, Value=0x%x%x\n",
                                   ptypestring, link, adapter, card, signal, bovalue/16, bovalue%16);
                    }
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        if (type == ANALOG)
                            logMsg("%s DEQUEUE: Output succeeded:  L=%d, A=%d, C=%d, S=%d, Value=%6.1f\n",
                                   ptypestring, link, adapter, card, signal, dblaovalue);
                        else
                            logMsg("%s DEQUEUE: Output succeeded:  L=%d, A=%d, C=%d, S=%d, Value=0x%x%x\n",
                                   ptypestring, link, adapter, card, signal, bovalue/16, bovalue%16);
                    }
                }
            }
        }
        else
        {
            /* unknown type in queue. */
            if (mltrace [link] == 3)
            {
                logMsg ("%s DEQUEUE: Output Failed: Unknown Type: L=%d, A=%d, C=%d, S=%d\n",
                         ptypestring, link, adapter, card, signal);
            }
        }
        oreleasefull (line);     /* release the output que entry */
    }
}

/*
**      AIDRIVER                                                                
**                                                                              
**      This routines main purpose is to return the analog input value for the  
**      specified module. For a non-pseudo value a (-1) will be returned if     
**      there is no valid data ready.                                           
**                                                                              
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, short *pvalue,
              unsigned short conversion, unsigned char *resname)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

             short  zero = 0;
    unsigned short *pzero;
    unsigned short *pdata;
    unsigned short  newindex, tb100, tb1;

    union join {
                       float     real;
                       short     word[2];
               } both;


    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned short  conversionerror;
    unsigned short  returnzero;

    pzero = &zero;
    returnzero = FALSE;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;
    conversionerror = FALSE;

    switch (block)
    {
        case DATETIME:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case PSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case CIUPSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case LOOPPSEUDO:
            /* pcu=0, module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case PCUPSEUDO:
            /* module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case MODULEPSEUDO:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
                if (conversion != AICNVFLOAT)
                    conversionerror = TRUE;
            }
            else
            {
                /* invalid block */
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((looptest) && ((loop < looptestmin) || (loop > looptestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter(Loop):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIBRIVER: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (conversionerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d, CNV=%d\n",
                    pointname, link, adapter, card, signal, conversion);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were any Bailey block values requested */
                *pvalue = pciu->control.was_requested;
                break;
            case 1: /* Is the CIU responding */
                *pvalue = pciu->is_responding;
                break;
            case 5: /* Output Messages */
                *pvalue = pciu->no_dataout_msgs & 0x7fff;
                break;
            case 6: /* Input Messages */
                *pvalue = pciu->no_datain_msgs & 0x7fff;
                break;
            case 7: /* No Receiver Responses */
                *pvalue = pciu->no_rxnoresp & 0x7fff;
                break;
            case 8: /* No Transmitter Response */
                *pvalue = pciu->no_txnoresp & 0x7fff;
                break;
            case 9: /* Data Echo Errors */
                *pvalue = pciu->no_dataerr & 0x7fff;
                break;
            case 10: /* Message Retries */
                *pvalue = pciu->no_retries & 0x7fff;
                break;
            case 11: /* RX Hardware errors */
                *pvalue = pciu->no_rxhwerrs & 0x7fff;
                break;
            case 12: /* TX Hardware errors */
                *pvalue = pciu->no_txhwerrs & 0x7fff;
                break;
            case 13: /* Checksum errors */
                *pvalue = pciu->no_chksumerrs & 0x7fff;
                break;
            case 14: /* Offline transitions */
                *pvalue = pciu->no_offlines & 0x7fff;
                break;
            case 15: /* reset statistics */
                *pvalue = pciu->cmd_reset_stat;
                break;
            case 16: /* Force the CIU offline */
                *pvalue = pciu->cmd_force_offline;
                break;
            case 17: /* Failed output commands */
                *pvalue = pciu->badoutcnt & 0x7fff;
                break;
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }    /* end of pseudo point processing */

    /******************************************************/
    /* service bailey CIU level pseudo points immediately */
    /******************************************************/
    if (card == CIUPSEUDO)
    {
        switch (signal)
        {
            /* no error */
            case (0):
                *pvalue = pciu->ciu_noerrors & 0x7fff;
                break;

            /* valid status from CIU */
            case (1):
                *pvalue = pciu->ciu_loopwait & 0x7fff;
                break;
            case (9):
                *pvalue = pciu->ciu_repeatrestart & 0x7fff;
                break;
            case (18):
                *pvalue = pciu->ciu_needrestart & 0x7fff;
                break;
            case (22):
                *pvalue = pciu->ciu_specslost & 0x7fff;
                break;
            case (23):
                *pvalue = pciu->ciu_emptyqueue & 0x7fff;
                break;
            case (28):
                *pvalue = pciu->ciu_indexinuse & 0x7fff;
                break;

            /* transitory bailey errors */
            case (7):
                *pvalue = pciu->ciu_btmbad & 0x7fff;
                break;
            case (12):
                *pvalue = pciu->ciu_commerror & 0x7fff;
                break;
            case (27):
                *pvalue = pciu->ciu_commtimeout & 0x7fff;
                break;
            case (31):
                *pvalue = pciu->ciu_checksum & 0x7fff;
                break;
            case (35):
                *pvalue = pciu->ciu_busy & 0x7fff;
                break;

            /* non-transitory bailey problems */
            case (13):
                *pvalue = pciu->ciu_btmdead & 0x7fff;
                break;
            case (34):
                *pvalue = pciu->ciu_error & 0x7fff;
                break;
            case (36):
                *pvalue = pciu->ciu_btmoffline & 0x7fff;
                break;

            /* TIS-Bailey database conflicts */
            case (11):
                *pvalue = pciu->ciu_memerr & 0x7fff;
                break;
            case (16):
                *pvalue = pciu->ciu_rangeerr & 0x7fff;
                break;

            /* TIS driver logic errors */
            case (2):
                *pvalue = pciu->ciu_format & 0x7fff;
                break;
            case (3):
                *pvalue = pciu->ciu_illegal & 0x7fff;
                break;
            case (4):
                *pvalue = pciu->ciu_reindex & 0x7fff;
                break;
            case (5):
                *pvalue = pciu->ciu_reblock & 0x7fff;
                break;
            case (6):
                *pvalue = pciu->ciu_toolong & 0x7fff;
                break;
            case (8):
                *pvalue = pciu->ciu_eierr & 0x7fff;
                break;
            case (10):
                *pvalue = pciu->ciu_noindex & 0x7fff;
                break;
            case (14):
                *pvalue = pciu->ciu_ieerr & 0x7fff;
                break;
            case (17):
                *pvalue = pciu->ciu_badkey & 0x7fff;
                break;
            case (19):
                *pvalue = pciu->ciu_mierr & 0x7fff;
                break;
            case (20):
                *pvalue = pciu->ciu_msgactive & 0x7fff;
                break;
            case (21):
                *pvalue = pciu-> ciu_iomerr & 0x7fff;
                break;
            case (24):
                *pvalue = pciu->ciu_bigreply & 0x7fff;
                break;
            case (25):
                *pvalue = pciu->ciu_illegalsmc & 0x7fff;
                break;
            case (26):
                *pvalue = pciu->ciu_reporterr & 0x7fff;
                break;
            case (29):
                *pvalue = pciu->ciu_pointbad & 0x7fff;
                break;
            case (30):
                *pvalue = pciu->ciu_watchdog & 0x7fff;
                break;
            case (33):
                *pvalue = pciu->ciu_needcallup & 0x7fff;
                break;
            case (37):
                *pvalue = pciu->ciu_mmconflict & 0x7fff;
                break;
            case (38):
                *pvalue = pciu->ciu_pointtype & 0x7fff;
                break;

            /* unknown reply codes */
            case (99):
                *pvalue = pciu->ciu_unknown & 0x7fff;
                break;
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal CIU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    } /* end of ciu pseudo point processing */

    /*******************************************************/
    /* service bailey loop level pseudo points immediately */
    /*******************************************************/
    if (card == LOOPPSEUDO)
    {
        ploop = pciu->loops[loop];
        if (ploop == NULL)
        {
            /* preset a zero return value if structure not allocated */
            *pvalue = *pzero;
            returnzero = TRUE;
        }
        switch (signal)
        {
            /* transitory bailey errors */
            case (41):
                if (returnzero) break;
                *pvalue = ploop->ring_busy & 0x7fff;
                break;

            /* non-transitory bailey problems */
            case (39):
                if (returnzero) break;
                *pvalue = ploop->ring_offline & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Loop Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    } /* end of loop pseudo point processing */

    /******************************************************/
    /* service bailey pcu level pseudo points immediately */
    /******************************************************/
    if (card == PCUPSEUDO)
    {
        ploop = pciu->loops[loop];
        if (ploop == NULL)
        {
            /* preset a zero return value if structure not allocated */
            *pvalue = *pzero;
            returnzero = TRUE;
        }
        else
        {
            ppcu = ploop->pcus[pcu];
            if (ppcu == NULL)
            {
                /* preset a zero return value if structure not allocated */
                *pvalue = *pzero;
                returnzero = TRUE;
            }
        }
        switch (signal)
        {
            /* transitory bailey errors */
            case (40):
                if (returnzero) break;
                *pvalue = ppcu->node_busy & 0x7fff;
                break;

            /* non-transitory bailey problems */
            case (15):
                if (returnzero) break;
                *pvalue = ppcu->node_looptimeout & 0x7fff;
                break;
            case (32):
                if (returnzero) break;
                *pvalue = ppcu->node_offline & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal PCU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    } /* end of pcu pseudo point processing */

    /*********************************************************/
    /* service bailey module level pseudo points immediately */
    /*********************************************************/
    if (card == MODULEPSEUDO)
    {
        ploop = pciu->loops[loop];
        if (ploop == NULL)
        {
            /* preset a zero return value if structure not allocated */
            *pvalue = *pzero;
            returnzero = TRUE;
        }
        else
        {
            ppcu = ploop->pcus[pcu];
            if (ppcu == NULL)
            {
                /* preset a zero return value if structure not allocated */
                *pvalue = *pzero;
                returnzero = TRUE;
            }
            else
            {
                pmodule = ppcu->modules[module];
                if (pmodule == NULL)
                {
                    /* preset a zero return value if structure not allocated */
                    *pvalue = *pzero;
                    returnzero = TRUE;
                }
            }
        }

        switch (signal)
        {
            /* transitory bailey errors */
            case (101):
                if (returnzero) break;
                *pvalue = pmodule->module_busy & 0x7fff;
                break;

            /* non-transitory bailey problems */
            case (109):
                if (returnzero) break;
                *pvalue = pmodule->module_memerr & 0x7fff;
                break;
            case (110):
                if (returnzero) break;
                *pvalue = pmodule->module_dead & 0x7fff;
                break;

            /* TIS-Bailey database conflicts */
            case (100):
                if (returnzero) break;
                *pvalue = pmodule->module_badmsg & 0x7fff;
                break;
            case (103):
                if (returnzero) break;
                *pvalue = pmodule->module_rangeerr & 0x7fff;
                break;
            case (104):
                if (returnzero) break;
                *pvalue = pmodule->module_blkerr & 0x7fff;
                break;
            case (105):
                if (returnzero) break;
                *pvalue = pmodule->module_blkundef & 0x7fff;
                break;
            case (106):
                if (returnzero) break;
                *pvalue = pmodule->module_blknoread & 0x7fff;
                break;
            case (107):
                if (returnzero) break;
                *pvalue = pmodule->module_funerr & 0x7fff;
                break;
            case (108):
                if (returnzero) break;
                *pvalue = pmodule->module_funblkerr & 0x7fff;
                break;

            /* TIS driver logic errors */
            case (102):
                if (returnzero) break;
                *pvalue = pmodule->module_cmmismatch & 0x7fff;
                break;
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Module Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    } /* end of module pseudo point processing */


    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/
    /* this leaves us to process 'real' data points:           */
    /* DATETIME and 'normal' blocks.                           */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/


    /*************/
    /* Date/Time */
    /*************/
    if (card == DATETIME)
    {
        if ((signal < 1) || (signal >TIME_AINUM))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal Signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        pciu->time_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (pciu->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pciu->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!pciu->control.data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        /* everything is ok. exit, returning the value. */

        switch (signal)
        {
            case 1:
                *pvalue = pciu->year;
                break;
            case 2:
                *pvalue = pciu->month;
                break;
            case 3:
                *pvalue = pciu->day;
                break;
            case 4:
                *pvalue = pciu->day_of_week;
                break;
            case 5:
                *pvalue = pciu->hour;
                break;
            case 6:
                *pvalue = pciu->minute;
                break;
            case 7:
                *pvalue = pciu->second;
                break;
            case 8:
                *pvalue = pciu->sample_number;
                break;
            case 9:
                *pvalue = pciu->time_sync_master;
                break;
        }
        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, *pvalue);
        return (0);
    }
    /* end of date/time processing */

    /*************************************************/
    /* this leaves us to process 'real' data points. */
    /*************************************************/
    /*  (this require pcu allocation)                */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }
    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }
    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AIDRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */

        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    /*************************************************/
    /* finally, we have come to the last 'real' data */
    /* points: 'normal' blocks. If the block type is */
    /* NOT normal, then it is an error.              */
    /*************************************************/

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            if ((field > (AER_AINUM)))
                fielderror = TRUE;
            break;
        case DER_TYPE:
            typeerror = TRUE;
            break;
        case RCM_TYPE:
            typeerror = TRUE;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_AINUM)))
                fielderror = TRUE;
            break;
        case CS_TYPE:
            if ((field > (CS_AINUM)))
                fielderror = TRUE;
            break;
        case DD_TYPE:
            typeerror = TRUE;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    /*****************************************/
    /* all driver call parameters validated. */
    /*****************************************/

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/

    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AIDRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("AIDRIVER: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d, TYPE=%d\n",
                    pointname, link, adapter, card, signal,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pciu->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pciu->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (!((COMMONALLOC *) pblock)->control.data_valid)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* everything is ok. exit, returning the value. */

    switch (type)
    {
        case AER_TYPE:
            both.real = ((AERALLOC *) pblock)->data_read;
            break;
        case RMSC_TYPE:
            both.real = ((RMSCALLOC *) pblock)->data_read;
            break;
        case CS_TYPE:
            switch (field)
            {
                case 1:
                    both.real = ((CSALLOC *) pblock)->PV_read;
                    break;
                case 2:
                    both.real = ((CSALLOC *) pblock)->SP_read;
                    break;
                case 3:
                    both.real = ((CSALLOC *) pblock)->CO_read;
                    break;
                case 4:
                    both.real = ((CSALLOC *) pblock)->RI_read;
                    break;
            }
            break;
    }
    pvalue[0] = both.word[0];
    pvalue[1] = both.word[1];

    /* everything is ok. exit, returning the value. */
    if (mltrace[link] == 8)
        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, 0x%x:0x%x, V=%f\n",
                pointname, link, adapter, card, signal,
                both.word[0], both.word[1], both.real);
    return (0);
}

/*
**      AODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */

int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, double dvalue,
              unsigned short value, unsigned short conversion, unsigned char *resname)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

    unsigned short *pdata;

    unsigned short  blocktype;

    OUTQENT        *oqp;

    unsigned short  newindex, tb100, tb1;

    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned short  conversionerror;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;
    conversionerror = FALSE;

    switch (block)
    {
        case PSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case CIUPSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case LOOPPSEUDO:
            /* pcu=0, module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case PCUPSEUDO:
            /* module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case MODULEPSEUDO:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
                if (conversion != ASCFLT)
                    conversionerror = TRUE;
            }
            else
            {
                /* invalid block */
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((looptest) && ((loop < looptestmin) || (loop > looptestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter(Loop):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }
    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if (conversionerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d, V=%f, CNV=%d\n",
                    pointname, link, adapter, card, signal, dvalue, conversion);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats(link);
                }
                break;
            case 16: /* Force the PLC online/offline */
                pciu->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pciu->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;
           default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of pseudo point processing */

    /**************************************************/
    /* service bailey error pseudo points immediately */
    /**************************************************/
    if (card == CIUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initciustats(pciu);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal CIU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of ciu pseudo point processing */

    /*******************************************************/
    /* service bailey loop level pseudo points immediately */
    /*******************************************************/
    if (card == LOOPPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    initloopstats(ploop);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Loop Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of loop pseudo point processing */

    /******************************************************/
    /* service bailey pcu level pseudo points immediately */
    /******************************************************/
    if (card == PCUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    ppcu = ploop->pcus[pcu];
                    if (ppcu == NULL)
                    {
                         break;
                    }
                    initpcustats(ppcu);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal PCU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of pcu pseudo point processing */

    /*********************************************************/
    /* service bailey module level pseudo points immediately */
    /*********************************************************/
    if (card == MODULEPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    ppcu = ploop->pcus[pcu];
                    if (ppcu == NULL)
                    {
                         break;
                    }
                    pmodule = ppcu->modules[module];
                    if (pmodule == NULL)
                    {
                         break;
                    }
                    initmodulestats(pmodule);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Module Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of module pseudo point processing */

    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/

    /*************************************************/
    /* this leaves us to process 'real' data points. */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }

    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }

    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AODRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d, V=%f",
                        pointname, link, adapter, card, signal, dvalue);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    /*************************************************/
    /* finally, we have come to the last 'real' data */
    /* points: 'normal' blocks. If the block type is */
    /* NOT normal, then it is an error.              */
    /*************************************************/

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            typeerror = TRUE;
            break;
        case DER_TYPE:
            typeerror = TRUE;
            break;
        case RCM_TYPE:
            typeerror = TRUE;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_AONUM)))
                fielderror = TRUE;
            break;
        case CS_TYPE:
            if ((field > (CS_AONUM)))
                fielderror = TRUE;
            break;
        case DD_TYPE:
            typeerror = TRUE;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    /*************************************/
    /* driver call parameters validated. */
    /*************************************/
    blocktype = type;

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/

    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AODRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("AODRIVER: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%f, TYPE=%d\n",
                    pointname, link, adapter, card, signal, dvalue,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AODRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    /* check for bailey simulated mode. */
    if (baileysim [link])
    {
        if (mltrace [link] == 3)
        {
            logMsg("AODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        }
        return (0);
    }

    /* now see if we can actually make the request. */
    if (!pciu->is_responding)
    {
       if (trace[link] & CALLREJECTTRACE)
            logMsg("AODRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
       return (-1);
    }

    if (pciu->cmd_force_offline)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AODRIVER: Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    oqp = ogetemptyp (link);
    if (oqp == NULLP)
    {
        if (trace[link] & RUNTIMEERRORTRACE)
        {
            logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        }
        pciu->badoutcnt++;
        return (-1);               /* output queue is full */
    }

    oqp->otype      = blocktype;
    oqp->blocktype  = blocktype;
    oqp->tatetype   = ANALOG;
    oqp->index      = newindex;

    oqp->link       = link;
    oqp->adapter    = adapter;
    oqp->card       = card;
    oqp->signal     = signal;
    oqp->aovalue    = value;
    oqp->dblaovalue = dvalue;
    oqp->conversion = conversion;

    oqp->ploop      = ploop;
    oqp->ppcu       = ppcu;
    oqp->pmodule    = pmodule;
    oqp->pblock     = pblock;

    omarkfull (link);		/* Mark this entry as ready for output */

    if (mltrace [link] == 3)
    {
        logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                pointname, link, adapter, card, signal, dvalue);
    }
    return (0);
}

/*
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back        
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */

int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
            unsigned short card, unsigned short signal, unsigned short *pvalue,
            unsigned short conversion, unsigned char *resname)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

    unsigned short *pdata;

             short  zero = 0;
    unsigned short *pzero;

    unsigned short  newindex, tb100, tb1;

    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned short  conversionerror;

    pzero = &zero;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;
    conversionerror = FALSE;

    switch (block)
    {
        case PSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case CIUPSEUDO:
            /* loop=0, pcu=0, module=0 */
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case LOOPPSEUDO:
            /* pcu=0, module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case PCUPSEUDO:
            /* module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        case MODULEPSEUDO:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            if (conversion != AICNVINTEGER)
                conversionerror = TRUE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
                if (conversion != ASCFLT)
                    conversionerror = TRUE;
            }
            else
            {
                /* invalid block */
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((looptest) && ((loop < looptestmin) || (loop > looptestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal adapter(Loop):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (conversionerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            case 16: /* Force the PLC online/offline */
                *pvalue = pciu->cmd_force_offline;
                break;
           default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of pseudo point processing */

    /**************************************************/
    /* service bailey error pseudo points immediately */
    /**************************************************/
    if (card == CIUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal CIU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of ciu pseudo point processing */

    /*******************************************************/
    /* service bailey loop level pseudo points immediately */
    /*******************************************************/
    if (card == LOOPPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Loop Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of loop pseudo point processing */

    /******************************************************/
    /* service bailey pcu level pseudo points immediately */
    /******************************************************/
    if (card == PCUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal PCU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of pcu pseudo point processing */

    /*********************************************************/
    /* service bailey module level pseudo points immediately */
    /*********************************************************/
    if (card == MODULEPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Module Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of module pseudo point processing */

    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/

    /*************************************************/
    /* this leaves us to process 'real' data points. */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }

    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }

    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AOREAD: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            typeerror = TRUE;
            break;
        case DER_TYPE:
            typeerror = TRUE;
            break;
        case RCM_TYPE:
            typeerror = TRUE;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_AONUM)))
                fielderror = TRUE;
            break;
        case CS_TYPE:
            if ((field > (CS_AONUM)))
                fielderror = TRUE;
            break;
        case DD_TYPE:
            typeerror = TRUE;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*************************************/
    /* driver call parameters validated. */
    /*************************************/

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/
    
    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AOREAD: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("AOREAD: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d, TYPE=%d\n",
                    pointname, link, adapter, card, signal,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AOREAD: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* now see if we can actually make the request. */
    if (pciu->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AOREAD: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pciu->is_responding)
    {
       if (trace[link] & CALLREJECTTRACE)
            logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
       return (-1);
    }

    if (!((COMMONALLOC *) pblock)->control.data_valid)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AOREAD: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*********/
    /* Block */
    /*********/
    switch (type)
    {
        case RMSC_TYPE:
            *pvalue = *pzero; /* even though values are stored in structure, return zero */
            break;
        case CS_TYPE:
            *pvalue = *pzero; /* even though values are stored in structure, return zero */
            break;
    }
    /* everything is ok. exit, returning the value. */
    if (mltrace[link] == 8)
        logMsg("AOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                pointname, link, adapter, card, signal, *pvalue);
    return (0);
}
/*
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, unsigned long mask,
              unsigned long *pvalue, unsigned char *resname)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

    unsigned short *pdata;
    unsigned short  newindex, tb100, tb1;

    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned char   maskcount, maskerror;

    unsigned long   tvalue;

    unsigned short  rotate;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /* no mask value may span a byte boundary. */
    maskcount = 0;
    maskerror = TRUE;
    if (mask & 0x000000FF) maskcount++;
    if (mask & 0x0000FF00) maskcount++;
    if (mask & 0x00FF0000) maskcount++;
    if (mask & 0xFF000000) maskcount++;
    if (maskcount == 1) maskerror = FALSE;

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;

    switch (block)
    {
        case DATETIME:
            /* loop=0, pcu=0, module=0 */
            break;
        case PSEUDO:
            /* loop=0, pcu=0, module=0 */
            break;
        case MODULESTATUS:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
            }
            else
            {
                /* invalid block */
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIBRIVER: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIBRIVER: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the CIU values requested */
                *pvalue = pciu->control.was_requested;
                break;
            case 1: /* Is the CIU responding */
                *pvalue = pciu->is_responding;
                break;
            case 15: /* reset statistics */
                *pvalue = pciu->cmd_reset_stat;
                break;
            case 16: /* Force the CIU offline */
                *pvalue = pciu->cmd_force_offline;
                break;
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }    /* end of pseudo point processing */


    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/
    /* this leaves us to process 'real' data points:           */
    /* DATETIME, MODULESTATUS, and 'normal' blocks.            */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/

    /*************/
    /* Date/Time */
    /*************/

    if (card == DATETIME)
    {
        if ((signal < 1) || (signal >TIME_BINUM))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal Signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (maskerror)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal Mask:[%s] L=%d, A=%d, C=%d, S=%d, M=0x%x, MSKCNT=%d\n",
                        pointname, link, adapter, card, signal, mask, maskcount);
            return (-1);
        }

        pciu->time_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pciu->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pciu->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!pciu->control.data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        /* everything is ok. exit, returning the value. */

        tvalue = pciu->syncbyte;
        *pvalue = (unsigned long) tvalue & mask;

        if (mltrace[link] == 8)
            logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0], pvalue[1]);
        return (0);
    }
    /* end of date/time processing */

    /*************************************************/
    /* this leaves us to process 'real' data points: */
    /* MODULESTATUS and 'normal' blocks.             */
    /*************************************************/
    /*  (all of these types require pcu allocation)  */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }

    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }

    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BIDRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    /**********/
    /* Module */
    /**********/
    if (card == MODULESTATUS)
    {
        if ((signal < 1) || (signal >MODULE_BINUM))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIBRIVER: Illegal Signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (maskerror)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal Mask:[%s] L=%d, A=%d, C=%d, S=%d, M=0x%x, MSKCNT=%d\n",
                        pointname, link, adapter, card, signal, mask, maskcount);
            return (-1);
        }

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIBRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (pciu->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIBRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pciu->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIBRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!pmodule->control.data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIBRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }


        switch (field / 32)
        {
            case 0:  /*  1  -  32 */
                tvalue =  (unsigned long) pmodule->status[0];
                tvalue += (unsigned long) pmodule->status[1] << 8;
                tvalue += (unsigned long) pmodule->status[2] << 16;
                tvalue += (unsigned long) pmodule->status[3] << 24;
                break;
            case 1:  /* 33  -  64 */
                tvalue =  (unsigned long) pmodule->status[4];
                tvalue += (unsigned long) pmodule->detailstatus[0] << 8;
                tvalue += (unsigned long) pmodule->detailstatus[1] << 16;
                tvalue += (unsigned long) pmodule->detailstatus[2] << 24;
                break;
            case 2:  /* 65  -  96 */
                tvalue =  (unsigned long) pmodule->detailstatus[3];
                tvalue += (unsigned long) pmodule->detailstatus[4] << 8;
                tvalue += (unsigned long) pmodule->detailstatus[5] << 16;
                tvalue += (unsigned long) pmodule->detailstatus[6] << 24;
                break;
            case 3:  /* 97  - 128 */
                tvalue =  (unsigned long) pmodule->detailstatus[7];
                tvalue += (unsigned long) pmodule->detailstatus[8] << 8;
                tvalue += (unsigned long) pmodule->detailstatus[9] << 16;
                tvalue += (unsigned long) pmodule->detailstatus[10] << 24;
                break;
            default:
                tvalue = 0;
                break;
        }
        *pvalue = tvalue & mask;

        /* everything is ok. exit, returning the value. */
        if (mltrace[link] == 8)
            logMsg("BIBRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return (0);
    }  /* end of module status processing */


    /*************************************************/
    /* finally, we have come to the last 'real' data */
    /* points: 'normal' blocks. If the block type is */
    /* NOT normal, then it is an error.              */
    /*************************************************/

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            if ((field > (AER_BINUM)))
            fielderror = TRUE;
            break;
        case DER_TYPE:
            if ((field > (DER_BINUM)))
            fielderror = TRUE;
            break;
        case RCM_TYPE:
            if ((field > (RCM_BINUM)))
            fielderror = TRUE;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_BINUM)))
                fielderror = TRUE;
            break;
        case CS_TYPE:
            if ((field > (CS_BINUM)))
                fielderror = TRUE;
            break;
        case DD_TYPE:
            if ((field > (DD_BINUM)))
                fielderror = TRUE;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIBRIVER: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIBRIVER: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIBRIVER: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (maskerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal Mask:[%s] L=%d, A=%d, C=%d, S=%d, M=0x%x, MSKCNT=%d\n",
                    pointname, link, adapter, card, signal, mask, maskcount);
        return (-1);
    }

    /*************************************/
    /* driver call parameters validated. */
    /*************************************/

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/

    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BIBRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("AODRIVER: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d TYPE=%d\n",
                    pointname, link, adapter, card, signal,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIBRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pciu->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIBRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pciu->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIBRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (!((COMMONALLOC *) pblock)->control.data_valid)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIBRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* everything is ok. exit, returning the value. */

    /*********/
    /* Block */
    /*********/

    switch (type)
    {
        case AER_TYPE:
            rotate  = (AER_TYPE*1000)%32;
            tvalue  =  (unsigned long)  ((AERALLOC *) pblock)->status_read;
            break;

        case DER_TYPE:
            rotate  = (DER_TYPE*1000)%32;
            tvalue  =  (unsigned long)  ((DERALLOC *) pblock)->status_read;
            break;

        case RCM_TYPE:
            rotate  = (RCM_TYPE*1000)%32;
            tvalue  =  (unsigned long)  ((RCMALLOC *) pblock)->status_read[0];
            tvalue +=  (unsigned long) (((RCMALLOC *) pblock)->status_read[1]) << 8;
            tvalue +=  (unsigned long) (((RCMALLOC *) pblock)->status_read[2]) << 16;
            tvalue +=  (unsigned long) (((RCMALLOC *) pblock)->status_read[3]) << 24;
            break;

        case RMSC_TYPE:
            rotate  = (RMSC_TYPE*1000)%32;
           tvalue   =  (unsigned long) ((RMSCALLOC *) pblock)->status_read;
            break;

        case CS_TYPE:
            rotate  = (CS_TYPE*1000)%32;
            tvalue  =  (unsigned long)   ((CSALLOC *) pblock)->status_read[0];
            tvalue +=  (unsigned long)  (((CSALLOC *) pblock)->status_read[1]) << 8;
            break;

        case DD_TYPE:
            rotate  = (DD_TYPE*1000)%32;
            tvalue  =  (unsigned long)   ((DDALLOC *) pblock)->status_read[0];
            tvalue +=  (unsigned long)  (((DDALLOC *) pblock)->status_read[1]) << 8;
            tvalue +=  (unsigned long)  (((DDALLOC *) pblock)->status_read[2]) << 16;
            tvalue +=  (unsigned long)  (((DDALLOC *) pblock)->status_read[3]) << 24;
            break;
        default:
            rotate  = 0;
            tvalue  = 0;
            break;
    }

            tvalue = ((tvalue << rotate) | (tvalue >> (32 - rotate)));
            *pvalue = tvalue & mask;

    /* everything is ok. exit, returning the value. */
    if (mltrace[link] == 8)
        logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                pointname, link, adapter, card, signal, *pvalue);
    return (0);
}

/*
**      BODRIVER                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, unsigned long value,
              unsigned long mask, unsigned char *resname)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

    unsigned short *pdata;

    unsigned short  blocktype;

    OUTQENT        *oqp;

    unsigned short  newindex, tb100, tb1;

    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned char maskcount, maskerror;

    unsigned long rotate, shiftedmask, shiftedvalue;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /* no mask value may span a byte boundary. */
    maskcount = 0;
    maskerror = TRUE;
    if (mask & 0x000000FF) maskcount++;
    if (mask & 0x0000FF00) maskcount++;
    if (mask & 0x00FF0000) maskcount++;
    if (mask & 0xFF000000) maskcount++;
    if (maskcount == 1) maskerror = FALSE;

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;

    switch (block)
    {
        case PSEUDO:
            /* loop=0, pcu=0, module=0 */
            break;
        case CIUPSEUDO:
            /* loop=0, pcu=0, module=0 */
            break;
        case LOOPPSEUDO:
            /* pcu=0, module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            break;
        case PCUPSEUDO:
            /* module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            break;
        case MODULEPSEUDO:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
            }
            else
            {
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((looptest) && ((loop < looptestmin) || (loop > looptestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter(Loop):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats(link);
                }
                break;
            case 16: /* Force the PLC online/offline */
                pciu->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pciu->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;
           default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of pseudo point processing */

    /**************************************************/
    /* service bailey error pseudo points immediately */
    /**************************************************/
    if (card == CIUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initciustats(pciu);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal CIU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of ciu pseudo point processing */

    /*******************************************************/
    /* service bailey loop level pseudo points immediately */
    /*******************************************************/
    if (card == LOOPPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    initloopstats(ploop);
                }
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Loop Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of loop pseudo point processing */

    /******************************************************/
    /* service bailey pcu level pseudo points immediately */
    /******************************************************/
    if (card == PCUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    ppcu = ploop->pcus[pcu];
                    if (ppcu == NULL)
                    {
                         break;
                    }
                    initpcustats(ppcu);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal PCU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of pcu pseudo point processing */

    /*********************************************************/
    /* service bailey module level pseudo points immediately */
    /*********************************************************/
    if (card == MODULEPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    ploop = pciu->loops[loop];
                    if (ploop == NULL)
                    {
                         break;
                    }
                    ppcu = ploop->pcus[pcu];
                    if (ppcu == NULL)
                    {
                         break;
                    }
                    pmodule = ppcu->modules[module];
                    if (pmodule == NULL)
                    {
                         break;
                    }
                    initmodulestats(pmodule);
                }
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Module Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }   /* end of module pseudo point processing */

    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/

    /*************************************************/
    /* this leaves us to process 'real' data points. */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }

    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }

    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d, V=%d",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    /*************************************************/
    /* finally, we have come to the last 'real' data */
    /* points: 'normal' blocks. If the block type is */
    /* NOT normal, then it is an error.              */
    /*************************************************/

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            typeerror = TRUE;
            break;
        case DER_TYPE:
            typeerror = TRUE;
            break;
        case RCM_TYPE:
            if ((field > (RCM_BONUM)))
                fielderror = TRUE;
            /* shift data and mask before testing */
            rotate  = (RCM_TYPE*1000)%32;
            shiftedmask = mask >> rotate;
            if (shiftedmask != 0x03)
                maskerror = TRUE;
            shiftedvalue = (((value >> rotate) | (value << (32 - rotate)))) & 0x03;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_BONUM)))
                fielderror = TRUE;
            rotate  = (RMSC_TYPE*1000)%32;
            shiftedmask = mask >> rotate;
            if (shiftedmask > (0x0001 << RMSC_BINUM))
                maskerror = TRUE;
            shiftedvalue = (((value >> rotate) | (value << (32 - rotate)))) & ((0x0001 << RMSC_BINUM)-1);
            break;
        case CS_TYPE:
            if ((field > (CS_BONUM)))
                fielderror = TRUE;
            /* shift data and mask before testing */
            rotate  = (CS_TYPE*1000)%32;
            shiftedmask = mask >> rotate;
            if (shiftedmask != 0x0f)
                maskerror = TRUE;
            shiftedvalue = (((value >> rotate) | (value << (32 - rotate)))) & 0x0f;
            break;
        case DD_TYPE:
            if ((field > (DD_BONUM)))
                fielderror = TRUE;
            /* shift data and mask before testing */
            rotate  = (DD_TYPE*1000)%32;
            shiftedmask = mask >> rotate;
            if (shiftedmask != 0x0f)
                maskerror = TRUE;
            shiftedvalue = (((value >> rotate) | (value << (32 - rotate)))) & 0x0f;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (maskerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal Mask:[%s] L=%d, A=%d, C=%d, S=%d, V=%d, M=0x%x, MSKCNT=%d\n",
                    pointname, link, adapter, card, signal, value, mask, maskcount);
        return (-1);
    }

    /*************************************/
    /* driver call parameters validated. */
    /*************************************/
    blocktype = type;

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/
    
    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("BODRIVER: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d, TYPE=%d\n",
                    pointname, link, adapter, card, signal, value,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    /* check for bailey simulated mode. */
    if (baileysim [link])
    {
        if (mltrace [link] == 3)
        {
            logMsg("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        return (0);
    }

    /* now see if we can actually make the request. */
    if (!pciu->is_responding)
    {
       if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
       return (-1);
    }

    if (pciu->cmd_force_offline)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    oqp = ogetemptyp (link);
    if (oqp == NULLP)
    {
        if (trace[link] & RUNTIMEERRORTRACE)
        {
            logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        pciu->badoutcnt++;
        return (-1);               /* output queue is full */
    }

    oqp->otype      = blocktype;
    oqp->blocktype  = blocktype;
    oqp->tatetype   = BINARY;
    oqp->index      = newindex;

    oqp->link       = link;
    oqp->adapter    = adapter;
    oqp->card       = card;
    oqp->signal     = signal;
    oqp->mask       = shiftedmask;
    oqp->bovalue    = shiftedvalue;

    oqp->ploop      = ploop;
    oqp->ppcu       = ppcu;
    oqp->pmodule    = pmodule;
    oqp->pblock     = pblock;

    omarkfull (link);		/* Mark this entry as ready for output */

    if (mltrace [link] == 3)
    {
        logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, M=%d, V=%d\n",
                pointname, link, adapter, card, signal, shiftedmask, shiftedvalue);
    }
    return (0);
}
/*
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the digital output hardware. This is used to initialize digital  	
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */
int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
            unsigned short card, unsigned short signal, unsigned long *pvalue,
            unsigned long mask, unsigned char *resname)
{

    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;
    BLOCK100ALLOC  *pblock100;
    void           *pblock;

    unsigned short *pdata;

             short  zero = 0;
    unsigned short *pzero;

    unsigned short  newindex, tb100, tb1;

    unsigned short  loop,   looperror,   looptest,   looptestmin,   looptestmax;
    unsigned short  pcu,    pcuerror,    pcutest,    pcutestmin,    pcutestmax;
    unsigned short  module, moduleerror, moduletest, moduletestmin, moduletestmax;
    unsigned short  block,  blockerror,  blocktest,  blocktestmin,  blocktestmax;
    unsigned short  type,   typeerror,   typetest,   typetestmin,   typetestmax;
    unsigned short  field,  fielderror,  fieldtest,  fieldtestmin,  fieldtestmax;

    unsigned char maskcount, maskerror;

    pzero = &zero;

    /****************************/
    /* validate Line parameters */
    /****************************/

    if (link > HIGHLINE)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pciu = ciu [link];
    if (pciu == NULL)
    {
        if (!allocate_ciu (link))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pciu = ciu [link];
    }

    /* no mask value may span a byte boundary. */
    maskcount = 0;
    maskerror = TRUE;
    if (mask & 0x000000FF) maskcount++;
    if (mask & 0x0000FF00) maskcount++;
    if (mask & 0x00FF0000) maskcount++;
    if (mask & 0xFF000000) maskcount++;
    if (maskcount == 1) maskerror = FALSE;

    /*******************************************/
    /* validate Loop, PCU, & Module parameters */
    /*******************************************/

    loop          = adapter/1000;
    looperror     = FALSE;
    looptest      = TRUE;
    looptestmax   = 0;
    looptestmin   = 0;

    pcu           = (adapter/10)%100;
    pcuerror      = FALSE;
    pcutest       = TRUE;
    pcutestmax    = 0;
    pcutestmin    = 0;

    module        = adapter%10;
    moduleerror   = FALSE;
    moduletest    = TRUE;
    moduletestmin = 0;
    moduletestmax = 0;

    block         = card;
    blockerror    = FALSE;

    switch (block)
    {
        case PSEUDO:
             /* loop=0, pcu=0, module=0 */
            break;
        case CIUPSEUDO:
            /* loop=0, pcu=0, module=0 */
            break;
        case LOOPPSEUDO:
            /* pcu=0, module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            break;
        case PCUPSEUDO:
            /* module=0 */
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            break;
        case MODULEPSEUDO:
            looptestmin = LOWLOOP;
            looptestmax = HIGHLOOP;
            pcutestmin = LOWPCU;
            pcutestmax = HIGHPCU;
            moduletestmin = LOWMODULE;
            moduletestmax = HIGHMODULE;
            break;
        default:
            if (block <= HIGHBLOCK)
            {
                /* 'normal data' */
                looptestmin = LOWLOOP;
                looptestmax = HIGHLOOP;
                pcutestmin = LOWPCU;
                pcutestmax = HIGHPCU;
                moduletestmin = LOWBLOCKMODULE;
                moduletestmax = HIGHBLOCKMODULE;
            }
            else
            {
                /* invalid block */
                blockerror = TRUE;
                looptest   = FALSE;
                pcutest    = FALSE;
                moduletest = FALSE;
            }
            break;
    }

    if ((looptest) && ((loop < looptestmin) || (loop > looptestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter(Loop):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((pcutest) && ((pcu < pcutestmin) || (pcu > pcutestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter(PCU):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((moduletest) && ((module < moduletestmin) || (module > moduletestmax)))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter(Module):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (blockerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*************************************/
    /* service pseudo points immediately */
    /*************************************/
    if (card == PSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            case 16: /* Force the PLC online/offline */
                *pvalue = pciu->cmd_force_offline;
                break;
           default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of pseudo point processing */

    /**************************************************/
    /* service bailey error pseudo points immediately */
    /**************************************************/
    if (card == CIUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal CIU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of ciu pseudo point processing */

    /*******************************************************/
    /* service bailey loop level pseudo points immediately */
    /*******************************************************/
    if (card == LOOPPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Loop Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of loop pseudo point processing */

    /******************************************************/
    /* service bailey pcu level pseudo points immediately */
    /******************************************************/
    if (card == PCUPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal PCU Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of pcu pseudo point processing */

    /*********************************************************/
    /* service bailey module level pseudo points immediately */
    /*********************************************************/
    if (card == MODULEPSEUDO)
    {
        switch (signal)
        {
            case RESETSTATISTICS: /* Reset the accumulated statistics */
                *pvalue = *pzero;
                break;
            /* no error */
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Module Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }   /* end of module pseudo point processing */

    /***********************************************************/
    /* all driver calls for pseudo points have been processed. */
    /***********************************************************/

    if (resname != 0)
    { 
        register_resource(link, resname, pointname);
    }

    /*************************************/
    /*************************************/
    pciu->control.was_requested = TRUE;/**/
    /*************************************/
    /*************************************/

    /*************************************************/
    /* this leaves us to process 'real' data points. */
    /*************************************************/

    ploop = pciu->loops[loop];
    if (ploop == NULL)
    {
        if (!allocate_loop (link, loop))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ploop = pciu->loops[loop];

        /* register the driver call parameters from the first time the loop was referenced */
        ploop->control.address = adapter;
        ploop->control.card    = card;
        ploop->control.signal  = signal;

        ploop->control.loop    = loop;
    }

    /**************************************************************************/
    /* whether or not the loop data structure was allocated before, it is now.*/
    /* note: loops do not have Host-CIU data query commands associated with   */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL)
    {
        if (!allocate_pcu (link, ploop, pcu))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        ppcu = ploop->pcus[pcu];

        /* register the driver call parameters from the first time the pcu was referenced */
        ppcu->control.address = adapter;
        ppcu->control.card    = card;
        ppcu->control.signal  = signal;

        ppcu->control.loop    = loop;
        ppcu->control.pcu     = pcu;
    }

    /**************************************************************************/
    /* whether or not the pcu data structure was allocated before, it is now. */
    /* note: pcus do not have Host-CIU data query commands associated with    */
    /*       them (unlike blocks and modules). Therefore we do not assign an  */
    /*       index value to them as we do the others.                         */ 
    /**************************************************************************/

    pmodule = ppcu->modules[module];
    if (pmodule == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BOREAD: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_module (link, ppcu, module))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmodule = ppcu->modules[module];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pmodule;  /* (cast doesn't seem to be needed)           */
        pmodule->control.index = newindex;     /* will be used when establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the module was referenced */
        pmodule->control.address = adapter;
        pmodule->control.card    = card;
        pmodule->control.signal  = signal;

        pmodule->control.loop    = loop;
        pmodule->control.pcu     = pcu;
        pmodule->control.module  = module;

        /* Notice that when a new block for a new module is referenced, both the module      */
        /*  and the block are put in the indextable.                                         */

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */
    }

    if ((card < LOWBLOCK) || (card > HIGHBLOCK))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal Card(Block):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /**************************************/
    /* validate Type and Field parameters */
    /**************************************/

    type = signal/1000;
    field = signal%1000;
    typeerror = FALSE;
    fielderror = FALSE;

    switch (type)
    {
        case AER_TYPE:
            typeerror = TRUE;
            break;
        case DER_TYPE:
            typeerror = TRUE;
            break;
        case RCM_TYPE:
            if ((field > (RCM_BONUM)))
                fielderror = TRUE;
            break;
        case RMSC_TYPE:
            if ((field > (RMSC_BONUM)))
                fielderror = TRUE;
            break;
        case CS_TYPE:
            if ((field > (CS_BONUM)))
                fielderror = TRUE;
            break;
        case DD_TYPE:
            if ((field > (DD_BONUM)))
                fielderror = TRUE;
            break;
        default:
            typeerror = TRUE;
            break;
    }

    if (typeerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal signal(Type):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (field == 0)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal signal(Field=0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (fielderror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal signal(Field):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (maskerror)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal Mask:[%s] L=%d, A=%d, C=%d, S=%d, M=0x%x, MSKCNT=%d\n",
                    pointname, link, adapter, card, signal, mask, maskcount);
        return (-1);
    }

    /*************************************/
    /* driver call parameters validated. */
    /*************************************/

    /****************************************/
    /* Allocate Block level data structure. */
    /****************************************/

    tb100 = card/NUMBLOCKALLOC;
    tb1 = card%NUMBLOCKALLOC;

    pblock100 = pmodule->blocks100[tb100];
    if (pblock100 == NULL)
    {
        if (!allocate_block100 (link, pmodule, tb100))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock100 = pmodule->blocks100[tb100];
    }

    pblock = pblock100->blocks[tb1];
    if (pblock == NULL)
    {
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BOREAD: Maximum Index Exceeded:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!allocate_block (link, pblock100, tb1, type))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pblock = pblock100->blocks[tb1];

        /* handle the index stuff */
        taskLock ();                           /* insure assigned index values are unique.   */
        /* see if we are out of indices. if we are, we can't go on. */
        if ((pciu->nextindex) >= MAXINDEX) return (-1);
        newindex = pciu->nextindex++;          /* get this value, and bump next available.   */
        pciu->indextable[newindex] = pblock;   /* (cast doesn't seem to be needed)           */
        ((COMMONALLOC *) pblock)->control.index = newindex;  /* use establishing connection. */
        taskUnlock ();

        /* register the driver call parameters from the first time the block was referenced */
        ((COMMONALLOC *) pblock)->control.address = adapter;
        ((COMMONALLOC *) pblock)->control.card    = card;
        ((COMMONALLOC *) pblock)->control.signal  = signal;

        ((COMMONALLOC *) pblock)->control.loop    = loop;
        ((COMMONALLOC *) pblock)->control.pcu     = pcu;
        ((COMMONALLOC *) pblock)->control.module  = module;
        ((COMMONALLOC *) pblock)->control.block   = card;
        ((COMMONALLOC *) pblock)->control.element = field;

        /* Notice that nothing here actually sends a message to the CIU. That happens in     */
        /*  the scan_ciu code, where we walk through the index table looking for things      */
        /*  that haven't been established and connected yet. When we find them, we           */
        /*  establish and connect them, and set the flags appropriately in the module/or     */
        /*  block data structure control area.                                               */

        /* If the index assignment fails, we never get to this point. Therefore, we will go  */
        /*  through this same attempted index assignment. this goes on until a new on_line   */
        /*  is issued. given the current customer system configuration, running out of       */
        /*  indices 'should' never occur.                                                    */
    }
    /* end of block level memory allocation and index entry. */

    /**********************************************************************************************/
    /* pointer tables and data structures were previously allocated, or just have been allocated. */
    /**********************************************************************************************/


    if (((COMMONALLOC *) pblock)->control.type != type)
    {
        if (trace[link] & (CONFIGURATIONTRACE | RUNTIMEERRORTRACE))
            logMsg("BOREAD: Block Type Conflict(1):[%s] L=%d, A=%d, C=%d, S=%d, TYPE=%d\n",
                    pointname, link, adapter, card, signal,
                    ((COMMONALLOC *) pblock)->control.type);
        return (-1);
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /* now see if we can actually make the request. */
    if (pciu->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pciu->is_responding)
    {
       if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
       return (-1);
    }

    if (!((COMMONALLOC *) pblock)->control.data_valid)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    /*********/
    /* Block */
    /*********/
    switch (type)
    {
        case RCM_TYPE:
            *pvalue = *pzero;
            break;
        case RMSC_TYPE:
            *pvalue = *pzero;
            break;
        case CS_TYPE:
            *pvalue = *pzero;
            break;
        case DD_TYPE:
            *pvalue = *pzero;
            break;
    }

    /* everything is ok. exit, returning the value. */
    if (mltrace[link] == 8)
        logMsg("BOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                pointname, link, adapter, card, signal, *pvalue);
    return (0);
}

/*
** register_resource
**
**  This routine is used to initialize the resource pointers. If this is the first time the resource 
**  for this line is being referenced the pointer to the resource table entry will be set and the
**  resource name will be saved. If the resource name has already been set, this routine will verify
**  that all other points for this driver are using the same resource name.
**
*/
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER, and BOREAD.
*/                               	

static void  register_resource (unsigned short link, unsigned char *resname, char *pointname)
{
    CIUALLOC   *pciu;

    pciu = ciu [link];

    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                     pointname, resname );
        }
        else
        {
            strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                     resnames[link], pointname, resname );
        }
    }
}


/*
**      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
    oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
    if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
    {
        return (&oq [line]->outque[oq [line]->oinix]);
    }
    if (mltrace [line] == 11)
    {
        logMsg ( "Output Queue Full\n");
    }
    return (NULLP);
}


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
    oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
    if (oq [line]->ooutix != oq [line]->oinix)
    {
        return (&oq [line]->outque[oq [line]->ooutix]);
    }
    else
    {
        return (NULLP);
    }
}


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
    if (oq [line]->ooutix == oq [line]->oinix)
    {
        return;
    }
    oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}
/*                                                          			
**      link_status                                                           	
**                                                                            	
**      The purpose of this routine is to print out the state of each of the  	
**      analog devices lines and the statistics gathered about them.         	
**                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
{
    if (line > HIGHLINE)
    {
        return;
    }
}

/*
**                                                                              
**	allocate_ciu                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	CIU data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_ciu (unsigned short line)
{
    CIUALLOC     *pciu;
    LOOPALLOC    *ploop;
    PCUALLOC     *ppcu;
    MODULEALLOC  *pmodule;

    pciu = (CIUALLOC *) calloc (1, (sizeof (CIUALLOC)));

    if (!pciu)
    {
        if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
            logMsg ("Unable to allocate memory for CIU data structure on line %d\n", line);
        return(FALSE);
    }
    else
    {
        if (trace[line] & CIUALLOCTRACE)
            logMsg ("Allocated memory for CIU data structure on line %d\n",line);
        ciu [line] = pciu;
        init_ciu_tab (pciu);	     /*	initialize the data structures. */

        if (!allocate_loop (line, 0))
        {
            return (FALSE); /* if can't allocate, report error. */
        }
        ploop = pciu->loops[0];

        if (!allocate_pcu (line, ploop, 0))
        {
            return (FALSE); /* if can't allocate, report error. */
        }
        ppcu = ploop->pcus[0];

        if (!allocate_module (line, ppcu, 0))
        {
            return (FALSE); /* if can't allocate, report error. */
        }

        /***********************************/
        /* Initialize this tasks semaphore */
        /***********************************/
        semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
        semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    }
    return (TRUE);
}

/*
**                                                                              
**	allocate_loop                                                           
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	Loop data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_loop (unsigned short line, unsigned short loop)
{
    CIUALLOC  *pciu;
    LOOPALLOC *ploop;

    pciu = ciu [line];

    ploop = (LOOPALLOC *) calloc (1, (sizeof (LOOPALLOC)));
    if (!ploop)
    {
        if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
            logMsg ("Unable to allocate memory for Loop (%d) data structure on line %d\n",
                     loop, line );
        return(FALSE);
    }
    else
    {
        if (trace[line] & CIUALLOCTRACE)
            logMsg ("Allocated memory for Loop (%d) data structure on line %d\n", loop, line);
        pciu->loops[loop] = ploop;
        init_loop_tab (ploop);	     /*	initialize the data structures. */
    }

    return (TRUE);
}
/*
**                                                                              
**	allocate_pcu                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	PCU data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_pcu (unsigned short line, LOOPALLOC  *ploop, unsigned short pcu)
{
    PCUALLOC  *ppcu;

    ppcu = (PCUALLOC *) calloc (1, (sizeof (PCUALLOC)));
    if (!ppcu)
    {
        if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
            logMsg ("Unable to allocate memory for PCU (%d) data structure on line %d\n",
                     pcu, line );
        return(FALSE);
    }
    else
    {
        if (trace[line] & CIUALLOCTRACE)
            logMsg ("Allocated memory for PCU (%d) data structure on line %d\n", pcu, line);
        ploop->pcus[pcu] = ppcu;
        init_pcu_tab (ppcu);	     /*	initialize the data structures. */
    }

    return (TRUE);
}

/*
**                                                                              
**	allocate_module                                                         
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	module data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_module (unsigned short line, PCUALLOC  *ppcu, unsigned short module)
{
    MODULEALLOC  *pmodule;

    pmodule = (MODULEALLOC *) calloc (1, (sizeof (MODULEALLOC)));
    if (!pmodule)
    {
        if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
            logMsg ("Unable to allocate memory for Module (%d) data structure on line %d\n",
                     module, line );
        return(FALSE);
    }
    else
    {
        if (trace[line] & CIUALLOCTRACE)
            logMsg ("Allocated memory for Module (%d) data structure on line %d\n", module, line );
        ppcu->modules[module] = pmodule;
        init_module_tab (pmodule);	     /*	initialize the data structures. */
    }
    return (TRUE);
}

/*
**                                                                              
**	allocate_block100                                                       
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	block100 data structure. If not successful, a console error message 	
**	is printed and an error flag is returned to the caller.                 
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_block100 (unsigned short line, MODULEALLOC  *pmodule, unsigned short block100)
{
    BLOCK100ALLOC  *pblock100;

    pblock100 = (BLOCK100ALLOC *) calloc (1, (sizeof (BLOCK100ALLOC)));
    if (!pblock100)
    {
        if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
            logMsg ("Unable to allocate memory for Block100 (%d) data structure on line %d\n",
                     block100, line );
        return(FALSE);
    }
    else
    {
        if (trace[line] & CIUALLOCTRACE)
            logMsg ("Allocated memory for Block100 (%d) data structure on line %d\n", block100, line);
        pmodule->blocks100[block100] = pblock100;
        init_block100_tab (pblock100);	     /*	initialize the data structures. */
    }
    return (TRUE);
}

/*
**                                                                              
**	allocate_block                                                          
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	block data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/
static int allocate_block (unsigned short line, BLOCK100ALLOC  *pblock100,
                           unsigned short block, unsigned short type)
{
    void    *pblock;

    switch (type)
    {
        case AER_TYPE:
            pblock = (AERALLOC *) calloc (1, (sizeof (AERALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for AER Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for AER Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_aer_tab ((AERALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;

        case DER_TYPE:
            pblock = (DERALLOC *) calloc (1, (sizeof (DERALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for DER Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for DER Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_der_tab ((DERALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;

        case RCM_TYPE:
            pblock = (RCMALLOC *) calloc (1, (sizeof (RCMALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for RCM Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for RCM Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_rcm_tab ((RCMALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;

        case RMSC_TYPE:
            pblock = (RMSCALLOC *) calloc (1, (sizeof (RMSCALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for RMSC Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for RMSC Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_rmsc_tab ((RMSCALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;

        case CS_TYPE:
            pblock = (CSALLOC *) calloc (1, (sizeof (CSALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for CS Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for CS Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_cs_tab ((CSALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;

        case DD_TYPE:
            pblock = (DDALLOC *) calloc (1, (sizeof (DDALLOC)));
            if (!pblock)
            {
                if (trace[line] & (CIUALLOCTRACE | CIUALLOCERRORTRACE))
                    logMsg ("Unable to allocate memory for DD Block (%d) on line %d\n",
                             block, line);
                return(FALSE);
            }
            else
            {
                if (trace[line] & CIUALLOCTRACE)
                    logMsg ("Allocated memory for DD Block (%d) on line %d\n", block, line);
                pblock100->blocks[block] = pblock;
                init_dd_tab ((DDALLOC *) pblock); /* initialize the data structures. */
            }
            return (TRUE);
            break;
    }
}

/*
**                                                                          
**    init_ciu_tab                                                          
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    the ciu data structure.                                               
**                                                                          
*/
static void init_ciu_tab (CIUALLOC  *pciu)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pciu->control.address       = 0;
    pciu->control.card          = 0;
    pciu->control.signal        = 0;
    pciu->control.loop          = 0;
    pciu->control.pcu           = 0;
    pciu->control.module        = 0;
    pciu->control.block         = 0;
    pciu->control.type          = 0;
    pciu->control.element       = 0;
    pciu->control.index         = 0;
    pciu->control.was_requested = FALSE;
    pciu->control.established   = FALSE;
    pciu->control.connected     = FALSE;
    pciu->control.data_valid    = FALSE;

    /* initialize the type-specific data structures. */
    pciu->holdflag              = FALSE;
    pciu->is_responding         = FALSE;
    pciu->cmd_force_offline     = FALSE;

    pciu->lastconnected         = 0; /* CIU is always index zero */
    pciu->nextindex             = 1;

    pciu->ploop                 = 0;
    pciu->ppcu                  = 0;
    pciu->pmodule               = 0;
    pciu->pblock                = 0;

    pciu->time_requested        = FALSE;
    pciu->time_valid            = FALSE;
    pciu->syncbyte              = 0;
    pciu->year                  = 0;
    pciu->month                 = 0;
    pciu->day                   = 0;
    pciu->day_of_week           = 0;
    pciu->hour                  = 0;
    pciu->minute                = 0;
    pciu->second                = 0;
    pciu->sample_number         = 0;
    pciu->time_sync_master      = 0;


    /* initialize pointer table to lower data structures. */
    for (i = 0; i < HIGHLOOP; i++)
    {
        pciu->loops[i]  = 0;
    }

    /* initialize the type-specific statistics. */
    initciustats (pciu);
}

/*
**                                                                          
**    init_loop_tab                                                         
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    the loop data structure.                                              
**                                                                          
*/
static void init_loop_tab (LOOPALLOC  *ploop)
{
    unsigned short i;

    /*	initialize the common data structures. */
    ploop->control.address       = 0;
    ploop->control.card          = 0;
    ploop->control.signal        = 0;
    ploop->control.loop          = 0;
    ploop->control.pcu           = 0;
    ploop->control.module        = 0;
    ploop->control.block         = 0;
    ploop->control.type          = 0;
    ploop->control.element       = 0;
    ploop->control.index         = 0;
    ploop->control.was_requested = TRUE;
    ploop->control.established   = FALSE;
    ploop->control.connected     = FALSE;
    ploop->control.data_valid    = FALSE;

    /* initialize the type-specific data structures. */
    ploop->is_responding    = TRUE;

    /* initialize pointer table to lower data structures. */
    for (i = 0; i < HIGHPCU; i++)
    {
        ploop->pcus[i]  = 0;
    }

    /* initialize the type-specific statistics. */
    initloopstats (ploop);
}
/*
**                                                                          
**    init_pcu_tab                                                          
**                                                                          
**    The purpose of this routine is to initialize the data within          
**    the pcu data structure.                                               
**                                                                          
*/
static void init_pcu_tab (PCUALLOC  *ppcu)
{
    unsigned short i;

    /*	initialize the common data structures. */
    ppcu->control.address       = 0;
    ppcu->control.card          = 0;
    ppcu->control.signal        = 0;
    ppcu->control.loop          = 0;
    ppcu->control.pcu           = 0;
    ppcu->control.module        = 0;
    ppcu->control.block         = 0;
    ppcu->control.type          = 0;
    ppcu->control.element       = 0;
    ppcu->control.index         = 0;
    ppcu->control.was_requested = TRUE;
    ppcu->control.established   = FALSE;
    ppcu->control.connected     = FALSE;
    ppcu->control.data_valid    = FALSE;

    /* initialize the type-specific data structures. */
    ppcu->is_responding = TRUE;

    /* initialize pointer table to lower data structures. */
    for (i = 0; i < HIGHMODULE; i++)
    {
        ppcu->modules[i] = 0;
    }

    /* initialize the type-specific statistics. */
    initpcustats (ppcu);
}

/*
**                                                                          
**    init_module_tab                                                       
**                                                                          
**    The purpose of this routine is to initialize the data within          
**    the module data structure.                                            
**                                                                          
*/
static void init_module_tab (MODULEALLOC  *pmodule)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pmodule->control.address       = 0;
    pmodule->control.card          = 0;
    pmodule->control.signal        = 0;
    pmodule->control.loop          = 0;
    pmodule->control.pcu           = 0;
    pmodule->control.module        = 0;
    pmodule->control.block         = 0;
    pmodule->control.type          = MODULE_TYPE;
    pmodule->control.CIUpoint      = CPT_MODULESTATUS;
    pmodule->control.element       = 0;
    pmodule->control.index         = 0;
    pmodule->control.was_requested = TRUE;
    pmodule->control.established   = FALSE;
    pmodule->control.connected     = FALSE;
    pmodule->control.data_valid    = FALSE;

    /* initialize the type-specific data structures. */
    pmodule->holdflag = TRUE; /*   The Module data is in hold   */

    for (i = 0; i < 5; i++)
    {
        pmodule->status[i];
    }
    for (i = 0; i < 11; i++)
    {
        pmodule->detailstatus[i];
    }

    /* initialize pointer table to lower data structures. */
    for (i = 0; i < HIGHBLOCK/NUMBLOCKALLOC; i++)
    {
        pmodule->blocks100[i] = 0;
    }

    /* initialize the type-specific statistics. */
    initmodulestats (pmodule);
}
/*
**                                                                          
**    init_block100_tab                                                     
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    block100 data structure.                                              
**                                                                          
*/
static void init_block100_tab (BLOCK100ALLOC *pblock100)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock100->control.address       = 0;
    pblock100->control.card          = 0;
    pblock100->control.signal        = 0;
    pblock100->control.loop          = 0;
    pblock100->control.pcu           = 0;
    pblock100->control.module        = 0;
    pblock100->control.block         = 0;
    pblock100->control.type          = 0;
    pblock100->control.element       = 0;
    pblock100->control.index         = 0;
    pblock100->control.was_requested = TRUE;
    pblock100->control.established   = FALSE;
    pblock100->control.connected     = FALSE;
    pblock100->control.data_valid    = FALSE;

    /* initialize pointer table to lower data structures. */
    for (i = 0; i < NUMBLOCKALLOC; i++)
    {
        pblock100->blocks[i] = 0;
    }
}

/*
**                                                                          
**    init_aer_tab                                                          
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    AER block data structure. the pointer table structure is not          
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_aer_tab (AERALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = AER_TYPE;
    pblock->control.CIUpoint      = CPT_ANALOGREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    pblock->status_read = 0;
    for (i = 0; i < 3; i++)
    {
        pblock->raw_read[i] = 0;
    }
    pblock->data_read = 0;
}

/*
**                                                                          
**    init_der_tab                                                          
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    DER block data structure. the pointer table structure is not          
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_der_tab (DERALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = DER_TYPE;
    pblock->control.CIUpoint      = CPT_DIGITALREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    pblock->status_read = 0;
}

/*
**                                                                          
**    init_rcm_tab                                                          
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    RCM block data structure. the pointer table structure is not          
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_rcm_tab (RCMALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = RCM_TYPE;
    pblock->control.CIUpoint      = CPT_RCMREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    for (i = 0; i < 5; i++)
    {
        pblock->status_read[i];
    }
    pblock->status_write = 0;
}

/*
**                                                                          
**    init_rmsc_tab                                                         
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    RMSC block data structure. the pointer table structure is not         
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_rmsc_tab (RMSCALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = RMSC_TYPE;
    pblock->control.CIUpoint      = CPT_RMSCREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    pblock->status_read      = 0;
    pblock->status_write     = 0;
    pblock->data_read        = 0;
    pblock->data_write       = 0;
    for (i = 0; i < 3; i++)
    {
        pblock->raw_read[i]  = 0;
        pblock->raw_write[i] = 0;
    }
}

/*
**                                                                          
**    init_cs_tab                                                           
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    CS block data structure. the pointer table structure is not           
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_cs_tab (CSALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = CS_TYPE;
    pblock->control.CIUpoint      = CPT_SISTATIONREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    pblock->status_read[0] = 0;
    pblock->status_read[1] = 0;
    pblock->PV_read  = 0;
    pblock->SP_read  = 0;
    pblock->CO_read  = 0;
    pblock->RI_read  = 0;
    pblock->SP_write = 0;
    pblock->RI_write = 0;
    pblock->CO_write = 0;
    for (i = 0; i < 3; i++)
    {
        pblock->PVraw_read[0]  = 0;
        pblock->SPraw_read[1]  = 0;
        pblock->COraw_read[2]  = 0;
        pblock->RIraw_read[2]  = 0;
        pblock->SPraw_write[1] = 0;
        pblock->RIraw_write[2] = 0;
        pblock->COraw_write[2] = 0;
    }
    pblock->status_write = 0;
}
/*
**                                                                          
**    init_dd_tab                                                           
**                                                                          
**    The purpose of this routine is to initialize the data within the      
**    DD block data structure. the pointer table structure is not           
**    initialized here to make reuse after a CIURESTART command simpler.    
**                                                                          
*/
static void init_dd_tab (DDALLOC *pblock)
{
    unsigned short i;

    /*	initialize the common data structures. */
    pblock->control.address       = 0;
    pblock->control.card          = 0;
    pblock->control.signal        = 0;
    pblock->control.loop          = 0;
    pblock->control.pcu           = 0;
    pblock->control.module        = 0;
    pblock->control.block         = 0;
    pblock->control.type          = DD_TYPE;
    pblock->control.CIUpoint      = CPT_RCMREAD;
    pblock->control.element       = 0;
    pblock->control.index         = 0;
    pblock->control.was_requested = TRUE;
    pblock->control.established   = FALSE;
    pblock->control.connected     = FALSE;
    pblock->control.data_valid    = FALSE;

    /*	initialize the type-specific data structures. */
    for (i = 0; i < 5; i++)
    {
        pblock->status_read[i];
    }
    pblock->status_write = 0;
}


/*                                                                                              
**    makechecksum                                                                              
**                                                                                              
*/
/* called from msgxfer, baileyrestart, readcoils, readdis, readais, readregs, setcoil, & setreg
*/

static	void makechecksum (unsigned char *srcbuf, unsigned short srclen,
                           unsigned char *retbuf, unsigned short *retlen)
{
    unsigned short  checksum;
    unsigned short  i, j;

    i = 0;
    checksum = 0x0000;
    for (j = 0; j < srclen; j++)
    {
        checksum += srcbuf[j];
        switch (srcbuf[j])
        {
            case 0x0d:
                retbuf[i++] = 0x1b;
                retbuf[i++] = 0x0e;
                break;
            case 0x1b:
                retbuf[i++] = 0x1b;
                retbuf[i++] = 0x1b;
                break;
            default:
                retbuf[i++] = srcbuf[j];
                break;
        }
    }

    checksum = checksum%256;

    switch (checksum)
    {
        case 0x0d:
            retbuf[i++] = 0x1b;
            retbuf[i++] = 0x0e;
            break;
        case 0x1b:
            retbuf[i++] = 0x1b;
            retbuf[i++] = 0x1b;
            break;
        default:
            retbuf[i++] = checksum;
            break;
    }
    retbuf[i++] = 0x0d;
    *retlen = i;
    return;
}

/*                                                                                              
**    checkchecksum                                                                              
**                                                                                              
*/
/* only called from msgxfer   
*/

static	int checkchecksum (unsigned char *srcbuf, unsigned short srclen,
                           unsigned char *retbuf, unsigned short *retlen)

{
    unsigned short  checksum, thischar;
    unsigned short  i, j;

    i = 0;
    *retlen = 0;

    checksum = 0x0000;
    for (j = 0; j < srclen+1; j++)
    {
        thischar = srcbuf[j];
        if (thischar == 0x1b)
        {
            switch (srcbuf[j+1])
            {
                case 0x0e:
                    j++;
                    thischar = 0x0d;
                    break;
                case 0x1b:
                    j++;
                    thischar = 0x1b;
                    break;
                default:
                    return (FALSE);     /* if not one of these two, something is wrong. */
            }
        }
        retbuf[i++] = thischar;
        /* if this character is the checksum, don't include it in the checksum calculation. */
        if (srcbuf[j+1] == 0x0d)
        {
            break;
        }            
        checksum += thischar;
    }
    if ((checksum%256) == thischar)
    {
        *retlen = i;
        return (TRUE);
    }
    return (FALSE);
}

/*                                                                   		
**      start_rx                                                                
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus )
{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
        rxp->rxmsglen = rxp->rxmsglenexpected;
	rxp->rxstate = RXRECEIVE;
}

/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
    }

/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

        linestats [line].RXintcount++;

	rxp = rxlinetab [line];

	/* Something is sending in data */
        activity_tick[line] = tickGet();
        recent_activity[line] = TRUE;

	if (rxp->rxstate == RXIGNORE)
	{
	    return;
	}
        /* no matter what the state, errors cause a logical reset of the message processing */
        if ((rxstat & rx_err_mask) != 0)
	{
	    rxp->rxstate = RXRECEIVE;/* if comm goes bad, assume it was garbage,  */
                                     /* and go wait for the good stuff.           */ 
            rxp->rxix = 0;           /* reset the buffer index/counter            */
            rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.*/
	    return;
	}

	rxp->rxbuf [rxp->rxix++] = rxchar;/* store the character in the buffer and bump the index. */
	rxp->rxmsglen--;                  /* decrement the message length counter.                 */

        if (rxchar == 0x0d)
        {
            *(rxp->status) = RXGOOD;
            rxp->rxstate = RXIGNORE;
            semGive (rxp->semid);
            return;
        }

        if (rxp->rxmsglen == 0)
        {
            *(rxp->status) = RXGOOD;
            rxp->rxstate = RXIGNORE;
            semGive (rxp->semid);
            return;
        }
	return;                         /* simple return from interrupt. */
}

/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE        *rxp;
    unsigned long  thistime;
    short          status;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;

    if (predelay != 0)
        taskDelay (predelay);

    thistime = tickGet ();

    if ((thistime - activity_tick[line]) < ACTIVITYTIME)
    {
        recent_activity[line] = TRUE;
        return (TRUE);
    }
    return (FALSE);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */

static void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )
{

    TXLINE     *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;

    enable_tx_ints (line);
}


/*                                                                              
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/
/* only called from msgxfer  */


static void stop_tx (unsigned short line )
{
    TXLINE     *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;
}

/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc ( unsigned short line )

{
    char            txchar;
    unsigned short          txstat;
    unsigned short          tx_err_mask;
    TXLINE                  *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];
    if (txp->txdisable)
    {
        return;
    }
    if (txp->txix == txp->txmsglen)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }
    else
    {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
    }

    if (txp->txix >= MAXTXMSG)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXBAD;
        semGive (txp->semid);
        return;
    }
}


/*                                                                              
**      msgxfer                                                                 
**                                                                              
**      The purpose of this routine is to transmit a buffer to the              
**      Bailey CIU and to await a response. The transmit and receive            
**      buffers are in their respective line tables. This routine will retry    
**      the message up to a maximum number of times or until a response         
**      is received with a proper checksum.                                     
**              returns         XFERGOOD if response received                   
**                              XFERBAD  if no good response is received        
**                                                                              
*/
/* called from baileyrestart, readcoils, readdis, readais, readregs, setcoil, & setreg */

static unsigned short msgxfer (unsigned short line)
{
    CIUALLOC      *pciu;

    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, fline, ix, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    unsigned char   csums [2];
    unsigned short  oldrxix;
    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned short  retryflag;
    unsigned short  msglen, reply, replyclass;
    int             receivetimeout;
    unsigned char   localtrace, alltrace;

    /* initialize all pointers for current values */
    pciu = ciu [line];

    delta40 = delta01 = delta12 = delta23 = delta34 = 0;
    rxp = rxlinetab [line];
    txp = txlinetab [line];

    /* establish receive timeout */
    if (txp->txbuf [0] == CIURESTART)
    {
        receivetimeout = RESTART_TIMEOUT/2;
    }
    else
    { 
        receivetimeout = NORMAL_TIMEOUT/2;
    }

    /* test for tracing of this message */
    if ((tracetype [line] == txp->txbuf [0]) || (tracetype [line] == 255))
    {
        localtrace = TRUE;
    }
    else
    {
        localtrace = FALSE;
    }

    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        retryflag = FALSE;

        /* calculate and store the time since end of last msgxfer */
        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

        if (intermsgdelay [line] != 0)
        {
            taskDelay (intermsgdelay [line]);
        }
        set_rts (line);

        if (pretxdelay [line] != 0)
        {
            taskDelay (pretxdelay [line]);
        }

        txstatus = IO_TIMEOUT;
        rxstatus = IO_TIMEOUT;

        semTake (semids [line] [TXSEM], NO_WAIT);
        semTake (semids [line] [RXSEM], NO_WAIT);

        txlen = txp->txmsglen;

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        if ((trace [line] & ALLTRAFFICTRACE) && (localtrace))
        {
           printf ("TX:");
           for (ix = 0; ix < 40; ix++) /* 40 is maximum TX message length */
           {
                if (ix < txlen)
                {
                   printf("_%2x", txp->txbuf [ix]);
                }
                else
                {
                   printf ("...");
                }
           } 
           printf ("\n");
        }

        /* calculate and store the time from entering msgxfer to starting transmission. */
        /* (including delays & diags) */
        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

        start_rx (line, semids [line] [RXSEM], &rxstatus);
        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
            txstatus = IO_TIMEOUT;
        }

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        /* calculate and store the time to transmit message. */
        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);

        stop_tx (line);
        if (posttxdelay [line] != 0)
        {
            taskDelay (posttxdelay [line]);
        }

        if (halfduplex [line] == TRUE)
        {
            clear_rts (line);
        }
        /* calculate and store the intermessage wait time. */
        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);

        if (txstatus == TXGOOD)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            oldrxix = -1;    /* make it pass through timeout loop at least once */
            while ((semTake (semids [line] [RXSEM], receivetimeout)) == ERROR)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
                if (oldrxix == rxp->rxix)
                {
                    if (modtrace [line])
                    {
                        logMsg("RX timeout\n");
                    }
                    rxstatus = IO_TIMEOUT;
                    break;
                }
                else
                {
                    if ((modtrace [line]) || (mltrace[line] == 12))
                    {
                         logMsg("waiting...");
                    }
                }
                oldrxix = rxp->rxix;
            }
            stop_rx (line);

            /* calculate and store the time to receive message. */
            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

            rxlen = rxp->rxix;
            if (rxstatus == RXGOOD)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if ((trace [line] & ALLTRAFFICTRACE) && (localtrace))
                {
                    printf("RX:");
                    for (ix = 0; ix < 40; ix++) /* 40 is maximum RX message length */
                    {
                        if (ix < rxlen)
                        {
                            printf("_%2x", rxp->rxbuf [ix]);
                        }
                        else
                        {
                            printf("...");
                        }
                    } 
                    printf("\n");
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                if (checkchecksum ( &(rxp->rxbuf[0]), rxlen, &(rxp->rxbuf[0]), &msglen) == TRUE)
                {
                    reply = pciu->reply = (rxp->rxbuf [0]);
                    replystats (line, reply); /* bumps ciu level stats and sets pciu->replyclass */
                    replyclass = pciu->replyclass;
                    replytrace (line, reply, replyclass);
                    switch (reply)
                    { 
                        /* transitory bailey errors */
                        case (7):
                        case (12):
                        case (27):
                        case (31):
                        case (35):
                        case (40):
                        case (41):
                        case (101):
                        case (110):
                            retryflag = TRUE;
                            break;

                        /* everything else */
                        default:
                            break;
                    }
                    /* see if we need to retry due to transitory Bailey communication failure. */
                    if (!retryflag)
                    {
                        return (XFERGOOD);
                    }
                }
                else
                {
                    pciu->no_chksumerrs++;
                    if (modtrace [line])
                    {
                        logMsg ("Bad Checksum: Message Length = %d, Checksum =0x%x",
                                 msglen, rxp->rxbuf [msglen-1]);
                    }
                }
            }
            else if (rxstatus == IO_TIMEOUT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (modtrace [line])
                {
                    logMsg ("Receive Timeout... Length: %d\n", rxlen);
                }
                if ((trace [line] & ALLTRAFFICTRACE) && (localtrace))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                pciu->no_rxnoresp++;
            }
            else
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (modtrace [line])
                {
                    logMsg ( "Receive Error: RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
                              rxp->rxbuf[100],
                              rxp->rxbuf[101],
                              rxp->rxix);
                }
                pciu->no_rxhwerrs++;
            }
        }
        else
        {
            if (txstatus == IO_TIMEOUT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (modtrace [line])
                {
			logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) && (localtrace))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                pciu->no_txnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Transmit Error\n");
                }
                pciu->no_txhwerrs++;
            }
        }
        if (retry != MAXRETRYS)
            pciu->no_retries++;
    }

    /* see if we failed after retrying on Bailey equipment comm problems. its not a local comm problem. */
    if (retryflag)
    {
        return (XFERGOOD);
    }

    if (modtrace [line])
    {
        logMsg ("Xfer Bad\n");
    }
    return (XFERBAD);
}

/*                                                                              
**      replystats                                                              
**                                                                              
**      The purpose of this routine is to increment the CIU statistics counters 
**                                                                              
**
*/
/* called from msgxfer  */


static void replystats (unsigned short line, unsigned short reply)
{
    CIUALLOC      *pciu;
    LOOPALLOC     *ploop;
    PCUALLOC      *ppcu;
    MODULEALLOC   *pmodule;

    /* initialize all pointers for current values */
    pciu = ciu [line];

    ploop = pciu->ploop;
    ppcu = pciu->ppcu;
    pmodule = pciu->pmodule;

    pciu->reply = reply;

    /* initialize all pointers for current values */
    pciu = ciu [line];

    switch (reply)
    {
        /* no error */
        case (0):
            pciu->replyclass = RC_NOERROR;
            pciu->ciu_noerrors++;
            break;

        /* valid status from CIU */
        case (1):
            pciu->replyclass = RC_PROBLEM;
            pciu->ciu_loopwait++;
            break;
        case (9):
            pciu->replyclass = RC_PROBLEM;
            pciu->ciu_repeatrestart++;
            break;
        case (18):
            pciu->ciu_needrestart++;
            pciu->replyclass = RC_INIT;
            break;
        case (22):
            pciu->replyclass = RC_NOERROR;
            pciu->ciu_specslost++;
            break;
        case (23):
            pciu->replyclass = RC_NOERROR;
            pciu->ciu_emptyqueue++;
            break;
        case (28):
            pciu->replyclass = RC_PROBLEM; /* nothing should be assigning indices but this driver. */
            pciu->ciu_indexinuse++;
            break;

        /* transitory bailey errors */
        case (7):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_btmbad++;
            break;
        case (12):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_commerror++;
            break;
        case (27):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_commtimeout++;
            break;
        case (31):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_checksum++;
            break;
        case (35):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_busy++;
            break;
        case (40):
            pciu->replyclass = RC_PCU_ERR;
            ppcu->node_busy++;
            break;
        case (41):
            pciu->replyclass = RC_RING_ERR;
            ploop->ring_busy++;
            break;
        case (101):
            pciu->replyclass = RC_MODULE_ERR;
            pmodule->module_busy++;
            break;

        /* non-transitory bailey problems */
        case (13):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_btmdead++;
            break;
        case (15):
            pciu->replyclass = RC_PCU_ERR;
            ppcu->node_looptimeout++;
            break;
        case (32):
            pciu->replyclass = RC_PCU_ERR;
            ppcu->node_offline++;
            break;
        case (34):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_error++;
            break;
        case (36):
            pciu->replyclass = RC_CIU_ERR;
            pciu->ciu_btmoffline++;
            break;
        case (39):
            pciu->replyclass = RC_RING_ERR;
            ploop->ring_offline++;
            break;
        case (109):
            pciu->replyclass = RC_MODULE_ERR;
            pmodule->module_memerr++;
            break;
        case (110):
            pciu->replyclass = RC_MODULE_ERR;
            pmodule->module_dead++;
            break;

        /* TIS-Bailey database conflicts */
        case (11):
            pciu->replyclass = RC_CONF_ERR;
            pciu->ciu_memerr++;
            break;
        case (16):
            pciu->replyclass = RC_CONF_ERR;
            pciu->ciu_rangeerr++;
            break;
        case (100):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_badmsg++;
            break;
        case (103):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_rangeerr++;
            break;
        case (104):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_blkerr++;
            break;
        case (105):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_blkundef++;
            break;
        case (106):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_blknoread++;
            break;
        case (107):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_funerr++;
            break;
        case (108):
            pciu->replyclass = RC_MCONF_ERR;
            pmodule->module_funblkerr++;
            break;

        /* TIS driver logic errors */
        case (2):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_format++;
            break;
        case (3):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_illegal++;
            break;
        case (4):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_reindex++;
            break;
        case (5):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_reblock++;
            break;
        case (6):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_toolong++;
            break;
        case (8):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_eierr++;
            break;
        case (10):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_noindex++;
            break;
        case (14):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_ieerr++;
            break;
        case (17):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_badkey++;
            break;
        case (19):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_mierr++;
            break;
        case (20):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_msgactive++;
            break;
        case (21):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu-> ciu_iomerr++;
            break;
        case (24):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_bigreply++;
            break;
        case (25):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_illegalsmc++;
            break;
        case (26):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_reporterr++;
            break;
        case (29):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_pointbad++;
            break;
        case (30):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_watchdog++;
            break;
        case (33):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_needcallup++;
            break;
        case (37):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_mmconflict++;
            break;
        case (38):
            pciu->replyclass = RC_LOGIC_ERR;
            pciu->ciu_pointtype++;
            break;
        case (102):
            pciu->replyclass = RC_MLOGIC_ERR;
            pmodule->module_cmmismatch++;
            break;

        /* unknown reply code */
        default:
            pciu->replyclass = RC_UNKNOWN_ERR;
            pciu->ciu_unknown++;
            break;
    }
}

/*
**      replytrace
**                                                                              
**      The purpose of this routine is to display, under trace control, the     
**      replies to Bailey CIU commands.                                         
**                                                                              
**
*/
/* called from msgxfer  */

static void replytrace (unsigned short line, unsigned short reply, unsigned short replyclass)
{
    if (trace[line] & CIUOKTRACE)       /* no error. */
    {
        if (reply == 0)
        {
            logMsg("CIU:(0) No error. \n");
            taskDelay (4); /* just enough to keep diagnostic msgs from overlapping */
            return;
        }
    }
    if (trace[line] & CIUSTATETRACE)    /* not a communication error: code can adapt. */
    {
        switch (reply)
        {
            /* This should only happen when using a non-zero key, which we do NOT. */
            case (1):
                logMsg("CIU:(1) Waiting For Loop .... \n");
                taskDelay (4);
                return;
            /* this should only occur after sending the first CIU RESTART */
            case (9):
                logMsg("CIU:(9) Repeat CIU RESTART command. \n");
                taskDelay (4);
                return;
            /* if this occurs, we need to restart the CIU and rebuild the index table */
            case (18):
                logMsg("CIU:(18) Need a restart command. \n");
                taskDelay (4);
                return;
            /* these are benign non-error replies, to be further handled by the calling routine. */
            case (22):
                logMsg("CIU:(22) Exception report specs lost. \n");
                taskDelay (4);
                return;
            case (23):
                logMsg("CIU:(23) No message queued or de-queue received. \n");
                taskDelay (4);
                return;
            /* this can be handled, but it is unexpected that anyone else will assign CIU indices. */
            case (28):
                logMsg("CIU:(28) Index already established by another PCU. \n");
                taskDelay (4);
                return;
        }
    }

    if (trace[line] & CIUERRORTRACE)    /* something is wrong in CIU. assume it's transitory. try again. */
    {
        switch (reply)
        {
            case (7):
                /*  */
                logMsg("CIU:(7) Bad reply from BTM. \n");
                taskDelay (4);
                return;
            case (12):
                /* this should be treated the host-CIU comm error that it is. not a bailey network error. */
                logMsg("CIU:(12) Computer communication error. \n");
                taskDelay (4);
                return;
            case (27):
                /*  */
                logMsg("CIU:(27) Timeout between bytes in command. \n");
                taskDelay (4);
                return;
            case (31):
                /* */
                logMsg("CIU:(31) Checksum compare error. \n");
                taskDelay (4);
                return;
            case (35):
                /* */
                logMsg("CIU:(35) CIU busy. \n");
                taskDelay (4);
                return;
            case (40):
                /* This is a PCU level statistic */
                logMsg("PCU:(40) Destination Node Busy. \n");
                taskDelay (4);
                return;
            case (41):
                /* This is a Loop level statistic */
                logMsg("Loop:(41) Destination Ring Busy. \n");
                taskDelay (4);
                return;
            case (101):
                /* Module level stat - only bump this one.                                          */
                /* note: this will only happen when making direct actions regarding this module or  */
                /* a block within this module. this should only be at establish and connect time.   */
                /* When something goes wrong after that it will come from module status errors.     */
                logMsg("Module:(101)  Busy - cannot respond at this time. \n");
                taskDelay (4);
                return;
        }
    }
    /* something is wrong in Bailey. needs fixing by external action. retry won't help. */
    if (trace[line] & CIUERRORTRACE)
    {
        switch (reply)
        {
            case (13):
                /*  */
                logMsg("CIU:(13) BTM not responding. \n");
                taskDelay (4);
                return;
            case (15):
                /* This is a PCU level error */
                logMsg("PCU:(15) Time-out of loop response. \n");
                taskDelay (4);
                return;
            case (32):
                /* This is a PCU level statistic */
                logMsg("CIU:(32) Destination node offline. \n");
                taskDelay (4);
                return;
            case (34):
                /* */
                logMsg("CIU:(34) CIU internal error. \n");
                taskDelay (4);
                return;
            case (36):
                /* */
                logMsg("CIU:(36) BTM Off-line. \n");
                taskDelay (4);
                return;
            case (39):
                /* This is a Loop level statistic */
                logMsg("CIU:(39) Destination Ring Off-line. \n");
                taskDelay (4);
                return;
            case (109):
                /* Module level stat - only bump this one.                                               */
                /* note: since we don't configure modules, this error should NEVER occur in this driver. */
                logMsg("Module:(109) Insufficient memory to write block in EEPROM and/or RAM. \n");
                taskDelay (4);
                return;
            case (110):
                /* Module level stat - only bump this one.                                          */
                /* note: this will only happen when making direct actions regarding this module or  */
                /* a block within this module. this should only be at establish and connect time.   */
                /* When something goes wrong after that it will come from module status errors.     */
                logMsg("Module:(110) Module not responding. \n");
                taskDelay (4);
                return;
        }
    }
    /* user configured database wrong. */
    if (trace[line] & CIUCONFIGTRACE)
    {
        switch (reply)
        {
            case (11):
                /* */
                logMsg("CIU:(11) Memory Full. (too many blocks defined) \n");
                taskDelay (4);
                return;
            case (16):
                /* */
                logMsg("CIU:(16) Number out of range. \n");
                taskDelay (4);
                return;
            case (100):
                /* Module level stat - only bump this one. */
                logMsg("Module:(100) Undefined message type for target module. \n");
                taskDelay (4);
                return;
            case (103):
                /* Module level stat - only bump this one. */
                logMsg("Module:(103) Message data out of legal range. \n");
                taskDelay (4);
                return;
            case (104):
                /* Module level stat - only bump this one. */
                logMsg("Module:(104) Invalid block number. \n");
                taskDelay (4);
                return;
            case (105):
                /* Module level stat - only bump this one. */
                logMsg("Module:(105) Undefined block number. (valid but not configured)\n");
                taskDelay (4);
                return;
            case (106):
                /* Module level stat - only bump this one. */
                logMsg("Module:(106) Block not readable. (valid but no readable parameters)\n");
                taskDelay (4);
                return;
            case (107):
                /* Module level stat - only bump this one. */
                logMsg("Module:(107) Invalid function code for target module. \n");
                taskDelay (4);
                return;
            case (108):
                /* Module level stat - only bump this one. */
                logMsg("Module:(108) Function code and block number not compatible in target module.\n");
                taskDelay (4);
                return;
        }
    }
    /* we are screwing up talking to ciu. these errors should only happen during debug, or */
    /*  in the rare case when a communications error has occured but the checksum is good. */
    if (trace[line] & CIUCONFIGTRACE)
    {
        switch (reply)
        {
            case (2):
                /* */
                logMsg("CIU:(2) Improper Command Format. \n");
                taskDelay (4);
                return;
            case (3):
                /* */
                logMsg("CIU:(3) Illegal Command. \n");
                taskDelay (4);
                return;
            case (4):
                /* */
                logMsg("CIU:(4) Index already established by this driver. \n");
                taskDelay (4);
                return;
            case (5):
                /* */
                logMsg("CIU:(5) Block already established as another point. \n");
                taskDelay (4);
                return;
            case (6):
                /* */
                logMsg("CIU:(6) Command too long. \n");
                taskDelay (4);
                return;
            case (8):
                /* */
                logMsg("CIU:(8) Export used as import. \n");
                taskDelay (4);
                return;
            case (10):
                /* */
                logMsg("CIU:(10) Undefined index. \n");
                taskDelay (4);
                return;
            case (14):
                /* */
                logMsg("CIU:(14) Import used as export. \n");
                taskDelay (4);
                return;
            case (17):
                /* */
                logMsg("CIU:(17) Illegal key. \n");
                taskDelay (4);
                return;
            case (19):
                /* */
                logMsg("CIU:(19) Module status used as import. \n");
                taskDelay (4);
                return;
            case (20):
                /* this reply is only issued in response to a dequeue command. it should never occur. */
                logMsg("CIU:(20) Message active on loop. \n");
                taskDelay (4);
                return;
            case (21):
                /* */
                logMsg("CIU:(21) Import or export used as module status. \n");
                taskDelay (4);
                return;
            case (24):
                /* */
                logMsg("CIU:(24) Reply too large. \n");
                taskDelay (4);
                return;
            case (25):
                /* */
                logMsg("CIU:(25) Illegal station mode command. \n");
                taskDelay (4);
                return;
            case (26):
                /* */
                logMsg("CIU:(26) Illegal module number to CIU problem report command. \n");
                taskDelay (4);
                return;
            case (29):
                /* */
                logMsg("CIU:(29) Point type incompatible with command. \n");
                taskDelay (4);
                return;
            case (30):
                /* we don't enable the watchdog timer, so this should never happen. */
                logMsg("CIU:(30) Watchdog timeout. \n");
                taskDelay (4);
                return;
            case (33):
                /* */
                logMsg("CIU:(33) Callup command required. \n");
                taskDelay (4);
                return;
            case (37):
                /* */
                logMsg("CIU:(37) Monitor Mode Conflict. \n");
                taskDelay (4);
                return;
            case (38):
                /* */
                logMsg("CIU:(38) Point Type Mismatch. \n");
                taskDelay (4);
                return;
            case (102):
                /* Module level stat - only bump this one.                                               */
                /* note: since we don't configure modules, this error should NEVER occur in this driver. */
                logMsg("Module:(102) Command mode does not agree with module mode. \n");
                taskDelay (4);
                return;
        }
    }
    if (trace[line] & CIUUNKNOWNTRACE)
    {
        if (replyclass == RC_UNKNOWN_ERR)
        {
            logMsg("CIU:(%d) *************** Unknown Reply Code **************** \n");
            taskDelay (4);
            return;
        }
    }
    return;
}


/*                                                                      
**                                                              	
** initialize the statistics for the Bailey CIU Driver                 	
**                                                              	
*/                                                               	
/* called from AODRIVER and BODRIVER  */

static	void initstats (unsigned short line)
{
    CIUALLOC  *pciu;

    pciu = ciu [line];

    pciu->no_dataout_msgs = 0;  /* 5  Count Output Msgs            */
    pciu->no_datain_msgs  = 0;  /* 6  Count Data Requests          */
    pciu->no_rxnoresp     = 0;  /* 7  Count No Responses           */
    pciu->no_txnoresp     = 0;  /* 8  Count No Responses           */
    pciu->no_dataerr      = 0;  /* 9  Count Message Echo Errors    */
    pciu->no_retries      = 0;  /* 10 Count Retries                */
    pciu->no_rxhwerrs     = 0;  /* 11 Count Comm Hardware Errors   */
    pciu->no_txhwerrs     = 0;  /* 12 Count Comm Hardware Errors   */
    pciu->no_chksumerrs   = 0;  /* 13 Count RX Checksum Errors     */
    pciu->no_offlines     = 0;  /* 14 Count Off Line Transitions   */
    pciu->badoutcnt       = 0;  /* 17 Count failed output commands */
}

/*
**                                                              	
** initialize the CIU statistics for the Bailey CIU Driver          	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_ciu_tab  */

static	void initciustats (CIUALLOC  *pciu)
{
    pciu->ciu_noerrors = 0;         /* case (0) */

    /* valid status from CIU */
    pciu->ciu_loopwait      = 0;    /* case (1)   */
    pciu->ciu_repeatrestart = 0;    /* case (9)   */
    pciu->ciu_needrestart   = 0;    /* case (18)  */
    pciu->ciu_specslost     = 0;    /* case (22)  */
    pciu->ciu_emptyqueue    = 0;    /* case (23)  */
    pciu->ciu_indexinuse    = 0;    /* case (28)  */
    /* transitory bailey errors */
    pciu->ciu_btmbad        = 0;    /* case (7)   */
    pciu->ciu_commerror     = 0;    /* case (12)  */
    pciu->ciu_commtimeout   = 0;    /* case (27)  */
    pciu->ciu_checksum      = 0;    /* case (31)  */
    pciu->ciu_busy          = 0;    /* case (35)  */

    /* non-transitory bailey problems */
    pciu->ciu_btmdead       = 0;    /* case (13)  */
    pciu->ciu_error         = 0;    /* case (34)  */
    pciu->ciu_btmoffline    = 0;    /* case (36)  */

    /* TIS-Bailey database conflicts */
    pciu->ciu_memerr        = 0;    /* case (11)  */
    pciu->ciu_rangeerr      = 0;    /* case (16)  */

    /* TIS driver logic errors */
    pciu->ciu_format        = 0;    /* case (2)   */
    pciu->ciu_illegal       = 0;    /* case (3)   */
    pciu->ciu_reindex       = 0;    /* case (4)   */
    pciu->ciu_reblock       = 0;    /* case (5)   */
    pciu->ciu_toolong       = 0;    /* case (6)   */
    pciu->ciu_eierr         = 0;    /* case (8)   */
    pciu->ciu_noindex       = 0;    /* case (10)  */
    pciu->ciu_ieerr         = 0;    /* case (14)  */
    pciu->ciu_badkey        = 0;    /* case (17)  */
    pciu->ciu_mierr         = 0;    /* case (19)  */
    pciu->ciu_msgactive     = 0;    /* case (20)  */
    pciu->ciu_iomerr        = 0;    /* case (21)  */
    pciu->ciu_bigreply      = 0;    /* case (24)  */
    pciu->ciu_illegalsmc    = 0;    /* case (25)  */
    pciu->ciu_reporterr     = 0;    /* case (26)  */
    pciu->ciu_pointbad      = 0;    /* case (29)  */
    pciu->ciu_watchdog      = 0;    /* case (30)  */
    pciu->ciu_needcallup    = 0;    /* case (33)  */
    pciu->ciu_mmconflict    = 0;    /* case (37)  */
    pciu->ciu_pointtype     = 0;    /* case (38)  */

            /* unknown reply codes */
    pciu->ciu_unknown       = 0;    /* case (99)  */

    return;

/*    pciu->node_busy = 0;            ** case ()  */
/*    pciu->ring_busy = 0;            ** case ()  */
/*    pciu->module_busy = 0;          ** case ()  */

/*    pciu->ciu_btmdead = 0;          ** case ()  */
/*    pciu->ciu_looptimeout = 0;      ** case ()  */
/*    pciu->node_offline = 0;         ** case ()  */
/*    pciu->ciu_error = 0;            ** case ()  */
/*    pciu->ciu_btmoffline = 0;       ** case ()  */
/*    pciu->ring_offline = 0;         ** case ()  */
/*    pciu->module_memerr = 0;        ** case ()  */
/*    pciu->module_dead = 0;          ** case ()  */

/*    pciu->module_badmsg = 0;        ** case ()  */
/*    pciu->module_rangeerr = 0;      ** case ()  */
/*    pciu->module_blkerr = 0;        ** case ()  */
/*    pciu->module_blkundef = 0;      ** case ()  */
/*    pciu->module_blknoread = 0;     ** case ()  */
/*    pciu->module_funerr = 0;        ** case ()  */
/*    pciu->module_funblkerr = 0;     ** case ()  */

/* work down into the sub levels; */
/*    return; */
}
/*
**                                                              	
** initialize the Loop statistics for the Bailey CIU Driver          	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_loop_tab  */

static	void initloopstats (LOOPALLOC *ploop)
{
    /* transitory bailey errors */
    ploop->ring_busy    = 0;            /* case (41)  */

    /* non-transitory bailey problems */
    ploop->ring_offline = 0;            /* case (39)  */
    return;
}
/*
**                                                              	
** initialize the PCU statistics for the Bailey CIU Driver          	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_pcu_tab  */

static	void initpcustats (PCUALLOC *ppcu)
{
    /* transitory bailey errors */
    ppcu->node_busy        = 0;         /* case (40)  */

    /* non-transitory bailey problems */
    ppcu->node_looptimeout = 0;         /* case (15)  */
    ppcu->node_offline     = 0;         /* case (32)  */
    return;
}
/*
**                                                              	
** initialize the Module statistics for the Bailey CIU Driver          	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_module_tab  */

static	void initmodulestats (MODULEALLOC *pmodule)
{
    /* transitory bailey errors */
    pmodule->module_busy       = 0;     /* case (101)  */

    /* non-transitory bailey problems */
    pmodule->module_memerr     = 0;     /* case (109)  */
    pmodule->module_dead       = 0;     /* case (110)  */

    /* TIS-Bailey database conflicts */
    pmodule->module_badmsg     = 0;     /* case (100)  */
    pmodule->module_rangeerr   = 0;     /* case (103)  */
    pmodule->module_blkerr     = 0;     /* case (104)  */
    pmodule->module_blkundef   = 0;     /* case (105)  */
    pmodule->module_blknoread  = 0;     /* case (106)  */
    pmodule->module_funerr     = 0;     /* case (107)  */
    pmodule->module_funblkerr  = 0;     /* case (108)  */

    /* TIS driver logic errors */
    pmodule->module_cmmismatch = 0;     /* case (102)  */

    return;
}

/*
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)
{
    CIUALLOC       *pciu;

    pciu = ciu [line];
    if (pciu)			/* verify pointer validity prior to use */
    {
        /* check cmd_force_offline flag because it is set in an asynchronous task */
        if ((pciu->is_responding) && (!pciu->cmd_force_offline))
        {
            return (TRUE);
        }
    }
    return (FALSE);
}
/*                                                                           
** baileyrestart                                                             
**                                                                           
** because of the mode we start this thing in, the only valid reply is 'ok'  
**                                                                           
*/
/* only called from on_line */

static	unsigned short baileyrestart (unsigned short line)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;

    TXLINE        *txp;
    RXLINE        *rxp;

    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];

    unsigned short reply, replyclass;

    /* initialize all pointers for current values */
    pciu          = ciu [line];
    pciu->ploop   = pciu->loops[0];
    pciu->ppcu    = pciu->ploop->pcus[0];
    pciu->pmodule = pciu->ppcu->modules[0];
    pmodule       = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = CIURESTART;
    buffer [1] = 0;    /* key = 0 */
    buffer [2] = 0;    /* watchdog is disabled */
/*    buffer [3] = 0x82; ** mode:  CIU04 Mode & CIU primary. */
    buffer [3] = 0x83; /* mode:  CIU04 Mode & CIU primary, stations into computer mode. */

/*    buffer [3] = 0xba; ** mode:  CIU04 Mode, time-sync, exception report screening, */

    buffer [4] = 0;    /* no reply delay (for maximum throughput) */
    buffer [5] = 0;    /* parallel port work flag interrupt mode disabled. */

    makechecksum (&buffer[0], CIURESTARTLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a 'normal' response to 'RESTART' command */
        case RC_NOERROR:
            if (reply == R_NOERRORS)
            {
                pciu->is_responding = TRUE;
                pciu->LOOPnumber = rxp->rxbuf[2];  /* store CIU Loop number, which is returned by  */
                                                   /*  the CIU in reply to 'CIU Restart' command.  */
                pciu->PCUnumber = rxp->rxbuf[1];   /* store CIU PCU number, which is returned by   */
                                                   /*  the CIU in reply to 'CIU Restart' command.  */
                return (CMDDONE);
            }
            /* for a restart, any other RC_NOERROR reply (specslost or emptyqueue) is invalid. */
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDFAIL);
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for a required restart. since we just issued it, this response is an error. */
        case RC_INIT:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
    }
}
/*
** Setrmsc_ao                                                       	
**                                                                  	
*/
/* only called from checkoutputs */

static unsigned short setrmsc_ao (unsigned short line, unsigned short signal, float fvalue)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    RMSCALLOC     *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned char *pchar;

    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];

    unsigned short reply, replyclass, index;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;
    pblock  = pciu->pblock;

    index   = ((COMMONALLOC *) pblock)->control.index;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    ((RMSCALLOC *) pblock)->data_write = fvalue;
    /* convert floating point to raw Bailey Real3 format. */
    pchar = &(((RMSCALLOC *) pblock)->raw_write[0]);
    float_to_real3 (fvalue, pchar);

    /* Count number of data output messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = OUTPUTVALUE;
    buffer [1] = 0;
    buffer [2] = index/256;
    buffer [3] = index%256;
    buffer [4] = ((RMSCALLOC *) pblock)->status_write;
    buffer [5] = ((RMSCALLOC *) pblock)->raw_write[0];
    buffer [6] = ((RMSCALLOC *) pblock)->raw_write[1];
    buffer [7] = ((RMSCALLOC *) pblock)->raw_write[2];

    makechecksum (&buffer[0], OUTPUTVALUELEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for all ok */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            return (CMDDONE);
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
    }
}
/*
** Setrmsc_bo                                                       	
**                                                                  	
*/
/* only called from checkoutputs */

static unsigned short setrmsc_bo (unsigned short line, unsigned short signal,
                                  unsigned long value, unsigned long mask)
{
    CIUALLOC      *pciu;
    RMSCALLOC     *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];
    unsigned short reply, replyclass, index;
    unsigned char xx_oldval, xx_maskchar, xx_valchar, xx_tempval, xx_newval;

    /* initialize all pointers for current values */
    pciu = ciu [line];
    pblock = pciu->pblock;

    xx_oldval = ((RMSCALLOC *) pblock)->status_write;
    xx_maskchar = mask;
    xx_valchar = value;

    /* for RMSC, output to the binary point does NOT cause command to be sent to CIU. */
    if (mask < (0x0001 << RMSC_BINUM))
    {
        xx_tempval = xx_oldval ^ xx_maskchar;
        xx_newval = xx_oldval | xx_valchar;
        ((RMSCALLOC *) pblock)->status_write = xx_newval;
        return (CMDDONE);
    }
    return (CMDFAIL);
}

/*
** Setrcm                                                       	
**                                                                  	
*/
/* only called from checkoutputs */

static unsigned short setrcm (unsigned short line, unsigned short signal,
                              unsigned long value, unsigned long mask)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    RCMALLOC      *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];

    unsigned short reply, replyclass, index;
    unsigned long temp;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;
    pblock  = pciu->pblock;
    index   = ((COMMONALLOC *) pblock)->control.index;

    switch (((RCMALLOC *) pblock)->control.type)
    {
        case RCM_TYPE:
            if (mask != 0x03)
            {
                return (CMDFAIL);
            }
            switch (value)
            {
                case 0:
                    ((RCMALLOC *) pblock)->status_write = SUSTAINRESET;
                    break;
                case 1:
                    ((RCMALLOC *) pblock)->status_write = SUSTAINSET;
                    break;
                case 2:
                    ((RCMALLOC *) pblock)->status_write = PULSERESET;
                    break;
                case 3:
                    ((RCMALLOC *) pblock)->status_write = PULSESET;
                    break;
            }
            break;
        case DD_TYPE:
            if (mask != 0x0f)
            {
                return (CMDFAIL);
            }
            ((DDALLOC *) pblock)->status_write = (unsigned char) value;
            break;
        default:
            return (CMDFAIL);
    }

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = OUTPUTSTATUS;
    buffer [1] = 0;
    buffer [2] = index/256;
    buffer [3] = index%256;
    buffer [4] = ((RCMALLOC *) pblock)->status_write;

    makechecksum (&buffer[0], OUTPUTSTATUSLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for all ok */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            return (CMDDONE);
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
    }
}





/*
** Setcs                                                               	
**                                                                  	
*/
/* only called from checkoutputs */

static unsigned short setcs_bo (unsigned short line, unsigned short signal,
                             unsigned long value, unsigned long mask)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    RCMALLOC      *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];

    unsigned short reply, replyclass, index;
    unsigned long temp;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;
    pblock  = pciu->pblock;
    index   = ((COMMONALLOC *) pblock)->control.index;

    /* preserve the write value */
    ((CSALLOC *) pblock)->status_write = (unsigned char) value;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = OUTPUTSTATUS;
    buffer [1] = 0;
    buffer [2] = index/256;
    buffer [3] = index%256;
    buffer [4] = ((CSALLOC *) pblock)->status_write;

    makechecksum (&buffer[0], OUTPUTSTATUSLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for all ok */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            return (CMDDONE);
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
    }
}






/*
** Setstation                                                       	
**                                                                  	
*/
/* only called from checkoutputs */

static unsigned short setstation (unsigned short line, unsigned short signal, float fvalue)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    CSALLOC       *pblock;
    unsigned char *pchar;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256];

    unsigned short reply, replyclass, index;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;
    pblock  = pciu->pblock;
    index   = ((COMMONALLOC *) pblock)->control.index;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = OUTPUTSTATIONVALUE;
    buffer [1] = 0;
    buffer [2] = index/256;
    buffer [3] = index%256;
    switch (signal%1000)
    {
        case 1:
            buffer [4] = 1;
            ((CSALLOC *) pblock)->SP_write = fvalue;
            /* convert floating point to raw Bailey Real3 format. */
            pchar = &(((CSALLOC *) pblock)->SPraw_write[0]);
            float_to_real3 (fvalue, pchar);
            buffer [5] = ((CSALLOC *) pblock)->SPraw_write[0];
            buffer [6] = ((CSALLOC *) pblock)->SPraw_write[1];
            buffer [7] = ((CSALLOC *) pblock)->SPraw_write[2];
            break;

        case 2:
            buffer [4] = 2;
            ((CSALLOC *) pblock)->RI_write = fvalue;
            /* convert floating point to raw Bailey Real3 format. */
            pchar = &(((CSALLOC *) pblock)->RIraw_write[0]);
            float_to_real3 (fvalue, pchar);
            buffer [5] = ((CSALLOC *) pblock)->RIraw_write[0];
            buffer [6] = ((CSALLOC *) pblock)->RIraw_write[1];
            buffer [7] = ((CSALLOC *) pblock)->RIraw_write[2];
            break;

        case 3:
            buffer [4] = 3;
            ((CSALLOC *) pblock)->CO_write = fvalue;
            /* convert floating point to raw Bailey Real3 format. */
            pchar = &(((CSALLOC *) pblock)->COraw_write[0]);
            float_to_real3 (fvalue, pchar);
            buffer [5] = ((CSALLOC *) pblock)->COraw_write[0];
            buffer [6] = ((CSALLOC *) pblock)->COraw_write[1];
            buffer [7] = ((CSALLOC *) pblock)->COraw_write[2];
            break;

        default:
            return (CMDFAIL);
            break;
    }

    makechecksum (&buffer[0], OUTPUTSTATIONVALUELEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for all ok */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            return (CMDDONE);
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
    }
}
/*
** readexceptions - gets data from AER, DER, and RMSC blocks                    
**                                                                              
*/
/* only called from scan_ciu */

static unsigned short readexceptions (unsigned short line)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    void          *pblock;

    unsigned char *pchar;
    float         *pfloat;

    TXLINE        *txp;
    RXLINE        *rxp;

    unsigned short i, j, x, maxx, countx, rowx, columnx;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, index, exceptiondata, recordsize;

    /* initialize all pointers for current values */
    pciu          = ciu [line];
    pciu->ploop   = pciu->loops[0];
    pciu->ppcu    = pciu->ploop->pcus[0];
    pciu->pmodule = pciu->ppcu->modules[0];
    pmodule       = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_datain_msgs++;

    /* Format the output message */
    buffer [0] = READEXCEPTIONS;
    buffer [1] = 0;
    buffer [2] = 0; /* Send as many as you've got, up to the max */

    makechecksum (&buffer[0], READEXCEPTIONSLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    exceptiondata = FALSE; /* presume no data */
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 23: /* Empty Queue. no problem. just get out. */
                    return (CMDNADA);
                    break;

                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

                case 0: /* No Problem */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

               default:
                    pmodule->holdflag = TRUE;
                    pmodule->is_responding = FALSE;
                    return (CMDFAIL);
                    break;
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }

    /* we received at least one exception report. */

    recordsize = 6;
    maxx = 5;
    countx = rxp->rxbuf [1];
    rowx = (countx-1)/maxx;
    columnx = (countx-1)%maxx;

    if (trace[line] & CIU08TRAFFIC)
    {
      for (j = 0; j <= rowx ; j ++)
      {
        if ( j == rowx)
        {
            x = columnx+1; 
        }
        else
        {
            x = maxx;
        }
        if ( j == 0 )
        {
            printf("EXCEPTIONS:        (%x%x)  ", countx/16, countx%16);
        }
        else
        {
            printf("                         ");
        }
        for (i = 0; i < x; i++) /* 42 is maximum RX returned count */
        {
            printf("  %x%x%x%x__%x%x,%x%x%x%x%x%x",
                    rxp->rxbuf [(((j*maxx)+i)*6)+2]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+2]%16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+3]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+3]%16,

                    rxp->rxbuf [(((j*maxx)+i)*6)+4]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+4]%16,

                    rxp->rxbuf [(((j*maxx)+i)*6)+5]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+5]%16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+6]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+6]%16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+7]/16,
                    rxp->rxbuf [(((j*maxx)+i)*6)+7]%16);
        }
        if ( j != rowx ) printf(" ...");
        printf("\n");
      }
    }

    /***********************/

    for (i = 0; i < rxp->rxbuf[1]; i++)
    {
        index = (rxp->rxbuf[(i*recordsize)+2])*256 + rxp->rxbuf[(i*recordsize)+3];
        if (index >= MAXINDEX)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds upper bound. (%d)\n",index);
            return (CMDFAIL);
        }
        if (index >= pciu->nextindex)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds 'nextindex' value (%d)\n",index);
            return (CMDFAIL);
        }
        pblock = pciu->indextable [index];
        if (!pblock)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index not defined. (%d)\n",index);
            return (CMDFAIL);
        }

        type = ((COMMONALLOC *) pblock)->control.type;
        switch (type)
        {
            case AER_TYPE:
                ((AERALLOC *) pblock)->control.data_valid = TRUE;
                ((AERALLOC *) pblock)->status_read = rxp->rxbuf[(i*recordsize)+4];
                ((AERALLOC *) pblock)->raw_read[0] = rxp->rxbuf[(i*recordsize)+5];
                ((AERALLOC *) pblock)->raw_read[1] = rxp->rxbuf[(i*recordsize)+6];
                ((AERALLOC *) pblock)->raw_read[2] = rxp->rxbuf[(i*recordsize)+7];
                /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
                pchar = &(((AERALLOC *) pblock)->raw_read[0]);
                pfloat = &(((AERALLOC *) pblock)->data_read);
                real3_to_float (pchar, pfloat);
                break;

            case DER_TYPE:
                ((DERALLOC *) pblock)->control.data_valid = TRUE;
                ((DERALLOC *) pblock)->status_read = rxp->rxbuf[(i*recordsize)+4];
                break;

            case RMSC_TYPE:
                ((RMSCALLOC *) pblock)->control.data_valid = TRUE;
                ((RMSCALLOC *) pblock)->status_read = rxp->rxbuf[(i*recordsize)+4];
                ((RMSCALLOC *) pblock)->raw_read[0] = rxp->rxbuf[(i*recordsize)+5];
                ((RMSCALLOC *) pblock)->raw_read[1] = rxp->rxbuf[(i*recordsize)+6];
                ((RMSCALLOC *) pblock)->raw_read[2] = rxp->rxbuf[(i*recordsize)+7];
                /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
                pchar = &(((RMSCALLOC *) pblock)->raw_read[0]);
                pfloat = &(((RMSCALLOC *) pblock)->data_read);
                real3_to_float (pchar, pfloat);
                break;

            default:
                pciu->holdflag = TRUE;
                pciu->is_responding = FALSE;
                return (CMDFAIL);
                break;
        }
    }
    /* the exception has been read and stored */
    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/*                                                                              
** read station exceptions - gets data from Control Station blocks              
**                                                                              
*/
/* only called from scan_ciu */

static unsigned short readstationexceptions (unsigned short line)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;

    void          *pblock;
    unsigned char *pchar;
    float         *pfloat;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i, j, x, maxx, countx, rowx, columnx;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, index, exceptiondata, recordsize;

    /* initialize all pointers for current values */
    pciu          = ciu [line];
    pciu->ploop   = pciu->loops[0];
    pciu->ppcu    = pciu->ploop->pcus[0];
    pciu->pmodule = pciu->ppcu->modules[0];
    pmodule       = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_datain_msgs++;

    /* Format the output message */
    buffer [0] = READSTATIONEXCEPTS;
    buffer [1] = 0;
    buffer [2] = 0; /* Send as many as you've got, up to the max */

    makechecksum (&buffer[0], READSTATIONEXCEPTSLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    exceptiondata = FALSE; /* presume no data */
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 23: /* Empty Queue. no problem. just get out. */
                    return (CMDNADA);
                    break;

                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

                case 0: /* No Problem */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

               default:
                    pmodule->holdflag = TRUE;
                    pmodule->is_responding = FALSE;
                    return (CMDFAIL);
                    break;
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }
    /* we received at least one station exception report. */

    recordsize = 16;
    maxx = 2;
    countx = rxp->rxbuf [1];
    rowx = (countx-1)/maxx;
    columnx = (countx-1)%maxx;

    if (trace[line] & CIU53TRAFFIC)
    {
      for (j = 0; j <= rowx ; j ++)
      {
        if ( j == rowx)
        {
            x = columnx+1; 
        }
        else
        {
            x = maxx;
        }
        if ( j == 0 )
        {
            printf("STATION EXCEPTIONS:(%x%x)  ", countx/16, countx%16);
        }                                   
        else
        {
            printf("                         ");
        }
        for (i = 0; i < x; i++) /* 42 is maximum RX returned count */
        {
            printf("  %x%x%x%x__%x%x,%x%x%x%x%x%x,%x%x%x%x%x%x,%x%x%x%x%x%x,%x%x%x%x%x%x,%x%x",
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+2]/16, /* index */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+2]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+3]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+3]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+4]/16, /* quality */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+4]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+5]/16, /* PV value */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+5]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+6]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+6]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+7]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+7]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+8]/16, /* SP value */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+8]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+9]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+9]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+10]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+10]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+11]/16, /* CO value */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+11]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+12]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+12]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+13]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+13]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+14]/16, /* RI value */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+14]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+15]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+15]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+16]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+16]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+17]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+17]%16);
        }
        if ( j != rowx ) printf(" ...");
        printf("\n");
      }
    }

    /***********************/

    for (i = 0; i < rxp->rxbuf[1]; i++)
    {
        index = (rxp->rxbuf[(i*recordsize)+2])*256 + rxp->rxbuf[(i*recordsize)+3];

        if (index >= MAXINDEX)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds upper bound. (%d)\n",index);
            return (CMDFAIL);
        }
        if (index >= pciu->nextindex)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds 'nextindex' value (%d)\n",index);
            return (CMDFAIL);
        }
        pblock = pciu->indextable [index];
        if (!pblock)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index not defined. (%d)\n",index);
            return (CMDFAIL);
        }
        type = ((COMMONALLOC *) pblock)->control.type;

        if (type != CS_TYPE)
        {
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDFAIL);
        }
        /* type is CS_TYPE */
        ((CSALLOC *) pblock)->control.data_valid = TRUE;

        ((CSALLOC *) pblock)->status_read[0] = rxp->rxbuf[(i*recordsize)+4];
        ((CSALLOC *) pblock)->PVraw_read[0] = rxp->rxbuf[(i*recordsize)+5];
        ((CSALLOC *) pblock)->PVraw_read[1] = rxp->rxbuf[(i*recordsize)+6];
        ((CSALLOC *) pblock)->PVraw_read[2] = rxp->rxbuf[(i*recordsize)+7];
        /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
        pchar = &(((CSALLOC *) pblock)->PVraw_read[0]);
        pfloat = &(((CSALLOC *) pblock)->PV_read);
        real3_to_float (pchar, pfloat);

        ((CSALLOC *) pblock)->SPraw_read[0] = rxp->rxbuf[(i*recordsize)+8];
        ((CSALLOC *) pblock)->SPraw_read[1] = rxp->rxbuf[(i*recordsize)+9];
        ((CSALLOC *) pblock)->SPraw_read[2] = rxp->rxbuf[(i*recordsize)+10];
        /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
        pchar = &(((CSALLOC *) pblock)->SPraw_read[0]);
        pfloat = &(((CSALLOC *) pblock)->SP_read);
        real3_to_float (pchar, pfloat);

        ((CSALLOC *) pblock)->COraw_read[0] = rxp->rxbuf[(i*recordsize)+11];
        ((CSALLOC *) pblock)->COraw_read[1] = rxp->rxbuf[(i*recordsize)+12];
        ((CSALLOC *) pblock)->COraw_read[2] = rxp->rxbuf[(i*recordsize)+13];
        /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
        pchar = &(((CSALLOC *) pblock)->COraw_read[0]);
        pfloat = &(((CSALLOC *) pblock)->CO_read);
        real3_to_float (pchar, pfloat);

        ((CSALLOC *) pblock)->RIraw_read[0] = rxp->rxbuf[(i*recordsize)+14];
        ((CSALLOC *) pblock)->RIraw_read[1] = rxp->rxbuf[(i*recordsize)+15];
        ((CSALLOC *) pblock)->RIraw_read[2] = rxp->rxbuf[(i*recordsize)+16];
        /* convert raw Bailey Real 3 floating point to IEEE 754 floating point. */
        pchar = &(((CSALLOC *) pblock)->RIraw_read[0]);
        pfloat = &(((CSALLOC *) pblock)->RI_read);
        real3_to_float (pchar, pfloat);

        ((CSALLOC *) pblock)->status_read[1] = rxp->rxbuf[(i*recordsize)+17];
    }
    /* the exception has been read and stored */
    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/*                                                                              
** read misc status exceptions - gets data from Modules, RCM and DD blocks      
**                                                                              
*/
/* only called from scan_ciu */

static unsigned short readmiscstatusexceptions (unsigned short line)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    void          *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;

    unsigned short i, j, x, maxx, countx, rowx, columnx;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, index, exceptiondata, recordsize;

    /* initialize all pointers for current values */
    pciu          = ciu [line];
    pciu->ploop   = pciu->loops[0];
    pciu->ppcu    = pciu->ploop->pcus[0];
    pciu->pmodule = pciu->ppcu->modules[0];
    pmodule       = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_datain_msgs++;

    /* Format the output message */
    buffer [0] = READMISCSTATUSEXCEPTS;
    buffer [1] = 0;
    buffer [2] = 0; /* Send as many as you've got, up to the max */

    makechecksum (&buffer[0], READMISCSTATUSEXCEPTSLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    exceptiondata = FALSE; /* presume no data */
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 23: /* Empty Queue. no problem. just get out. */
                    return (CMDNADA);
                    break;

                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

                case 0: /* No Problem */
                    if (rxp->rxbuf[1] == 0)
                    {
                        return (CMDNADA);
                    }
                    exceptiondata = TRUE;
                    break;

               default:
                    pmodule->holdflag = TRUE;
                    pmodule->is_responding = FALSE;
                    return (CMDFAIL);
                    break;
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }

    /* we received at least one miscellaneous status exception report. */

    recordsize = 7;
    maxx = 5;
    countx = rxp->rxbuf [1];
    rowx = (countx-1)/maxx;
    columnx = (countx-1)%maxx;

    if (trace[line] & CIU22TRAFFIC)
    {
      for (j = 0; j <= rowx ; j ++)
      {
        if ( j == rowx)
        {
            x = columnx+1; 
        }
        else
        {
            x = maxx;
        }
        if ( j == 0 )
        {
            printf("MISC EXCEPTIONS:   (%x%x)  ", countx/16, countx%16);
        }
        else
        {
            printf("                         ");
        }
        for (i = 0; i < x; i++) /* 42 is maximum RX returned count */
        {
            printf("  %x%x%x%x__%x%x,%x%x,%x%x,%x%x,%x%x",
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+2]/16, /* index */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+2]%16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+3]/16,
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+3]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+4]/16, /* byte 1 */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+4]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+5]/16, /* byte 2 */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+5]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+6]/16, /* byte 3 */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+6]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+7]/16, /* byte 4 */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+7]%16,

                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+8]/16, /* byte 5 */
                    rxp->rxbuf [(((j*maxx)+i)*recordsize)+8]%16);
        }
        if ( j != rowx ) printf(" ...");
        printf("\n");
      }
    }

    /***********************/

    for (i = 0; i < rxp->rxbuf[1]; i++)
    {
        index = (rxp->rxbuf[(i*recordsize)+2])*256 + rxp->rxbuf[(i*recordsize)+3];
        if (index == 0)
        {
            pciu->status_valid = TRUE;
            pciu->status_read[0] = rxp->rxbuf[(i*recordsize)+4];
            pciu->status_read[1] = rxp->rxbuf[(i*recordsize)+5];
            pciu->status_read[2] = rxp->rxbuf[(i*recordsize)+6];
            pciu->status_read[3] = rxp->rxbuf[(i*recordsize)+7];
            pciu->status_read[4] = rxp->rxbuf[(i*recordsize)+8];
            /* detect CIU failure/error mode */
            pciu->ciumode = (pciu->status_read[0] >> 5) & 0x03;
            continue;
        }

        if (index >= MAXINDEX)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds upper bound. (%d)\n",index);
            return (CMDFAIL);
        }
        if (index >= pciu->nextindex)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index value exceeds 'nextindex' value (%d)\n",index);
            return (CMDFAIL);
        }
        pblock = pciu->indextable [index];
        if (!pblock)
        {
            if (trace[line] & INDEXERRORTRACE)
                logMsg ("Index not defined. (%d)\n",index);
            return (CMDFAIL);
        }

        type = ((COMMONALLOC *) pblock)->control.type;
        switch (type)
        {
            case RCM_TYPE:
                ((RCMALLOC *) pblock)->control.data_valid = TRUE;
                ((RCMALLOC *) pblock)->status_read[0] = rxp->rxbuf[(i*recordsize)+4];
                ((RCMALLOC *) pblock)->status_read[1] = rxp->rxbuf[(i*recordsize)+5];
                ((RCMALLOC *) pblock)->status_read[2] = rxp->rxbuf[(i*recordsize)+6];
                ((RCMALLOC *) pblock)->status_read[3] = rxp->rxbuf[(i*recordsize)+7];
                ((RCMALLOC *) pblock)->status_read[4] = rxp->rxbuf[(i*recordsize)+8];
                break;

            case DD_TYPE:
                ((DDALLOC *) pblock)->control.data_valid = TRUE;
                ((DDALLOC *) pblock)->status_read[0] = rxp->rxbuf[(i*recordsize)+4];
                ((DDALLOC *) pblock)->status_read[1] = rxp->rxbuf[(i*recordsize)+5];
                ((DDALLOC *) pblock)->status_read[2] = rxp->rxbuf[(i*recordsize)+6];
                ((DDALLOC *) pblock)->status_read[3] = rxp->rxbuf[(i*recordsize)+7];
                ((DDALLOC *) pblock)->status_read[4] = rxp->rxbuf[(i*recordsize)+8];
                break;

            case MODULE_TYPE:
                ((MODULEALLOC *) pblock)->control.data_valid = TRUE;
                ((MODULEALLOC *) pblock)->status[0] = rxp->rxbuf[(i*recordsize)+4];
                ((MODULEALLOC *) pblock)->status[1] = rxp->rxbuf[(i*recordsize)+5];
                ((MODULEALLOC *) pblock)->status[2] = rxp->rxbuf[(i*recordsize)+6];
                ((MODULEALLOC *) pblock)->status[3] = rxp->rxbuf[(i*recordsize)+7];
                ((MODULEALLOC *) pblock)->status[4] = rxp->rxbuf[(i*recordsize)+8];

                /* detect Module failure/error mode */
                ((MODULEALLOC *) pblock)->modulemode = (((MODULEALLOC *) pblock)->status[0] >> 5) & 0x03;
                break;

            default:
                pciu->holdflag = TRUE;
                pciu->is_responding = FALSE;
                return (CMDFAIL);
                break;
        }
    }
    /* the exception has been read and stored */
    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/*
** read system date and time                                                    
**                                                                              
*/
/* only called from scan_ciu */

static unsigned short readdatetime (unsigned short line)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;
    void          *pblock;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, timedata, recordsize;

    /* initialize all pointers for current values */
    pciu          = ciu [line];
    pciu->ploop   = pciu->loops[0];
    pciu->ppcu    = pciu->ploop->pcus[0];
    pciu->pmodule = pciu->ppcu->modules[0];
    pmodule       = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_datain_msgs++;

    /* Format the output message */
    buffer [0] = READSYSTEMDATETIME;
    buffer [1] = 0;

    makechecksum (&buffer[0], READSYSTEMDATETIMELEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    timedata = FALSE; /* presume no data */
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    if (rxp->rxbuf[1] == 0) /* test sync byte */
                    {
                        return (CMDNADA); /* TIME DATE NOT AVAILABLE */
                    }
                    timedata = TRUE;
                    break;

                case 0: /* No Problem */
                    if (rxp->rxbuf[1] == 0) /* test sync byte */
                    {
                        return (CMDNADA); /* TIME DATE NOT AVAILABLE */
                    }
                    timedata = TRUE;
                    break;

               default:
                    return (CMDFAIL);
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }

    pciu->time_valid = FALSE; /* just while it is being changed */

    pciu->syncbyte         =  rxp->rxbuf[(i*recordsize)+1];
    pciu->year             = (rxp->rxbuf[(i*recordsize)+2])*256 + rxp->rxbuf[(i*recordsize)+3];
    pciu->month            = (rxp->rxbuf[(i*recordsize)+4])*256 + rxp->rxbuf[(i*recordsize)+5];
    pciu->day              = (rxp->rxbuf[(i*recordsize)+6])*256 + rxp->rxbuf[(i*recordsize)+7];
    pciu->day_of_week      = (rxp->rxbuf[(i*recordsize)+8])*256 + rxp->rxbuf[(i*recordsize)+9];
    pciu->hour             = (rxp->rxbuf[(i*recordsize)+10])*256 + rxp->rxbuf[(i*recordsize)+11];
    pciu->minute           = (rxp->rxbuf[(i*recordsize)+12])*256 + rxp->rxbuf[(i*recordsize)+13];
    pciu->second           = (rxp->rxbuf[(i*recordsize)+14])*256 + rxp->rxbuf[(i*recordsize)+15];
    pciu->sample_number    = (rxp->rxbuf[(i*recordsize)+16])*256 + rxp->rxbuf[(i*recordsize)+17];
    pciu->time_sync_master = (rxp->rxbuf[(i*recordsize)+18])*256 + rxp->rxbuf[(i*recordsize)+19];

    pciu->time_valid = TRUE;

    /* the time has been read and stored */
    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/*
** send establish                                                               
**                                                                              
*/
/* only called from establishandconnect */

static unsigned short sendestablish (unsigned short line, void *pointer)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, recordsize;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0]  = ESTABLISHPOINT;
    buffer [1]  = 0;
    buffer [2]  = ((COMMONALLOC *) pointer)->control.index/256;
    buffer [3]  = ((COMMONALLOC *) pointer)->control.index%256;
    buffer [4]  = ((COMMONALLOC *) pointer)->control.CIUpoint;
    buffer [5]  = ((COMMONALLOC *) pointer)->control.loop;
    buffer [6]  = ((COMMONALLOC *) pointer)->control.pcu;
    buffer [7]  = 0;
    buffer [8]  = ((COMMONALLOC *) pointer)->control.module;
    buffer [9]  = ((COMMONALLOC *) pointer)->control.block/256;
    buffer [10] = ((COMMONALLOC *) pointer)->control.block%256;

    makechecksum (&buffer[0], ESTABLISHPOINTLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;
    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    break;

                case 0: /* No Problem */
                    break;

               default:
                    return (CMDFAIL);
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }

    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/*
** send connect                                                               
**                                                                              
*/
/* only called from establishandconnect */

static unsigned short sendconnect (unsigned short line, void *pointer)
{
    CIUALLOC      *pciu;
    MODULEALLOC   *pmodule;

    TXLINE        *txp;
    RXLINE        *rxp;
    unsigned short i;
    unsigned short length;
    unsigned char  buffer[256], type;

    unsigned short reply, replyclass, recordsize;

    /* initialize all pointers for current values */
    pciu    = ciu [line];
    pmodule = pciu->pmodule;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pciu->no_dataout_msgs++;

    /* Format the output message */
    buffer [0] = CONNECTPOINTLIST;
    buffer [1] = 0;
    buffer [2] = (((COMMONALLOC *) pointer)->control.index)/256;
    buffer [3] = (((COMMONALLOC *) pointer)->control.index)%256;
    buffer [4] = (((COMMONALLOC *) pointer)->control.index)/256;
    buffer [5] = (((COMMONALLOC *) pointer)->control.index)%256;

    makechecksum (&buffer[0], CONNECTPOINTLISTLEN, &(txp->txbuf [0]), &length);
    txp->txmsglen = length;

    /* Send out the message */
    if (msgxfer (line) == XFERBAD)
    {
        pciu->no_offlines++;
        pciu->holdflag = TRUE;
        pciu->is_responding = FALSE;
        return (CMDFAIL);
    }
    reply = pciu->reply;
    replyclass = pciu->replyclass;

    switch (replyclass)
    {
        /* test for a good response */
        case RC_NOERROR:
            pciu->is_responding = TRUE;
            switch (pciu->reply)
            {
                case 22: /* Specs Lost. We don't care about this. the question is, is there data? */
                    break;

                case 0: /* No Problem */
                    break;

               default:
                    return (CMDFAIL);
            }
            break;
        /* test for a required restart */
        case RC_INIT:
            pciu->holdflag = TRUE;
            pciu->is_responding = FALSE;
            return (CMDINIT);
            break;
        /* test for an unexpected/inappropriate response to the command. */
        case RC_PROBLEM:
        /* test for CIU/INFI-90 level functional error */
        case RC_CIU_ERR:
        /* test for RING level functional error */
        case RC_RING_ERR:
        /* test for PCU level functional error */
        case RC_PCU_ERR:
        /* test for Module level functional error */
        case RC_MODULE_ERR:
        /* test for CIU level logic error */
        case RC_LOGIC_ERR:
        /* test for Module level logic error */
        case RC_MLOGIC_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            return (CMDFAIL);
            break;
        /* test for CIU level config error */
        case RC_CONF_ERR:
        /* test for Module level config error */
        case RC_MCONF_ERR:
            pmodule->holdflag = TRUE;
            pmodule->is_responding = FALSE;
            pciu->no_dataerr++;
            return (CMDNACK);
        /* test for unknown error */
        case RC_UNKNOWN_ERR:
        default:
            return (CMDFAIL);
            break;
    }

    pciu->is_responding = TRUE;
    return (CMDDONE);
}

/********************************************************************************/
/********************************************************************************/
/*

floating point data format discussion:

IEEE-754 floating point format uses sign-magnitude representation and stores the
8 bit exponent in biased notation or 'excess - 127' notation. The mantissa is
stored in a 23 bit normalized form, with a hidden 24th bit located immediately to
the left of the the decimal point for all values except floating-point 0.
 
the 'internal' format (the memory stored format) is as follows:


|    byte 0     |    byte 1     |    byte 2     |    byte 3     |
-----------------------------------------------------------------
| sign | exponent |  mantissa                                   |
-----------------------------------------------------------------
 1 bit   8 bits     23 bits  


The Bailey Real-2 floating point format uses a three character long sign magnitude
format and stores the 7 bit exponent in unbiased two's complement notation. The
mantissa is stored in a 16 bit normalized form. 


the 'internal' format (the memory stored format) is as follows:

|    byte 0       |    byte 1     |    byte 2     |
---------------------------------------------------
| exponent | sign |  mantissa                     |
---------------------------------------------------
   7 bits   1 bit    16 bits  

*/



/*                                                                            
** float_to_real3                                                             
**                                                                            
**    convert native IEEE-754 floating point format to Bailey Real 3 format   
**                                                                            
*/
static unsigned short float_to_real3 (float input, unsigned char *output)
{
/* input:   floating point value (IEEE-754 format, 32 bits)    */
/* output:  points to a 3 character array holding the 24 bits  */
/*          of the output Bailey Real-3 value                  */ 

    unsigned char  sign;
    short          exponent;
    unsigned long  mantissa;

    union f_value {
                   float       fvalue;
                   long        lvalue;
                   short       svalue;
                   char        cvalue;
                   }  inputval;

    char cvalue[4];

    inputval.fvalue = input;


    if (inputval.lvalue == 0)
    {
        output[0] = 0;
        output[1] = 0;
        output[2] = 0;
        return (TRUE);
    }

    sign     = (((inputval.cvalue) & 0x80)?1:0);
    exponent = (((inputval.svalue) & 0x07fff) >> 7) - (127 - 1); 
    mantissa = (((inputval.lvalue | 0x00800000) & 0x00ffffff)) >> 8;

    /* test for convertible exponent */
    if ((exponent < -64) || (exponent > 63))
    {
        return (FALSE);
    }

    output[0] = (((exponent << 1) & 0xfe) | sign);
    output[1] = mantissa / 256;
    output[2] = mantissa % 256;
}

/*                                                                           
** real3_to_float:                                                           
**                                                                           
**    convert Bailey Real 3 format to native IEEE-754 floating point format  
**                                                                           
*/
static unsigned short real3_to_float (unsigned char *input, float *output)
{
/* input:   points to a 3 character array holding the 24 bits of the */
/*          input Bailey Real-3 value                                */
/* output:  points to a float value (IEEE-754 format, 32 bits),      */
/*          in which the value is returned                           */

    unsigned char  sign;
    short          exponent;
    unsigned long  mantissa;

    union f_value {
                   float       fvalue;
                   long        lvalue;
                   short       svalue;
                   char        cvalue;
                   }  outputval;

    if ((input[0] == 0) &&(input[1] == 0) &&(input[2] == 0))
    {
        *output = 0;
        return (TRUE);
    }

    sign     =   ((input[0] & 1)?1:0);
    exponent =   (signed short)(((signed char)input[0] >> 1) + (127 - 1));
    mantissa = ((((input[1] << 8 ) | input [2]) & 0x7fff) << 8);

    outputval.lvalue = mantissa;
    outputval.svalue = (outputval.svalue | (exponent << 7));
    outputval.cvalue = (outputval.cvalue | (sign?0x80:0));

    *output = outputval.fvalue;
    return (TRUE);
}

/*********************************************************************************************/
/*********************************************************************************************/
/***** User/Operator Routines ****************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/*
**                                                              	
** initialize the CIU statistics for the Bailey CIU Driver           	
**  this routine is for operator use only.                              
**
*/                                                               	
static	void clearciustats (unsigned short line)
{
    CIUALLOC  *pciu;

    pciu = ciu [line];

    initciustats (pciu);
    return;
}
/*
**                                                              	
** initialize the Loop statistics for the Bailey CIU Driver           	
**  this routine is for operator use only.                              
**
*/                                                               	
static	void clearloopstats (unsigned short line, unsigned short loop)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;

    pciu  = ciu [line];
    ploop = pciu->loops[loop];
    if (ploop == NULL) return;

    initloopstats (ploop);
    return;
}
/*
**                                                              	
** initialize the PCU statistics for the Bailey CIU Driver          	
**  this routine is for operator use only.                              
**                                                                      
*/                                                               	
static	void clearpcustats (unsigned short line, unsigned short loop,
                            unsigned short pcu)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;

    pciu  = ciu [line];
    ploop = pciu->loops[loop];
    if (ploop == NULL) return;
    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL) return;

    initpcustats (ppcu);
    return;
}
/*
**                                                              	
** initialize the Module statistics for the Bailey CIU Driver          	
**  this routine is for operator use only.                              
**                                                                      
*/                                                               	
static	void clearmodulestats (unsigned short line, unsigned short loop,
                               unsigned short pcu, unsigned short module)
{
    CIUALLOC       *pciu;
    LOOPALLOC      *ploop;
    PCUALLOC       *ppcu;
    MODULEALLOC    *pmodule;

    pciu  = ciu [line];
    ploop = pciu->loops[loop];
    if (ploop == NULL) return;
    ppcu = ploop->pcus[pcu];
    if (ppcu == NULL) return;
    pmodule = ppcu->modules[module];
    if (pmodule == NULL) return;

    initmodulestats (pmodule);
    return;
}


/*
**      DUMPMSGCNTS
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
**      CLEARMSGCNTS
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*
**      DUMPLINESTATS
**
**      The purpose of this routine is to dump the plc level statistics for this driver.  
**
*/
/* called from TABLEINFO */

void DUMPLINESTATS (unsigned short line)

    {
	CIUALLOC	*pciu;

	pciu = ciu [line];
	if (!pciu)
	{
	    printf ("Bailey Driver Task does not exist for line %d\n", line);
	    return;
	}

	printf (" Was requested      = %5d         ", pciu->control.was_requested);
	printf (" Is responding      = %5d         ", pciu->is_responding);
	printf (" # Output messages  = %5d       \n", pciu->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %5d         ", pciu->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response    = %5d         ", pciu->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses   = %5d       \n", pciu->no_txnoresp & 0x7fff);
	printf (" #Data Errors       = %5d         ", pciu->no_dataerr & 0x7fff);
	printf (" #Retries           = %5d         ", pciu->no_retries & 0x7fff);
	printf (" #Rx Hw Errors      = %5d       \n", pciu->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors      = %5d         ", pciu->no_txhwerrs & 0x7fff);
	printf (" #Crc Errors        = %5d         ", pciu->no_chksumerrs & 0x7fff);
	printf (" #Off Lines         = %5d       \n", pciu->no_offlines & 0x7fff);
	printf (" Reset Statistics   = %5d         ", pciu->cmd_reset_stat);
	printf (" Force Offline      = %5d         ", pciu->cmd_force_offline);
	printf (" #Failed Outputs    = %5d       \n", pciu->badoutcnt & 0x7fff);

	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Hold flag  = %d \n", pciu->holdflag );
        return;
}

/*
**      CLEARLINESTATS
**
**      The purpose of this routine is to clear the CIU level statistics for this driver.
**
*/
/* called from TABLEINFO */

void CLEARLINESTATS (unsigned short line)

    {
	CIUALLOC    *pciu;

	pciu = ciu [line];
	if (!pciu)
	{
	    printf ("Bailey Driver Task does not exist for line %d\n", line);
	    return;
	}

        initstats (line); /* use existing procedure */

        return;
    }


/*                                                                                 
**      baileyciuinfo                                                    	   
**                                                                           	   
**      The purpose of this routine is to dump the ciu's information               
**                                                                                 
*/
/* not called from within this driver */

void CIUINFO (unsigned short line)
{
    CIUALLOC      *pciu;
    LOOPALLOC     *ploop;
    unsigned short i;

    pciu = ciu [line];
    if (!pciu)
    {
        printf ("Bailey Driver Task does not exist for line %d\n", line);
        return;
    }

    printf ("CIU Loop Number = %d,  CIU PCU Number =  %d\n",
             pciu->LOOPnumber,
             pciu->PCUnumber);

    /***** Display Bailey Time *****/
    printf("  TimeDate:  Requested = %d,  Valid = %d\n", pciu->time_requested, pciu->time_valid);

    printf("  Sync = %d\n", pciu->syncbyte);

    printf("  Date (MM/DD/YY) = %2d/%2d/%2d, Day = %d, Time (HH:MM:SS) = %2d:%2d:%2d, Sample = %d\n",
            pciu->month, pciu->day, pciu->year, pciu->day_of_week,
            pciu->hour, pciu->minute, pciu->second, pciu->sample_number);

    printf ("Next Available Index Number = %d\n",  pciu->nextindex);
    printf ("Last Connected Index Number = %d\n",  pciu->lastconnected);

/*    commoninfo(pciu); */

    printf("  *** CIU specific display ************************************************\n");
    printf("  Status Validity = 0x%x%x\n", pciu->status_valid/16, pciu->status_valid%16);
    printf("  Status Value    = 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x\n",
            pciu->status_read[0]/16, pciu->status_read[0]%16,
            pciu->status_read[1]/16, pciu->status_read[1]%16,
            pciu->status_read[2]/16, pciu->status_read[2]%16,
            pciu->status_read[3]/16, pciu->status_read[3]%16,
            pciu->status_read[4]/16, pciu->status_read[4]%16);

    printf("  CIU Mode        = 0x%x%x\n", pciu->ciumode/16, pciu->ciumode%16);

    /* number of Loops defined. */
    for (i = LOWLOOP; (i <= HIGHLOOP); i++)
    {
        ploop = pciu->loops [i];
        if (ploop)
        {
            printf ("Loop %d Data Structure Exists.\n", i);
        }
    }

    /*** Display Loop Summary Statistics ***/
    /*     (not currently implemented)     */
    /*                                     */
    /*    number of pcus                   */
    /*    number of modules                */
    /*    number of points of each type    */
    /*    number of total points           */
    /*                                     */
    /***************************************/
}

void commoninfo (void *pointer)
{
    printf ("  Address = %5d,  Card: = %5d, Signal: = %5d, Type = %2d\n",
            ((COMMONALLOC *) pointer)->control.address,
            ((COMMONALLOC *) pointer)->control.card,
            ((COMMONALLOC *) pointer)->control.signal,
            ((COMMONALLOC *) pointer)->control.type);

    printf ("  Loop = %2d   PCU = %2d   Module = %2d   Block = %5d   Type = %2d   Element = %2d\n",
            ((COMMONALLOC *) pointer)->control.loop,
            ((COMMONALLOC *) pointer)->control.pcu,
            ((COMMONALLOC *) pointer)->control.module,
            ((COMMONALLOC *) pointer)->control.block,
            ((COMMONALLOC *) pointer)->control.type,
            ((COMMONALLOC *) pointer)->control.element);

    printf ("  WasRequested = %d,  Established = %d  Connected = %d  DataValid = %d\n",
            ((COMMONALLOC *) pointer)->control.was_requested,
            ((COMMONALLOC *) pointer)->control.established,
            ((COMMONALLOC *) pointer)->control.connected,
            ((COMMONALLOC *) pointer)->control.data_valid);

    printf ("  Index = %5d\n", ((COMMONALLOC *) pointer)->control.index);


}


/*
**      baileyciustats                                                    	   
**                                                                           	   
**      The purpose of this routine is to dump the statistics for the ciu          
**                                                                                 
*/
/* not called from within this driver */

void CIUSTATS (unsigned short line)
{
    CIUALLOC      *pciu;
/*    LOOPALLOC     *ploop; */
    unsigned short i;


    pciu = ciu [line];
    if (!pciu)
    {
        printf ("Bailey Driver Task does not exist for line %d\n", line);
        return;
    }

    printf ("CIU Loop Number = %d,  CIU PCU Number =  %d\n",
             pciu->LOOPnumber,
             pciu->PCUnumber);

    /***** Display Bailey Time *****/
    /* (not currently implemented) */

    printf ("Next Available Index Number = %d\n",  pciu->nextindex);

    printf ("Reply Code Counts\n");

    printf (" No Errors (0)                = %5d     \n"   , pciu->ciu_noerrors);
/*    printf ("\n"); */
    printf (" Loop Wait (1)                = %5d       "   , pciu->ciu_loopwait);
    printf (" Repeat CIURESTART (9)        = %5d       "   , pciu->ciu_repeatrestart);
    printf (" Need CIURESTART (18)         = %5d     \n"   , pciu->ciu_needrestart);
    printf (" Specifications Lost (22)     = %5d       "   , pciu->ciu_specslost);
    printf (" Empty Queue (23)             = %5d       "   , pciu->ciu_emptyqueue);
    printf (" Index In Use (28)            = %5d     \n"   , pciu->ciu_indexinuse);
/*    printf ("\n"); */
    printf (" Bad Reply from BTM (7)       = %5d       "   , pciu->ciu_btmbad);
    printf (" Host Comm Error (12)         = %5d       "   , pciu->ciu_commerror);
    printf (" Timeout Between Bytes (27)   = %5d     \n"   , pciu->ciu_commtimeout);
    printf (" Checksum Error (31)          = %5d       "   , pciu->ciu_checksum);
    printf (" CIU Busy (35)                = %5d       "   , pciu->ciu_busy);
    printf (" Node (PCU) Busy (40)         = %5d     \n"   , pciu->node_busy);
    printf (" Ring (Loop) Busy (41)        = %5d       "   , pciu->ring_busy);
    printf (" Module Busy (101)            = %5d     \n"   , pciu->module_busy);
/*    printf ("\n"); */
/*    taskDelay(30); */
    printf (" BTM Not Responding (13)      = %5d       "   , pciu->ciu_btmbad);
    printf (" Plant Loop Timeout (15)      = %5d       "   , pciu->ciu_commerror);
    printf (" Node (PCU) Offline (32)      = %5d     \n"   , pciu->ciu_commtimeout);
    printf (" CIU_Error (34)               = %5d       "   , pciu->ciu_checksum);
    printf (" BTM_Offline (36)             = %5d       "   , pciu->ciu_busy);
    printf (" Ring (Loop) Offline (39)     = %5d     \n"   , pciu->node_busy);
    printf (" Module Memory Error (109)    = %5d       "   , pciu->ring_busy);
    printf (" Module Not Responding (110)  = %5d     \n"   , pciu->module_busy);
/*    printf ("\n"); */
    printf (" Export Used As Import (8)    = %5d       "   , pciu->ciu_eierr);
    printf (" CIU Memory Full (11)         = %5d       "   , pciu->ciu_memerr);
    printf (" Import Used As Export (14)   = %5d     \n"   , pciu->ciu_ieerr);
    printf (" Number Out Of Range (16)     = %5d     \n"   , pciu->ciu_rangeerr);
/*    printf ("\n"); */
    printf (" Undefined Message (100)      = %5d       "   , pciu->module_badmsg);
    printf (" Data Range Error (103)       = %5d       "   , pciu->module_rangeerr);
    printf (" Invalid Block Number (104)   = %5d     \n"   , pciu->module_blkerr);
    printf (" Undefined Block Number (105) = %5d       "   , pciu->module_blkundef);
    printf (" Block Not Readable (106)     = %5d       "   , pciu->module_blknoread);
    printf (" Invalid Function Code (107)  = %5d     \n"   , pciu->module_funerr);
    printf (" FC and BN Incompatible (108) = %5d     \n"   , pciu->module_funblkerr);
/*    printf ("\n"); */
/*    taskDelay(30); */
    printf (" Improper Command Format (2)  = %5d       "   , pciu->ciu_format);
    printf (" Illegal Command (3)          = %5d       "   , pciu->ciu_illegal);
    printf (" Multiple Index Est Error (4) = %5d     \n"   , pciu->ciu_reindex);
    printf (" Multiple Block Est Error (5) = %5d       "   , pciu->ciu_reblock);
    printf (" Command Too Long (6)         = %5d       "   , pciu->ciu_toolong);
    printf (" Undefined Index (10)         = %5d     \n"   , pciu->ciu_noindex);
    printf (" Illegal Key (17)             = %5d       "   , pciu->ciu_badkey);
    printf (" Mod Stat Used As Import(19)  = %5d       "   , pciu->ciu_mierr);
    printf (" Message Active On Loop (20)  = %5d     \n"   , pciu->ciu_msgactive);
    printf (" Im/Ex Used As Mod Stat (21)  = %5d       "   , pciu->ciu_iomerr);
    printf (" Reply Too Large (24)         = %5d       "   , pciu->ciu_bigreply);
    printf (" Illegal Station Mode (25)    = %5d     \n"   , pciu->ciu_illegalsmc);
    printf (" Illegal Module Number (26)   = %5d       "   , pciu->ciu_reporterr);
    printf (" PointType/Command Error (29) = %5d       "   , pciu->ciu_pointbad);
    printf (" WatchDog Timeout (30)        = %5d     \n"   , pciu->ciu_watchdog);
    printf (" Callup Command Required (33) = %5d       "   , pciu->ciu_needcallup);
    printf (" Monitor Mode Conflict (37)   = %5d       "   , pciu->ciu_mmconflict);
    printf (" Point Type Mismatch (38)     = %5d     \n"   , pciu->ciu_pointtype);
    printf (" Module Mode Conflict (102)   = %5d     \n"   , pciu->module_cmmismatch);
/*    printf ("\n"); */
    printf (" Unknown Reply Code           = %5d     \n"   , pciu->ciu_unknown);
    taskDelay(60);
}

void CIUTREE (unsigned short line)
{
  CIUALLOC       *pciu;
  LOOPALLOC      *ploop;
  PCUALLOC       *ppcu;
  MODULEALLOC    *pmodule;
  BLOCK100ALLOC  *pblock100;
  void           *pblock;

  unsigned short h, i, j, k, l;

  pciu = ciu [line];

  for (h = 0 /*LOWLOOP*/; (h <= HIGHLOOP); h++)
  {
    ploop = pciu->loops [h];
    if ((ploop) && (ploop->control.was_requested))
    {
      printf ("Loop %d\n", h);
      for (i = 0 /*LOWPCU*/; (i <= HIGHPCU); i++)
      {
        ppcu = ploop->pcus [i];
        if ((ppcu) && (ppcu->control.was_requested))
        {
            printf ("    PCU %d\n", i);
            for (j = 0 /*LOWMODULE*/; (j <= HIGHMODULE); j++)
            {
                pmodule = ppcu->modules [j];
                if ((pmodule) && (pmodule->control.was_requested))
                {
                    printf ("        Module %2d                    (index %d) %d\n", j,
                            pmodule->control.index,
                            pmodule->control.data_valid);
                    for (k = 0; (k < HIGHBLOCK/NUMBLOCKALLOC); k++)
                    {
                        pblock100 = pmodule->blocks100 [k];
                        if ((pblock100) && (pblock100->control.was_requested))
                        {
                            printf ("            Block100 %d\n", k);
                            for (l = 0; (l < NUMBLOCKALLOC); l++)
                            {
                                pblock = pblock100->blocks[l];
                                if (pblock)
                                {
                                    printf ("                  Block %2d, Type %d   (index %d) %d\n", l,
                                            ((COMMONALLOC *) pblock)->control.type,
                                            ((COMMONALLOC *) pblock)->control.index,
                                            ((COMMONALLOC *) pblock)->control.data_valid);
                                }
                            }
                        }
                    }
                }
            }
        }
      }
    }
  }
}

/*
**      baileymodule                                                       	   
**                                                                           	   
**      The purpose of this routine is to dump the data for the specified module   
**                                                                                 
*/
/* not called from within this driver */

void MODULEINFO (unsigned short line,
                 unsigned short loop,
                 unsigned short pcu,
                 unsigned short module)
{
    CIUALLOC      *pciu;
    LOOPALLOC     *ploop;
    PCUALLOC      *ppcu;
    MODULEALLOC   *pmodule;
    BLOCK100ALLOC *pblock100;
    void          *pblock;

    unsigned short pcu_module;
    unsigned short block100;
    unsigned short block;


    TXLINE        *txp;
    RXLINE        *rxp;

    unsigned short length;
    unsigned short reply, replyclass, index;

    unsigned short   i, j;
    unsigned short   linecnt;

    pciu = ciu [line];
    if (!pciu)
    {
        printf ("Bailey Driver Task does not exist for line %d\n", line);
        return;
    }

    ploop = pciu->loops [loop];
    if (!ploop)
    {
        printf ("Bailey Loop %d not defined in this CIU.\n", loop);
        return;
    }

    ppcu = ploop->pcus [pcu];
    if (!ppcu)
    {
        printf ("Bailey Loop %d, PCU %d not defined in this CIU.\n", loop, pcu);
        return;
    }

    pmodule = ppcu->modules [module];
    if (!pmodule)
    {
        printf ("Bailey Loop %d, PCU %d, Module %d, not defined in this CIU.\n", loop, pcu, module);
        return;
    }

    /* print the module information if available */

    printf ("Bailey Loop %d, PCU %d, Module %d\n", loop, pcu, module);

    printf("  *** common display *********************************************************\n");

    commoninfo(pmodule);

    printf("  *** module specific display ************************************************\n");
    printf("  Module Status = 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x\n",
            pmodule->status[0]/16, pmodule->status[0]%16,
            pmodule->status[1]/16, pmodule->status[1]%16,
            pmodule->status[2]/16, pmodule->status[2]%16,
            pmodule->status[3]/16, pmodule->status[3]%16,
            pmodule->status[4]/16, pmodule->status[4]%16);

    printf("  Module Mode   = 0x%x%x\n", pmodule->modulemode/16, pmodule->modulemode%16);


    printf("  DetailStatus  = 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x, 0x%x%x\n",
            pmodule->detailstatus[0]/16, pmodule->detailstatus[0]%16,
            pmodule->detailstatus[1]/16, pmodule->detailstatus[1]%16,
            pmodule->detailstatus[2]/16, pmodule->detailstatus[2]%16,
            pmodule->detailstatus[3]/16, pmodule->detailstatus[3]%16,
            pmodule->detailstatus[4]/16, pmodule->detailstatus[4]%16,
            pmodule->detailstatus[5]/16, pmodule->detailstatus[5]%16,
            pmodule->detailstatus[6]/16, pmodule->detailstatus[6]%16,
            pmodule->detailstatus[7]/16, pmodule->detailstatus[7]%16,
            pmodule->detailstatus[8]/16, pmodule->detailstatus[8]%16,
            pmodule->detailstatus[9]/16, pmodule->detailstatus[9]%16);

    printf("  ************************************************************************************\n");
    /* now print the function block contents that have been read to date. */

    linecnt = 18;

/*    printblockhhdr (buffer, linecnt); */

    for (i = 0; (i < HIGHBLOCK/NUMBLOCKALLOC); i++)
    {
        pblock100 = pmodule->blocks100 [i];
        if (pblock100)
        {
            for (j = 0; (j < NUMBLOCKALLOC); j++)
            {
                pblock = pblock100->blocks [j];
                if (pblock)
                {
                    if (linecnt >= 18)
                    {
                        commonheader();
                        linecnt = 0;
                    }
                    print_block (pblock);
                    linecnt++;
                }
            }
        }
    }
    printf ("  ************************************************************************************\n");
}


static void commonheader (void)
{
    printf("    ----------------------------------------------------------\n");
    printf("    Item   R E C V: Address  Card Signal  Index :TYPE: STATUS:\n");
    printf("    ----------------------------------------------------------\n");
}
static void print_block (void *pblock)
{
    static short blockcount;

    union join {
                       float          real;
                       unsigned char  byte[4];
               } both;


    blockcount++;

    printf("    %3d    %1d %1d %1d %1d:    %4d  %4d  %5d    %2d  :",
            blockcount,
            ((COMMONALLOC *) pblock)->control.was_requested,
            ((COMMONALLOC *) pblock)->control.established,
            ((COMMONALLOC *) pblock)->control.connected,
            ((COMMONALLOC *) pblock)->control.data_valid,
            ((COMMONALLOC *) pblock)->control.address,
            ((COMMONALLOC *) pblock)->control.card,
            ((COMMONALLOC *) pblock)->control.signal,
/*            ((COMMONALLOC *) pblock)->control.type, */
            ((COMMONALLOC *) pblock)->control.index);

    switch (((COMMONALLOC *) pblock)->control.type)
    {
        case AER_TYPE:
                 both.real = ((AERALLOC *) pblock)->data_read;
            printf("AER:  0x%x%x       Raw: %x%x %x%x %x%x  FLOAT: %x%x %x%x %x%x %x%x  Value(R):%6.1f\n",
                 (((AERALLOC *) pblock)->status_read)/16, (((AERALLOC *) pblock)->status_read)%16,
                 (((AERALLOC *) pblock)->raw_read[0])/16, (((AERALLOC *) pblock)->raw_read[0])%16,
                 (((AERALLOC *) pblock)->raw_read[1])/16, (((AERALLOC *) pblock)->raw_read[1])%16,
                 (((AERALLOC *) pblock)->raw_read[2])/16, (((AERALLOC *) pblock)->raw_read[2])%16,
                    both.byte[0]/16, both.byte[0]%16,
                    both.byte[1]/16, both.byte[1]%16,
                    both.byte[2]/16, both.byte[2]%16,
                    both.byte[3]/16, both.byte[3]%16,
                  ((AERALLOC *) pblock)->data_read);
            break;
        case DER_TYPE:
            printf("DER:  0x%x%x\n",
                 (((DERALLOC *) pblock)->status_read)/16, (((DERALLOC *) pblock)->status_read)%16);
            break;
        case RCM_TYPE:
            printf("RCM:  0x%x%x,0x%x%x  Mode(W):0x%x%x\n",
                 (((RCMALLOC *) pblock)->status_read[0])/16, (((RCMALLOC *) pblock)->status_read[0])%16,
                 (((RCMALLOC *) pblock)->status_read[1])/16, (((RCMALLOC *) pblock)->status_read[1])%16,
                 (((RCMALLOC *) pblock)->status_write)/16,   (((RCMALLOC *) pblock)->status_write)%16);
            break;
        case RMSC_TYPE:
            printf("RMSC: 0x%x%x       Mode(W):0x%x%x   Value(R):%6.1f   Value(W):%6.1f\n",
                 (((RMSCALLOC *) pblock)->status_read)/16,  (((RMSCALLOC *) pblock)->status_read)%16,
                 (((RMSCALLOC *) pblock)->status_write)/16, (((RMSCALLOC *) pblock)->status_write)%16,
                  ((RMSCALLOC *) pblock)->data_read,
                  ((RMSCALLOC *) pblock)->data_write);
            break;
        case CS_TYPE:
            printf("CS:   0x%x%x,0x%x%x  PV(R):%6.1f  SP(R):%6.1f  CO(R):%6.1f  RI(R):%6.1f\n",
                 (((CSALLOC *) pblock)->status_read[0])/16, (((CSALLOC *) pblock)->status_read[0])%16,
                 (((CSALLOC *) pblock)->status_read[1])/16, (((CSALLOC *) pblock)->status_read[1])%16,
                  ((CSALLOC *) pblock)->PV_read,
                  ((CSALLOC *) pblock)->SP_read,
                  ((CSALLOC *) pblock)->CO_read,
                  ((CSALLOC *) pblock)->RI_read);
            printf("                                                :  :");
            printf("  Mode(W):0x%x%x              SP(W):%6.1f  CO(W):%6.1f  RI(W):%6.1f\n",
                 (((CSALLOC *) pblock)->status_write)/16,   (((CSALLOC *) pblock)->status_write)%16,
                  ((CSALLOC *) pblock)->SP_write,
                  ((CSALLOC *) pblock)->CO_write,
                  ((CSALLOC *) pblock)->RI_write);
            break;
        case DD_TYPE:
            printf("DD:   0x%x%x,0x%x%x  Mode(W):0x%x%x\n",
                 (((DDALLOC *) pblock)->status_read[0])/16, (((DDALLOC *) pblock)->status_read[0])%16,
                 (((DDALLOC *) pblock)->status_read[1])/16, (((DDALLOC *) pblock)->status_read[1])%16,
                 (((DDALLOC *) pblock)->status_write)/16,   (((DDALLOC *) pblock)->status_write)%16);
            break;
        default:
            printf("????: [0]=0x%x, [1]=0x%x,  [2]=0x%x,  [3]=0x%x,  [4]=0x%x,  [5]=0x%x,  [6]=0x%x,  [7]=0x%x\n",
                   ((COMMONALLOC *) pblock)->data_read[0],
                   ((COMMONALLOC *) pblock)->data_read[1],
                   ((COMMONALLOC *) pblock)->data_read[2],
                   ((COMMONALLOC *) pblock)->data_read[3],
                   ((COMMONALLOC *) pblock)->data_read[4],
                   ((COMMONALLOC *) pblock)->data_read[5],
                   ((COMMONALLOC *) pblock)->data_read[6],
                   ((COMMONALLOC *) pblock)->data_read[7]);
            break;
    }
}

/*
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/
/* this routine not called from within this driver */

LINEINFO ()
{
	short	i;
	char	buffer [132];
	char	*resrsp;
	char	*lineact;

        printf ("                                 Bailey Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number       CIU Table           Name        Response");
        printf ("     Activity      IM  .TX  TX.         Tick\n");
	printf ("\n");

	for (i = 0; i < NUMLINES; i++)
	{
	    if(ciu [i] == NULL)
	    {
		continue;
	    }
            /* if not, we've got an installed driver on this line */
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (activity_state [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s          %2d   %2d   %2d      %6d\n",
			i,ciu[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_tick[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}




/*	End of File:	drvBailey.c */
