/*drvMr350.c,v 1.1.1.1 1999/08/03 14:43:22 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*                                                                                 
**  File: drvMr350.c                                                               
**                                                                                 
**  Edit: 09/17/96      WEP: created MR-350 Data Collection Terminal (DCT) Drive   
**        09/04/97	WEP: added Resource Group Lock function                    
**        09/26/97	WEP: rtuname sensitive code in getSetCurrentState modified 
**                         : to only strip trailing A, B, a, and b characters from 
**                         : the rtuname when building database point names.       
**        10/29/97      WEP: added ability to modify the 'ack' response count.     
**                         : added controls to individually enable and disable the 
**                         : sending a 0xff byte both pre and post transmission of 
**                         : a command, ack, or nak message to the MR350. inserted 
**                         : a version number into the help message. fixed benign  
**                         : flaw in the Resource Group Lock function.             
**                         : removed MDS radio mutual-exclusion shared line logic. 
**        11/10/97      WEP: added logic to send multiple pre and post TX 0xFF     
**                         : characters. added utility to send MR350 OS timeout    
**                         : communication parameter to the MR350. removed radio   
**                         : mutual exclusion logic. created explicit test for     
**                         : RES_LOCKED mode in the Resource Group Lock logic.     
**        11/20/97      WEP: modified driver invocation to add a port parameter to 
**                         : be used in the Partner Redundant Update function.     
**                         : now start Partner Redundant Update function only when 
**                         : driver is started in redundant mode.                  
**         1/22/98      WEP: modified BODRIVER and BOREAD to make PERIMETER and    
**                         : NEWFILES card types independent of the is_responding  
**                         : status flag of the mr350.                             
*/

#define  VERSIONNUM     98                  /* NOTE: change here */

#define  RSATASK        mr350_rsa           /* NOTE: change here */

#define  MAIN           mr350_driver        /* NOTE: change here */
#define  AIDRIVER       mr350_aidriver      /* NOTE: change here */
#define  AODRIVER       mr350_aodriver      /* NOTE: change here */
#define  AOREAD         mr350_aoread        /* NOTE: change here */
#define  BIDRIVER       mr350_bidriver      /* NOTE: change here */
#define  BODRIVER       mr350_bodriver      /* NOTE: change here */
#define  BOREAD         mr350_boread        /* NOTE: change here */
#define  SIDRIVER       mr350_sidriver      /* NOTE: change here */
#define  SODRIVER       mr350_sodriver      /* NOTE: change here */

#define  TRAFFICON      mr350trafficon      /* NOTE: change here */
#define  TRAFFICOFF     mr350trafficoff     /* NOTE: change here */
#define  TRAFFIC        mr350traffic        /* NOTE: change here */
#define  TRACEON        mr350traceon        /* NOTE: change here */
#define  TRACEOFF       mr350traceoff       /* NOTE: change here */
#define  RTRACE         mr350restrlv        /* NOTE: change here */
#define  RTRACEON       mr350restraceon     /* NOTE: change here */
#define  RTRACEOFF      mr350restraceoff    /* NOTE: change here */
#define  TRACELEVEL     mr350trlv           /* NOTE: change here */
#define  CONTRACEON     mr350contraceon     /* NOTE: change here */
#define  CONTRACEOFF    mr350contraceoff    /* NOTE: change here */
#define  RUNTRACEON     mr350runtraceon     /* NOTE: change here */
#define  RUNTRACEOFF    mr350runtraceoff    /* NOTE: change here */
#define  REJECTTRACEON  mr350rejecttraceon  /* NOTE: change here */
#define  REJECTTRACEOFF mr350rejecttraceoff /* NOTE: change here */
/* #define  NACKTRACEON    mr350nacktraceon    ** NOTE: change here */
/* #define  NACKTRACEOFF   mr350nacktraceoff   ** NOTE: change here */
#define  DEFAULTTRACE   mr350defaulttrace   /* NOTE: change here */
#define  DEBUGTRACE     mr350debugtrace     /* NOTE: change here */

#define  HELP           mr350help           /* NOTE: change here */
#define  SIMON          mr350simon          /* NOTE: change here */
#define  SIMOFF         mr350simoff         /* NOTE: change here */

#define  STOPDRIVER     stopmr350           /* NOTE: change here */
#define  STARTDRIVER    startmr350          /* NOTE: change here */
#define  SETCOMM        mr350comm           /* NOTE: change here */
#define  SHOWINFO       mr350info           /* NOTE: change here */

#define  DUMPMSGCNTS    mr350dumpmsgcnts    /* NOTE: change here */
#define  CLEARMSGCNTS   mr350clearmsgcnts   /* NOTE: change here */
#define  DUMPDCTSTATS   mr350dumpdctstats   /* NOTE: change here */
#define  CLEARDCTSTATS  mr350cleardctstats  /* NOTE: change here */

#define  TABLEINFO      mr350table          /* NOTE: change here */

#define  ASSIGNGROUP    mr350ResGroup       /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
/*
#include <types.h>
#include <in.h>
#include <bootLib.h>
#include <inetLib.h>
*/
#include <sysLib.h>
#include <semLib.h>
/*
#include <errno.h>
#include <socket.h>
#include <selectLib.h>
#include <fcntl.h>
#include <ioLib.h>
*/
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdlib.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
/*#include <module_types.h>*/
/*
#include <cvnTypes.h>
*/
#include <tsDefs.h>
#include <drvMr350.h>			  /* NOTE: change here */
#include <drvMr350_proto.h> 		  /* NOTE: change here */
#include <restable.h>
/*
#include <devType.h>
#include <scan_types.h>
*/

/* -------------------------------- */
/* Remote Site Access Include Files */
/* -------------------------------- */

#include <stdio.h>
#include <ctype.h>
#include <bootLib.h>
#include <time.h>
#include <string.h>
#include <dbAccess.h>
#include <slmDefs.h>
#include <sys/stat.h>


extern TS_STAMP	time_stamp;	/* current time stamp, defined in .../share/src/time/ts_drive.c */


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvMr350={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
static 	unsigned char	resnames [MR350LINES] [RESNAMELEN]; /* array of resource name strings.		*/

static 	RES_TABLE	*prestable [MR350LINES];	/* array of pointers to resource tables 	*/

static 	unsigned short	resresponse [MR350LINES];	/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

static 	unsigned short	line_activity [MR350LINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
static 	unsigned short	lastactivity [MR350LINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

static 	unsigned short	modtrace [MR350LINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
static 	unsigned short	mltrace [MR350LINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
static 	unsigned short	modrestrace [MR350LINES];	/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

static 	SEM_ID		semids [MR350LINES] [2];	/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

static 	unsigned short	intermsgdelay [MR350LINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
static 	unsigned short	pretxdelay [MR350LINES];	/* holds post RTS delay before TX. 		*/
static 	unsigned short	posttxdelay [MR350LINES];	/* holds post TX delay before dropping RTS. 	*/

static 	long		activity_time [MR350LINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

static   unsigned short  halfduplex [MR350LINES];        /* store half/full duplex line status           */

static   unsigned short  pstatewait [MR350LINES];       /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

extern  short           resGroupLock [];                /* holds line driver group lock flags.          */
extern  char           *resGroupTripName [];            /* holds line driver trip name.                 */


/*
**      Storage for MR-350 DCT Comm Line Structures
**
*/

static RXLINE          *rxlinetab [MR350LINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ; /* array of pointers to dynamically           */
                                       /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [MR350LINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ; /* array of pointers to dynamically           */
                                       /* allocated comm controls/buffers            */

/*
**      Storage for MR-350 DCT Structures
**
*/
static unsigned short   pryvate [MR350LINES];      /* 0 = redundant mode,   !0=private mode             */

static unsigned int     dctsim [MR350LINES];       /* 0 = normal operation, 1 = DCT simulation.         */

static unsigned int	simdelay [MR350LINES];

static 		int	simlow [MR350LINES];

static 		int	simhigh [MR350LINES];

static		int	simdigon [MR350LINES];

static unsigned int     tick [MR350LINES][5];

static unsigned int     lastscan [MR350LINES];          /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [MR350LINES];          /* holds actual time taken to scan dcts.        */

static unsigned int     taskoutmsgs [MR350LINES];

static unsigned int     loopoutmsgs [MR350LINES];

static unsigned int     loopmsgs [MR350LINES];

static LINESTATS	linestats [MR350LINES];		/* array of line level statistics.              */

static MR350		*dcts [MR350LINES] [NUMDCTS + 1];/* two dimensional array of pointers to the    */
                                                        /* fixed length dynamically allocated DCT       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the DCT address value.        */

static ACCESS           *access [MR350LINES];           /* one dimensional array of pointers to the     */
                                                        /* fixed length dynamically allocated DCT       */
                                                        /* control and data structures.                 */

static	unsigned short	trace [MR350LINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [MR350LINES];
static  unsigned char   tracetype [MR350LINES];

static OUTPUTQUE	*oq [MR350LINES];		/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static TASKQUE	        *tq [MR350LINES];		/* array of ptrs to the line task queues and    */
                                                        /* their control structures                     */

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on the Valid User */
                                                        /* Password file                                */

static  unsigned short  options [MR350LINES];           /* store half/full duplex line status           */

static char    *bools [] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [MR350LINES];


static char *tasknames [] = {"MR-350 Ch0","MR-350 Ch1","MR-350 Ch2","MR-350 Ch3",
                             "MR-350 Ch4","MR-350 Ch5","MR-350 Ch6","MR-350 Ch7",
                             "MR-350 Ch8","MR-350 Ch9","MR-350 Ch10","MR-350 Ch11",
                             "MR-350 Ch12","MR-350 Ch13","MR-350 Ch14",
                             "MR-350 Ch15","MR-350 Ch16","MR-350 Ch17",
                             "MR-350 Ch18","MR-350 Ch19","MR-350 Ch20",
                             "MR-350 Ch21","MR-350 Ch22","MR-350 Ch23",
                             "MR-350 Ch24","MR-350 Ch25","MR-350 Ch26",
                             "MR-350 Ch27","MR-350 Ch28","MR-350 Ch29",
                             "MR-350 Ch30","MR-350 Ch31","MR-350 Ch32"
                            };
static char *subtasknames [] = {"RSA Ch0","RSA Ch1","RSA Ch2","RSA Ch3",
                                "RSA Ch4","RSA Ch5","RSA Ch6","RSA Ch7",
                                "RSA Ch8","RSA Ch9","RSA Ch10","RSA Ch11",
                                "RSA Ch12","RSA Ch13","RSA Ch14",
                                "RSA Ch15","RSA Ch16","RSA Ch17",
                                "RSA Ch18","RSA Ch19","RSA Ch20",
                                "RSA Ch21","RSA Ch22","RSA Ch23",
                                "RSA Ch24","RSA Ch25","RSA Ch26",
                                "RSA Ch27","RSA Ch28","RSA Ch29",
                                "RSA Ch30","RSA Ch31","RSA Ch32"
                            };

static unsigned short mr350ResGroups [MR350LINES] =
			{0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0} ; /* line driver group assignments   */


static unsigned short  snag [MR350LINES];

static unsigned short  ackcount [MR350LINES] =
			{1, 1, 1, 1, 1, 1, 1, 1,
                         1, 1, 1, 1, 1, 1, 1, 1,
                         1, 1, 1, 1, 1, 1, 1, 1,
                         1, 1, 1, 1, 1, 1, 1, 1} ; /* ACK reply count   */


static unsigned short   mr350timeout [MR350LINES];

/*
**      Storage for MR-350 DCT Structures
**
*/
static SEM_ID           redsemids [MR350LINES];
static int		redsize [MR350LINES];
static int		Rsaredport [MR350LINES];
static int		Rsaredperiod [MR350LINES];
static	RSAREDUPD	redund [MR350LINES];

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf ("Starting and Stopping the MR350 Driver:\n");
    printf ("\n");
    printf (" startmr350(N,P,C,t1,f,t2,t3,P)                                                 \n");
    printf ("                     N:  start the driver on line N.                            \n");
    printf ("                     P:  port for Partner Redundant Update function.            \n");
    printf ("                     C:  communications parameter string (comma delimited ascii)\n");
    printf ("                     t1: intermessage delay (in ticks)                          \n");
    printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex   \n");
    printf ("                     t2: post RTS assert, pre TX delay (in ticks)               \n");
    printf ("                     t3: post TX, pre RTS drop delay (in ticks)                 \n");
    printf ("                     P:  Private flag.  0 = Redundant, 1 = Non-Redundant        \n");
    printf ("                                                                                \n");
    printf (" Example: startmr350(2,\"9600,N,8,1\", 2,1,4,0)                                 \n");
    printf ("                                                                                \n");
    printf ("  (v%d)                                                             \n", VERSIONNUM);
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" MR-350 Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" mr350traceon(N)        Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                   \n");
    printf ("                           scan time, total output messages, and total messages.    \n"); 
    printf ("                         2) Output Queue Overflow.                                  \n");
    printf ("                         3) All communication errors encountered in msgxfer.        \n");
    printf ("*mr350traceoff(N)       Disable all of the mr350traceon debug messages for line N.  \n");
    printf ("\n");
    printf (" mr350restrlv(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*mr350restraceon(N)     Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" mr350restraceoff(N)    Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mr350contraceon(N)     Enable display of configuration errors in driver calls.     \n");
    printf ("*mr350contraceoff(N)    Disable display of configuration errors in driver calls.    \n");
    printf (" mr350runtraceon(N)     Enable display of runtime errors (queue overflow).          \n");
    printf ("*mr350runtraceoff(N)    Disable display of runtime errors (queue overflow).         \n");
    printf (" mr350rejecttraceon(N)  Enable display of driver call rejections in driver calls.   \n");
    printf ("*mr350rejecttraceoff(N) Disable display of driver call rejections in driver calls.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mr350trlv(N,X)         Enable the following message for line N:                    \n");
    printf ("                         X=0,  display none of the messages below.                  \n");
    printf ("                         X=1,  beginning of mr350 scan loop, bringing DCTs online.  \n");
    printf ("                         X=2,  beginning of DCT scan.                               \n");
    printf ("                         X=3,  AO queue actions (normal: AODRIVER & checkoutputs)   \n");
    printf ("                         X=4,  BO queue actions (normal: BODRIVER & checkoutputs)   \n");
    printf ("                         X=5,  SO queue actions (normal: SODRIVER & checkoutputs)   \n");
    printf ("                         X=6,  calls to checkoutputs.                               \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.           \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.                \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.                \n");
    printf ("                         X=10, SIDRIVER: normal call return.                        \n");
    printf ("                         X=11 to 254,  reserved.                                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mr350trafficon(N)      Enable traffic tracing for all MR350 DCT addresses          \n");
    printf ("                         and all MR350 functions on line N.                         \n");
    printf ("*mr350trafficoff(N)     Disable all traffic tracing on line N.                      \n");
    printf (" mr350traffic(N,X,Y)    Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.                   \n");
    printf ("                         X=255 enables tracing of all addresses.                    \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.          \n");
    printf ("                         Y=0   disables tracing of all MR350 functions.             \n");
    printf ("                         Y=255 enables tracing of all MR350 functions.              \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.         \n");
    printf ("\n");
    printf (" mr350defaulttrace(N)   Restores default setting for all traces.                    \n");
    printf ("\n");

/*    taskDelay (30); ** Time for operator to see it and pause the output */
/*
**    printf (" mr350simon(N,D,L,H,T)  Enables the simulation of responding MR350 DCTs.            \n");
**    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60.  \n");
**    printf ("                        L: low value of analog simulation range.                    \n");
**    printf ("                        H: high value of analog simulation range.                   \n");
**    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle. \n");
**    printf ("*mr350simoff(N)         Disables simulation, thus enabling normal driver function.  \n");
**    printf ("\n");
*/
    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" mr350info(N)            Display startup and current state information.             \n");
    printf (" mr350comm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows: \n");
    printf ("                         t1: intermessage delay (in ticks).                         \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                      \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).              \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).                \n");
    printf ("\n");
    printf (" mr350dumpmsgcnts(N)       Display line N communication statistics.                 \n");
    printf (" mr350clearmsgcnts(N)      Display and clear line N communication statistics.       \n");
    printf (" mr350dumpdctstats(N,X)    Display line N, MR350 DCT X, comm statistics.            \n");
    printf (" mr350cleardctstats(N,X)   Display and clear line N, MR350 DCT X, xfers,            \n");
    printf ("                             status & errors.                                       \n");
    printf (" mr350table(N,X)           Display line N, MR350 DCT X, transfers, status,          \n");
    printf ("                             errors and input data.                                 \n");
    printf (" mr350ResGroup(N,G)        Assign line N to group G (valid G range is 1 to 16)      \n");
}

/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line]  = 255;  /* every address      */
        tracetype [line] = 255;  /* every message type */
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}


/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	This routine enables the simulation of responding dcts, reading all input values as zero.
**
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	dctsim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
**
**	This routine disables simulation, thus enabling normal driver function.
**
********/
void SIMOFF (unsigned short line)
{
	dctsim [line] = FALSE;
}

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }

/********
**
**	This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
{
    /* debug structures */
    modtrace [line] = FALSE;
    mltrace [line] = 0;
    modrestrace [line] = 1;
    trace [line] = 0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
}
/********
**
**	This routine turns on all error tracing.
**
********/
void DEBUGTRACE (unsigned short line)
{
    /* debug structures */
    modtrace [line] = TRUE;
    modrestrace [line] = 2;
    trace[line] = /* DCTNACKTRACE | */
                  CONFIGURATIONTRACE |
                  RUNTIMEERRORTRACE |
                  CALLREJECTTRACE |
                  RSADEBUGENABLE |
                  0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
}

void mr350debug (unsigned short line)
{
    /* debug structures */
    modtrace [line] = FALSE;
    mltrace [line] = 4; /* BO queue & unqueue */
    modrestrace [line] = 2;
    trace[line] = /* DCTNACKTRACE | */
                  CONFIGURATIONTRACE |
                  RUNTIMEERRORTRACE |
                  CALLREJECTTRACE |
                  RSADEBUGENABLE |
                  0;
    trace [line] = trace [line] | ALLTRAFFICTRACE;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
}


void mr350traces (unsigned short line)
{
    logMsg ("Line %d Debugging Trace Values:\n", line);
    logMsg ("   modtrace = %d, mltrace = %d, modrestrace = %d\n",
             modtrace [line], mltrace [line], modrestrace [line]);
    logMsg ("   trace = 0x%x, traceadr = %d, tracetype = %d\n",
             trace [line], traceadr[line], tracetype [line]);
}



unsigned short mr350site (unsigned short line, unsigned char site)
{
    ACCESS          *paccess;

    paccess = access [line];
    /* if allocated, do it. */
    if (paccess != NULL)
    {
        if (mltrace [line] > 0)
        {
            logMsg ("Access Task writing to Site State: %d\n", site); 
        }
        paccess-> siteins [0].last_read = site;
        paccess-> siteins [0].data_valid = TRUE;

        return;
    }
    /* if not allocate, get out. */
    if (mltrace [line] > 0)
    {
        logMsg ("Access Task tried to write to uninitialized driver\n"); 
    }
}


void accesstest2 (unsigned short line)
{
    mr350site (line, TESTSTATE14);
    return;
}


void accesstest3 (unsigned short line)
{
    mr350site (line, TESTSTATE15);
    return;
}

void sendcomm (unsigned short line, unsigned short dct, unsigned short ticks)
{
    MR350    *pdct;

    pdct = dcts [line] [dct];
    if (pdct)			/* verify pointer validity prior to use */
    {
        mr350timeout [line] = ticks;
        pdct->mr350sendto = TRUE;
    }
    return;
}



















#define COMMTABLELEN 10
/*
** sendcommtable
**
*/

static	unsigned short sendcommtable (unsigned short line, unsigned short dct, MR350 *pdct)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;
    unsigned short   msb, lsb;

    msb = mr350timeout[line]/16;                  /* timeout: commtimeout MSB          */
    lsb = mr350timeout[line]%16;                  /* timeout: commtimeout LSB          */
    if (msb > 9) msb += 7;
    if (lsb > 9) msb += 7;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0]  = ESC;           /* MR350 Escape Command              */
    txp->txbuf [1]  = 'C';           /* write communication control table */
    txp->txbuf [2]  = '7';           /* Baud Rate: 7=9600                 */
    txp->txbuf [3]  = '1';           /* stop bit: 1 = 1                   */
    txp->txbuf [4]  = '8';           /* data bit: 8 = 8                   */
    txp->txbuf [5]  = 'N';           /* parity:   N = none                */
    txp->txbuf [6]  = 'M';           /* protocol: M = multipoint          */
    txp->txbuf [7]  = 'A' + dct;     /* address: assigned value           */
    txp->txbuf [8]  = '0' + msb;     /* timeout: commtimeout MSB          */
    txp->txbuf [9]  = '0' + lsb;     /* timeout: commtimeout LSB          */

/*    makechksum (&(txp->txbuf [0]), COMMTABLELEN, txp->address, &(txp->txbuf [COMMTABLELEN])); */
    txp->txmsglen = COMMTABLELEN /* + CHKSUMLEN */ ;

/*     txp->txmsglen = 0;*/

    /* Increment message counter */
    pdct->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->is_responding = FALSE;
        return (FALSE);
    }

    return (TRUE);
}




























unsigned short mr350userid (unsigned short line, unsigned char *userid)
{
    ACCESS          *paccess;

    paccess = access [line];
    /* if allocated, do it. */
    if (paccess != NULL)
    {
        if (mltrace [line] > 0)
        {
            logMsg ("Access Task writing to User ID string: %s\n", userid); 
        }
        strncpy (&paccess-> userids [0].last_read [0], userid, STRINGMSGLEN);
        paccess-> userids [0].data_valid = TRUE;

        return;
    }
    /* if not allocate, get out. */
    if (mltrace [line] > 0)
    {
        logMsg ("Access Task tried to write to uninitialized driver\n"); 
    }
}


void accesstest0 (unsigned short line)
{
    unsigned char *userid;
    unsigned char  userstring[81];

    userid = &userstring[0];
    strcpy (&userstring, "Keypad Login: 12345");
    mr350userid (line, userid);
    return;
}


void accesstest1 (unsigned short line)
{
    unsigned char *userid;
    unsigned char  userstring[81];

    userid = &userstring[0];
    strcpy (&userstring, "MagCard Login: 6789");
    mr350userid (line, userid);
    return;
}



rsasetdefaulttimouts(unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];

    if (paccess != NULL)
    {
        paccess->delays [RSA_ALERT].last_write    = ALERTTIMEOUT;
        paccess->delays [RSA_SECURING].last_write = SECURINGTIMEOUT;
        paccess->delays [RSA_WARNING].last_write  = WARNINGTIMEOUT;
        paccess->delays [RSA_MESSAGE].last_write  = MESSAGETIMEOUT;
        paccess->delays [RSA_ALARM].last_write    = ALARMTIMEOUT;
    }
}

rsasettimeouts (unsigned short line,  unsigned short time1, unsigned short time2,
                unsigned short time3, unsigned short time4, unsigned short time5)
{
    ACCESS         *paccess;

    paccess = access [line];

    if (paccess != NULL)
    {
        paccess->delays [RSA_ALERT].last_write    = time1;
        paccess->delays [RSA_SECURING].last_write = time2;
        paccess->delays [RSA_WARNING].last_write  = time3;
        paccess->delays [RSA_MESSAGE].last_write  = time4;
        paccess->delays [RSA_ALARM].last_write    = time5;
    }
}

rsasetdefaultretry(unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];

    if (paccess != NULL)
    {
        paccess->delays [RSA_RETRY].last_write    = RETRYCOUNT;
    }
}


rsasetretry (unsigned short line,  unsigned short count)
{
    ACCESS         *paccess;

    paccess = access [line];

    if (paccess != NULL)
    {
        paccess->delays [RSA_RETRY].last_write    = count;
    }
}


void debuggersnag(unsigned short line)
{
    snag [line] = TRUE;
    while (snag [line])
    {
        logMsg ( "Debug Snag Active. Execute unsnag(line) to release.\n");
        taskDelay (600);
    }
    logMsg ( "Debug Snag Released.\n");
}

void unsnag(unsigned short line)
{
    snag [line] = FALSE;
}

void setack(unsigned short line, unsigned short count)
{
    ackcount [line] = count;
}

int STOPDRIVER (short ln)
{
    if (comm_disconnect (ln) != -1)
    {
        taskDelete (taskId [ln]);
        return (1);
    }
    else
    {
        return (-1);
    }
}

int STARTDRIVER  (unsigned short line,      /* the line number of this driver.                      */
                  unsigned short port,      /* the port used by the redundant memory sharing logic. */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
    if (line < MR350LINES)
    {
        taskId [line] = taskSpawn (tasknames [line],
                                   DCT_PRIORITY,
                                   DCT_TASK_OPTIONS,
                                   DCT_STACK,
                                   MAIN,
                                   line,
                                   port,
                                   mode,
                                   delay,
                                   hdflag,
                                   delay1,
                                   delay2,
                                   private);

        logMsg ("Started the MR-350 driver on line %d\n",line);

        remCurIdGet (user,password);
        return (1);
    }
    else
    {
        logMsg ("Invalid line number %d\n", line);
        return (-1);
    }
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
     intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
     halfduplex [line]    = hdflag;
     pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
     posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}



void mr350ffpostackon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | POSTTXACKFLAG;
}

void mr350ffpostackoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~POSTTXACKFLAG;
}

void mr350ffpostnakon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | POSTTXNAKFLAG;
}

void mr350ffpostnakoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~POSTTXNAKFLAG;
}

void mr350ffpostaddon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | POSTTXADDFLAG;
}

void mr350ffpostaddoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~POSTTXADDFLAG;
}



void mr350ffpostallon (unsigned short line)
{
    mr350ffpostackon (line);
    mr350ffpostnakon (line);
    mr350ffpostaddon (line);
}

void mr350ffpostalloff (unsigned short line)
{
    mr350ffpostackoff (line);
    mr350ffpostnakoff (line);
    mr350ffpostaddoff (line);
}





void mr350ffpreackon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | PRETXACKFLAG;
}

void mr350ffpreackoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~PRETXACKFLAG;
}

void mr350ffprenakon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | PRETXNAKFLAG;
}

void mr350ffprenakoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~PRETXNAKFLAG;
}

void mr350ffpreaddon (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff | PRETXSTXFLAG;
}

void mr350ffpreaddoff (unsigned short line)
{
    TXLINE     *txp;
    txp = txlinetab [line];
    txp->txff = txp->txff & ~PRETXSTXFLAG;
}



void mr350ffpreallon (unsigned short line)
{
    mr350ffpreackon (line);
    mr350ffprenakon (line);
    mr350ffpreaddon (line);
}

void mr350ffprealloff (unsigned short line)
{
    mr350ffpreackoff (line);
    mr350ffprenakoff (line);
    mr350ffpreaddoff (line);
}










int ASSIGNGROUP (unsigned short line, unsigned short group)
{
    if (line < MR350LINES)
    {
        if (group <= MAXGROUPNUM)
        {
            mr350ResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, MR350LINES);
        return (-1);
    }
}

void mr350grouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  Limitorque Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = MR350LINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    mr350ResGroups [index]/10,
                    mr350ResGroups [index]%10);
        }
        printf ("\n");
    }
}

void mr350locktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void mr350lockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", *resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void mr350setlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void mr350clrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void mr350grouphelp (void)
{
    printf (" Mr350 Driver Group Related Functions\n");
    printf ("\n");
    printf (" mr350ResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" mr350grouptable         Display the Limitorque's line to group assignment table.    \n");
    printf (" mr350locktable          Display the resource group lock Global Array.               \n");
    printf (" mr350lockall            Display the resource group lock and trip name Global Array. \n");
    printf (" mr350setlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" mr350clrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" mr350grouphelp          Display this help message.                                  \n");
    printf ("\n");
}


/********
**
** Show Driver Info and Current State Information */ 
**
********/
void SHOWINFO (unsigned short line)
{
    TXLINE     *txp;

    txp = txlinetab [line];

    printf ("intermsgdelay [%d]  = %d\n", line, intermsgdelay[line]);
    printf ("pretxdelay [%d]     = %d\n", line, pretxdelay[line]);
    printf ("posttxdelay [%d]    = %d\n", line, posttxdelay[line]);
    printf ("pryvate [%d]        = %d\n", line, pryvate[line]);
    printf ("resresponse [%d]    = %d\n", line, resresponse[line]);
    printf ("activity_time [%d]  = %d\n", line, activity_time[line]);
    printf ("line_activity [%d]  = %d\n", line, line_activity[line]);
    printf ("lastactivity [%d]   = %d\n", line, lastactivity[line]);
    printf ("modtrace [%d]       = %d\n", line, modtrace[line]);
    printf ("mltrace [%d]        = %d\n", line, mltrace[line]);
    printf ("modrestrace [%d]    = %d\n", line, modrestrace[line]);
    printf ("ackcount [%d]       = %d\n", line, ackcount[line]);
    printf ("txp->txff [%d]      = %d\n", line, txp->txff);
    printf ("txp->txffcount [%d] = %d\n", line, txp->txffcount);
}


/*                                                                      
**      mr350_driver                                                    
**                                                                      
**      The purpose of this task is to scan the MR350 DCT lines.        
**      It will maintain a table of most recently scanned values.       
**                                                                      
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned short port,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
    unsigned short  dct, cfgchk, cnt, dctspolled, onlinefreq;
    unsigned short  activity, pstate, lstate, execute, command, i;
    unsigned short  masterpass1;
    long	    this_time, last_time;
    MR350          *pdct;
    RXLINE         *rxp;
    TXLINE         *txp;
    unsigned int    temptick, tempdiff;
    int             temp;
    short          *ptable_id;
    unsigned short  timeout1, timeout2, timeout3;
    unsigned short  group;

/* Initialize the data structures */

    mr350timeout [line] = 2;

    intermsgdelay [line] = delay;

    halfduplex [line]  = hdflag;
    pretxdelay [line]  = delay1;
    posttxdelay [line] = delay2;
    pryvate[line]      = private;

    resresponse [line] = FALSE;
    resnames [line] [0] = 0;
    prestable [line] = NULL;

    activity_time [line] = tickGet ();
    lastactivity [line] = line_activity [line] = FALSE;

    pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

    /* debug structures */
    DEFAULTTRACE (line);
/*    DEBUGTRACE (line);          ** disable this line in released version. */
/*    mr350debug (line);          ** disable this line in released version. */
/*    mr350trlv(4,7);             ** trace queued outputs */
/*    trace[line] = trace [line] | RSADEBUGENABLE;
*/


    tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].RXbadcount = 0;
    linestats [line].msgxfercount = 0;
    linestats [line].startingtick = tickGet ();

    dctsim [line] = FALSE;              /* start with normal operation. */


    /* access status and user ID initialization */
    access [line] = (ACCESS *) calloc (1, (sizeof (ACCESS)));
    if (!access [line])
    {
        logMsg ("Not enough memory for data structure (access)\n");
        return;
    }
    accessinit (line);

    /* set sub-task default timeouts */
    rsasetdefaulttimouts(line);
    rsasetdefaultretry(line);

    /* output queue initialization */
    oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
    if (!oq [line])
    {
        logMsg ("Not enough memory for data structure (data output queue)\n");
        return;
    }
    outqueinit (line);

    /* task queue initialization */
    tq [line] = (TASKQUE *) calloc (1, (sizeof (TASKQUE)));
    if (!tq [line])
    {
        logMsg ("Not enough memory for data structure (task output queue)\n");
        return;
    }
    taskqueinit (line);

    /* communication initialization */

    rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
    if (!rxlinetab [line])
    {
        logMsg ("Not enough memory for data structure (comm: rx)\n");
        return;
    }
    txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
    if (!txlinetab [line])
    {
        logMsg ("Not enough memory for data structure (comm: tx)\n");
        return;
    }

    taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */

    temp = comm_init (line, mode, &tx_int_proc, &rx_int_proc);
    logMsg ("\n\ncomm_init returned a value of %d.\n\n", temp);
    if (temp == 0)
    {
        logMsg ("********************************************\n");
        logMsg ("*                                          *\n");
        logMsg ("*  COMMUNICATION INITALIZATION SUCCEEDED   *\n");
        logMsg ("*                                          *\n");
        logMsg ("********************************************\n");
    }
    else
    {
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
        logMsg ("*                                          *\n");
        logMsg ("*    COMMUNICATION INITALIZATION FAILED    *\n");
        logMsg ("*                                          *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                  FAILED                  *\n");
        logMsg ("*                                          *\n");
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
        logMsg ("********************************************\n");
    }


    clear_rts (line);
    taskUnlock ();

    onlinefreq = 1;	  /* causes on_line calls to begin on first pass as master */

    /* Initialize the Rx interrupts to receive once for activity check         */
    /* enable the receiver interrupt after set to ignore                       */

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    enable_rx_ints (line);

    /* set TXFF mode */
    mr350ffprealloff (line);
    mr350ffpostalloff (line);

    /* Initialize line communication semaphores */
    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);

    /* Wait for prime resource to be defined via first call to */
    /*  its 'register_resource' via DRIVER/READ call.          */

    while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
    {
        if (modrestrace [line] > 1)
        {
            logMsg ( "No Resource Defined for this line\n");
            mr350traces(line);
        }
        taskDelay (600);
    }


/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
    if (pryvate[line])
    {
        port = 0;
    }
    taskId [line] = taskSpawn (subtasknames [line],
                               RSA_PRIORITY,
                               RSA_TASK_OPTIONS,
                               RSA_STACK,
                               RSATASK,
                               line,
                               timeout1,
                               timeout2,
                               timeout3,
                               port);

    logMsg ("Started the RSA Sub-Task for this line.\n");
/*********************************************************************/
/*********************************************************************/
/*********************************************************************/


    /*****************/
/*    debuggersnag(line);
    ******************/

    if (pryvate[line])
    {
        /*****************************/
        /* Immediately become master */
        /*****************************/

        resSetCaAnswer (prestable [line]);
        resPutLocalState (prestable [line], RES_MSTR);

        lastscan [line] = tickGet ();
        scantime [line] = 0;

        lstate = RES_MSTR;
        if (modrestrace [line])
        {
            logMsg ("0] Private: Initialize as RES_MSTR\n");
        }
    }
    else /* this is the 'normal' path */
    {
        /**********************/
        /* Start out as slave */

        resClearCaAnswer (prestable [line]);		/* start quiet */
        resPutLocalState (prestable [line], RES_SLV);

        if (modrestrace [line])
        {
            logMsg ("1] Initialized as RES_SLV\n");
        }

        /* wait finite time for pstate to be resolved */
        logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
        for (i = 0; i <= pstatewait [line]; i++)
        {
            resGetStates (prestable [line], &lstate, &pstate);
            if (pstate != 0)
            {
                break;
            }
            taskDelay (60);
        }
        if (pstate == 0)
        {
            logMsg ("Timeout of pstate wait.\n");
        }
        else
        {
            logMsg ("Completion of pstate wait.\n");
        }

        for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
        {
            taskDelay(10);
        }

        activity = check_line_activity(line, 0);
        resGetStates (prestable [line], &lstate, &pstate);

        /******************************************/
        /* if the partner is not there, be master */

        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
        {
            resSetCaAnswer (prestable [line]);
            resPutLocalState (prestable [line], RES_MSTR);
            lastscan [line] = tickGet ();
            scantime [line] = 0;
            lstate = RES_MSTR;
            if (modrestrace [line])
            {
                logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
            }
            onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
            masterpass1 = TRUE;
        }
    }

    cfgchk = 0;     /* Init the new config pointer */
    last_time = tickGet (); /* Initialize the time  */

    while (TRUE)
    {
        activity_time [line] = tickGet ();
        lastactivity [line] = line_activity [line] = FALSE;

            /************************************/
            /* check for line group disablement */
            /************************************/
            group = mr350ResGroups [line];
            if ((group) && (resGroupLock [group-1]))
            {
                if (modrestrace [line])
                {
                    logMsg ("13] Forced to RES_SLV.\n");
                }
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
                if (modrestrace [line])
                {
                    logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity);
                }
                while (resGroupLock [group-1])
                {
                    group = mr350ResGroups [line];
                    if (group)
                    {
                        clear_rts (line); 		/* Make sure line is left for master    */
                        taskDelay (2);
                    }
                    else /* the line has been taken out of the group */
                    {
                        break;
                    }
                }
                if (modrestrace [line])
                {
                    logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity);
                    logMsg ("16] Released to RES_SLV.\n");
                }
            }



        /********************************************************************************************/
        /* we arrive here because we are a slave.                                                   */
        /* we stay until:   asked to be master by partner. if we can reach DCTs, we become master.  */
        /*                  the partner is not master and there is no activity on the line.         */
        /********************************************************************************************/

        while (lstate == RES_SLV)
        {
            /* check for dct simulated mode. */
            if (dctsim [line])
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                }
                masterpass1 = TRUE;
                break;
            }

            if (pstate != RES_SLVWANT)
            {
                clear_rts (line); 				/* make sure line is left for master 	*/
            }
            resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
            resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
            activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
            resGetStates (prestable [line], &lstate, &pstate);

            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 17)) break;

            /****************************************************************************************/
            /* see if needed by partner to be master. if yes, do it and break out of slave state.   */
            if (pstate == RES_SLVWANTCA)
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("3] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                }
                onlinefreq = 1;            /* causes on_line calls to begin on first pass as master */
                masterpass1 = TRUE;
                break;
            }
            /***************************************************************/
            /* If partner is there and wants to give it up, try to take it */

            if (pstate == RES_SLVWANT)
            {
                execute = FALSE;
                taskDelay (2); /* Time for switch to occur */

                /* See if anyone is out there and able to respond to a loopback command */
                for (dct = 0; (dct < NUMDCTS); dct++)
                {
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 18)) break;

                    pdct = dcts [line] [dct];
                    if ((pdct) &&                    /* verify pointer validity prior to use */
                        (pdct->was_requested) &&     /* data points have been requested      */
                        (!pdct->cmd_force_offline))  /* user has NOT forced dct offline      */
                    {
                        on_line (line, dct);
                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((pdct->is_responding) && (!pdct->cmd_force_offline))
                        {
                            execute = TRUE;
                            break;
                        }
                    }
                }
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 19)) break;

                /* If someone answered, become master and make sure partner really gave it up */
                if (execute)
                {
                    resPutLocalState (prestable [line], RES_MSTR);
                    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

                    if (modrestrace [line])
                    {
                        logMsg ("4] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                    }
                    execute = FALSE;
                    activity_time [line] = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < 60); i++)
                    {
                        activity = check_line_activity (line, 2); /* pause before testing */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
                        {
                            execute = TRUE; /* Partner Gave It Up so take CA */
                            break;
                        }
                    }
                    if (!execute)
                    {   /* Partner did not give it up go back to slave */
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        if (modrestrace [line])
                        {
                            logMsg ("5] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                        }
                    }
                    else
                    { /* Assume control by taking the CA responsibilities */ 
                        resSetCaAnswer (prestable [line]);
                        prepresponses (line);
                        masterpass1 = TRUE;
                        break;
                    }
                }
            }

            /********************************************/
            /* if the partner is not talking, be master */

            if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("6] Became RES_MSTR P= %x A= %d \n", pstate, activity);
                }
                prepresponses (line);
                onlinefreq = 1;        /* causes on_line calls to begin on first pass as master */
                masterpass1 = TRUE;
            }
        }

        /****************************************************************************************/
        /* to arrive here, we used to be master, and had been told to relinquish master status. */
        /* stay in this loop until the partner takes over, or the command is canceled           */
        while (lstate == RES_SLVWANTCA)
        {
            taskDelay (2);                   /* Give OS a chance...  */

            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 20)) break;

            clear_rts (line); 		/* Make sure line is left for master    */
            resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
            {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                if (modrestrace [line])
                {
                    logMsg ("7] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                }
                break;
            }
            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0); /* clear out commands */
            if (command == RES_CANCELREL)
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("8] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                }
                prepresponses (line);
                onlinefreq = 1;        /* causes on_line calls to begin on first pass as master */
                masterpass1 = TRUE;
            }
        }

        /****************************************************************************************/
        /* in normal operation this code should never execute. it has, however, been seen to    */
        /* execute when the database has been inadvertently configured with the same resource   */
        /* assigned to two different drivers in the same IOC. The state does funny things.      */
        /****************************************************************************************/
        while (lstate == RES_SLVWANT)
        {
            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 21)) break;

            if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))
            {
                /* condition should NEVER occur. print error message every 5 seconds. */
                logMsg ("Illegal Local Resource State.\n");
                if (trace[line] & CONFIGURATIONTRACE)
                {
                    logMsg ("  Possible Resource Configuration Error:\n");
                    logMsg ("   Check for multiple drivers sharing single Resource.\n");
                }
                taskDelay (600);
            }
            taskDelay (2);
        }
        /****************************************************************************************/
        /* we come here because we have gone to, or are looping in, the master state.           */
        /* we stay in this loop until:    we have been told to give master state to the partner.*/
        /*                                we break out to RES_SLVWANTCA.                        */
        /*                                we have successfully handed master state to partner.  */
        /* While master, this task will process all DCTs sending outputs and getting inputs.    */
        /* It will then try to configure requested non-responding DCTs.                         */
        /****************************************************************************************/

        last_time = tickGet ();		/* initialize gap */
        while (lstate == RES_MSTR)
        {
            if (mltrace [line] == 1)
            {
                logMsg ( "Top of Master Loop... \n");
            }
            /* check for DCT simulated mode. */
            while (dctsim [line])
            {
                resresponse [line] = TRUE; /* Make sure driver is responding. driver won't         */
                for (dct = 0; (dct < NUMDCTS); dct++)
                {
                    pdct = dcts [line] [dct];	/* shorthand pointer 			*/
                    if (pdct)			/* verify pointer validity prior to use */
                    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 22)) break;

                        if (pdct->cmd_force_offline)
                        { 
                            /* if user has turned this DCT offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
                            pdct->is_responding = FALSE;
                        }
                        else
                        {
                            sim_dct (pdct, line, dct);      /* I/O done here! 		*/
                            taskDelay (simdelay [line]);
                        }
                    }
                }
                /************************************/
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;
            }
            /************************************/
            /* test for line group disablement. */
            if (lstate == RES_LOCKED) break;

            /* initial stuff */
            resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                       /* issue commands if not set.                             */

            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0);        /* clear out commands */

            /************************************************************************/
            /* if relinquish command sent, change state and break out to outer loop */
            if (command == RES_RELINQUISH)
            {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLVWANTCA);
                lstate = RES_SLVWANTCA;
                if (modrestrace [line])
                {
                   logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n", pstate, activity);
                }
                break;
            }

            /* measure time between scans of the entire set of dcts. display if requested. */
            temptick = tickGet ();
            tempdiff = temptick - lastscan [line];

            if (modtrace [line])
            {
                logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                         scantime[line], loopoutmsgs[line], loopmsgs[line]);
            }

            loopoutmsgs [line] = 0;
            loopmsgs [line] = 0;
            lastscan [line] = temptick;

            /* scan dcts for data i/o, if allowed */
            dctspolled = 0;

            /* call 'scan_dct' for each DCT device, unless user has */
            /* taken it off line or it is not responding.           */

            for (dct = 0; (dct < NUMDCTS); dct++)
            {
                pdct = dcts [line] [dct];		/* shorthand pointer 			*/
                if (pdct)				/* verify pointer validity prior to use */
                {
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 23)) break;

                    if (pdct->cmd_force_offline)
                    { 
                        /* if user has turned this DCT offline via pseudo commands,     */
                        /* mark it as not responding.                                   */
                        pdct->is_responding = FALSE;
                    }
                    else if (pdct->is_responding)
                    {
                        /* local/partner lockstep recovery */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate == RES_MSTR) && (!pryvate[line]))
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            clear_rts (line); 		/* Make sure line is left for master */
                            if (modrestrace [line])
                            {
                                logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                            }
                            temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                            for ( i = 0; i < temp; i++)
                            {
                               taskDelay(60);
                            }
                            break;
                        }
                        dctspolled++;

                        scan_dct (pdct, line, dct);      	/* I/O done here! 		*/
                        if (!pdct->is_responding)
                        {
                            mark_not_valid (pdct);
                        }
                    }
                }
                /* end of single module action */

                /* if told to relinquish our master state, stop DCT scanning immediately. */
                /* don't trash the command, so that we can still read it on the next loop */
                /* through this while statement.                                          */
                resGetCommand (prestable [line], &command);
                if (command == RES_RELINQUISH)
                {
                    break;
                }
            } /* end of scan loop */

            /**********************************************************/
            /* test for lockstep detection or line group disablement. */
            if ((lstate == RES_SLV) || (lstate == RES_LOCKED)) break;

            /* measure how long the scan took. to be displayed at beginning of next loop. */
            temptick = tickGet ();
            scantime [line] = temptick - lastscan [line];

            /* try and bring all nonresponding dcts on line, but don't bring in more than */
            /* a specified number. (unless this is the first pass since becoming master)  */

            cnt = 0;
            if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
            { 
                onlinefreq = BRINGBACKCNT;
                for (dct = 0; dct < NUMDCTS ; dct++)
                {
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 24)) break;

                    cfgchk++;		/* manage DCT index */
                    if (cfgchk == NUMDCTS)
                    {
                        cfgchk = 0;	/* wrap DCT index */
                    }
                    pdct = dcts [line] [cfgchk];
                    if ((pdct) &&		/* verify pointer validity prior to use*/
                        (!pdct->is_responding) &&
                        (pdct->was_requested) &&
                        (!pdct->cmd_force_offline))
                    {
                        on_line (line, cfgchk);	/* loopback testing done here! 	*/
                        dctspolled++;
                        cnt++;
                        /* if just became master, try all dcts. else, only try a fixed number. */
                        if ((cnt == MAXCFGCK) && (!masterpass1))
                        {
                            break;
                        }
                    }
                }
            }

            /************************************/
            /* test for line group disablement. */
            if (lstate == RES_LOCKED) break;

            /* see if anyone on the line has been responding. */
            /* if not, try to get partner to become slave.    */
            /* Check for no one responding */

            if ((!any_responding (line)) && (!pryvate[line]))
            {
                /* See if it is time to let partner try */

                this_time = tickGet ();
                if ((this_time - last_time) > (3 * SLWWINDOW))
                {   /* #ticks for slave to try */

                    /* Switch States to let partner know it's its time to try */
                    resPutLocalState (prestable [line], RES_SLVWANT);

                    lstate = RES_SLVWANT;
                    if (modrestrace [line])
                    {
                        logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
                    }
                    /* Give partner access to the hardware */
                    clear_rts (line);

                    /* Remember the time of this try */
                    last_time = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < SLWWINDOW); i += 10)
                    {       		/* SLWINDOW is the # of ticks for slave to try */
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 25)) break;

                        taskDelay (10);
                                       /* If partner picked up let it have control */
                        activity = check_line_activity (line, 0);  /* check immediately */
                        resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) ||
                                (pstate == RES_SLVWANT) ||
                                ((activity) &&
                                 (pstate != RES_SLV) &&
                                 (pstate != RES_SLVWANTCA)))
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            if (modrestrace [line])
                            {
                                logMsg ("11] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                            }
                            taskDelay(60);
                            taskDelay(60);
                            taskDelay(60);
                            break;
                        }
                    }
                    /************************************/
                    /* test for line group disablement. */
                    if (lstate == RES_LOCKED) break;

                    /* Go Back to being the Master and take control of the hardware */
                    if (lstate != RES_SLV)
                    {
                        resSetCaAnswer (prestable [line]);
                        resPutLocalState (prestable [line], RES_MSTR);
                        lstate = RES_MSTR;
                        if (modrestrace [line])
                        {
                            logMsg ("12] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
                        }
                        onlinefreq = 1;     /* causes on_line calls to begin on first pass as master */
                        masterpass1 = TRUE;
                        break;
                    }
                }
            }

            /* take dcts off hold status. the DCT's data are not to be held off since now master. */
            for (dct = 0; (dct < NUMDCTS); dct++ )
            {
                pdct = dcts [line] [dct];
                if (pdct)			/* verify pointer validity prior to use */
                {        
                    pdct->holdflag = FALSE;
                }
            }
            masterpass1 = FALSE;
            if (dctspolled == 0)
            {
                taskDelay(6);
            }
            else
            {
                taskDelay(2);
            }
        }
    } /* end infinite task loop */
}

/************************************/
/* check for line group disablement */
/************************************/
int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = mr350ResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum);
        }
        return (TRUE);
    }
    return (FALSE);
}

/*
** Try to bring a DCT on line
**
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line, unsigned short dct)
{
    MR350		*pdct;
    unsigned	short i, j;

    pdct = dcts [line] [dct];
    if (pdct)			/* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring Online DCT %d\n", dct );
        }
        /* Use the loopback function to see if the unit is there and responding */

        if (!dctloopback (ONERETRY + line, dct, pdct))
            return; /* if no response, get out */

        mark_not_valid (pdct);	/* a DCT that has just been brought online must have    */
                                /* it's data marked as being not valid.                 */
        pdct->is_responding = TRUE;
        pdct->newflag = TRUE;
    }
}


/*							
** Mark all DCT data elements as not valid              
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/

static void mark_not_valid (MR350  *pdct)
{
    unsigned short    i, j;

/*
**      DIGITAL INPUTS ARE INITIALIZED AS NOT VALID             
*/
    for (i = 0; (i < NUMDINS); i++)
    {
        pdct->dins[i].data_valid = FALSE;
    }

/*
**      DIGITALS OUTPUTS ARE INITIALIZED AS NOT VALID		
*/
    for (i = 0; (i < NUMDOUTS); i++)
    {
        pdct->douts[i].data_valid = FALSE;
    }

/*
**      LEDS OUTPUT ARE INITIALIZED AS NOT VALID		
*/
    for (i = 0; (i < NUMLEDOUTS); i++)
    {
        pdct->ledouts[i].data_valid = FALSE;
    }

/*
**      LCDS OUTPUT ARE INITIALIZED AS NOT VALID		
*/
    for (i = 0; (i < NUMLCDOUTS); i++)
    {
        pdct->lcdouts[i].data_valid = FALSE;
    }

/*
**      STRINGS INPUT ARE INITIALIZED AS NOT VALID		
*/
    for (i = 0; (i < NUMSTRINGINS); i++)
    {
        pdct->stringins[i].data_valid = FALSE;
    }

/*
**      BUZZER OUTPUTS ARE INITIALIZED AS NOT VALID		
*/
    for (i = 0; (i < NUMBUZZEROUTS); i++)
    {
        pdct->buzzerouts[i].data_valid = FALSE;
    }
}


/*                                                           	
** Scan a MR-350 DCT -  get inputs and set outputs as required  
**                                                            	
*/
/* this routine only called from MAIN 		*/


static	void scan_dct (MR350 *pdct, unsigned short line, unsigned short dct)
{
    unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long   bitmask;
    unsigned short  temp, cmd;

    pdct->tscanpass++;

    if (mltrace [line] == 2)
    {
        logMsg ( "Scanning DCT - %d.\n", dct );
    }

    if (pdct->mr350sendto == TRUE)
    {
        pdct->mr350sendto = FALSE;
        sendcommtable (line, dct, pdct);
    }
    checkoutputs (line);
    checktaskqueue (line);

    /* if needed, request digital input values to be returned in a message format */
    if ((pdct->dins [0].was_requested == TRUE) &&
        (pdct->dins [0].data_valid != TRUE))
    {
        temp = requestdins (line, dct, pdct);
        if (temp == CMDFAIL)
        {
            return;
        }
    }

    checkoutputs (line);
    checktaskqueue (line);

    /* request messages */
    temp = requestmsgs (line, dct, pdct);
    if (temp == CMDFAIL)
    {
        return;
    }
}

/*                                                              
** Scan a MR-350 DCT -  get inputs and set outputs as required  
**                                                            	
*/
/* this routine only called from MAIN 		*/

static	void sim_dct (MR350 *pdct, unsigned short line, unsigned short dct)
{
    unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long   bitmask;
    unsigned short  temp, cmd;

    pdct->is_responding = pdct->was_requested;

    /* read the digital input values to be scanned */
    for (i = 0 ; i < NUMDINS ; i++)
    {
        pdct->dins [i].data_valid = pdct->dins [i].was_requested;
        if (simdigon [line])
        {
            pdct->dins [i].last_read = ~pdct->dins [i].last_read;
        }
    }

    /* read the string input values to be scanned */
    for (i = 0 ; i < NUMSTRINGINS ; i++)
    {
        pdct->stringins [i].data_valid = pdct->stringins [i].was_requested;
        if (simdigon [line])
        {
            strcpy (&(pdct->stringins [i].last_read[0]), &(pdct->stringins [i].last_read[1]));
        }
    }
}



/*
** checkoutputs
**      checks output que and returns if empty.
**      if there is something on the queue it attempts to process all
**      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
**
*/                                                                                              
/* this routine only called from scan_dct */

static	void checkoutputs (unsigned short line)
{
    OUTQENT         *optr;
    MR350           *pdct;

    unsigned short   link, adapter, card, signal, value, i;
    unsigned short   stringaddr, stringlen;
    unsigned char    valuestring[STRINGMSGLEN];
    unsigned short   write_status;
    unsigned char   *pstringval;


    if (mltrace [line] == 6)
    {
        logMsg ("Checking Output Queue ...\n"); 
    }

    while ((optr = ogetnextp (line)) != NULLP)
    {
        if ((optr->otype) == AOUTTYPE)
        {
            link    = optr->out.aonode.link;
            adapter = optr->out.aonode.adapter;
            pdct    = dcts [link] [adapter];
            if (pdct == NULL)
            {
                if (!allocate_dct (link, adapter))
                {
                    return; /* if not allocated, try. if can't allocate, get out. */
                }
                pdct = dcts [link] [adapter];
            }
            card    = optr->out.aonode.card;
            signal  = optr->out.aonode.aosignal;
            value   = optr->out.aonode.aovalue;
            if (mltrace [link] == 7)
            {
                printf("AOREQUEST IN QUEUE: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                        link, adapter, card, signal, value);
            } 

            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                loopoutmsgs [line]++;
                switch (card)
                {
                    case DOUTS:
                        /* save value */
                        pdct->douts[signal].last_write = value;
                        write_status = setdouts (link, adapter, pdct, signal, value);
                        break;
                    default:
                        write_status = CMDFAIL;
                        break;
                }
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        printf("AOREQUEST DEQUEUE: Output failed: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                link, adapter, card, signal, value);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        printf ("AOREQUEST DEQUEUE: Output succeeded: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                 link, adapter, card, signal, value);
                    } 
                }
            }
        }
        else if ((optr->otype) == BOUTTYPE)
        {
            link    = optr->out.bonode.link;
            adapter = optr->out.bonode.adapter;
            pdct    = dcts [link] [adapter];
            if (pdct == NULL)
            {
                if (!allocate_dct (link, adapter))
                {
                    return; /* if not allocated, try. if can't allocate, get out. */
                }
                pdct = dcts [link] [adapter];
            }
            card    = optr->out.bonode.card;
            signal  = optr->out.bonode.bosignal;
            value   = optr->out.bonode.bovalue;
            if (mltrace [link] == 7)
            {
                printf("BOCOMMAND IN QUEUE: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                        link, adapter, card, signal, value);
            } 

            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                loopoutmsgs [line]++;
                switch (card)
                {
                    case DOUTS:
                        /* save value */
                        pdct->douts[signal].last_write = value;
                        write_status = setdouts (link, adapter, pdct, signal, value);
                        break;
                    case LEDOUTS:
                        /* save value */
                        pdct->ledouts[signal].last_write = value;
                        write_status = setledouts (link, adapter, pdct, signal, value);
                        break;
                    case BUZZEROUTS:
                        /* save value */
                        pdct->buzzerouts[signal].last_write = value;
                        write_status = setklaxonouts (link, adapter, pdct, signal, value);
                        break;
                    default:
                        write_status = CMDFAIL;
                        break;
                }
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 4)
                    {
                        printf("BOREQUEST DEQUEUE: Output failed: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                link, adapter, card, signal, value);
                    } 
                }
                else
                {
                    if (mltrace [link] == 4)
                    {
                        printf ("BOREQUEST DEQUEUE: Output succeeded: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                 link, adapter, card, signal, value);
                    } 
                }
            }
        }
        else if ((optr->otype) == SOUTTYPE)
        {
            link    = optr->out.sonode.link;
            adapter = optr->out.sonode.adapter;
            pdct = dcts [link] [adapter];
            if (pdct == NULL)
            {
                if (!allocate_dct (link, adapter))
                {
                    return; /* if not allocated, try. if can't allocate, get out. */
                }
                pdct = dcts [link] [adapter];
            }
            card    = optr->out.sonode.card;
            signal  = optr->out.sonode.sosignal;
            /* value   = optr->out.sonode.sovalue; */
            /* Move in the output string (strcpy not used because */
            /*  string content could contain terminators)         */
            for (i = 0 ;(i < STRINGMSGLEN) ; i++)
            {
                valuestring[i] = optr->out.sonode.sovalue[i];
            }
            pstringval = &valuestring[0];

            if (mltrace [link] == 7)
            {
                printf ("SOREQUEST IN QUEUE: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                        link, adapter, card, signal, value);
            } 

            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                loopoutmsgs [line]++;
                switch (card)
                {
                    case DOUTS:
                        write_status = setdouts (link, adapter, pdct, signal, value);
                        break;

                    case LCDOUTS:
                        write_status = setlcdouts (link, adapter, pdct, signal, pstringval);
                        break;

                    default:
                        write_status = CMDFAIL;
                        break;
                }
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 5)
                    {
                        printf ("SOREQUEST DEQUEUE: Output failed: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                link, adapter, card, signal, value);
                    } 
                }
                else
                {
                    if (mltrace [link] == 5)
                    {
                        printf ("SOREQUEST DEQUEUE: Output succeeded: L=%d, A=%d, C=%d, S=%d, Value=%d\n",
                                 link, adapter, card, signal, value);
                    } 
                }
            }
        }
        oreleasefull (line);     /* release the output que entry */
    }
}


/*
** checktaskqueue
**      checks Remote Site Access Task queue and returns if empty.
**      if there is something on the queue it attempts to process all
**      pending outputs, doing immediate retries. If attempts fail the request is dropped. 
**
*/                                                                                              
/* this routine only called from scan_dct */

static	void checktaskqueue (unsigned short line)
{
    TASKOUT         *tptr;
    MR350           *pdct;

    unsigned short   link, unit, card, signal, value, i;
    unsigned short   frequency, length, numsecs;
    unsigned short   stringaddr, stringlen;
    unsigned char    valuestring[STRINGMSGLEN];
    unsigned short   write_status;
    unsigned char   *pstringval;


    if (mltrace [line] == 6)
    {
        logMsg ("Checking Task Queue ...\n"); 
    }

    while ((tptr = tgetnextp (line)) != NULLP)
    {
        link = tptr->link;
        unit = tptr->unit;
        pdct = dcts [link] [unit];
        if (pdct == NULL)
        {
            if (!allocate_dct (link, unit))
            {
                return; /* if not allocated, try. if can't allocate, get out. */
            }
            pdct = dcts [link] [unit];
        }
        /****************************************************************************/
        /****************************************************************************/
        if ((tptr->command) == LCDCMD)
        {
            signal = tptr->parameter[0];
            pstringval = &tptr->parameter[1];
            if (mltrace [link] == 7)
            {
                printf("LCD OUTPUT IN QUEUE: L=%d, U=%d, LCD=%d, Msg=%s\n",
                        link, unit, signal, pstringval);
            } 
            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                taskoutmsgs [line]++;
                pdct->lcdouts[signal].data_valid = TRUE;
                strcpy( pdct->lcdouts[signal].last_write, pstringval);
                write_status = setlcdouts (link, unit, pdct, signal, pstringval);

                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        printf("LCD DEQUEUE: Output failed: L=%d, U=%d, LED=%d, Msg=%s\n",
                        link, unit, signal, pstringval);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        printf ("LCD DEQUEUE: Output succeeded: L=%d, U=%d, LED=%d, Msg=%s\n",
                        link, unit, signal, pstringval);
                    } 
                }
            }
        }
        /****************************************************************************/
        /****************************************************************************/
        if ((tptr->command) == LEDCMD)
        {
            signal = tptr->parameter[0];
            value  = tptr->parameter[1];
            if (mltrace [link] == 7)
            {
                printf("LED OUTPUT IN QUEUE: L=%d, U=%d, LED=%d, Value=%d\n",
                        link, unit, signal, value);
            } 
            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                taskoutmsgs [line]++;
                pdct->ledouts[signal].data_valid = TRUE;
                pdct->ledouts[signal].last_write = value;
                write_status = setledouts (link, unit, pdct, signal, value);
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        printf("LED DEQUEUE: Output failed: L=%d, U=%d, LED=%d, Value=%d\n",
                        link, unit, signal, value);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        printf ("LED DEQUEUE: Output succeeded: L=%d, U=%d, LED=%d, Value=%d\n",
                        link, unit, signal, value);
                    } 
                }
            }
        }
        /****************************************************************************/
        /****************************************************************************/
        if ((tptr->command) == LOGCMD)
        {
            signal = tptr->parameter[0];
            value  = tptr->parameter[1];
            if (mltrace [link] == 7)
            {
                printf("LOG OUTPUT IN QUEUE: L=%d, U=%d, LOG=%d, Value=%d\n",
                        link, unit, signal, value);
            } 
            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                taskoutmsgs [line]++;
                pdct->douts[signal].data_valid = TRUE;
                pdct->douts[signal].last_write = value;
                write_status = setdouts (link, unit, pdct, signal, value);
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        printf("LOG DEQUEUE: Output failed: L=%d, U=%d, LOG=%d, Value=%d\n",
                        link, unit, signal, value);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        printf ("LOG DEQUEUE: Output succeeded: L=%d, U=%d, LOG=%d, Value=%d\n",
                        link, unit, signal, value);
                    } 
                }
            }
        }
        /****************************************************************************/
        /****************************************************************************/
        if ((tptr->command) == KLAXONCMD)
        {
            frequency = tptr->parameter[0];
            length    = tptr->parameter[1];
            numsecs   = (tptr->parameter[2])*100 + (tptr->parameter[3])*10 + tptr->parameter[4];
            if (mltrace [link] == 7)
            {
                printf("KLAXON OUTPUT IN QUEUE: L=%d, U=%d, Freq=%d, Len=%d, Dur=%d\n",
                        link, unit, frequency, length, numsecs);
            } 
            if ((!pdct->cmd_force_offline) &&
                (resresponse [link]) &&
                (pdct->is_responding))
            {
                taskoutmsgs [line]++;
                pdct->buzzerouts[1].data_valid = TRUE;       /* frequency */
                pdct->buzzerouts[1].last_write = frequency;
                pdct->buzzerouts[2].data_valid = TRUE;       /* duration  */
                pdct->buzzerouts[2].last_write = length;   
                pdct->buzzerouts[3].data_valid = TRUE;       /* number of seconds to fire claxon */
                pdct->buzzerouts[3].last_write = numsecs;  
                write_status = setklaxonouts (link, unit, pdct, signal, value);
                if (write_status != CMDDONE)
                {
                    pdct->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        printf("KLAXON DEQUEUE: Output failed: L=%d, U=%d, Freq=%d, Len=%d, Dur=%d\n",
                        link, unit, frequency, length, numsecs);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        printf ("KLAXON DEQUEUE: Output succeeded: L=%d, U=%d, Freq=%d, Len=%d, Dur=%d\n",
                        link, unit, frequency, length, numsecs);
                    } 
                }
            }
        }
        treleasefull (line);     /* release the output que entry */
    }
}


/*                                                                                        
**      AIDRIVER                                                                          
**                                                                                        
**      This routines main purpose is to return the analog input value for the specified  
**      DCT. For an DCT value a (-1) will be returned if there is no valid data ready.    
**                                                                                        
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
{
    MR350         *pdct;
    ACCESS        *paccess;

    if (link >= MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter >= NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != DINS) && (card != DOUTS) && (card != DETAILS) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
	}
        pdct = dcts [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the DCT values requested */
                *pvalue = pdct->was_requested;
                break;

            case 1: /* Is the DCT responding */
                *pvalue = pdct->is_responding;
                break;


            case 5: /* Output Messages */
                *pvalue = pdct->no_dataout_msgs & 0x7fff;
                break;

            case 6: /* Input Messages */
                *pvalue = pdct->no_datain_msgs & 0x7fff;
                break;

            case 7: /* No Receiver Responses */
                *pvalue = pdct->no_rxnoresp & 0x7fff;
                break;

            case 8: /* No Transmitter Response */
                *pvalue = pdct->no_txnoresp & 0x7fff;
                break;

            case 9: /* Data Echo Errors */
                *pvalue = pdct->no_dataerr & 0x7fff;
                break;

            case 10: /* Message Retries */
                *pvalue = pdct->no_retries & 0x7fff;
                break;

            case 11: /* RX Hardware errors */
                *pvalue = pdct->no_rxhwerrs & 0x7fff;
                break;

            case 12: /* TX Hardware errors */
                *pvalue = pdct->no_txhwerrs & 0x7fff;
                break;

            case 13: /* Checksum errors */
                *pvalue = pdct->no_cserrs & 0x7fff;
                break;

            case 14: /* Offline transitions */
                *pvalue = pdct->no_offlines & 0x7fff;
                break;

            case 15: /* reset statistics */
                *pvalue = pdct->cmd_reset_stat;
                break;

            case 16: /* Force the DCT offline */
                *pvalue = pdct->cmd_force_offline;
                break;

            case 17: /* Failed output commands */
                *pvalue = pdct->badoutcnt & 0x7fff;
                break;

            case 18: /* MR-350 response messages */
                *pvalue = pdct->no_mr350_msgs & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                   printf("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                           pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    /* process digital input points */
    if (card == DINS)
    {
        if (signal >= NUMDINS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDINS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->dins [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->dins [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        pvalue[0] = pdct->dins [signal].last_read;
        pvalue[1] = 0;

        if (mltrace[link] == 8)
            printf("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }

    /* process digital output points */
    if (card == DOUTS)
    {
        if (signal >= NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->douts [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        pvalue[0] = pdct->douts [signal].last_write;
        pvalue[1] = 0;

        if (mltrace[link] == 8)
            printf("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }

    /* process details points */
    if (card == DETAILS)
    {
        if (signal >= NUMDETAILS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->douts [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AIDRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        switch (signal)
        {
            case 0:
                pvalue[0] = paccess->usersincount;
                break;

            case 1:
                pvalue[0] = paccess->timeremaining;
                break;
          
            default:
                pvalue[0] = 0;
                break;
        }

        pvalue[1] = 0;

        if (mltrace[link] == 8)
            printf("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }

    return(-1);
}

/*  										
**      AODRIVER                                                                
**                                                                            	
**      This routine's main purpose is to set requested analog outputs to the   
**      specified DCT.                                                          
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal,double dvalue, unsigned short value,
              unsigned short conversion, unsigned char *resname)
{
    MR350          *pdct;
    OUTQENT        *oqp;
    ACCESS         *paccess;
    unsigned short  testmax;


    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if ((card != DOUTS) && (card != BUZZEROUTS) && (card != DELAYS) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pdct = dcts [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats(pdct);
                }
                break;

            case 16: /* Force the DCT online/offline */
                pdct->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pdct->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }


    /***********************************************/
    /* process Delay Intervals and Retry Counts    */
    if (card == DELAYS)
    {
        switch(signal)
        {
            case RSA_ALERT:
                testmax = MAX_RSA_ALERT;
                break;

            case RSA_SECURING:
                testmax = MAX_RSA_SECURING;
                break;

            case RSA_WARNING:
                testmax = MAX_RSA_WARNING;
                break;

            case RSA_MESSAGE:
                testmax = MAX_RSA_MESSAGE;
                break;

            case RSA_ALARM:
                testmax = MAX_RSA_ALARM;
                break;

            case RSA_RETRY:
                testmax = MAX_RSA_RETRY;
                break;

            default:

                if (trace[link] & CONFIGURATIONTRACE)
                    printf("AODRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: Legal=1\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
                break;
        }

        if (value > testmax)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AODRIVER: Illegal value(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: max=\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        /*******************/
        /* write the value */
        /*******************/
        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AODRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        paccess->delays [signal].last_write = value;

        if (mltrace [link] == 3)
        {
            printf("AODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        return (0);

    }

/******************************************************/
    /* process buzzer duration and interval output */
    if (card == BUZZEROUTS)
    {
        switch(signal)
        {
            case 1:
                if (value > 8)
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        printf("AODRIVER: Illegal value(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: max=8\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }

                if (resname != 0)
                {
                    register_resource(link,pdct,resname,pointname);
                }

                pdct->was_requested = TRUE;
                pdct->buzzerouts [1].was_requested = TRUE;
                pdct->buzzerouts [1].last_write = value;  /* duration  */
                if (mltrace [link] == 3)
                {
                    printf("AODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                }
                return (0);
                break;

            case 2:
                if (value > 8)
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        printf("AODRIVER: Illegal value(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: max=8\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }

                if (resname != 0)
                {
                    register_resource(link,pdct,resname,pointname);
                }

                pdct->was_requested = TRUE;
                pdct->buzzerouts [2].was_requested = TRUE;
                pdct->buzzerouts [2].last_write = value;  /* duration  */
                if (mltrace [link] == 3)
                {
                    printf("AODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                           pointname, link, adapter, card, signal, value);
                }
                return (0);
                break;

            case 3:
                if (value > 999)
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        printf("AODRIVER: Illegal value(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: max=999\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }

                if (resname != 0)
                {
                    register_resource(link,pdct,resname,pointname);
                }

                pdct->was_requested = TRUE;
                pdct->buzzerouts [3].was_requested = TRUE;
                pdct->buzzerouts [3].last_write = value;  /* interval  */
                if (mltrace [link] == 3)
                {
                    printf("AODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                           pointname, link, adapter, card, signal, value);
                }
                return (0);
                break;


            default:

                if (trace[link] & CONFIGURATIONTRACE)
                    printf("AODRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: Legal=1\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
                break;
        }
    }

    /******************************************************/
    /* process digital output points */
    if (card == DOUTS)
    {
        if (signal >= NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AODRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d: max=%d\n",
                        pointname, link, adapter, card, signal, value, NUMDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AODRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AODRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-2);
        }

        /* check for DCT simulated mode. */
        if (dctsim [link])
        {
            if (mltrace [link] == 3)
            {
                printf("AODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            }
            return (0);
        }

	if ((!pdct->is_responding) || (pdct->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                printf("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

        oqp = ogetemptyp (link);
        if (oqp == NULLP)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
            {
                printf("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            }
            pdct->badoutcnt++;
            return (-1);		/* output queue is full */
        }
        oqp->otype = AOUTTYPE;
        oqp->out.aonode.link     = link;
        oqp->out.aonode.adapter  = adapter;
        oqp->out.aonode.card     = card;
        oqp->out.aonode.aosignal = signal;
        oqp->out.aonode.aovalue  = value;

        omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace [link] == 3)
        {
            printf("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        return (0);
    }
    return (-1);
}

/*                                                                             
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
            unsigned short signal, unsigned short *pvalue,
            unsigned short conversion, unsigned char *resname)

{
    MR350          *pdct;
    ACCESS         *paccess;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != DOUTS) && (card != BUZZEROUTS) && (card != DELAYS) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pdct = dcts [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* read statistics command value */
                *pvalue = pdct->cmd_reset_stat;
                break;

            case 16: /* Read the current DCT offline command status */
                *pvalue = pdct->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
        }
        return (0);
    }

    /***********************************************/
    /* process Delay Intervals and Retry Counts    */
    if (card == DELAYS)
    {
        switch(signal)
        {
            case RSA_ALERT:
            case RSA_SECURING:
            case RSA_WARNING:
            case RSA_MESSAGE:
            case RSA_ALARM:
            case RSA_RETRY:
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("AOREAD: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=2, max=7\n",
                            pointname, link, adapter, card, signal);
                return (-1);
                break;
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        /******************/
        /* read the value */
        /******************/
        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = paccess->delays [signal].last_write;
         return (0);

    }

    /* process digital output points */
    if (card == DOUTS)
    {
        if (signal >= NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AOREAD: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        pdct->douts [signal].data_valid = TRUE;
        pvalue[0] = 0;
        pvalue[1] = 0;

        if (mltrace[link] == 8)
            printf("AOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x00(forced)\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }


    /* process buzzer frequency output */
    if (card == BUZZEROUTS)
    {
        if ((signal < 1) || (signal > 3))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("AOREAD: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->buzzerouts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("AOREAD: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        pdct->buzzerouts [signal].data_valid = TRUE;
        pvalue[0] = 0;
        pvalue[1] = 0;

        if (mltrace[link] == 8)
            printf("AOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x00(forced)\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }
    return(-1);
}

/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested DCT is the wrong type or the data is not yet valid.                   
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, unsigned long mask, unsigned long *pvalue,
              unsigned char *resname)
{
    MR350          *pdct;
    ACCESS         *paccess;
    unsigned long   tvalue;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != DINS) &&
        (card != DOUTS) &&
        (card != LEDOUTS) &&
        (card != SITEINS) &&
        (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pdct = dcts [link] [adapter];
    }

    pdct->was_requested = TRUE;

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the DCT values requested */
                *pvalue = pdct->was_requested;
                break;

            case 1: /* Is the DCT responding */
                *pvalue = pdct->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = pdct->cmd_reset_stat;
                break;

            case 16: /* Force the DCT offline */
                *pvalue = pdct->cmd_force_offline;
                break;


            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }
    tvalue = 0;

    /* process site state */
    if (card == SITEINS)
    {
        if (signal != 0)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: legal=0\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->siteins[signal].was_requested = TRUE;

        if (!paccess->siteins [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = (unsigned long) paccess->siteins[0].last_read;

        if (mltrace[link] == 8)
            printf("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return (0);
    }



    /* process digital input points */
    if (card == DINS)
    {
        if (signal >= NUMDINS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDINS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->dins [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (!pdct->dins [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
         *pvalue = pdct->dins [signal].last_read;

        if (mltrace[link] == 8)
            printf("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }

    /* process digital output points */
    if (card == DOUTS)
    {
        if (signal >= NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->douts [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        *pvalue = pdct->douts [signal].last_write;

        if (mltrace[link] == 8)
            printf("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }



    /* process LED output points */
    if (card == LEDOUTS)
    {
        if (signal >= NUMLEDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d\n",
                        pointname, link, adapter, card, signal, NUMLEDOUTS);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->ledouts [signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->ledouts [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        *pvalue = pdct->ledouts [signal].last_write;

        if (mltrace[link] == 8)
            printf("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue[0]);
        return(0);
    }

    return(-1);
}
/*                                                                                     
**      BODRIVER                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested DCT is the wrong type or not configured yet.                          
**                                                                                 	
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, unsigned long value, unsigned long mask,
              unsigned char *resname)
{
    MR350 		*pdct;
    ACCESS              *paccess;
    OUTQENT		*oqp;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if ((card != DOUTS) &&
        (card != LEDOUTS) &&
        (card != PERIMETERS) &&
        (card != NEWFILES) &&
        (card != BUZZEROUTS))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
	}
        pdct = dcts [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal & 0x1f)
        {
	    case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (pdct);
                }
                break;

            case 16: /* Force the DCT offline */
                pdct->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pdct->is_responding = FALSE; /* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }

    if (card == DOUTS)
    {
        if (signal > NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;
    }

    if (card == LEDOUTS)
    {
        if (signal > NUMLEDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->ledouts [signal].was_requested = TRUE;
    }

    /* This point holds a copy of the Modicon input point that contains the perimeter status. */
    if (card == PERIMETERS)
    {
        if (signal > NUMPERIMETERS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BODRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        /* a MAGIC point written with a copy of the Modicon input point.  */
        /* note: if the Modicon point ever goes invalid, this driver will */
        /* never know it. the last value written will always be valid.    */
        paccess->perimeters [signal].was_requested = TRUE;
        paccess->perimeters [signal].data_valid = TRUE;
        paccess->perimeters [signal].new_flag = TRUE;
        paccess->perimeters [signal].last_write = (unsigned short) value;

        if (mltrace[link] == 4)
            printf("BODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (0);
    }

    /* This point is set by greg's code to tell us we need to load a new file. */
    if (card == NEWFILES)
    {
        if (signal > NUMNEWFILES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BODRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        /* a MAGIC point written by greg's code.                          */
        paccess->newfiles [signal].was_requested = TRUE;
        paccess->newfiles [signal].data_valid = TRUE;
        paccess->newfiles [signal].new_flag = TRUE;
        paccess->newfiles [signal].last_write = (unsigned short) value;

        if (mltrace[link] == 4)
            printf("BODRIVER: Direct Write:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (0);
    }

    if (card == BUZZEROUTS)
    {
        if (signal != 0)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;

        if (signal == 0)
        {
            pdct->buzzerouts [signal].was_requested = TRUE;
        }
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            printf("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (dctsim [link])
    {
        if (mltrace [link] == 4)
        {
            printf("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        return (0);
    }
    /* 1/22/98 : these are not mr350 connection related points */
    if ((card != PERIMETERS) &&
        (card != NEWFILES))
    {
        if ((!pdct->is_responding) || (pdct->cmd_force_offline))
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
    }

    oqp = ogetemptyp (link);
    if (oqp == NULLP)
    {
        if (trace[link] & RUNTIMEERRORTRACE)
            printf("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        pdct->badoutcnt++;
        return (-1);		/* output queue is full */
    }

    if (value) value = 1;

    oqp->otype = BOUTTYPE;
    oqp->out.bonode.link     = link;
    oqp->out.bonode.adapter  = adapter;
    oqp->out.bonode.card     = card;
    oqp->out.bonode.bosignal = signal;
    oqp->out.bonode.bomask   = mask;
    oqp->out.bonode.bovalue  = value;

    omarkfull (link);		/* Mark this entry as ready for output */

    if (mltrace[link] == 4)
        printf("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                pointname, link, adapter, card, signal, value);
    return (0);
}



/*
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the digital output hardware. This is used to initialize digital  	
**      outputs. This will return a (-1) if the DCT is the wrong type or        
**      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
            unsigned short signal, unsigned long *pvalue, unsigned long mask,
            unsigned char *resname)
{
    MR350          *pdct;
    ACCESS         *paccess;
    unsigned long   tvalue;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != DOUTS) &&
        (card != LEDOUTS) &&
        (card != PERIMETERS) &&
        (card != NEWFILES) &&
        (card != BUZZEROUTS))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts [link] [adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pdct = dcts [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 2: /* Set the program Load request */
                *pvalue = 0;
                break;

            case 15: /* reset statistics */
                *pvalue = pdct->cmd_reset_stat;
                break;

            case 16: /* Force the DCT offline */
                *pvalue = pdct->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    printf("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    if (card == DOUTS)
    {
        if (signal > NUMDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->douts [signal].was_requested = TRUE;
    }

    if (card == LEDOUTS)
    {
        if (signal > NUMLEDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->ledouts [signal].was_requested = TRUE;
    }

    if (card == PERIMETERS)
    {
        if (signal > NUMPERIMETERS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BOREAD: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->perimeters[signal].was_requested = TRUE;
    }

    if (card == NEWFILES)
    {
        if (signal > NUMNEWFILES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BOREAD: RSA Task NOT Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->newfiles[signal].was_requested = TRUE;
    }

    if (card == BUZZEROUTS)
    {
        if (signal != 0)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        {
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->buzzerouts [signal].was_requested = TRUE;
    }

    /* back to common code */

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            printf("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (pdct->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            printf("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }
    /* 1/22/98 : these are not mr350 connection related points */
    if ((card != PERIMETERS) &&
        (card != NEWFILES))
    {
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
    }

    /* we can't actually read back any of these outputs, so we treat them all as valid. */
    tvalue = 0;
    *pvalue = tvalue & mask;
    if (mltrace[link] == 9)
        printf("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                pointname, link, adapter, card, signal, *pvalue);

    return (0);
}




/*                                                                                       
**      SIDRIVER                                                                          
**                                                                              	  
**      This routines main purpose is to return the analog input value for the specified  
**       DCT. For an DCT value a (-1) will be returned if there is no valid data ready.   
**                                                                                     	  
*/
/* this routine not called from within this driver */

int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, short *pvalue, unsigned short len,
              unsigned char *resname)
{
    MR350          *pdct;
    ACCESS         *paccess;

    unsigned short  reglen;
    unsigned short  tempshort;
    int             i;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != LCDOUTS) && (card != STRINGINS) &&
        (card != USERIDS) && (card != USERSIN) && (card != TIMEDATE))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts[link][adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct(link, adapter))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        pdct = dcts[link][adapter];
    }

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

    if (card == LCDOUTS)
    {
        /* ensure string contained entirely within the address space of the allocated region */
        if (signal > NUMLCDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;

        reglen = (len+1)/2;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        pdct->lcdouts[signal].was_requested = TRUE;
        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
                        return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        /* check for DCT simulated mode. */
        if (dctsim [link])
        {
            *pvalue = 0;
            if (mltrace [link] == 10)
            {
                printf("SIDRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            }
            return (0);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->lcdouts[signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        for ( i = 0; i < reglen ; i++)
        {
            pvalue[i] = pdct->lcdouts [signal].last_write [i*2];
        }
        pvalue[i] = 0; /* null terminate the string */
        if (mltrace[link] == 8)
            printf ("SIDRIVER: Data Returned(0):[%s] L=%d, A=%d, C=%d, S=%d, V=:%s:\n",
                      pointname, link, adapter, card, signal, pvalue);
                    return(0);

        return(0);
    }

    if (card == STRINGINS)
    {
        /* ensure string contained entirely within the address space of the allocated region */
        if (signal >= NUMSTRINGINS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;

        reglen = (len+1)/2;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        pdct->stringins[signal].was_requested = TRUE;
        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
                        return (-1);
        }
        if (pdct->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        /* check for DCT simulated mode. */
        if (dctsim [link])
        {
            *pvalue = 0;
            if (mltrace [link] == 10)
            {
                printf("SIDRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            }
            return (0);
        }
        if (!pdct->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!pdct->stringins[signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        for ( i = 0; i < reglen ; i++)
        {
            tempshort = (pdct->stringins [signal].last_read [(i*2)])*256 +
                         pdct->stringins [signal].last_read [(i*2)+1];
            pvalue[i] = tempshort;
            pvalue[i+1] = 0;
        }
        pvalue[i] = 0; /* null terminate the string */

        if (mltrace[link] == 8)
            printf ("SIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=:%s:\n",
                      pointname, link, adapter, card, signal, pvalue);
        return(0);
    }

    if (card == USERIDS)
    {
        /* ensure string contained entirely within the address space of the allocated region */
        if (signal >= NUMUSERIDS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        reglen = ((len+1)/2)*2+1;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->userids[signal].was_requested = TRUE;

        if (!paccess->userids [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

/*        strncpy ((char *) pvalue, &paccess->userids [signal].last_read[0], len); */
        for ( i = 0; i < reglen ; i++)
        {
            tempshort = (paccess->userids [signal].last_read [(i*2)])*256 +
                         paccess->userids [signal].last_read [(i*2)+1];
            pvalue[i] = tempshort;
            pvalue[i+1] = 0;
        }
        pvalue[i] = 0; /* null terminate the string */


        if (mltrace[link] == 8)
            printf ("SIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=:%s:\n",
                      pointname, link, adapter, card, signal, pvalue);
        return(0);
    }

    if (card == USERSIN)
    {
        /* ensure string contained entirely within the address space of the allocated region */
        if (signal >= NUMUSERSIN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        reglen = ((len+1)/2)*2+1;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->usersin[signal].was_requested = TRUE;

        if (!paccess->usersin [signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        for ( i = 0; i < reglen ; i++)
        {
            tempshort = (paccess->usersin [signal].last_read [(i*2)])*256 +
                         paccess->usersin [signal].last_read [(i*2)+1];
            pvalue[i] = tempshort;
            pvalue[i+1] = 0;
        }
        pvalue[i] = 0; /* null terminate the string */


        if (mltrace[link] == 8)
            printf ("SIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=:%s:\n",
                      pointname, link, adapter, card, signal, pvalue);
        return(0);
    }

    if (card == TIMEDATE)
    {
        if (signal > NUMTIMEDATE)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        reglen = ((len+1)/2)*2+1;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SIDRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess = access [link];
        if (paccess == NULL)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: RSA Task Not Active:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        paccess->timedate [0].was_requested = TRUE;

        if (!paccess->timedate [0].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        for ( i = 0; i < reglen ; i++)
        {
            tempshort = (paccess->timedate [0].last_read [(i*2)])*256 +
                         paccess->timedate [0].last_read [(i*2)+1];
            pvalue[i] = tempshort;
            pvalue[i+1] = 0;
        }
        pvalue[i] = 0; /* null terminate the string */


        if (mltrace[link] == 8)
            printf ("SIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=:%s:\n",
                      pointname, link, adapter, card, signal, pvalue);
        return(0);
    }

    return(-1);
}


/*  										
**      SODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested string outputs to the  	
**      specified DCT via the output buffer.                                    
*/                                                                            	
/* this routine not called from within this driver */

int SODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, unsigned char *value, unsigned short len, unsigned char *resname)
{
    MR350  *pdct;
    OUTQENT *oqp;
    unsigned short reglen;
    int            i;

    if (link > MR350LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMDCTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != LCDOUTS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            printf("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pdct = dcts[link][adapter];
    if (pdct == NULL)
    {
        if (!allocate_dct(link, adapter))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        pdct = dcts[link][adapter];
    }

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

    if (card == LCDOUTS)
    {
        /* ensure string contained entirely within the address space of the allocated region */
        if (signal > NUMLCDOUTS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        reglen = (len+1)/2;     /* round up odd length character count string lengths */
 
        if (len > STRINGMSGLEN)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                printf("SODRIVER: String is too long:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pdct,resname,pointname);
        }

        pdct->was_requested = TRUE;
        pdct->lcdouts[signal].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
                        return (-1);
        }

        /* check for DCT simulated mode. */
        if (dctsim [link])
        {
            if (mltrace [link] == 5)
            {
                printf("SODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                       pointname, link, adapter, card, signal);
            }
            return (0);
        }
        if ((!pdct->is_responding) || (pdct->cmd_force_offline))
        {
            if (trace[link] & CALLREJECTTRACE)
                printf("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        oqp = ogetemptyp (link);
        if (oqp == NULLP)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
                printf("SODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            pdct->badoutcnt++;
            return (-1);		/* output queue is full */
        }
        oqp->otype = SOUTTYPE;
        oqp->out.sonode.link = link;
        oqp->out.sonode.adapter = adapter;
        oqp->out.sonode.card = card;
        oqp->out.sonode.sosignal = signal;
        oqp->out.sonode.solen = len;

        /* Move in the output string (strcpy not used because */
        /*  string content could contain terminators)         */
        for (i = 0 ;(i < STRINGMSGLEN) ; i++)
        {
            oqp->out.sonode.sovalue[i] = value[i];
        }

        omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 5)
            printf("SODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%s\n",
                    pointname, link, adapter, card, signal, value);
        return (0);
    }
    return (-1);
}

/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**  If this is the first time the resource for this line is being
**  referenced the pointer to the resource table entry will be set
**  and the resource name will be saved. If the resource name has
**  already been set, this routine will verify that all other points
**  for this driver are using the same resource name.
**
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, MR350 *pdct,
                                unsigned char *resname, char *pointname)
{
    int group;

    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                     pointname, resname );
        }
        else
        {
            strcpy (resnames [link], resname);
            group = mr350ResGroups [link];
            if (group)
            {
                if (assignLockGroup (group, resname) == ERROR)
                {
                    logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                             link, group, pointname, resname);
                }
            }
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                     resnames[link], pointname, resname );
        }
    }
}

/*
**      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
    oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
    if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
    {
        return (&oq [line]->outque[oq [line]->oinix]);
    }
    if (mltrace [line] == 11)
    {
        logMsg ( "Output Queue Full\n");
    }
    return (NULLP);
}


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
	oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
    if (oq [line]->ooutix != oq [line]->oinix)
    {
        return (&oq [line]->outque[oq [line]->ooutix]);
    }
    else
    {
        return (NULLP);
    }
}


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
    if (oq [line]->ooutix == oq [line]->oinix)
    {
        return;
    }
    oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}





/*
**      Initialize the Task Queue                                      		
*/                                                                        	
static	void taskqueinit (unsigned short line)
{
    tq [line]->ooutix = tq [line]->oinix = 0;
}
/*                                                                     		
**  tgetempty - get the next available slot on the task output list    		
*/
static	TASKOUT *tgetemptyp (unsigned short line)
{
    if (((tq [line]->oinix + 1) % TASKQSIZE) != tq [line]->ooutix)
    {
        return (&tq [line]->taskque[tq [line]->oinix]);
    }
    if (mltrace [line] == 11)
    {
        logMsg ( "Task Output Queue Full\n");
    }
    return (NULLP);
}
/*                                                                    		
** tmarkfull                                                          		
**      mark the next block as full                                     	
*/
static	void tmarkfull (unsigned short line)
{
	tq [line]->oinix = ((tq [line]->oinix + 1) % TASKQSIZE);
}
/*                                                                      	
**  tgetnextp - get the next full slot on the task output list               	
*/                                                                      	
static	TASKOUT *tgetnextp (unsigned short line)
{
    if (tq [line]->ooutix != tq [line]->oinix)
    {
        return (&tq [line]->taskque[tq [line]->ooutix]);
    }
    else
    {
        return (NULLP);
    }
}
/*                                                       	               	
** treleasefull - release the current full task output block  	              	
*/                                                                            	
static	void treleasefull (unsigned short line)
{
    if (tq [line]->ooutix == tq [line]->oinix)
    {
        return;
    }
    tq [line]->ooutix = ((tq [line]->ooutix + 1) % TASKQSIZE);
}



/*
**      link_status                                                           	
**                                                                            	
**      The purpose of this routine is to print out the state of each of the  	
**      analog devices lines and the statistics gathered about them.         	
**                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
{
    if (line > MR350LINES-1)
    {
        return;
    }
}

/*
**                                                                              
**	allocate_dct                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	DCT data structure. If not successful, a console error message is       
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_dct (unsigned short line, unsigned short dct )
{
    dcts [line] [dct] = (MR350 *) calloc (1, (sizeof (MR350)));
    if (!dcts [line] [dct])
    {
        logMsg ("Unable to allocate memory");
            printf (" for MR350 data structure on line %d, dct %d\n",line ,dct);
        return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for MR350 data structure on line %d, dct %d\n",line ,dct);
        init_dct_tab (line, dct);	     /*	initialize the data structures. */
    }

    return (TRUE);
}



/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */

static	void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus )
{
    RXLINE		*rxp;

    rxp = rxlinetab [line];
    rxp->rawchksum = 0;
    rxp->rxix = 0;
    rxp->semid = semid;
    rxp->status = pstatus;
    rxp->rxstate = RXSTX;
}


/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/
/* only called from msgxfer */

static	void stop_rx (unsigned short line )
{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
}


/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;
    RXLINE          *rxp;

    read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);
    /* only execute if no comm error */
    if ((rxstat & rx_err_mask) == 0)
    {
        /* Something is sending in data. */
        line_activity [line] = TRUE;
        linestats [line].RXintcount++;
    }
    else
    {
        linestats [line].RXbadcount++;
    }

    rxp = rxlinetab [line];

    if (rxp->rxstate == RXIGNORE)
    {
        return;
    }

    /* no matter what the state, errors cause a logical reset of the message processing */
    if ((rxstat & rx_err_mask) != 0)
    {
        rxp->rxstate = RXSTX;           /* if comm goes bad, assume it was garbage,      */
                                        /* and go wait for the good stuff.               */
        rxp->rxix = 0;                  /* reset the buffer index/counter                */
        return;
    }

    /* the STX mode is looking for four possible responses: STX, ACK, NAK, and EOT.     */
    if (rxp->rxstate == RXSTX)
    {
        rxp->rawchksum = 0;             /* dynamic checksum calculation */
        if (rxchar == STX)              /* if STX, data is next. be ready to get it.     */
        {
            rxp->rxstate = RXDATA;      /* don't store any data here, just change state. */
            rxp->rxspecial = FALSE;
            return;
        }
        if (rxchar == ACK)              /* if ACK, then last message was recieved ok,    */
        {                               /*  but there is no response data to send.       */
            rxp->rxstate = RXIGNORE;    /* don't store any data here. just change state. */
            *(rxp->status) = RXACK;
            semGive (rxp->semid);
            return;
        }
        if (rxchar == NAK)              /* if NAK, the last message was corrupted.       */
        {
            rxp->rxstate = RXIGNORE;    /* don't store any data here. just change state. */
            *(rxp->status) = RXNAK;
            semGive (rxp->semid);
            return;
        }
        if (rxchar == EOT)              /* if EOT then there is no response data to send.*/
        {
            rxp->rxstate = RXIGNORE;    /* don't store any data here. just change state. */
            *(rxp->status) = RXEOT;
            semGive (rxp->semid);
            return;
        }
        else                            /* if not SXT, ACK, NAK, or EOT, ignore it.      */
        {
            return;
        }
    }

    if (rxp->rxstate == RXDATA)
    {
        if (rxchar == STX)              /* if explicit STX, then something is wrong. the */
        {                               /* STX that brought us here must be spurious.    */
            rxp->rxstate = RXDATA;      /* presume that this new STX must be genuine.    */
            rxp->rxix = 0;              /* reset the buffer index/counter.               */
            return;
        }

        if (rxchar == ETX)              /* if explicit EXT, then message is over.        */
        {
            rxp->rxstate = RXIGNORE;    /* don't store any data here. just change state. */
            *(rxp->status) = RXGOOD;    /* let msgxfer know that the message was good.   */
            semGive (rxp->semid);       /* return semaphore to msgxfer routine.          */
            return; 
        }

        if (rxchar == 0x5C)             /* if backslash, special range char to follow.   */
        {
            /* dynamically calculate checksum */
            rxp->rawchksum = rxp->rawchksum + 0x5D;
            rxp->rxspecial = TRUE;      /* don't store any data here, just set flag.     */
            return;
        }

        /* dynamically calculate checksum */
        rxp->rawchksum = rxp->rawchksum + rxchar + 1;

        if (rxp->rxspecial)
        {
            rxp->rxspecial = FALSE;     /* turn it off for next time.                    */
            if ((rxchar >= 0x80) && (rxchar <= 0x9F))
            {
                rxchar = rxchar - 0x80; /* reconvert the special character, store it in  */
                rxp->rxbuf [rxp->rxix++] = rxchar;    /* the buffer, and bump the index. */
                return;
            }

            if ((rxchar >= 0x20) && (rxchar <= 0x7F))
            {
                rxchar = rxchar + 0x80; /* reconvert the special character, store it in  */
                rxp->rxbuf [rxp->rxix++] = rxchar;    /* the buffer, and bump the index. */
                return;
            }

            if (rxchar == 0x5C)        
            {
                rxp->rxbuf [rxp->rxix++] = rxchar;    /* store it, and bump the index.   */
                return;
            }
            rxp->rxstate = RXSTX;       /* if unexpected value, then this is an  error.  */
            rxp->rxix = 0;              /* reset the state and the buffer index/counter. */
            return;
        }
        else
        {
            if (rxp->rxix < MAXRXMSG)
            {
                rxp->rxbuf [rxp->rxix++] = rxchar;    /* store it, and bump the index.   */
                return;
            }
            else
            {
                rxp->rxstate = RXIGNORE; /* if it doesn't end well, it won't end well.   */
                *(rxp->status) = RXBAD;  /* let msgxfer know that message was aborted.   */
                semGive (rxp->semid);    /* return semaphore to msgxfer routine.         */
                return; 
            }

        }
    }
    rxp->rxstate = RXIGNORE; /* if we are in an unknown state, something is wrong.       */
    *(rxp->status) = RXBAD;  /* let msgxfer know that message was aborted.               */
    semGive (rxp->semid);    /* return semaphore to msgxfer routine.                     */
    return;
}

/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE          *rxp;
    long             thistime;
    short            status;

    if (predelay != 0)
    {
        taskDelay (predelay);
    }
    thistime = tickGet ();
    if ((thistime - activity_time [line]) < ACTIVITYTIME)
    {
        return (lastactivity [line] || (line_activity [line]));
    }

    lastactivity [line] = status = line_activity [line];
    line_activity [line] = FALSE;
    activity_time [line] = thistime;
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;

    return (status);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus)
{

    TXLINE		*txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;
    txp->txspecial = FALSE;
    txp->rawchksum = 0;             /* dynamic checksum calculation */

    enable_tx_ints (line);
}


/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for transmit and to disable the transmitter.                           	
**                                                                             	
*/
/* only called from msgxfer  */

static	void stop_tx (unsigned short line )
{
    TXLINE		*txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;
}


/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */

static	void tx_int_proc (unsigned short line )
{
    unsigned char     txchar;
    unsigned short    txstat;
    unsigned short    tx_err_mask;
    TXLINE           *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];
    if (txp->txdisable)
    {
        disable_tx_ints (line);
        return;
    }

    /* the FF terminate character is a one character output. */
    if (txp->txstate == TXFF)
    {
        txp->txffcount++;
        txchar = 0xff;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        txp->txdisable = TRUE;
        txp->txstate = TXIGNORE;
        disable_tx_ints (line);

        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            *(txp->status) = TXBAD3;
            semGive (txp->semid);
            return;
        }

        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }

    /********************************************/
    /* check for pre transmit of 0xff character */
    /********************************************/
    if (txp->txstate == PRETXACK)
    {
        if (txp->txff & PRETXACKFLAG)
        {
            txchar = 0xff;
            write_tx_hw (line, txchar, &txstat, &tx_err_mask);
            /* if an error has occurred, note it and stop transmission. */
            if ((txstat & tx_err_mask) != 0 )
            {
                txp->txdisable = TRUE;
                txp->txstate = TXIGNORE;
                disable_tx_ints (line);
                *(txp->status) = TXBAD3;
                semGive (txp->semid);
                return;
            }
            else
            {
                txp->txstate = TXACK;
                return;
            }
        }
        /* if no pre-TX 0xff, fall through to TXACK state now. */
        txp->txstate = TXACK;
    }
    /* the ACK mode is a one character output. we don't even look at the data buffer. */
    if (txp->txstate == TXACK)
    {
        txchar = ACK;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            txp->txstate = TXIGNORE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD3;
            semGive (txp->semid);
            return;
        }
        /* if FF terminate mode, handle it. */
        if (txp->txff & POSTTXACKFLAG)
        {
            txp->txstate = TXFF;
            return;
        }
        else
        {
            txp->txdisable = TRUE;
            txp->txstate = TXIGNORE;
            disable_tx_ints (line);
            *(txp->status) = TXGOOD;
            semGive (txp->semid);
            return;
        }
    }

    /********************************************/
    /* check for pre transmit of 0xff character */
    /********************************************/
    if (txp->txstate == PRETXNAK)
    {
        if (txp->txff & PRETXNAKFLAG)
        {
            txchar = 0xff;
            write_tx_hw (line, txchar, &txstat, &tx_err_mask);
            /* if an error has occurred, note it and stop transmission. */
            if ((txstat & tx_err_mask) != 0 )
            {
                txp->txdisable = TRUE;
                txp->txstate = TXIGNORE;
                disable_tx_ints (line);
                *(txp->status) = TXBAD3;
                semGive (txp->semid);
                return;
            }
            else
            {
                txp->txstate = TXNAK;
                return;
            }
        }
        /* if no pre-TX 0xff, fall through to TXNAK state now. */
        txp->txstate = TXNAK;
    }
    /* the NAK mode is a one character output. we don't even look at the data buffer. */
    if (txp->txstate == TXNAK)
    {
        txchar = NAK;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            txp->txstate = TXIGNORE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD4;
            semGive (txp->semid);
            return;
        }
        /* if FF terminate mode, handle it. */
        if (txp->txff & POSTTXNAKFLAG)
        {
            txp->txstate = TXFF;
            return;
        }
        else
        {
            txp->txdisable = TRUE;
            txp->txstate = TXIGNORE;
            disable_tx_ints (line);
            *(txp->status) = TXGOOD;
            semGive (txp->semid);
            return;
        }
    }

    /********************************************/
    /* check for pre transmit of 0xff character */
    /********************************************/
    if (txp->txstate == PRETXSTX)
    {
        if (txp->txff & PRETXSTXFLAG)
        {
            txchar = 0xff;
            write_tx_hw (line, txchar, &txstat, &tx_err_mask);
            /* if an error has occurred, note it and stop transmission. */
            if ((txstat & tx_err_mask) != 0 )
            {
                txp->txdisable = TRUE;
                txp->txstate = TXIGNORE;
                disable_tx_ints (line);
                *(txp->status) = TXBAD3;
                semGive (txp->semid);
                return;
            }
            else
            {
                txp->txstate = TXSTX;
                return;
            }
        }
        /* if no pre-TX 0xff, fall through to TXNAK state now. */
        txp->txstate = TXSTX;
    }
    /* the STX mode starts a multi-character output sequence:   */
    /*    STX, then data & checksum (if any), then address.     */
    if (txp->txstate == TXSTX)
    {
        txp->rawchksum = txp->address;             /* dynamic checksum calculation */
        txchar = STX;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD5;
            semGive (txp->semid);
            return;
        }
        /* if no data, skip to address */
        if (txp->txmsglen)
        {
            txp->txstate = TXDATA;
        }
        else
        {
            txp->txstate = TXADDRESS;
        }
        return;
    }

    if (txp->txstate == TXDATA)
    {
        if (txp->txspecial)
        {
            txp->txspecial = FALSE;       /* turn it off for next time.                    */
            txchar = txp->txbuf [txp->txix++];
            if (txchar < 0x20)
            {
                txchar = txchar + 0x80;   /* convert the special character to transmit.    */
            }
            else if (txchar > 0xA0)
            {
                txchar = txchar - 0x80;   /* convert the special character to transmit.    */
            }
            /* 0x5C passes through untranslated. */
        }
        else
        {
            txchar = txp->txbuf [txp->txix];
            if ((txp->txix != 0) &
                ((txchar < 0x20) ||
                 ((txchar > 0xA0) && (txchar != 0xDC)) ||
                 (txchar == 0x5C)))
            {
                txp->txspecial = TRUE;    /* turn it on for next time.                     */
                txchar = 0x5C;            /* transmit the \ prefix character.              */
            }
            else
            {
                txp->txix++;              /* increment pointer to next character.          */
            }
        }
        /* dynamically calculate checksum */
        txp->rawchksum = txp->rawchksum + txchar + 1;

        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD6;
            semGive (txp->semid);
            return;
        }
        if (txp->txix == txp->txmsglen)
        {
            txp->txstate = TXCHKSUM1;
            return;
        }

        if (txp->txix >= MAXTXMSG)
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD7;
            semGive (txp->semid);
            return;
        }
        /* this is the 'normal' exit point while outputting the message data */
        return;
    }

    if (txp->txstate == TXCHKSUM1)
    {
        txchar = ((txp->rawchksum >> 4) & 0x0f) + 0x40; /* MSD of Chksum */
        txp->chksum1 = txchar;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD8;
            semGive (txp->semid);
            return;
        }
        txp->txstate = TXCHKSUM2;
        return;
    }

    if (txp->txstate == TXCHKSUM2)
    {
        txchar = (txp->rawchksum & 0x0f) + 0x40;  /* LSD of Chksum */
        txp->chksum2 = txchar;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        /* if an error has occurred, note it and stop transmission. */
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD8;
            semGive (txp->semid);
            return;
        }
        txp->txstate = TXADDRESS;
        return;
    }

    if (txp->txstate == TXADDRESS)
    {
        /* convert to receiver EOT-recognition character (high bit set) */
        txchar = txp->address;
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            txp->txstate = TXIGNORE;
            *(txp->status) = TXBAD10;
            semGive (txp->semid);
            return;
        }
        /* if address goes out good, then its all over. */
        /* if FF terminate mode, handle it. */
        if (txp->txff & POSTTXADDFLAG)
        {
            txp->txstate = TXFF;
            return;
        }
        else
        {
            txp->txdisable = TRUE;
            txp->txstate = TXIGNORE;
            disable_tx_ints (line);
            *(txp->status) = TXGOOD;
            semGive (txp->semid);
            return;
        }
    }

    /* Unexpected execution path.  */
    else
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        txp->txstate = TXIGNORE;
        *(txp->status) = TXBAD11;
        semGive (txp->semid);
        return;
    }
}




/*                                                                         	
**      msgxfer                                                                 
**                                                                           	
**      The purpose of this routine is to transmit a buffer to the         	
**      analog devices I/O and to await a response. The transmit and receive	
**      buffers are in their respective line tables. This routine will retry 	
**      the message up to a maximum number of times or until a response      	
**      is received with a proper checksum.                                  	
**              returns         XFERGOOD if response received                	
**                              XFERBAD  if no good response is received     	
**                                                                           	
*/

static	unsigned short  msgxfer (unsigned short fline,
                                 unsigned short msgtype,
                                 MR350 *pdct)
{
    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i, j;
    RXLINE          *rxp;
    TXLINE          *txp;
    unsigned char   csums [2];
    unsigned short  oldrxix;
    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned long   msgstart;
    unsigned short  queryflag, acknakflag;

    acknakflag = FALSE;
    msgstart = tickGet();

    line = (fline & (~ONERETRY));          /* strip off the no retry flag */

    delta40 = delta01 = delta12 = delta23 = delta34 = 0;

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    /* determine if this is a query or a command (a query has zero length) */
    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        /* time since end of last msgxfer */
        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

        if (intermsgdelay [line] != 0)
        {
            taskDelay (intermsgdelay [line]);
        }
        set_rts (line);

        if (pretxdelay [line] != 0)
        {
            taskDelay (pretxdelay [line]);
        }

        /* initialize command/query and response pair. */
        txp->chksum1 = 0;
        txp->chksum2 = 0;
        txp->txstate = PRETXSTX;
        txstatus = IO_TIMEOUT;
        rxstatus = IO_TIMEOUT;

        semTake (semids [line] [TXSEM], NO_WAIT);
        semTake (semids [line] [RXSEM], NO_WAIT);

        txlen = txp->txmsglen;
        if (txlen == 0)
        {
            queryflag = TRUE;
        }
        else
        {
            queryflag = FALSE;
        }

        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
        {
            printf ("TX:");
            for (ix = 0; ix < 14 ; ix++) /* 14 is maximum TX message length */
            {
                if (ix < txlen)
                {
                    printf("_%2x", txp->txbuf [ix]);
                }
                else
                {
                    printf ("...");
                }
            } 
        }

        /* time from entering msgxfer to starting transmission. (including delays & diags) */

        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

        start_rx (line, semids [line] [RXSEM], &rxstatus); 
        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */


        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
            txstatus = IO_TIMEOUT;
        }

        /* time it took to transmit message. */

        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);

        stop_tx (line);



        if (posttxdelay [line] != 0)
        {
            taskDelay (posttxdelay [line]);
        }

        if (halfduplex [line] == TRUE)
        {
           clear_rts (line);
        }
        /* intermessage wait time. */

        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);



        /* print checksum and address values */
        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
        {
            printf (" CS:_%2x_%2x ADD:_%2x   ", txp->chksum1, txp->chksum2, txp->address);
        }

        if (txstatus == TXGOOD)
        {
            oldrxix = -1;    /* make it pass through timeout loop at least once */
            while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
            {
                if (oldrxix == rxp->rxix)
                {
                    if (modtrace [line])
                    {
                        logMsg("RX timeout\n");
                    }
                    rxstatus = IO_TIMEOUT;
                    break;
                }
                else
                {
                    if ((modtrace [line]) || (mltrace[line] == 12))
                    {
                         logMsg("waiting...");
                    }
                }
                oldrxix = rxp->rxix;
            }
            stop_rx (line);

            /* time to receive message. */
            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

            rxlen = rxp->rxix;
            /* preserve for post msgxfer analysis */ 
            if (((queryflag == FALSE) &&
                 ((rxstatus == RXACK) ||
                  (rxstatus == RXNAK) ||
                  (rxstatus == RXGOOD)))
                ||
                ((queryflag == TRUE) &&
                 ((rxstatus == RXEOT) ||
                  (rxstatus == RXGOOD))))
            {
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
                {
                    printf("     (%d) ", rxstatus);
                    printf("RX:");
                    if (rxlen != 0)
                    {
                        for (ix = 0; ix < 14; ix++) /* 14 is maximum RX message length */
                        {
                            if (ix < rxlen)
                            {
                                printf("_%2x", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf("...");
                            }
                        }
                    }
                    else
                    {
                        if (rxstatus == RXACK)
                        {
                            printf("ACK");
                        }
                        else if (rxstatus == RXNAK)
                        {
                            printf("NAK");
                        }
                        else if (rxstatus == RXEOT)
                        {
                            printf("EOT");
                        }
                        for (ix = 0; ix < 13; ix++) /* 14 is maximum RX message length */
                        {
                            if (ix < rxlen)
                            {
                                printf("_%2x", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf("...");
                            }
                        }
                    }
                    printf("DELTA: %3d %3d %3d %3d %3d txcnt=%d\n",
                            delta40, delta01, delta12, delta23, delta34, txp->txffcount);
                }

                if (rxlen != 0)
                {
                    rxp->rawchksum = rxp->rawchksum - (rxp->rxbuf [rxp->rxix - 2] +
                                                       rxp->rxbuf [rxp->rxix - 1] +
                                                       2);
                    csums [0] = ((rxp->rawchksum >> 4) & 0x0f) + 0x40;
                    csums [1] = (rxp->rawchksum & 0x0f) + 0x40;
                }
                else
                {
                    /* note: if NAK (busy), break out to the retry */
                    /* logic. otherwise, bump counters and return. */
                    if (!(rxstatus == RXNAK))
                    {
                        pdct->msgs++;
                        pdct->responsetime += (tickGet() - msgstart);
                        /* the TX/RX communication pair is successfully completed.*/
                        return (XFERGOOD);
                    }
                    else
                    {
                        /* if NAK response, wait 1 second before trying again. */
                        taskDelay (RXTIMEOUT);
                    }
                }
                /* if not a zero length reply, test the checksum */
                if ((csums [0] == rxp->rxbuf [rxp->rxix - 2]) &&
                    (csums [1] == rxp->rxbuf [rxp->rxix - 1]))
                {
                    pdct->msgs++;
                    pdct->responsetime += (tickGet() - msgstart);

                    /* now that the TX/RX communication pair is successfully  */
                    /* completed, tell the MR-350 that everything went ok.    */

                    if (intermsgdelay [line] != 0)
                    {
                        taskDelay (intermsgdelay [line]);
                    }

                    set_rts (line);

                    for (j = 0; j < ackcount [line]; j++)
                    { 
                        /* initialize acknowledge response. */
                        txp->txstate = PRETXACK;
                        txstatus = IO_TIMEOUT;
                        semTake (semids [line] [TXSEM], NO_WAIT);

                        if ((trace [line] & ALLTRAFFICTRACE) &&
                            ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
                        {
                            printf ("TX:ACK(%d)\n", j);
                        }

                        if (pretxdelay [line] != 0)
                        {
                            taskDelay (pretxdelay [line]);
                        }

                        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

                        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
                        {
                            txstatus = IO_TIMEOUT;
                            break;
                        }
                    }

                    if (posttxdelay [line] != 0)
                    {
                        taskDelay (posttxdelay [line]);
                    }

                    if (halfduplex [line] == TRUE)
                    {
                       clear_rts (line);
                    }
                    return (XFERGOOD);
                }
                else
                {
                    pdct->no_cserrs++;
                    if (modtrace [line])
                    {
                        logMsg ("Checksum Data Message Length = %d\n", rxlen);
                        logMsg ("%x%x : %x%x    Bad Checksum\n",
                                 rxp->rxbuf [rxp->rxix - 2], rxp->rxbuf [rxp->rxix - 1],
                                 csums [0], csums [1]);
                    }
                    for (ix = 0; ix < rxlen; ix++)
                    {
                        if (modtrace [line])
                        {
                            logMsg ("rxbuf[%d] = %x\n", ix, rxp->rxbuf [ix]);
                        }
                    }
                    /* tell the MR-350 that it was a bad transmission.  */
                    /* initialize acknowledge response. */
                    txp->txstate = PRETXNAK;
                    txstatus = IO_TIMEOUT;
                    semTake (semids [line] [TXSEM], NO_WAIT);

                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
                    {
                        printf ("TX:NAK\n");
                    }
                    /* this fires off the transmission. */
                    start_tx (line, semids [line] [TXSEM], &txstatus);
                    /* return (XFERGOOD); */ /* fall through and try again. */
                }
            }
            else if (rxstatus == IO_TIMEOUT)
            {
                if (modtrace [line])
                {
                    logMsg ("Receive Timeout... Length: %d\n", rxlen);
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d txcnt=%d\n",
                            delta40, delta01, delta12, delta23, delta34, txp->txffcount);
                }
                    pdct->no_rxnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Receive Error\n");
                    logMsg ( "queryflag = %d,  rxstatus = %d",
                             queryflag, rxstatus);
                }
                pdct->no_rxhwerrs++;
            }
        }
        else if (txstatus == IO_TIMEOUT)
        {
            if (modtrace [line])
            {
                logMsg ("Transmit Timeout\n");
            }
            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->address) || (traceadr [line] == 255)))
            {
                printf("DELTA: %3d %3d %3d %3d %3d txcnt=%d\n",
                        delta40, delta01, delta12, delta23, delta34, txp->txffcount);
            }
                pdct->no_txnoresp++;
        }
        else
        {
            if (modtrace [line])
            {
                 logMsg ("Transmit Error(%d)\n", txstatus);
            }
            pdct->no_txhwerrs++;
        }
        if (retry != MAXRETRYS)
        {
            pdct->no_retries++;
        }

    }
    if (modtrace [line])
    {
        logMsg ("Xfer Bad\n");
    }
    return (XFERBAD);
}

/*
**      accessinit
**
**      The purpose of this routine is to initialize the access variables
**
*/
/* only called from allocate_dct  */


static	void accessinit (unsigned short line)
{
    ACCESS            *paccess;
    unsigned short    i;

    paccess = access [line];
    if (!paccess)
    {
        return;
    }

    /*  PERIMETERS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMPERIMETERS); i++)
    {
        paccess->perimeters [i].was_requested = FALSE;
        paccess->perimeters [i].data_valid = FALSE;
        paccess->perimeters [i].new_flag = FALSE;
        paccess->perimeters [i].last_write = UNKNOWN;
    }

    /*  SITEINS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMSITEINS); i++)
    {
        paccess->siteins [i].was_requested = FALSE;
        paccess->siteins [i].data_valid = FALSE;
        paccess->siteins [i].new_flag = FALSE;
        paccess->siteins [i].last_read = UNKNOWN;
    }

    /*  USERIDS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMUSERIDS); i++)
    {
        paccess->userids [i].was_requested = FALSE;
        paccess->userids [i].data_valid = FALSE;
        paccess->userids [i].new_flag = FALSE;
        paccess->userids [i].last_read[0] = 0; /* NULL string */
    }

    /*  USERSIN ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMUSERSIN); i++)
    {
        paccess->usersin [i].was_requested = FALSE; /* no one cares, but mark it anyway. */
        paccess->usersin [i].data_valid = TRUE;     /* all are valid, but blank.         */
        paccess->usersin [i].new_flag = TRUE;
        paccess->usersin [i].last_read[0] = 0;      /* NULL string */
        paccess->usersincount = 0;

        /* DEBUG ONLY - REMOVE FROM PRODUCTION CODE */
        paccess->usersin [i].data_valid = TRUE;
        paccess->usersin [i].last_read[0] = 'U';
        paccess->usersin [i].last_read[1] = 's';
        paccess->usersin [i].last_read[2] = 'e';
        paccess->usersin [i].last_read[3] = 'r';
        paccess->usersin [i].last_read[4] = ' ';
        paccess->usersin [i].last_read[5] = '0' + (i/10);
        paccess->usersin [i].last_read[6] = '0' + (i%10);
        paccess->usersin [i].last_read[0] = 0; /* NULL string */
    }

    /*  TIMEDATE ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMTIMEDATE); i++)
    {
        paccess->timedate [i].was_requested = FALSE;
        paccess->timedate [i].data_valid = FALSE;
        paccess->timedate [i].new_flag = FALSE;
        paccess->timedate [i].last_read[0] = 0; /* NULL string */
    }
}

/*
**      init_dct_tab
**
**      The purpose of this routine is to initialize the device I/O
**
*/
/* only called from allocate_dct  */


static	void init_dct_tab (unsigned short line, unsigned short dct)
{
    MR350  *pdct;

    pdct = dcts [line] [dct];
    if (!pdct)
    {
        return;
    }
    pdct->is_responding = FALSE;
    pdct->holdflag = FALSE;
    pdct->was_requested = FALSE;
    pdct->cmd_force_offline = FALSE;

    pdct->mr350sendto = FALSE;

    initdct (pdct);
    initstats (pdct);
}
/*
** Cold Init a DCT
**
*/
/* only called from init_line_tabs  */

static void initdct (MR350  *pdct)
{
unsigned short	i,j;
                                                                	
/*  DINS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID          */
    for (i = 0; (i < NUMDINS); i++)
    {
        pdct->dins [i].was_requested = FALSE;
        pdct->dins [i].data_valid = FALSE;
        pdct->dins [i].last_read = 0;
    }

/*  DOUTS ARE INITIALIZED AS WRITE ONLY VALUES                   */
    for (i = 0; (i < NUMDOUTS); i++)
    {
        pdct->douts [i].was_requested = FALSE;
        pdct->douts [i].data_valid = FALSE;
        pdct->douts [i].last_write = 0;
    }
/*  LEDOUTS ARE INITIALIZED AS WRITE ONLY VALUES                 */
    for (i = 0; (i < NUMLEDOUTS); i++)
    {
        pdct->ledouts [i].was_requested = FALSE;
        pdct->ledouts [i].data_valid = FALSE;
        pdct->ledouts [i].last_write = 0;
    }
/*  LCDOUTS ARE INITIALIZED AS WRITE ONLY VALUES                 */
    for (i = 0; (i < NUMLCDOUTS); i++)
    {
        pdct->lcdouts [i].was_requested = FALSE;
        pdct->lcdouts [i].data_valid = FALSE;
        pdct->lcdouts [i].last_write[0] = 0;
    }

/*  STRINGINS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID     */
    for (i = 0; (i < NUMSTRINGINS); i++)
    {
        pdct->stringins [i].was_requested = FALSE;
        pdct->stringins [i].data_valid = FALSE;
        pdct->stringins [i].last_read[0] = 0;
    }

/*  BUZZEROUTS ARE INITIALIZED AS WRITE ONLY VALUES              */
    for (i = 0; (i < NUMBUZZEROUTS); i++)
    {
        pdct->buzzerouts [i].was_requested = FALSE;
        pdct->buzzerouts [i].data_valid = FALSE;
        pdct->buzzerouts [i].last_write = 0;
    }
}

/*                                                            		
**                                                              	
** initialize the statistics for a MR350 DCT                            
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static	void initstats (MR350 *pdct)
{
    pdct->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
    pdct->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
    pdct->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
    pdct->no_txnoresp = 0;      /* 8  Count No Responses 		*/
    pdct->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
    pdct->no_retries = 0;       /* 10 Count Retries 		        */
    pdct->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
    pdct->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
    pdct->no_cserrs = 0;        /* 13 Count CRC Errors 		        */
    pdct->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
    pdct->badoutcnt = 0;	/* 17 Count failed output commands 	*/
    pdct->no_mr350_msgs = 0;    /* 18 Count MR-350 response messages    */

    pdct->tscanpass = 0;        /* DCT scan pass counter                */
    pdct->msgs = 0;             /* good response message counts         */
    pdct->responsetime = 0;     /* total wait time for good messages    */
}


/*
** dctloopback                                                            
**                                                                        
*/                                                                          	
/* only called from on_line */


static	unsigned short dctloopback (unsigned short line, unsigned short dct, MR350 *pdct)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command */
    txp->txbuf [1] = '9';                  /* loopback command     */
    txp->txbuf [2] = ' ';                  /* Echo Test Pattern    */
    txp->txbuf [3] = 'T';                  /* Echo Test Pattern    */
    txp->txbuf [4] = 'E';
    txp->txbuf [5] = 'S';
    txp->txbuf [6] = 'T';
    txp->txbuf [7] = 'I';
    txp->txbuf [8] = 'N';
    txp->txbuf [9] = 'G';

/*    makechksum (&(txp->txbuf [0]), LOOPBACKLEN, txp->address, &(txp->txbuf [LOOPBACKLEN])); */

    txp->txmsglen = LOOPBACKLEN; /* +CHKSUMLEN;*/

/*     txp->txmsglen = 0;*/

    /* Increment message counter */
    pdct->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->is_responding = FALSE;
        return (FALSE);
    }

    return (TRUE);
}


/*                                                                           	
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the DCTs as on hold and the      
**	data as not valid until read again from the DCT                         
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)
{
    unsigned short	dct;
    MR350		*pdct;

    for (dct = 0; (dct <= NUMDCTS); dct++)
    {
        pdct = dcts [line] [dct];
        if (pdct)                /* verify pointer validity prior to use */
        {
            pdct->holdflag = TRUE;
            mark_not_valid (pdct);
        }
    }
}


/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are          
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)
{
    unsigned short  dct;
    MR350		*pdct;

    for (dct = 0; (dct <= NUMDCTS); dct++)
    {
        pdct = dcts [line] [dct];
        if (pdct)			/* verify pointer validity prior to use */
        {
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pdct->is_responding) && (!pdct->cmd_force_offline))
            {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}



/*                                                                      
** Requestmsgs                                                       	
**                                                                  	
*/
static	unsigned short requestmsgs (unsigned short line, unsigned short dct, MR350 *pdct)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i, temp;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    txp->txmsglen = 0;

    /* Increment message counter */
    pdct->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }

    pdct->no_mr350_msgs++;

    if (rxp->rxix)
    {
        rxp->rxbuf[rxp->rxix-2] = 0; /* terminate the string */
/*        printf ("Raw Input String :%s:\n", &rxp->rxbuf[1]); */

        /* parse the response and store the data. */
        switch (rxp->rxbuf[0])
        {

            case BADGETYPE:
                pdct->stringins [0].data_valid = TRUE;
                pdct->stringins [0].new_flag = TRUE;
                /* extract the message from the string and store it */
                for (i = 0; i < STRINGMSGLEN; i++)
                {
                    if ( (i+1) < rxp->rxix-3)
                    {
                        pdct->stringins [0].last_read[i] = rxp->rxbuf[2+i];
                    }
                    else
                    {
                        pdct->stringins [0].last_read[i] = 0;
                    }
                }
                pdct->stringins [0].last_read[STRINGMSGLEN] = 0;
/*                printf ("Stored Badge String :%s:\n", &pdct->stringins [0].last_read[0]); */
                break;

            case KEYPADTYPE:
                pdct->stringins [1].data_valid = TRUE;
                pdct->stringins [1].new_flag = TRUE;
                /* extract the message from the string and store it */
                for (i = 0; i < STRINGMSGLEN; i++)
                {
                    if ( (i+1) < rxp->rxix-3)
                    {
                        pdct->stringins [1].last_read[i] = rxp->rxbuf[2+i];
                    }
                    else
                    {
                        pdct->stringins [1].last_read[i] = 0;
                    }
                }
                pdct->stringins [1].last_read[STRINGMSGLEN] = 0;
/*                printf ("Stored Keypad String :%s:\n", &pdct->stringins [1].last_read[0]); */
                break;

            case LOGOUTTYPE:
                /* ignore it. customer doesn't want to use unlabeled key. */
                /* ignore 'ignore it' comment above. F3 is now equivelant to logout button. */
                pdct->fin.data_valid = TRUE;
                pdct->fin.new_flag = TRUE;
                pdct->fin.last_read = '3';
                break;

            case PHOTOTYPE:
                for (i = 0; i < NUMDINS; i++)
                {
                    pdct->dins [i].data_valid = TRUE;
                    temp = rxp->rxbuf[1+i] - '0';
                    if (pdct->dins [i].last_read != temp)
                    {
                        /* whenever the value changes from 0 to 1, set the flag */
                        if (pdct->dins [i].last_read)
                        {
                            pdct->dins [i].new_flag = TRUE;
                        }
                    }
                    pdct->dins [i].last_read = temp;
                }
                /* create a message and store it */
                break;
        }
    }
    return (CMDDONE);
}



/*
** Requestdins                                                       	
**                                                                  	
*/
static	unsigned short requestdins (unsigned short line, unsigned short dct, MR350 *pdct)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = REQDINS;              /* request MR350 to send digital inputs */

/*    makechksum (&(txp->txbuf [0]), REQDINSLEN, txp->address, &(txp->txbuf [REQDINSLEN])); */
    txp->txmsglen = REQDINSLEN; /*+CHKSUMLEN; */

    /* Increment message counter */
    pdct->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}




/*
** Setdouts                                                       	
**                                                                  	
*/
static	unsigned short setdouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                 unsigned short signal, unsigned short value)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = SETDOUTS;             /* request MR350 to set digital outputs */
    txp->txbuf [3] = signal + '0';
    txp->txbuf [4] = pdct->douts[signal].last_write + '0';

/*    makechksum (&(txp->txbuf [0]), SETDOUTSLEN, txp->address, &(txp->txbuf [SETDOUTSLEN]));*/
    txp->txmsglen = SETDOUTSLEN; /*+CHKSUMLEN; */

    /* Increment message counter */
    pdct->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}


/*
** Setledouts                                                       	
**                                                                  	
*/
static	unsigned short setledouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                   unsigned short signal, unsigned short value)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = SETLEDOUTS;           /* request MR350 to set LED outputs     */
    txp->txbuf [3] = pdct->ledouts[0].last_write + '0';
    txp->txbuf [4] = pdct->ledouts[1].last_write + '0';
    txp->txbuf [5] = pdct->ledouts[2].last_write + '0';
    txp->txbuf [6] = pdct->ledouts[3].last_write + '0';

/*    makechksum (&(txp->txbuf [0]), SETLEDOUTSLEN, txp->address, &(txp->txbuf [SETLEDOUTSLEN])); */
    txp->txmsglen = SETLEDOUTSLEN; /*+CHKSUMLEN;*/

    /* Increment message counter */
    pdct->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}


/*
** Setlcdouts                                                       	
**                                                                  	
*/
static	unsigned short setlcdouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                   unsigned short signal, unsigned char *value)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i, los;

    if (signal == 0)
    {
        value[16] = 0;   /* force string truncation on top line */
    }
    else
    {
        value[15] = 0;   /* force string truncation on botton line */
    }

    los = strlen (value);

    /* Move in the output string (strcpy not used because */
    /*  string content could contain terminators)         */
    strcpy (&pdct->lcdouts[signal].last_write[0], value);

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

   /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = SETLCDOUTS;           /* request MR350 to output LCD message  */
    txp->txbuf [3] = signal + '0';         /* set line number for output.          */
    txp->txbuf [4] = los + 'A';            /* set line number for output.          */

    strcpy (&txp->txbuf [5], value);

/*    makechksum (&(txp->txbuf [0]), (los + 5), txp->address, &(txp->txbuf [(los + 5)])); */
    txp->txmsglen = (los + 5); /* + CHKSUMLEN; */

    /* Increment message counter */
    pdct->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}




/*
** Setklaxonouts
**                                                                  	
*/
static	unsigned short setklaxonouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                      unsigned short signal, unsigned short value)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i, interval;

    interval = pdct->buzzerouts[3].last_write;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = SETKLAXON;            /* request MR350 to set buzzer outputs  */
    txp->txbuf [3] = pdct->buzzerouts[1].last_write + '0';  /* frequency */
    txp->txbuf [4] = pdct->buzzerouts[2].last_write + '0';  /* duration  */
    txp->txbuf [5] = (interval%1000)/100 + '0';             /* Interval seconds (hundreds) */
    txp->txbuf [6] = (interval%100)/10 + '0';               /* Interval seconds (tens)     */
    txp->txbuf [7] = (interval%10)/1 + '0';                 /* Interval seconds (units)    */

/*     makechksum (&(txp->txbuf [0]), SETBUZZEROUTSLEN, txp->address, &(txp->txbuf [SETBUZZEROUTSLEN])); */
    txp->txmsglen = SETBUZZEROUTSLEN + 0; /*+CHKSUMLEN;*/

    /* Increment message counter */
    pdct->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}





/*
** Setbuzzerouts
**                                                                  	
*/
static	unsigned short setbuzzerouts (unsigned short line, unsigned short dct, MR350 *pdct,
                                      unsigned short signal, unsigned short value)
{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short   i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* Load adjusted MR-350 address */
    txp->address = dct + 'A' + 0x80;

    /* Format the output message */
    txp->txbuf [0] = ESC;                  /* MR350 Escape Command                 */
    txp->txbuf [1] = '0';                  /* user defined command to follow       */
    txp->txbuf [2] = SETBUZZEROUTS;        /* request MR350 to set buzzer outputs  */
    txp->txbuf [3] = pdct->buzzerouts[0].last_write + '0';  /* frequency */
    txp->txbuf [4] = pdct->buzzerouts[1].last_write + '0';  /* duration  */
    txp->txbuf [5] = pdct->buzzerouts[2].last_write + '0';  /* volume    */

/*     makechksum (&(txp->txbuf [0]), SETBUZZEROUTSLEN, txp->address, &(txp->txbuf [SETBUZZEROUTSLEN])); */
    txp->txmsglen = SETBUZZEROUTSLEN + 0; /*+CHKSUMLEN;*/

    /* Increment message counter */
    pdct->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, 0, pdct) == XFERBAD)
    {
        pdct->no_offlines++;
        pdct->holdflag = TRUE;
        pdct->is_responding = FALSE;
        return (CMDFAIL);
    }
    return (CMDDONE);
}





/*
** makechksum 									
**                                                                        	
*/

static	void makechksum (unsigned char *chkbuf, int len,
                         unsigned char addr, char unsigned *retbuf)
{
    unsigned short  checksum;
    unsigned int    i, j;
    unsigned short  flag;
    unsigned char   tempch;

    checksum = len;

    for (i=0; i < len; i++)
    {
        checksum += chkbuf[i]; 
    }

    checksum += addr;

    retbuf [0] = ((checksum >> 4) & 0x0f) + 0x40;
    retbuf [1] = (checksum & 0x0f) + 0x40;
}

/*                                                                        	
**      hexascii                                                            	
**                                                                          	
**      The purpose of this routine is to convert the hex byte to 2 ascii   	
**      characters and to place them into the buffer.                       	
**                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val,char *buf)

{
	char    hi, lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi <= 9)
	{
	    hi+='0';
	}
	else
	{
	    hi += ('A' - 10);
	}
	if (lo <= 9)
	{
	    lo += '0';
	}
	else
	{
	    lo += ('A' - 10);
	}
	buf [0] = hi;
	buf [1] = lo;

}

/*                                                                         	
**      asciihex                                                    	   	
**                                                                         	
**      The purpose of this routine is to convert the next 2 ascii         	
**      characters in the buffer to hex and return them in val. It         	
**      will return TRUE if good conversion of FALSE if bad.               	
*/                                                                         	
/* not called from within this driver */


static	short asciihex (unsigned short *val,char *buf)

{
	if ((buf [0] < '0') || (buf [0] > 'F'))
	{
	    return (FALSE);
	}
	if (buf [0] <= '9')
	{
	    *val = ((buf [0] & 0x0f) << 4);
	}
	else
	{
	    if (buf [0] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val = ((buf [0] - 'A' + 10) << 4);
	    }
	}
	if ((buf [1] < '0') || (buf [1] > 'F'))
	{
	    return (FALSE);
	}
	if ( buf [1] <= '9')
	{
	    *val += (buf [1] & 0x0f);
	}
	else
	{
	    if (buf [1] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val += (buf [1] - 'A' + 10);
	    }
	}
	return (TRUE);
}


/*
**      DUMPMSGCNTS
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, e, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
        e = linestats [line].RXbadcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf ("TX Interrupt Count    = %10d\n", x);
            printf ("RX Interrupt Count    = %10d\n", y);
            printf ("BadRX Intrpt Count    = %10d\n", e);
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
        printf ("BadRX Intrpt Count    = %10d\n", e);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
**      CLEARMSGCNTS
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
        linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*
**      DUMPDCTSTATS
**
**      The purpose of this routine is to dump the DCT level statistics for this driver.
**
*/
/* called from TABLEINFO */

void DUMPDCTSTATS (unsigned short line, unsigned short maddr)

{
    MR350         *pdct;
    unsigned long   microsecs;

    pdct = dcts [line] [maddr];
    if (!pdct)
    {
        logMsg ("Line/Address Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n", pdct->was_requested);
    printf (" Is responding = %d \n", pdct->is_responding);
    printf (" # Output messages = %d \n", pdct->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", pdct->no_datain_msgs & 0x7fff);
    printf (" # No Rx Response = %d \n", pdct->no_rxnoresp & 0x7fff);
    printf (" # No Tx Responses = %d \n", pdct->no_txnoresp & 0x7fff);
    printf (" # Data Errors = %d \n", pdct->no_dataerr & 0x7fff);
    printf (" # Retries = %d \n", pdct->no_retries & 0x7fff);
    printf (" # Rx Hw Errors = %d \n", pdct->no_rxhwerrs & 0x7fff);
    printf (" # Tx Hw Errors = %d \n", pdct->no_txhwerrs & 0x7fff);
    printf (" # Checksum Errors = %d \n", pdct->no_cserrs & 0x7fff);
    printf (" # Off Lines = %d \n", pdct->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n", pdct->cmd_reset_stat);
    printf (" Force Offline = %d \n", pdct->cmd_force_offline);
    printf (" # Failed Outputs = %d \n", pdct->badoutcnt & 0x7fff);
    printf (" # MR-350 response messages = %d \n", pdct->no_mr350_msgs & 0x7fff);
    printf ("\n");

    printf ("\n");
    printf (" # of Completed Messages %d \n", pdct->msgs);
    printf (" Total Response Time (in ticks) = %lu \n", pdct->responsetime);
    printf ("   (includes retries prior to each completed message)\n");
    if (pdct->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pdct->responsetime/pdct->msgs));
        microsecs = (16667*pdct->responsetime)/pdct->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n", pdct->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pdct->holdflag );
    return;
}

/*
**      CLEARDCTSTATS
**
**      The purpose of this routine is to clear the DCT level statistics for this driver.
**
*/
/* called from TABLEINFO */

void CLEARDCTSTATS (unsigned short line, unsigned short maddr)
{
    MR350		*pdct;

    pdct = dcts [line] [maddr];
    if (!pdct)
    {
        logMsg ("Line/Address Not Defined \n");
        return;
    }

    initstats (pdct); /* use existing procedure */
    return;
}

void www (unsigned short line, unsigned short maddr)
{
    TABLEINFO(line, maddr);
}


/*
**      dump_dct_table
**                                                                           	
**      The purpose of this routine is twofold:                                 
**         1) dump the DCT level statistics for the MR350 driver.               
**         2) dump the data for the specified MR350 DCT.                        
**                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)
{
    MR350          *pdct;
    ACCESS         *paccess;
    short           ix;
    unsigned short  i, n, j; 

    DCTFIN         *finptr;
    DCTDINS        *dinptr;
    DCTDOUTS       *doutptr;
    DCTLEDOUTS     *ledoutptr;
    DCTLCDOUTS     *lcdoutptr;
    DCTSTRINGINS   *stringinptr;
    DCTBUZZEROUTS  *buzzeroutptr;
    XUSERIDS       *useridptr;
    XSITEINS       *siteinptr;
    XDELAYS        *delayptr;
    XPERIMETERS    *perimeterptr;
    XNEWFILES      *newfilesptr;
    XUSERSIN       *usersinptr;
    XTIMEDATE      *timedateptr;

    unsigned short req, val, value, addr, linecnt;
    unsigned long  bigvalue;
    unsigned char  buffer [200];

    pdct = dcts [line] [maddr];
    if (!pdct)
    {
        logMsg("MR-350 Line/Address Not Defined \n");
        return;
    }

    addr = 0;


    paccess = access [line];
    if (!paccess)
    {
        logMsg("RSA Task Not Active \n");
        return;
    }




    /* previously integral code moved to seperate procedure for debugging convenience */
    DUMPDCTSTATS (line, maddr);


    printf("\nFunction Key Input:           ");
    finptr = &pdct->fin;
    printf("%x,%x,%x,   '%c'",
            finptr->was_requested,
            finptr->data_valid,
            finptr->new_flag,
            finptr->last_read);

    printf("\nDigital Inputs:           ");
    for (n = 0; n < NUMDINS; n++)
    {		
        dinptr = &pdct->dins[n];
        printf("%x,%x,%x,   %x,        ",
                dinptr->was_requested,
                dinptr->data_valid,
                dinptr->new_flag,
                dinptr->last_read);
    }

    printf("\nDigital Outputs:          ");
    for (n = 0; n < NUMDOUTS; n++)
    {		
        doutptr = &pdct->douts[n];
        printf("%x,%x,     %x,        ",
                doutptr->was_requested,
                doutptr->data_valid,
                doutptr->last_write);
    }

    printf("\nLED Outputs:              ");
    for (n = 0; n < NUMLEDOUTS; n++)
    {		
        ledoutptr = &pdct->ledouts[n];
        printf("%x,%x,     %x,        ",
                ledoutptr->was_requested,
                ledoutptr->data_valid,
                ledoutptr->last_write);
    }

    printf("\nLCD Outputs:              ");
    for (n = 0; n < NUMLCDOUTS; n++)
    {		
        lcdoutptr = &pdct->lcdouts[n];
        printf("%x,%x,     :%s:,        ",
                lcdoutptr->was_requested,
                lcdoutptr->data_valid,
                &lcdoutptr->last_write[0]);
    }

    printf("\nString Inputs:            ");
    for (n = 0; n < NUMSTRINGINS; n++)
    {		
        stringinptr = &pdct->stringins[n];
        printf("%x,%x,%x,   :%s:,        \n",
                stringinptr->was_requested,
                stringinptr->data_valid,
                stringinptr->new_flag,
                &stringinptr->last_read[0]);
        printf("\n                          ");
    }

    printf("\nBuzzer Outputs:           ");
    for (n = 0; n < NUMBUZZEROUTS; n++)
    {		
        buzzeroutptr = &pdct->buzzerouts[n];
        printf("%x,%x,     %x,        ",
                buzzeroutptr->was_requested,
                buzzeroutptr->data_valid,
                buzzeroutptr->last_write);
    }

    printf("\n------------------------------------------------------- \n");
    paccess = access [line];
    if (!paccess)
    {
        logMsg("RSA Task Not Active \n");
        printf("\n------------------------------------------------------- \n");
        return;
    }


    printf("\nACCESS Perimeters:        ");
    for (n = 0; n < NUMPERIMETERS; n++)
    {		
        perimeterptr = &paccess->perimeters[n];
        printf("%x,%x,%x,   %2x,       ",
                perimeterptr->was_requested,
                perimeterptr->data_valid,
                perimeterptr->new_flag,
                perimeterptr->last_write);
    }
    printf("\nACCESS New files:         ");
    for (n = 0; n < NUMNEWFILES; n++)
    {		
        newfilesptr = &paccess->newfiles[n];
        printf("%x,%x,%x,   %2x,       ",
                newfilesptr->was_requested,
                newfilesptr->data_valid,
                newfilesptr->new_flag,
                newfilesptr->last_write);
    }
    printf("\nACCESS Site Inputs:       ");
    for (n = 0; n < NUMSITEINS; n++)
    {		
        siteinptr = &paccess->siteins[n];
        printf("%x,%x,%x,   %2x,        ",
                siteinptr->was_requested,
                siteinptr->data_valid,
                siteinptr->new_flag,
                siteinptr->last_read);
    }

    printf("\nACCESS User ID:           ");
    useridptr = &paccess->userids[0];
    printf("%x,%x,%x,   :%2s:",
            useridptr->was_requested,
            useridptr->data_valid,
            useridptr->new_flag,
            &useridptr->last_read[0]);



    printf("\nACCESS Delays:            ");
    for (n = 2; n < NUMDELAYS; n++)
    {		
        delayptr = &paccess->delays[n];
        printf("[%x]%x, %d      ", n, delayptr->was_requested, delayptr->last_write);
    }

    printf("\nACCESS Site User List:    \n");
    for (n = 0; n < NUMUSERSIN/4; n++)
    {		
        for (i = 0; i < 4; i++)
        {
            ix = (i*(NUMUSERSIN/4))+n;
            usersinptr = &paccess->usersin[ix];
            printf("[%1d%1d]%x,%x,%x:%14s:     ",
                    ix/10,
                    ix%10,
                    usersinptr->was_requested,
                    usersinptr->data_valid,
                    usersinptr->new_flag,
                   &usersinptr->last_read[0]);
        }
        printf("\n");
    }
    printf("\nACCESS Site User List Length = %d\n", paccess->usersincount);


    printf("\nACCESS Time/Date of Loaded File: ");
    timedateptr = &paccess->timedate[0];
    printf("%x,%x,%x,   :%2s:\n",
            timedateptr->was_requested,
            timedateptr->data_valid,
            timedateptr->new_flag,
            &timedateptr->last_read[0]);


    printf("\nACCESS State Time Remaining:  %d\n", paccess->timeremaining);
    rsainfo();
    printf("\n");
}


/*
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer [132];
	char	*resrsp;
	char	*lineact;


        printf ("                                 MR-350 DCT Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number      MR350 Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
	printf ("\n");

	for (i = 0; i < MR350LINES; i++)
	{
	    if(dcts [i] == NULL)
	    {
		continue;
	    }
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (line_activity [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,dcts[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}


/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ----  Remote Site Access Control Task and Associates    ---- */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */

/**********************/
/* External functions */
/**********************/
extern BOOT_PARAMS   sysBootParams;
extern	void	     resolveLinks ();


/************************************************************************
*                   ED's  PUBLIC DECLARATIONS                           *
************************************************************************/
typedef struct accessList
{
    struct accessList	*nextEntry;
    char		usrName[SLM_NAME_SIZE + 1];
    char		cardId[SLM_CARDID_SIZE + 1];
    char		passWd[SLM_KEYPADID_SIZE * 2 + 1];
} ACCESSLIST, *ACCESSLIST_PTR;

static ACCESSLIST_PTR   accessTree = (ACCESSLIST_PTR)0;
static char             timedatestring[81] = "empty time/date string";

/*
static void	byteShift(unsigned char *, int);
static char	code(unsigned char *, int, unsigned char *, int);
static int	getSetCurrentState (unsigned short *, int);
static int	loadAccessList (void);
static void	tisEncrypt (char *, int);
static int	verifyId (char *, char *, char *);
*/

static char masker[] =/*  "this is a cheap substitute until ed can fix the one below"; */
"\'Twas brillig and the slithy toves \
Did gyre and gimble in the wabe. \
All mimsy were the borogoves \
And the mome raths outgabe. \
\"Beware the Jabberwock, my son! \
The jaws that bite, the claws that catch! \
Beware the jubjub bird and shun \
the frumious bandersnatch!";




/************************************************************************
*                    WALTER's  PUBLIC DECLARATIONS                      *
************************************************************************/

static unsigned short  userfilechanged;         /* set by driver BO call by Greg */
                                                /* read by Ed, cleared by Ed     */ 

static unsigned short  sitestate;              /* main state variable           */
static unsigned short  lastknownstate;
static unsigned short  suspendprocessflag;


static unsigned short  line2state     [NUMDCTS];
static unsigned short  lastline2state [NUMDCTS];
static          long   line2timeout   [NUMDCTS];

static unsigned short  enable;
static unsigned short  loginflag;
static          long   statetimeout;
static          long   line1updatetimer [NUMDCTS];

static unsigned short  perimeterbreach;
static unsigned short  oldperimeterbreach;
static unsigned short  newperimeterbreach;
static unsigned short  lastperimeterbreach;

static unsigned short  logoutflag[NUMDCTS];
static unsigned short  validkeyflag[NUMDCTS];
static unsigned short  validcardflag[NUMDCTS];
static unsigned short  invalidkeyflag[NUMDCTS];
static unsigned short  invalidcardflag[NUMDCTS];
static                 validLEDtimer[NUMDCTS];
static                 invalidLEDtimer[NUMDCTS];
static unsigned short  mr350valid[NUMDCTS];

static char            cardId  [SLM_CARDID_SIZE + 1];
static char            passWd  [SLM_KEYPADID_SIZE * 2 + 1];
static char            usrName [SLM_NAME_SIZE + 1];

static struct dbAddr   point;

static long  newtick, oldtick, delta;

static unsigned short  badretry;




static unsigned short  rsa_debug;



void rsadebug (unsigned short level)
{
    rsa_debug = level;
} 

void rsadebugon (void)
{
    rsa_debug = 1;
} 

void rsadebugoff (void)
{
    rsa_debug = 0;
} 

static	void    master_updateredimage (unsigned short line)
{
    ACCESS         *paccess;
    unsigned short  i;
    int             lock;

    if (rsa_debug >= 8) printf("RSA(%d): Updating Data Set for Partner in Redundant IOC.\n", line);

    paccess = access [line];
    if (!paccess)
    {
        if (rsa_debug >= 8) printf("RSA(%d) Task Not Active. No Data To Share. \n", line);
        return;
    }

    drvRedTake (redsemids [line]);

    /* Fill in the header */
    redund [line].line = line;
    redund [line].usersincount = paccess->usersincount;
    redund [line].statetimeout = statetimeout;

    for (i = 0; i < NUMUSERSIN; i++)
    {		
        redund [line].usersin [i].was_requested = paccess->usersin[i].was_requested;
        redund [line].usersin [i].data_valid = paccess->usersin[i].data_valid;
        redund [line].usersin [i].new_flag = paccess->usersin[i].new_flag;
        strncpy (redund [line].usersin [i].last_read, paccess->usersin[i].last_read,  XUSERLEN);
    }
    drvRedGive (redsemids [line]);
    if (rsa_debug >= 8) printf("RSA(%d): Redundant IOC Partner data set has been sent.\n", line);
}



static	void    slave_updateredimage (unsigned short line,
                                      RSAREDUPD *redbuf, int size)
{
    ACCESS         *paccess;
    unsigned short  i;
    int             lock;


    if (rsa_debug >= 8) printf("RSA(%d): Partner in Redundant IOC has sent data set.\n", line);

    if (line != redbuf->line)
    {
        if (rsa_debug >= 8) ("Slave update line mismatch L %d BL %d\n", line, redbuf->line);
        return;
    }

    paccess = access [line];
    if (!paccess)
    {
        if (rsa_debug >= 8) printf("RSA(%d) Task Not Active. \n", line);
        return;
    }

    lock = taskLock ();
    paccess->usersincount = redbuf->usersincount;
    statetimeout = redund [line].statetimeout;

    for (i = 0; i < NUMUSERSIN; i++)
    {		
        paccess->usersin[i].was_requested = redbuf->usersin [i].was_requested;
        paccess->usersin[i].data_valid    = redbuf->usersin [i].data_valid;
        paccess->usersin[i].new_flag      = redbuf->usersin [i].new_flag;
        strncpy (paccess->usersin[i].last_read, redbuf->usersin [i].last_read, XUSERLEN);
    }
    taskUnlock ();
    if (rsa_debug >= 8) printf("RSA(%d): Redundant IOC Partner data set has been written.\n", line);
}


/*
** read driver stuff. */
/*
*/
void presslogout (unsigned short line, unsigned short unit)
{
    logoutflag [unit] = TRUE;
}

void rsainfo(void)
{
    ACCESSLIST_PTR    list;
    unsigned short    i, n;
             short    namelen;
    printf("\n------------------------------------------------------- ");
    printf("\nRSA Site State = %d", sitestate);

    printf("\nRSA Line 1 Timeouts:  ");
    for (n = 0; n < NUMDCTS; n++)
    {		
        printf("[%d] %3d       ", n, line1updatetimer[n]);
    }

    printf("\nRSA Line 2 States:    ");
    for (n = 0; n < NUMDCTS; n++)
    {		
        printf("[%d] %3d       ", n, line2state[n]);
    }

    printf("\nRSA Line 2 Timeouts:  ");
    for (n = 0; n < NUMDCTS; n++)
    {		
        printf("[%d] %3d       ", n, line2timeout[n]);
    }

    printf("\nRSA Suspend Process Flag = %d", suspendprocessflag);
    printf("\nRSA Debug Mode = %d", rsa_debug);
    printf("\n-------------------------------------------------------\n");

    list = accessTree;
    while (list != (ACCESSLIST_PTR)0)
    {
        for ( i = 0; i < 4; i++)
        {
            namelen = strlen(list->usrName);
            printf ("Name: %s", list->usrName);
            for (n = namelen; n < 20; n++)
            {
                printf (" ");
            }
            list = list -> nextEntry;
            if (list == (ACCESSLIST_PTR)0) break;
        }
        printf ("\n");
    }
    printf("\n------------------------------------------------------- ");
    printf("\n");
}


/****************************************************************
*
*    verifyId ()
*	given either a cardid or password, return the username
*
****************************************************************/

static int	verifyId (char *cardId, char *passWd, char *usrName)
{
    char		encryptedPassWd[SLM_KEYPADID_SIZE * 2 + 1];
    ACCESSLIST_PTR	list;

    if (userfilechanged)
    {
	if (loadAccessList ())
	    return (0);
    }

    if (passWd != NULL)
    {
	strncpy (encryptedPassWd, passWd, SLM_KEYPADID_SIZE);
	encryptedPassWd[SLM_KEYPADID_SIZE] = NULL;
	tisEncrypt (encryptedPassWd, SLM_KEYPADID_SIZE);
    }
    list = accessTree;
    while (list != (ACCESSLIST_PTR)0)
    {
	if (cardId != NULL)
	{
	    if ((strcmp (cardId, list -> cardId)) == 0)
	    {
		strncpy (usrName, list -> usrName, SLM_NAME_SIZE);
		usrName[SLM_NAME_SIZE] = NULL;
		return (1);
	    }
	}
	else if (passWd != NULL)
	{
	    if ((strcmp (encryptedPassWd, list -> passWd)) == 0)
	    {
		strncpy (usrName, list -> usrName, SLM_NAME_SIZE);
		usrName[SLM_NAME_SIZE] = NULL;
		return (1);
	    }
	}
	/* someone screwed up, I should not get here */
	else
	    return (0);
	list = list -> nextEntry;
    }
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /* remove this after debug */
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
/*    strncpy (usrName, "dummy12345678901234", SLM_NAME_SIZE);
    return (1);
    ****************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/
    /***************************/

    return (0);
}


/*******************************************************
*
*    tisEncrypt ()
*	start the encryption process
*
*******************************************************/

void	tisEncrypt(char *password, int size)
{
   char buf[3],key[17],*paddedPassword;
   int i;

   paddedPassword = (char *)calloc(1,size+1);
   strcpy(key,"ThIs Is A kEy!!!" );
   sprintf(paddedPassword, "%-*s", size, password);
   code(paddedPassword, size, key, strlen(key));
   strcpy(password, "");
   for (i=0 ; i < size ; i++)
   {
	sprintf(buf, "%02x", paddedPassword[i] & 0xff);
	strcat(password, buf);
   }
   free((void *)paddedPassword);
}


/***********************************************
*
*    code () and byteShift()
*	continue encryption process
*
***********************************************/

static char	code(unsigned char *block, int blockLen, unsigned char *key, int keyLen)
{
    int nshifts = blockLen << 3;
    int	i;

    while (nshifts--)
    {
	byteShift(block, blockLen);
	byteShift(key, keyLen);
	if (key[keyLen - 1] & 1)
	    for (i = 0; i < blockLen; i++)
		block[i] ^= masker[i];
    }
}

static void	byteShift(unsigned char *block, int blockLen)
{
    int		i;
    int		carry;
    int		prevCarry = 0;

    for (i = 0; i < blockLen; i++)
    {
	carry = block[i] & 1;
	block[i] >>= 1;
	if (prevCarry)
	    block[i] |= 0x80;
	prevCarry = carry;
    }

    if (prevCarry)
	block[0] |= 0x80;
}


/**********************************************************
*
*    loadAccessList ()
*	load the access list, if it chg'd, free up old
*	list and then read the new one
*
**********************************************************/

static int	loadAccessList (void)
{
    char		line[SLM_MAX_LINE_SIZE];
    char		rtuName[64];
    char		remotepath[128];
    char		localpath[128];
    char		*pChar;
    int			cnt, timedateline;
    FILE		*fdremote, *fdlocal;
    ACCESSLIST_PTR	list, prevList;
    char		*cp;
    struct stat         statbuf;


    strcpy (rtuName, sysBootParams.targetName);

    /*                                                                */
    /* rtu name may have a letter at the end due to MASTER/SLAVE pair */
    /* this no longer is relevant, since each rtu gets its' own file  */
    /*                                                                */
    /* ems 13 jun97                                                   */
    /* pChar  = (char *)( (&rtuName[0]) + (strlen (rtuName) - 1));    */
    /* if (!(isdigit((*pChar))))                                      */
    /* *pChar = NULL;                                                 */
    /*                                                                */

    sprintf (remotepath, "/tis4000db/%s.db", rtuName);
    if (cp = getenv ("SDR:") != NULL)
	sprintf (localpath, "%s%s.db", cp, rtuName);
    else
        sprintf (localpath, "SDR:%s.db", rtuName);
    if(rsa_debug >= 3) printf ("RSA: loading %s to %s\n", remotepath, localpath);
    if (accessTree != (ACCESSLIST_PTR)0)
    {
	list = accessTree;
	while (list != (ACCESSLIST_PTR)0)
	{
	    prevList = list;
	    list = list -> nextEntry;
	    free ((void *)prevList);
	}
	accessTree = (ACCESSLIST_PTR)0;
    }
    cnt = 0;
    while (cnt < 2)
    {
	if ((fdremote = fopen (remotepath,"r")) != NULL)
	{
            stat(remotepath, &statbuf);

            logMsg ("Remote file opened: %s\n", remotepath);
            if (rsa_debug > 4)
            {
                printf ("**********************************************************\n");
                printf ("The file was last modified on %s\n", ctime(&statbuf.st_mtime));
                printf ("**********************************************************\n");
            }

	    if ((fdlocal = fopen (localpath, "w+")) != NULL)
	    {
                logMsg ("Local file opened: %s\n", localpath);
		while (!(feof(fdremote)))
		{
		    fgets (line, SLM_MAX_LINE_SIZE - 1, fdremote);
		    fputs (line, fdlocal);
		}
		userfilechanged = 0;
	    }
            else
            {
                logMsg ("Local file failed to open: %s\n", localpath);
            }
	    fclose (fdremote);
	    fclose (fdlocal);
            break;
	}
	else
	{
	    taskDelay (30);
	    cnt++;
	}
    }
    if (cnt >= 2)
    {
        logMsg ("Remote file failed to open: %s\n", remotepath);
    }
    if ((fdlocal = fopen (localpath, "r")) != NULL)
    {
        timedateline = TRUE;

	while (!(feof(fdlocal)))
	{
	    if (fgets (line, SLM_MAX_LINE_SIZE - 1, fdlocal))
	    {
		if (pChar = strchr (line, '\n'))
		    *pChar = NULL;

                if (timedateline == TRUE)
                {
                    strcpy (timedatestring, line);
                    timedateline = FALSE;
                }
                else
                {
                    if ((list = (ACCESSLIST_PTR)calloc (1, sizeof (ACCESSLIST))) == NULL)
                    {
                        logMsg ("Local file calloc error: %s\n", localpath);
                        fclose (fdlocal);
                        return (1);
                    }
                    list -> nextEntry = (ACCESSLIST_PTR)0;
                    strncpy (list -> usrName, strtok (line, " "), SLM_NAME_SIZE);
                    strncpy (list -> cardId, strtok (NULL, " "), SLM_CARDID_SIZE);
                    strncpy (list -> passWd, strtok (NULL, " "), SLM_KEYPADID_SIZE*2);
                    if (accessTree == (ACCESSLIST_PTR)0)
                        accessTree = list;

                    else
                        prevList -> nextEntry = list;
                    prevList = list;
                }
	    }
	    else if (ferror (fdlocal))
	    {
		logMsg ("Local file read error: %s\n", localpath);
		fclose (fdlocal);
		return (1);
	    }
	}
	fclose (fdlocal);
    }
    else
    {
	logMsg ("Local file open error: %s\n", localpath);
	return (1);
    }
    return (0);
}


/*********************************************
*
*    getSetCurrentState ()
*	get or set the current state
*
*********************************************/

static int	getSetCurrentState (unsigned short *state, int get)
{
    long		status = 0;
    long		options = 0;
    long		nRequests = 1;
    char		pvName[PVNAME_SZ + FLDNAME_SZ + 1];
    char		rtuName[64];
    char		*pChar;
    struct dbAddr	dbAddr;

    strcpy (rtuName, sysBootParams.targetName);
    /* rtu name may have a letter at the end due to MASTER/SLAVE pair */
    pChar  = (char *)( (&rtuName[0]) + (strlen (rtuName) - 1));

    /* strip last character from tame if non-numeric.   */
    /*    if (!(isdigit((*pChar))))                     */
    /*      *pChar = NULL;                              */

    /* only strip a trailing A, B, a, and b character from the rtuname string. */
    if ((*pChar == 'A') || (*pChar == 'B') || (*pChar == 'a') || (*pChar == 'b'))
         *pChar = NULL;

    /* since the CNST is prompted, when we change it it will make its way back to */
    /* the database so that on an rtu reload we will come up with the last state. */
    sprintf (pvName, "%s%s.CNST", rtuName, ROOT_POINTNAME);
    if ((status = dbNameToAddr (pvName, &dbAddr)) != 0)
    {
	logMsg ("dbNameToAddr failed for %s, point may not exist\n", pvName);
	return (1);
    }
    if (get)
    {
	if ((status = dbGetField (&dbAddr, DBR_ENUM, (caddr_t)state,
				 &options, &nRequests, NULL)) != 0)
	{
	    logMsg ("dbGetField failed for %s\n", pvName);
	    return (1);
	}
    }
    else
    {
	if ((status = dbPutField (&dbAddr, DBR_ENUM, (caddr_t)state, nRequests)) != 0)
	{
	    logMsg ("dbPutField failed for %s\n", pvName);
	    return (1);
	}
    }

    return (0);
}

/******************************************************************************************/

/*
** build & send transaction messages
*/


/* this routine allows time for the 1 second scan task to */
/* pick up new message from driver using SIDRIVER call.   */

void transactionmsgwait(void)
{
    taskDelay(70);
}


void sendforcedstatemsg (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Forced Remote Site Access State.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendtaskinitmsg (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Remote Site Access Task Initializing.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendsecuringmsg (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Logout Initiated: Securing Site.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendsecuredmsg (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Logout Completed. Site Secure.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendalarmmsg1 (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Intruder Alarm: Perimeter Breach Timeout.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendalarmmsg2 (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Intruder Alarm: Invalid Login Count Exceeded.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendalarmmsg3 (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Intruder Alarm: Unexpected and Invalid Login.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}


void sendalarmmsg4 (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Intruder Alarm: Unexpected Login.\n",
             sysBootParams.targetName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

void sendvalidkeymsg (unsigned short line, unsigned short unit, unsigned short type)
{
    ACCESS         *paccess;

    paccess = access [line];
    switch (type)
    {
        case LOGIN:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Keypad Login (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;

        case LOGOUT:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Keypad Logout (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;

        default:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Keypad Type Error (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;
    }
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

void sendinvalidkeymsg (unsigned short line, unsigned short unit)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Invalid Keypad Login (%d) ID#%s.\n",
             sysBootParams.targetName,
            unit, passWd);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

void sendvalidcardmsg (unsigned short line, unsigned short unit, unsigned short type)
{
    ACCESS         *paccess;

    paccess = access [line];
    switch (type)
    {
        case LOGIN:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Card Login (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;

        case LOGOUT:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Card Logout (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;

        default:
            sprintf(paccess->userids[0].last_read,
                    "RTU %s: Valid Card Type Error (%d) by %s.\n",
                     sysBootParams.targetName,
                    unit, usrName);
            break;
    }
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

void sendinvalidcardmsg (unsigned short line, unsigned short unit)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Invalid Card Login (%d) Card#%s.\n",
             sysBootParams.targetName,
            unit, cardId);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

void sendautologoutmsg (unsigned short line)
{
    ACCESS         *paccess;

    paccess = access [line];
    sprintf(paccess->userids[0].last_read,
            "RTU %s: Auto-Logout - User Name: %s.\n",
             sysBootParams.targetName, usrName);
    paccess->userids[0].data_valid = TRUE;
    paccess->userids[0].new_flag = TRUE;
    transactionmsgwait();
}

/*************************************/
/*************************************/
/*************************************/

void commandLCD (unsigned short line, unsigned short unit,
                 unsigned short lcdline, unsigned char *lcdstring)
{
    TASKOUT         *tpq;

    tpq = tgetemptyp (line);
    if (tpq == NULLP)
    {
        if(rsa_debug >= 2)  printf("RSA(%d): Unit %d Task Queue Overflow\n", line, unit);
        return;
    }
    if (rsa_debug >= 4) printf("RSA(%d): Unit %d LCD    command queued\n", line, unit);
    tpq->link    = line;
    tpq->unit    = unit;
    tpq->command = LCDCMD;
    tpq->parameter[0] = lcdline;
    strcpy(&tpq->parameter[1], lcdstring);
    tmarkfull (line);     /* Mark this entry as ready for output */
    return;
}


/*************************************/
/*************************************/
/*************************************/

void commandLED (unsigned short line, unsigned short unit,
                 unsigned short lednum, unsigned short ledstate)
{
    TASKOUT         *tpq;

    tpq = tgetemptyp (line);
    if (tpq == NULLP)
    {
        if (rsa_debug >= 2) printf("RSA(%d): Unit %d Task Queue Overflow\n", line, unit);
        return;
    }
    if (rsa_debug >= 4) printf("RSA(%d): Unit %d LED    command queued\n", line, unit);
    tpq->link    = line;
    tpq->unit    = unit;
    tpq->command = LEDCMD;
    tpq->parameter[0] = lednum;
    tpq->parameter[1] = ledstate;
    tmarkfull (line);		/* Mark this entry as ready for output */
    return;
}


/*************************************/
/*************************************/
/*************************************/

void commandLOG (unsigned short line, unsigned short unit,
                 unsigned short lognum, unsigned short logstate)
{
    TASKOUT         *tpq;

    tpq = tgetemptyp (line);
    if (tpq == NULLP)
    {
        if (rsa_debug >= 2) printf("RSA(%d): Unit %d Task Queue Overflow\n", line, unit);
        return;
    }
    if (rsa_debug >= 4) printf("RSA(d): Unit %d LOG    command queued\n", line, unit);
    tpq->link    = line;
    tpq->unit    = unit;
    tpq->command = LOGCMD;
    tpq->parameter[0] = lognum;
    tpq->parameter[1] = logstate;
    tmarkfull (line);		/* Mark this entry as ready for output */
    return;
}

/*************************************/
/*************************************/
/*************************************/

void commandKLAXON (unsigned short line, unsigned short unit,
                   unsigned short frequency, unsigned short length, unsigned short numsecs)
{
    TASKOUT         *tpq;

    tpq = tgetemptyp (line);
    if (tpq == NULLP)
    {
        if (rsa_debug >= 2) printf("RSA(%d): Unit %d Task Queue Overflow\n", line, unit);
        return;
    }
    if (rsa_debug >= 4) printf("RSA(%d): Unit %d KLAXON command queued\n", line, unit);
    tpq->link    = line;
    tpq->unit    = unit;
    tpq->command = KLAXONCMD;
    tpq->parameter[0] = frequency;
    tpq->parameter[1] = length;
    tpq->parameter[2] = (numsecs/100)%10;
    tpq->parameter[3] = (numsecs/10)%10;
    tpq->parameter[4] = (numsecs/1)%10;
    tmarkfull (line);		/* Mark this entry as ready for output */
    return;
}

void warningklaxon (unsigned short line)
{
    ACCESS         *paccess;
    unsigned short unit;

    paccess = access [line];

    for (unit = 0; unit < NUMDCTS; unit++)
    {
        if (mr350valid[unit])
        {
/*
            commandKLAXON (line, unit, 0, 5, paccess->delays [RSA_WARNING].last_write);
*/
            commandKLAXON (line, unit, 5, 4, paccess->delays [RSA_WARNING].last_write);
        }
    }
}

void allklaxonon (unsigned short line)
{
    unsigned short unit;

    for (unit = 0; unit < NUMDCTS; unit++)
    {
        if (mr350valid[unit])
        {
            klaxonon(line, unit);
        }
    }
}

void allklaxonoff (unsigned short line)
{
    unsigned short unit;

    for (unit = 0; unit < NUMDCTS; unit++)
    {
        if (mr350valid[unit])
        {
            klaxonoff(line, unit);
        }
    }
}

void klaxonon (unsigned short line, unsigned short unit)
{
    commandKLAXON (line, unit, 5, 4, 999);
}

void klaxonoff (unsigned short line, unsigned short unit)
{
    commandKLAXON (line, unit, 5, 4, 0);
}


/* temporarily light an LED  */
void lightup (unsigned short line, unsigned short unit, unsigned short led)
{
    if (led == VALIDLEDNUM)
    {
        validLEDtimer[unit] = 30;
        /* write to the point to turn on the Valid ID LED   */
        commandLED (line, unit, VALIDLEDNUM, LEDON);
        /* send valid ID beeper/tone */

    }

    if (led == INVALIDLEDNUM)
    {
        invalidLEDtimer[unit] = 30;
        /* write to the point to turn on the Invalid ID LED   */
        commandLED (line, unit, INVALIDLEDNUM, LEDON);
        /* send invalid ID beeper/tone */

    }
}


/******************************************************************************************/
/******************************************************************************************/
/******************************************************************************************/

/*
** read driver stuff. */
/*
*/
void getmr350stuff (unsigned short line, unsigned short unit)
{
    MR350          *pdct;
    ACCESS         *paccess;
    unsigned int    i;

    pdct = dcts [line] [unit];
    paccess = access [line];

    /**********************/
    /*  F3 pressed?       */
    /**********************/
    if ((pdct->fin.data_valid) &&
        (pdct->fin.new_flag))
    {
        if (pdct->fin.last_read == '3')
        {
            logoutflag[unit] = TRUE;
        }
        pdct->fin.new_flag = FALSE;
    }

    /**************************/
    /*  logout pressed?       */
    /**************************/
    if ((pdct->dins [0].data_valid) &&
        (pdct->dins [0].new_flag))
    {
        logoutflag[unit] = TRUE;
        pdct->dins [0].new_flag = FALSE;
    }

    /**************************/
    /*  card swipe?           */
    /**************************/
    if ((pdct->stringins [0].data_valid) &&
        (pdct->stringins [0].new_flag))
    {
        strcpy (cardId, &pdct->stringins [0].last_read[0]);

        /* verify the card ID by encrypting the card number, opening */
        /* the file, and searching for the encrypted card number.    */
        if (verifyId (cardId, 0, usrName))
        {
            validcardflag[unit] = TRUE;
        }
        else
        {
            sprintf (usrName, "UNKNOWN CARD ID: %s", cardId);
            invalidcardflag[unit] = TRUE;
        }
        pdct->stringins [0].new_flag = FALSE;

        /* copy the first line string directly to the driver data structure. */
        for (i = 0; (i < NUMTIMEDATE); i++)
        {
            paccess->timedate [i].data_valid = TRUE;
            paccess->timedate [i].new_flag = TRUE;
            strcpy (&paccess->timedate [i].last_read[0], &timedatestring[0]);
        }
    }

    /**************************/
    /*  keypad entry?         */
    /**************************/
    if ((pdct->stringins [1].data_valid) &&
        (pdct->stringins [1].new_flag))
    {
        strcpy (passWd, &pdct->stringins [1].last_read[0]);

        /* verify the password by encrypting the password, opening */
        /* the file, and searching for the encrypted password.     */
        if (verifyId (0, passWd, usrName))
        {
            validkeyflag[unit] = TRUE;
        }
        else
        {
            fprintf (usrName, "UNKNOWN PASSWORD: %s", passWd);
            invalidkeyflag[unit] = TRUE;
        }
        pdct->stringins [1].new_flag = FALSE;

        /* copy the first line string directly to the driver data structure. */
        for (i = 0; (i < NUMTIMEDATE); i++)
        {
            paccess->timedate [i].data_valid = TRUE;
            paccess->timedate [i].new_flag = TRUE;
            strcpy (&paccess->timedate [i].last_read[0], &timedatestring[0]);
        }
    }
}

void getperimeterstate (unsigned short line)
{
    ACCESS         *paccess;
    unsigned short  i;

    paccess = access [line];

    /**************************/
    /* perimeter breach?      */
    /**************************/
    lastperimeterbreach = perimeterbreach;
    perimeterbreach = FALSE;

    for (i = 0; i < NUMPERIMETERS; i++)
    {
        /* look at the MAGIC point written with a copy of the Modicon input point. */
        if (paccess->perimeters [i].data_valid)
        {
            if (paccess->perimeters [i].last_write)
            {
                perimeterbreach = TRUE;
            }
        }
        /* just for yucks, clear the flag. not currently functional */
        if (paccess->perimeters [i].new_flag)
        {
            paccess->perimeters [i].new_flag = FALSE;
        }
    }

    if ((lastperimeterbreach == FALSE) && (perimeterbreach == TRUE))
    {
        newperimeterbreach = TRUE;
    }
}

void getnewfilestate (unsigned short line)
{
    ACCESS         *paccess;
    unsigned short  i;


    paccess = access [line];

    /**********************/
    /* file changed?      */
    /**********************/

    for (i = 0; i < NUMNEWFILES; i++)
    {
        /* look at the MAGIC point written with a copy of the Modicon input point. */
        if (paccess->newfiles [i].data_valid)
        {
            if (paccess->newfiles [i].last_write)
            {
                paccess->newfiles [i].last_write = 0;
                /* load new file from workstation.               */
                userfilechanged = TRUE;
                if (loadAccessList())
                {
                    /* failed to open file */
                    if (rsa_debug >= 1) printf ("RSA(%d): File failed to open.\n", line);
                }
                else
                {
                    /* opened file */
                    if (rsa_debug >= 3) printf ("RSA(%d): New File downloaded from workstation.\n", line);

                    /* copy the first line string directly to the driver data structure. */
                    for (i = 0; (i < NUMTIMEDATE); i++)
                    {
                        paccess->timedate [i].data_valid = TRUE;
                        paccess->timedate [i].new_flag = TRUE;
                        strcpy (&paccess->timedate [i].last_read[0], &timedatestring[0]);
                    }

                }
            }
        }
        /* just for yucks, clear the flag. not currently functional */
        if (paccess->newfiles [i].new_flag)
        {
            paccess->newfiles [i].new_flag = FALSE;
        }
    }
}


/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

void line1manager (unsigned short line, unsigned short unit)
{
    MR350          *pdct;

    pdct = dcts [line] [unit];
    if (!pdct)  return;
    if (!pdct->is_responding) return;

    if (!line1updatetimer[unit])
    {
        if (rsa_debug >= 5) printf ("RSA(%d): Unit %d Periodic Update of MR350 Display State\n", line, unit);
        line1update(line, unit);
        line1updatetimer[unit] = TICKSPERSEC * REFRESHINTERVAL;
    }

    if (pdct->newflag)
    {
        pdct->newflag = FALSE;
        if (rsa_debug >= 5) printf ("RSA(%d): Unit %d Online Update of MR350 Display State\n", line, unit);
        line1update(line, unit);
        line1updatetimer[unit] = TICKSPERSEC * REFRESHINTERVAL;
    }
}


/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

void line1update (unsigned short line, unsigned short unit)
{
    ACCESS         *paccess;
    unsigned char   line1buffer[81];

    paccess = access [line];

    if (mr350valid[unit] == FALSE) return;

    switch (sitestate)
    {
        case SECURE:
            /* build the line 1 message */
            strcpy(line1buffer, " Site Secured   ");
            /* extinguish both LOGIN & LOGOUT      */
            commandLOG (line, unit, LOGINNUM, LOGOFF);
            commandLOG (line, unit, LOGOUTNUM, LOGOFF);
            /* turn off the alarm klaxon           */
            klaxonoff(line, unit);
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;

        case ALERT:
            /* illuminate LOGIN, extinguish LOGOUT */
            commandLOG (line, unit, LOGINNUM, LOGON);
            commandLOG (line, unit, LOGOUTNUM, LOGOFF);
            /* turn off the alarm klaxon           */
            klaxonoff(line, unit);
            /* build the line 1 message */
            strcpy(line1buffer, " Intruder Alert ");
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;

        case OCCUPIED:
            /* illuminate LOGOUT, extinguish LOGIN */
            commandLOG (line, unit, LOGINNUM, LOGOFF);
            commandLOG (line, unit, LOGOUTNUM, LOGON);
            /* turn off the alarm klaxon           */
            klaxonoff(line, unit);       
            /* build the line 1 message */
            strcpy(line1buffer, " Site Occupied  ");
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;

        case SECURING:
            /* extinguish both LOGIN & LOGOUT      */
            commandLOG (line, unit, LOGINNUM, LOGOFF);
            commandLOG (line, unit, LOGOUTNUM, LOGOFF);
            /* turn off the alarm klaxon           */
            klaxonoff(line, unit);
            /* build the line 1 message */
            strcpy(line1buffer, " Securing Site  ");
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;

        case ALARM:
            /* extinguish both LOGIN & LOGOUT      */
            commandLOG (line, unit, LOGINNUM, LOGOFF);
            commandLOG (line, unit, LOGOUTNUM, LOGOFF);
            /* only turn on alarm klaxon if significant time left to beep */
            if (statetimeout >300) klaxonon(line, unit);
            else                   klaxonoff(line, unit);
            /* build the line 1 message */
            strcpy(line1buffer, " Intruder Alarm ");
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;


        default:
            /* illuminate both LOGIN & LOGOUT      */
            commandLOG (line, unit, LOGINNUM, LOGON);
            commandLOG (line, unit, LOGOUTNUM, LOGON);
            /* turn off the alarm klaxon           */
            klaxonoff(line, unit);
            /* build the line 1 message */
            strcpy(line1buffer, " Unknown State ");
            /* output the line 1 message to each unit. */
            commandLCD (line, unit, 0, line1buffer);
            break;
    }
    return;
}

/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

void transition (unsigned short line, unsigned short newstate)
{
    ACCESS         *paccess;
    unsigned short  unit;
    unsigned char   line1buffer[81];

    paccess = access [line];
    newperimeterbreach = FALSE;

    /* set database and remote copies of site state */
    sitestate = newstate;
    lastknownstate = newstate;

    switch (newstate)
    {
        case SECURE:
            suspendprocessflag = TRUE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to SECURE state\n", line);
            statetimeout = 0;
            for (unit = 0; unit < NUMDCTS; unit++)  line1update (line, unit);
            badretry = 0;
            break;

        case ALERT:
            suspendprocessflag = FALSE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to ALERT state\n", line);
            statetimeout = TICKSPERSEC * paccess->delays [RSA_ALERT].last_write;
            for (unit = 0; unit < NUMDCTS; unit++) line1update (line, unit);
            badretry = 0;
            break;

        case OCCUPIED:
            suspendprocessflag = FALSE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to OCCUPIED state\n", line);
            statetimeout = 0;
            for (unit = 0; unit < NUMDCTS; unit++) line1update (line, unit);
            badretry = 0;
            break;

        case SECURING:
            suspendprocessflag = FALSE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to SECURING state\n", line);
            statetimeout = TICKSPERSEC * paccess->delays [RSA_SECURING].last_write;
            for (unit = 0; unit < NUMDCTS; unit++) line1update (line, unit);
            badretry = 0;
            break;

        case ALARM:
            suspendprocessflag = FALSE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to ALARM state\n", line);
            statetimeout = TICKSPERSEC * paccess->delays [RSA_ALARM].last_write;
            for (unit = 0; unit < NUMDCTS; unit++) line1update (line, unit);
            badretry = 0;
            break;


        default:
            suspendprocessflag = FALSE;
            if (rsa_debug >= 3) printf ("RSA(%d): Transitioning to UNKNOWN state(%d)\n", line, newstate);
            statetimeout = 0;
            for (unit = 0; unit < NUMDCTS; unit++) line1update (line, unit);
            badretry = 0;
            break;
    }
    mr350site (line, newstate);
    getSetCurrentState(&newstate, SETIT);

    return;
}

/***************************************************************************************/
/***************************************************************************************/
/***************************************************************************************/
/***************************************************************************************/

void line2trans (unsigned short line, unsigned short unit, unsigned short newline2state)
{
    ACCESS         *paccess;
    unsigned char   line2buffer[81];
    unsigned short  i;
    unsigned short  idcount;

    paccess = access [line];

    idcount = paccess->usersincount;

    switch (newline2state)
    {
        case VALIDLOGIN:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transitioning to VALIDLOGIN state\n", line, unit);
            /* build the line 2 message */
            strcpy(line2buffer, "          LOGIN");
            for (i=0 ; i < MAXIDLENGTH ; i++)
            {
                if (usrName[i] == 0) break;
                line2buffer[i] = usrName[i];
            }
            /* output the line 2 message only to the specific unit that logged it in. */
            commandLCD (line, unit, 1, line2buffer);
            /* set up the time delay for state transition. */
            line2timeout [unit] = TICKSPERSEC * paccess->delays [RSA_MESSAGE].last_write;
            break;

        case VALIDLOGOUT:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transitioning to VALIDLOGOUT state\n", line, unit);
            /* build the line 2 message */
            strcpy(line2buffer, "         LOGOUT");
            for (i=0 ; i < MAXIDLENGTH ; i++)
            {
                if (usrName[i] == 0) break;
                line2buffer[i] = usrName[i];
            }
            /* output the line 2 message only to the specific unit that logged it out. */
            commandLCD (line, unit, 1, line2buffer);
            /* set up the time delay for state transition. */
            line2timeout [unit] = TICKSPERSEC * paccess->delays [RSA_MESSAGE].last_write;
            break;

        case DISPLAYCOUNT:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transitioning to DISPLAYCOUNT state\n", line, unit);
            /* build the line 2 message */
            sprintf(line2buffer, "  %d%d Logged In ", idcount/10, idcount%10);
            /* output the line 2 message only to the specific unit that logged it in or out. */
            commandLCD (line, unit, 1, line2buffer);
            /* set up the time delay for state transition. */
            line2timeout [unit] = TICKSPERSEC * paccess->delays [RSA_MESSAGE].last_write;
            break;

        case INVALIDID:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transitioning to INVALIDID state\n", line, unit);
            /* build the line 2 message */
            sprintf(line2buffer, "   INVALID ID  ");
            /* output the line 2 message only to the specific unit that the login failed at. */
            commandLCD (line, unit, 1, line2buffer);
            /* set up the time delay for state transition. */
            line2timeout [unit] = TICKSPERSEC * paccess->delays [RSA_MESSAGE].last_write;
            break;

        default:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transition to UNKNOWN state(%d)\n", line, unit, newline2state);
            line2state [unit] = IDLE;
            /* yes, this an intentional fall through. */

        case IDLE:
            if (rsa_debug >= 4) printf ("RSA(%d): Unit %d Line 2 Transitioning to VALIDLOGIN state\n", line, unit);
            /* build the line 2 message */
            sprintf(line2buffer, "                ");
            /***************************************/
            /***************************************/
            /***************************************/
/*          sprintf(line2buffer, "   Blank Line   "); */
            sprintf(line2buffer, "                ");
            /***************************************/
            /***************************************/
            /***************************************/
            /* output the line 2 message only to the specific unit that just went idle. */
            commandLCD (line, unit, 1, line2buffer);
            /* make state stable by never allowing transition to zero */
            line2timeout [unit] = 0;
            break;

    }
    /* update line 2 state logic */
    line2state[unit] = newline2state;
    lastline2state[unit] = newline2state;
    return;
}


/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

void line2manager (unsigned short line, unsigned short unit)
{

    switch (line2state[unit])
    {
        case VALIDLOGIN:

            /************************/
            /* check state time out */
            if (line2timeout [unit]  == 0)
            {
                /* transition to Display Count State */
                line2trans (line, unit, DISPLAYCOUNT);
            }
            break;

        case VALIDLOGOUT:
            /************************/
            /* check state time out */
            if (line2timeout [unit] == 0)
            {
                /* transition to Display Count State */
                line2trans (line, unit, DISPLAYCOUNT);
            }
            break;

        case DISPLAYCOUNT:
            /************************/
            /* check state time out */
            if (line2timeout [unit] == 0)
            {
                /* transition to Idle State */
                line2trans (line, unit, IDLE);
            }
            break;

        case INVALIDID:
            /************************/
            /* check state time out */
            if (line2timeout [unit] == 0)
            {
                /* transition to Idle State */
                line2trans (line, unit, IDLE);
            }
            break;

        case IDLE:
            /******************************/
            /* this state never times out */
            break;
    }
}


/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

unsigned short checkuserlist (unsigned short line)
{
    unsigned short   n;
    XUSERSIN        *userptr;
    ACCESS          *paccess;

    paccess = access [line];

    for (n = 0; n < (NUMUSERSIN); n++)
    {		
        userptr = &paccess->usersin[n];
        /* if we get a match, exit with valid status  */
        if (strcmp (userptr->last_read, usrName) == 0)
        {
            return (TRUE);
        }

        /* if we get to the end of the count without a match,       */
        /* increment the user count and add entry to the next slot. */
        if (n >= paccess->usersincount)
        {
            return (FALSE);
        }
    }
    /* exit here if usersincount > NUMUSERSIN (this condition should never occur) */
    return (FALSE);
}

/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/

unsigned short manageuserlist (unsigned short line)
{
    unsigned short   n;
    XUSERSIN        *userptr;
    XUSERSIN        *olduserptr;
    ACCESS          *paccess;

    paccess = access [line];

    for (n = 0; n < (NUMUSERSIN); n++)
    {		
        userptr = &paccess->usersin[n];

        /* if we get a match, decrement the user count, delete the  */
        /* entry, and move the others down in the list.             */
        if (strcmp (userptr->last_read, usrName) == 0)
        {
            paccess->usersincount--;
            n++;
            /* collapse the list */
            while (n < NUMUSERSIN)
            {		
                olduserptr = userptr;
                userptr = &paccess->usersin[n];
                strcpy(olduserptr->last_read, userptr->last_read);
                userptr->last_read[0] = 0;
                n++;
            }
            return (DELETED);
        }

        /* if we get to the end of the count without a match,       */
        /* increment the user count and add entry to the next slot. */
        if (n >= paccess->usersincount)
        {
            /* insert the user name into the list */
            strcpy (userptr->last_read, usrName);
            paccess->usersincount++;
            return (INSERTED);
        }
    }
    /* if we get to the end of the list without a match, there  */
    /* is no room for another entry. the list is full. get out. */
    return (LISTFULL);
}

/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/
/***********************************************************************************/


/*******************************************/
/*******************************************/
/*******************************************/
/* manage timer controls of MR350 actions. */
/*******************************************/
/*******************************************/
/*******************************************/

void gettimerdelta (void)
{
    /* manage timer. */

    newtick = tickGet ();
    delta = newtick - oldtick;

    /* handle unsigned-to-signed wrap condition that happens approximately every 1.5 years */
    if (abs(delta) > 1000000) delta = 1;

    oldtick = newtick;

    /*********************************/
    /* decrease statetimeout counter */
    /*********************************/
    if (delta)
    {
        if (statetimeout > 0)
        {
            statetimeout = statetimeout - delta;
            if (statetimeout < 0)
            {
                statetimeout = 0;
            }
        }
    }
    return;
}

void managetimer (unsigned short line, unsigned short unit)
{
    if (delta)
    {
        /*****************************************/
        /* manage turning off valid/invalid LEDs */
        /*****************************************/
        if (validLEDtimer[unit] > 0)
        {
            validLEDtimer[unit] = validLEDtimer[unit] - delta;
            if (validLEDtimer[unit] <= 0)
            {
                /* turn off the Valid ID LED   */
                commandLED (line, unit, VALIDLEDNUM, LEDOFF);
                validLEDtimer[unit] = -1;
            }
        }

        if (invalidLEDtimer[unit] > 0)
        {
            invalidLEDtimer[unit] = invalidLEDtimer[unit] - delta;
            if (invalidLEDtimer[unit] <= 0)
            {
                /* turn off the Invalid ID LED   */
                commandLED (line, unit, INVALIDLEDNUM, LEDOFF);
                invalidLEDtimer[unit] = -1;
            }
        }

        /*******************************************/
        /* manage individual line 1 update timers. */
        /*******************************************/
        if (line1updatetimer[unit] > 0)
        {
            line1updatetimer[unit] = line1updatetimer[unit] - delta;
            if (line1updatetimer[unit] < 0)
            {
                line1updatetimer[unit] = 0;
            }
        }


        /******************************************/
        /* manage individual line 2 state timers. */
        /******************************************/
        if (line2timeout[unit] > 0)
        {
            line2timeout[unit] = line2timeout[unit] - delta;
            if (line2timeout[unit] < 0)
            {
                line2timeout[unit] = 0;
            }
        }
    }
}

/***********************************************************************************/
/*                                                                                 */
/* accessTask (line, time1, time2, time3)       (time values not currently used)   */
/*                                                                                 */
/*  this task monitors the devices on the remote site access systems and           */
/*  determines the state and access to the building.                               */
/*                                                                                 */
/***********************************************************************************/

void RSATASK (unsigned short line,
              unsigned short delay1,
              unsigned short delay2,
              unsigned short delay3,
              unsigned short port)
{
    MR350          *pdct;
    ACCESS         *paccess;
    unsigned short  pstate, lstate;
    unsigned short  unit, i, j, hit;
    unsigned short  liststatus;

    /* initialize a bunch of variables.                                   */
    badretry = 0;
    paccess = access [line];
    /******************/
    rsadebugon(); /****/
    /******************/

    if (rsa_debug >= 1) printf ("RSA(%d): Remote Site Access Task Started.\n", line);


    /* in main, if not redundant, port is set to zero to let  */
    /* this task know to not start this memory sharing code.  */
    if (port)
    {
        redsize [line]      = sizeof (RSAREDUPD);
        Rsaredport [line]   = port;
        Rsaredperiod [line] = 60;

        initRedDriverData (&resnames [line], &redund [line],
                           &redsize [line], (FUNCPTR) slave_updateredimage,
                           line, Rsaredperiod [line], Rsaredport[line],
                           &redsemids [line]);
    }

    /* determine the number of configured MR350 terminals.                */
    for (unit = 0; unit < NUMDCTS; unit++)
    {
        mr350valid[unit] = FALSE;
    }

    /***********************/
    /* debuggersnag(line); */
    /***********************/


    /* open the file and build the user password structure.               */
    userfilechanged = TRUE;
    while (loadAccessList())
    {
        /* failed to open file */
        if (rsa_debug >= 1) printf ("RSA(%d): File failed to open.\n", line);
        taskDelay(1*60*60);      /* output message and re-check every 60 seconds */
    }
    /* opened file */
    if (rsa_debug >= 3) printf ("RSA(%d): New File downloaded from workstation.\n", line);

    /* copy the first line string directly to the driver data structure. */
    for (i = 0; (i < NUMTIMEDATE); i++)
    {
         paccess->timedate [i].data_valid = TRUE;
         paccess->timedate [i].new_flag = TRUE;
         strcpy (&paccess->timedate [i].last_read[0], &timedatestring[0]);
    }

    /* wait here until MR350 Driver is master */
    resGetStates (prestable [line], &lstate, &pstate);
    while (lstate == RES_SLV)
    {
        taskDelay(60);
        resGetStates (prestable [line], &lstate, &pstate);
    }

    i = (1*60)+1;
    hit = FALSE;
    /* wait here until MR350 Driver talks with MR350 */
    while (!hit)
    {
        /* check each unit sequentially */
        for ( unit = 0; unit < NUMDCTS; unit++ )
        {
            /* to see if driver is still RES_MSTR, get current state of MR350 Driver */
            resGetStates (prestable [line], &lstate, &pstate);
            if (lstate == RES_SLV)
            {
                break;
            }
            /* check each configured MR350 unit for input */
            pdct = dcts [line] [unit];
            if (!pdct)  /* verify pointer prior to use */
            {
                continue;
            }
            if (pdct->is_responding)
            {
                hit = TRUE;
                break;
            }
        }
        if (hit) break;

        /* added 1/23/98 to be able to download file while Mr350 is initially offline. */
        getnewfilestate (line);

        if (i++ > 1*60)
        {
            if (rsa_debug >= 2) printf ("RSA(%d): Waiting for MR-350 Driver to Establish Communications ......\n", line);
            taskDelay(60);
            i = 0;
        }
        taskDelay(60);
    }

    /* get state to initial conditions.                                   */
    while (getSetCurrentState(&sitestate, GETIT))
    {
        /* point not found */
        if (rsa_debug >= 2) printf ("RSA(%d): Current State Point Not Found ......\n", line);
        taskDelay (60*60);
    }
    lastknownstate = sitestate;

    /* put SOMETHING in this string to make it valid. */
    sendtaskinitmsg(line);

    /* if this is the first time up for the system, force state to secure */
    if (sitestate == UNDEFINED)
    {
        if (rsa_debug >= 2) printf ("RSA(%d): Site State is initially undefined.\n", line);
        taskDelay(60);                   /* see joe h. for explanation */
        sendsecuringmsg (line);
        transition(line, SECURING);      /* transition to Securing Site         */
    }

    if (trace[line] & RSADEBUGENABLE)
    {
        /******************/
        rsadebugon(); /****/
        /******************/
    }
    else
    {
        /******************/
        rsadebugoff(); /***/
        /******************/
    }

    oldtick = tickGet ();

    suspendprocessflag = FALSE;

    while (TRUE)
    {
        taskDelay(15);
        gettimerdelta();

        paccess->timeremaining = statetimeout;


        /* get current state of MR350 Driver */
        resGetStates (prestable [line], &lstate, &pstate);
        while (lstate == RES_SLV)
        {
            /* note: while this task's associated driver is slave, */
            /* gordon's magic code is keeping this task 'advised'  */
            /* of the changes to statetimeout and the valid user   */
            /* list data structure made by the companion task.     */
            taskDelay(60);
            /* get current state of MR350 Driver */
            resGetStates (prestable [line], &lstate, &pstate);

            /* added 1/23/98 to be able to download file while in SLAVE state. */
            getnewfilestate (line);
        }

        /* process state machine sequentially through each configured driver */
        for ( unit = 0; unit < NUMDCTS; unit++ )
        {
            /* update database point */
            paccess->timeremaining = statetimeout;

            /* to see if driver is still RES_MSTR, get current state of MR350 Driver */
            resGetStates (prestable [line], &lstate, &pstate);
            if (lstate == RES_SLV)
            {
                if (rsa_debug >= 2) printf ("RSA(%d): Driver Not Master - suspend processing (Unit = %d).\n", line, unit);
                break;
            }

            master_updateredimage (line);  /* Get Last update over */

            /* check each configured MR350 unit for input */
            pdct = dcts [line] [unit];
            if (!pdct)  /* verify pointer prior to use */
            {
                if (rsa_debug >= 7) printf ("RSA(%d): Unit %d not configured. skip processing. \n", line, unit);
                continue;
            }
            if (!pdct->is_responding)
            {
                if (rsa_debug >= 6) printf ("RSA(%d): Unit %d not responding. skip processing. \n", line, unit);
                /* don't look at inputs or generate outputs. */
                mr350valid[unit] = FALSE;
                continue;
            }
            else
            {
                if (rsa_debug >= 9) printf ("RSA: Unit %d is responding. performing normal processing. \n", unit);
            }

            /* this establishes that the points for the MR350 exists, */
            /* and that the unit has been successfully reached.       */
            if (mr350valid[unit] == FALSE)
            {
                if (rsa_debug >= 2) printf ("RSA(%d): Unit %d just came Online.\n", line, unit);
                mr350valid[unit] = TRUE;
                /* cause update immediately after coming on line. */
                /*                line1updatetimer[unit] = 0; */
            }

            /* manage timer controls of MR350 actions. */
            managetimer(line, unit);

            /* manage line 1 update logic */
            line1manager (line, unit);

            /* manage line 2 state logic */
            line2manager (line, unit);


            if (!suspendprocessflag)
            {
                /* read and process MR350 driver data structures */
                getmr350stuff (line, unit);
                getperimeterstate (line);
                getnewfilestate (line);

                getSetCurrentState(&sitestate, GETIT);
                /* if we have come to this state without our knowledge, */
                /* make sure we know whats going on. (this means that   */
                /* the state was changed via a database point write.)   */
                if (sitestate != lastknownstate)
                {
                    /* put LOGIN & LOGOUT, leds, display, in certain order */
                    taskDelay(60);
                    sendforcedstatemsg (line);
                    transition (line, sitestate);
                }
            }

            switch (sitestate)
            {
                /****************************/
                /****************************/
                /****************************/
                case SECURE:

                    if (paccess->usersincount != 0)
                    {
                        /* clear all valid & invalid new key and new card flags.  */
                        validkeyflag[unit] = FALSE;
                        invalidkeyflag[unit] = FALSE;
                        validcardflag[unit] = FALSE;
                        invalidcardflag[unit] = FALSE;

                        /* get first name from list and write it into usrName.    */
                        strcpy (usrName, &paccess->usersin[0].last_read[0]);

                        /* manageuserlist to remove it.                           */
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != DELETED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): Auto-Logout User List failure. (%d)\n", line, liststatus);
/* */                   }
                        /* send a logout message to host, NOT THE MR350 DISPLAY.  */
                        sendautologoutmsg (line);/* build & send a transaction message  */
                    }
                    else
                    {
                        suspendprocessflag = FALSE;
                    }

                    if (paccess->usersincount != 0)
                    {
                        break;
                    }

                    /* normal unattended state */


                    /*********************************/
                    /* if LOGOUT pressed, ignore it. */
                    if (logoutflag[unit])
                    {
                            logoutflag[unit] = FALSE;
                    }

                    /*******************/
                    /* check perimeter */
                    if (perimeterbreach)
                    {
                        transition(line, ALERT);             /* transition to Intruder Alert        */
                        break;
                    }
                    /***********************************************/
                    /* check for valid keypad value being entered. */
                    if (validkeyflag[unit])
                    {
                        validkeyflag[unit] = FALSE;          /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied.        */
                        warningklaxon(line);
                        break;
                    }
                    /*************************************************/
                    /* check for invalid keypad value being entered. */
                    if (invalidkeyflag[unit])
                    {
                        invalidkeyflag[unit] = FALSE;        /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidkeymsg (line, unit);      /* build & send a transaction message  */
                        transition(line, ALERT);             /* transition to Intruder Alert        */
                        badretry++;                          /* account for this invalid attempt    */
/*                        sendalarmmsg3 (line);
**                        transition(line, ALARM);             ** transition to Intruder Alarm        */
/*                        ** if alarm timeout is zero, don't sound the alarm. */
/*                        if (statetimeout) allklaxonon(line);
*/                      break;
                    }
                    /*********************************************/
                    /* check for valid card value being entered. */
                    if (validcardflag[unit])
                    {
                        validcardflag[unit] = FALSE;         /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidcardmsg (line, unit, LOGIN);/* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied.        */
                        warningklaxon(line);
                        break;
                    }
                    /***********************************************/
                    /* check for invalid card value being entered. */
                    if (invalidcardflag[unit])
                    {
                        invalidcardflag[unit] = FALSE;       /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        sendinvalidcardmsg (line, unit);     /* build & send a transaction message  */
                        transition(line, ALERT);             /* transition to Intruder Alert        */
                        badretry++;                          /* account for this invalid attempt    */
/*                        sendalarmmsg3 (line);
**                        transition(line, ALARM);             ** transition to Intruder Alarm        */
/*                        ** if alarm timeout is zero, don't sound the alarm. */
/*                        if (statetimeout) allklaxonon(line);
*/                      break;
                    }
                    break;

                /****************************/
                /****************************/
                /****************************/
                case ALERT:
                    /* the perimeter has been breached */

                    /************************/
                    /* check state time out */
                    if (statetimeout == 0)
                    {
                        /* transition to Intruder Alert */
                        transition (line, ALARM);
                        /* if alarm timeout is zero, don't sound the alarm. */
                        if (statetimeout) allklaxonon(line);
                        sendalarmmsg1 (line);
                        break;
                    }
                    /*********************************/
                    /* if LOGOUT pressed, ignore it. */
                    if (logoutflag[unit])
                    {
                        logoutflag[unit] = FALSE;
                    }
                    /*******************/
                    /* check perimeter */

                    if (perimeterbreach)
                    {
                        /* no action */
                    }
                    /***********************************************/
                    /* check for valid keypad value being entered. */
                    if (validkeyflag[unit])
                    {
                        validkeyflag[unit] = FALSE;          /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied         */
                        break;
                    }
                    /*************************************************/
                    /* check for invalid keypad value being entered. */
                    if (invalidkeyflag[unit])
                    {
                        invalidkeyflag[unit] = FALSE;        /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidkeymsg (line, unit);      /* build & send a transaction message  */
                        if (++badretry > paccess->delays [RSA_RETRY].last_write)
                        {
                            sendalarmmsg2 (line);
                            transition(line, ALARM);         /* transition to Intruder Alarm        */
                            /* if alarm timeout is zero, don't sound the alarm. */
                            if (statetimeout) allklaxonon(line);
                        }
                        break;
                    }
                    /*********************************************/
                    /* check for valid card value being entered. */
                    if (validcardflag[unit])
                    {
                        validcardflag[unit] = FALSE;         /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidcardmsg (line, unit, LOGIN);/* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied         */
                        break;
                    }
                    /***********************************************/
                    /* check for invalid card value being entered. */
                    if (invalidcardflag[unit])
                    {
                        invalidcardflag[unit] = FALSE;       /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidcardmsg (line, unit);     /* build & send a transaction message  */
                        if (++badretry > paccess->delays [RSA_RETRY].last_write)
                        {
                            sendalarmmsg2 (line);
                            transition(line, ALARM);         /* transition to Intruder Alarm        */
                            /* if alarm timeout is zero, don't sound the alarm. */
                            if (statetimeout) allklaxonon(line);
                        }
                        break;
                    }
                    break;

                /****************************/
                /****************************/
                /****************************/
                case OCCUPIED:

                    /*************************************/
                    /* if LOGOUT pressed, go to securing */
                    if (logoutflag[unit])
                    {
                        if (!perimeterbreach)
                        {
                            logoutflag[unit] = FALSE;
                            sendsecuringmsg (line);
                            transition(line, SECURING);      /* transition to Securing Site         */
                            break;
                        }
                        else
                        {
                            line1updatetimer[unit] = TICKSPERSEC * REFRESHINTERVAL;
                            logoutflag[unit] = FALSE;
                            warningklaxon(line);
                        }
                    }

                    /*******************/
                    /* check perimeter */
                    if (perimeterbreach)
                    {
                        /* no action */
                    }

                    /***********************************************/
                    /* check for valid keypad value being entered. */
                    if (validkeyflag[unit])
                    {
                        validkeyflag[unit] = FALSE;          /* clear the flag.                     */
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   switch (liststatus)
/* */                   {
/* */                       case INSERTED:
/* */                           line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
/* */                           sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
/* */                           break;
/* */
/* */                       case DELETED:
/* */                           line2trans(line, unit, VALIDLOGOUT); /* build and send LCD line 2 message.  */
/* */                           sendvalidkeymsg (line, unit, LOGOUT);/* build & send a transaction message  */
/* */                           break;
/* */
/* */                       default:
/* */                           /* user should be given an indication he/she is not actually in the list.   */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                           line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
/* */                           sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
/* */                           break;
/* */                   }
                        /************************************/
                    }
                    /*************************************************/
                    /* check for invalid keypad value being entered. */
                    if (invalidkeyflag[unit])
                    {
                        invalidkeyflag[unit] = FALSE;        /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidkeymsg (line, unit);      /* build & send a transaction message  */
                        break;
                    }
                    /*********************************************/
                    /* check for valid card value being entered. */
                    if (validcardflag[unit])
                    {
                        validcardflag[unit] = FALSE;         /* clear the flag.                     */
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   switch (liststatus)
/* */                   {
/* */                       case INSERTED:
/* */                           line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
/* */                           sendvalidcardmsg (line, unit, LOGIN); /* build & send a transaction message  */
/* */                           break;
/* */
/* */                       case DELETED:
/* */                           line2trans(line, unit, VALIDLOGOUT); /* build and send LCD line 2 message.  */
/* */                           sendvalidcardmsg (line, unit, LOGOUT);/* build & send a transaction message  */
/* */                           break;
/* */
/* */                       default:
/* */                           /* user should be given an indication he/she is not actually in the list.   */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                           line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
/* */                           sendvalidcardmsg (line, unit, LOGIN); /* build & send a transaction message  */
/* */                           break;
/* */                   }
                        /************************************/
                    }
                    /***********************************************/
                    /* check for invalid card value being entered. */
                    if (invalidcardflag[unit])
                    {
                        invalidcardflag[unit] = FALSE;       /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidcardmsg (line, unit);     /* build & send a transaction message  */
                        break;
                    }
                    break;


                /****************************/
                /****************************/
                /****************************/
                case SECURING:

                    /************************/
                    /* check state time out */
                    if (statetimeout == 0)
                    {
                        /* transition to Site Secure */
                        sendsecuredmsg (line);
                        transition (line, SECURE);
                        statetimeout = -1;
                        break;
                    }
                    /*********************************/
                    /* if LOGOUT pressed, ignore it. */
                    if (logoutflag[unit])
                    {
                            logoutflag[unit] = FALSE;
                    }

                    /*******************/
                    /* check perimeter */
                    if (perimeterbreach)
                    {
                        /* no action (we expect a breach to occur as the user leaves the site) */
                    }
                    /***********************************************/
                    /* check for valid keypad value being entered. */
                    if (validkeyflag[unit])
                    {
                        validkeyflag[unit] = FALSE;          /* clear the flag.                     */
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        /************************************/
                        /* check to see if this user is in the list. */
                        liststatus = checkuserlist(line);
                        if (liststatus)
                        {
                            /* since this user is in the list, we will delete it */
                            liststatus = manageuserlist(line);
                            if (liststatus != DELETED)
                            {
                                /* it should always be deleted */
                                if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
                            }
                            else
                            {
                                line2trans(line, unit, VALIDLOGOUT);  /* build and send LCD line 2 message.   */
                                sendvalidkeymsg (line, unit, LOGOUT); /* build & send a transaction message   */
/*****  by commenting out this line, the securing action will continue until site secure mode is reached. *****/
/*                              transition(line, OCCUPIED);           ** transition to Site Occupied.         */
                            }
                        }
                        else
                        {
                            /* since this user is not in the list, we will add it */
                            liststatus = manageuserlist(line);
                            if (liststatus != INSERTED)
                            {
                                /* it should always insert, unless the list is full */
                                if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
                            }
                            line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                            sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
                            transition(line, OCCUPIED);          /* transition to Site Occupied.        */
                        }
                    }
                    /*************************************************/
                    /* check for invalid keypad value being entered. */
                    if (invalidkeyflag[unit])
                    {
                        invalidkeyflag[unit] = FALSE;        /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidkeymsg (line, unit);      /* build & send a transaction message  */
                        transition(line, ALERT);             /* transition to Intruder Alert        */
                        break;
                    }
                    /*********************************************/
                    /* check for valid card value being entered. */
                    if (validcardflag[unit])
                    {
                        validcardflag[unit] = FALSE;         /* clear the flag.                     */
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        /************************************/
                        /* check to see if this user is in the list. */
                        liststatus = checkuserlist(line);
                        if (liststatus)
                        {
                            /* since this user is in the list, we will delete it */
                            liststatus = manageuserlist(line);
                            if (liststatus != DELETED)
                            {
                                /* it should always be deleted */
                                if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
                            }
                            else
                            {
                                line2trans(line, unit, VALIDLOGOUT);   /* build and send LCD line 2 message.  */
                                sendvalidcardmsg (line, unit, LOGOUT); /* build & send a transaction message  */
/*****  by commenting out this line, the securing action will continue until site secure mode is reached. *****/
/*                              transition(line, OCCUPIED);            ** transition to Site Occupied.        */
                            }
                        }
                        else
                        {
                            /* since this user is not in the list, we will add it */
                            liststatus = manageuserlist(line);
                            if (liststatus != INSERTED)
                            {
                                /* it should always insert, unless the list is full */
                                if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
                            }
                            line2trans(line, unit, VALIDLOGIN);   /* build and send LCD line 2 message.  */
                            sendvalidcardmsg (line, unit, LOGIN); /* build & send a transaction message  */
                            transition(line, OCCUPIED);           /* transition to Site Occupied.        */
                        }
                    }
                    /***********************************************/
                    /* check for invalid card value being entered. */
                    if (invalidcardflag[unit])
                    {
                        invalidcardflag[unit] = FALSE;       /* clear the flag.                     */
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidcardmsg (line, unit);     /* build & send a transaction message  */
                        transition(line, ALERT);             /* transition to Intruder Alert        */
                        break;
                    }
                    break;

                /****************************/
                /****************************/
                /****************************/
                case ALARM:

                    /************************/
                    /* check state time out */
                    if (statetimeout == 0)
                    {
                        /* turn off the klaxon */
                        allklaxonoff(line);
                        statetimeout = -1;
                    }

                    /*********************************/
                    /* if LOGOUT pressed, ignore it. */
                    if (logoutflag[unit])
                    {
                            logoutflag[unit] = FALSE;
                    }

                    /**********************************/
                    /* check for new perimeter breach */
                    if (newperimeterbreach)
                    {
                        newperimeterbreach = FALSE;
                        /* turn on the klaxon for timeout, only if not already on */
                        if (statetimeout < 1)
                        {
                            /* note: this logic is not retriggering */
                            statetimeout = TICKSPERSEC * paccess->delays [RSA_ALARM].last_write;
                            /* if alarm timeout is zero, don't sound the alarm. */
                            if (statetimeout) allklaxonon(line);
                        }
                    }
                    /***********************************************/
                    /* check for valid keypad value being entered. */
                    if (validkeyflag[unit])
                    {
                        validkeyflag[unit] = FALSE;          /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidkeymsg (line, unit, LOGIN); /* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied.        */
                        break;
                    }
                    /*************************************************/
                    /* check for invalid keypad value being entered. */
                    if (invalidkeyflag[unit])
                    {
                        invalidkeyflag[unit] = FALSE;        /* clear the flag.                     */
                        /* turn on the klaxon for timeout, only if not already on */
                        if (statetimeout < 1)
                        {
                            /* note: this logic is not retriggering */
                            statetimeout = TICKSPERSEC * paccess->delays [RSA_ALARM].last_write;
                            /* if alarm timeout is zero, don't sound the alarm. */
                            if (statetimeout) allklaxonon(line);
                        }
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidkeymsg (line, unit);      /* build & send a transaction message  */
                    }
                    /*********************************************/
                    /* check for valid card value being entered. */
                    if (validcardflag[unit])
                    {
                        validcardflag[unit] = FALSE;         /* clear the flag.                     */
                        /************************************/
/* */                   liststatus = manageuserlist(line);
/* */                   if (liststatus != INSERTED)
/* */                   {
/* */                       /* it should always insert */
/* */                       if (rsa_debug >= 2) printf ("RSA(%d): User List failure. (%d)\n", line, liststatus);
/* */                       break;
/* */                   }
                        /************************************/
                        lightup (line, unit, VALIDLEDNUM);   /* temporarily light valid ID LED      */
                        line2trans(line, unit, VALIDLOGIN);  /* build and send LCD line 2 message.  */
                        sendvalidcardmsg (line, unit, LOGIN);/* build & send a transaction message  */
                        transition(line, OCCUPIED);          /* transition to Site Occupied.        */
                        break;
                    }
                    /***********************************************/
                    /* check for invalid card value being entered. */
                    if (invalidcardflag[unit])
                    {
                        invalidcardflag[unit] = FALSE;       /* clear the flag.                     */
                        /* turn on the klaxon for timeout, only if not already on */
                        if (statetimeout < 1)
                        {
                            /* note: this logic is not retriggering */
                            statetimeout = TICKSPERSEC * paccess->delays [RSA_ALARM].last_write;
                            /* if alarm timeout is zero, don't sound the alarm. */
                            if (statetimeout) allklaxonon(line);
                        }
                        lightup (line, unit, INVALIDLEDNUM); /* light invalid ID LED                */
                        line2trans(line, unit, INVALIDID);   /* build and send LCD line 2 message.  */
                        sendinvalidcardmsg (line, unit);     /* build & send a transaction message  */
                    }
                    break;

                default:
                    /**********************************************************/
                    /* if UNINITIALIZED or UNEXPECTED pressed, go to securing */
                        sendsecuringmsg (line);
                        transition(line, SECURING);      /* transition to Securing Site         */
                        break;
            }
        }
    }
}

void rsadata(void)
{
    printf ("RSA Data:\n");
    printf ("userfilechanged = %d\n", userfilechanged);
    printf ("sitestate       = %d\n", sitestate);
    printf ("lastknownstate  = %d\n", lastknownstate);
    printf ("enable          = %d\n", enable);
    printf ("loginflag       = %d\n", loginflag);
    printf ("statetimeout    = %d\n", statetimeout);
    printf ("perimeterbreach = %d\n", perimeterbreach);
    printf ("delta           = %d\n", delta);

    printf ("\n  Unit 1, 2, 3. \n");
    printf ("    logoutflag        = %3d, %3d, %3d\n", logoutflag[0],logoutflag[1],logoutflag[2]);
    printf ("    validkeyflag      = %3d, %3d, %3d\n", validkeyflag[0], validkeyflag[1], validkeyflag[2]);
    printf ("    invalidkeyflag    = %3d, %3d, %3d\n", invalidkeyflag[0], invalidkeyflag[1], invalidkeyflag[2]);
    printf ("    validcardflag     = %3d, %3d, %3d\n", validcardflag[0], validcardflag[1], validcardflag[2]);
    printf ("    invalidcardflag   = %3d, %3d, %3d\n", invalidcardflag[0], invalidcardflag[1], invalidcardflag[2]);
    printf ("    validLEDtimer     = %3d, %3d, %3d\n", validLEDtimer[0], validLEDtimer[1], validLEDtimer[2]);
    printf ("    invalidLEDtimer   = %3d, %3d, %3d\n", invalidLEDtimer[0], invalidLEDtimer[1], invalidLEDtimer[2]);
    printf ("    mr350valid        = %3d, %3d, %3d\n", mr350valid[0], mr350valid[1], mr350valid[2]);
    printf ("\n");
    printf ("    line2state        = %3d, %3d, %3d\n", line2state[0], line2state[1], line2state[2]);
    printf ("    lastline2state    = %3d, %3d, %3d\n", lastline2state[0], lastline2state[1], lastline2state[2]);
    printf ("    line2timeout      = %3d, %3d, %3d\n", line2timeout[0], line2timeout[1], line2timeout[2]);
}





/*	End of File:	drvMr350.c */
